package com.despark.tuning3d
{
import com.despark.tuning3d.controller.AuthUserCommand;
import com.despark.tuning3d.controller.DisplayBrandsScreenCommand;
import com.despark.tuning3d.controller.DisplayBuyAdsRemoverPopUpCommand;
import com.despark.tuning3d.controller.DisplayBuyCarPopUpCommand;
import com.despark.tuning3d.controller.DisplayBuyPacketPopUpCommand;
import com.despark.tuning3d.controller.DisplayChallengeLeaderBoardScreenCommand;
import com.despark.tuning3d.controller.DisplayChallengeLeaderBoardTuningScreenCommand;
import com.despark.tuning3d.controller.DisplayChallengeNotificationTuningScreenCommand;
import com.despark.tuning3d.controller.DisplayChallengeNotificationsPopupCommand;
import com.despark.tuning3d.controller.DisplayChallengeScreenCommand;
import com.despark.tuning3d.controller.DisplayChallengeTuningViewPopupCommand;
import com.despark.tuning3d.controller.DisplayChallengeVotePopupCommand;
import com.despark.tuning3d.controller.DisplayDownloadsPopUpCommand;
import com.despark.tuning3d.controller.DisplayForgottenPasswordScreenCommand;
import com.despark.tuning3d.controller.DisplayFriendsListScreenCommand;
import com.despark.tuning3d.controller.DisplayGalleryScreenCommand;
import com.despark.tuning3d.controller.DisplayGalleryTuningPopupCommand;
import com.despark.tuning3d.controller.DisplayHomeScreenPopUpCommand;
import com.despark.tuning3d.controller.DisplayInAppNotificationPopUp;
import com.despark.tuning3d.controller.DisplayInfoPopUpCommand;
	import com.despark.tuning3d.controller.DisplayInstantMailPopupCommand;
	import com.despark.tuning3d.controller.DisplayLoginScreenCommand;
	import com.despark.tuning3d.controller.DisplayMailBoxPopupCommand;
	import com.despark.tuning3d.controller.DisplayMailScreenCommand;
	import com.despark.tuning3d.controller.DisplayMoreCarsPopUpCommand;
import com.despark.tuning3d.controller.DisplayPartInfoPopUpCommand;
import com.despark.tuning3d.controller.DisplayPreviousScreenCommand;
import com.despark.tuning3d.controller.DisplayProfilePopupCommand;
import com.despark.tuning3d.controller.DisplayRegisterScreenCommand;
import com.despark.tuning3d.controller.DisplayRewardConfirmPopUpCommand;
import com.despark.tuning3d.controller.DisplayRewardNoAdsPopUpCommand;
import com.despark.tuning3d.controller.DisplayRewardNoCoinPopUpCommand;
import com.despark.tuning3d.controller.DisplayRewardsInfoPopupCommand;
import com.despark.tuning3d.controller.DisplayRootScreenCommand;
import com.despark.tuning3d.controller.DisplayStartChallengePopupCommand;
import com.despark.tuning3d.controller.DisplayTimelineFeedViewPopup;
import com.despark.tuning3d.controller.DisplayTimelineScreenCommand;
import com.despark.tuning3d.controller.DisplayTuningEditorPopUpCommand;
import com.despark.tuning3d.controller.DisplayTuningScreenCommand;
import com.despark.tuning3d.controller.DisplayTuningSettingsPopUpCommand;
import com.despark.tuning3d.controller.DisplayTuningSharingPopUpCommand;
	import com.despark.tuning3d.controller.DisplayTuningVideoPopup;
	import com.despark.tuning3d.controller.DisplayTuningsListScreenCommand;
import com.despark.tuning3d.controller.DisplayTunningNameInputPopUpCommand;
	import com.despark.tuning3d.controller.DisplayUserDetailsPopupCommand;
	import com.despark.tuning3d.controller.DisplayVotesListScreenCommand;
import com.despark.tuning3d.controller.RemovePopUpCommand;
import com.despark.tuning3d.controller.StartupCommand;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.brands.BrandsProxy;
import com.despark.tuning3d.model.cars.CarBackgroundsProxy;
import com.despark.tuning3d.model.cars.CarsProxy;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.model.core.ConnectionProxy;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.core.http.caching.HttpFileCache;
import com.despark.tuning3d.model.core.images.BitmapDataUtil;
import com.despark.tuning3d.model.disks.DiskBrandsProxy;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.languages.LanguagesProxy;
	import com.despark.tuning3d.model.mails.MailsProxy;
	import com.despark.tuning3d.model.packages.PackagesProxy;
import com.despark.tuning3d.model.parts.PartSlotsProxy;
import com.despark.tuning3d.model.settings.SettingsProxy;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingOkProxy;
import com.despark.tuning3d.model.sharing.SharingPinProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.UserProfileProxy;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.model.votes.VotesProxy;
import com.despark.tuning3d.view.BrandsScreenMediator;
import com.despark.tuning3d.view.components.core.AlertView;

import flash.data.EncryptedLocalStore;
import flash.filesystem.File;

import org.puremvc.as3.patterns.facade.Facade;

public class ApplicationFacade extends Facade
	{
		private var httpClient : HttpClient;
		public static function getInstance() : ApplicationFacade 
		{
			if (!instance)
			{
				instance = new ApplicationFacade();
			}
			
			return instance as ApplicationFacade;
		}
		
		override protected function initializeModel() : void 
		{
			super.initializeModel();
			
			var httpFileCache : HttpFileCache = new HttpFileCache(null); 
			httpFileCache.cacheDirectoryHandler = function(remoteUrl : String) : File
			{
				var mainDir : File;
				
				if(remoteUrl.indexOf("translations") < 0 && remoteUrl.indexOf("regions") < 0)
				{
					mainDir = File.cacheDirectory;
				}
				else
				{
					mainDir = File.applicationStorageDirectory;
				}
				
				var file1: File = mainDir.resolvePath("httpCache");
				file1.preventBackup = true;
				
				return file1;
			};
				
			httpClient = new HttpClient( httpFileCache);
			
			var that:ApplicationFacade = this;
			
			httpClient.onError = function(errorText : String) : void
			{
				
				/*if(errorText && errorText.indexOf("Invalid username or password")>=0){
					AlertView.show(errorText.substr(0, Math.min(140, errorText.length)), -1, false);   
				}*/
				
				if(errorText!="requestFailed"){  
					//AlertView.show(errorText.substr(0, Math.min(140, errorText.length)), -1, false);         
				}
				
				if(errorText && errorText.indexOf("FacebookGraphAPIError")>=0){
					//that.
						
						if(EncryptedLocalStore.isSupported){
							
							EncryptedLocalStore.setItem("fbdata", null);
							
							that.sendNotification(Notifications.OPEN_FACEBOOK_LOGIN_DIALOG);
							
						}
				}
				//UserAgreementView.show(errorText);
			};
				
			BitmapDataUtil.globalWritingErrorHandler = function() : void {
				AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "carPartsNotCached"), -1, false);
			};
				
			BrandsScreenMediator.httpClient = httpClient;

			var assetsProxy : AssetsProxy = new AssetsProxy();
			assetsProxy.httpClient = httpClient;
			registerProxy(assetsProxy);
			
			var tuningsProxy : TuningsProxy = new TuningsProxy();
			tuningsProxy.httpClient = httpClient;
			registerProxy(tuningsProxy);

			var brandsProxy : BrandsProxy = new BrandsProxy();
			brandsProxy.httpClient = httpClient;
			registerProxy(brandsProxy);
			
			var diskBrandsProxy : DiskBrandsProxy = new DiskBrandsProxy();
			diskBrandsProxy.httpClient = httpClient;
			registerProxy(diskBrandsProxy);
			
			var carsProxy : CarsProxy = new CarsProxy();
			carsProxy.httpClient = httpClient;
			registerProxy(carsProxy);
			
			var packagesProxy:PackagesProxy=new PackagesProxy();
			packagesProxy.httpClient=httpClient;
			registerProxy(packagesProxy);
			
			
			var usersProxy : UsersProxy = new UsersProxy();
			usersProxy.httpClient = httpClient;
			registerProxy(usersProxy);
			
			var carBackgroundsProxy : CarBackgroundsProxy = new CarBackgroundsProxy();
			carBackgroundsProxy.httpClient = httpClient;
			registerProxy(carBackgroundsProxy);
			
			var languagesProxy : LanguagesProxy = new LanguagesProxy();
			languagesProxy.httpClient = httpClient;
			registerProxy(languagesProxy);
			
			var votesProxy:VotesProxy=new VotesProxy();
			votesProxy.httpClient=httpClient;
			registerProxy(votesProxy);

            var friendsProxy:FriendProxy=new FriendProxy();
            friendsProxy.httpClient=httpClient;
            registerProxy(friendsProxy);

            var timelineProxy : TimelineProxy= new TimelineProxy();
            timelineProxy.httpClient = httpClient;
            registerProxy(timelineProxy);

			var challengesProxy : ChallengesProxy= new ChallengesProxy();
            challengesProxy.httpClient = httpClient;
            registerProxy(challengesProxy);


			var userProfileProxy : UserProfileProxy = new UserProfileProxy();
            userProfileProxy.httpClient = httpClient;
            registerProxy(userProfileProxy);

			var mailsProxy : MailsProxy = new MailsProxy();
			mailsProxy.httpClient = httpClient;
            registerProxy(mailsProxy);



			var connectionProxy : ConnectionProxy = new ConnectionProxy();
			registerProxy(connectionProxy);
			registerProxy(new PartSlotsProxy());
			registerProxy(new SettingsProxy());
			registerProxy(new SharingProxy());
			registerProxy(new SharingVkProxy());
			registerProxy(new SharingInstagramProxy());
			registerProxy(new SharingOkProxy());
			registerProxy(new SharingPinProxy());

			httpClient.isUserSigned = usersProxy.currentUser != null;
			if (httpClient.isUserSigned) {
				httpClient.userToken = usersProxy.getUserToken();
			}
		}
		
		override protected function initializeController() : void
		{
			super.initializeController();

			registerCommand(Notifications.STARTUP, StartupCommand);
			registerCommand(Notifications.DISPLAY_BRANDS_SCREEN, DisplayBrandsScreenCommand);
			registerCommand(Notifications.DISPLAY_TUNING_SCREEN, DisplayTuningScreenCommand);
			registerCommand(Notifications.DISPLAY_TUNINGS_LIST_SCREEN, DisplayTuningsListScreenCommand);
			registerCommand(Notifications.DISPLAY_VOTES_LIST_SCREEN, DisplayVotesListScreenCommand);
			registerCommand(Notifications.DISPLAY_GALLERY_SCREEN, DisplayGalleryScreenCommand);
			registerCommand(Notifications.DISPLAY_MAIL_SCREEN, DisplayMailScreenCommand);
			registerCommand(Notifications.DISPLAY_MAIL_BOX_POPUP, DisplayMailBoxPopupCommand);
			registerCommand(Notifications.DISPLAY_INSTANT_MAIL_POPUP, DisplayInstantMailPopupCommand);

			registerCommand(Notifications.DISPLAY_CHALLENGE_SCREEN, DisplayChallengeScreenCommand);


			registerCommand(Notifications.DISPLAY_TIMELINE_SCREEN, DisplayTimelineScreenCommand);
            registerCommand(Notifications.DISPLAY_FRIENDS_LIST_SCREEN, DisplayFriendsListScreenCommand);
            registerCommand(Notifications.DISPLAY_IN_APP_NOTIFICATION_POPUP, DisplayInAppNotificationPopUp);
            registerCommand(Notifications.DISPLAY_FEED_VIEW_POPUP, DisplayTimelineFeedViewPopup);

			registerCommand(Notifications.DISPLAY_HOME_SCREEN_POPUP, DisplayHomeScreenPopUpCommand);
			registerCommand(Notifications.DISPLAY_TUNING_EDITOR_POPUP, DisplayTuningEditorPopUpCommand);

			
			registerCommand(Notifications.DISPLAY_PREVIOUS_SCREEN, DisplayPreviousScreenCommand);
			registerCommand(Notifications.DISPLAY_ROOT_SCREEN, DisplayRootScreenCommand);
			registerCommand(Notifications.DISPLAY_DOWNLOADS_POP_UP, DisplayDownloadsPopUpCommand);
			registerCommand(Notifications.DISPLAY_MORE_CARS_POP_UP, DisplayMoreCarsPopUpCommand);
			registerCommand(Notifications.DISPLAY_INFO_POP_UP, DisplayInfoPopUpCommand);
			registerCommand(Notifications.DISPLAY_PART_INFO_POP_UP, DisplayPartInfoPopUpCommand);
			registerCommand(Notifications.DISPLAY_BUY_PACKET_POP_UP, DisplayBuyPacketPopUpCommand);
			registerCommand(Notifications.REMOVE_POP_UP, RemovePopUpCommand);
			registerCommand(Notifications.DISPLAY_TUNNING_NAME_INPUT_POP_UP, DisplayTunningNameInputPopUpCommand);
			registerCommand(Notifications.DISPLAY_LOGIN_SCREEN, DisplayLoginScreenCommand);
			registerCommand(Notifications.DISPLAY_REGISTER_SCREEN, DisplayRegisterScreenCommand);
			registerCommand(Notifications.DISPLAY_TUNING_SETTINGS_POP_UP, DisplayTuningSettingsPopUpCommand);
			registerCommand(Notifications.DISPLAY_FORGOTTEN_PASSWORD_SCREEN, DisplayForgottenPasswordScreenCommand);
			registerCommand(Notifications.AUTHENTICATE_USER, AuthUserCommand);
			registerCommand(Notifications.DISPLAY_TUNING_SHARING_POP_UP, DisplayTuningSharingPopUpCommand);			
			registerCommand(Notifications.DISPLAY_BUY_CAR_POP_UP, DisplayBuyCarPopUpCommand);
			registerCommand(Notifications.DISPLAY_BUY_REMOVE_ADS_POP_UP, DisplayBuyAdsRemoverPopUpCommand);

            registerCommand(Notifications.DISPLAY_REWARD_INFO_POPUP, DisplayRewardsInfoPopupCommand);
            registerCommand(Notifications.DISPLAY_REWARD_CONFIRM_POPUP, DisplayRewardConfirmPopUpCommand);
            registerCommand(Notifications.DISPLAY_REWARD_NOCOIN_POPUP, DisplayRewardNoCoinPopUpCommand);
            registerCommand(Notifications.DISPLAY_REWARD_NOADS_POPUP, DisplayRewardNoAdsPopUpCommand);

            /**
			 * Challenges command registrations
             */
            registerCommand(Notifications.DISPLAY_START_CHALLENGE_POPUP, DisplayStartChallengePopupCommand);
            registerCommand(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP, DisplayChallengeNotificationsPopupCommand);
            registerCommand(Notifications.DISPLAY_CHALLENGE_TUNING_POPUP, DisplayChallengeTuningViewPopupCommand);
            registerCommand(Notifications.DISPLAY_CHALLENGE_VOTE_POPUP, DisplayChallengeVotePopupCommand);
            registerCommand(Notifications.DISPLAY_CHALLENGE_LEADERBOARD_POPUP, DisplayChallengeLeaderBoardScreenCommand);
            registerCommand(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_TUNING_POPUP, DisplayChallengeNotificationTuningScreenCommand);
            registerCommand(Notifications.DISPLAY_GALLERY_TUNING_POPUP, DisplayGalleryTuningPopupCommand);
            registerCommand(Notifications.DISPLAY_TUNING_VIDEO_POPUP, DisplayTuningVideoPopup);


			registerCommand(Notifications.DISPLAY_USER_PROFILE_SCREEN, DisplayProfilePopupCommand);
			registerCommand(Notifications.DISPLAY_USER_DETAILS_POPUP, DisplayUserDetailsPopupCommand);
		}
		
		public function startup(app : Tuning3D) : void
		{
			sendNotification(Notifications.STARTUP, {app: app, httpClient: httpClient});
		}
	}
}