package com.despark.tuning3d.controller {
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.challenges.modals.ChallengeLeaderBoardScreen;
import com.despark.tuning3d.view.components.challenges.modals.ChallengeVotePopup;

import feathers.layout.HorizontalAlign;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayChallengeLeaderBoardScreenCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var countryLoadCompleteHandler:Function = function(obj:Object):void {
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadFlagTexture(obj.country, false, null);
                assetsProxy.loadBrandScreenAssets(false);
                assetsProxy.loadFeedAssets(false);
                assetsProxy.loadFriendsAssets(null, false);
                assetsProxy.loadChallengeLeaderBoardPopupAssets(function ():void {
                    trace("loadChallengeLeaderBoardPopupAssets");
                    var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var leaderBoardScreen : ChallengeLeaderBoardScreen = new ChallengeLeaderBoardScreen(note.getBody());
                    leaderBoardScreen.countryData = obj;
                    windowMediator.pushScreen(leaderBoardScreen, true, true);
                    if(note.getBody() && note.getBody().hasOwnProperty("isLeaderBoard") && note.getBody().isLeaderBoard){
                        leaderBoardScreen.isLeaderBoard = true;
                    }
                });
            };

            var timelineProxy:TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
            timelineProxy.getCountryApi(countryLoadCompleteHandler);
        }
    }
}
