package com.despark.tuning3d.controller
{
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;


import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayTuningsListScreenCommand extends DisplayScreenCommand {
    override public function execute(note : INotification) : void {
        executeHandler = function ():void {
            var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadBrandScreenAssets(false);
            assetsProxy.loadFeedAssets(true, function () : void {
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var garageScreen : TuningsListScreen = new TuningsListScreen();
                var deleteOthers:Boolean = true;

                if(note.getBody() && note.getBody().hasOwnProperty("deleteOtherScreens")) {
                    deleteOthers = note.getBody().deleteOtherScreens;
                    garageScreen.enableBackward = !deleteOthers;
                    if(windowMediator.window.screenNavigator.screenTypeExists(TuningsListScreen)){
                        deleteOthers = true;
                    }
                    windowMediator.pushScreen(garageScreen, true, deleteOthers);
                    if(deleteOthers){
                        garageScreen.activateCloseButton(function():void{
                            sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
                        });
                    }else if(garageScreen.enableBackward){
                        if(note.getBody()){
                            garageScreen.activateCloseButton(note.getBody().closeHandler);
                        }else{
                            garageScreen.activateCloseButton();
                        }
                    }
                } else {
                    windowMediator.pushScreen(garageScreen);
                    if(note.getBody() && note.getBody().hasOwnProperty("enableCloseButton")){
                        garageScreen.enableBackward = note.getBody().enableCloseButton;
                        if(garageScreen.enableBackward){
                            garageScreen.activateCloseButton(note.getBody().closeHandler);
                        }
                    }
                }
            });
        };
        super.execute(note);

    }
}
}