package com.despark.tuning3d.controller
{
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.assets.AssetsScaleFinder;
import com.despark.tuning3d.model.brands.BrandsProxy;
import com.despark.tuning3d.model.cars.CarsProxy;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.disks.DiskBrandsProxy;
import com.despark.tuning3d.model.languages.LanguagesProxy;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
import com.despark.tuning3d.model.sharing.UserVkView;
import com.despark.tuning3d.view.TuningScreenMediator;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.auth.LoginScreen;
import com.despark.tuning3d.view.components.auth.UserAgreementView;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.AlertViewHL;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.CustomAlertView;
import com.despark.tuning3d.view.components.core.MainMenuView;
import com.despark.tuning3d.view.components.core.PackagesView;
import com.despark.tuning3d.view.components.core.PurchaseView;
import com.despark.tuning3d.view.components.core.TextInputNewView;
import com.despark.tuning3d.view.components.core.TextInputView;
import com.despark.tuning3d.view.components.core.Window;
import com.despark.tuning3d.view.components.instructions.TutorialView;
import com.utils.DisplayObjectUtil;
import com.utils.SplashScreenLogo;
import com.utils.StageUtil;

import flash.display.Bitmap;
import flash.display.Stage;
import flash.display.StageAspectRatio;
import flash.display.StageOrientation;
import flash.events.Event;
import flash.events.StageOrientationEvent;
import flash.geom.Rectangle;
import flash.system.Capabilities;
import flash.utils.clearInterval;
import flash.utils.getTimer;
import flash.utils.setInterval;
import flash.utils.setTimeout;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

import starling.core.Starling;
import starling.events.Event;
import starling.utils.AssetManager;

public class StartupCommand extends SimpleCommand
	{ 		
		
		protected function onOrientationChanging( event:StageOrientationEvent ):void {
			trace("onOrientationChanging:",event.beforeOrientation, event.afterOrientation);
        }
		
		protected function onOrientationChange( event:StageOrientationEvent ):void {
			trace("onOrientationChange:",event.beforeOrientation, event.afterOrientation)
			
			if(Device.isIos()){
				if(Starling.current.isStarted){
					Starling.current.setRequiresRedraw();
				}
			}
		}
		
		public static var  splashLogo:SplashScreenLogo=null;
		private var assetManager: AssetManager;
		private var _startTimeSplashLogo:int=0;
		
		private var _hideIntervalId:int=0;
		private var app : Tuning3D;
		private var googlePixel2XLMenuWidth:Number = 202;
		private var _screenWidth: int;
		private var _screenHeight: int;


		override public function execute(note : INotification) : void {
			trace("StartupCommand");
			_startTimeSplashLogo=getTimer();
			app = note.getBody().app;
			var stage : Stage = app.stage;

			trace("nativeStage.autoOrients:", stage.autoOrients);
			trace("nativeStage.orientation:", stage.orientation);
			
			trace("nativeStage.width:", stage.stageWidth);
			trace("nativeStage.height:", stage.stageHeight);
			
			
			splashLogo  = new  SplashScreenLogo();//LoginScreen.SPLASH_LOGO_CLASS(); // This is in 2x scale

			if (!Constants.isIOS) {
//				AndroidUtilsAne.init();
//				if (AndroidUtilsAne.isSupported) {
////					AndroidUtilsAne.systemUISetFlags(
////							SystemUIFlags.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
////							| SystemUIFlags.STATUS_BAR_HIDDEN
////							| SystemUIFlags.SYSTEM_UI_FLAG_HIDE_NAVIGATION
////							| SystemUIFlags.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
////							| SystemUIFlags.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
////					);
////					AIRAndroidUtils.setUIVisibility( AIRAndroidUtilsUIFlags.SYSTEM_UI_FLAG_HIDE_NAVIGATION );
////					_checkStatusbar();
//
//
////					_screenWidth = AIRAndroidUtils.screenWidth;
////					if (AndroidUtilsAne.getSystemVersion() >= 27) {
////						if (AndroidUtilsAne.getStatusbarHeight() / (Capabilities.screenDPI / 160) > 25) {
////							_screenWidth = _screenWidth - 80;
////						}
////
////					}
////					_screenHeight = AIRAndroidUtils.screenHeight;
//
//					_screenWidth = stage.fullScreenWidth;
//					_screenHeight = stage.fullScreenHeight;
//				} else {
//					_screenWidth = stage.fullScreenWidth;
//					_screenHeight = stage.fullScreenHeight;
//
//				}

				_screenWidth = stage.fullScreenWidth;
				_screenHeight = stage.fullScreenHeight;
			} else {
				_screenWidth = stage.fullScreenWidth;
				_screenHeight = stage.fullScreenHeight;

			}
			if (Device.isBigNoch()) {
				_screenWidth = _screenWidth - 160;
			}

			splashLogo.setSize(stage.fullScreenWidth, stage.fullScreenHeight);
			/*splashLogo.width =  stage.fullScreenWidth;
			splashLogo.height =  stage.fullScreenHeight;*/
			
			splashLogo.x =0;// ((stage.fullScreenWidth - splashLogo.width) / 2);
			splashLogo.y =0;// ((stage.fullScreenHeight - splashLogo.height) / 2);
			app.addChild(splashLogo);
			

			var contentScaleFinder : AssetsScaleFinder = new AssetsScaleFinder();
			var scale : Number = contentScaleFinder.getContentScale(Device.isRoundCornered() ? stage.fullScreenWidth-googlePixel2XLMenuWidth : stage.fullScreenWidth, stage.fullScreenHeight);

			stage.addEventListener( StageOrientationEvent.ORIENTATION_CHANGING, onOrientationChanging );
			stage.addEventListener( StageOrientationEvent.ORIENTATION_CHANGE, onOrientationChange );


			Starling.multitouchEnabled = true;
			//Starling. = !Device.isIos();

            var starlingObj:Starling = new Starling(Window, stage);


			starlingObj.showStats = false;
			starlingObj.skipUnchangedFrames = true;
			starlingObj.simulateMultitouch = false;

			//starlingObj.context.totalGPUMemory
			
			//starlingObj.simulateMultitouch = false;
			starlingObj.enableErrorChecking = Capabilities.isDebugger;
			var stageWidth:Number = stage.fullScreenWidth;
			/*if(Device.isRoundCornered()){
                stageWidth = stage.fullScreenWidth - googlePixel2XLMenuWidth;
			}else */
			if(stage.fullScreenWidth/stage.fullScreenHeight>2 && !Device.isIos()){
                stageWidth = stage.stageWidth;
            }
			starlingObj.viewPort = new Rectangle(0, 0, stageWidth, stage.fullScreenHeight);
			starlingObj.stage.stageWidth = starlingObj.viewPort.width / scale;
			starlingObj.stage.stageHeight = starlingObj.viewPort.height / scale;

			Constants.STAGE_WIDTH=starlingObj.stage.stageWidth;
			Constants.STAGE_HEIGHT=starlingObj.stage.stageHeight;
            Constants.isWide = Constants.STAGE_WIDTH / Constants.STAGE_HEIGHT > 1.5 ;
			Constants.SCALE_FACTOR=scale;  
			Constants.STAGE=stage;
			Constants.SCREEN_WIDTH = Constants.STAGE_WIDTH*scale;
			Constants.SCREEN_HEIGHT = Constants.STAGE_HEIGHT*scale;
			
			trace("Constants.SCREEN_WIDTH:", Constants.SCREEN_WIDTH);
			trace("Constants.SCREEN_HEIGHT:", Constants.SCREEN_HEIGHT);
			
			
			trace("starlingObj.stage.width:", starlingObj.stage.width);
			trace("starlingObj.stage.height:", starlingObj.stage.height);

			
			var logo2 : Bitmap = new LoginScreen.LOGO_CLASS_4(); // This is in 2x scale
			logo2.width  *= scale / 2;
			logo2.height *= scale / 2;
						
			starlingObj.addEventListener(starling.events.Event.ROOT_CREATED, function rootCreatedHandler(event : starling.events.Event, window : Window) : void
			{
				starlingObj.removeEventListener(starling.events.Event.ROOT_CREATED, rootCreatedHandler);
				starlingObj.start();


                stage.addEventListener(flash.events.Event.RESIZE, function onStageResize(event:flash.events.Event):void {
					if(StageUtil.aspectRatio() != StageAspectRatio.LANDSCAPE){
						StageUtil.setAspectRatio(StageAspectRatio.LANDSCAPE);
					} else {
                        var width:Number = Starling.current.nativeStage.stageWidth;
                        var height:Number = Starling.current.nativeStage.fullScreenHeight;

                        var contentScaleFinder:AssetsScaleFinder = new AssetsScaleFinder();
                        var scale:Number = contentScaleFinder.getContentScale(width, height);

                        Starling.current.viewPort = new Rectangle(0, 0, width, height);
                        Starling.current.stage.stageWidth = Starling.current.viewPort.width / scale;
                        Starling.current.stage.stageHeight = Starling.current.viewPort.height / scale;

                        Constants.STAGE_WIDTH = starlingObj.stage.stageWidth;
                        Constants.STAGE_HEIGHT = starlingObj.stage.stageHeight;
                        Constants.isWide = Constants.STAGE_WIDTH / Constants.STAGE_HEIGHT > 1.5;
                        Constants.SCALE_FACTOR = scale;
                        Constants.STAGE = stage;
                        Constants.SCREEN_WIDTH = Constants.STAGE_WIDTH * scale;
                        Constants.SCREEN_HEIGHT = Constants.STAGE_HEIGHT * scale;
                        DisplayObjectUtil.redrawAll(Starling.current.stage);
                    }
                }, false, 100);


				var windowMediator : WindowMediator = new WindowMediator(window);
				windowMediator.starlingObj = starlingObj;
				windowMediator.httpClient = note.getBody().httpClient;
				
				facade.registerMediator(windowMediator);
				
				var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
				assetsProxy.scale = scale;
				
				var brandsProxy : BrandsProxy = facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy;
				brandsProxy.assetManager = assetsProxy.assetManager;
				
				var carsProxy : CarsProxy = facade.retrieveProxy(CarsProxy.NAME) as CarsProxy;
				carsProxy.assetManager = assetsProxy.assetManager;
				
				var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
				languagesProxy.assetManager = assetsProxy.assetManager;
				
				var diskBrandsProxy : DiskBrandsProxy = facade.retrieveProxy(DiskBrandsProxy.NAME) as DiskBrandsProxy;
				diskBrandsProxy.assetManager = assetsProxy.assetManager;
				
				
				var sharingProxy : SharingProxy = facade.retrieveProxy(SharingProxy.NAME) as SharingProxy;
				sharingProxy.logoBitmap = logo2;
				sharingProxy.screenScale = scale;
				
				var sharingVkProxy : SharingVkProxy = facade.retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
				sharingVkProxy.logoBitmap = logo2;
				sharingVkProxy.screenScale = scale;
				
				var sharingInstagramProxy:SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
				sharingInstagramProxy.logoBitmap = logo2;
				sharingInstagramProxy.screenScale = scale;
				
				TuningScreenMediator.logoBitmap = logo2;
				
				AlertView.assetManager = assetsProxy.assetManager;
				AlertViewHL.assetManager = assetsProxy.assetManager;
				UserVkView.assetManager = assetsProxy.assetManager;
				UserAgreementView.assetManager = assetsProxy.assetManager;
				TextInputView.assetManager = assetsProxy.assetManager;
				TextInputNewView.assetManager = assetsProxy.assetManager;
				ButtonFactory.assetManager = assetsProxy.assetManager;
				TutorialView.assetManager = assetsProxy.assetManager;    
				CustomAlertView.assetManager = assetsProxy.assetManager;				
				PackagesView.assetManager = assetsProxy.assetManager;
				MainMenuView.assetManager = assetsProxy.assetManager;
				PurchaseView.assetManager = assetsProxy.assetManager;



                var loadCount : int = 2;

				var checkAndComplete : Function = function() :void
				{
					loadCount --;
					if(loadCount == 0)
					{
                        _hideIntervalId = setInterval(hideSplashScreen, 200);

                        //PackagesView.PACKAGE_ITEM_WIDTH = Device.isIos() ? 242 : Constants.SCALE_FACTOR==3.375 ? 232 : 242;
						sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);

					}
				};


                assetsProxy.loadUpdateText(checkAndComplete);
				assetsProxy.loadAssets(checkAndComplete);
			});
		}



		private function _checkStatusbar(): void {
//			AndroidUtilsAne.systemUISetFlags(SystemUIFlags.STATUS_BAR_HIDDEN);
//			setTimeout(_checkStatusbar, 2000);
		}


		private function hideSplashScreen():void
		{
			try{
			
//				if (/*getTimer() -_startTimeSplashLogo > 4000*/  BrandsScreenMediator.FIRST_LOAD_COMPLETE)
				{
					clearInterval(_hideIntervalId);
					_hideIntervalId = 0;
	
					if (Device.isIos()){
						app.removeChild(splashLogo);  
						splashLogo = null;
					}else{
						splashLogo.visible = false;
					}
	
	                //splashLogo.dispose();
				}
				
			}catch(e:Error){
				
				
			}
		}
	}
} 