package com.despark.tuning3d.model.brands
{
	import flash.data.SQLConnection;
	import flash.data.SQLStatement;
	import flash.events.EventDispatcher;
	import flash.events.SQLErrorEvent;
	import flash.events.SQLEvent;
	import flash.filesystem.File;
	
	public class BrandsDB extends EventDispatcher
	{
		
		
		private var sessionDBConn:SQLConnection;
		private var sessionDBFile:File;
		private var queryStmt:SQLStatement;
		private static var _ref:BrandsDB = null;
		
		public function BrandsDB()
		{
			if(_ref){
				throw new Error("Use function getInstance()");
				return;
			}
			
			sessionDBConn = new SQLConnection();
			sessionDBConn.addEventListener(SQLEvent.OPEN, openSessionSuccess);
			sessionDBConn.addEventListener(SQLErrorEvent.ERROR, openSessionFailure);
			
			var embededSessionDB:File = File.applicationDirectory.resolvePath("brands.db");
			sessionDBConn.openAsync(embededSessionDB);
		}
		
		public function getInstance():BrandsDB{
			
			if(!_ref) _ref = new BrandsDB();
			
			return _ref;
		}
		
		private function dropAllTable():void{
			
			var queryStmt:SQLStatement = new SQLStatement();
			queryStmt.sqlConnection = sessionDBConn;
			var sql:String = "";
			sql += " DROP TABLE IF EXISTS brands;\n"
			sql += " DROP TABLE IF EXISTS brands_cars; "
			queryStmt.text = sql;
			
			queryStmt.addEventListener(SQLEvent.RESULT, onResultDropAllTable);
			queryStmt.addEventListener(SQLErrorEvent.ERROR, onErrorDropAllTable);
			
			queryStmt.execute();
		}
		
		private function onResultDropAllTable(event:SQLEvent):void{
			trace("onResultDropAllTable");
			createAllTable();
		}
		
		private function onErrorDropAllTable(event:SQLErrorEvent):void{
			trace("onErrorDropAllTable");
		}
		
		
		private function createAllTable():void{
			
			var queryStmt:SQLStatement = new SQLStatement();
			queryStmt.sqlConnection = sessionDBConn;
			var sql:String = "";
			sql += "CREATE TABLE IF NOT EXISTS brands (";
			sql += "	id	TEXT PRIMARY KEY,";
			sql += "	remoteUrl	TEXT,";
			sql += "	imageURL	TEXT,";
			sql += "	localFile	TEXT,";
			sql += "	name	TEXT,";
			sql += "	lastAdded	INTEGER,";
			sql += "	index	INTEGER,";
			sql += "	isDefault	INTEGER,";
			sql += "	isEncrypted	INTEGER,";
			sql += "	ignoresTransparentPixelsOnTouch	INTEGER,";
			sql += "	touchable	INTEGER,";
			sql += "	important	INTEGER,";
			sql += "	brightness	REAL";
			sql += ");\n";
			
			queryStmt.text = sql;
			
			queryStmt.addEventListener(SQLEvent.RESULT, onResultCreateAllTable);
			queryStmt.addEventListener(SQLErrorEvent.ERROR, onErrorCreateAllTable);
			
			queryStmt.execute();
		}
		
		private function onResultCreateAllTable(event:SQLEvent):void{
			trace("onResultCreateAllTable");
			this.dispatchEvent(new BrandsDBEvent(BrandsDBEvent.READY));
		}
		
		private function onErrorCreateAllTable(event:SQLErrorEvent):void{
			trace("onErrorCreateAllTable");
		}
		
		
		private function onInsertBrandResult(event:SQLEvent):void{
			
			
		}
		
		private function onInsertError(event:SQLErrorEvent):void{
			
			
		}
		
		private function openSessionSuccess(event:SQLEvent):void{
			
			trace("openSessionSuccess");
			dropAllTable();
			
		}
		
		private function openSessionFailure(event:SQLEvent):void{
			
			
		}
		
		public function insertBrand(data:Object):void{
			
			
			
			var insertStmt:SQLStatement = new SQLStatement();
			insertStmt.sqlConnection = sessionDBConn;
			var sql:String = "";
			sql += "INSERT INTO brands (id, remoteUrl, imageURL, localFile, name, lastAdded, index, isDefault, isEncrypted, ignoresTransparentPixelsOnTouch, touchable, important, brightness) ";
			sql += "VALUES ('Bob', 'Smith', 8000)";
			insertStmt.text = sql;
			
			insertStmt.addEventListener(SQLEvent.RESULT, onInsertBrandResult);
			insertStmt.addEventListener(SQLErrorEvent.ERROR, onInsertError);
			
			insertStmt.execute();
		}
		
		
	}
}