package com.despark.tuning3d.model.cars
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	import com.despark.tuning3d.model.parts.Material3dtProvider;
	
	import flash.filesystem.File;
	
	public class CarBackground implements PersistentImageProvider {
		public static const DEFAULT_ID:String = "58e6705efbf756040095bb34";
		public function CarBackground() {
			super();
		}
		
		public var id : String;
		public var isCustom : Boolean;
		public var thumbnailUrl : String;
		public var mainUrl : String;
		public var showThumbnailUrl : Boolean = true;
		public var isLocalFile:Boolean = false;
		public var imagePathSecondCam:String;
        private var _isEncrypted : Boolean = false;
		public var customSnapshotsCamera:int = 0;
		public var selectedCamera:int = 0;

        private var _isDefault : Boolean;
		
		
		public function copyWithShowMainUrl() : CarBackground
		{
			var copyOfCarBackground : CarBackground = new CarBackground();
			copyOfCarBackground.id = id;
			copyOfCarBackground.isCustom = isCustom;
			copyOfCarBackground.thumbnailUrl = thumbnailUrl;
			copyOfCarBackground.mainUrl = mainUrl;
			copyOfCarBackground.showThumbnailUrl = false;
			copyOfCarBackground.imagePathSecondCam = imagePathSecondCam;
			
			return copyOfCarBackground;
		}
		
		private function get url() : String 
		{
			if(showThumbnailUrl){
				if(selectedCamera==0)
				return "http:" + thumbnailUrl;
				else return imagePathSecondCam;
			}else{
				
				if(selectedCamera==0){
					if(!isLocalFile){
						return "http:" + mainUrl;
					}else{
						return mainUrl;
					}
				}else{
					
					//if(!isLocalFile){
					//	return "http:" + mainUrl;
					//}else{
					return imagePathSecondCam;
					//}
				}
			}
		}
		
		public function get frameIndeX() : int 
		{
			return -1;
		}
		
		public function get isDefault() : Boolean 
		{
			return _isDefault;
		}
		
		public function set isDefault(value : Boolean) : void
		{
			_isDefault = value;
		}
		
		public function get localFile() : String
		{
			var localPath : String;
			
			if(isCustom)
			{
				//localPath = "Cars/Backgrounds/Custom/" + url;
				localPath = String(url).replace(Constants.BACKGROUNDS_URL, "Cars/Backgrounds/");
			}
			else
			{
				localPath = String(url).replace(Constants.BACKGROUNDS_URL, "Cars/Backgrounds/");
			}
			
			//var file1: File = File.cacheDirectory.resolvePath(localPath);
			//file1.preventBackup = true;
			return localPath;
		}
		
		public function get remoteUrl() : String
		{
			return url;
		}
        public function set isEncrypted(value : Boolean) : void
        {
            _isEncrypted = value;
        }

        public function get isEncrypted() : Boolean
		{
			return false;
		}
		
		public function get ignoresTransparentPixelsOnTouch() : Boolean 
		{
			return false;
		}
		
		public function get touchable() : Boolean 
		{
			return true;
		}
		
		public function get important() : Boolean
		{
			return true;
		}
		
		public function get brightness() : Number
		{
			return 1.0;
		}
		
		public function set brightness(value : Number) : void
		{
			
		}
		
		public function get material3dtProvider() : Material3dtProvider
		{
			return null;
		}
	}
}


