package com.despark.tuning3d.model.challenges.feed {
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeLabel;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeNotesLabelFactory;
import com.utils.DateParser;
import com.utils.ObjectUtils;

import feathers.controls.Label;

import starling.display.DisplayObject;
import starling.events.Touch;
import starling.events.TouchEvent;
import starling.events.TouchPhase;

public class ChallengeAcceptedNoteData extends ChallengeNotificationData {
    private var _tuning:Tuning;
    private var _creatorLabel:Label;
    private var _textLabel:Label;
    public function ChallengeAcceptedNoteData(data:Object) {
        _iconTextureId = "challenge_accepted_icon";
        _tuning = TuningsProxy.parseTuning(data.tuning, false);
        super(data);
        _time =  new Date().time - DateParser.parseDate(data.updated).time;
        //
        if(ObjectUtils.hasProperty(_data, 'challenge.owner.user') && _data.challenge.owner.user is String){

        }

        if(ObjectUtils.hasProperty(_data, 'challenge.owner.user') && _data.challenge.owner.user is String){

        }
        trace();
    }



    override public function dispose():void {
        super.dispose();
        if(_creatorLabel){
            _creatorLabel.removeFromParent(true);
            _creatorLabel = null;
        }
        if(_textLabel){
            _textLabel.removeFromParent(true);
            _textLabel = null;
        }
    }

    override public function createView():void {
        if(!_disposed){
            return;
        }
        super.createView();

        var usersProxy:UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
        var currentUser:User = usersProxy.currentUser;

        var vsUser:User;
        if(_data.challenge.owner.user == currentUser.id){
            if(ObjectUtils.hasProperty(_data, 'user._id') && _data.challenge.receiver.user == _data.user._id){
                vsUser = new User(_data.user);
            }
        }else if(ObjectUtils.hasProperty(_data, 'user._id') && _data.challenge.owner.user == _data.user._id){
            vsUser = new User(_data.user);
        }

        _creatorLabel = new Label();
        _creatorLabel.textRendererFactory = ChallengeNotesLabelFactory.nameLabelRenderer;
        if(vsUser){
            _creatorLabel.text = "You & " + vsUser.nameToShow;
        }else{
            trace('No user data found');
        }

        _textLabel = new Label();
        _textLabel.textRendererFactory = ChallengeNotesLabelFactory.messageLabelRenderer;
        _textLabel.text = "started challenge";

        _challengeLabel = new ChallengeLabel(_data.challenge.owner.tuning is String ? _data.tuning : _data.challenge.owner.tuning, _data.challenge.receiver.tuning is String  ? null : _data.challenge.receiver.tuning);
        _challengeLabel.onComplete = function():void{
            _holder.updateView();
        };
        _challengeLabel.addEventListener(TouchEvent.TOUCH, triggeredHandler);
        _creatorLabel.addEventListener(TouchEvent.TOUCH, triggeredHandler);

        _messageLabel.addChild(_creatorLabel);
        _messageLabel.addChild(_textLabel);
        _creatorLabel.validate();
        _textLabel.validate();
        _messageLabel.validate();
    }

    private function triggeredHandler(event:TouchEvent):void {
        var touch:Touch = event.getTouch(event.target as DisplayObject, TouchPhase.ENDED);
        if (touch && !_holder.owner.isScrolling){
            showChallengePopup();
        }
    }
}
}
