package com.despark.tuning3d.model.challenges.feed {
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeNotesLabelFactory;
import com.despark.tuning3d.view.components.challenges.controls.TuningLabel;
import com.utils.DateParser;

import feathers.controls.Label;

public class ChallengeRejectedNoteData extends ChallengeNotificationData {
    private var _creatorLabel:Label;
    private var _textLabel:Label;
    private var _tuningLabel:Label;
    private var _tuning:Tuning;
    public function ChallengeRejectedNoteData(data:Object) {
        _iconTextureId = "challenge_rejected_icon";
        _tuning = TuningsProxy.parseTuning(data.tuning, false);
        super(data);
        _time =  new Date().time - DateParser.parseDate(data.updated).time;
    }

    override public function createView():void {
        if(!_disposed){
            return;
        }
        super.createView();

        _creatorLabel = new Label();
        _creatorLabel.textRendererFactory = ChallengeNotesLabelFactory.nameLabelRenderer;
        _creatorLabel.text = "Your";

        _tuningLabel = new Label();
        _tuningLabel.textRendererFactory = ChallengeNotesLabelFactory.tuningLabelRenderer;
        _tuningLabel.text = _tuning.name;

        _textLabel = new Label();
        _textLabel.textRendererFactory = ChallengeNotesLabelFactory.messageLabelRenderer;
        _textLabel.text = "challenge was rejected";

        _messageLabel.addChild(_creatorLabel);
        _messageLabel.addChild(_tuningLabel);
        _messageLabel.addChild(_textLabel);

        _tuningView = new TuningLabel(_tuning.thumbnailURL);
        _tuningView.loadComplete = function():void{
            _holder.updateView();
            _holder.validate();
        };
    }

    override public function dispose():void {
        super.dispose();
        if(_creatorLabel){
            _creatorLabel.removeFromParent(true);
            _creatorLabel = null;
        }
        if(_textLabel){
            _textLabel.removeFromParent(true);
            _textLabel = null;
        }
        if(_tuningLabel){
            _tuningLabel.removeFromParent(true);
            _tuningLabel = null;
        }
    }
}
}
