package com.despark.tuning3d.model.core {

import flash.system.Capabilities;

import starling.utils.MathUtil;

public class Device {
    private static var init:Boolean = false;
    private static var iOS:Boolean = true;
    private static var googlePixel:Boolean = false;
    private static var  isRoundCorner:Boolean = false;
    private static var emulator:Boolean = false;
	private static var iPhoneX:Boolean = false;

    private static var haveBigNoch: Boolean = false;
    private static function initialize():void {
        iOS = (Capabilities.manufacturer.indexOf("iOS") != -1 );

        var man:String = Capabilities.manufacturer;
        emulator = man.indexOf("Adobe Windows") != -1 || Capabilities.manufacturer.indexOf("Adobe Macintosh") != -1;
//
//        if (!emulator && !iOS) {
//            var deviceInfo:DeviceInfo = DeviceInfoExtension.instance.deviceInfo;
//            var brand : String = deviceInfo.brand.toLocaleLowerCase();
//            var model : String = deviceInfo.model.toLocaleLowerCase();
//            Tracer.print(brand, 'Brand');
//            Tracer.print(model, 'Model');
//
//
//            googlePixel = (brand == "google" && model.indexOf('ixel') >= 0);
//            isRoundCorner = googlePixel || isRoundCorner;
//
//            isRoundCorner = isRoundCorner || (brand == "xiaomi" && model == "mi 8");
//            isRoundCorner = isRoundCorner || (brand == "xiaomi" && (model.indexOf('poco') >= 0 || model.indexOf('redmi 6') >= 0));
//            isRoundCorner = isRoundCorner || (brand == "huawei" && model.indexOf('p20') >= 0);
//            isRoundCorner = isRoundCorner || (brand == "samsung" && model.indexOf('galaxy s10') >= 0);
//
//
//            if (brand == "google" && model.indexOf("ixel 3") > -1
//                    || (model.indexOf('moto g7') > -1)
//                    || (model.indexOf('sm-g970') > -1 || model.indexOf('sm-g973') > -1 || model.indexOf('sm-g975') > -1 || model.indexOf('sm-g977') > -1)) {
//                haveBigNoch = true;
//            }
//        }

        init = true;
    }



    public static function isIos():Boolean {
        if (!init) {
            initialize();
        }
        return iOS;
    }

    public static function isEmulator():Boolean {
        if (!init) {
            initialize();
        }
        return emulator;
    }
	
	public static function isIphoneX():Boolean {
		
		if (!init) {
			initialize();
		}
		
		return Device.isIphoneXVariant();
	}

    public static function isGooglePixel2XL():Boolean {

        if (!init) {
            initialize();
        }

        return googlePixel;
    }

    public static function isRoundCornered():Boolean {

        if (!init) {
            initialize();
        }

        return isRoundCorner;
    }

    public static function isBigNoch(): Boolean {
        if (!init) {
            initialize();
        }
        return haveBigNoch;
    }

    public static const IPHONE_X_VARIANT_MARGIN_TOP:int = 44;
    public static const IPHONE_X_VARIANT_MARGIN_BOTTOM:int = 34;
    public static const IPHONE_X_VARIANT_MARGIN_LEFT:int = 44;
    public static const IPHONE_X_VARIANT_MARGIN_RIGHT:int = 44;
    public static function isIphoneXVariant():Boolean {
        var longSide:int = MathUtil.max(Capabilities.screenResolutionX, Capabilities.screenResolutionY);
        return Device.isIos() && (longSide == 1792 || longSide == 2436 || longSide == 2688 || longSide == 1624);
    }

}
}