

package com.despark.tuning3d.model.core.images
{
	
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.http.URLLoaderObjects;
	import com.despark.tuning3d.model.core.images.BitmapDataUtil;
	import com.despark.tuning3d.model.parts.PartMaterialImage;
	import com.utils.Logger;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.system.ImageDecodingPolicy;
	import flash.system.LoaderContext;
	import flash.utils.ByteArray;
	import flash.utils.getTimer;
	import flash.utils.setTimeout;
	
	public class ImageCacher
	{
		private static const LOADER_CONTEXT:LoaderContext = new LoaderContext(true);
		LOADER_CONTEXT.imageDecodingPolicy = ImageDecodingPolicy.ON_LOAD;
		LOADER_CONTEXT.checkPolicyFile = false;
		
		protected var urlLoader : URLLoader;	
		protected var loader : Loader;
		
		public var source:String;
		public var completeHandler : Function;
		public var errorHandler : Function;
		public var cachingErrorHandler : Function;
		public var bitmapLoadedHandler : Function;
		public var persistentImageProvider : PersistentImageProvider;
		public var important : Boolean = true;
		
		public var cache : Boolean;
		public var decryptAndLoad : Boolean;
		
		public var onlyLoad:Boolean;
		
		private static var maxCountLoader:int=10;
		
		
		public function load() : void
		{
			
			//if(!Constants.isIOS){
			
			maxCountLoader=100;
			//}
			
			var url : String = null;
			if(cache){
				/*if(persistentImageProvider.material3dtProvider){
					url = persistentImageProvider.material3dtProvider.url;
				}else{*/
				url = persistentImageProvider.remoteUrl;
				//}
			}else{
				var localFile: File = File.cacheDirectory.resolvePath( persistentImageProvider.localFile);
				localFile.preventBackup = true;
				
				url = localFile.url;
			}
			
			/*if(persistentImageProvider.material3dtProvider){
				
				//persistentImageProvider.material3dtProvider.dicOfImageLoaderWithStates[frameIndex] = this;
				persistentImageProvider.material3dtProvider.dicOfImageCacher[persistentImageProvider.frameIndeX] = this;
				
				switch(persistentImageProvider.material3dtProvider.stepOfDownloading){
					
					case persistentImageProvider.material3dtProvider.stepOfDownloading_None:
					{
						persistentImageProvider.material3dtProvider.stepOfDownloading = persistentImageProvider.material3dtProvider.stepOfDownloading_Downloading;
						
					}
						break;
					case persistentImageProvider.material3dtProvider.stepOfDownloading_Downloading:
					{
						//уже идет згрузка
						
						return;
					}
						break;
					case persistentImageProvider.material3dtProvider.stepOfDownloading_Downloaded:
					{
						//это не должно выполнятся так как localFile уже должен быть
						break;
					}
						break;
					
					
				}
				
				
			}*/
			
			
			
			delayLoad(url);
			
			
		}
		
		private var isUrlLoaderStarted:Boolean=false;
		private static var urlLoaderFull:Boolean=false;
		private static var openedLoaderCount:int=0;
		
		
		
		private function delayLoad(url:String):void{
			
			if(!isUrlLoaderStarted && !urlLoaderFull){
				
				urlLoader =  URLLoaderObjects.getInstance().takeLoader();
				urlLoader.dataFormat = URLLoaderDataFormat.BINARY;
				urlLoader.addEventListener(flash.events.Event.COMPLETE, urlLoader_completeHandler);
				urlLoader.addEventListener(IOErrorEvent.IO_ERROR, urlLoader_errorHandler);
				urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoader_errorHandler);
				
				
				var request : URLRequest = new URLRequest(url);
				request.idleTimeout = Constants.IMAGE_REQUESTS_TIMEOUT;
				
				isUrlLoaderStarted=true;
				openedLoaderCount++;
				if(openedLoaderCount>=maxCountLoader){
					urlLoaderFull=true;
				}
				urlLoader.load(request);
				
				
				//Logger.d(openedLoaderCount+'. load image:'+url, this);
				
				
				
			}else if(!isUrlLoaderStarted){
				setTimeout(delayLoad, 10, url);
			}
			
		}
		
		public function cancel() : void
		{
			if(urlLoader)
			{
				try
				{
					urlLoader.removeEventListener(flash.events.Event.COMPLETE, urlLoader_completeHandler);
					urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, urlLoader_errorHandler);
					urlLoader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoader_errorHandler);
					
					openedLoaderCount--;		
					
					if(openedLoaderCount<=0){  
						openedLoaderCount=0;
						urlLoaderFull=false;
					}
					isUrlLoaderStarted=false;
					
					//urlLoader.
					urlLoader.close();
					
					//urlLoader=null;
				}
				catch(error : Error)
				{
					//no need to do anything in response
					
					Logger.e("cancel error:"+error.message+" stack:"+error.getStackTrace(), this);
				}
				
				URLLoaderObjects.getInstance().releaseLoader(urlLoader);
				urlLoader = null;
			}
			
			if(loader) 
			{
				loader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, loaderCompleteHandler);
				loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loaderErrorHandler);
				
				try
				{
					
					
					
					loader.close();
					
					
					
					
					
				}
				catch(error : Error)
				{
					//no need to do anything in response
				}
				
				try{
					
				}catch(e:Error){
					
					loader.unload();   
				}
				
				loader = null;
			}
		}
		
		protected function urlLoader_completeHandler(event:flash.events.Event):void
		{		
			try{
				
				
				
				
				var data:*=urlLoader.data;
				
				urlLoader.data=null;
				
				cancel();
				
				//Logger.d("urlLoader_completeHandler", this);
				/*if(persistentImageProvider.material3dtProvider ){
					
					var localFile: File = File.cacheDirectory.resolvePath( persistentImageProvider.localFile);
					localFile.preventBackup = true;
					
					
					if(localFile.exists){
						var nameOfImage : String = persistentImageProvider.material3dtProvider.nameOfImageByNativePath(localFile.nativePath);
						var imageInfo : String = nameOfImage.substring(nameOfImage.indexOf("00") + 2, nameOfImage.length - 4);
						var imageInfoParts : Array = imageInfo.split("_");
						
						var frameIndex : int = parseInt(imageInfoParts[0]);
						var x : int = parseInt(imageInfoParts[1]) ;
						var y : int = parseInt(imageInfoParts[2]);
						
						var partMaterialImage : PartMaterialImage = persistentImageProvider.material3dtProvider.dicOfPartMaterialImages[frameIndex];
						
						//partMaterialImage.x += x;
						//partMaterialImage.y += y;
						//this.x = this.kx * partMaterialImage.x + this.ax;
						//this.y = this.ky * partMaterialImage.y + this.ay;
						
						
						performBytesAfterDownloading(data,nameOfImage);
					}else{
						var resultOfDecrypting3DTfile : Boolean = persistentImageProvider.material3dtProvider.decrypte3DTfile(data);
					}
					
				}else{*/
				performBytesAfterDownloading(data);
				//}
				
			}catch(e:Error){
				
				
				//trace("urlLoader_completeHandler error:"+e.message/*+" stack:"+e.getStackTrace()*/);
			}
			
			
			//////////////
			//var bytes : ByteArray = urlLoader.data as ByteArray;
			
			
		}
		
		public function performBytesAfterDownloading(__imageBytes : ByteArray, __filename : String = null): void
		{
			
			
			imageBytesLoaded(__imageBytes,__filename);
			
		}
		
		protected function imageBytesLoaded(bytes : ByteArray, __filename : String = null) : void
		{	
			/*if(persistentImageProvider.material3dtProvider){
				
				
				//Logger.d('persistentImageProvider.material3dtProvider==true', this);
				
				
			}
			*/
			
			if(decryptAndLoad || bitmapLoadedHandler) 
			{
				decryptAndLoadImageBytes(bytes,__filename, !onlyLoad);
			}
			
			if(cache) 
			{
				cacheImageBytes(bytes);
			}
		}
		
		private function cacheImageBytes(bytes : ByteArray) : void
		{
			
			var localFile: File = File.cacheDirectory.resolvePath(persistentImageProvider.localFile);
			localFile.preventBackup = true;
			
			BitmapDataUtil.saveImageBytes(bytes,localFile, cacheError); 
			
			if(completeHandler)
			{
				completeHandler(this);
			}
		}
		
		private function cacheError() : void
		{
			if(cachingErrorHandler) 
			{
				cachingErrorHandler(this);
			}
		}
		
		private function decryptAndLoadImageBytes(bytes : ByteArray,__filename : String = null, decrypt:Boolean=true) : void
		{
			//			var filename : String = null;
			//			if(persistentImageProvider.material3dtProvider){
			//				trace("test");
			//				filename = persistentImageProvider.material3dtProvider.nameOfImageByNativePath(persistentImageProvider.localFile.nativePath);
			//				
			//				
			//			}
			

			if(decryptAndLoad && decrypt){
				
				BitmapDataUtil.decryptImageBytes(bytes, persistentImageProvider.remoteUrl,__filename);
			}
			
			
			cancel();  
			try{
				
				loader = new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loaderCompleteHandler);
				loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loaderErrorHandler);
				loader.loadBytes(bytes, LOADER_CONTEXT);
				
				
				
			}catch(e:Error){
				
				
			}
			
		}
		
		private function loaderCompleteHandler(event : Event) : void
		{
			
			//Logger.d('loaderCompleteHandler', this);
			
			
			var bitmap : Bitmap = Bitmap(loader.content);
			
			if(bitmapLoadedHandler) 
			{
				bitmapLoadedHandler(bitmap);
			}
			
			cancel();
		}
		
		private function loaderErrorHandler(event : IOErrorEvent) : void
		{
			cancel();
		}
		
		private function fileStreamIoErrorHandler(event : IOErrorEvent) : void 
		{
			if(cachingErrorHandler)
			{
				cachingErrorHandler(this);
			}
		}
		
		protected function urlLoader_errorHandler(event:ErrorEvent):void
		{		
			cancel();
			
			if(important)
			{
				if(errorHandler)
				{
					errorHandler(this);
				}
			}
			else 
			{
				if(completeHandler)
				{
					completeHandler(this);
				}
			}
		}
	}
}