package com.despark.tuning3d.model.disks
{
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	import com.despark.tuning3d.model.parts.Material3dtProvider;
	import com.despark.tuning3d.model.parts.Part;
	
	import flash.filesystem.File;
	
	public class DiskBrand implements PersistentImageProvider {
		public var id : String;
		public var imageUrl : String;
        public var link:String;
        public var possibleParts : Array;
        public var sortKey:int=-1;
		private var _brightness : Number;
        private var _isDefault : Boolean;
        private var _name : String;
		public var isAllBrands:Boolean=false;
		public var existCamber:Boolean=false;
		public static const PROFILE_REG_EXP:RegExp = /\((DEEP|MID|FLAT|S\.DEEP)\)/gms;
		public static var ref:DiskBrand;
		
		public function DiskBrand(){
			ref=this;
		}
		
		public function addPossiblePart(part : Part) : void {
			//part.parentSlot = this;
			possibleParts.push(part);
		}
		
		public function set name(value:String):void{
			_name = value;
		}

		public function get name():String{
			return _name;
		}
		
		public function get brightness():Number
		{
			return _brightness;
		}
		
		public function set brightness(value:Number):void
		{
			_brightness = value;
		}
		
		public function get frameIndeX():int
		{
			return -1;
		}
		
		public function get ignoresTransparentPixelsOnTouch():Boolean
		{
			return false;
		}
		
		public function get important():Boolean
		{
			return false;
		}
		
		public function get isDefault():Boolean
		{
			return _isDefault;
		}
		
		public function set isDefault(value:Boolean):void
		{
			_isDefault = value;
		}
		
		public function get isEncrypted():Boolean
		{
			return false;
		}
		
		public function get localFile():String
		{
			//var localImagePath : String = imageUrl.replace(Constants.IMAGES_URL, "Cars/");
			if(imageUrl){
				var localImagePath : String = imageUrl.replace("http://www.dmtruckparts.com/media/import/", "Cars/");
				return localImagePath;
			}else{
				
				return "";
			}
			
			
			
		}
		
		public function get material3dtProvider():Material3dtProvider
		{
			return null;
		}
		
		public function get remoteUrl():String
		{
			return imageUrl;
		}
		
		public function get touchable():Boolean
		{
			return true;
		}
		
	}
}

