package com.despark.tuning3d.model.disks {
	import by.blooddy.crypto.serialization.JSONer;
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.model.core.http.HttpClient;
	import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;
	import feathers.data.ListCollection;
	import org.puremvc.as3.patterns.proxy.Proxy;
	import starling.utils.AssetManager;
	public class DiskBrandsProxy extends Proxy {
		public static var NAME : String = "DiskBrandsProxy";
		public var httpClient : HttpClient;
		public var assetManager : AssetManager;
		private var diskBrandsParser : DiskBrandsParser;
		public function DiskBrandsProxy() {
			super(NAME);
			diskBrandsParser = new DiskBrandsParser();
		}
		
		public function loadDiskBrands(car_id:String) : void {
			httpClient.getPathCached("manufacturers",{carid:car_id}, HttpCachePolicy.INTERNET_FIRST, function(success : Boolean, result : Object) : void {
				if(success) {
					var diskBrandsJSON : Array = JSONer.parse(result as String) as Array;
					var diskBrands : Array = diskBrandsParser.parseObjects(diskBrandsJSON);
					Disk.brandList = new ListCollection(diskBrands);
					var brandFactory:DiskBrand = new DiskBrand();
					brandFactory.id="factory";
					brandFactory.name="factory";
					brandFactory.sortKey=1;
					//brandFactory.im
					Disk.brandList.addItemAt(brandFactory, 0);
					var brandAll : DiskBrand = new DiskBrand();
					brandAll.sortKey=0;
					brandAll.id = "0";
					brandAll.name = "All brands";
					//brandAll.imageUrl = "http://ridenegotiator.com/allBrands.png";
					brandAll.isAllBrands=true;
					Disk.brandList.addItemAt(brandAll, 0);
					sendNotification(Notifications.DISK_BRANDS_LOADED);
				} else {
					sendNotification(Notifications.DISK_BRANDS_LOADING_FAILED);
				}
			});
		}
	}
}