package com.despark.tuning3d.model.friend
{
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.friends.FriendItemRenderer;
import com.utils.DateParser;

public class Friend
{
    public static const STATE_NO_FRIEND : String = "STATE_NO_FRIEND";
    public static const STATE_REQUEST_SENT : String = "STATE_REQUEST_SENT";
    public static const STATE_PENDING : String = "STATE_PENDING";
    public static const STATE_FRIEND : String = "STATE_FRIEND";

    public static var CURRENT_USER : User;
    public static var PROXY : FriendProxy;

    private var _state:String = STATE_NO_FRIEND;

    private var _user : User;
    public var requestId: String = '';
    private var _holder : IFriendHolder;
    private var _date : Date;
    private var _updatedDate : Date;

    public function Friend(state:String, data : Object) {
        _state = state;

        if(data){
            switch (_state){
                case STATE_NO_FRIEND:
                case STATE_FRIEND:
                    _user = new User();
                    _user.name = data.name;
                    _user.avatarPath = data.avatar;
                    _user.username  = data.username;
                    _user.id = data._id;
                    break;
                case STATE_REQUEST_SENT:
                case STATE_PENDING:
                    _user = new User();
                    _user.name = data.sender.name;
                    _user.avatarPath = data.sender.avatar;
                    _user.username  = data.sender.username;
                    _user.id = data.sender._id;
                    if(data.created){
                        _date = DateParser.parseDate(data.created);
                    }
                    if(data.updated){
                        _updatedDate = DateParser.parseDate(data.updated);
                    }
                    break;
            }
        }
    }

    public function removeHolder(item: IFriendHolder) : void{
        if(item == _holder){
            _holder = null;
        }
    }

    public function notifyHolder(state : String):void {
        this._state = state;

        if(_holder ){
            _holder.updateFriendState(state);
        }
    }

    public function get holder() : IFriendHolder{
        return _holder;
    }

    public function set holder(item: IFriendHolder):void {
        _holder = item;
    }

    public function set state(state : String) : void{
        this._state = state;
    }

    public function get state() : String{
        return _state;
    }

    public function get user():User {
        return _user;
    }

    public function set user(value:User):void {
        _user = value;
    }

    public function get availableDate() : Date
    {
        if(_updatedDate)
            return _updatedDate;

        return _date;
    }
}
}