package com.despark.tuning3d.model.languages
{
	import com.despark.tuning3d.ApplicationFacade;
	import com.despark.tuning3d.model.settings.Settings;
	import com.despark.tuning3d.model.settings.SettingsProxy;

	public class Language
	{
		public var name : String;
		public var code : String;
		public var shortname:String;
		public var dictionaries : Object;
		
		public static const CODES_SUPPORTING_EMBEDDED_FONT : Array = [ 
			"en-US", 
			"ru-RU"

		];
		
		public function Language(aDictionaries : Object) 
		{
			super();
			dictionaries = aDictionaries;
			shortname="";
		}		
		
		public function translate(category : String, key : String) : String   
		{		
			
			if(!key){
				
				return "";  
			}
			
			if(!dictionaries){
				return key.replace("_"," ").replace("_"," ").replace("_"," ");
			}
			
			if(!dictionaries[category]){
				
				return key.replace("_"," ").replace("_"," ").replace("_"," ");
			}
			
			
			if(!dictionaries[category][key]){
				
				return key.replace("_"," ").replace("_"," ").replace("_"," ");
			}
			
			
		
			
			return dictionaries[category][key];
		}
		
		public function get supportsEmbeddedFont() : Boolean 
		{
			return true;//CODES_SUPPORTING_EMBEDDED_FONT.indexOf(code) != -1;
		}
		
		public static function get supportsEmbeddedFont():Boolean{
			
			var facade :ApplicationFacade = ApplicationFacade.getInstance();
			
			var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
			var settings : com.despark.tuning3d.model.settings.Settings = settingsProxy.currentSettings;
			
			
			return true;//CODES_SUPPORTING_EMBEDDED_FONT.indexOf(settings.selectedLanguageCode) != -1;
		}
	}
}