package com.despark.tuning3d.model.languages
{
    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.core.http.HttpClient;

    import flash.events.Event;
    import flash.filesystem.File;
    import flash.globalization.LocaleID;
    import flash.globalization.StringTools;
    import flash.net.SharedObject;
    import flash.net.URLLoader;
    import flash.net.URLRequest;

    import org.puremvc.as3.patterns.proxy.Proxy;

    import starling.utils.AssetManager;

    public class LanguagesProxy extends Proxy {
    public static const NAME : String = "LanguagesProxy";

    public var httpClient :HttpClient;
    public var assetManager : AssetManager;

    private var map : Object;
    private var languagesParser : LanguagesParser;
    private var _languages : Array;
    private var loadingStringForCurrentLanguageSharedObject : SharedObject;

    public static const LANG_NAMES : Object = {
        "en-US":"English",
        "ru-RU":"Russian"
        /*"de-DE":"German",
        "es-ES":"Spanish",
        "fr-FR":"French",
        "pt-PT":"Portuguese",
        "az-AZ":"Azeri (Latin)",
        "kk-KZ":"Kazakh",
        "it-IT":"Italian"*/
    };

    //tempstab

    public function LanguagesProxy() {
        super(NAME);

        map = {};
        languagesParser = new LanguagesParser();
        loadingStringForCurrentLanguageSharedObject = SharedObject.getLocal("loadingStringForCurrentLanguageSharedObject");
    }

    public function get languages() : Array {
        return _languages;
    }

    public function get defaultLanguageCode() : String {
        var stringTool:StringTools=new StringTools(LocaleID.DEFAULT);
        var locale:String=stringTool.actualLocaleIDName;/*(locale == 'ru-GB' || locale == 'ru-RU' || *//*)*/
        if(locale && (locale.indexOf("ru-") == 0 || locale.indexOf("ru_") == 0)){
            locale = 'ru-RU';
        } else {
            locale = "en-US";
        }
        return locale;
    }

    public function get defaultLanguage() : Language {
        var language : Language = new Language(new Object());
        language.code = defaultLanguageCode;
        language.name = LANG_NAMES[defaultLanguageCode];
        return language;
    }

    public function getLanguage(code : String) : Language {
        if(!map[code] && _languages){
            for(var i:int=0; i<_languages.length; i++){
                if(_languages[i].code==code){
                    return _languages[i];
                }
            }
        }

        return map[code];
    }

    public function loadLanguages() : void
    {
        var result:String='{"langs":[{"code":"ru-RU","name":"Русский"},{"code":"en-US","name":"English"}]}';
        var languagesJSON : Object = JSONer.parse(result as String);
        _languages = languagesParser.parseObjects(languagesJSON.langs);
        sendNotification(Notifications.LANGUAGES_LOADED, {languages: languages});
    }


    public function loadLanguage(language : Language) : void {
//        if(map && map.hasOwnProperty(language.code)) {
//            sendNotification(Notifications.LANGUAGE_LOADED, {language: map[language.code]});
//            return;
//        }

//        var url : String = 'http://www.3dtuning.com/api/v1/translations/';
//        url += (language.code == "en-US") ? 'en-US' : 'ru-RU';
//        url += '%3Ftags=purchase';
//        httpClient.loadPath('', URLRequestMethod.GET, null, HttpCachePolicy.CACHE_FIRST, false, function (success : Boolean, result : String) : void {
//            if (!success) {
//                sendNotification(Notifications.LANGUAGE_LOADING_FAILED);
//                return;
//            }
//
//            var languageJSON : Object = JSONer.parse(result);
//            var loadedLanguage : Language = new Language(languageJSON);
//
//            loadedLanguage.name = language.name;
//            loadedLanguage.code = language.code;
//
//            map[loadedLanguage.code] = loadedLanguage;
//
//            loadingStringForCurrentLanguageSharedObject.data.string = loadedLanguage.translate("mob_alertsAndOverlays", "loading");
//            loadingStringForCurrentLanguageSharedObject.flush();
//            sendNotification(Notifications.LANGUAGE_LOADED, {language: loadedLanguage});
//        }, url);
//
//        return;

//        var fileName : String = language.code + "en-US";

        if(Language.CODES_SUPPORTING_EMBEDDED_FONT.indexOf(language.code) < 0) {
            language.code = 'en-US';
        }

        var path : String = File.applicationDirectory.resolvePath('assets/manualCache/api/v1/translations').resolvePath(language.code).url;
        var urlLoader : URLLoader = new URLLoader();
        urlLoader.addEventListener(Event.COMPLETE, function (e : Event) : void {
            var languageJSON : Object = JSONer.parse(urlLoader.data as String);
            var loadedLanguage : Language = new Language(languageJSON);

            loadedLanguage.name = language.name;
            loadedLanguage.code = language.code;

            map[loadedLanguage.code] = loadedLanguage;

            loadingStringForCurrentLanguageSharedObject.data.string = loadedLanguage.translate("mob_alertsAndOverlays", "loading");
            loadingStringForCurrentLanguageSharedObject.flush();
            sendNotification(Notifications.LANGUAGE_LOADED, {language: loadedLanguage});
        });

        urlLoader.load(new URLRequest(path));
    }
}
}