package com.despark.tuning3d.model.packages
{
import by.blooddy.crypto.serialization.JSONer;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.cars.CarsParser;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.distriqt.BillingManager;
	import com.distriqt.GameService;
	import com.distriqt.extension.inappbilling.Product;
	import com.distriqt.extension.inappbilling.events.InAppBillingEvent;
	import com.utils.FileUtil;
	import com.utils.NumberExtract;

	import flash.events.Event;
import flash.events.IOErrorEvent;
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
import flash.net.URLLoader;
import flash.net.URLRequest;
import flash.net.URLRequestMethod;
import org.puremvc.as3.patterns.proxy.Proxy;
public class PackagesProxy extends Proxy
	{
		public static var NAME : String = "PackagesProxy";
		public var httpClient : HttpClient;
		private var packagesResponseString : String;
		private var packagesParser :PackagesParser;
		private var _packages:Array;
		private var urlreq:URLRequest;
		private var urlLoad:URLLoader;
		
		public function PackagesProxy()
		{
			super(NAME);
			packagesParser=new PackagesParser();			
			packagesParser.carsParser=new CarsParser();  
		}

		public function set packages(pkgs: Array): void {
			if (!this._packages || this._packages.length == 0) {
				this._packages = pkgs;
			}
		}

		public function get packages() : Array {
			return this._packages;
		}

		public function findPacketById(id:String):Packet{
			
			if(!packages)
				return null;
			
			var i:int=0;
			
			
			for(i=0; i<packages.length; i++){
				
				var packet:Packet=packages[i];
				
				if(packet.id==id){
					
					return packet;
				}
				
			}
			
			return null;
		}
		
		public function findPacketByProductId(product_id:String):Packet{
			
			if(!packages)
				return null;
			
			var i:int=0;
			
			
			for(i=0; i<packages.length; i++){
				
				var packet:Packet=packages[i];
				
				if(packet.productId==product_id){
					
					return packet;
				}
				
			}
			
			return null;
		}
		
		public function findPackagesByCarId(car_id:String):Array{
			var result:Array=[];
			if(!packages)
				return result;
			var i:int=0;
			var j:int=0;

			for(i=0; i<packages.length; i++){
				var packet:Packet=packages[i] as Packet;
				if(!packet)
					continue;
				if(!packet.cars)
					continue;
				for(j=0; j<packet.cars.length; j++){
					var car:Car=packet.cars[j];
					if(car && car.id==car_id){
						result.push(packet);
					}
				}
			}
			
			return result;   
		}

		public function loadPackages(allCarsList:Object) : void {
			if(Constants.IN_APP_PURCHASE_ENABLED){
				getProducts();
			}else{
				var packagesJSONString : String ='[]';//'[{"id":"com.tuning.3dtuning.partpack1","show":true,"title":"Pack1","body":"Ut mollis blandit est, eu tristique quam consectetur porttitor.","price":10,"cars":[{"id":"537f31fd984539401f0ac8e8","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."}]},{"id":"com.tuning.3dtuning.bigpack2","title":"bigpack2","body":"Ut mollis blandit est, eu tristique quam consectetur porttitor. Duis et nisi finibus, pellentesque eros vel, sagittis purus. Etiam tincidunt arcu et turpis condimentum condimentum. Sed dapibus pharetra iaculis. Pellentesque viverra tellus metus, a faucibus leo commodo in. Integer fermentum tellus a consectetur sodales. Etiam eget gravida justo. Donec rhoncus augue id risus aliquet iaculis.","price":10,"cars":[{"id":"537f31f9984539401f0ab92a","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."},{"id":"537f31fd984539401f0ac7f3","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."},{"id":"5319aaef69584a880335231a","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."}]},{"id":"com.3dtuning.Tuning3D.pack1","title":"bigpack1","body":"Ut mollis blandit est, eu tristique quam consectetur porttitor.   Integer fermentum tellus a consectetur sodales. Etiam eget gravida justo. Donec rhoncus augue id risus aliquet iaculis.","price":10,"cars":[{"id":"54a2c21930f1b8241b60a907","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."},{"id":"545b5d79a87954841a712ebb","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."},{"id":"5319aae669584a8803350c08","price":3,"discountprice":2,"body":"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed nisi quam, sagittis sed mollis eget, lacinia facilisis est. Suspendisse sodales dictum nisl quis porttitor. Quisque semper consectetur turpis vitae tristique. Curabitur eget maximus metus. In blandit, velit eu sagittis pharetra, est dui maximus felis, nec tempus orci est id ipsum. Sed tempor nunc odio, id porta massa lobortis in."}]}]';
				var packagesJSON : Array = JSONer.parse(packagesJSONString) as Array;
				var packages:Array=handlePackagesLoaded(packagesJSON);
				this.packages=packages;
				sendNotification(Notifications.PACKAGES_LOADED, {packages: packages});
			}
		}
		
		private function getProducts():void{
			if(!Constants.IN_APP_PURCHASE_ENABLED){
				return;
			}
			var urlll : String = Constants.API_URL_device+"products";
			var platform: String;
			if(Device.isIos()){
				platform = 'ios';
			}else{
				platform = 'android';

			}
            urlll += "/platforms/" + platform;
			urlLoad = new URLLoader();
			urlreq = new URLRequest(urlll);
			trace("Start load products:", urlll);
			urlreq.requestHeaders = [];
			urlreq.contentType="application/json";
			urlreq.manageCookies=true;
			urlreq.method = URLRequestMethod.GET;
			urlLoad.addEventListener(IOErrorEvent.IO_ERROR,ioErrorGetProductsHandler);
			urlLoad.addEventListener(Event.COMPLETE,completeGetTestProductHandler);
			urlLoad.load(urlreq);
		}
		
		private function ioErrorGetProductsHandler(e:IOErrorEvent):void
		{
			trace("error load products")

			urlLoad.removeEventListener(IOErrorEvent.IO_ERROR,ioErrorGetProductsHandler);
			urlLoad.removeEventListener(Event.COMPLETE,completeGetTestProductHandler);
			var cacheResult:String=readCache("packages");
			if(cacheResult){
				completeGetTestProductHandler(null, cacheResult);
				return;
			}
			sendNotification(Notifications.PACKAGES_LOADING_FAILED)
		}
		
		private function completeGetTestProductHandler(e:Event=null, data:String=null):void{
			trace("completeGetTestProductHandler");
			urlLoad.removeEventListener(IOErrorEvent.IO_ERROR,ioErrorGetProductsHandler);
			urlLoad.removeEventListener(Event.COMPLETE,completeGetTestProductHandler);
			var packagesJSONString : String="";
			if(e){
				packagesJSONString = URLLoader(e.target).data as String;
			}
			else{
				packagesJSONString = data;
			}
			if(packagesJSONString!="") {
				saveCache(packagesJSONString, 'packages');
			}
			try{
				packagesJSON = JSONer.parse(packagesJSONString) as Object;
				var packagesArray:Array=packagesJSON as Array;
				packagesJSON={products:packagesArray};  
				
				trace("packagesArray.len:", packagesArray.length);
			}catch(e:Error){
				packagesJSON={products:[]};  
			}
			packages = handlePackagesLoaded(packagesJSON.products);
			var productIds:Array=[];
			for each(var packet:Packet in packages){
				productIds.push(packet.productId);        
			}

			BillingManager.$.setup(productIds, products_loadedHandler, setup_failureHandler);
            sendNotification(Notifications.PACKAGES_REFRESHED);
		}

		internal function products_loadedHandler(event:InAppBillingEvent ):void
		{
			saveCache( JSON.stringify(event.data), 'product_info_new');
			handleProductsLoaded(event.data);
			var productsInfoList:Object=new Object();
			productsInfoList.details={};
			for each (var product: Product in event.data)
			{
				productsInfoList.details[product.id]={
					priceNum:product.price,
					price: product.priceString,
					localizedPrice: product.priceString,
					description: product.description,
					title: product.title,
					id: product.id,
					localeId:product.id
				};
			}
			var json:String=JSONer.stringify(productsInfoList);
			saveCache(json, 'product_info_new');
			var productsInfo:Object=productsInfoList.details;
			handleProductsLoaded(productsInfo);
		}

		private function setup_failureHandler(event: InAppBillingEvent):void{

			var json:String=readCache('product_info_new');
			var flagError:Boolean=false;
			if(json!=null){
				var productsInfo:Object=JSONer.parse(json);
				if(productsInfo.hasOwnProperty('details')){
					productsInfo=productsInfo.details;
					handleProductsLoaded(productsInfo);
				}else{
					flagError=true;
				}
			}else{
				flagError=true;
			}
			if(flagError){
				if(Constants.IS_DEBUG){
					handleProductsLoaded({});
				}
			}
		}
		private function handleProductsLoaded(productsInfo:Object):void{
			GameService.$.getSaveData(function(data: String): void {
				var saveData: Object = JSONer.parse(data);
				for (var i: Number = 0; i < packages.length; i++) {
					var packet:Packet=packages[i];
					var packetId: String = (packages[i] as Packet).id;
					if(saveData.rewardsPackets.indexOf(packetId) > -1) {
						packages[i].tempOpened = true;
						packages[i].lock = false;
					}
					if(productsInfo[packet.productId]){

						var productPriceStr:String=productsInfo[packet.productId];
						var obj:Object=productsInfo[packet.productId];
						productPriceStr=obj.price;
						if(productPriceStr.substr(productPriceStr.length-1)=="."){
							productPriceStr=productPriceStr.substr(0, productPriceStr.length-1);
						}
						if(productPriceStr){
							packet.feeString=productPriceStr;
							var productPrice:Number=NumberExtract.execute(productPriceStr);
							var productCurrency:String=NumberExtract.removeNumericChars(productPriceStr);
							packet.fee=productPrice;
							packet.feeСurrency=productCurrency;
						}
					}
				}

				BillingManager.$.allPackets = packages;
				sendNotification(Notifications.PACKAGES_LOADED, {packages: packages});
			})
		}

		private var packagesJSON:Object;
		private function handlePackagesLoaded(packagesJSON : Array) : Array
		{
			var packages : Array = packagesParser.parseObjects(packagesJSON);
            return packages;
		}
		private function saveCache(packages:String, type:String="packages"):void{
			var file1: File = File.cacheDirectory.resolvePath(type+".json");
			FileUtil.filePutContent(file1, packages);
			/*return;

			var fileStream:FileStream=new FileStream();
			fileStream.open(file1, FileMode.WRITE);
			fileStream.writeUTF(packages);
			fileStream.close();*/
		}
		
		
		public function readCache(type:String="packages"):String{
			try{
				var file1: File = File.cacheDirectory.resolvePath(type+".json");
				if(file1.exists){
					var packagesStringJSON:String = FileUtil.fileGetContent(file1);
					return packagesStringJSON;
					/*var fileStream:FileStream=new FileStream();
					fileStream.open(file1, FileMode.READ);
					var packagesStringJSON:String=fileStream.readUTF();
					fileStream.close();
					return packagesStringJSON;*/
				}
			}catch(e:Error){
				return null;   
			}
			return null;
		}
	}
}