package com.despark.tuning3d.model.parts
{
	import com.despark.tuning3d.ApplicationFacade;
	import com.despark.tuning3d.model.core.images.BitmapDataUtil;
	import com.despark.tuning3d.model.core.images.ImageCacher;
	import com.despark.tuning3d.model.users.UsersProxy;
	import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
	
	import flash.filesystem.File;
	import flash.utils.ByteArray;
	
	public class Material3dtProvider
	{
		
		public const stepOfDownloading_None:int = 0;
		public const stepOfDownloading_Downloading:int = 1;
		public const stepOfDownloading_Downloaded:int = 2;
		
		public var url : String;
		public var dicOfPartMaterialImages : Object = [];
		public var dicOfImageLoaderWithStates : Object = [];
		public var dicOfImageCacher : Object = [];
		//ImageCacher
		public var stepOfDownloading : int = stepOfDownloading_None;
		private var usersProxy : UsersProxy;
		//PartMaterialImage
		
		//private var dataBytes : ByteArray;
		
		public function Material3dtProvider()
		{
			var facade : ApplicationFacade = ApplicationFacade.getInstance();
			usersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
		}
		
		public function saveNameOfImage(__NameOfImage : String, __nativePath : String) : void
		{
			usersProxy.saveNameOfImage(__NameOfImage, __nativePath);
		}
		
		public function nameOfImageByNativePath(__nativePath : String) : String
		{
			return usersProxy.nameOfImageByNativePath(__nativePath);
		}
		
		/*public function decrypte3DTfile(__dataBytes : ByteArray):Boolean
		{
			
			if(stepOfDownloading != stepOfDownloading_Downloading){
				//не тот статус
				return false;
			}
			
			
			__dataBytes.position = 0;
			var signature : String = __dataBytes.readUTFBytes(3);
			if(signature != "3DT"){
				return false;
			}
			
			var version : uint = __dataBytes.readUnsignedByte();
			
			if(version != 1){
				return false;
			}
			var imagesCount1 : uint = __dataBytes.readUnsignedByte();
			var imagesCount2 : uint = __dataBytes.readUnsignedByte();
			var imagesCount3 : uint = __dataBytes.readUnsignedByte();
			var imagesCount4 : uint = __dataBytes.readUnsignedByte();
			var imagesCount : uint = imagesCount1 + imagesCount2 * 256 + imagesCount3 * 256 * 256 + imagesCount4 * 256 * 256 * 256;
			
			for(var indexOfImage: int = 0 ; indexOfImage < imagesCount; indexOfImage ++)
			{
				
				var previousPosition: uint = __dataBytes.position;
				//var nameOfImage : String = __dataBytes.readUTF();
				//var bytesOfName : ByteArray = new ByteArray();
				var byte: uint = __dataBytes.readUnsignedByte();
				var nameOfImage : String = "";
				//var testI : int = 0;
				while(byte!=0){
					//bytesOfName.writeByte(byte);
					if(byte >=32 && byte <=122){
						nameOfImage += String.fromCharCode(byte);
					}
					
					//testI ++;
					byte = __dataBytes.readUnsignedByte();
				}
				//bytesOfName.position = 0;
				//var nameOfImage : String = bytesOfName.readUTFBytes(bytesOfName.length);
				
				//__dataBytes.position = previousPosition + nameOfImage.length + 1;
				
				
				var dataLength1 : uint = __dataBytes.readUnsignedByte();
				var dataLength2 : uint = __dataBytes.readUnsignedByte();
				var dataLength3 : uint = __dataBytes.readUnsignedByte();
				var dataLength4 : uint = __dataBytes.readUnsignedByte();
				var dataLength : uint = dataLength1 + dataLength2 * 256 + dataLength3 * 256 * 256 + dataLength4 * 256 * 256 * 256;
				
				//var dataLength : uint = __dataBytes.readUnsignedShort()
				var dataBytesOfImage : ByteArray = new ByteArray();
				__dataBytes.readBytes(dataBytesOfImage,0,dataLength);
				///////////////////////////закончили расшифровку
				
				
				var imageInfo : String = nameOfImage.substring(nameOfImage.indexOf("00") + 2, nameOfImage.length - 4);
				var imageInfoParts : Array = imageInfo.split("_");
				
				var frameIndex : int = parseInt(imageInfoParts[0]);
				var x : int = parseInt(imageInfoParts[1]) ;
				var y : int = parseInt(imageInfoParts[2]);
				
				
				//сохраним картинку в любом случае
				
				var localFile : String = PartMaterialImage.nameOfFrameFileBy3DTurl(url, frameIndex);
				var file1: File = File.cacheDirectory.resolvePath(localFile);
				//var localFile : File = persistentImageProvider.localFile;
				
				if(!file1.exists)
				{
					BitmapDataUtil.saveImageBytes(dataBytesOfImage, file1);
				}
				
				
				
				
				var partMaterialImage : PartMaterialImage = dicOfPartMaterialImages[frameIndex];
				if(!partMaterialImage){
					// trace("error!!!! failed partMaterialImage of Material3dtProvider frameIndex=",frameIndex);
					
				}else{
					partMaterialImage.x += x;
					partMaterialImage.y += y;
					
					
					var file2: File = File.cacheDirectory.resolvePath(partMaterialImage.localFile);
					
					saveNameOfImage(nameOfImage,file2.nativePath);
					
				}
				
				
				
				var imageLoaderWithStates : ImageLoaderWithStates = dicOfImageLoaderWithStates[frameIndex];
				
				if(!imageLoaderWithStates){

				}else{
					if(partMaterialImage){
						imageLoaderWithStates.x = imageLoaderWithStates.kx * partMaterialImage.x + imageLoaderWithStates.ax;
						imageLoaderWithStates.y = imageLoaderWithStates.ky * partMaterialImage.y + imageLoaderWithStates.ay;
					}
					
					
					imageLoaderWithStates.performBytesAfterDownloading(dataBytesOfImage,nameOfImage,true);
					dicOfImageLoaderWithStates[frameIndex] = null;
				}
				
				//dicOfImageCacher
				
				var imageCacher : ImageCacher = dicOfImageCacher[frameIndex];
				
				if(!imageCacher){
					// trace("error!!!! failed imageLoaderWithStates of Material3dtProvider frameIndex=",frameIndex);
					
				}else{
					//if(partMaterialImage){
					//	 imageLoaderWithStates.x = imageLoaderWithStates.kx * partMaterialImage.x + imageLoaderWithStates.ax;
					//	 imageLoaderWithStates.y = imageLoaderWithStates.ky * partMaterialImage.y + imageLoaderWithStates.ay;
					// }
					
					
					imageCacher.performBytesAfterDownloading(dataBytesOfImage,nameOfImage);
					dicOfImageCacher[frameIndex] = null;
				}
				
				
				
			}
			
			
			
			
			stepOfDownloading = stepOfDownloading_Downloaded;
			
			return true;
		}*/
	}
}
//import com.despark.tuning3d.model.parts;

