package com.despark.tuning3d.model.parts
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	
	public class PartMaterialImage implements PersistentImageProvider
	{
	   // public static var isTrace:Boolean=true;
	
	    //private var _data:ByteArray
	
	    //public var _url : String;
	    //public var _material3dtProvider : Material3dtProvider;
	
		//private var _isEncrypted:Boolean=true;
	    public var parentMaterial : PartMaterial;
	    public var frameIndex:int;
	    public var angleIndex:int;
	    public var x : int;
	    public var y : int;

		private var _lastImagePath : String = "";
	    //private var _brightness : Number;
	    //private var _isDefault : Boolean;
	
	    //private static var countPartMaterialImage:int=0;

		public var typesForFakeOffset: Array = [
			'tire_rear_right',
			'tire_rear_left',
			'tire_front_left',
			'tire_front_right',
			'disk_rear_right',
			'disk_rear_left',
			'disk_front_right',
			'disk_front_left',
			'tire_rear_right',
			'tire_rear_left',
			'tire_front_left',
			'tire_front_right',
			'disk_rear_right',
			'disk_rear_left',
			'disk_front_right',
			'disk_front_left',
			'shadow_front_left',
			'shadow_front_right',
			'shadow_rear_left',
			'shadow_rear_right'
		];
		public var typesFakeStates: Array = [
			'of1',
			'of2',
			'of1-trr',
			'of2-trr',
			'cm1-of1',
			'cm1-of2',
			'cm2-of1',
			'cm2-of2',
			'cm1-of1-trr',
			'cm1-of2-trr',
			'cm2-of1-trr',
			'cm2-of2-trr',
			'neon-of1',
			'neon-of2',
			'neon-of1-trr',
			'neon-of2-trr',
			'neon-cm1-of1',
			'neon-cm1-of2',
			'neon-cm2-of1',
			'neon-cm2-of2',
			'neon-cm1-of1-trr',
			'neon-cm1-of2-trr',
			'neon-cm2-of1-trr',
			'neon-cm2-of2-trr'
		];

	    public function dispose():void{
	
	        parentMaterial=null;
	        //countPartMaterialImage--;
	        //Tracer.print("countPartMaterialImage:"+countPartMaterialImage);
	    }
		
		public static function createFileNameFromData(angleIndex:int, frameIndex:int, x:int, y:int, parentSlotName:String, isDef:Boolean):String{
			var aUrl:String;
			aUrl = 'a' + angleIndex + '0';
			
			if(frameIndex<=9) aUrl = aUrl + "0" + frameIndex;
			else aUrl = aUrl + frameIndex;
			
			if(parentSlotName =="shadow")
				aUrl = aUrl + "_"+(x+52)+"_"+y+".png";
			else aUrl = aUrl + "_"+x+"_"+y+".png";
			return aUrl;
		}

		private function get imagePath() : String
		{
			if(parentMaterial && parentMaterial.parentPart && parentMaterial.parentPart.parentSlot && parentMaterial.parentPart.parentSlot.parentCar)
			{
                _lastImagePath = parentMaterial.parentPart.parentSlot.parentCar.imagePath;
			}
			return _lastImagePath;
		}
	
	    public function get url():String{
	        
			var psName:String = parentMaterial && parentMaterial.parentPart &&  parentMaterial.parentPart.parentSlot ? parentMaterial.parentPart.parentSlot.name: "";
			var isDef : Boolean = parentMaterial && parentMaterial.parentPart ? parentMaterial.parentPart.isDefault : false;
			var aUrl:String = createFileNameFromData(angleIndex, frameIndex, x, y, psName, isDef);



			if (parentMaterial && parentMaterial.componentPath) {
				aUrl = imagePath + parentMaterial.componentPath + aUrl;
			} else {
				aUrl = imagePath + aUrl;
			}

			if (parentMaterial && parentMaterial.parentPart.parentSlot.parentCar.offsetDifference && parentMaterial.name != 'mask' && parentMaterial.name != 'antimask' ) {
				var part: Part = parentMaterial.parentPart;
				if (part.parentSlot && (aUrl.indexOf('states') > -1)) {
					var stateName: String;

					if (aUrl.indexOf('/of1/') > -1) {
						stateName = 'of1';
					} else if (aUrl.indexOf('/of2/') > -1) {
						stateName = 'of2';
					}else if (aUrl.indexOf('/cm1-of1/') > -1) {
						stateName = 'cm1-of1';
					}else if (aUrl.indexOf('/cm1-of2/') > -1) {
						stateName = 'cm1-of2';
					}else if (aUrl.indexOf('/cm2-of1/') > -1) {
						stateName = 'cm2-of1';
					}else if (aUrl.indexOf('/cm2-of2/') > -1) {
						stateName = 'cm2-of2';
					}else if (aUrl.indexOf('/cm1-of1-trr/') > -1) {
						stateName = 'cm1-of1-trr';
					}else if (aUrl.indexOf('/cm1-of2-trr/') > -1) {
						stateName = 'cm1-of2-trr';
					}else if (aUrl.indexOf('/cm2-of1-trr/') > -1) {
						stateName = 'cm2-of1-trr';
					}else if (aUrl.indexOf('/cm2-of2-trr/') > -1) {
						stateName = 'cm2-of2-trr';
					}else if (aUrl.indexOf('/of2-trr/') > -1) {
						stateName = 'of2-trr';
					}else if (aUrl.indexOf('/of1-trr/') > -1) {
						stateName = 'of1-trr';
					} /**/else if (aUrl.indexOf('/neon-of1-trr/') > -1) {
						stateName = 'neon-of1-trr';
					}else if (aUrl.indexOf('/neon-of2-trr/') > -1) {
						stateName = 'neon-of2-trr';
					}else if (aUrl.indexOf('/neon-cm1-of1/') > -1) {
						stateName = 'neon-cm1-of1';
					}else if (aUrl.indexOf('/neon-cm1-of2/') > -1) {
						stateName = 'neon-cm1-of2';
					}else if (aUrl.indexOf('/neon-cm2-of1/') > -1) {
						stateName = 'neon-cm2-of1';
					}else if (aUrl.indexOf('/neon-cm2-of2/') > -1) {
						stateName = 'neon-cm2-of2';
					}else if (aUrl.indexOf('/neon-cm1-of1-trr/') > -1) {
						stateName = 'neon-cm1-of1-trr';
					}else if (aUrl.indexOf('/neon-cm1-of2-trr/') > -1) {
						stateName = 'neon-cm1-of2-trr';
					}else if (aUrl.indexOf('/neon-cm2-of1-trr/') > -1) {
						stateName = 'neon-cm2-of1-trr';
					}else if (aUrl.indexOf('/neon-cm2-of2-trr/') > -1) {
						stateName = 'neon-cm2-of2-trr';
					}else if (aUrl.indexOf('/neon-of1/') > -1) {
						stateName = 'neon-of1';
					}else if (aUrl.indexOf('/neon-of2/') > -1) {
						stateName = 'neon-of2';
					}
//					if (part.parentSlot.name.indexOf('disk') > -1) {
//						trace('ok');
//					}
					var realSource: String;
					if (typesForFakeOffset.indexOf(part.parentSlot.name) > -1 && typesFakeStates.indexOf(stateName) > -1) {
						var material: String = parentMaterial.name;
						switch (stateName) {
							case 'of1':
							case 'of2':
								if (part.parentSlot.selectedPart.getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage) {
									realSource = (part.parentSlot.selectedPart.getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
							case 'cm1-of1':
							case 'cm1-of2':
								if ((part.states['cm1'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)){
									realSource = (part.states['cm1'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
							case 'cm2-of1':
							case 'cm2-of2':
								if ((part.states['cm2'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['cm2'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
							case 'cm1-of1-trr':
							case 'cm1-of2-trr':
								if ((part.states['cm1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['cm1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
							case 'cm2-of1-trr':
							case 'cm2-of2-trr':
								if ((part.states['cm2-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['cm2-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
							case 'of2-trr':
							case 'of1-trr':
								if ((part.states['trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;


							case 'neon-of1-trr':
							case 'neon-of2-trr':
								if ((part.states['neon-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;

							case 'neon-cm1-of1':
							case 'neon-cm1-of2':
								if ((part.states['neon-cm1'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon-cm1'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;

							case 'neon-cm2-of1':
							case 'neon-cm2-of2':
								if ((part.states['neon-cm2'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon-cm2'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;

							case 'neon-cm1-of1-trr':
							case 'neon-cm1-of2-trr':
								if ((part.states['neon-cm1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon-cm1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;

							case 'neon-cm2-of1-trr':
							case 'neon-cm2-of2-trr':
								if ((part.states['neon-cm2-of1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon-cm2-of1-trr'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;

							case 'neon-of1':
							case 'neon-of2':
								if ((part.states['neon'] && part.states['neon'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage)) {
									realSource = (part.states['neon'].getPossibleMaterial(material).imagesMap[angleIndex][frameIndex] as PartMaterialImage).url;
								}
								break;
						}

						if(realSource) {
							return realSource;
						}
					}
				}
			}

			return aUrl;
	    }
	
	    public function get frameIndeX() : int
	    {
	        return frameIndex;
	    }
	
	    public function get isDefault() : Boolean
	    {
			//throw new Error("get isDefault function not implementing ");
			if(!parentMaterial) return false;
			
			if(!parentMaterial.parentPart) return false;
			
			var part : Part = parentMaterial.parentPart;
			
			return part.isDefault;
	    }
		
		
		public function set isDefault(value:Boolean):void{
			
			throw new Error("set isDefault function not implementing ");
		}
	
	   
	
	    public function PartMaterialImage(aUrl : String, index : String, __material3dtProvider : Material3dtProvider, material:PartMaterial)
	    {
	        super();
	        parentMaterial=material;
	        if(index){
	            frameIndex = int(index);
	            x = 0;
	            y = 0;
	        }else
	        if(aUrl)
	        {
	            initWithUrl(aUrl);
	            //_brightness = 1.0;
	        }
	
	        //countPartMaterialImage++;
	    }
	
	    public static function getFrameIndexByUrl(url:String):int{
	
	        if(url){
	
	            /*var fileName : String;
	
	            if(url.indexOf("/")>=0){
	                var lastSlashIndex : int = url.lastIndexOf("/");
	                fileName  = url.substring(lastSlashIndex + 1, url.length);
	            }else{
	                fileName=url;
	            }*/
	          
	            var imageInfo : String = url.substr(3,2);
	
	            var frameIndex:int = parseInt(imageInfo);
	
	
	            return frameIndex;
	
	        }else{
	
	            return -1;
	        }
		}
	
	    public static function getAngleIndexByUrl(url:String, car:Car):int{
	
	        if(url){
	
	            var imageInfo : String = url.substr(1, 1);
	            var angelIndex:int = int(imageInfo);
	
	            if(angelIndex+1>car.countAngels){
	
	                car.countAngels=angelIndex+1;
	            }
	            return angelIndex;
	
	        }else{
	
	            return -1;
	        }
	    }
		
		private static var imageData:Object = {};
		private static var filePattern:RegExp = /a(\d{1})0(\d{2})_(-?\d{1,4})_(-?\d{1,4})\.png$/;
		private static var filePatternResult:Array;
		
		public static function WithUrl(aUrl : String, parentCar:Car) : Object
		{
			filePatternResult = filePattern.exec(aUrl);
			imageData.x =  parseInt(filePatternResult[3]);
			imageData.y =  parseInt(filePatternResult[4]);
			imageData.frameIndex =  parseInt(filePatternResult[2]);
			imageData.angleIndex = parseInt(filePatternResult[1]);
			
			
			return imageData;
		}
		
		public function init(imageData:Object):void{
			
			this.angleIndex=imageData.angleIndex;
			this.frameIndex=imageData.frameIndex;
			this.x=imageData.x;
			this.y=imageData.y;
			
			//this.isEncrypted=imageData.isEncrypted;
			//this.brightness=imageData.brightness;
			//this.isDefault=imageData.isDefault;
			
		}
		
	
	    public function initWithUrl(aUrl : String) : void
	    {
	        aUrl;
	
	        if(!aUrl){
	
	            frameIndex=x=y=0;
	            return;
	
	        }
	
	        var fileName : String;
	
	        if(aUrl.indexOf("/")>=0){
	            var lastSlashIndex : int = aUrl.lastIndexOf("/");
	            fileName  = aUrl.substring(lastSlashIndex + 1, aUrl.length);
	        }else{
	            fileName=aUrl;
	        }
	
	
	
	        fileName = aUrl.substring(lastSlashIndex + 1, aUrl.length);//11_12_13_14_15.3dt
	        var imageInfo : String = fileName.substring(2, fileName.length - 4);
	        var imageInfoParts : Array = imageInfo.split("_");
	
	        frameIndex = parseInt(imageInfoParts[0]);
	
	        angleIndex=getAngleIndexByUrl(aUrl, parentMaterial.parentPart.parentSlot.parentCar);
	
	        x = parseInt(imageInfoParts[1]) ;
	        y = parseInt(imageInfoParts[2]);
	    }
	
	
	    public function get localFile() : String
	    {
	        return url.replace(Constants.IMAGES_URL, "Cars/"); //localPath;
	    }
	
	    public function get remoteUrl() : String
	    {
			return url;
	    }
	
	    
	    public function get isEncrypted() : Boolean
	    {
			if(!parentMaterial) return false;
			
			if(!parentMaterial.parentPart) return false;
			
			
			
			if(!parentMaterial.parentPart.parentSlot) return false;
			
			if(!parentMaterial.parentPart.parentSlot.parentCar) return false;
			
			return parentMaterial.parentPart.parentSlot.parentCar.partMaterialEncrypted;
	    }
	
	    public function set isEncrypted(value:Boolean):void{
	
	        //_isEncrypted=value;
	    }
	
	    public function get ignoresTransparentPixelsOnTouch() : Boolean
	    {
			
			if(!parentMaterial) return false;
			
			if(!parentMaterial.parentPart) return false;
			
	        var part : Part = parentMaterial.parentPart;
	        var partSlot : PartSlot = part.parentSlot;
	
	        return !part.isSubpart && partSlot.isEditable;
	    }
	
	    public function get touchable() : Boolean
	    {
	        return ignoresTransparentPixelsOnTouch;
	    }
	
	    public function get important() : Boolean
	    {
	        return true;
	    }
	
	    public function get brightness() : Number
	    {
			if(!parentMaterial) return 1.0;
			
			if(!parentMaterial.parentPart) return 1.0;
			
			var part : Part = parentMaterial.parentPart;
			
			return part.brightness;
	    }
	
	    public function set brightness(value : Number) : void
	    {
			throw new Error("set brightness function not implementing ");
			//_brightness = value;
	    }
	
	   
	}
}


