package com.despark.tuning3d.model.settings {
	import com.despark.tuning3d.model.languages.Language;

	import flash.globalization.LocaleID;
	import flash.globalization.StringTools;
	import flash.net.SharedObject;

	import org.puremvc.as3.patterns.proxy.Proxy;

	public class SettingsProxy extends Proxy {
		public static const NAME : String = "SettingsProxy";
		private var settingsSharedObject : SharedObject;
		public function SettingsProxy() {
			super(NAME);
			settingsSharedObject = SharedObject.getLocal("settingsSharedObject_1");
		}

		private function indexOfSubstring(array:Array, stringToFind:String):int {
			var answer:int = array.indexOf(stringToFind);
			if (answer == -1) {
				var separator:String = "|";
				var arrayToString:String = array.join(separator);
				var indexInString:int = arrayToString.indexOf(stringToFind);
				
				if (indexInString != -1) {
					var shorterStr:String = arrayToString.substring(0, indexInString);
					answer = shorterStr.split(separator).length - 1;
				}
			}
			return answer;
		}

		public function get currentSettings() : Settings {
			var settingsData : Object = settingsSharedObject.data.settings;
			var settings : Settings = new Settings();
								
			if(!settingsData) {
				var stringTool:StringTools = new StringTools(LocaleID.DEFAULT);
				var locale:String=stringTool.actualLocaleIDName;
				if(locale=='ru-GB'){
					locale='ru-RU';
				}

				if(indexOfSubstring(Language.CODES_SUPPORTING_EMBEDDED_FONT, locale)<0){
					locale="en-US";
				}

				settings.autoscrollEnabled=false;
				settings.selectedLanguageCode=locale;
				update(settings);
			} else {
				settings.autoscrollEnabled = settingsData.autoscrollEnabled;
				settings.selectedLanguageCode = settingsData.test;
			}
			return settings;
		}
		
		public function update(settings : Settings) : void
		{				
			settingsSharedObject.data.settings = {
				autoscrollEnabled: settings.autoscrollEnabled, 
				test: settings.selectedLanguageCode
			};
			
			settingsSharedObject.flush();
		}
	}
}