package com.despark.tuning3d.model.sounds
{
	import flash.filesystem.File;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;

	public class SoundManager {
		public static const DISABLED_PART:String = "disable_part.mp3";
		public static const MENU:String = "menu.mp3";
		public static const MENU_CLOSE:String = "menu_close.mp3";
		public static const PART_MENU:String = "parts_menu.mp3";
		public static const PART_MENU_CLOSE:String = "parts_menu_close.mp3";
		public static const LOADING:String = "loading.mp3";
		public static const PAINTING:String = "painting.mp3";
		public static const SAVE_AND_NOTIFICATION:String = "save_and_notification.mp3";
		public static const SELECT_PART:String = "select_parts.mp3";
		public static const SELECT_PART_BACK:String = "select_parts_back.mp3";
		//
		private static const soundList:Object = {};
		public function SoundManager() {

		}

		public static function playSound(soundId:String, loops:int = 0):SoundChannel{
			var file:File = getSoundFile(soundId);
			if(soundList[soundId]){
				return Sound(soundList[soundId]).play(0, loops);
			}
			var sound:Sound = new Sound();
			soundList[soundId] = sound;
			sound.load(new URLRequest(file.url));
			return sound.play(0, loops);
		}

		private static function getSoundFile(soundName : String) : File {
			var appDirectory : File = File.applicationDirectory;
			var path : File;
            path = appDirectory.resolvePath("assets/sounds/" + soundName);
			path.preventBackup = true;
			return path;
		}
	}
}