package com.despark.tuning3d.model.users
{
	public class User
	{
		public function User(data : Object = null)
		{
			super();
			if(data){
				if(data.hasOwnProperty("username")){
					username = data.username;
                }
                if(data.hasOwnProperty("avatar")){
					if(data.avatar is Array){
						for(var i:int = data.avatar.length-1; i>=0; i--){
							if(data.avatar[i] && data.avatar[i].hasOwnProperty("current") && data.avatar[i].current) {
                                avatarPath = data.avatar[i].path;
								break;
                            }
						}
					}else{
                        avatarPath = data.avatar;
					}
                }
                if(data.hasOwnProperty("name")){
					name = data.name;
                }
                if(data.hasOwnProperty("_id")){
					id = data._id;
                }
                if(data.hasOwnProperty("emailVerified")){
					emailVerified = data.emailVerified;
                }
				if(data.hasOwnProperty("roles")){
					roles=data.roles;
					trace("roles:", roles)
				
				}
			}
		}
		
		public var username : String;
		public var email : String;
		public var id : String;
		
		public var name : String;
		public var avatarPath : String;
		public var roles:Array=[];
		public var emailVerified:Boolean = false;

		public function copy() : User
		{
			var user : User = new User();
			user.id = id;
			user.email = email;
			user.name = name;
			user.avatarPath = avatarPath;
			user.username = username;
			user.roles = roles;
			user.emailVerified = emailVerified;

			
			return user;
		}

		public function get nameToShow() : String
		{
			if(name == null || name.length <= 2 || name == "" )
			{
				return username;
			}
			return name;


		}
		
		public function get isSuperAdmin():Boolean{
			
			if(roles && roles.indexOf("superadmin")>=0){
				return true;
			}
			
			return false;
		}
	}
}