package com.despark.tuning3d.view
{
    import air.net.URLMonitor;

    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.brands.BrandsProxy;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.cars.CarsProxy;
    import com.despark.tuning3d.model.core.AppMode;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.ConnectionProxy;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.core.http.HttpClient;
    import com.despark.tuning3d.model.friend.FriendProxy;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.LanguagesProxy;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.model.packages.Purchase;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.parts.PartMaterial;
    import com.despark.tuning3d.model.parts.PartMaterialImageTest;
    import com.despark.tuning3d.model.parts.PartSlot;
    import com.despark.tuning3d.model.settings.Settings;
    import com.despark.tuning3d.model.settings.SettingsProxy;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.brands.BrandsScreen;
    import com.despark.tuning3d.view.components.brands.PacketItemRenderer;
    import com.despark.tuning3d.view.components.challenges.modals.ChallengeVotePopup;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.CustomAlertView;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.PackagesView;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
    import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
    import com.despark.tuning3d.view.components.instructions.TutorialView;
    import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
    import com.distriqt.AdsManager;
    import com.distriqt.BillingManager;
    import com.distriqt.GameService;
    import com.utils.ArrayUtil;
    import com.utils.RandomSplashManager;
    import com.utils.Tracker;

    import flash.desktop.NativeApplication;
    import flash.desktop.SystemIdleMode;
    import flash.events.KeyboardEvent;
    import flash.events.StageOrientationEvent;
    import flash.events.StatusEvent;
    import flash.filesystem.File;
    import flash.filesystem.FileMode;
    import flash.filesystem.FileStream;
    import flash.net.URLLoader;
    import flash.net.URLRequest;
    import flash.ui.Keyboard;
    import flash.utils.setTimeout;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;
    import starling.display.Stage;
    import starling.events.Event;
    import starling.utils.ScaleMode;

    public class BrandsScreenMediator extends StackedScreenExtendedMediator
{
    public static const AUTH_ACTION_GARAGE : String = "garage";
    public static const AUTH_ACTION_TUNING : String = "tuning";
    public static const AUTH_ACTION_TIMELINE : String = "timeline";
    public static const AUTH_ACTION_NOTIFICATIONS : String = "notifications";
    public static const AUTH_ACTION_CHALLENGE_NOTIFICATIONS : String = "challengeNotifications";
    public static const AUTH_ACTION_FRIENDS : String = "friends";
    public static const AUTH_ACTION_LOGIN : String = "login";
    public static const AUTH_ACTION_LOGOUT : String = "logout";
    public static const AUTH_ACTION_RESTORE : String = "restore";
    public static const AUTH_ACTION_BUY_PACKET : String = "by_packet";

    public static var FIRST_LOAD_COMPLETE:Boolean = false;
    public static var SECOND_LOAD_COMPLETE:Boolean = false;

    public static var httpClient : HttpClient;

    private static var firstStart : Boolean = true;

    private var screenShown : Boolean;
    private var requestsToMakeCount : int;
    private var requestsFinishedCount : int;
    private var tuningLoadInitiated : Boolean;
    private var urlMonitor : URLMonitor;

    private var brandsLoaded:Boolean = false;
    private var purchaseLoaded:Boolean = false;
    private var languageLoaded:Boolean = false;
    private var packagesLoaded:Boolean = false;

    //private var _iap:InAppPurchase;
    //public var tracker:AnalyticsTracker;

    public function BrandsScreenMediator(stackedScreen : StackedScreen)
    {
        //Logger.d("BrandsScreenMediator", this);
        super(stackedScreen);

        urlMonitor = new URLMonitor(new URLRequest(Constants.API_URL_assets));
        urlMonitor.addEventListener(StatusEvent.STATUS, urlMonitorStatusHandler);

        if(!Device.isIos()){
            NativeApplication.nativeApplication.addEventListener(KeyboardEvent.KEY_DOWN, handleKeys, false, 0, true);
        }
    }

    private function handleKeys(event:KeyboardEvent):void {
        if(event.keyCode == Keyboard.BACK){

            if(!brandsScreen) return;

            if(!(brandsScreen.owner as  StackedScreenNavigator)) return;

            if ((brandsScreen.owner as  StackedScreenNavigator).stackSize > 1) return;

            event.preventDefault();
            event.stopImmediatePropagation();

            NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.KEEP_AWAKE;
            NativeApplication.nativeApplication.exit();
        }
    }


    override public function onRegister() : void {
        super.onRegister();

        brandsScreen.addEventListener(BrandsScreen.SELECT_CAR, brandsScreenCarSelectedHandler);
        brandsScreen.addEventListener(Event.ADDED_TO_STAGE, brandsScreenAddedToStageHandler);
        brandsScreen.addEventListener(BrandsScreen.CAR_SELECTED, homeScreenCarSelectedHandler);
        brandsScreen.addEventListener(BrandsScreen.LANGUAGE_CHANGED,homeScreenLanguageChangedHandler);
        brandsScreen.addEventListener(BrandsScreen.INSTRUCTION_SELECTED, tuningScreenInstructionSelectedHandler);
        brandsScreen.addEventListener(BrandsScreen.VS_SELECTED, tuningScreenVsSelectedHandler);
        brandsScreen.addEventListener(BrandsScreen.MINIFRAME_SELECTED, tuningScreenMiniframeSelectedHandler);
        brandsScreen.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        brandsScreen.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        brandsScreen.addEventListener(BrandsScreen.BUY_NOW_PACKET, onBuyNowPacket);
        brandsScreen.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);
        brandsScreen.addEventListener(BrandsScreen.SLECTED_MATERIAL_WITH_RELOAD_CAR, onSelectedMaterialWithReloadCar);
        brandsScreen.addEventListener(BrandsScreen.CLEANUP_MEMORY, cleanUpMemorySelectedHandler);

        brandsScreen.addEventListener(BrandsScreen.DISPLAY_REWARD_INFO_POPUP, displayRewardInfoPopUp);
        brandsScreen.addEventListener(BrandsScreen.DISPLAY_REWARD_NOADS_POPUP, displayRewardNoAdsPopUp);
        brandsScreen.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        brandsScreen.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
        brandsScreen.addEventListener(PackagesView.UPDATE_CAR_PACKAGES, updatePackagesView);

        brandsScreen.addEventListener(Event.REMOVED_FROM_STAGE, screenRemovedHandler);

        brandsScreen.addEventListener(BrandsScreen.OPEN_MAIN_MENU, mainMenuOpenHandler);
        brandsScreen.addEventListener(BrandsScreen.CLOSE_MAIN_MENU, mainMenuCloseHandler);

        AdsManager.$.showBannerAfterComplete = true;
        Starling.juggler.delayCall(initialize, 1);
    }

    private function mainMenuCloseHandler(event:Event):void {
        if(brandsScreen && brandsScreen.stage && brandsScreen.mainMenuView && brandsScreen.mainMenuView.isOpened) {
            AdsManager.$.showBannerAfterComplete = true;
            brandsScreen.showAdBanner();
        }
    }

    private function mainMenuOpenHandler(event:Event):void {
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide(false);
    }

    private function screenRemovedHandler(event:Event):void {
        AdsManager.$.bannerHide(true);
    }

    private function initialize():void{
        if(Device.isIphoneXVariant()){
            brandsScreen.stage.starling.nativeStage.addEventListener(StageOrientationEvent.ORIENTATION_CHANGE, stageOrientationChangeHandler);
            brandsScreen.setNavButtonPosition();
        }

        if(!pendinfFriendRequested){
            var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
            friendProxy.loadPendings();
            pendinfFriendRequested = true;
        }
        ChallengeVotePopup.requestShowVotePopup();
        brandsScreen.showAdBanner();

        if (BillingManager.$.allPackets) {
            brandsScreen.packages = BillingManager.$.allPackets;
            checkBonusCar(BillingManager.$.allPackets);
            var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if(Constants.IN_APP_PURCHASE_ENABLED) {
                requestsFinishedCount++;
                usersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                trace('*********handleCarPackagesLoaded*******')
                usersProxy.getPurchases();
            }
            this.packagesLoaded = true;
            checkDataLoaded();
            checkAllLoaded();
        }

    }

    private function stageOrientationChangeHandler(event:StageOrientationEvent):void {
        brandsScreen.setNavButtonPosition();
    }

    private function displayRewardInfoPopUp(event: Event): void {
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide(false);
        sendNotification(Notifications.DISPLAY_REWARD_INFO_POPUP);
    }

    private function displayRewardNoAdsPopUp(event: Event): void {
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide(false);
        sendNotification(Notifications.DISPLAY_REWARD_NOADS_POPUP);
    }

    private function displayRewardNoCoinPopUp(event: Event): void {
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide(false);
        sendNotification(Notifications.DISPLAY_REWARD_NOCOIN_POPUP);
    }

    private function updatePackagesView(event: Event): void {
        AdsManager.$.showBannerAfterComplete = true;
        if(packagesLoaded){
            initialize();
        }
    }

    private function displayRewardConfirmPopUp(event: Event): void {
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide(false);
        var packet: Packet = event.data.packet as Packet;
        sendNotification(Notifications.DISPLAY_REWARD_CONFIRM_POPUP, {packet: packet});
    }

    private function checkPackets(): void {
        GameService.$.getSaveData(function(data: String): void {
            var saveData: Object = JSONer.parse(data);
            if(brandsScreen && brandsScreen.packages) {
                for (var i: Number = 0; i < brandsScreen.packages.length; i++){
                    var packetId: String = (brandsScreen.packages[i] as Packet).id;
                    if(saveData.rewardsPackets.indexOf(packetId) > -1) {
                        brandsScreen.packages[i].tempOpened = true;
                        brandsScreen.packages[i].lock = false;
                    } else if (brandsScreen.packages[i].tempOpened) {
                        brandsScreen.packages[i].tempOpened = false;
                        brandsScreen.packages[i].lock = true;
                    }
                }
            }
        });
    }


    private function onSelectedMaterialWithReloadCar(event:Event):void {
        //brandsScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);
        //sendNotification(Notifications.DISPLAY_TUNING_SCREEN, {car: BrandsScreen.selectedCar, backLevel: 0, carView: null, tunning: null});
        showCar({car: BrandsScreen.selectedCar, backLevel: 0, carView: null, tunning: null});

        Starling.juggler.delayCall(function():void{
            BrandsScreen.screenShotImage.removeFromParent(true);
            BrandsScreen.screenShotTexture.dispose();
            BrandsScreen.screenShotImage=null;
            BrandsScreen.screenShotTexture=null;

        }, 1);
    }

    private function viewCar360(event:Event):void
    {
        var car:Car=event.data.car;
        var packet:Packet=event.data.packet;

        continueCarSelect(car,0,true, true, packet);
    }

    protected function touchPacketInfo(event:Event):void
    {
        var packet:Packet=event.data.packet as Packet;
        sendNotification(Notifications.DISPLAY_INFO_POP_UP, {packet:packet});
    }

    protected function itemTouchPacket(event:Event):void{

        var packet:Packet=event.data.packet as Packet;
        if (Purchase.startPurchase) return;

        sendNotification(Notifications.DISPLAY_BUY_PACKET_POP_UP, {packet:packet});
    }

    protected function adsRemoverHandler(event:Event):void
    {
        sendNotification(Notifications.DISPLAY_BUY_REMOVE_ADS_POP_UP, {ads:event.data.ads});
    }

    override public function onRemove() : void
    {
        super.onRemove();

        brandsScreen.removeEventListener(BrandsScreen.SELECT_CAR, brandsScreenCarSelectedHandler);
        brandsScreen.removeEventListener(Event.ADDED_TO_STAGE, brandsScreenAddedToStageHandler);
        brandsScreen.removeEventListener(BrandsScreen.CAR_SELECTED, homeScreenCarSelectedHandler);//tuningLoadInitiated
        brandsScreen.removeEventListener(BrandsScreen.LANGUAGE_CHANGED,homeScreenLanguageChangedHandler);
        brandsScreen.removeEventListener(BrandsScreen.INSTRUCTION_SELECTED, tuningScreenInstructionSelectedHandler);
        brandsScreen.removeEventListener(BrandsScreen.VS_SELECTED, tuningScreenVsSelectedHandler);
        brandsScreen.removeEventListener(BrandsScreen.MINIFRAME_SELECTED, tuningScreenMiniframeSelectedHandler);
        brandsScreen.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        brandsScreen.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        brandsScreen.removeEventListener(BrandsScreen.BUY_NOW_PACKET, onBuyNowPacket);
        brandsScreen.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);
        brandsScreen.removeEventListener(BrandsScreen.SLECTED_MATERIAL_WITH_RELOAD_CAR, onSelectedMaterialWithReloadCar);
        brandsScreen.removeEventListener(BrandsScreen.CLEANUP_MEMORY, cleanUpMemorySelectedHandler);

        brandsScreen.removeEventListener(BrandsScreen.DISPLAY_REWARD_INFO_POPUP, displayRewardInfoPopUp);
        brandsScreen.removeEventListener(BrandsScreen.DISPLAY_REWARD_NOADS_POPUP, displayRewardNoAdsPopUp);
        brandsScreen.removeEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        brandsScreen.removeEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
        if(Device.isIphoneXVariant()){
            brandsScreen.stage.starling.nativeStage.removeEventListener(StageOrientationEvent.ORIENTATION_CHANGE, stageOrientationChangeHandler);
        }
    }

    private function brandsScreenCarSelectedHandler(event:Event):void {
        brandsScreen.featuredCarsList.dispose();
        showCar({car:brandsScreen.currentCar});
    }

    private function onBuyNowPacket(event:Event):void
    {
        var packet:Packet=event.data.packet;
        sendNotification(Notifications.BUY_NOW_PACKET, {packet:event.data.packet, popUp:null});
    }

    private var languageChangeFlag:Boolean=false;
    private function homeScreenLanguageChangedHandler(event : Event) : void
    {
        languageChangeFlag=true;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguage(brandsScreen.selectedLanguage);

        if (alertView) alertView.hide();
    }

    private function tuningScreenInstructionSelectedHandler(event : Event) : void
    {
        TutorialView.showCustomUrl();
    }

    private function tuningScreenVsSelectedHandler(event : Event) : void
    {
        TutorialView.showCustomUrl(true);
    }

    private function tuningScreenMiniframeSelectedHandler(event : Event) : void
    {
    }

    public function get brandsScreen() : BrandsScreen
    {
        return viewComponent as BrandsScreen;
    }

    private function updateNotifications():void{
        trace("BrandScreen#updateNotifications");
        if(brandsScreen) {
            brandsScreen.updateNotifications();
        }
    }

    private function brandsScreenAddedToStageHandler(event : Event=null) : void {
        updateNotifications();
        if(firstStart){
            AppMode.self.addEventListener(Event.CHANGE, function(e : Event):void{
                brandsScreen.showBlocker();
                brandsScreen.featuredCars = [];
                Starling.juggler.delayCall(function () : void  {
                    (facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy).loadBrands();
                }, 1)
            });
        }

        if(!screenShown){
            screenShown = true;
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            brandsScreen.userSignedIn = usersProxy.currentUser != null;
            if(usersProxy.currentUser && usersProxy.currentUser.isSuperAdmin){
                CarsProxy.IS_FULL = true;
                Constants.IN_APP_PURCHASE_ENABLED = false;
                Constants.update_API_URLS(true);
            }
            var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
            var settings : Settings = settingsProxy.currentSettings;
            if(settings.selectedLanguageCode){
                var filename:String = (settings.selectedLanguageCode == 'ru-RU') ? 'ru-RU' : 'en-US';
                var path : String = File.applicationDirectory.resolvePath('assets/manualCache/api/v1/translations').resolvePath(filename).url;
                var urlLoader : URLLoader = new URLLoader();
                urlLoader.addEventListener(Event.COMPLETE, function (e : flash.events.Event) :void{
                    var l : Language = new Language(JSONer.parse(urlLoader.data));
                    l.code = settings.selectedLanguageCode;
                    AlertView.language = l;
                    AlertViewHL.language = l;
                    CustomAlertView.language = l;
                    httpClient.language = l;
                    extendSessionIfNeccessary();
                });
                urlLoader.load(new URLRequest(path));
            } else {
                var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
                var newSettings : Settings = new Settings();
                newSettings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
                settingsProxy.update(newSettings);

                AlertView.language = languagesProxy.defaultLanguage;
                AlertViewHL.language = languagesProxy.defaultLanguage;
                CustomAlertView.language = languagesProxy.defaultLanguage;
                httpClient.language = languagesProxy.defaultLanguage;

                extendSessionIfNeccessary();
            }
        }
        handleCarPackagesRefreshed();
        var connectionProxy :ConnectionProxy = facade.retrieveProxy(ConnectionProxy.NAME) as ConnectionProxy;
        connectionProxy.check();
    }

    private function loadData() : void
    {
        if(firstStart){
            removeAlertView();
            alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
            firstStart = false;
        }

        requestsToMakeCount = 0;
        requestsFinishedCount = 0;

        requestsToMakeCount++;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguages();

        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languageToLoad : Language = new Language(null);
        trace("loadData", settingsProxy.currentSettings.selectedLanguageCode );

        if(languagesProxy.defaultLanguageCode.indexOf("ru")<0 && settingsProxy.currentSettings.selectedLanguageCode && settingsProxy.currentSettings.selectedLanguageCode.indexOf("en")<0){
            settingsProxy.currentSettings.selectedLanguageCode = "en-US";
        }

        requestsToMakeCount++;
        languageToLoad.code = settingsProxy.currentSettings.selectedLanguageCode;
        languagesProxy.loadLanguage(languageToLoad);

        requestsToMakeCount++;
        var brandsProxy : BrandsProxy = facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy;
        brandsProxy.loadBrands();
    }

    private function getNeededUser() : String
    {
        var userID : String = null;

        if (Constants.selectedUser){
            userID = Constants.selectedUser.id;
        }
        else if(facade.retrieveProxy(UsersProxy.NAME) as UsersProxy){

            var user : User = (facade.retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
            userID = user == null ? null : user.id;
        }

        return userID;
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
            Notifications.USER_AUTHENTICATED,
            Notifications.BRANDS_LOADED,
            Notifications.BRANDS_LOADING_FAILED,
            Notifications.PACKAGES_LOADED,
            Notifications.PACKAGES_REFRESHED,
            Notifications.PACKAGES_LOADING_FAILED,
            Notifications.LANGUAGES_LOADED,
            Notifications.LANGUAGES_LOADING_FAILED,
            Notifications.LANGUAGE_LOADED,
            Notifications.LANGUAGE_LOADING_FAILED,
            Notifications.USER_LOGGED_OUT,
            Notifications.APPLICATION_BECAME_ACTIVE,
            Notifications.CAR_TUNNING_LOADED,
            Notifications.CAR_TUNNING_LOADING_FAILED,
            Notifications.USER_SESSION_EXTENDED,
            Notifications.USER_SESSION_EXTENDING_FAILED,
            Notifications.USER_SESSION_EXTENDING_NOT_POSSIBLE,
            Notifications.BUY_NOW_PACKET,
            Notifications.BUY_NOW_CAR,
            Notifications.PACKET_PURCHASE_SUCCESS,
            Notifications.CAR_PURCHASE_SUCCESS,
            Notifications.BUY_NOW_ADS_REMOVER,
            Notifications.ADS_REMOVE_PURCHASE_SUCCESS,
            Notifications.PURCHASES_LOADED,
            Notifications.PURCHASES_LOADING_FAILED,
            Notifications.INTERNET_CONNECTED,
            Notifications.INTERNET_DISCONNECTED,
            Notifications.REWARD_DATA_CHANGE,
            Notifications.DELETE_REWARD_PACKET,
            Notifications.REWARD_ARS_OPEND,
            Notifications.REWARD_ARS_LOAD,

            Notifications.CHALLENGE_NOTIFICATIONS_VIEWED,
            Notifications.PENDING_FRIENDS_LOADED,

            Notifications.TIMELINE_SCREEN_FEED_PREVIEW
        ]);
    }

    override public function handleNotification(note : INotification) : void
    {

        switch(note.getName())
        {
            case Notifications.ADS_REMOVE_PURCHASE_SUCCESS:

                handleAdsRemoverPurchaseSuccess(note.getBody().ads);
                break;

            case Notifications.TIMELINE_SCREEN_FEED_PREVIEW:
                handleDisplayTimelineScreenFeed(note.getBody());
                break;

            case Notifications.BUY_NOW_ADS_REMOVER:

                handleBuyNowAdsRemover(note.getBody().ads);
                break;

            case Notifications.BUY_NOW_CAR:

                handleBuyNowCar(note.getBody().car);
                break;


            /*case Notifications.BUY_NOW_PACKET:

                handleBuyNowPacket(note.getBody().packet, note.getBody().popUp);
                break;*/

            case Notifications.CAR_PURCHASE_SUCCESS:

                handleCarPurchaseSuccess(note.getBody().car);
                break;


            case Notifications.PACKET_PURCHASE_SUCCESS:
                if(note.getBody().hasOwnProperty("isRestoring") && note.getBody().isRestoring) {
                    handlePacketPurchaseSuccess(note.getBody().packet);
                }
                break;
            case Notifications.BRANDS_LOADED:
                handleCarBrandsLoaded(note.getBody().brands, note.getBody().featuredCars);
                break;

            case Notifications.PURCHASES_LOADED:
                handlePurchasesLoaded(note.getBody().purchases);
                break;


            case Notifications.PURCHASES_LOADING_FAILED:
                handlePurchasesLoadingFailed();
                break;

            case Notifications.PACKAGES_LOADED:
                handleCarPackagesLoaded(note.getBody().packages);
                break;

            case Notifications.PACKAGES_REFRESHED:
                handleCarPackagesRefreshed();
                break;



            case Notifications.PACKAGES_LOADING_FAILED:
                handlePackagesLoadingFailed();
                break;

            case Notifications.USER_LOGGED_OUT:
                handleUserLoggedOut();
                break;

            case Notifications.USER_AUTHENTICATED:
                handleUserAuthenticated();
                break;

            case Notifications.BRANDS_LOADING_FAILED:
                handleBrandsLoadingFailed();
                break;

            case Notifications.APPLICATION_BECAME_ACTIVE:
                handleApplicationBecameActive();
                break;

            case Notifications.LANGUAGES_LOADED:
                handleLanguagesLoaded();
                break;

            case Notifications.LANGUAGES_LOADING_FAILED:
                handleLanguagesLoadingFailed();
                break;

            case Notifications.LANGUAGE_LOADED:
                handleLanguageLoaded(note.getBody().language);
                break;

            case Notifications.LANGUAGE_LOADING_FAILED:
                handleLanguageLoadingFailed();
                break;


            case Notifications.CAR_TUNNING_LOADED:
                handleCarLoaded(note.getBody() as Car);
                break;

            case Notifications.CAR_TUNNING_LOADING_FAILED:
                handleCarTunningLoadingFailed();
                break;

            case Notifications.USER_SESSION_EXTENDED:
                handleUserSessionExtented();
                break;

            case Notifications.USER_SESSION_EXTENDING_FAILED:
                handleUserSessionExtendingFailed();
                break;

            case Notifications.USER_SESSION_EXTENDING_NOT_POSSIBLE:
                handleUserSessionExtendingNotPossible();
                break;

            case Notifications.INTERNET_CONNECTED:
                handleInternetConnected();
                break;

            case Notifications.INTERNET_DISCONNECTED:
                handleInternetDisconnected();
                break;

            case Notifications.REWARD_DATA_CHANGE:
                handleRewardDataChange();
                break;
            case Notifications.DELETE_REWARD_PACKET:
                handleDeleteRewardPacket(note.getBody());
                break;
            case Notifications.REWARD_ARS_LOAD:
                handleRewardAdsLoad();
                break;
            case Notifications.REWARD_ARS_OPEND:
                handleRewardAdsOpend();
                break;
            case Notifications.PENDING_FRIENDS_LOADED:
                handlePendingFriendsLoaded(note.getBody());
                updateNotifications();
                break;
            case Notifications.CHALLENGE_NOTIFICATIONS_VIEWED:
                handleChallengeNotificationsClean();
                break;
        }

        super.handleNotification(note);
    }

    private function handleCarPackagesRefreshed():void {
        brandsScreen.refresh();
    }



    private function handleRewardAdsOpend(): void {

        brandsScreen.rewardNotificationImage.visible = false;
    }
    private function handleRewardAdsLoad(): void {
        brandsScreen.rewardsAdsAvailable = true;
        brandsScreen.rewardNotificationImage.x =  brandsScreen.rewardsButton.x +  brandsScreen.rewardsButton.width -  brandsScreen.rewardNotificationImage.width;
        brandsScreen.rewardNotificationImage.y =  brandsScreen.rewardsButton.y/* -  brandsScreen.rewardNotificationImage.height*/;
        brandsScreen.rewardNotificationImage.visible = brandsScreen.rewardsAvailable;
        brandsScreen.rewardNotificationImage.alpha = (brandsScreen.rewardsAvailable?1:0);
    }

    private function handleRewardDataChange(): void {
        GameService.$.getSaveData(function (data: String): void {
            var saveGameObject: Object = JSONer.parse(data);
            brandsScreen.rewardsButton.label = saveGameObject.rewards.toString();
        });

    }


    private function handleDeleteRewardPacket(packet: Object): void {
        trace(packet);
//			for (var i=0; i< brandsScreen.packages.length; i++){
//				if (brandsScreen.packages[i].id === packet.packetId) {
//					(brandsScreen.packages[i] as Packet).tempOpened = false;
//                    (brandsScreen.packages[i] as Packet).tempUsed = false;
//                    (brandsScreen.packages[i] as Packet).lock = true;
//				}
//			}
    }

    private function handlePendingFriendsLoaded(friends: Object): void {
        //if(brandsScreen.stage)
        brandsScreen.dispatchEventWith(FriendsListPopUp.PENDING_FRIENDS_READ, false, friends);
    }

    private function handleChallengeNotificationsClean(): void {
        Constants.UNREAD_CHALLENGE_NOTIFICATIONS = 0;
        Constants.updateNotificationCount();
        if(brandsScreen.mainMenuView){
            brandsScreen.mainMenuView.challengeNotesButton.noteCount = 0;
        }
    }

    private function handleInternetConnected():void{

        trace("handleInternetConnected");
        showAlertConnectionLost=false;

        if(!(brandsScreen.owner as  StackedScreenNavigator))
            return;


        if((this.brandsScreen.owner as  StackedScreenNavigator).activeScreen.name!=brandsScreen.name)
            return;


        if(reloadCarFlag){

            loadData();
            reloadCarFlag=false;
        }
    }


    private var showAlertConnectionLost:Boolean=false;
    private var reloadCarFlag:Boolean=false;

    private function handleInternetDisconnected():void{

        trace("handleInternetDisconnected");

        if(!FIRST_LOAD_COMPLETE){

            trace("handleInternetDisconnected2");
            if(!showAlertConnectionLost){
                trace("handleInternetDisconnected3");
                AlertView.show("Lost internet connection",-1, false);
                showAlertConnectionLost=true;
            }
        }


        if(!(brandsScreen.owner as  StackedScreenNavigator))
            return;


        if((this.brandsScreen.owner as  StackedScreenNavigator).activeScreen.name!=brandsScreen.name)
            return;



        if(!showAlertConnectionLost){
            AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "lostinternetconnection"),-1, false);
            showAlertConnectionLost=true;
        }
    }

    private function handleBuyNowAdsRemover(ads:Object):void{
        this.sendNotification(Notifications.ADS_REMOVE_PURCHASE_SUCCESS, {ads:ads});
    }


    private function handleBuyNowCar(car:Car):void{


        this.sendNotification(Notifications.CAR_PURCHASE_SUCCESS, {car:car});
    }

    private function handlePacketPurchaseSuccess(packet:Packet):void{

        this.brandsScreen.packetPurchaseSuccess(packet);

        AdsManager.turnOffAds();
        brandsScreen.topButtonPadding = 0;
    }

    private function handleDisplayTimelineScreenFeed(data:Object):void {
        if(brandsScreen && brandsScreen.stage){
            sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
        }
    }

    private function handleDisplayGalleryScreen(data:Object = null):void {
        if(brandsScreen && brandsScreen.stage){
            sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
        }
    }

    private function handleAdsRemoverPurchaseSuccess(ads:Object):void{
        this.brandsScreen.adsRemoverPurchaseSuccess(ads);
    }

    private function handleCarPurchaseSuccess(car:Car):void{
        this.brandsScreen.carPurchaseSuccess(car);
    }



    private function extendSessionIfNeccessary():void
    {

        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;


        if(!firstStart)
        {

            if(usersProxy.currentUser){
                trace('*********extendSessionIfNeccessary*******')
                usersProxy.getPurchases();
            }

            if(Device.isIos())
                return;
        }

        if(!firstStart)
        {
            if(brandsScreen)
                brandsScreen.invalidate();
            return;
        }

        if(usersProxy.currentUser)
        {
            usersProxy.extendSession();
        }
        else
        {
            loadData();
        }
    }

    private function urlMonitorStatusHandler(event : StatusEvent) : void
    {
        if (urlMonitor.available){
            extendSessionIfNeccessary();
        }
    }

    private function dataLoadFailed() : void
    {
        httpClient.cancelAllRequests();
        removeAlertView();

        if(!reloadCarFlag){

            //brandsScreen.showBlocker();
            reloadCarFlag=true;
        }
    }

    private function handleUserSessionExtented() : void
    {

        if(urlMonitor.running)
        {
            urlMonitor.stop();
        }
        else
        {
            loadData();
        }
    }

    private function handleUserSessionExtendingNotPossible() : void
    {
        loadData();

        if(urlMonitor.running)
        {
            urlMonitor.stop();
        }

        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        usersProxy.logoutCurrentUser();

        sendNotification(Notifications.DISPLAY_LOGIN_SCREEN);
    }

    private function handleUserSessionExtendingFailed() : void
    {
        loadData();

        if(!urlMonitor.running)
        {
            urlMonitor.start();
        }
    }

    private function handleCarBrandsLoaded(brands : Array, featuredCars : Array) : void
    {


        brandsScreen.hideBlocker();
        trace("handleCarBrandsLoaded");

        if(Constants.IN_APP_PURCHASE_ENABLED){

            setTimeout(function():void{
                requestsFinishedCount++;
                var packagesProxy:PackagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                packagesProxy.loadPackages(BrandsProxy.makeAllCarsList(brands));
            }, 1000);
        }else{
            this.purchaseLoaded = true;
            this.packagesLoaded = true;
        }

        brandsScreen.featuredCars = featuredCars;
        brandsScreen.brands = brands;
        Starling.juggler.delayCall(brandsScreen.updateView, 1);

        if(Constants.IN_APP_PURCHASE_ENABLED){
            checkDataLoaded();
        }

        this.brandsLoaded = true;

        checkAllLoaded();

        brandsScreen.updateModeView();
    }


    private function checkBonusCar(packages : Array):void{

        if(!Constants.LEFT_DAYS_ALERT_SHOW){

        }

        if(Constants.OPEN_PACKET_CAR){


            var carsProxy : CarsProxy = facade.retrieveProxy(CarsProxy.NAME) as CarsProxy;
            //var completeAddBonusCar:Boolean=false;
            var bonusCar:Car=null;



            for(var i:int=0; i<packages.length; i++){

                var packet:Packet=packages[i];

                if(!packet){
                    continue;
                }

                if(packet.type!=Packet.TYPE_COMPONENTS) continue;

                if(!packet.cars) continue;

                for(var j:int=0; j<packet.cars.length; j++){

                    var car:Car=packet.cars[j];


                    if(!carsProxy.bonusCarExists(car.id)){

                        bonusCar=car;
                        carsProxy.addBonusCars(car.id);
                        break;
                    }
                }

                if(bonusCar){
                    break;
                }
            }


            if(bonusCar){


                sendNotification(Notifications.DISPLAY_BUY_CAR_POP_UP, {car: bonusCar});
            }

            brandsScreen.updateCarList();

            //AlertView.show("Open Car", -1, false);
            Constants.OPEN_PACKET_CAR=false;
        }
    }

    private var pendinfFriendRequested:Boolean = false;
    private function handleCarPackagesLoaded(packages : Array) : void {
        brandsScreen.ads={
            id:'3472234323',
            title:"Turn Off Ads",
            price:5,
            discountprice:3,
            body:"The placeholder attribute specifies a short hint that describes the expected value of an input field (e.g. a sample value or a short description of the expected format).",
            lock: true
        };
        brandsScreen.packages = packages;
        checkBonusCar(packages);
        var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        //if(usersProxy.currentUser)
        if(Constants.IN_APP_PURCHASE_ENABLED) {
            requestsFinishedCount++;
            usersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            trace('*********handleCarPackagesLoaded*******')
            usersProxy.getPurchases();
        }
        this.packagesLoaded = true;
        checkDataLoaded();
        checkAllLoaded();
    }

    private function handlePackagesLoadingFailed() : void {
        dataLoadFailed();
    }

    private function handleBrandsLoadingFailed() : void {
        trace("handleBrandsLoadingFailed");
        dataLoadFailed();
    }

    private function handlePurchasesLoaded(products:Array):void{
        var i:int=0;
        var packet:Packet;
        var packagePacketMap:Object={};
        var existAllPacket:Boolean=false;
        var existCurrentAllPacket:Boolean=false;
        var packetCurrentAllPacket:Packet=null;
        var purchases:Array=[];
        var packet_id:String;
        var j:int;


        this.purchaseLoaded = true;


        if(!(brandsScreen.owner as  StackedScreenNavigator))
            return;

        if((brandsScreen.owner as  StackedScreenNavigator).activeScreen.name!=brandsScreen.name)
            return;


        if(!products)
            return;

        var packagesProxy : PackagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;

        if(!packagesProxy.packages)
            return;



        for(i=0; i<packagesProxy.packages.length; i++){

            packet=packagesProxy.packages[i];


            for(j=0; j<products.length; j++ ){

                packet_id=products[j].product;

                if(packet.id==packet_id){

                    packagePacketMap[packet_id]=packet;
                }

            }

        }


        for each( packet in packagePacketMap){


            purchases.push(new Purchase(packet.id, packet.title, true, packet.type));
            packet.lock=false;

            if(packet.type==Packet.TYPE_ALLPACKET){

                existAllPacket=true;

            }

            if(packet.type==Packet.TYPE_CURRENTALLPACKET){

                existCurrentAllPacket=true;
                packetCurrentAllPacket=packet;

            }

        }

        if(existAllPacket){

            for(i=0; i<packagesProxy.packages.length; i++){




                packet=packagesProxy.packages[i];

                packet.lock=false;

            }
        }else if(existCurrentAllPacket){

            for(i=0; i<packagesProxy.packages.length; i++){





                packet=packagesProxy.packages[i];

                if(packetCurrentAllPacket.packets.indexOf(packet.id)>=0){

                    packet.lock=false;

                }

            }

        }


        if(purchases.length>0){

            AdsManager.turnOffAds();
            brandsScreen.topButtonPadding =0;

        }
        brandsScreen.purchases=purchases;

        checkDataLoaded();
    }

    private function handlePurchasesLoadingFailed():void{


        checkDataLoaded();
        //dataLoadFailed();
    }



    private function handleLanguagesLoaded() : void
    {
        requestsFinishedCount++;
        checkDataLoaded();



        Starling.juggler.delayCall(refreshSettings, 1.5);
    }

    private function updateSettings() : void
    {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var settings : Settings = settingsProxy.currentSettings;

        //settings.autoscrollEnabled = brandsScreen.autoscrollEnabled;

        if(brandsScreen.selectedLanguage)
        {
            settings.selectedLanguageCode = brandsScreen.selectedLanguage.code;
        }

        settingsProxy.update(settings);
    }


    private function handleLanguagesLoadingFailed() : void
    {

        if(alertView)
        {
            alertView.hide();
        }

        this.brandsScreen.selectedLanguage = null;
        dataLoadFailed();

        /*var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguages();*/
    }

    private var firstFlagForShowRate:Boolean = false;

    private function handleLanguageLoaded(loadedLanguage : Language) : void {
        if(brandsScreen) {
            brandsScreen.updateWithLanguage(loadedLanguage);

            if(alertView)
            {
                alertView.hide();
            }

            updateSettings();

            sendNotification(Notifications.LANGUAGE_CHANGED);

            if(!firstFlagForShowRate){
                var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                usersProxy.ShowRateBoxIfNeed();
                firstFlagForShowRate = true;
            }
        }

        httpClient.language = loadedLanguage;

        requestsFinishedCount++;
        checkDataLoaded();


        if(this.brandsScreen && languageChangeFlag){

            brandsScreen.recreateElementWithLanguage();
        }
        languageChangeFlag=false;
    }

    private function handleLanguageLoadingFailed() : void
    {
        languageChangeFlag=false;
        dataLoadFailed();
    }

    private function checkDataLoaded() : void
    {
        if(requestsFinishedCount == requestsToMakeCount)
        {
            checkForPendingTuning();
        }
    }

    private function checkForPendingTuning() : void
    {
        {
            removeAlertView();
        }
    }

    private function handleCarTunningLoadingFailed() : void
    {
        removeAlertView();
        tuningLoadInitiated = false;
    }

    private function handleCarLoaded(loadedCar : Car) : void
    {

        if(tuningLoadInitiated)
        {
            tuningLoadInitiated = false;
            removeAlertView();

            showCar({
                loadedCar: loadedCar
            })
        }
    }

    private function removeAlertView() : void
    {
        if(alertView)
        {
            alertView.hide();
            alertView = null;
        }
    }


    private function handleApplicationBecameActive() : void {
        if(!(brandsScreen.owner as  StackedScreenNavigator))
            return;
        if((brandsScreen.owner as  StackedScreenNavigator).activeScreen.name!=brandsScreen.name)
            return;
        extendSessionIfNeccessary();
    }

    private function handleUserLoggedOut() : void
    {
        brandsScreen.userSignedIn = false;

        if(!Device.isIos()){
            var packagesProxy : PackagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;

            if(packagesProxy.packages){

                var i:int=0;

                for(i=0; i<packagesProxy.packages.length; i++){

                    packagesProxy.packages[i].lock=true;
                }
            }

            brandsScreen.purchases=[];
        }


        /*var userProxy:UsersProxy =  facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(userProxy.currentUser && userProxy.currentUser.isSuperAdmin){

            CarsProxy.IS_FULL = true;
            Constants.IN_APP_PURCHASE_ENABLED = false;

            loadData();
        }else{*/

        Constants.update_API_URLS(false);

        CarsProxy.IS_FULL = false;
        Constants.IN_APP_PURCHASE_ENABLED = true;
        loadData();
        //}
        sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
        Starling.juggler.delayCall(brandsScreen.updateView, 3);
    }

    private var _garage_delay:Number=0.5;

    private function handleUserAuthenticated() : void {
        if(!brandsScreen.userSignedIn){
            var userProxy:UsersProxy =  facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if(userProxy.currentUser && userProxy.currentUser.isSuperAdmin){

                var packagesProxy:PackagesProxy =  facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
                packagesProxy.packages = [];
                brandsScreen.packages = [];
                CarsProxy.IS_FULL = true;
                Constants.IN_APP_PURCHASE_ENABLED = false;

                Constants.update_API_URLS(true);

                loadData();
            }else{

                Constants.update_API_URLS(false);


                CarsProxy.IS_FULL = false;
                Constants.IN_APP_PURCHASE_ENABLED = true;
                loadData();
            }
        }

        trace("BrandsScreenMediator handleUserAuthenticated:", pendingForAuthAction);
        var assetsProxy:AssetsProxy =  facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;

        var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
        friendProxy.loadPendings();

        if (brandsScreen){
            brandsScreen.userSignedIn = true;
            brandsScreen.mainMenuView.loginButtonTriggeredHandler();
            // if (brandsScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_LOGIN) return;
        }

        if(stackedScreen && !stackedScreen.stage) {
            return;
        }

        /*if(pendingForAuthAction == AUTH_ACTION_FRIENDS) {
            Starling.juggler.delayCall(function():void{
                AdsManager.$.bannerHide(false);
                sendNotification(Notifications.DISPLAY_FRIENDS_LIST_SCREEN, {showBannerAfterExit: true, bannerScreen:BannerScreen.HOME_SCREEN});
            }, _garage_delay);
        }*/

        /*if(pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_GARAGE){
            Starling.juggler.delayCall(function():void{
                brandsScreen.clearMemory();
                sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
            }, _garage_delay);
        }*/

        /*if(pendingForAuthAction == AUTH_ACTION_TIMELINE) {
            Starling.juggler.delayCall(function():void{
                //brandsScreen.clearMemory();
                sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN);
            }, _garage_delay);
        }*/

        /*if(pendingForAuthAction == AUTH_ACTION_NOTIFICATIONS){
            Starling.juggler.delayCall(function():void{
                AdsManager.$.bannerHide(false);
                sendNotification(Notifications.DISPLAY_IN_APP_NOTIFICATION_POPUP, {showBannerAfterExit: true, bannerScreen:BannerScreen.HOME_SCREEN});
            }, _garage_delay);
        }else if(pendingForAuthAction == AUTH_ACTION_CHALLENGE_NOTIFICATIONS){
            Starling.juggler.delayCall(function():void{
                AdsManager.$.bannerHide(false);
                sendNotification(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP, {showBannerAfterExit: true, bannerScreen:BannerScreen.HOME_SCREEN});
            }, _garage_delay);
        }*/

        if (pendingForAuthAction == AUTH_ACTION_LOGIN){

        }
    }

    private function refreshSettings() : void
    {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        var settings : Settings = settingsProxy.currentSettings;

        trace("refreshSettings", settings.selectedLanguageCode);


        if(settings.selectedLanguageCode && settings.selectedLanguageCode.indexOf("ru")<0 && settings.selectedLanguageCode.indexOf("en")<0 )
            settings.selectedLanguageCode = null;

        if(languagesProxy.defaultLanguageCode.indexOf("ru")<0 && settings.selectedLanguageCode && settings.selectedLanguageCode.indexOf("en")<0){
            settings.selectedLanguageCode = "en-US";
        }

        trace("refreshSettings", settings.selectedLanguageCode);


        if(!settings.selectedLanguageCode)
        {
            settings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
        }

        trace("languagesProxy.defaultLanguageCode", languagesProxy.defaultLanguageCode);


        brandsScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);

        if(!brandsScreen.selectedLanguage){

            settings.selectedLanguageCode="en-US";
            brandsScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);

        }
        brandsScreen.languages = languagesProxy.languages;

        if(brandsScreen.languages!=null && brandsScreen.languages.length<=0){

            //languagesProxy  = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
            languagesProxy.loadLanguages();
        }else if (brandsScreen.languages==null){

            //languagesProxy  = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
            languagesProxy.loadLanguages();
        }

        this.languageLoaded = true;

        checkAllLoaded();


    }

    private function checkAllLoaded():void{


        if(this.languageLoaded && this.purchaseLoaded && this.brandsLoaded && this.packagesLoaded){


            //BrandsScreenMediator.FIRST_LOAD_COMPLETE = true;
        }

    }




    private function findPacketByCar(car:Car):Packet{

        var i:int=0;
        var j:int=0;
        var carItem:Car;

        var selectedPacket:Packet=null;


        for(i=0; i<brandsScreen.packages.length; i++){

            var packet:Packet=brandsScreen.packages[i];

            for(j=0; j<packet.cars.length; j++){


                carItem=packet.cars[j];

                if(carItem.id==car.id){

                    selectedPacket=packet;
                    break;

                }
            }

            if(selectedPacket){
                break;
            }
        }

        return selectedPacket;
    }

    private function homeScreenCarSelectedHandler(event : Event) : void {
        if(this.brandsScreen.witeTouchEventEnded){
            return;
        }
        brandsScreen.showSearchButtons();
        var car: Car = event.data as Car;
        if(!car)
            return;

        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(car.moreCarsURL){
            sendNotification(Notifications.DISPLAY_MORE_CARS_POP_UP, {car: car});
            return;
        }

        if(car && !car.packet){
            //	var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var packagesProxy :PackagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
            var packs:Array=packagesProxy.findPackagesByCarId(car.id);
            for(var k:int=0; k<packs.length; k++){
                car.addPacket(packs[k]);
            }
            //packagesProxy.findPacketByCarId(car.id);
        }

        if(car.packet  && car.packet.lock && !car.packet.show){
            //var packet:Packet=findPacketByCar(car);
            /*if(Purchase.startPurchase)
                return;*/

            this.brandsScreen.showBuyPacket(car.packet);
            //sendNotification(Notifications.DISPLAY_BUY_PACKET_POP_UP, {packet:car.packet});
            return;
        }

        if(usersProxy.httpClient.isUserSigned){
            continueCarSelect(car);
            return;
        }

        var textOfMessage:String = AlertView.language.translate("carchooserTop", "agreement_text");
        var title:String = AlertView.language.translate("carchooserTop", "agreement_title");
        var agree:String = AlertView.language.translate("carchooserTop", "agree");
        var disagree:String = AlertView.language.translate("carchooserTop", "disagree");
        if(!textOfMessage){
            textOfMessage = "Вы согласны с <u><a href=\"http://google.com\">лицензионным соглашением</a></u>?";
        }


        if(BrandsScreen.ONE_ALGREE){

            continueCarSelect(car,0, true, true, BrandsScreen.SELECTED_PACKET);

            BrandsScreen.ONE_ALGREE=false;
            BrandsScreen.SELECTED_PACKET=null;

        }else{
            SoundManager.playSound(SoundManager.SELECT_PART);
            AlertViewHL.show(title,textOfMessage,agree,disagree, -1, false, function(yesSelected : Boolean) : void
            {
                if(yesSelected){
                    continueCarSelect(car);
                }

            },  0x49cc46);
        }
    }

    private var skipAdsTrigger:Boolean=true;

    private var _saveStage:Stage;

    private function continueCarSelect(car: Car, index:int=0, addStats:Boolean=true, view360:Boolean=false, packet:Packet=null):void{
        _saveStage = brandsScreen.stage;
        brandsScreen.packagesView.hide(false);
        var bmpDir:File=File.applicationStorageDirectory.resolvePath("CarsBmp");
        if(bmpDir.exists){
            bmpDir.deleteDirectory(true);
            Tracer.print("DELETE CarsBmp");
        }

        //if(!car.lock){

        //var flurry:Flurry=Flurry.getInstance();
        //flurry.startTimedEvent("selected_car/"+car.displayName);
        brandsScreen.showBlocker();

        if(addStats){
            Tracker.getInstance().trackEvent("selected_car",  car.displayName, car.displayName);
        }


        var skipFullscreenAds:Boolean=false;


        if(car && car.packet)
        {

            if(car.packet.type!=Packet.TYPE_SUBCOMPONENT){
                skipFullscreenAds=true;
            }
        }

        var first_install_car:Boolean=false;
        if(!skipFullscreenAds && Constants.FIRST_APP_START && Constants.FIRST_TUNING_SCREEN_FREE_CAR){

            first_install_car=true;
            skipFullscreenAds=true;
            Constants.FIRST_TUNING_SCREEN_FREE_CAR=false;

        }else if(Constants.FIRST_APP_START && Constants.FIRST_TUNING_SCREEN_FREE_CAR ){


            first_install_car=true;
            skipFullscreenAds=true;
            Constants.FIRST_TUNING_SCREEN_FREE_CAR=false;
        }




        if(!skipFullscreenAds && !view360 && index==0){

            skipAdsTrigger=!skipAdsTrigger;
        }




        //if(!Device.isIos())
        {

            skipFullscreenAds=false;

            var xml : XML = NativeApplication.nativeApplication.applicationDescriptor;
            var ns : Namespace = xml.namespace();
            var version : String = xml.ns::versionNumber;

            var file:File=File.applicationStorageDirectory.resolvePath(version+"_first.dat");

            if(!file.exists){

                var fs:FileStream=new FileStream();
                fs.open(file, FileMode.WRITE);
                fs.writeByte(1);
                fs.close();

                skipFullscreenAds=true;
            }

            view360=false;
        }


        if(AdsManager.ENABLED && !view360 && !skipFullscreenAds){

            if(index<=1){
                AdsManager.$.requestInterstitial(function(sccess:Boolean):void{

                    if(sccess){

                        showCar({car: car, backLevel: 0, carView: null, tunning: null});

                    }else{

                        Starling.juggler.delayCall(function():void{
                            continueCarSelect(car, index+1, false)
                        }, 1.5);

                    }
                });
            }else{

                showCar({car: car, backLevel: 0, carView: null, tunning: null});

                car=null;

            }


        }else{


            /*if(brandsScreen.firstAdsTimeoutId){

                Starling.juggler.remove(brandsScreen.firstAdsTimeoutId);

                brandsScreen.firstAdsTimeoutId=null;
            }

            brandsScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);*/
            //sendNotification(Notifications.DISPLAY_TUNING_SCREEN, {car: car, backLevel: 0, carView: null, tunning: null, packet:packet});
            showCar({car: car, backLevel: 0, carView: null, tunning: null, packet:packet});
        }


    }

    private function showCar(data:Object):void{
//			brandsScreen.featuredCarsList.dispose();
        var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;

        if(data && data.car){
            var tmpCar:Car = data.car;

            if(tmpCar && tmpCar.updated>0){
                Tuning3D.CAR_UPDATE_DATE = tmpCar.updated;
            }
        }

        //assetsProxy.loadTuningAssets(function():void{


        var partSlot:PartSlot = new PartSlot(data.car);
        var partCarSplash:Part = new Part(partSlot);
        var partMaterial:PartMaterial = new PartMaterial(partCarSplash);

        var randomSplashUrl:String = RandomSplashManager.getRandomUrl();

        trace("randomSplashUrl:", randomSplashUrl);

        var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
        carSplashImageProvider.frameIndex = 0;
        carSplashImageProvider.angleIndex = 0;
        carSplashImageProvider.isEncrypted = false;


        var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
        carSplashImage.overrideDispose = false;
        carSplashImage.snapToPixels = false;
        if(Constants.TOTAL_MEMORY<1024 && Constants.SCALE_FACTOR<2){
            carSplashImage.bitmapScale = 0.5;
        }

        //carSplashImage.startManually = true;

        carSplashImage.visible = false;

        //tuningScreen.carView.setCarSplash(carSplashImage);
        _saveStage ||= brandsScreen.stage;
        if(_saveStage){
            _saveStage.addChild(carSplashImage);
        }

        carSplashImage.completeHandler = function(image:ImageLoaderWithStates):void{
            data.carSplashImage=carSplashImage;
            sendNotification(Notifications.DISPLAY_TUNING_SCREEN, data);
            setTimeout(function():void{
                brandsScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);
            },500);
        };

        carSplashImage.scaleMode =	ScaleMode.NONE;
        carSplashImage.persistentImageProvider = carSplashImageProvider;

    }


    private function cleanUpMemorySelectedHandler(event : Event) : void{
        brandsScreen.clearMemory();
    }

   /* private function homeScreenLoginSelectedHandler(event : Event) : void
    {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;

        if(!usersProxy.currentUser) _garage_delay=1.5;
        else _garage_delay=0.2;

        pendingForAuthAction = AUTH_ACTION_LOGIN;
        sendNotification(Notifications.AUTHENTICATE_USER);
    }*/

/*

    private function brandsScreenLogoutSelectedHandler(event : Event) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        usersProxy.logoutCurrentUser();

        AlertView.show(AlertView.language.translate("mob_saving", "loggedOut"), -1, false);
        this.brandsScreen.mainMenuView.signedIN = false;
        this.brandsScreen.ShowDone();
        this.brandsScreen.closeNotificationBar();
        sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
        brandsScreen.updateNotifications();
    }*/
}
}