package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.view.components.challenges.modals.*;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.core.StackedScreen;
import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.distriqt.AdsManager;
import com.utils.ArrayUtil;

    import feathers.core.PopUpManager;

    import flash.display.Loader;
    import flash.events.Event;

    import flash.net.URLRequest;

    import org.puremvc.as3.interfaces.INotification;

import starling.core.Starling;

import starling.events.Event;

public class ChallengeTuningViewPopupMediator extends PopUpMediator {
    private var _proxy:ChallengesProxy;
    private var _sharingProxy:SharingProxy;
    private var _challengeTuningPreviewPopup:ChallengeTuningViewPopup;
    public function ChallengeTuningViewPopupMediator(popUp:PopUp) {
        super(popUp);
        _challengeTuningPreviewPopup = popUp as ChallengeTuningViewPopup;
    }

    override public function onRegister():void {
        super.onRegister();
        _proxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;

        _challengeTuningPreviewPopup.addEventListener(ChallengeEvent.VIEW_NEXT_CHALLENGE_TUNING, nextChallengeTuningViewHandler);
        _challengeTuningPreviewPopup.addEventListener(TuningScreen.SHARE_FB_SELECTED, shareChallengeOnFacebookHandler);
//        _challengeTuningPreviewPopup.addEventListener(TuningScreen.SHARE_VK_SELECTED, shareChallengeOnVkHandler);
        _challengeTuningPreviewPopup.addEventListener(TuningScreen.SHARE_INSTAGRAM_SELECTED, shareChallengeOnInstagramHandler);
        _challengeTuningPreviewPopup.tuningView.addEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);
        _challengeTuningPreviewPopup.tuningView.addEventListener(StackedScreen.GARAGE_SELECTED, garageSelectedHandler);

    }

    override public function onRemove():void {
        super.onRemove();
        _challengeTuningPreviewPopup.removeEventListener(ChallengeEvent.VIEW_NEXT_CHALLENGE_TUNING, nextChallengeTuningViewHandler);
        _challengeTuningPreviewPopup.removeEventListener(TuningScreen.SHARE_FB_SELECTED, shareChallengeOnFacebookHandler);
//        _challengeTuningPreviewPopup.removeEventListener(TuningScreen.SHARE_VK_SELECTED, shareChallengeOnVkHandler);
        _challengeTuningPreviewPopup.removeEventListener(TuningScreen.SHARE_INSTAGRAM_SELECTED, shareChallengeOnInstagramHandler);
        if(_challengeTuningPreviewPopup.tuningView){
            _challengeTuningPreviewPopup.tuningView.removeEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);
            _challengeTuningPreviewPopup.tuningView.removeEventListener(StackedScreen.GARAGE_SELECTED, garageSelectedHandler);
        }
    }

    private function nextChallengeTuningViewHandler(event:starling.events.Event):void {
        _proxy.getRandomChallenge(_challengeTuningPreviewPopup.loadChallenge);
    }

    private function shareChallengeOnFacebookHandler(event:starling.events.Event):void {
        Starling.juggler.delayCall(function ():void {
            AdsManager.$.requestInterstitial(function (showed : Boolean) : void {
                SharingProxy.shareUrlOnFacebook(event.data.url);
            });
        }, 0.4);
    }

    private function shareChallengeOnVkHandler(event:starling.events.Event):void {

    }

    private function shareChallengeOnInstagramHandler(event:starling.events.Event):void {
        var sharingInstagramProxy:SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
        sharingInstagramProxy.sharePhoto('', event.data.bitmapData, function ():void {
            event.data.bitmapData.dispose();
        }, event.data.url);

    }

    private function userDetailsSelectedHandler(event:starling.events.Event):void {
        Constants.selectedUser = event.data.user;
        sendNotification(Notifications.DISPLAY_USER_DETAILS_POPUP, {user:Constants.selectedUser});
    }

    private function garageSelectedHandler(event:starling.events.Event):void {
        PopUpManager.removeAllPopUps(true);
        Constants.selectedUser = null;
        sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
    }

    private function shareInInstagram(): void {
//        var sharingInstagramProxy:SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
//        sharingInstagramProxy.sharePhoto(event.data.url, event.data.bitmapData, function ():void {
//            event.data.bitmapData.dispose();
//        });
    }


    private function handleSharingTextEnter(): void {
        var sharingObject: Object = {};
        if (_challengeTuningPreviewPopup.tuningView.challengeData
                && _challengeTuningPreviewPopup.tuningView.challengeData[_challengeTuningPreviewPopup.tuningView.challengeType]
                && _challengeTuningPreviewPopup.tuningView.challengeData[_challengeTuningPreviewPopup.tuningView.challengeType].tuning
                && _challengeTuningPreviewPopup.tuningView.challengeData[_challengeTuningPreviewPopup.tuningView.challengeType].tuning.additionalSnapshots
                && _challengeTuningPreviewPopup.tuningView.challengeData[_challengeTuningPreviewPopup.tuningView.challengeType].tuning.additionalSnapshots.challenge) {

            _challengeTuningPreviewPopup.showLoader();

            sharingObject.imageUrl = 'http:' + _challengeTuningPreviewPopup.tuningView.challengeData[_challengeTuningPreviewPopup.tuningView.challengeType].tuning.additionalSnapshots.challenge.replace('http:', '');

            var url:URLRequest = new URLRequest(sharingObject.imageUrl);
            var img:Loader = new Loader();


            img.load(url);
            img.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, function (e: flash.events.Event): void {
                _challengeTuningPreviewPopup.hideLoader();
                sharingObject.bitmapData = e.target.content.bitmapData;
                _challengeTuningPreviewPopup.dispatchEvent(new starling.events.Event(TuningScreen.SHARE_INSTAGRAM_SELECTED, false, sharingObject));
            });

        }
    }

    private function handleSharingReady(__title:String):void {

        var challengeUrl: String = ChallengesProxy.getChallengeShareUrl(_challengeTuningPreviewPopup.tuningView.challengeData._id, _challengeTuningPreviewPopup.tuningView.challengeType)
        sendNotification(Notifications.DISPLAY_TUNING_SHARING_POP_UP, {title: __title, siteLink: challengeUrl});

    }


    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
                Notifications.SHARING_READY,
                Notifications.TUNING_SHARING_MESSAGE_ENTERED
            ]);
    }

    override public function handleNotification(note:INotification):void {
        super.handleNotification(note);

        switch(note.getName()) {
            case Notifications.SHARING_READY:
                handleSharingReady(note.getBody() as String);
                break;
            case Notifications.TUNING_SHARING_MESSAGE_ENTERED:
                handleSharingTextEnter();
                break;
        }

    }
}
}
