package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.view.components.challenges.modals.*;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.utils.ArrayUtil;

import org.puremvc.as3.interfaces.INotification;

import starling.events.Event;

public class ChallengeVotePopupMediator extends PopUpMediator {
    private var _proxy:ChallengesProxy;
    private var _challengeVotePopup:ChallengeVotePopup;
    public function ChallengeVotePopupMediator(popUp:PopUp) {
        super(popUp);
        _challengeVotePopup = popUp as ChallengeVotePopup;
    }

    override public function onRegister():void {
        super.onRegister();
        _proxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
        _challengeVotePopup.addEventListener(ChallengeEvent.VIEW_NEXT_CHALLENGE_TUNING, nextChallengeTuningViewHandler);
        _challengeVotePopup.addEventListener(ChallengeEvent.VIEW_CHALLENGE_TUNING, viewChallengeTuningHandler);
        //nextChallengeTuningViewHandler(null);
    }

    override public function onRemove():void {
        super.onRemove();
        _challengeVotePopup.removeEventListener(ChallengeEvent.VIEW_NEXT_CHALLENGE_TUNING, nextChallengeTuningViewHandler);
        _challengeVotePopup.removeEventListener(ChallengeEvent.VIEW_CHALLENGE_TUNING, viewChallengeTuningHandler);
    }

    private function viewChallengeTuningHandler(event:Event):void {
        var closeHandler:Function = function ():void {
            _challengeVotePopup.skip();
        };
        sendNotification(Notifications.DISPLAY_CHALLENGE_TUNING_POPUP, {deleteOtherScreens : false, enableCloseButton: true, closeHandler: closeHandler, data:event.data});
    }

    private function nextChallengeTuningViewHandler(event:Event):void {
        _proxy.getRandomChallenge(_challengeVotePopup.loadChallenge);
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [

        ]);
    }

    override public function handleNotification(note:INotification):void {
        switch(note.getName()) {

        }
        super.handleNotification(note);
    }
}
}
