package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.packages.Packet;
import com.despark.tuning3d.view.components.brands.RewardConfirmPopUp;
import com.despark.tuning3d.view.components.core.PacketView;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.distriqt.GameService;

import starling.events.Event;

public class RewardConfirmPopUpMediator   extends PopUpMediator{
    private const REWARD_BUY_PACKET: String = "REWARD_BUY_PACKET";
    public function RewardConfirmPopUpMediator(popUp : PopUp) {
        super(popUp);
    }
    public function get rewardConfirmPopUp() : RewardConfirmPopUp
    {
        return RewardConfirmPopUp(popUp);
    }

    override public function onRegister() : void
    {
        rewardConfirmPopUp.addEventListener(REWARD_BUY_PACKET, rewardBuyPacketHandler);
        super.onRegister();
    }

    override public function onRemove() : void
    {
        rewardConfirmPopUp.removeEventListener(REWARD_BUY_PACKET, rewardBuyPacketHandler);
        super.onRemove();
    }

    private function rewardBuyPacketHandler(event: Event): void {
        var packet: Packet = event.data.packet;
        GameService.$.addRewardPacket(packet.id, packet.coin3dFee, function(status: Boolean): void {
            if (status) {
                packet.tempOpened = true;
                sendNotification(Notifications.BUY_NOW_PACKET, {packet : packet, popUp : null});
            }
        });
    }
}
}
