package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.view.components.brands.RewardInfoPopUp;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.utils.Tracker;

public class RewardInfoPopUpMediator  extends PopUpMediator{
    public static const OPEN_NO_ADS_POP_UP : String = 'OPEN_NO_ADS_POP_UP';
    public function RewardInfoPopUpMediator(popUp : PopUp) {
        super(popUp);
    }
    public function get rewardInfoPopUp() : RewardInfoPopUp
    {
        return RewardInfoPopUp(popUp);
    }

    override public function onRegister() : void
    {
        super.onRegister();
        rewardInfoPopUp.addEventListener(OPEN_NO_ADS_POP_UP, openNoAdsPopUpHandler);
    }

    override public function onRemove() : void
    {
        rewardInfoPopUp.removeEventListener(OPEN_NO_ADS_POP_UP, openNoAdsPopUpHandler);
        super.onRemove();
    }

    private function openNoAdsPopUpHandler(): void {
        Tracker.getInstance().trackEvent("click_watch_reward", 'click_watch_reward', 'click_watch_reward');
        sendNotification(Notifications.DISPLAY_REWARD_NOADS_POPUP);
    }
}
}
