package com.despark.tuning3d.view {
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.partinfo.webview.IWebView;
import com.despark.tuning3d.view.components.partinfo.webview.NativeWB;
import com.despark.tuning3d.view.components.partinfo.webview.StageWB;
    import com.distriqt.extension.nativewebview.Header;


    import flash.geom.Rectangle;

import starling.core.Starling;
import starling.events.Event;

public class TuningEditorPopUp extends PopUp{

    public static const CLOSED_TRIGGERED : String = 'closedTriggered';

    private var _url : String ;
    private var _webView : IWebView;
    private var _headers:Vector.<Header>;
    private var _tuning:Tuning;
    public function TuningEditorPopUp(obj : Object) {
        super();
        _url = obj.url;
        _tuning = obj.tuning;
    }


    override protected function initialize():void {
        super.initialize();

        setSizeInternal(this.stage.stageWidth, this.stage.stageHeight,false);

        closeButton.x = actualWidth - closeButton.width - 10;
        closeButton.y = 5;


        contentBackgroundImage.visible = false;
        background.width = actualWidth;
        background.height = actualHeight;

        if (Device.isEmulator()) {
            _webView = new StageWB();
        } else {
            _webView = new NativeWB();
        }
        _webView = new NativeWB();
        var gap : Number = closeButton.height + closeButton.y*2;
        var ratio : Number = Starling.current.nativeStage.stageWidth / Constants.STAGE_WIDTH;
        var leftOffset: int = 0;
        if (Device.isIphoneXVariant()) {
            leftOffset = Device.IPHONE_X_VARIANT_MARGIN_LEFT * Starling.current.contentScaleFactor;
        }
        _webView.setViewPort(new Rectangle(leftOffset, ratio * gap, (actualWidth)*ratio - 2 * leftOffset, (actualHeight - gap * 2) * ratio));

        Starling.juggler.delayCall(function () : void {
            _webView.loadURL(_url, _headers);
        }, 2);


    }

    override protected function closeButtonTriggeredHandler(event:Event):void {
//        _webView.hide();
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        _webView.dispose();
        this.dispatchEventWith(CLOSED_TRIGGERED, false, _tuning);
        super.closeButtonTriggeredHandler(event);
    }

    override protected function draw():void {
        super.draw();

        closeButton.x = actualWidth - closeButton.width - 10;
        closeButton.y = 5;

    }

    public function setHeader(headers:Vector.<Header>):void {
        _headers = headers;
    }

}
}
