package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.brands.BrandsProxy;
import com.despark.tuning3d.model.core.AppMode;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.*;
import com.distriqt.extension.nativewebview.Header;

import org.puremvc.as3.interfaces.INotification;

import starling.events.Event;

public class TuningEditorPopUpMediator extends PopUpMediator {


    public function TuningEditorPopUpMediator(popUp:PopUp
    ) {
        super(popUp);

        var token : String = (facade.retrieveProxy(UsersProxy.NAME) as UsersProxy).getUserToken();
        var _headers : Vector.<Header> = new Vector.<Header>();
        _headers.push(new Header('Cookie', 'token=' + token + ';'));

        editorPopUp.setHeader(_headers);
    }

    public function get editorPopUp() : TuningEditorPopUp
    {
        return TuningEditorPopUp(popUp);
    }


    override public function onRegister():void {
        super.onRegister();

        editorPopUp.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
        editorPopUp.addEventListener(TuningEditorPopUp.CLOSED_TRIGGERED, closeTriggeredHandler);
    }

    private function closeTriggeredHandler(event:Event):void {
        sendNotification(Notifications.TUNING_REFRESH, event.data);
    }

    private function onAddedToStage(event:Event):void {
    }



    override public function onRemove():void {
        super.onRemove();
        editorPopUp.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
        editorPopUp.removeEventListener(TuningEditorPopUp.CLOSED_TRIGGERED, closeTriggeredHandler);

    }

}
}
