
package com.despark.tuning3d.view
{
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.tunings.editing.TuningSharingPopUp;
	import com.despark.tuning3d.view.core.PopUpMediator;
	
	import starling.events.Event;
	
	public class TuningSharingPopUpMediator extends PopUpMediator
	{
		public function TuningSharingPopUpMediator(popUp : PopUp)
		{
			super(popUp);
		}
		
		public function get tuningSharingPopUp() : TuningSharingPopUp
		{
			return TuningSharingPopUp(popUp);
		}
		
		override public function onRegister() : void
		{
			super.onRegister();
			tuningSharingPopUp.addEventListener(TuningSharingPopUp.SHARE_BUTTON_SELECTED, tuningSharingPopUpSharingButtonSelectedHandler);
		}
		
		override public function onRemove() : void
		{
			super.onRemove();
			tuningSharingPopUp.removeEventListener(TuningSharingPopUp.SHARE_BUTTON_SELECTED, tuningSharingPopUpSharingButtonSelectedHandler);
		}
		
		private function tuningSharingPopUpSharingButtonSelectedHandler(event : Event) : void
		{
			sendNotification(Notifications.TUNING_SHARING_MESSAGE_ENTERED, tuningSharingPopUp.message);
			sendNotification(Notifications.REMOVE_POP_UP, popUp);
		}
	}
}