package com.despark.tuning3d.view
{
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.brands.BrandsProxy;
import com.despark.tuning3d.model.cars.CarBackground;
import com.despark.tuning3d.model.cars.CarBackgroundsProxy;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.LanguagesProxy;
import com.despark.tuning3d.model.parts.Part;
import com.despark.tuning3d.model.parts.PartMaterial;
import com.despark.tuning3d.model.parts.PartMaterialImageTest;
import com.despark.tuning3d.model.parts.PartSlot;
import com.despark.tuning3d.model.settings.Settings;
import com.despark.tuning3d.model.settings.SettingsProxy;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.BannerStackedScreen;
	import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.MainMenuItem;
import com.despark.tuning3d.view.components.core.StackedScreen;
import com.despark.tuning3d.view.components.core.StackedScreen;
import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
import com.despark.tuning3d.view.components.instructions.TutorialView;
	import com.despark.tuning3d.view.components.mailbox.MailsScreen;
	import com.despark.tuning3d.view.components.tunings.TuningsListMenuView;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
	import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
	import com.despark.tuning3d.view.core.StackedScreenMediator;
import com.distriqt.extension.facebookapi.facebookapi_internal;
import com.utils.ArrayUtil;
import com.utils.RandomSplashManager;

import feathers.data.ListCollection;
import feathers.events.FeathersEventType;

import flash.display.BitmapData;
import flash.filesystem.File;
import flash.utils.Timer;
import flash.utils.clearTimeout;
import flash.utils.setTimeout;

import org.puremvc.as3.interfaces.INotification;

import starling.core.Starling;
import starling.events.Event;
import starling.utils.ScaleMode;

public class TuningsListScreenMediator extends StackedScreenMediator
	{
		private var allTunningsLoaded : Boolean;
		private static var b : int;
		private var _backgroundsMap:Object={};
        private var _updateTimer:Timer;
        private var _isFeedUpdating : Boolean = false;
		private var _startChallengeData:Object;


		public function TuningsListScreenMediator(stackedScreen : StackedScreen)
		{
			super(stackedScreen);
		}
		
		override public function onRegister() : void       
		{
			super.onRegister();

            tuningsListScreen.addEventListener(TuningsListScreen.CAR_SELECTED, tuningsListScreenCarSelectedHandler);
			tuningsListScreen.addEventListener(StackedScreen.BRANDS_SELECTED, tuningsListScreenBrandsSelectedHandler);
			tuningsListScreen.addEventListener(StackedScreen.HOME_SELECTED, tuningsListScreenHomeSelectedHandler);
			tuningsListScreen.addEventListener(StackedScreen.TUNING_SELECTED, tuningsListScreenTuningSelectedHandler);
			tuningsListScreen.addEventListener(TuningsListScreen.TUNING_SHARE, tuningsListScreenTuningShareHandler);
			tuningsListScreen.addEventListener(TuningsListScreen.TUNING_DELETE, tuningsListScreenTuningDeleteHandler);
			tuningsListScreen.addEventListener(FeathersEventType.INITIALIZE, tuningsListScreenInitializeStageHandler);

            tuningsListScreen.addEventListener(StackedScreen.TIMELINE_SECLECTED, tuningsListScreenTimelineSelectedHandler);
            tuningsListScreen.addEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
            tuningsListScreen.addEventListener(StackedScreen.NOTIFICATION_SELECTED, notificationSelectedHandler);
            tuningsListScreen.addEventListener(StackedScreen.FRIENDS_SELECTED, tuningsListScreenFriendsSelectedHandler);
            tuningsListScreen.addEventListener(StackedScreenNavigator.BACK_TO_SCREEN, backToPreviousScreen);
			tuningsListScreen.addEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);
			tuningsListScreen.addEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);

			//////////////////////
			tuningsListScreen.addEventListener(StackedScreen.VOTE_SELECTED, tuningsListScreenVotesSelectedHandler);
			tuningsListScreen.addEventListener(BrandsScreen.CLEANUP_MEMORY, tuningsListCleanUpMemoryHandler);
			tuningsListScreen.addEventListener(BrandsScreen.LANGUAGE_CHANGED,tuningsListScreenLanguageChangedHandler);
			tuningsListScreen.addEventListener(BrandsScreen.LOGOUT_SELECTED, tuningsListScreenLogoutSelectedHandler);
			tuningsListScreen.addEventListener(BrandsScreen.INSTRUCTION_SELECTED, tuningsListScreenInstructionSelectedHandler);
			///////////////////////
            tuningsListScreen.addEventListener(StackedScreen.CHALLENGE_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
			tuningsListScreen.addEventListener(StackedScreen.CHALLENGES_SELECTED, challengeSelectHandler);
            tuningsListScreen.addEventListener(StackedScreen.LEADER_BOARD_SELECTED, leaderBoardSelectHandler);
            tuningsListScreen.addEventListener(BrandsScreen.LOGIN_SELECTED, loginSelectHandler);


            tuningsListScreen.addEventListener(TuningsListScreen.UPDATE_FEED, tuningScreenUpdatedFeedHandller);
            tuningsListScreen.addEventListener(TuningsListScreen.GET_SOCIAL_DATA, tuningScreenSocialSelectedHandler);
			// challenges
            tuningsListScreen.addEventListener(ChallengeEvent.CHALLENGE_REQUEST, handleChallengeRequest);
            tuningsListScreen.addEventListener(TuningsListMenuView.LIKE_SELECTED, tuningLikeSelectedHandler);
            tuningsListScreen.addEventListener(TuningsListMenuView.COMMENT_SELECTED, tuningCommentSelectedHandler);
			//
            tuningsListScreen.addEventListener(MailsScreen.SEND_INSTANT_MAIL, sendInstantMailHandler);

            Starling.juggler.delayCall(initialize, 1);
        }

        private function initialize():void{
            var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
            friendProxy.loadPendings();
            loadSelectedUserTunings();
		}

        private function leaderBoardSelectHandler(event : Event) : void {
			BannerStackedScreen.hideAdBanner(false);
            sendNotification(Notifications.DISPLAY_CHALLENGE_LEADERBOARD_POPUP, {showBannerAfterExit: true});
        }

		private function loginSelectHandler(event : Event) : void {
            sendNotification(Notifications.DISPLAY_LOGIN_SCREEN);
        }

		private function challengeSelectHandler(event : Event) : void {
			sendNotification(Notifications.DISPLAY_CHALLENGE_SCREEN);
		}

		private function sendInstantMailHandler(event:Event):void {
			sendNotification(Notifications.DISPLAY_INSTANT_MAIL_POPUP, event.data);
		}

        private function tuningCommentSelectedHandler(event:Event):void {
            sendNotification(Notifications.AUTHENTICATE_USER);
        }

        private function tuningLikeSelectedHandler(event:Event):void {
            sendNotification(Notifications.AUTHENTICATE_USER);
        }

		private function gallerySelectHandler(event : Event) : void {
            sendNotification(Notifications.DISPLAY_GALLERY_SCREEN);
        }

		private function mailSelectedHandler(event:Event):void {
			pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_MAILS;
			sendNotification(Notifications.AUTHENTICATE_USER);
		}

		private function userDetailsSelectedHandler(event:Event):void {
			sendNotification(Notifications.DISPLAY_USER_DETAILS_POPUP, event.data);
		}

        private function tuningsListCleanUpMemoryHandler(event: Event):void {
			if(tuningsListScreen) tuningsListScreen.cleanupMemory();
        }
		
		private var _isRemove:Boolean = false;
        private var _garage_delay:Number;
		override public function onRemove() : void {
			_isRemove = true;
			super.onRemove();
			if(alertView) {
				alertView.hide();
			}
			if(_timerID) {
				clearTimeout(_timerID);
				_timerID=0;
			}
			
            tuningsListScreen.removeEventListener(TuningsListScreen.CAR_SELECTED, tuningsListScreenCarSelectedHandler);
            tuningsListScreen.removeEventListener(StackedScreen.BRANDS_SELECTED, tuningsListScreenBrandsSelectedHandler);
            tuningsListScreen.removeEventListener(StackedScreen.CHALLENGE_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
            tuningsListScreen.removeEventListener(StackedScreen.HOME_SELECTED, tuningsListScreenHomeSelectedHandler);
			tuningsListScreen.removeEventListener(TuningsListScreen.TUNING_SELECTED, tuningsListScreenTuningSelectedHandler);
			tuningsListScreen.removeEventListener(TuningsListScreen.TUNING_SHARE, tuningsListScreenTuningShareHandler);
			tuningsListScreen.removeEventListener(TuningsListScreen.TUNING_DELETE, tuningsListScreenTuningDeleteHandler);
			tuningsListScreen.removeEventListener(FeathersEventType.INITIALIZE, tuningsListScreenInitializeStageHandler);
			tuningsListScreen.removeEventListener(StackedScreen.USER_DETAILS_SELECTED, userDetailsSelectedHandler);

            tuningsListScreen.removeEventListener(StackedScreen.TIMELINE_SECLECTED, tuningsListScreenTimelineSelectedHandler);
            tuningsListScreen.removeEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
			tuningsListScreen.removeEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);
            tuningsListScreen.removeEventListener(StackedScreen.NOTIFICATION_SELECTED, notificationSelectedHandler);

            tuningsListScreen.removeEventListener(StackedScreen.FRIENDS_SELECTED, tuningsListScreenFriendsSelectedHandler);
            tuningsListScreen.removeEventListener(StackedScreenNavigator.BACK_TO_SCREEN, backToPreviousScreen);

			//////////////////////
			tuningsListScreen.removeEventListener(StackedScreen.VOTE_SELECTED, tuningsListScreenVotesSelectedHandler);
			tuningsListScreen.removeEventListener(BrandsScreen.CLEANUP_MEMORY, tuningsListCleanUpMemoryHandler);
			tuningsListScreen.removeEventListener(BrandsScreen.LANGUAGE_CHANGED,tuningsListScreenLanguageChangedHandler);
			tuningsListScreen.removeEventListener(BrandsScreen.LOGOUT_SELECTED, tuningsListScreenLogoutSelectedHandler);
            tuningsListScreen.removeEventListener(BrandsScreen.LOGIN_SELECTED, loginSelectHandler);
			tuningsListScreen.removeEventListener(BrandsScreen.INSTRUCTION_SELECTED, tuningsListScreenInstructionSelectedHandler);
			///////////////////////

			tuningsListScreen.removeEventListener(StackedScreen.CHALLENGES_SELECTED, challengeSelectHandler);
            tuningsListScreen.removeEventListener(TuningsListScreen.UPDATE_FEED, tuningScreenUpdatedFeedHandller);
            tuningsListScreen.removeEventListener(TuningsListScreen.GET_SOCIAL_DATA, tuningScreenSocialSelectedHandler);
            tuningsListScreen.removeEventListener(TuningsListScreen.GET_SOCIAL_DATA, tuningScreenSocialSelectedHandler);

            tuningsListScreen.removeEventListener(ChallengeEvent.CHALLENGE_REQUEST, handleChallengeRequest);
            tuningsListScreen.removeEventListener(TuningsListMenuView.LIKE_SELECTED, tuningLikeSelectedHandler);
            tuningsListScreen.removeEventListener(TuningsListMenuView.COMMENT_SELECTED, tuningCommentSelectedHandler);

			tuningsListScreen.removeEventListener(MailsScreen.SEND_INSTANT_MAIL, sendInstantMailHandler);

			tuningsListScreen.dispose();  
		}

		private function tuningsListScreenInstructionSelectedHandler(event:Event):void{
			TutorialView.showCustomUrl();
		}

		private function tuningsListScreenLogoutSelectedHandler(event:Event) : void
		{
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.logoutCurrentUser();
			
			AlertView.show(AlertView.language.translate("mob_saving", "loggedOut"), -1, false);   
			tuningsListScreen.updateNotifications();
			this.tuningsListScreen.ShowDone();
            tuningsListScreen.requireLogin = true;
		}

        private function challengeNotesSelectHandler(event : Event) : void {
            // sendNotification(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP);

            if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_LOGIN) {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_LOGIN);
            } else {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_CHALLENGE_NOTIFICATIONS);
            }
        }

        private function backToPreviousScreen(event:Event):void {
            sendNotification(Notifications.DISPLAY_PREVIOUS_SCREEN);
        }

        private function notificationSelectedHandler(event:Event):void{
            if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_LOGIN) {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_LOGIN);
            } else {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_NOTIFICATIONS);
            }

        }
        private function tuningsListScreenFriendsSelectedHandler(event:Event):void{
            sendNotification(Notifications.DISPLAY_FRIENDS_LIST_SCREEN, null);
        }
        private function tuningsListScreenTimelineSelectedHandler(event:Event):void{
            if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_LOGIN) {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_LOGIN);
            } else {
                userAuthenticate(BrandsScreenMediator.AUTH_ACTION_TIMELINE);
            }

        }

		private function tuningsListScreenVotesSelectedHandler(event:Event):void{
			sendNotification(Notifications.DISPLAY_VOTES_LIST_SCREEN, null);
		}

		private function tuningsListScreenLanguageChangedHandler(event:Event):void{
			
			var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
			languagesProxy.loadLanguage(tuningsListScreen.selectedLanguage);
		}
		
		protected function tuningsListScreenTuningDeleteHandler(event:Event):void{
			alertView = AlertView.show(AlertView.language.translate("mob_downloads", "deleting"), -1);
			var tuningsProxy : TuningsProxy = facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
			if(event.data && event.data.deleteFrame) {
                var index:int = tuningsListScreen.selectedTuningFrameIndex;
                tuningsProxy.deleteTuningFrame(tuningsListScreen.getSelectedTuning(), index);
            }else{
                tuningsProxy.deleteTuning(tuningsListScreen.getSelectedTuning());
			}
		}

        public function loadCurrentUserTunings():void{
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            var currentUser:User = usersProxy.currentUser;
			if(currentUser) {
				loadUserTunings(currentUser.id);
            }
        }

		public function loadSelectedUserTunings():void{
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            var currentUser:User = Constants.selectedUser||usersProxy.currentUser;
			if(currentUser) {
				loadUserTunings(currentUser.id);
            }
        }

		public function loadUserTunings(userId:String):void{
            var challengesProxy : ChallengesProxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
			if(userId) {
                challengesProxy.loadUserChallenges(userId, false);
            }
        }

		protected function tuningsListScreenTuningShareHandler(event:Event):void{
            //trace(this+"->tuningsListScreenTuningShareHandler("+tuningsListScreen.selectedSocial+")");
            if(tuningsListScreen.selectedSocial=="timeline"){
                AlertView.show('Are you sure you want to share this tuning on 3DTuning\' feed', -1, false, function (yesSelected:Boolean):void {
                    if (yesSelected) {
                        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
                        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                        timelineProxy.newPost('', usersProxy.currentUser, [{url: tuningsListScreen.getVisibleTuningURL()}]);
                    }
                });
            }

			if(tuningsListScreen.selectedSocial=="fb"){
				SharingProxy.TUNING_FOR_SHARE = tuningsListScreen.selectedTuning;
                var userProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
                SharingProxy.generateURLForFbShare(userProxy.currentUser, settingsProxy.currentSettings.selectedLanguageCode)
			}else if(tuningsListScreen.selectedSocial=="vk"){
				
				var sharingVkProxy : SharingVkProxy = facade.retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
				sharingVkProxy.prepare();
			}else if(tuningsListScreen.selectedSocial=="instagram"){
				var sharingInstagramProxy : SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
				sharingInstagramProxy.prepare();
			}else if(tuningsListScreen.selectedSocial=="tw"){
				
				AlertView.show("Нет твитер шаринга",5);
			}
		}



        protected function tuningsListScreenCarSelectedHandler(event : Event) : void
        {

			var selectedTuning : Tuning = tuningsListScreen.selectedTuning;
			var info : Object = {
				car : selectedTuning.car
			};
            var userProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			if(event.data && event.data.isEditing && userProxy.currentUser) {
                if (selectedTuning.tuningUserID == userProxy.currentUser.id || (selectedTuning.userObj && selectedTuning.userObj._id == userProxy.currentUser.id)) {
                    info["tuning"] = selectedTuning;
                }
            }

			tuningsListScreen.cleanupMemory();
			
			var partSlot:PartSlot = new PartSlot(tuningsListScreen.selectedTuning.car);
			var partCarSplash:Part = new Part(partSlot);
			var partMaterial:PartMaterial = new PartMaterial(partCarSplash);
			var randomSplashUrl:String = RandomSplashManager.getRandomUrl();
			
			trace("randomSplashUrl:", randomSplashUrl);
			
			var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
			carSplashImageProvider.frameIndex = 0;
			carSplashImageProvider.angleIndex = 0;
			carSplashImageProvider.isEncrypted = false;
			
			
			var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
			carSplashImage.overrideDispose = true;
			carSplashImage.snapToPixels = false;
			if(Constants.TOTAL_MEMORY<1024 && Constants.SCALE_FACTOR<2){
				carSplashImage.bitmapScale = 0.5;
			}

			carSplashImage.visible = false;
			tuningsListScreen.stage.addChild(carSplashImage);
			
			carSplashImage.completeHandler = function(image:ImageLoaderWithStates):void{
				
				info.carSplashImage=carSplashImage;
				sendNotification(Notifications.DISPLAY_TUNING_SCREEN, info);
				setTimeout(function() : void{
					tuningsListScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);
				},500);
			};
			
			
			carSplashImage.scaleMode =	ScaleMode.NONE;
			carSplashImage.persistentImageProvider = carSplashImageProvider;	
        }

        private function tuningScreenUpdatedFeedHandller(event:Event):void
        {
            if(_isFeedUpdating) return;
            _isFeedUpdating = true;
        }

        private function tuningScreenSocialSelectedHandler(event:Event):void
        {
            //trace("TuningsListScreen.GET_SOCIAL_DATA:",tuningsListScreen.selectedTuningID);
            (facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy).loadComments(tuningsListScreen.selectedTuningID);
            //(facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy).loadLikes(tuningsListScreen.selectedTuningID);
        }

		private function handleChallengeRequest(event:Event):void {
            var userProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			if(userProxy.currentUser) {
                sendNotification(Notifications.DISPLAY_START_CHALLENGE_POPUP, event.data);
            }else{
				userAuthenticate(event.data);
			}
        }

		protected function tuningsListScreenInitializeStageHandler(event:Event):void{
            (facade.retrieveProxy(BrandsProxy.NAME) as BrandsProxy).loadAllBrands(function () : void {
                var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
                languagesProxy.loadLanguages();

                var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
                var languageToLoad : Language = new Language(null);
                languageToLoad.code = settingsProxy.currentSettings.selectedLanguageCode;
                languagesProxy.loadLanguage(languageToLoad);

                alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
				var user:User = Constants.selectedUser;
                (facade.retrieveProxy(CarBackgroundsProxy.NAME) as CarBackgroundsProxy).loadBackgrounds(user?user.id:getNeededUser(), true, "all", null, true);
            });
		}

		protected function tuningsListScreenTuningSelectedHandler(event : Event) : void
		{
			var selectedTuning : Tuning = tuningsListScreen.selectedTuning;
			var info : Object = {
					car : selectedTuning.car,
					tuning: selectedTuning
			};
			
			tuningsListScreen.cleanupMemory();
			
			var partSlot:PartSlot = new PartSlot(selectedTuning.car);
			var partCarSplash:Part = new Part(partSlot);
			var partMaterial:PartMaterial = new PartMaterial(partCarSplash);
			var randomSplashUrl:String = RandomSplashManager.getRandomUrl();
			
			trace("randomSplashUrl:", randomSplashUrl);
			
			var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
			carSplashImageProvider.frameIndex = 0;
			carSplashImageProvider.angleIndex = 0;
			carSplashImageProvider.isEncrypted = false;
			
			
			var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
			carSplashImage.overrideDispose = true;
			carSplashImage.snapToPixels = false;
			if(Constants.TOTAL_MEMORY<1024 && Constants.SCALE_FACTOR<2){
				carSplashImage.bitmapScale = 0.5;
			}
			
			carSplashImage.visible = false;
			

			tuningsListScreen.stage.addChild(carSplashImage);
			
			
			
			
			carSplashImage.completeHandler = function(image:ImageLoaderWithStates):void{
				
				info.carSplashImage=carSplashImage;
				
				sendNotification(Notifications.DISPLAY_TUNING_SCREEN, info);

				setTimeout(function():void{
					tuningsListScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);
				},500);
				
			};
			
			
			carSplashImage.scaleMode =	ScaleMode.NONE;
			carSplashImage.persistentImageProvider = carSplashImageProvider;	
			//});
			
			//tuningsListScreen.unselectSelectedTunning();
		}
		
		protected function tuningsListScreenHomeSelectedHandler(event:Event):void{
			
			sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
		}

		protected function tuningsListScreenBrandsSelectedHandler(event:Event):void{
            if(HomeScreenPopUpMediator.isFirstOpen) {
                sendNotification(Notifications.DISPLAY_BRANDS_SCREEN);
            } else {
                sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
            }
            HomeScreenPopUpMediator.isFirstOpen = false;
		}

        public function get tuningsListScreen() : TuningsListScreen
		{
			return viewComponent as TuningsListScreen;
		}
		
		override public function listNotificationInterests() : Array
		{
            return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
				Notifications.TUNINGS_LOADED,
				Notifications.TUNING_LOADED,
				Notifications.TUNINGS_LOADING_FAILED,
				Notifications.TUNING_DELETED,
				Notifications.TUNING_FRAME_DELETED,
				Notifications.TUNING_DELETION_FAILED,
				Notifications.TUNING_SAVED,
				Notifications.TUNING_REFRESH,
				Notifications.APPLICATION_BECAME_ACTIVE,
				Notifications.TUNING_SHARING_MESSAGE_ENTERED,
				Notifications.SHARING_READY,
				Notifications.SHARING_PREPARING_ERROR,
				Notifications.SHARING_PHOTO_UPLOADED,
				Notifications.SHARING_PHOTO_UPLOADING_ERROR,
				Notifications.CAR_BACKGROUNDS_LOADED,
				Notifications.CAR_BACKGROUNDS_LOADING_FAILED,
				Notifications.PENDING_FRIENDS_LOADED,
				///////////////////////
				Notifications.LANGUAGES_LOADED,
				Notifications.LANGUAGES_LOADING_FAILED,
				Notifications.LANGUAGE_LOADED,
				Notifications.LANGUAGE_LOADING_FAILED,
				Notifications.USER_LOGGED_OUT,
				Notifications.USER_SESSION_EXTENDED,
				Notifications.USER_SESSION_EXTENDING_FAILED,
				Notifications.USER_SESSION_EXTENDING_NOT_POSSIBLE,
                Notifications.USER_AUTHENTICATED,

                Notifications.TUNING_FEED_DATA_LOADED,
                Notifications.TUNING_FEED_DATA_LOAD_FAILURE,
                Notifications.TIMELINE_POST_ADDED,

                Notifications.TIMELINE_SCREEN_FEED_PREVIEW,
                Notifications.CHALLENGE_NOTIFICATIONS_VIEWED,

				Notifications.CHALLENGES_LOADED,
				Notifications.CREATE_RANDOM_CHALLENGE

			]);
		}
		
		private function handleTuningDeletionFailed() : void {
			alertView.hide();
		}

		override public function handleNotification(note : INotification) : void {
			switch(note.getName()) {
                case Notifications.TUNING_LIKES_LOADED:
                    handleLikesDataLoaded(note.getBody());
                    break;
				case Notifications.TIMELINE_SCREEN_FEED_PREVIEW:
                    handleDisplayTimelineScreenFeed(note.getBody());
                    break;
                case Notifications.TUNING_LIKES_LOAD_FAILED:
                    handleLikesDataLoadFailed();
                    break;
                case Notifications.TUNING_COMMENTS_LOADED:
                    handleCommentDataLoaded(note.getBody());
                    break;
                case Notifications.TUNING_COMMENTS_LOAD_FAILED:
                    handleCommentDataLoadFailed();
                    break;
                case Notifications.TUNING_FEED_DATA_LOADED:
                    handleFeedDataLoaded(note.getBody().feed as Array);
                    break;
                case Notifications.TUNING_FEED_DATA_LOAD_FAILURE:
                    handleFeedDataLoadedFailed();
                    break;
                case Notifications.TIMELINE_POST_ADDED:
                    handleTuningSharedToTimeline();
                    break;
				case Notifications.TUNINGS_LOADED:
					handleTuningsLoaded(note.getBody());
					break;
                case Notifications.TUNING_LOADED:
                    handleTuningLoaded(note.getBody() as Tuning);
                    break;

                case Notifications.TUNINGS_LOADING_FAILED:
					handleTunningsLoadingFailed();
					break;

				case Notifications.TUNING_DELETED:
					handleTuningDeleted();
					break;

                case Notifications.TUNING_FRAME_DELETED:
					handleTuningFrameDeleted();
					break;

				case Notifications.TUNING_DELETION_FAILED:
					handleTuningDeletionFailed();
					break;

				case Notifications.TUNING_SAVED:
					handleTuningSaved();
					break;
				case Notifications.TUNING_REFRESH:
					handleTuningRefresh(note.getBody() as Tuning);
					break;
				case Notifications.APPLICATION_BECAME_ACTIVE:{

					handleApplicationBecameActive();
				}
					break;

				case Notifications.SHARING_READY:
					handleSharingReady(note.getBody() as String);
					break;
				case Notifications.SHARING_PREPARING_ERROR:
					handleSharingPreparingError(note.getBody() as String);
					break;

				case Notifications.SHARING_PHOTO_UPLOADED:
					handleSharingPhotoUploaded();
					break;

				case Notifications.SHARING_PHOTO_UPLOADING_ERROR:
					handleSharingPhotoUploadingError();
					break;

				case Notifications.TUNING_SHARING_MESSAGE_ENTERED:
					handleTuningSharingMessageEntered(note.getBody() as String);
					break;

				case Notifications.CAR_BACKGROUNDS_LOADED:
					handleCarBackgroundsLoaded(note.getBody() as Array);
					break;

				case Notifications.CAR_BACKGROUNDS_LOADING_FAILED:
					handleCarBackgroundLoadingFailed();
					break;

				///////////////////////////
				case Notifications.LANGUAGES_LOADED:
					handleLanguagesLoaded();
					break;

				case Notifications.LANGUAGES_LOADING_FAILED:
					handleLanguagesLoadingFailed();
					break;

				case Notifications.LANGUAGE_LOADED:
					handleLanguageLoaded(note.getBody().language);
					break;

				case Notifications.LANGUAGE_LOADING_FAILED:
					handleLanguageLoadingFailed();
					break;

				case Notifications.USER_LOGGED_OUT:
					handleUserLoggedOut();
					break;

				case Notifications.USER_SESSION_EXTENDED:
					handleUserSessionExtented();
					break;

				case Notifications.USER_SESSION_EXTENDING_FAILED:
					handleUserSessionExtendingFailed();
					break;

				case Notifications.USER_SESSION_EXTENDING_NOT_POSSIBLE:
					handleUserSessionExtendingNotPossible();
					break;
                case Notifications.PENDING_FRIENDS_LOADED:
                    handlePendingFriendsLoaded(note.getBody());
                    updateNotifications();
                    break;
                case Notifications.CHALLENGE_NOTIFICATIONS_VIEWED:
                    handleChallengeNotificationsClean();
                    break;

                case Notifications.CHALLENGES_LOADED:
                    handleChallengesLoaded(note.getBody());
                    break;

                case Notifications.USER_AUTHENTICATED:
                    handleUserAuthenticated();
                    break;

				case Notifications.CREATE_RANDOM_CHALLENGE:
					handleCreateNewChallenge(note.getBody());
					break;


				//////////////////////////////
			}

			super.handleNotification(note);
		}

        private function handleDisplayTimelineScreenFeed(data:Object):void {
			sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
        }

		private function handleCreateNewChallenge(data: Object): void {

			var proxy:ChallengesProxy  = ApplicationFacade.getInstance().retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            proxy.checkTuningInChallenge(data.tuning, function (status: Boolean): void {
				tuningsListScreen.setTuningIsChallenge(data.tuning, status);
				tuningsListScreen.updateChallengeStatus(data.tuning, status);
            })

		}

		/////////////////////////////
		private function handleUserSessionExtendingNotPossible() : void
		{
			/*	var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.logoutCurrentUser();
			sendNotification(Notifications.DISPLAY_LOGIN_SCREEN);*/
		}

        private function handleUserAuthenticated():void {
			if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_NOTIFICATIONS){
                sendNotification(Notifications.DISPLAY_IN_APP_NOTIFICATION_POPUP);
			}else if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_CHALLENGE_NOTIFICATIONS){
                sendNotification(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP);
			}else if(tuningsListScreen.mainMenuView.pendingForAuthAction == BrandsScreenMediator.AUTH_ACTION_TIMELINE){
                Starling.juggler.delayCall(function():void{
                    sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, null);
				}, .3);
			}else if(_startChallengeData) {
                sendNotification(Notifications.DISPLAY_START_CHALLENGE_POPUP, _startChallengeData);
                _startChallengeData = null;
            }else if(pendingForAuthAction == StackedScreenExtendedMediator.AUTH_ACTION_MAILS){
				Starling.juggler.delayCall(function():void{
					sendNotification(Notifications.DISPLAY_MAIL_SCREEN);
				}, .3);
			}
			tuningsListScreen.requireLogin = false;
        }

        private function userAuthenticate(data:Object):void {
            _startChallengeData = data;
            var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            if (!usersProxy.currentUser) {
				_garage_delay = 1.5;
            } else {
				_garage_delay = 0.2;
            }
            ImageLoaderWithStates.disposeWhenRemovedFromStage = false;
            sendNotification(Notifications.AUTHENTICATE_USER);
        }

        private function handleChallengeNotificationsClean(): void {
			Constants.UNREAD_CHALLENGE_NOTIFICATIONS = 0;
            Constants.updateNotificationCount();
            if(tuningsListScreen.mainMenuView){
                tuningsListScreen.mainMenuView.challengeNotesButton.noteCount = 0;
			}
        }

        private function handleChallengesLoaded(body:Object):void {
            var result:Array = [];
            var challenges:Array = body.challenges as Array;
            for(var i:int = 0; i < challenges.length; i++){
                if(challenges[i].owner.user == body.user){
                    result.push(challenges[i].owner.tuning);
                }else if(challenges[i].receiver.user == body.user){
                    result.push(challenges[i].receiver.tuning);
                }
            }
            tuningsListScreen.appendChallenges(result);
        }

		private function handleUserSessionExtented() : void
		{

		}
		
		private function handleUserSessionExtendingFailed() : void
		{
			
		}

        private function handlePendingFriendsLoaded(friends: Object): void {
            //if(tuningsListScreen.stage)
				tuningsListScreen.dispatchEventWith(FriendsListPopUp.PENDING_FRIENDS_READ, false, friends);
        }
			
		private function handleUserLoggedOut() : void
		{
			//tuningsListScreen.userSignedIn = false;
			sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
            /*sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
            updateNotifications();*/
		}
				
		private function handleLanguageLoadingFailed() : void
		{
			
		}
		
		private function handleLanguagesLoadingFailed() : void
		{
			tuningsListScreen.selectedLanguage = null;
		}
		
		private function handleLanguageLoaded(loadedLanguage : Language) : void
		{
			if(tuningsListScreen)
			{
				tuningsListScreen.updateWithLanguage(loadedLanguage);
		
				updateSettings();
				
				sendNotification(Notifications.LANGUAGE_CHANGED);
			}
		}

        private function updateNotifications():void{
			trace("TuningsList#updateNotifications");
            (facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy).loadUnreadNotification(function (obj:Object) : void {
                tuningsListScreen.updateNotifications();
            });
        }
		
		private function handleLanguagesLoaded():void{
			
			Starling.juggler.delayCall(refreshSettings, 1.5);
		}

		private function refreshSettings() : void 
		{
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
			var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
			var settings : Settings = settingsProxy.currentSettings;
			
			if(!settings.selectedLanguageCode)
			{
				settings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
			}
			
			tuningsListScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
			
			if(!tuningsListScreen.selectedLanguage){
			
				settings.selectedLanguageCode="en-US";
				tuningsListScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
			}
			
			tuningsListScreen.languages = languagesProxy.languages;
			
			if(tuningsListScreen.languages!=null && tuningsListScreen.languages.length<=0){
				languagesProxy.loadLanguages();
			}else if (tuningsListScreen.languages==null){
				languagesProxy.loadLanguages();
		}
		}
		//////////////////////////////////

		private function handleCarBackgroundsLoaded(carBackgrounds : Array) : void {
			trace("handleCarBackgroundsLoaded");
			var background:CarBackground;
			_backgroundsMap={};
			for(var i:int=0; i<carBackgrounds.length; i++){
			
				background=carBackgrounds[i];
				
				_backgroundsMap[background.id]=background;
			}
			
			
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			var tuningsProxy : TuningsProxy = facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
            tuningsProxy.
			loadTunings(Constants.selectedUser ? Constants.selectedUser : usersProxy.currentUser, 0, tuningsListScreen.sortBy, tuningsListScreen.period);

		}


		private function handleCarBackgroundLoadingFailed() : void
		{
			//alertView.hide();
			
			trace("handleCarBackgroundLoadingFailed")
			
			Starling.juggler.delayCall(function():void{
				
				//(facade.retrieveProxy(CarBackgroundsProxy.NAME) as CarBackgroundsProxy).loadBackgrounds(getNeededUser());
				
				var carBackgroundsProxy : CarBackgroundsProxy = facade.retrieveProxy(CarBackgroundsProxy.NAME) as CarBackgroundsProxy;
				if(carBackgroundsProxy.CarBackgrounds!=null && carBackgroundsProxy.CarBackgrounds.length>0){
					
					handleCarBackgroundsLoaded(carBackgroundsProxy.CarBackgrounds);
					
				}else{
					carBackgroundsProxy.loadBackgrounds(getNeededUser(), false, "", null, true);
				}
				
				//alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
			
			
			}, 0.2);
		}

		private function getNeededUser() : String
		{
			var userID : String = null;

			if(facade.retrieveProxy(UsersProxy.NAME) as UsersProxy){
				userID = (facade.retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser.id;
			}

			return userID;
		}

		private function handleSharingReady(__title : String) : void
		{
			trace("handleSharingReady:", __title);
			
			//var userProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			
			var tuning:Tuning = tuningsListScreen.getSelectedTuning();
			
			var usernameStr:String = tuning.userObj.username; //userProxy.currentUser.username.toLowerCase();
			var shortId:String = tuning.shortId;
			
				
			
			
			
			var link:String="";
			
			try{
				link = tuning.car.getSiteLinkGrage(usernameStr, shortId);
			}catch(e:Error){
				trace("error:", e.getStackTrace());
			}
			//this.tuningsListScreen.
			
			//tuningDetailsScreen.closeMenu(true);
			sendNotification(Notifications.DISPLAY_TUNING_SHARING_POP_UP,{title : __title, siteLink:link});
		}

		private function handleSharingPreparingError(error : String) : void
		{
			AlertView.show(error, -1, false);
		}
		
		private function handleSharingPhotoUploaded() : void
		{
			alertView.hide();
			AlertView.show(AlertView.language.translate("mob_saving", "done"));
			tuningsListScreen.hideLoader();
		}
					
		private function handleSharingPhotoUploadingError() : void
		{
			alertView.hide();

			AlertView.show(AlertView.language.translate("mob_saving", "uploadingFailed"));
		}
		
		private function handleTuningSharingMessageEntered(message : String) : void {

				Starling.juggler.delayCall(function ():void {
					//tuningDetailsScreen.enableButtons(false);

					tuningsListScreen.beginScreenShot(function ():void {
						var bitmapData:BitmapData = Starling.current.stage.drawToBitmapData();
						if (tuningsListScreen.selectedSocial == "vk") {
							var sharingVkProxy:SharingVkProxy = facade.retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
							sharingVkProxy.sharePhoto(message, bitmapData);
						} else if (tuningsListScreen.selectedSocial == "instagram") {
							var sharingInstagramProxy:SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;
							sharingInstagramProxy.sharePhoto(message, bitmapData);
						} else if (tuningsListScreen.selectedSocial == "tw") {
							AlertView.show("Нет шаринга в твитер");
						}


						bitmapData.dispose();

						//alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "uploading"));

						Starling.juggler.delayCall(function ():void {
							tuningsListScreen.endScreenShot();
						}, 0.2);
					});
				}, 0.4);

		}

		private function handleApplicationBecameActive() : void
		{
			if(Device.isIos())
				return;
			
			
			if(this.tuningsListScreen){
				
				tuningsListScreen.invalidate();
			}
		}

		protected override function stackedScreenBackButtonSelectedHandler(event : Event) : void
		{

			super.stackedScreenBackButtonSelectedHandler(event);
		}
        private function handleLikesDataLoaded(info:Object):void
        {
            if(alertView) alertView.hide();
        }

        private function handleLikesDataLoadFailed():void {
            if(alertView) alertView.hide();
        }

        private function handleCommentDataLoaded(info:Object):void
        {
            tuningsListScreen.comments = info.comments;
            if(alertView) alertView.hide();
        }

        private function handleCommentDataLoadFailed():void {
            if(alertView) alertView.hide();
        }

        private function handleFeedDataLoaded(timeline:Array):void {

            _updateTimer.stop();
            _updateTimer.reset();
            _updateTimer.start();

            if(alertView)
            {
                alertView.hide();
                alertView =null;

            }
            //galleryScreen.feed = timeline;
            _isFeedUpdating = false;
        }

        private function handleFeedDataLoadedFailed():void
        {
            if(alertView) {
                alertView.hide();
                alertView =null;
            }

            _updateTimer.stop();
            _updateTimer.reset();
            _updateTimer.start();
        }

        private function handleTuningSharedToTimeline():void {
            AlertView.show('Tuning share completed',2);
            Starling.juggler.delayCall(function () : void {
                sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, null);
            }, 1)
        }

		private function handleTuningsLoaded(tunningsInfo : Object) : void
		{
			trace("handleTuningsLoaded");
			var tunings:Array=tunningsInfo.tunnings;
			var tuning:Tuning;
			tuningsListScreen.tuningsIsLoading = false;
			for(var i:int=0; i<tunings.length; i++){
				tuning=tunings[i];
				tuning.backgroundsMap=_backgroundsMap;
				tuning.isChallenging = (tuningsListScreen.challengesList && tuningsListScreen.challengesList[tuning.id]);
			}

			if(tuningsListScreen.tuningsListCollection.length === 0) {
				tuningsListScreen.tuningsListCollection = new ListCollection(tunningsInfo.tunnings);//addTunings(tunningsInfo.tunnings);
			} else {
				tuningsListScreen.tuningsListCollection.addAll(new ListCollection(tunningsInfo.tunnings));
			}

			if(alertView) {
				alertView.hide();
			}
			tuningsListScreen.showNoTuningsMessage(tuningsListScreen.tuningsListCollection.length == 0 );
		}
		
		private var _timerID:int=0;
        private var _tuningToUpdate:Tuning;
		
		private function handleTunningsLoadingFailed() : void
		{
			tuningsListScreen.tuningsIsLoading = false;
			if(_isRemove) return;
			
			trace("handleTunningsLoadingFailed");
			
			if(alertView) {
				alertView.hide();
			}
			
			alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "Could not load. Repeat for 1 second"), 1);


			
			
			_timerID = setTimeout(function():void{
				tuningsListScreen.tuningsIsLoading = true;
				if(alertView) {
					alertView.hide();
				}
				
				alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
				
				
				var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
				var tuningsProxy : TuningsProxy = facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
				//trace("handleCarBackgroundsLoaded:",Constants.selectedUser.id);
				tuningsProxy.loadTunings(Constants.selectedUser ? Constants.selectedUser : usersProxy.currentUser, 0, tuningsListScreen.sortBy, tuningsListScreen.period);
				
			},1000)
		}

		private function handleTuningDeleted() : void {
			if(alertView) {
				alertView.hide();
			}
			
			this.tuningsListScreen.removeTuning();
		}

        private function handleTuningFrameDeleted() : void {
			if(alertView) {
				alertView.hide();
			}
			tuningsListScreen.updateTuning();
		}

		private function handleTuningLoaded(tuning : Tuning)  : void {
			if(!tuning){
                tuningsListScreen.tuningsListCollection.updateAll();
				return;
			}
			if (alertView) {
				alertView.hide();
			}
			if(!_tuningToUpdate){
				return;
			}
			_tuningToUpdate.snapshots = tuning.snapshots;
			_tuningToUpdate.customSnapshotsBackgrounds = tuning.customSnapshotsBackgrounds;
			if (tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds[0]) {
				_tuningToUpdate.backgroundId = tuning.customSnapshotsBackgrounds[0];
			}

			_tuningToUpdate.imageURL = tuning.snapshots[0];

			if (tuning.customSnapshotsBackgrounds) {
				for (var i: Number = 0; i < tuning.customSnapshotsBackgrounds.length;  i++ ) {
					var newBg: CarBackground = new  CarBackground();
					newBg.id = tuning.customSnapshotsBackgrounds[i];
					newBg.imagePathSecondCam = null;
					newBg.isCustom = true;
					newBg.isLocalFile = false;
					newBg.mainUrl = tuning.customSnapshotsBackgrounds[i];
					newBg.selectedCamera = 0;
					newBg.showThumbnailUrl = false;
					newBg.brightness = 1;
					newBg.isDefault = false;
					newBg.isEncrypted = false;
					_tuningToUpdate.backgroundsMap[tuning.customSnapshotsBackgrounds[i]] = newBg;
				}

			}


			tuningsListScreen.tuningsListCollection.updateAll();
        }


		private function handleTuningRefresh(tuning : Tuning)  : void {
			_tuningToUpdate = tuning;
            alertView = AlertView.show(AlertView.language.translate("mob_downloads", "loading"), -1);

            var tuningsProxy : TuningsProxy = facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
            tuningsProxy.getTuning(tuning.shortId);
        }

		private function handleTuningSaved()  : void {
			refresh();
		}
		
		private function refresh() : void
		{

		}


		private function updateSettings() : void
		{
			var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
			var settings : Settings = settingsProxy.currentSettings;
			
			//settings.autoscrollEnabled = brandsScreen.autoscrollEnabled;
			
			if(tuningsListScreen.selectedLanguage) {
				settings.selectedLanguageCode = tuningsListScreen.selectedLanguage.code;
			}
			
			settingsProxy.update(settings);
			
			//if(alertView) alertView.hide();
		}
	}
}