package com.despark.tuning3d.view
{
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.controller.StartupCommand;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.parts.PartSlotsProxy;
import com.despark.tuning3d.view.components.auth.LoginScreen;
import com.despark.tuning3d.view.components.brands.PartInfoPopUp;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.core.StackedScreen;
import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
import com.despark.tuning3d.view.components.core.Window;
import com.despark.tuning3d.view.core.MediatorUtil;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.despark.tuning3d.view.core.StackedScreenMediator;
import com.greensock.TweenMax;

import feathers.core.FeathersControl;
import feathers.core.PopUpManager;
import feathers.layout.HorizontalAlign;

import flash.desktop.NativeApplication;
import flash.desktop.SystemIdleMode;
import flash.display.StageAspectRatio;
import flash.events.Event;
import flash.utils.clearTimeout;
import flash.utils.setTimeout;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.mediator.Mediator;

import starling.animation.Transitions;
import starling.core.Starling;
import starling.events.Event;
import starling.utils.AssetManager;

public class WindowMediator extends Mediator
	{
		public static const NAME : String = "WindowMediator";
		
		public var starlingObj : Starling;
		public var assetManager : AssetManager;
		public var httpClient : HttpClient;
		public var animate:Boolean = true;
		
		private var stackedScreenMediator : StackedScreenMediator;
		private var popUpMediator : PopUpMediator;
		private var lastPopUp : FeathersControl;
		
		private var isDiactivated:Boolean = false;
		private var diactivatedTimerId:int=0;
		private static const TRANSITION_DURATION:Number = 0.35;

		public function WindowMediator(viewComponent : Object)
		{
			super(NAME, viewComponent);
			
			/*PopUpManager.overlayFactory = function() : DisplayObject
			{
				var q :Quad = new Quad(1, 1, 0x000000);
				q.alpha = 0.2;
				return q;     
			}*/
		}
		
		public function get window() : Window
		{
			return viewComponent as Window;
		}
		
		override public function onRegister() : void 
		{
			NativeApplication.nativeApplication.addEventListener(flash.events.Event.ACTIVATE, nativeApplicationActivateHandler);
			NativeApplication.nativeApplication.addEventListener(flash.events.Event.DEACTIVATE, nativeApplicationDeactivateHandler);
			
			window.screenNavigator.addEventListener(StackedScreenNavigator.SCREEN_PUSHED, screenNavigatiorScreenPushedHandler);
			window.screenNavigator.addEventListener(StackedScreenNavigator.SCREEN_POPPED, screenNavigatiorScreenPoppedHandler);
		}
		
		override public function onRemove() : void 
		{
			NativeApplication.nativeApplication.removeEventListener(flash.events.Event.ACTIVATE, nativeApplicationActivateHandler);
			NativeApplication.nativeApplication.removeEventListener(flash.events.Event.DEACTIVATE, nativeApplicationDeactivateHandler);
			
			window.screenNavigator.removeEventListener(StackedScreenNavigator.SCREEN_PUSHED, screenNavigatiorScreenPushedHandler);
			window.screenNavigator.removeEventListener(StackedScreenNavigator.SCREEN_POPPED, screenNavigatiorScreenPoppedHandler);
		}
		
		override public function listNotificationInterests() : Array 
		{
			return [
				Notifications.ASSETS_LOADED,
				Notifications.CANCEL_ALL_HTTP_REQUESTS,
				Notifications.USER_LOGGED_IN
			];
		}
		
		
		private function onContext3dCreate(event:starling.events.Event):void{
			
			starlingObj.removeEventListener(starling.events.Event.CONTEXT3D_CREATE, onContext3dCreate);
			
			
			
			if(!Device.isIos()){   
				
			}
			
		
		}
		
		private function onAssetManagerEventTexturesRestored(event:starling.events.Event):void{

            if(starlingObj.contextValid){
                var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.assetManager.removeEventListener(starling.events.Event.TEXTURES_RESTORED, onAssetManagerEventTexturesRestored);

                // var t:Tween.

                if(!Device.isIos()){
                    setTimeout(function():void{

                        if(StartupCommand.splashLogo){
                            TweenMax.to(StartupCommand.splashLogo,1, {alpha:0, onComplete:function():void{

                                    StartupCommand.splashLogo.showSpinner();
                                    StartupCommand.splashLogo.visible=false;

                                    if(!Device.isIos()){

                                        try{
                                            if(PartInfoPopUp.WEBVIEW){

                                                PartInfoPopUp.WEBVIEW.visible=true;
                                            }
                                        }
                                        catch(e:Error){


                                        }

                                    }
                                }
							});
                        }

                    }, 2000);
                }
            }
        }
		
		private var timeoutId:uint=0;
		
		private var timeoutId2:uint=0;
		private function nativeApplicationActivateHandler(event : flash.events.Event) : void 
		{

			trace("nativeApplicationActivateHandler");

			
			var st:Starling=starlingObj;
			if(starlingObj)
			{
				trace("nativeStage.autoOrients:", starlingObj.nativeStage.autoOrients);
				trace("nativeStage.orientation:", starlingObj.nativeStage.orientation);
				
				trace("nativeStage.width:", starlingObj.nativeStage.stageWidth);
				trace("nativeStage.height:", starlingObj.nativeStage.stageHeight);
				if(Device.isIos()){
				
					starlingObj.nativeStage.autoOrients = true;
					starlingObj.nativeStage.setAspectRatio(StageAspectRatio.LANDSCAPE);
					//starlingObj.nativeStage.setOrientation(StageOrientation.DEFAULT);
				}
				
				if(!Device.isIos() && !starlingObj.contextValid){
					st.addEventListener(starling.events.Event.CONTEXT3D_CREATE, context3dCreate);
				}
				
				
				starlingObj.start();
				
				trace("starlingObj.stage.width:", starlingObj.stage.width);
				trace("starlingObj.stage.height:", starlingObj.stage.height);
				
				
				if(!Device.isIos()){
					if(starlingObj.contextValid &&  st.isStarted){
						
						
						
						timeoutId=setTimeout(function():void{
							
							
							
							if(StartupCommand.splashLogo){
								TweenMax.to(StartupCommand.splashLogo,1, {alpha:0, onComplete:function():void{
									StartupCommand.splashLogo.showSpinner();
									StartupCommand.splashLogo.visible=false;        
									//trace("UPSSS!!!")
									
									if(!Device.isIos()){
										
										try{
											if(PartInfoPopUp.WEBVIEW){
												
												PartInfoPopUp.WEBVIEW.visible=true;
											}
										}
										catch(e:Error){
											
											
										}
										
									}
								}});    
							}
							
						}, 2000);    
					}
				}  

				NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.KEEP_AWAKE;
			}
			sendNotification(Notifications.APPLICATION_BECAME_ACTIVE);
		}
		

		private function context3dCreate(event:starling.events.Event):void{
			trace("context3dCreate");
			if(!Device.isIos()){
				StartupCommand.splashLogo.alpha=1;
				StartupCommand.splashLogo.showSpinner();   
				StartupCommand.splashLogo.visible=true;   
			}
			
			if(timeoutId2!=0){
				clearTimeout(timeoutId);
				timeoutId=0;  
			}
			
			starlingObj.removeEventListener(starling.events.Event.CONTEXT3D_CREATE, context3dCreate);
			if(timeoutId!=0){
				
				clearTimeout(timeoutId);
				timeoutId=0;  
			}
			
			var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
			assetsProxy.assetManager.addEventListener(starling.events.Event.TEXTURES_RESTORED, onAssetManagerEventTexturesRestored);
			
			
		}
		
		private function deactivate():void{
			diactivatedTimerId = 0;
			if(starlingObj) {
				trace("Starling stop");
				starlingObj.stop(!Device.isIos()); //true
			}
			
			if(!Device.isIos()){
				if(PartInfoPopUp.WEBVIEW){
					PartInfoPopUp.WEBVIEW.visible=false;
				}
			}
			
			var partSlotsProxy : PartSlotsProxy = facade.retrieveProxy(PartSlotsProxy.NAME) as PartSlotsProxy;
			NativeApplication.nativeApplication.executeInBackground = partSlotsProxy.isDownloading;
			NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.NORMAL;
			
			sendNotification(Notifications.APPLICATION_WENT_BACKGROUND);
			
			if(!Device.isIos())
			isDiactivated = true;
		}
		
		private function nativeApplicationDeactivateHandler(event : flash.events.Event) : void {
			trace("nativeApplicationDeactivateHandler");
			if(!Device.isIos()){
				deactivate();
			}else{
				deactivate();
			}
			NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.NORMAL;
		}
		
		public function pushScreen(screen : StackedScreen, show : Boolean = true,deleteOthers : Boolean = true) : void {
			if(!window.screenNavigator.inTransition) {
				facade.registerMediator(MediatorUtil.mediatorForControl(screen));
				window.screenNavigator.pushScreen(screen, show, deleteOthers);
			}
		}
		
		public function popScreen() : void {
			window.screenNavigator.popScreen();
		}
		
		public function popToRootScreen(level : int = 0) : void {
			window.screenNavigator.popToRootScreen(level);
		}
		
		public function get stackSize() : int {
			return window.screenNavigator.stackSize;
		}
		
		private function screenNavigatiorScreenPushedHandler(event : starling.events.Event) : void {
			
		}
		
		private function screenNavigatiorScreenPoppedHandler(event : starling.events.Event) : void {
			var removedScreen : StackedScreen = event.data as StackedScreen;
			facade.removeMediator(removedScreen.screenName);
			
			removedScreen=null;
		}
		
		public function addPopUp(popUp : PopUp, hAlign:String = null, horizontalTransition:Boolean = false):void {
			lastPopUp = popUp;
            popUp.horizontalTransition = horizontalTransition;
			popUp.hAlign = hAlign;
			trace("Constants.STAGE_HEIGHT:", Constants.STAGE_HEIGHT, popUp.y);
			
			facade.registerMediator(MediatorUtil.mediatorForControl(popUp));
			PopUpManager.addPopUp(popUp);
			var centeredPopY : Number = 0;//popUp.y;
			popUp.y = Constants.STAGE_HEIGHT; //Starling.current.stage.stageHeight;
			var targetX:Number = popUp.x;
			if(popUp.hAlign){
				switch (popUp.hAlign){
					case HorizontalAlign.LEFT:
						popUp.x = -popUp.width;
                        targetX = 0;
						break;
					case HorizontalAlign.RIGHT:
						popUp.x = Constants.STAGE_WIDTH;
                        targetX = Constants.STAGE_WIDTH - popUp.width;
						break;

				}
			}
			if(animate) {
                if (horizontalTransition) {
                    popUp.y = centeredPopY;
                    Starling.juggler.tween(popUp, TRANSITION_DURATION, {
                        x: targetX,
                        transition: Transitions.EASE_IN_OUT
                    });
                    return;
                }
                Starling.juggler.tween(popUp, TRANSITION_DURATION, {
                    y: centeredPopY,
                    transition: Transitions.EASE_IN_OUT
                });
            }else{
				popUp.x = targetX;
				popUp.y = centeredPopY;
				animate = true;
			}
		}
		
		public function removePopUp(popUp : PopUp) : void {
			if(popUp.horizontalTransition){
				var targetX:Number;
				if(popUp.hAlign){
					if(popUp.hAlign == HorizontalAlign.LEFT){
						targetX = -popUp.width;
					}else{
						targetX = Constants.STAGE_WIDTH;
					}
				}
                Starling.juggler.tween(popUp, TRANSITION_DURATION, {
                    x: targetX,
                    transition: Transitions.EASE_IN_OUT,
                    onComplete: function() : void {
                        facade.removeMediator(popUp.popUpName);
                        if(PopUpManager.isPopUp(popUp)){
                            PopUpManager.removePopUp(popUp);
                        }
                        popUp.dispose();
                    }
                });
				return;
			}
			Starling.juggler.tween(popUp, TRANSITION_DURATION, {
				y: Constants.STAGE_HEIGHT,//Starling.current.stage.stageHeight, 
				transition: Transitions.EASE_IN_OUT,
				
				onComplete: function() : void {
					
					facade.removeMediator(popUp.popUpName);
					PopUpManager.removePopUp(popUp);
					popUp.dispose();
				}
			});
		}

        public function showPopUp(popUp : PopUp):void {
            lastPopUp = popUp;
            facade.registerMediator(MediatorUtil.mediatorForControl(popUp));
            PopUpManager.addPopUp(popUp);
            var centeredPopY : Number = 0;//popUp.y;
            popUp.y = Constants.STAGE_HEIGHT; //Starling.current.stage.stageHeight;
            var targetX:Number = popUp.x;
            if(popUp.hAlign){
                switch (popUp.hAlign){
                    case HorizontalAlign.LEFT:
                        popUp.x = -popUp.width;
                        targetX = 0;
                        break;
                    case HorizontalAlign.RIGHT:
                        popUp.x = Constants.STAGE_WIDTH;
                        targetX = Constants.STAGE_WIDTH - popUp.width;
                        break;

                }
            }
            if(popUp.horizontalTransition){
                popUp.y = centeredPopY;
                Starling.juggler.tween(popUp, TRANSITION_DURATION, {x: targetX, transition: Transitions.EASE_IN_OUT});
                return;
            }
            Starling.juggler.tween(popUp, TRANSITION_DURATION, {y: centeredPopY, transition: Transitions.EASE_IN_OUT});
        }

		public function hidePopUp(popUp : PopUp) : void {
			if(popUp.horizontalTransition){
				var targetX:Number;
				if(popUp.hAlign){
					if(popUp.hAlign == HorizontalAlign.LEFT){
						targetX = -popUp.width;
					}else{
						targetX = Constants.STAGE_WIDTH;
					}
				}
                Starling.juggler.tween(popUp, TRANSITION_DURATION, {
                    x: targetX,
                    transition: Transitions.EASE_IN_OUT
                });
				return;
			}
			Starling.juggler.tween(popUp, TRANSITION_DURATION, {
				y: Constants.STAGE_HEIGHT,
				transition: Transitions.EASE_IN_OUT
			});
		}
		
		override public function handleNotification(note : INotification) : void {
			switch(note.getName()) {
				case Notifications.ASSETS_LOADED:
					handleAssetsLoaded();
					break;
				
				case Notifications.CANCEL_ALL_HTTP_REQUESTS:
					handleCancelAllRequests();
					break;
				
				case Notifications.USER_LOGGED_IN:
					window.skipNextTransition = true;
					if(window.screenNavigator && window.screenNavigator.activeScreen && window.screenNavigator.activeScreen is LoginScreen) {
						sendNotification(Notifications.DISPLAY_PREVIOUS_SCREEN);
					}
					break;
			}
		}
		
		private function handleAssetsLoaded() : void 
		{


		}
		
		private function handleCancelAllRequests() : void
		{
			httpClient.cancelAllRequests();
		}
	}
}