/**
 * Created by Render-2 on 8/23/2017.
 */
package com.despark.tuning3d.view.components.NotificationView
{
    import com.utils.FontSelector;

    import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.ITextRenderer;

    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;

    public class NotificationPanelLabelFactory {

        public static const COLOR_TEXT_GREY :uint = 0x808285;
        public static const COLOR_TEXT_RED :uint = 0xb00000;
        public static const COLOR_TEXT_WHITE :uint = 0xfeffff;
        public static const COLOR_TEXT_LITE_GREY :uint = 0xA4A6A8;
        public static const SIZE_BIG:uint = 14;
        public static const SIZE_SMALL:uint = 12;

        public static function  notificationNotifierTextRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), 10, COLOR_TEXT_WHITE);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.5;
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            return textRenderer;
        }

        public static function  postDateLabelRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), 10, COLOR_TEXT_LITE_GREY);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.5;
            textRenderer.textFormat.italic = true;
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }


        public static function  nameLabelRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), SIZE_BIG, COLOR_TEXT_GREY);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.35;
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = true;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }

        public static function  postNameRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), SIZE_BIG, COLOR_TEXT_GREY);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.35;
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = true;
            textRenderer.wordWrap = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }

        public static function  textLabelRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), SIZE_BIG, COLOR_TEXT_GREY);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.5;
            textRenderer.wordWrap = true;

            textRenderer.textFormat.italic = true;
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }

        public static function  carNameLabelRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), SIZE_BIG, COLOR_TEXT_RED);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.letterSpacing = -.5;
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = true;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }
    }
}
