package com.despark.tuning3d.view.components.auth
{
import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.core.PopUp;
import com.distriqt.AdsManager;
import com.utils.FontSelector;
import com.utils.ObjectUtils;

import feathers.controls.Button;
import feathers.controls.Label;

import feathers.controls.LayoutGroup;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;
import feathers.layout.FlowLayout;
import feathers.layout.HorizontalAlign;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.Image;
import starling.events.Event;
import starling.filters.ColorMatrixFilter;

public class ProfilePopup extends PopUp {
		private var backgroundImage:Image;

		private var fullNameField:ProfilePageLabel;
		private var emailField:ProfilePageLabel;
		private var currentPasswordField:ProfilePageLabel;
		private var newPasswordField:ProfilePageLabel;
		private var repeatPasswordField:ProfilePageLabel;
        private var saveButton:MultilingualButton;
        private var cancelButton:MultilingualButton;

        private var resendEmailButton:Button;
        private var messageField:Label;

		private var formGroup:LayoutGroup;
        private var _isEmailVerified:Boolean;
        private var _isVerifiedIcon:Image;
        private var _exclamationIcon:Image;
    //
        public static const SAVE_CHANGES:String = 'saveChanges';
        public static const RESEND_EMAIL:String = 'resendVerificationEmail';
        private var userData:Object = {};
        private var messageCode:uint;
        private var showAdsOnClose:Boolean;
		public function ProfilePopup() {

		}

		public function updateWithLanguage(language : Language) : void {

		}
		
		override protected function initialize() : void {
			super.initialize();
            setSizeInternal(stage.stageWidth, stage.stageHeight, false);
            _isVerifiedIcon = new Image(ButtonFactory.assetManager.getTexture("profile_yes"));
            _exclamationIcon = new Image(ButtonFactory.assetManager.getTexture("profile_not"));
            _isVerifiedIcon.scale = _exclamationIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
			if(contentBackgroundImage){
				contentBackgroundImage.visible = false;
            }
			if(background){
				background.visible = false;
			}

			backgroundImage = new Image(ButtonFactory.assetManager.getTexture('profile_screen_background'));
			addChildAt(backgroundImage, 0);
			//
            fullNameField = new ProfilePageLabel("Full Name");
			fullNameField.width = 265;
			fullNameField.height = 30;

            emailField = new ProfilePageLabel("Email address");
            emailField.width = 265;
            emailField.height = 30;

            currentPasswordField = new ProfilePageLabel('<font color="#b50606">Change Password</font> &#47; Enter Current');
            currentPasswordField.displayAsPassword = true;
            currentPasswordField.width = 265;
            currentPasswordField.height = 30;

            newPasswordField = new ProfilePageLabel("New");
            newPasswordField.displayAsPassword = true;
            newPasswordField.width = 125;
            newPasswordField.height = 30;

            repeatPasswordField = new ProfilePageLabel("Retype new");
            repeatPasswordField.displayAsPassword = true;
            repeatPasswordField.width = 125;
            repeatPasswordField.height = 30;

            resendEmailButton = new Button();
            resendEmailButton.labelFactory = function ():ITextRenderer {
                var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 9, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.LEFT;
                textRenderer.textFormat.bold = false;
                textRenderer.textFormat.italic = false;
                textRenderer.embedFonts = FontSelector.embedFonts();
                return textRenderer;
            };
            resendEmailButton.label = "resend";
            var resendIcon:Image = new Image(ButtonFactory.assetManager.getTexture("restore"));
            resendIcon.width = 15;
            resendIcon.scale = resendIcon.scaleX;
            resendEmailButton.defaultIcon = resendIcon;
            var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
            colorFilter.tint(0xC90809, 1);
            resendEmailButton.filter = colorFilter;
            resendEmailButton.addEventListener(Event.TRIGGERED, resendEventHandler);

            formGroup = new LayoutGroup();
            formGroup.width = 266;
            formGroup.height = actualHeight;
            formGroup.x = (actualWidth - formGroup.width) /2;
            formGroup.y = 35;

            saveButton = ButtonFactory.defaultButton("SAVE", 0xC90809);
            saveButton.labelFactory = function ():ITextRenderer {
                var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 14, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.CENTER;
                textRenderer.textFormat.bold = true;
                textRenderer.embedFonts = true;
                return textRenderer;
            };
            saveButton.width = 96;
            saveButton.height = 30;
            saveButton.addEventListener(Event.TRIGGERED, saveHandler);


            cancelButton = ButtonFactory.defaultButton("CANCEL", 0xC90809);
            cancelButton.labelFactory = function ():ITextRenderer {
                var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 14, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.CENTER;
                textRenderer.textFormat.bold = true;
                textRenderer.embedFonts = true;
                return textRenderer;
            };
            cancelButton.defaultSkin.alpha = cancelButton.downSkin.alpha = 0;
            cancelButton.width = 96;
            cancelButton.height = 30;
            cancelButton.addEventListener(Event.TRIGGERED, cancelHandler);

            messageField = new Label();
            messageField.wordWrap = true;
            messageField.width = 266;
            messageField.height = 30;
            messageField.textRendererFactory = function ():ITextRenderer {
                var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 9, 0xFFFFFF);
                textRenderer.textFormat.align = TextFormatAlign.CENTER;
                textRenderer.textFormat.bold = true;
                textRenderer.embedFonts = true;
                textRenderer.isHTML = true;
                return textRenderer;
            };

			var groupLayout:FlowLayout = new FlowLayout();
            groupLayout.verticalGap = 15;
            groupLayout.horizontalGap = 15;
            groupLayout.horizontalAlign = HorizontalAlign.CENTER;
			formGroup.layout = groupLayout;

            formGroup.addChild(fullNameField);
            formGroup.addChild(emailField);
            formGroup.addChild(currentPasswordField);
            formGroup.addChild(newPasswordField);
            formGroup.addChild(repeatPasswordField);
            formGroup.addChild(messageField);
            formGroup.addChild(saveButton);
            formGroup.addChild(cancelButton);
			addChild(formGroup);
            addChild(_isVerifiedIcon);
            addChild(_exclamationIcon);
            addChild(resendEmailButton);
            resendEmailButton.visible = false;
            _exclamationIcon.visible = _isVerifiedIcon.visible = false;
            //
            showAdsOnClose = AdsManager.$.bannerHide();
		}


        override protected function closeButtonTriggeredHandler(event:Event):void {
            super.closeButtonTriggeredHandler(event);
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            if(showAdsOnClose){
                AdsManager.$.bannerShow(AdsManager.$.currentBannerScreen);
            }
        }

        private function cancelHandler(event:Event):void {
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            closeButtonTriggeredHandler(null);
        }

        private function resendEventHandler(event:Event):void {
            if(userData && userData.email != emailField.text){
                saveHandler(null);
            }else{
                dispatchEvent(new Event(RESEND_EMAIL));
            }
            AlertView.show("Verification mail sent", 3, false);
        }

        private function saveHandler(event:Event):void {
            if(newPasswordField.text.length && repeatPasswordField.text.length && newPasswordField.text !== repeatPasswordField.text){
                messageField.text = '<font color="#b00000">"New" and "Retype new" fields don\'t  match.<br/></font>';
                newPasswordField.setText('');
                repeatPasswordField.setText('');
                return;
            }
            SoundManager.playSound(SoundManager.SELECT_PART);
            var data:Object = {};
            if(userData.name != fullNameField.text){
                data.name = fullNameField.text;
                messageCode = 3;
            }
            if(userData.email != emailField.text){
                data.email = emailField.text;
            }
            if(newPasswordField.text.length && repeatPasswordField.text.length && currentPasswordField.text.length && currentPasswordField.text !== newPasswordField.text){
                data.password = {"passwordOld": currentPasswordField.text, "passwordNew": newPasswordField.text};
                messageCode = 4;
            }
            if(!ObjectUtils.isEmpty(data)){
                if(data.hasOwnProperty('email')){
                    messageCode = 1;
                }else if(ObjectUtils.getLength(data) > 1){
                    messageCode = 2;
                }
                dispatchEvent(new Event(SAVE_CHANGES, false, data));
            }
        }

		override protected function draw() : void {
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE)){
				if(stage.stageWidth/stage.stageHeight > backgroundImage.width/backgroundImage.height){
                    backgroundImage.width = stage.stageWidth;
                    backgroundImage.scale = backgroundImage.scaleX;
				}else{
                    backgroundImage.height = stage.stageHeight;
                    backgroundImage.scale = backgroundImage.scaleY;
				}
                backgroundImage.x = (stage.stageWidth - backgroundImage.width) / 2;
                backgroundImage.y = (stage.stageHeight - backgroundImage.height) / 2;
			}
		}


    override public function dispose():void {
        super.dispose();

		if(backgroundImage){
            backgroundImage.removeFromParent(true);
            backgroundImage = null;
		}

        if(fullNameField){
            fullNameField.removeFromParent(true);
            fullNameField = null;
        }

        if(emailField){
            emailField.removeFromParent(true);
            emailField = null;
        }

        if(currentPasswordField){
            currentPasswordField.removeFromParent(true);
            currentPasswordField = null;
        }

        if(newPasswordField){
            newPasswordField.removeFromParent(true);
            newPasswordField = null;
        }

        if(repeatPasswordField){
            repeatPasswordField.removeFromParent(true);
            repeatPasswordField = null;
        }

        if(saveButton){
            saveButton.removeFromParent(true);
            saveButton = null;
        }

        if(cancelButton){
            cancelButton.removeFromParent(true);
            cancelButton = null;
        }

        if(formGroup){
            formGroup.removeFromParent(true);
            formGroup = null;
        }
    }

    private function set isEmailVerified(value:Boolean):void{
        _isEmailVerified = value;
        resendEmailButton.x = formGroup.x + emailField.x + emailField.width - (resendEmailButton.width + 8);
        resendEmailButton.y = formGroup.y + emailField.y + (emailField.height - resendEmailButton.height) / 2;

        _isVerifiedIcon.x = formGroup.x + emailField.x + emailField.width - (_isVerifiedIcon.width + 8);
        _isVerifiedIcon.y = formGroup.y + emailField.y + (emailField.height - _isVerifiedIcon.height) / 2;

        _exclamationIcon.x = formGroup.x + messageField.x - _exclamationIcon.width;
        _exclamationIcon.y = formGroup.y + messageField.y;

        _exclamationIcon.visible = false;
        /*_exclamationIcon.visible = */resendEmailButton.visible = !value;
        _isVerifiedIcon.visible = value;
        if(!value && messageCode == 0){
            messageField.text = '<font color="#b00000">Unverified email:  Please log in to your email account' + '<br>' + 'and find the email we have just sent you.</font>';
        }
    }

    public function setChangeResult(object:Object):void{
        resendEmailButton.visible = false;
        if(object.success){
            _exclamationIcon.color =  0x0db500;
            if(messageCode == 1){
                messageField.text = '<font color="#0db500">We’ve sent you a link to confirm your email address.' + '<br/>' + 'Please check you inbox.</font>';
            }else if(messageCode == 4){
                messageField.text = '<font color="#0db500">Your password has been successfully changed.</font>';
            }else if(messageCode == 3){
                messageField.text = '<font color="#0db500">Your Profile changes has been saved successfully.</font>';
            }else if(messageCode == 2){
                messageField.text = '<font color="#0db500">Your Profile changes has been saved successfully.</font>';
            }
        }else{
            _exclamationIcon.color = 0xb00000;
            if(object.result.hasOwnProperty("param")){
                if(object.result.param == 'email'){
                    if(object.result.msg == "Invalid email"){
                        messageField.text = '<font color="#b00000">The email address you entered is invalid.' + '<br>' + 'Type a valid email address.</font>';
                    }
                }
            }else if(object.result == "invalid username password"){
                if(messageCode == 1){
                    messageField.text = '<font color="#b00000">An account with this email already exists.' + '<br>' + 'Type another email address please.</font>';
                }else if(messageCode == 4){
                    messageField.text = '<font color="#b00000">The current password you entered is incorrect.' + '<br>' + 'Type your current password, please.</font>';
                }
            }
        }
        currentPasswordField.setText('');
        newPasswordField.setText('');
        repeatPasswordField.setText('');
        _exclamationIcon.x = formGroup.x + messageField.x - _exclamationIcon.width;
        _exclamationIcon.y = formGroup.y + messageField.y;
    }

    public function setProfileData(result:Object):void {
        userData = result;
        if(result.name) {
            fullNameField.setText(result.name);
        }

        if(result.email) {
            emailField.setText(result.email);
        }

        isEmailVerified = result.emailVerified;
    }
}
}