package com.despark.tuning3d.view.components.auth
{
	//import com.despark.tuning3d.view.components.core.AlertView;

	import com.despark.tuning3d.model.sounds.SoundManager;

	import feathers.layout.RelativePosition;

import flash.geom.Rectangle;
	import flash.media.StageWebView;
	
	import feathers.controls.Button;
	import feathers.core.FeathersControl;
	
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.utils.AssetManager;

	public class UserAgreementView extends FeathersControl 
	{
		public static const CLOSE_SELECTED : String = "CloseSelected";
		public static var assetManager : AssetManager;
		
		private var text : String;
		private var backgroundQuad : Quad;
		private var closeButton : Button;
		private var closeButtonBackgroundQuad : Quad;
		private var stageWebView : StageWebView;
		
		protected override function initialize() : void
		{
			super.initialize();
			
			backgroundQuad = new Quad(1, 1, 0xFFFFFF);
			addChild(backgroundQuad);
			
			closeButtonBackgroundQuad = new Quad(10, 10, 0xFFFFFF);
			closeButtonBackgroundQuad.pivotX = closeButtonBackgroundQuad.width / 2;
			closeButtonBackgroundQuad.pivotY = closeButtonBackgroundQuad.height / 2;
			addChild(closeButtonBackgroundQuad);
			
			var closeButtonTexture : Texture = assetManager.getTexture("closeButton");
			closeButton = new Button();
			closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
			closeButton.defaultIcon = new Image(closeButtonTexture);
			closeButton.width = 25;
			closeButton.height = 25;
			closeButton.iconPosition = RelativePosition.MANUAL;
			closeButton.iconOffsetX = int((closeButton.width - closeButtonTexture.width) / 2);
			closeButton.iconOffsetY = int((closeButton.height - closeButtonTexture.height) / 2);
			closeButton.pivotX = closeButton.width / 2;
			closeButton.pivotY = closeButton.height / 2;
			addChild(closeButton);
			
			stageWebView = new StageWebView();
		}
		
		protected override function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				backgroundQuad.width = actualWidth;
				backgroundQuad.height = actualHeight;
				
				closeButton.x = actualWidth;
				closeButtonBackgroundQuad.x = closeButton.x;
				
				var scale : int = assetManager.scaleFactor;
				var webViewPadding : int = 10;
				
				stageWebView.stage = Starling.current.nativeStage;
				stageWebView.viewPort = new Rectangle(
					(x + webViewPadding) * scale, 
					(y + webViewPadding) * scale, 
					(actualWidth - 2 * webViewPadding) * scale, 
					(actualHeight - 2 * webViewPadding) * scale);
				
				stageWebView.loadString(text);
			}
		}
		
		private function closeButtonTriggeredHandler(event : Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			stageWebView.dispose();
			Starling.current.stage.removeChild(this);
		}
		
		public static function show(text : String) : void
		{
			var padding : int = 20;
			var userAgreementView : UserAgreementView = new UserAgreementView();
			
			userAgreementView.text = text;
			userAgreementView.x = padding;
			userAgreementView.y = padding;
			userAgreementView.width = Starling.current.stage.stageWidth - 2 * padding;
			userAgreementView.height = Starling.current.stage.stageHeight - 2 * padding;
			
			Starling.current.stage.addChild(userAgreementView);
		}
	}
}