package com.despark.tuning3d.view.components.brands
{
    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.brands.Brand;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.core.AppMode;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.Multilingual;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.model.packages.Purchase;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.BrandsScreenMediator;
    import com.despark.tuning3d.view.components.cars.CarItemRenderer;
    import com.despark.tuning3d.view.components.cars.FeaturedCarItemRenderer;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.core.BrandMenuScreen;
    import com.despark.tuning3d.view.components.core.BrandsScreenBackgroundImage;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.CustomAlertView;
    import com.despark.tuning3d.view.components.core.ExtendedList;
    import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.MainMenuButton;
    import com.despark.tuning3d.view.components.core.MainMenuView;
    import com.despark.tuning3d.view.components.core.MultilingualButton;
    import com.despark.tuning3d.view.components.core.MultilingualLabel;
    import com.despark.tuning3d.view.components.core.MultilingualToggleSwitch;
    import com.despark.tuning3d.view.components.core.PackagesView;
    import com.despark.tuning3d.view.components.core.PurchaseView;
    import com.despark.tuning3d.view.components.core.SearchView;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.languages.LanguageItemRenderer;
    import com.distriqt.AdsManager;
    import com.distriqt.GameService;
    import com.utils.FontSelector;
    import com.utils.ImageUtils;
    import com.utils.MemoryTracker;

    import feathers.controls.Button;
    import feathers.controls.List;
    import feathers.controls.ScrollBar;
    import feathers.controls.ScrollBarDisplayMode;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.FeathersControl;
    import feathers.core.ITextRenderer;
    import feathers.data.ListCollection;
    import feathers.layout.Direction;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.TiledRowsLayout;
    import feathers.layout.VerticalAlign;
    import feathers.layout.VerticalLayout;

    import flash.display.StageOrientation;
    import flash.events.TimerEvent;
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import flash.system.Capabilities;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;

    import mx.utils.StringUtil;

    import starling.core.Starling;
    import starling.display.DisplayObject;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;
    import starling.filters.ColorMatrixFilter;
    import starling.textures.Texture;

    public class BrandsScreen extends BrandMenuScreen implements Multilingual, IMainMenuHolder
{
    public static var adsBlocker:Boolean = false;
    public static var pageRef : BrandsScreen;
    public static var carchooserOrder : int = 0;

    private static const MENU_HEIGHT : int = 105;
    private static const BRAND_WIDTH : int = 63;
    private static const BRAND_WIDTH_HALF : int = int(BRAND_WIDTH / 2);
    private static const BRAND_HEIGHT : int = 37;
    private static const CAR_WIDTH  : int = 110;
    private static const CAR_HEIGHT : int = MENU_HEIGHT - BRAND_HEIGHT - 10;

    public static const SELECT_CAR : String = "SelectCar";
    public static const CLEANUP_MEMORY : String = "CleenupMemory";
    public static const LOGIN_SELECTED : String = "LoginSelected";
    public static const CAR_SELECTED : String = "CarSelected";
    public static const CUSTOMIZE_SELECTED : String = "CustomizeSelected";
    public static const LOGOUT_SELECTED : String = "LogoutSelected";
    public static const BUY_NOW_PACKET:String="onBuyNowPacket";
    public static const INSTRUCTION_SELECTED : String = "INSTRUCTION_SELECTED";
    public static const VS_SELECTED : String = "VS_SELECTED";
    public static const MINIFRAME_SELECTED : String = "MINIFRAME_SELECTED";
    public static const LANGUAGE_CHANGED : String = "LanguageChanged";
    public static const RESTORE_SELECTED:String = "RESTORE_SELECTED";
    public static const SLECTED_MATERIAL_WITH_RELOAD_CAR:String = "SLECTED_MATERIAL_WITH_RELOAD_CAR";

    public static const DISPLAY_REWARD_INFO_POPUP: String = "DISPLAY_REWARD_INFO_POPUP";
    public static const DISPLAY_REWARD_NOADS_POPUP: String = "DISPLAY_REWARD_NOADS_POPUP";

    public static const OPEN_MAIN_MENU: String = "BrandsOpenMainMenu";
    public static const CLOSE_MAIN_MENU: String = "BrandsCloseMainMenu";

    public var witeTouchEventEnded:Boolean = false;

    private var _packages:Array;
    private var _filteredPackages:Array;
    private var _ads:Object;

    private var _brands : Array;
    private var _selectedBrandIndex : int;

    private var brandsList : List;
    private var carsList : ExtendedList;
    public var featuredCarsList : List;
    private var carListIsScrolling : Boolean = false;

    private var _mainMenuView : MainMenuView;

    public var purchaseView : PurchaseView;
    private var searchView   : SearchView;
    public var packagesView : PackagesView;

    private var featuredButton : MultilingualButton;
    public var rewardsButton: Button;
    public var rewardsAvailable: Boolean;
    public var rewardsAdsAvailable: Boolean = false;

    private var updateTextLabel : MultilingualLabel;
    private var backgroundImage : BrandsScreenBackgroundImage;
    private var _featuredCars : Array;
    private var _userSignedIn : Boolean;
    private var featuresIcon:Image;
    private var brandsButtonIcon:Image;
    private var brandsButtonSearchIcon:Image;

    //public var restoreButton : Button;

    private var _selectedLanguage : Language;

    private var _languages : Array;

    private var blockerView:BlockerView;
    private var _purchasedList:Array=[];

    public static var FIRST_SHOW_DONE:Boolean=true;
    public static var SELECTED_CAR:Car=null;
    public static var SELECTED_PACKET:Packet=null;
    public static var ONE_ALGREE:Boolean=false;
    public static var selectedMaterialName:String=null;
    public static var selectedCarId : String=null;
    public static var selectedCar:Car=null;
    public static var screenShotTexture:Texture=null;
    public static var screenShotImage:Image=null;

    private var feauturedItemIndex : int = 0;

    private var lftSlidButton:Button;
    private var rgtSlidButton:Button;
    private var brandListButton:Button;
    // private var carListButton:Button;
    //private var titBarButton:Button;
    public  var displayImage:Image;

    private var searchMenuCloseButton : Button;
    private var searchFullCloseButton : Button;
    private var searchMenuFullButton  : Button;

    private var dummyButton : MainMenuButton;

    private var touchEventTriggered : Boolean = false;

    private var brandsListTopBack:Image;
    private var carsListTopBack:Image;

    private var redrowIndex : int;
    private var _language:Language = null;
    private var carListRequestedColumns : int = 1;

    private var _lastSelectedBrand:Brand=null;
    private var _car_filter:String = "";

    private var _topButtonPadding:Number = 0;//36;
    private var _topButtonPaddingAndRecive:Number = 0;

    private var serchViewMaximized : Boolean = false;
    private var brandListSeperator : Quad;
    private var carListSeperator : Quad;
    private var brandsListBotBack : Quad;
    private var carsListBotBack : Quad;
    private var searchBlocker : Quad;



    private var _carChoiceButton:Button;
    private static const bottomMargin:int = 5;
    private static const mainMargin:int = 10;

    public function startShow() : void
    {
        dispatchEvent(new Event(PackagesView.UPDATE_CAR_PACKAGES))
        feauturedItemIndex = 0;
        if(!selectedMaterialName)
        {
            Starling.juggler.delayCall(function():void{

                hideBlocker();

                if(FIRST_SHOW_DONE) {
                    FIRST_SHOW_DONE = false;
                    return;
                }

                var index:int=-1;
                if (!brandsList) {
                    var brandsLayout : VerticalLayout = new VerticalLayout();
                    brandsLayout.scrollPositionVerticalAlign = VerticalAlign.TOP;
                    //brandsLayout.manageVisibility = true;
                    brandsLayout.useVirtualLayout = true;
                    brandsLayout.gap = 0;
                    brandsList = new List();
                    brandsList.name = "brandsList";
                    brandsList.clipContent = true;
                    brandsList.layout = brandsLayout;
                    brandsList.paddingTop = 10;
                    brandsList.paddingBottom = 4;
                    brandsList.visible = false;
                    brandsList.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
                    brandsList.verticalScrollBarFactory = verticalScrollBarFactory;
                    brandsList.itemRendererFactory = brandsListItemRendererFactory;
                    brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);

                    if (searchView) {
                        addChildAt(brandsList,redrowIndex);
                    }

                    updateFeaturedCarList();
                }

                if (!carsList) {
                    var carsLayout : TiledRowsLayout = new TiledRowsLayout();
                    carsLayout.requestedColumnCount = carListRequestedColumns;
                    carsLayout.useSquareTiles = false;
                    //carsLayout.manageVisibility = true;
                    carsLayout.useVirtualLayout = true;
                    carsLayout.horizontalAlign = HorizontalAlign.LEFT;

                    carsLayout.gap = 0;
                    carsList = new ExtendedList();
                    carsList.name = "carsList";
                    carsList.clipContent = true;
                    carsList.layout = carsLayout;
                    carsList.paddingTop = 10;
                    carsList.paddingBottom = 4;
                    carsList.visible = false;
                    carsList.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
                    carsList.verticalScrollBarFactory = verticalScrollBarFactory;
                    carsList.itemRendererFactory = carsListItemRendererFactory;
                    carsList.addEventListener(Event.CHANGE, carsListChangeHandler);

                    if (searchView) {
                        addChildAt(carsList,redrowIndex);
                    }
                }

                if (_language) {
                    updateWithLanguage(_language);
                }

                if (!packagesView.dataProvider) {
                    recreateElementWithLanguage();
                }

                invalidate();

                brands = _brands;
                brandsList.selectedItem = _lastSelectedBrand;

                Starling.juggler.delayCall(function():void{
                    if (SELECTED_CAR) {
                        ONE_ALGREE = true;
                        dispatchEventWith(CAR_SELECTED, false, SELECTED_CAR);
                        SELECTED_CAR = null;
                        SELECTED_PACKET = null;
                    }

                    showAdBanner();

                }, 2);
            }, 0.2);
        }else{

            if(!screenShotImage)
            {
                screenShotImage = new Image(BrandsScreen.screenShotTexture);
                screenShotImage.x = 0;
                screenShotImage.y = 0;

                screenShotImage.width = actualWidth;
                screenShotImage.height = actualHeight;
                addChild(screenShotImage);

            }

            //Нужно найти тачку
            var brand:Brand;
            var car:Car;
            for (var i:int = 0; i < brands.length; i++){
                brand = brands[i];
                for (var j:int = 0; j < brand.cars.length; j++){

                    car = brand.cars[j];

                    if (car.id == BrandsScreen.selectedCarId){

                        BrandsScreen.selectedCar = car;
                        break;
                    }
                }

            }
            Starling.juggler.delayCall(function():void {dispatchEventWith(SLECTED_MATERIAL_WITH_RELOAD_CAR);},2);
        }

        MemoryTracker.gcAndCheck("BrandsScreen.startShow()");
        this.invalidate();
    }

    public function showAdBanner():void{
        AdsManager.$.bannerEnabled = true;
        locateAdBanner();
        if(AdsManager.$.showBannerAfterComplete) {
            AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
        }
    }

    public function locateAdBanner():void{
        var bannerPosition:Number = featuredButton.y + (featuredButton.height-AdsManager.$.bannerHeight)/2;
        AdsManager.$.setBannerPosition(bannerPosition * Starling.current.contentScaleFactor, BannerScreen.HOME_SCREEN);
    }

    public function get neededWidth() : Number{
        return actualWidth;
    }

    public function get neededHeight():Number{
        return actualHeight;
    }

    private static var FirstShowDone:Boolean = true;
    override public function ShowDone() : void
    {
        hideBlocker();

        updateModeView();

        if(Constants.FIRST_BRANDS_SCREEN) {
            startShow();
        }
        else {
            var time : Number = (Constants.SCALE_FACTOR >= 3.375) ? .6 : .3;
            if (mainMenuView && mainMenuView.isOpened) mainMenuView.hide();
            Starling.juggler.delayCall(startShow, time);
        }
        checkPackets();
        FirstShowDone = false;
    }
    private function checkPackets(): void {
        GameService.$.getSaveData(function(data: String): void {
            var saveData: Object = JSONer.parse(data);
            if (packages) {
                for (var i:Number = 0; i < packages.length; i++) {
                    var packetId:String = (packages[i] as Packet).id;
                    if (saveData.rewardsPackets.indexOf(packetId) > -1) {
                        packages[i].tempOpened = true;
                        packages[i].lock = false;
                    } else if (packages[i].tempOpened) {
                        packages[i].tempOpened = false;
                        packages[i].lock = true;
                    }
                }
            }
        });
    }
    /**
     * THe UI elements, which depends on AppMode, should be updated
     */
    public function updateModeView() : void
    {
        if(!actualWidth || isNaN(actualWidth))
        {
            Starling.juggler.delayCall(updateModeView, 0.2);
            return;
        }
        updateArrowStates();
        rgtSlidButton.x = actualWidth - rgtSlidButton.width/2/* - vertPadding + 1*/;
        updateTextLabel.x = displayImage.x + 15;
        //
        if(brandsButtonIcon){
            brandsButtonIcon.removeFromParent(true);
        }
        if(featuresIcon){
            featuresIcon.removeFromParent(true);
        }
        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }
        initIcons();
    }

    override public function dispose():void {
        super.dispose();
    }

    private var _currentCar : Car;
    public function set currentCar(value:Car) : void{
        _currentCar = value;
    }
    public function get currentCar() : Car{
        return _currentCar;
    }

    public function closeNotificationBar() : void
    {
        /*if (_notificationPanelView && (_notificationPanelView.isNotificationsActive || _notificationPanelView.isFriendsActive)){
            _notificationPanelView.hide();
        }*/
    }


    private function featuredCarsListItemRendererFactory():IListItemRenderer {
        var renderer:FeaturedCarItemRenderer = new FeaturedCarItemRenderer();
        renderer.setSize(actualWidth, actualHeight /*- (brandsList.y  - _topButtonPadding + vertPadding) * 2*/ /*180*/);


        return renderer;
    }

    private function brandsListItemRendererFactory() : IListItemRenderer {
        var renderer : BrandItemRenderer = new BrandItemRenderer();
        renderer.setSize(brandsList.width, 50);
        return renderer;
    }

    private function  carsListItemRendererFactory() : IListItemRenderer
    {
        var renderer : CarItemRenderer = new CarItemRenderer();
        renderer.setSize(carsList.width, 100);
        renderer._carOffset = 7;
        return renderer;
    }

    public function showBuyPacket(packet:Packet):void{
        this.packagesView.showPacket(packet);
    }

    public function clearMemory(rebuild:Boolean=false):void
    {
        Tracer.print("memoryCleanUp", "BRANDS SCREEN");
        if (!brandsList || !carsList) return;
        brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
        brandsList.dispose();
        removeChild(brandsList);
        brandsList = null;

        carsList.removeEventListener(Event.CHANGE, carsListChangeHandler);
        carsList.dataProvider = null;
        carsList.removeFromParent(true);
        carsList = null;

        if (!rebuild && featuredCarsList.dataProvider) {
            featuredCarsList.dataProvider = null;
            featuredCarsList.selectedIndex = -1;
        }

        ImageUtils.clearAllTexture();
        MemoryTracker.gcAndCheck("BrandsScreen.clearMemory()");

        if (rebuild) ShowDone();
    }

    protected function disposePackages() : void {
        if (packagesView){
            packagesView.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.removeEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.removeEventListener(Event.OPEN, packagesViewOpen);
            packagesView.removeEventListener(Event.CLOSE, packagesViewClose);
            packagesView.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);

            packagesView.removeEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
        }
    }


    protected function onReceiveBanner(event:Event):void
    {
        return;
        var prev : Number = _topButtonPadding;
        var rect : Rectangle = event.data.rect;
        if (!Device.isIos()){
            topButtonPadding = (rect.height / Constants.SCALE_FACTOR) - 5;
        }
        else
        {
            if (Constants.ThisIsIPAD){
                topButtonPadding = (rect.height / Constants.SCALE_FACTOR) - 5;
            }
            else {
                topButtonPadding = (rect.height / Constants.SCALE_FACTOR) - 5;
            }
        }
    }


    protected function onRemoveBanner(event:Event):void {

    }

    protected function turnOfAdsHandler( e : Event):void {
        topButtonPadding = 0;
    }



    public function logout() : void
    {
        var facade : ApplicationFacade = ApplicationFacade.getInstance();
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        usersProxy.logoutCurrentUser();
    }

    public function BrandsScreen()
    {
        super();
        name = "BrandsScreen";
        _isRoot = true;

        BrandsScreen.pageRef = this;

        ///////////////////////////////////////////////////////////////
//			if (!addsTimer){				
//				addsTimer = new Timer(1000,40);
//				addsTimer.addEventListener(TimerEvent.TIMER,showAddsCount);
//				addsTimer.start();
//			}
        ///////////////////////////////////////////////////////////////
    }


    protected function onGlobalEventMemLeakTest(event:*):void {
    }

    private function onUpdateTimer(event:TimerEvent):void {
    }

    public function get userSignedIn():Boolean{
        return _userSignedIn;
    }
    public function set userSignedIn(value:Boolean):void {
        _userSignedIn = value;
        if (!owner)	return;
        invalidate("userSignedIn");
    }

    public function get featuredCars() : Array{
        return _featuredCars;
    }

    private var _featuredCarsHasChanged : Boolean = false;
    public var rewardNotificationImage:Image;

    public function set featuredCars(value : Array) : void {

        if(_featuredCars==value)return;
        _featuredCarsHasChanged = true;

//			_featuredCars = [value[0]];
        _featuredCars = value;

        if(value){

            updateArrowStates();
            updateStandText(0);

            invalidate("featuredCars");
            updateFeaturedCarList();
        }

        /*if(_featuredCars && _featuredCars.length == value.length) // check if its the same return;
        {
            var identical : Boolean = true;

            for(var i : int = 0; i < _featuredCars.length; i++) {

                if (_featuredCars[i].id != value[i].id)
                {
                    identical = false;
                    break;
                }
            }

            if(identical) return;
        }*/


    }

    private function updateFeaturedCarList() : void
    {
        if(_featuredCarsHasChanged && featuredCarsList && featuredCars)

            if(featuredCarsList.dataProvider)
            {
                featuredCarsList.dataProvider.removeAll();
            }

        featuredCarsList.dataProvider = new ListCollection(featuredCars);
        featuredCarsList.selectedIndex = -1;
        var tlen : int = featuredCarsList.dataProvider.length;
        featuredCarsList.width = this.actualWidth * (tlen > 1 ? featuredCarsList.dataProvider.length / tlen : 1);
        featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;


        _featuredCarsHasChanged = false;

        refresh();
    }


    protected override function get handleTexture() : Texture {
        return null;
    }

    public function getFromAssets(str:String) : Texture {
        return assetManager.getTexture(str);
    }

    protected override function get menuBackgroundTexture() : Texture {
        return null;
    }

    protected override function get menuHeight() : int {
        return MENU_HEIGHT;
    }

    public function packetPurchaseSuccess(packet:Packet):void
    {
        var facade : ApplicationFacade = ApplicationFacade.getInstance();
        var packagesProxy : PackagesProxy;

        var i : int = 0;
        var p : Packet;

        packagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
        packet.lock = false;

        if (packet.type == Packet.TYPE_ALLPACKET){
            for (i = 0; i < packagesProxy.packages.length; i++){
                p = packagesProxy.packages[i];
                p.lock = false;
            }
        }

        if (packet.type == Packet.TYPE_CURRENTALLPACKET && packet.packets!=null)
        {
            for(i=0; i < packagesProxy.packages.length; i++){
                p = packagesProxy.packages[i];
                if (packet.packets.indexOf(p.id) >= 0){
                    p.lock = false;
                }
            }
        }

        if (this.carsList && carsList.dataProvider){
            carsList.dataProvider.updateAll();
        }


        this.packagesView.packetPurchaseSuccess(packet);

        _purchasedList.push(new  Purchase(packet.id, packet.title, true, packet.type));
        purchaseView.dataProvider = _purchasedList;
        try {
            purchaseView.dataProvider.updateAll();
        }catch(e:Error){

        }
        refresh();
    }

    public function adsRemoverPurchaseSuccess(ads:Object):void
    {
        AdsManager.turnOffAds();
        ads.lock = false;
        topButtonPadding = 0;


        _purchasedList.push(new Purchase(ads.id, ads.title, true,Packet.TYPE_REMOVE_ADS ));
        purchaseView.dataProvider = _purchasedList;
    }

    public function carPurchaseSuccess(car:Car):void
    {
        if (car.packet) car.packet.lock = false;

        carsList.dataProvider.updateAll();

        _purchasedList.push(new Purchase(car.id, car.name + " " + car.model, true,Packet.TYPE_COMPONENTS));
        purchaseView.dataProvider = _purchasedList;
    }

    public function recreateElementWithLanguage():void
    {
        if (this.packagesView)
        {
            var packagesViewVisible:Boolean = packagesView.visible;
            var dataProvider:Array = packagesView.dataProvider;

            packagesView.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.removeEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.removeEventListener(Event.OPEN, packagesViewOpen);
            packagesView.removeEventListener(Event.CLOSE, packagesViewClose);
            packagesView.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);
            packagesView.removeEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
            packagesView.removeEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.removeEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
            packagesView.removeFromParent(true);

            // PackagesView.PACKAGE_ITEM_WIDTH    = 262;//262;
            // PackagesView.OLD_PACKET_ITEM_WIDTH = 262; //262;
            PackagesView.PACKAGE_ITEM_WIDTH = PackagesView.getPackageItemWidth();//Device.isIos() ? 242 : Constants.SCALE_FACTOR==3.375 ? 232 : 242;
            PackagesView.OLD_PACKET_ITEM_WIDTH = PackagesView.PACKAGE_ITEM_WIDTH;

            AlertView.language = _language;
            packagesView = new PackagesView();
            packagesView.name = "packagesView";
            packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);

            PackagesView.calacItemCount = true;
            packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);

            if (!packagesViewVisible) {
                packagesView.hide();
            }

            packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.addEventListener(Event.OPEN, packagesViewOpen);
            packagesView.addEventListener(Event.CLOSE, packagesViewClose);
            packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);


            packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
            packagesView.addEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);

            packagesView.parentActualWith = actualWidth;
            packagesView.parentActualHeight = actualHeight;
            packagesView.dataProvider = dataProvider;
            addChild(packagesView);

            packagesView.updateWithLanguage(AlertView.language);
            packagesView.x = packagesView.y = 0;
        }

        if (carsList && carsList.dataProvider){
            for (var i:int = 0; i < carsList.dataProvider.length; i++){
                carsList.dataProvider.updateItemAt(i);
            }; carsList.invalidate();
        }
    }

    public function updateWithLanguage(language:Language) : void
    {
        _language = language;

        AlertView.language = language;
        CustomAlertView.language = language;
        AlertViewHL.language = language;

        if (brandListButton){
            brandListButton.label = _language.translate("mob_home","carBrands");
        }

        if (featuredButton){
            featuredButton.label = 'FEATURED\nPACKAGES';//_language.translate("mob_home", "featured"); //AlertView.language.translate("mob_home", "featured");
            featuredButton.updateWithLanguage(language);
        }

        if (packagesView){
            packagesView.updateWithLanguage(language);
        }

        if (purchaseView)
        {
            packagesView.updateWithLanguage(language);
            //this.invalidate();
            //purchaseView.updateWithLanguage(language);
        }

        if (mainMenuView){
            mainMenuView.updateWithLanguage(language);
        }

        if (searchView){
            searchView.updateWithLanguage(language);
        }

        if (carsList && carsList.dataProvider) {
            for (var i:int = 0; i < carsList.dataProvider.length; i++){
                carsList.dataProvider.updateItemAt(i);
            }
            carsList.invalidate();
        }

        if (brandsList && brandsList.dataProvider){
            for (var ii:int = 0; ii < 1; ii++)	{
                brandsList.dataProvider.updateItemAt(ii);
            }
            brandsList.invalidate();
        }
    }


    override protected function initialize() : void
    {
        trace("BrandScreen initialize");

        displayImage = ButtonFactory.standTexture("up_display");

        displayImage.name = "displayImage";
        displayImage.touchable = false;
        displayImage.visible = false;
        displayImage.width = 124;
        displayImage.height = 43;


        updateTextLabel = new MultilingualLabel();
        updateTextLabel.name = "updateTextLabel";
        updateTextLabel.textRendererFactory = titleLabelRenderer;

        rgtSlidButton = ButtonFactory.arrowButton("slide_arr_lt");
        rgtSlidButton.name = "rightArrow";
        rgtSlidButton.rotation = Math.PI;

        lftSlidButton = ButtonFactory.arrowButton("slide_arr_lt");
        lftSlidButton.name = "leftArrow";

        /*notificationButton = ButtonFactory.noteButton('N',0xF04100);
        notificationButton.addEventListener(Event.TRIGGERED, notificationButtonHanlder);
        notificationButton.name = "notificationButton";

        friendRequestsButton = ButtonFactory.noteButton('F',0x0592BF);
        friendRequestsButton.addEventListener(Event.TRIGGERED, friendRequestButtonHandler);
        friendRequestsButton.name = "friendRequestsButton";*/

        lftSlidButton.visible = rgtSlidButton.visible = false;


        var featuredCarsLayout : HorizontalLayout = new HorizontalLayout();
        //featuredCarsLayout.
        //featuredCarsLayout.manageVisibility = true;
        featuredCarsLayout.useVirtualLayout = false;
        featuredCarsList = new List();
        featuredCarsList.name = "featuredCarsList";
        featuredCarsList.paddingTop = 0;
        featuredCarsList.clipContent = true;
        featuredCarsList.layout = featuredCarsLayout;
        featuredCarsList.hasElasticEdges = false;
        featuredCarsList.snapToPages = true;
        featuredCarsList.itemRendererFactory = featuredCarsListItemRendererFactory;
        featuredCarsList.addEventListener(Event.CHANGE, featuredCarListChangeHandler);
        featuredCarsList.addEventListener(TouchEvent.TOUCH, handleTouch);
        featuredCarsList.addEventListener(Event.SCROLL, ftrListScrollHandler);
        featuredCarsList.addEventListener("featuredCompleteLoad", featuredCompleteLoad);


        super.initialize();

        featuredButton = ButtonFactory.featuredButton("BUY NOW");
        featuredButton.name = "featuredButton";
        featuredButton.addEventListener(Event.TRIGGERED, allCarsButtonTriggeredHandler);

        try{
            var screenRatio:Number = Starling.current.nativeStage.stage.fullScreenWidth / Capabilities.screenDPI;
            if(screenRatio < 3.5){
                displayImage.scale = updateTextLabel.scale = featuredButton.scale = 0.85;
            }
        }catch (e:Error) {
            // screen DPI is not available
        }


        //if (AdsManager.$.isSupportReward()) {
        GameService.$.getSaveData(function (gameData: String): void {
            var dateDataObject: Object = JSONer.parse(gameData);
            rewardsButton = ButtonFactory.haveRewardsButton(dateDataObject.rewards);
            rewardsButton.name = 'rewardsButton';
            rewardsButton.addEventListener(Event.TRIGGERED, rewardsButtonTriggeredHandler);
            var scaleKoef: Number = 35 / rewardsButton.height;
            rewardsButton.width = rewardsButton.width * scaleKoef;
            rewardsButton.height = 35;
            rewardsButton.paddingRight = rewardsButton.paddingRight * scaleKoef;
            AdsManager.$.requestReward();

            GameService.$.rewardsIsSupport(function(status: Boolean): void {
                rewardsAvailable = status;
                if(rewardsButton.visible){
                    rewardsButton.visible = status;
                }
                if(rewardNotificationImage){
                    rewardNotificationImage.visible = status;
                    rewardNotificationImage.alpha = 0;
                }
            });
        });
        //}





        searchMenuCloseButton = ButtonFactory.circleButton("model_close");
        searchMenuCloseButton.x = 0;
        searchMenuCloseButton.y = 0;
        searchMenuCloseButton.width = 47;
        searchMenuCloseButton.height = 47;

        if(Device.isIphoneXVariant()){
            searchMenuCloseButton.x += 6;
            searchMenuCloseButton.y += 6;
        }

        searchMenuCloseButton.name = "searchMenuCloseButton";
        //trace("searchMenuCloseButton.width:", searchMenuCloseButton.width);
        //searchMenuCloseButton.scaleX = searchMenuCloseButton.scaleY = 1.43;
        searchMenuCloseButton.visible = false;
        searchMenuCloseButton.addEventListener(Event.TRIGGERED, searchMenuToggleEvent);

        dummyButton = ButtonFactory.menuBigButton();
        dummyButton.name = "dummyButton";
        dummyButton.width = dummyButton.height = 35;
        dummyButton.addEventListener(Event.TRIGGERED, onDummyButtonHandler);

        searchMenuFullButton = ButtonFactory.circleButton("model_fullscr");
        searchMenuFullButton.width = 43;
        searchMenuFullButton.height = 43;
        searchMenuFullButton.name = "searchMenuFullButton";
        //searchMenuFullButton.x = actualWidth - searchMenuFullButton.width - vertPadding;
        //searchMenuFullButton.scaleX = searchMenuFullButton.scaleY = 1.45;
        searchMenuFullButton.addEventListener(Event.TRIGGERED, searchFullScreenMenuToggle);
        searchMenuFullButton.visible = false;

        searchFullCloseButton = ButtonFactory.circleButton("model_close_fl");
        searchFullCloseButton.name = "searchFullCloseButton";
        //searchFullCloseButton.width = searchFullCloseButton.height = searchMenuFullButton.width;
        searchFullCloseButton.x = actualWidth - searchFullCloseButton.width - vertPadding * 1.5;
        searchFullCloseButton.visible = false;
        searchFullCloseButton.addEventListener(Event.TRIGGERED, searchMenuToggleEvent);

        searchView = new SearchView(this);
        searchView.name = "searchView";
        searchView.addEventListener(Event.CHANGE, onChangeSearchInput);
        searchView.visible = false;

        searchBlocker = new Quad(1,1,0x000000);
        searchBlocker.name = "searchBlocker";
        searchBlocker.alpha = .65;
        searchBlocker.visible = false;

        brandListButton = ButtonFactory.dropMenuButton("drop_down_menu");
        brandListButton.width = 323;
        brandListButton.name = "brandListButton";
        brandListButton.addEventListener(Event.TRIGGERED, searchMenuToggleEvent);

        //
        initIcons();
        brandsButtonSearchIcon = new Image(ButtonFactory.assetManager.getTexture("src"));
        brandsButtonSearchIcon.width = brandsButtonSearchIcon.height = 16;
        brandsButtonSearchIcon.x = brandListButton.width - (brandsButtonSearchIcon.width + 8);
        brandsButtonSearchIcon.y = (brandListButton.height - brandsButtonSearchIcon.height) / 2;
        var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter.tint(0x535353, 0.5);
        brandsButtonSearchIcon.filter = colorFilter;
        brandListButton.addChild(brandsButtonSearchIcon);
        //

        _carChoiceButton = ButtonFactory.transparentButton();
        _carChoiceButton.alpha =0;
        _carChoiceButton.addEventListener(Event.TRIGGERED,searchMenuToggleEvent);


        brandsListTopBack = ButtonFactory.imageByTexture("make_bg_top2");
        brandsListTopBack.name = "brandsListTopBack";
        brandsListTopBack.visible = false;

        brandsListBotBack = new Quad(1,1,0xFFFFFF);
        brandsListBotBack.name = "brandsListBotBack";
        brandsListBotBack.visible = false;

        //searchMenuCloseButton.height = searchMenuCloseButton.width  = brandListButton.height;
        //searchFullCloseButton.width  = searchFullCloseButton.height = brandListButton.height;

        var brandsLayout : VerticalLayout = new VerticalLayout();
        brandsLayout.scrollPositionVerticalAlign = VerticalAlign.TOP;
        //brandsLayout.manageVisibility = true;
        brandsLayout.useVirtualLayout = true;
        brandsLayout.gap = 0;
        brandsList = new List();
        brandsList.name = "brandsList";
        brandsList.clipContent = true;
        brandsList.layout = brandsLayout;
        brandsList.paddingTop = 10;
        brandsList.paddingBottom = 4;
        brandsList.visible = false;
        brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
        brandsList.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
        brandsList.verticalScrollBarFactory = verticalScrollBarFactory;
        brandsList.itemRendererFactory = brandsListItemRendererFactory;



        carsListTopBack = ButtonFactory.imageByTexture("make_bg_top2");
        carsListTopBack.name = "carsListTopBack";
        carsListTopBack.visible = false;

        carsListBotBack = new Quad(1,1,0xFFFFFF);
        carsListBotBack.name = "carsListBotBack";
        carsListBotBack.visible = false;

        var carsLayout : TiledRowsLayout = new TiledRowsLayout();
        carsLayout.requestedColumnCount = carListRequestedColumns;
        carsLayout.useSquareTiles = false;
        carsLayout.verticalAlign = VerticalAlign.TOP;
        carsLayout.horizontalAlign = HorizontalAlign.LEFT;
        //carsLayout.manageVisibility = true;
        carsLayout.useVirtualLayout = true;
        carsLayout.gap = 0;
        carsList = new ExtendedList();
        carsList.name = "carsList";
        carsList.clipContent = true;
        carsList.paddingTop = 10;
        carsList.paddingBottom = 4;
        carsList.layout = carsLayout;
        carsList.visible = false;

        carsList.addEventListener(Event.CHANGE, carsListChangeHandler);
        carsList.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
        carsList.verticalScrollBarFactory = verticalScrollBarFactory;
        carsList.itemRendererFactory = carsListItemRendererFactory;




        addChild(featuredCarsList);

        addChild(displayImage);
        addChild(updateTextLabel);
        addChild(lftSlidButton);
        addChild(featuredButton);
        addChild(rgtSlidButton);
        if (rewardsButton) {
            addChild(rewardsButton);
        }

        addChild(dummyButton);
        addChild(searchBlocker);
        addChild(brandListButton);
        addChild(_carChoiceButton);
        addChild(searchMenuFullButton);
        addChild(searchMenuCloseButton);
        addChild(searchFullCloseButton);
        addChild(brandsListBotBack);
        addChild(brandsListTopBack);
        addChild(carsListBotBack);
        addChild(carsListTopBack);
        addChild(carsList);
        addChild(brandsList);
        addChild(searchView);



        redrowIndex = getChildIndex(searchView) - 1;
        /////////////////////////////////////////////////////////////////////////////////

        purchaseView = new PurchaseView();
        purchaseView.name = "purchaseView";
        purchaseView.setSize(featuredButton.width, featuredButton.height*4);
        purchaseView.hide();
        purchaseView.addEventListener(Event.OPEN, purchaseViewOpen);
        addChild(purchaseView);

        if (!LanguageItemRenderer.SHORT_LABEL){
            LanguageItemRenderer.SHORT_LABEL={};
            LanguageItemRenderer.SHORT_LABEL['ru-RU']='RUS';
            LanguageItemRenderer.SHORT_LABEL['en-US']='ENG';
        }

        createPackagesView();

        blockerView = new BlockerView();
        blockerView.name = "blockerView";
        blockerView.visible = false;
        addChild(blockerView);


        var rewardNotificationTexture: Texture = assetManager.getTexture('notification');
        rewardNotificationImage = new Image(rewardNotificationTexture);
        rewardNotificationImage.name = 'notificationReward';

        rewardNotificationImage.width = rewardNotificationTexture.width;
        rewardNotificationImage.height = rewardNotificationTexture.height;
        rewardNotificationImage.visible = false;
        addChild(rewardNotificationImage);

        updateModeView();

        rewardsAdsAvailable = AdsManager.$.haveRewardAds;
        if(rewardsAvailable && rewardsButton){
            rewardsButton.visible = true;
            rewardNotificationImage.visible = true;
            rewardNotificationImage.alpha = (rewardsAdsAvailable? 1: 0);
            //
            rewardNotificationImage.x =  rewardsButton.x +  rewardsButton.width -  rewardNotificationImage.width;
            rewardNotificationImage.y =  rewardsButton.y;
        }
    }

    private function createPackagesView():void{
        if (!packagesView) {
            packagesView = new PackagesView();
            packagesView.name = "packagesView";

            PackagesView.calacItemCount = true;

            var startWidth:int = Device.isIos() ? 262 : Constants.SCALE_FACTOR == 3.375 ? 262 : 262;

            packagesView.setSize(startWidth, actualHeight);
            packagesView.hide();
            packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.parentActualWith = actualWidth;
            packagesView.parentActualHeight = actualHeight;
            packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.addEventListener(Event.OPEN, packagesViewOpen);
            packagesView.addEventListener(Event.CLOSE, packagesViewClose);
            packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);
            packagesView.addEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
            packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);

            addChild(packagesView);
        }
    }

    private function createPurchaseView():void{
        if (!purchaseView) {
            purchaseView = new PurchaseView();
            purchaseView.name = "purchaseView";
            purchaseView.setSize(featuredButton.width, featuredButton.height*4);
            purchaseView.hide();
            purchaseView.addEventListener(Event.OPEN, purchaseViewOpen);
            addChild(purchaseView);
        }
    }

    private function initIcons():void{

        if(AppMode.self.mode == AppMode.MODE_TUNING){
            brandsButtonIcon = new Image(ButtonFactory.assetManager.getTexture("care_btn"));
            featuresIcon = new Image(ButtonFactory.assetManager.getTexture("care_btn"));
        }else if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR){
            brandsButtonIcon = new Image(ButtonFactory.assetManager.getTexture("truck_icon"));
            featuresIcon = new Image(ButtonFactory.assetManager.getTexture("truck_icon"));
        }

        var colorFilter1:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter1.tint(0x535353, 1);
        var colorFilter2:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter2.tint(0x535353, 1);
        featuredButton.addChild(featuresIcon);
        brandListButton.addChild(brandsButtonIcon);

        featuresIcon.filter = colorFilter1;
        brandsButtonIcon.filter = colorFilter2;
        featuresIcon.width = featuresIcon.height = 22;
        featuresIcon.x = 18;
        featuresIcon.y = (featuredButton.height - featuresIcon.height) / 2;

        brandsButtonIcon.width = brandsButtonIcon.height = 18;
        brandsButtonIcon.x = 8;
        brandsButtonIcon.y = (brandListButton.height - brandsButtonIcon.height) / 2;
    }

    public function updateArrowStates() : void
    {
        if (!_featuredCars || _featuredCars.length <= 1){
            if(lftSlidButton)
            {
                lftSlidButton.visible = rgtSlidButton.visible = false;
            }
            return;
        }

        lftSlidButton.visible = rgtSlidButton.visible = true;


        if (feauturedItemIndex == _featuredCars.length - 1){
            lftSlidButton.alpha =  1;
            rgtSlidButton.alpha = .5;
        }
        else if (feauturedItemIndex == 0){
            lftSlidButton.alpha = .5;
            rgtSlidButton.alpha =  1;
        }
        else {
            rgtSlidButton.alpha = lftSlidButton.alpha = 1;
        }

        rgtSlidButton.addEventListener(Event.TRIGGERED, feauturedListChange);
        lftSlidButton.addEventListener(Event.TRIGGERED, feauturedListChange);
    }

    private function friendRequestButtonHandler(event:Event):void
    {
        trace("friendRequestButtonHandler");
        if (!userSignedIn){
            dispatchEventWith(BrandsScreen.LOGIN_SELECTED);
        }
    }

    protected function featuredCompleteLoad(event:Event):void{
        AppMode.self.dispatchEventWith("featuredCompleteLoad");
    }

    public function updateNotifications() :void{
        if(dummyButton){
            dummyButton.updateNotification();
        }
        if(mainMenuView){
            mainMenuView.updateNotificationCount();
        }
    }



    protected function onDummyButtonHandler(event:Event):void{
        if(mainMenuView) {
            mainMenuView.toggle();
        }
    }


    private function verticalScrollBarFactory() : ScrollBar
    {
        var scrollbar:ScrollBar = new ScrollBar();
        scrollbar.direction = Direction.VERTICAL;
        scrollbar.thumbFactory = function() : Button {
            var button : Button = new Button();
            var sprite : Sprite = new Sprite();
            var back : Quad = new Quad(8, 25, 0xffffff);
            back.alpha = 0;
            var quad : Quad = new Quad(4, 25, 0xC1C3C2);
            quad.x = -2;
            sprite.addChild(back);
            sprite.addChild(quad);
            button.defaultSkin = sprite;
            return button;
        };
        return scrollbar;
    }

    private function verticalScrollBarFactory1() : ScrollBar
    {
        var scrollbar:ScrollBar = new ScrollBar();
        scrollbar.direction = Direction.VERTICAL;
        scrollbar.thumbFactory = function() : Button {
            var button : Button = new Button();
            var sprite : Sprite = new Sprite();
            var back : Quad = new Quad(8, 25, 0xffffff);
            back.alpha = 0;
            var quad : Quad = new Quad(4, 25, 0xC1C3C2);
            quad.x = 7;
            sprite.addChild(back);
            sprite.addChild(quad);
            button.defaultSkin = sprite;
            return button;
        };
        return scrollbar;
    }

    private var verticalGap : Number = 15;
    private var vertPadding : Number = 4.2;
    protected override function layoutMenuViews() : void
    {
        super.layoutMenuViews();

        if (mainMenuView){
            mainMenuView.caller = null;
            mainMenuView.hide();
        }

        ////////////////////////////////////////////////////////////
        if (backgroundImage){
            backgroundImage.y = 0;
            backgroundImage.setSize(actualWidth,actualHeight);
            backgroundImage.alignCenter();
        }

        lftSlidButton.y = (actualHeight) / 2 - 11;
        lftSlidButton.x = lftSlidButton.width / 2;
        rgtSlidButton.y = lftSlidButton.y;

        brandListButton.y = vertPadding + topButtonPadding + (mainMargin + 1.5);
        brandListButton.x = (actualWidth - brandListButton.width) / 2;

        if(Device.isIphoneXVariant()){
            brandListButton.y+= 6;
            setNavButtonPosition();
        }

        this._carChoiceButton.x = 100;
        this._carChoiceButton.y = 0;

        this._carChoiceButton.width = actualWidth - 200;
        _carChoiceButton.height = 40;


        ///////////////////////////////////////////////
        // search
        searchView.height = brandListButton.height;

        var view_offset : Number;
        if (Constants.SCALE_FACTOR == 4) {
            view_offset = Constants.isIOS ? 160 : 190;
        }
        else if (Constants.SCALE_FACTOR == 2){
            view_offset = Constants.isIOS ? 190 : 200;
        }
        else {
            view_offset = 190;
        }

        searchView.width = actualWidth - view_offset;
        searchView.x = (actualWidth - searchView.width) / 2;
        searchView.y = brandListButton.y;
        ///////////////////////////////////////////////

        // Brands
        if (brandsList){
            brandsList.x = searchView.x;
            brandsList.y = brandListButton.y + brandListButton.height + 15;
            brandsList.width = (searchView.width - 10) / 2;
            brandsList.height = actualHeight - brandsList.y;
        }

        if (brandListSeperator && serchViewMaximized) {
            brandListSeperator.y = searchView.y + searchView.height + 8;
            brandListSeperator.height = actualHeight - brandListSeperator.y;
        }

        if (carListSeperator && serchViewMaximized){
            carListSeperator.x = carsList.x + carsList.width / 2;
            carListSeperator.y = searchView.y + searchView.height + 8;
            carListSeperator.height = actualHeight - brandListSeperator.y;
        }

        if (brandsList){
            brandListButton.visible = !brandsList.visible ;
        }

        brandsListTopBack.x = searchView.x;
        brandsListTopBack.y = searchView.y + searchView.height + 5;
        brandsListTopBack.width  = (searchView.width - 10) / 2;
        brandsListTopBack.height = brandListButton.height;

        brandsListBotBack.x = brandsListTopBack.x;
        brandsListBotBack.y = brandsListTopBack.y + brandsListTopBack.height / 2;
        brandsListBotBack.width = brandsListTopBack.width;
        brandsListBotBack.height = actualHeight - (brandsListTopBack.y + brandsListTopBack.height / 2);

        // Cars
        if (carsList){
            carsList.x = brandsList.x + brandsList.width + 10;
            carsList.y = brandListButton.y + brandListButton.height + 15;
            carsList.width = brandsList.width;
            carsList.height = actualHeight - carsList.y;
        }

        carsListTopBack.x = brandsListTopBack.x + brandsListTopBack.width + 10; //carsList.x - 5;
        carsListTopBack.y = brandsListTopBack.y;
        carsListTopBack.width = brandsListTopBack.width; //carListButton.width + 27;
        carsListTopBack.height = brandListButton.height;

        carsListBotBack.x = carsListTopBack.x;
        carsListBotBack.y = carsListTopBack.y + carsListTopBack.height / 2;
        carsListBotBack.width = carsListTopBack.width;
        carsListBotBack.height = brandsListBotBack.height;

        searchFullScreenMenuToggle();

        //if (Constants.IN_APP_PURCHASE_ENABLED){
        //restoreButton.visible = true;
        //}

        searchMenuCloseButton.x = 0;
        searchMenuCloseButton.y = 0;//vertPadding + topButtonPadding;

        featuredButton.x = 0;
        featuredButton.y = actualHeight - featuredButton.height - bottomMargin;

        if (rewardsButton) {
            rewardsButton.x = actualWidth - rewardsButton.width - mainMargin;
            rewardsButton.y = mainMargin;

            if (Device.isIphoneXVariant()) {
                rewardsButton.x -= 15;
                rewardsButton.y += 6;
            }
            //
            if(rewardNotificationImage){
                rewardNotificationImage.x =  rewardsButton.x +  rewardsButton.width -  rewardNotificationImage.width;
                rewardNotificationImage.y =  rewardsButton.y;
            }
        }
        //searchMenuCloseButton.x = 0;
        searchMenuFullButton.x = actualWidth - searchMenuFullButton.width - vertPadding;
        searchMenuFullButton.y = vertPadding + topButtonPadding;
        searchFullCloseButton.x = actualWidth - searchFullCloseButton.width - vertPadding * 1.5;
        searchFullCloseButton.y = vertPadding + topButtonPadding + 6;

        dummyButton.x = mainMargin;//searchMenuCloseButton.x - (dummyButton.width  - searchMenuCloseButton.width)  / 2;
        dummyButton.y = mainMargin + topButtonPadding;



        //notificationButton.x = dummyButton.x + dummyButton.width + 6;
        //notificationButton.y = dummyButton.y + (dummyButton.height - notificationButton.height) / 2;

        //friendRequestsButton.x = notificationButton.x + friendRequestsButton.width + 6;
        //friendRequestsButton.y = notificationButton.y;

        //if (_notificationPanelView) {
        //    _notificationPanelView.y = dummyButton.height + dummyButton.y + 6;
        //    _notificationPanelView.setSize(actualWidth, actualHeight - _notificationPanelView.y)
        //}

        featuredButton.x = 0;
        featuredButton.y = actualHeight - featuredButton.height - bottomMargin;
        displayImage.x = actualWidth - displayImage.width;
        displayImage.y = actualHeight - displayImage.height - bottomMargin;
        if(Device.isIphoneXVariant()){
            displayImage.y-=6;

            //featuredButton.x += 6;
            featuredButton.y -= 6;

            searchMenuCloseButton.y += 6;
            searchMenuCloseButton.x += 6;

            searchMenuFullButton.y += 6;

            searchFullCloseButton.y += 6;
            searchFullCloseButton.x =-11;

            dummyButton.x += 6;
            dummyButton.y += 6;

            setNavButtonPosition();
        }

        updateTextPosition();
        searchBlocker.x = 0;
        searchBlocker.y  = topButtonPadding;
        searchBlocker.width  = actualWidth;
        searchBlocker.height = actualHeight - topButtonPadding;
    }

    public function setNavButtonPosition():void{
        if(!stage){
            return;
        }
        var marginSize:Number = 24;
        if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_RIGHT){
            lftSlidButton.x = lftSlidButton.width / 2 + marginSize;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2;
        }else if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_LEFT){
            lftSlidButton.x = lftSlidButton.width / 2;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2 - marginSize;
        }else{
            lftSlidButton.x = lftSlidButton.width / 2;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2;
        }
    }

    protected function onSearchAnimationUpdate(event:Event):void {
    }

    protected function onPackageAnimationUpdate(event:Event):void {
    }

    private function onChangeSearchInput(event:Event):void {
        var text : String = StringUtil.trim(searchView.text).toLowerCase();

        this._car_filter = text;

        var filtered_brands :Array=[];
        for (var i:int = 0; i < _brands.length; i++)
        {
            var brand:Brand = _brands[i];
            var flagAddBrand:Boolean = false;
            var flagBrandFull:Boolean = false;

            //Проверяем вхождения в бренд
            var brandName:String = brand.name.toLowerCase();


            if (brandName.indexOf(text) >= 0 || text.indexOf(brandName) == 0)
            {
                flagAddBrand = true;

                if (text.indexOf(brandName) == 0){
                    flagBrandFull = true;
                }
            }

            if (text == ""){
                flagAddBrand = true;
            }

            var car_name_search:String = text;

            if (flagAddBrand && text != "" && flagBrandFull){
                car_name_search = StringUtil.trim(text.replace(brandName, ""));
            }

            if (!flagAddBrand)
            {
                //Теперь ищем в машинах
                for (var j:int=0; j<brand.cars.length; j++)
                {
                    var car:Car = brand.cars[j];
                    var carName:String = car.displayName;//car.name+" "+car.model+" "+car.year;
                    carName = carName.toLowerCase();

                    if (carName.indexOf(car_name_search) >= 0){
                        flagAddBrand = true;
                        break;
                    }
                }
            }

            if (flagAddBrand){
                filtered_brands.push(brand);
            }
        }
        if(!brandsList)
            return;

        brandsList.dataProvider = new ListCollection(filtered_brands);

        if (filtered_brands.length >= 1){
            brandsList.selectedIndex = 0;
        }
        else {
            carsList.dataProvider = new ListCollection([]);
        }
    }

    private function setBulletStyle(in_html:String, bulletColor_ : Number = NaN, bulletSize_ : Number = NaN, bulletFont_ : String = null, indent_ : Number = NaN) : String
    {
        if (!in_html) return "";

        var out : String = in_html;//textField_.htmlText;
        var find : String = "<LI>";
        var replace : String = find;

        // you have to insert a character between the font tags, otherwise the Textfield will dump the tags
        // preferably you should take a character which isn't embeded in the font
        var nonPrintingChar : String = String.fromCharCode(1);

        // indent start
        if (!isNaN(indent_)) replace = "<TEXTFORMAT LEFTMARGIN=\"" + indent_ + "\">" + find;

        replace += "<FONT";
        // add font
        if (bulletFont_) replace += " FACE='" + bulletFont_ + "'";
        // add size
        if (!isNaN(bulletSize_)) replace += " SIZE='" + bulletSize_.toString() + "'";
        // close tag
        replace += ">" + nonPrintingChar + "</FONT>";

        // color
        if (!isNaN(bulletColor_)){
            replace += "<FONT COLOR='" + getColorWebFormat(bulletColor_) + "'>" + nonPrintingChar + "</FONT>";
        }

        // simple replace
        out = out.split(find).join(replace);

        // indent end
        if (!isNaN(indent_))
        {
            find = "</LI>";
            replace = find + "</TEXTFORMAT>";
            out = out.split(find).join(replace);
        }

        return out;
    }

    private function getColorWebFormat(color_ : uint) : String
    {
        var result : String = color_.toString(16).toUpperCase();
        while(result.length < 6) result = "0" + result;
        return "#" + result;
    }

    private function viewCar360(event:Event):void {
        var car:Car = event.data.car;
        var packet:Packet = event.data.packet;
        dispatchEventWith(PackagesView.VIEW_CAR_360, false, {car:car, packet:packet});
    }

    private function displayRewardConfirmPopUp(event: Event): void {
        var packet: Packet = event.data.packet;
        dispatchEventWith(PackagesView.SHOW_CONFIRM_POP_UP, false, {packet: packet});
    }

    private function displayRewardNoCoinPopUp(event:Event):void {
        dispatchEventWith(PackagesView.SHOW_NO_COIN_POP_UP);
    }

    private function onBuyNowPacket(event:Event):void{
        this.dispatchEventWith(BUY_NOW_PACKET, false, {packet:event.data.packet as Packet});
    }

    protected function onPackagesViewCalcWidthEnd(event:Event=null):void
    {
        packagesView.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        packagesView.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        packagesView.removeEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
        packagesView.removeEventListener(Event.OPEN, packagesViewOpen);
        packagesView.removeEventListener(Event.CLOSE, packagesViewClose);
        packagesView.removeEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
        packagesView.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);

        packagesView.removeEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        packagesView.removeEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);

        packagesView.removeFromParent(true);

        packagesView = new PackagesView();
        packagesView.name = "packagesView";
        PackagesView.calacItemCount = false;
        packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);
        packagesView.hide();
        packagesView.parentActualWith = actualWidth;
        packagesView.parentActualHeight = actualHeight;
        packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
        packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        packagesView.addEventListener(Event.OPEN, packagesViewOpen);
        packagesView.addEventListener(Event.CLOSE, packagesViewClose);
        packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);
        packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
//			packagesView.dataProvider = _filteredPackages;
        addChild(packagesView);

        if (AlertView.language) packagesView.updateWithLanguage(AlertView.language);

        packages = _packages;

        this.invalidate(FeathersControl.INVALIDATION_FLAG_SIZE);
    }


    protected function packagesViewOpen(event:Event) : void {
        this.purchaseView.visible = false;
    }

    protected function packagesViewClose(event:Event) : void {
        AdsManager.$.showBannerAfterComplete = true;
        AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
    }

    protected function purchaseViewOpen(event:Event) : void {
        //trace("purchaseViewOpen()");
        this.packagesView.visible = false;
    }

    protected function itemTouchPacket(event:Event):void{
        this.dispatchEventWith(PacketItemRenderer.ITEM_TOUCH_PACKET, false, {packet:event.data.packet as Packet});
    }

    protected function touchPacketInfo(event:Event):void{
        this.dispatchEventWith(PacketItemRenderer.TOUCH_PACKET_INFO, false, {packet:event.data.packet as Packet});
    }

    private function  debugInfoLabelRenderer ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), 9, 0x000000);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.letterSpacing = -.35;
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;

        textRenderer.isHTML = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    private function  titleLabelRenderer ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 9, 0xFFFFFF);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.letterSpacing = -.1;
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.isHTML = true;
        textRenderer.wordWrap = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    private function  textLabelRenderer ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 9, 0xFFFFFF);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.letterSpacing = -.1;
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static  function customCheckFactory(leftTitle : String, rightTitle : String, topTitle : String, isSelected: Boolean) : MultilingualToggleSwitch
    {
        var check : MultilingualToggleSwitch = new MultilingualToggleSwitch(isSelected);
        check.isHTML = true;
        check.x = 0;
        check.leftTitle  = leftTitle;
        check.rightTitle = rightTitle;
        check.topTitle   = topTitle;
        return check;
    }



    public function dispatchExternalEvent(msg:String):void {
        if (mainMenuView) mainMenuView.hide();
        dispatchEventWith(msg);
    }

    private function instructionButtonTriggeredHandler(event:Event=null) : void{
        dispatchEventWith(INSTRUCTION_SELECTED);
    }

    private function miniframeButtonTriggeredHandler(event : Event) : void{
        dispatchEventWith(MINIFRAME_SELECTED);
    }

    public function set ads(value:Object):void{
        _ads = value;
    }
    public function get ads():Object{
        return _ads;
    }

    private function getTextFieldTextFormat() : TextFormat
    {
        var useEmbeddedFont:Boolean = false;
        var bold:Boolean = false;
        var fontSize:int = 10;
        var textColor:uint = 0xffffff;
        var fontName:String =  (FontSelector.getFont(bold));
        var textFormat : TextFormat = new TextFormat(fontName, fontSize, textColor);
        textFormat.bold=bold;
        textFormat.align = TextFormatAlign.CENTER;
        return textFormat;
    }

    private  function getTextFormat() : Object{
        return getTextFieldTextFormat();
    }

    public function set packages(value:Array) : void {
        _packages = value;

        if (_packages && _packages.length > 0){
            featuredButton.visible = true;
        }

        _filteredPackages = Packet.filteringPackages(_packages);

        createPackagesView();
        packagesView.dataProvider = _filteredPackages;

        var facade : ApplicationFacade = ApplicationFacade.getInstance();
        var packagesProxy:PackagesProxy= facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;

        var car : Car;
        var i:int;

        if (carsList)
        {
            if (carsList.dataProvider) {
                for (i = 0; i < carsList.dataProvider.length; i++){
                    car = carsList.dataProvider.getItemAt(i) as Car;
                    carsList.dataProvider.updateItemAt(i);
                }
            }
            carsList.invalidate();
        }

        if (featuredCarsList)
        {
            if (featuredCarsList.dataProvider) {
                for(i = 0; i < featuredCarsList.dataProvider.length; i++){
                    car = featuredCarsList.dataProvider.getItemAt(i) as Car;
                    featuredCarsList.dataProvider.updateItemAt(i);
                }
            }
            featuredCarsList.invalidate();
        }
    }

    public function get packages():Array {
        return _packages;
    }

    public function updateCarList():void {
        if (carsList) {
            if (carsList.dataProvider) {
                for (var i:int = 0; i < carsList.dataProvider.length; i++) {
                    carsList.dataProvider.updateItemAt(i);
                }
            }
            carsList.invalidate();
        }
    }

    public function set purchases(value : Array) : void {
        _purchasedList = value;
        var allPacketsIsOpen: Boolean = false;
        var i:int;
        for (i = 0; i< value.length; i++) {
            var packetType: String = value[i].type;
            if (packetType ==  Packet.TYPE_ALLPACKET) {
                allPacketsIsOpen = true;
                break;
            }
        }

        if (allPacketsIsOpen) {
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var packagesProxy:PackagesProxy= facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
            var packets: Array = packagesProxy.packages;
            for (i = 0; i < packets.length; i++) {
                packets[i].lock = false;
            }
        }

        createPurchaseView();
        purchaseView.dataProvider = _purchasedList;
        if (packagesView && packagesView.dataProvider) {
            for(i = 0; i < packagesView.dataProvider.length; i++){
                if (allPacketsIsOpen) {
                    var pk: Packet = packagesView.dataProvider[i];
                    pk.lock = false;
                }
                packagesView.updateItemAt(i);
            }
        }

        packagesView.invalidate();
        if (carsList) {
            if (carsList.dataProvider){
                for(var ij:int = 0; ij < carsList.dataProvider.length; ij++){
                    carsList.dataProvider.updateItemAt(ij);
                }
            }
            carsList.invalidate();
        }

        var car:Car;
        if (this.featuredCarsList) {
            if (this.featuredCarsList.dataProvider) {
                for (var ii:int = 0; ii < featuredCarsList.dataProvider.length; ii++){
                    car = featuredCarsList.dataProvider.getItemAt(ii) as Car;
                    featuredCarsList.dataProvider.updateItemAt(ii);
                }
            }
            featuredCarsList.invalidate();
        }

        if(_purchasedList.length == 0){
            packagesView.clearPurchases();
        }else{
            for(var j:int = 0; j < _purchasedList.length; j++){
                packagesView.packetPurchaseUpdate(_purchasedList[j]);
            }
        }
    }

    public function get purchases():Array{
        return _purchasedList;
    }

    public function set brands(value : Array) : void
    {
        _brands = value;
        if (!brandsList) return;

        brandsList.dataProvider = new ListCollection(brands);
    }
    public function get brands() : Array {
        return _brands;
    }

    protected override function draw() : void
    {
        if (!brandsList) return;
        super.draw();
        if (!mainMenuView){
            mainMenuView = new MainMenuView();
            mainMenuView.name = "mainMenuView";
            mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight);
            mainMenuView.parentActualWidth = actualWidth;
            mainMenuView.parentActualHeight = actualHeight;
            addChildAt(mainMenuView,getChildIndex(blockerView) - 1);

            mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
            mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
        }
        if (brandsList && brandsList.selectedIndex == -1) {
            brandsList.selectedIndex = 0;
        }
        if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR || AppMode.self.mode == AppMode.MODE_TUNING) {
            if(featuredCarsList && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length && featuredCarsList.horizontalPageIndex>-1){
                var car:Car = featuredCarsList.dataProvider.getItemAt(featuredCarsList.horizontalPageIndex) as Car;
                brandListButton.label = getCarLabel(car);
            }
        }else{
            if (brandListButton && _language){
                brandListButton.label = _language.translate("mob_home","carBrands");
            }
        }

        var sizeInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);
        if (sizeInvalid)
        {
            searchMenuFullButton.y  = vertPadding + topButtonPadding;
            searchFullCloseButton.y = vertPadding + topButtonPadding + 6;


            lftSlidButton.y = (actualHeight) / 2 - 11;
            rgtSlidButton.y = lftSlidButton.y;

            featuredCarsList.height = actualHeight;
            //trace("featuredCarsList.height:", featuredCarsList.height)
            featuredCarsList.y =0;//vertPadding + 6 + brandListButton.height + verticalGap;//95;

            updateFeaturedCarList();

            if (featuredCarsList.dataProvider) {
                var tlen : int = featuredCarsList.dataProvider.length;
                featuredCarsList.width = this.actualWidth * (tlen > 1 ? featuredCarsList.dataProvider.length / tlen : 1);
                featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;

                if (featuredCarsList.dataProvider.length > 1) {
                    lftSlidButton.alpha = .5;
                    rgtSlidButton.alpha = 1;
                    updateStandText();
                }
                else {
                    if (featuredCarsList.dataProvider.length == 1){
                        updateStandText();
                    }
                }
            }
            else {
                featuredCarsList.width = actualWidth * 1.0;
                featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;
            }

            _newFrameImageHeight = actualHeight - menuHeight;

            layoutMenuViews();

            featuredButton.x = 0;
            featuredButton.y = actualHeight - featuredButton.height - bottomMargin;
            if(Device.isIphoneXVariant()){
                //featuredButton.x += 6;
                featuredButton.y -= 6;
            }

            if (packagesView)
            {
                packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);
                packagesView.x = 0;
                packagesView.y = 0;
                packagesView.parentActualWith = actualWidth;
                packagesView.parentActualHeight = actualHeight;
                purchaseView.setSize(packagesView.width, ((actualHeight - menuHeight - 70)));
                purchaseView.x = 10;
                purchaseView.y = 10 + topButtonPadding;
            }

            if (mainMenuView){
                mainMenuView.y = topButtonPadding;
                mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight - topButtonPadding);
                mainMenuView.parentActualWidth = actualWidth;
                mainMenuView.parentActualHeight = actualHeight - topButtonPadding;
            }

            blockerView.setSize(this.actualWidth, this.actualHeight);

            dummyButton.x = mainMargin;
            dummyButton.y = topButtonPadding + mainMargin;
            if(Device.isIphoneXVariant()){
                dummyButton.x += 6;
                dummyButton.y += 6;
            }
        }

        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }
    }

    private function menuOpenHandler(event:Event):void {
        dispatchEventWith(OPEN_MAIN_MENU);
    }

    private function menuCloseHandler(event:Event):void {
        dispatchEventWith(CLOSE_MAIN_MENU);
    }

    public function showBlocker() : void {
        if (this.blockerView) blockerView.visible = true;
    }

    public function hideBlocker() : void {
        if (this.blockerView) blockerView.visible = false;
    }

    private function createFeaturedCar(car:Car):void {
        var fcImageLoader:ImageLoaderWithStates = new ImageLoaderWithStates();
        fcImageLoader.overrideDispose = true;
        fcImageLoader.touchable = true;
        addChild(fcImageLoader);
    }

    public function get languages() : Array{
        return _languages;
    }
    public function set languages(value : Array):void {
        _languages = value;
        invalidate("languages");
    }

    private function featuredCarListChangeHandler(event:Event=null):void
    {
        if (!featuredCars || featuredCarsList.selectedIndex < 0){
            featuredCarsList.selectedIndex = -1;
            return;
        }

        trace("featuredCarListChangeHandler")

        var selectedFeaturedCar : Car = this.featuredCars[featuredCarsList.selectedIndex];

        //selectedFeaturedCar = BrandsParser.allCarsList[selectedFeaturedCar.id]

        if (selectedFeaturedCar) {
            SoundManager.playSound(SoundManager.SELECT_PART);
            dispatchEventWith(CAR_SELECTED, false, selectedFeaturedCar);
        }

        featuredCarsList.selectedIndex = -1;
    }

    private function brandsListChangeHandler(event:Event) : void
    {
        var selectedCarBrand : Brand = brandsList.selectedItem as Brand;
        if (selectedCarBrand == null) {
            return;
        }
        if(brandsList.visible){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
        _lastSelectedBrand = selectedCarBrand;

        var cars : Array = [];
        if (_car_filter != "")
        {
            var flagBrandFull : Boolean = _car_filter.indexOf(selectedCarBrand.name.toLowerCase()) == 0;
            var search : String = StringUtil.trim(_car_filter);

            if (flagBrandFull){
                search = StringUtil.trim(search.replace(selectedCarBrand.name.toLowerCase(), ""));
            }

            if (search != "")
            {
                for (var i:int = 0; i < selectedCarBrand.cars.length; i++)
                {
                    var car:Car = selectedCarBrand.cars[i];
                    var carName:String = car.displayName.toLowerCase(); //car.name+" "+car.model+" "+car.year;
                    carName = carName.toLowerCase();

                    if (carName.indexOf(search) >= 0) cars.push(car);
                }
            }
            else {
                cars = selectedCarBrand.cars;
            }
        }
        else {
            cars = selectedCarBrand.cars;
        }

        var showBrand : Boolean = selectedCarBrand.lastAdded;

        var collection : ListCollection = new ListCollection(cars);
        carsList.dataProvider = collection;
        carsList.data = {
            showBrand : showBrand
        }
    }

    private function feauturedListChange(event:Event=null) : void
    {
        if(featuredCarsList.isScrolling) return;

        if (!featuredCarsList || featuredCarsList.dataProvider==null ||  featuredCarsList.dataProvider.length < 1) {
            return;
        }

        var dir : int = 'leftArrow' == Button(event.target).name ? -1 : 1;

        if(featuredCarsList.horizontalPageIndex==0 && dir==-1)
            return;

        if(featuredCarsList.horizontalPageIndex==featuredCarsList.dataProvider.length-1 && dir==1)
            return;

        feauturedItemIndex = featuredCarsList.horizontalPageIndex + dir;

        featuredCarsList.scrollToDisplayIndex(feauturedItemIndex, 0.5);
        featuredCarsList.dataProvider.updateItemAt(featuredCarsList.horizontalPageIndex + dir);

    }

    private function carsListChangeHandler(event : Event) : void
    {
        if (AppMode.self.mode == AppMode.MODE_TUNING) {
            closeSearchMenu();
            if (carsList.selectedItem) {
                SoundManager.playSound(SoundManager.SELECT_PART);
                dispatchEventWith(BrandsScreen.CAR_SELECTED, false, carsList.selectedItem);
                if (carsList) {
                    carsList.selectedIndex = -1;
                }
            }
        } else if (AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR) {
            if(carsList.selectedItem && featuredCarsList.dataProvider.contains(carsList.selectedItem)) {
                var car:Car = carsList.selectedItem as Car;
                brandListButton.label = getCarLabel(car);
                featuredCarsList.removeEventListener(Event.CHANGE, featuredCarListChangeHandler);
                featuredCarsList.selectedItem = carsList.selectedItem;
                featuredCarsList.scrollToPageIndex(featuredCarsList.selectedIndex, 0, 1);
                featuredCarsList.selectedIndex = -1;
                featuredCarsList.addEventListener(Event.CHANGE, featuredCarListChangeHandler);
                closeSearchMenu();
                showSearchButtons();
            }else{
                //dispatchEventWith(CAR_SELECTED, false, carsList.selectedItem); // TODO: remove
            }
        }
    }

    private static function getCarLabel(car:Car):String{
        if(!car){
            return '';
        }
        var year:String = (car.year?car.year.toString().substring(2):'');
        return (car.name?car.name:"").toUpperCase() + ' ' + (car.model?car.model:"") + ' “' + year;
    }

    private function searchMenuVisibility(isVisible : Boolean) : void {
        if(brandsList)brandsList.visible = isVisible;
        if(carsList)carsList.visible = isVisible;
        if(searchView)searchView.visible = isVisible;
        if(searchBlocker)searchBlocker.visible = isVisible;
        if(searchMenuCloseButton)searchMenuCloseButton.visible = isVisible;
        if(brandsListTopBack)brandsListTopBack.visible = isVisible;
        if(brandsListBotBack)brandsListBotBack.visible = isVisible;
        if(carsListBotBack)carsListBotBack.visible = isVisible;
        if(carsListTopBack)carsListTopBack.visible = isVisible;
        if(searchMenuFullButton)searchMenuFullButton.visible = isVisible;
        if(carListSeperator)carListSeperator.visible = isVisible;
        if(brandListSeperator)brandListSeperator.visible = isVisible;
        if(searchFullCloseButton)searchFullCloseButton.visible = isVisible;
        if(rewardsButton){
            rewardsButton.visible = rewardsAvailable && !isVisible;
        }
        if(dummyButton){
            dummyButton.visible = !isVisible;
        }
        if(rewardNotificationImage){
            rewardNotificationImage.visible = rewardsAvailable;
            rewardNotificationImage.alpha = ((rewardsAdsAvailable && !isVisible)? 1: 0);
        }

    }

    public function showSearchButtons() : void {
        brandListButton.visible = true;
    }

    private function closeSearchMenu() : void {
        searchMenuVisibility(false);
    }

    private function searchMenuToggleEvent(event:Event) : void
    {
        if (!brandsList || !brands ){
            return;
        }
//
//			if (_notificationPanelView && (_notificationPanelView.isNotificationsActive || _notificationPanelView.isFriendsActive)){
//                _notificationPanelView.hide();
//            }
        if(brandsList.visible){
            SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        }else{
            SoundManager.playSound(SoundManager.PART_MENU);
        }
        if (!brandsList.dataProvider || !carsList.dataProvider )
        {
            brandsList.dataProvider = new ListCollection(brands);
            brandsList.selectedIndex = 0;
            if (brandsList.selectedItem) {
                _lastSelectedBrand = brandsList.selectedItem as Brand;
                carsList.dataProvider = new ListCollection(_lastSelectedBrand.cars as Array);
            }
        }

        if(searchView) searchView.externalCallbeck();
        if(brandsList)brandsList.visible = !brandsList.visible;
        if(carsList)carsList.visible = !carsList.visible;
        if(searchView)searchView.visible = !searchView.visible;
        if(searchBlocker)searchBlocker.visible = !searchBlocker.visible;
        if(searchMenuCloseButton)searchMenuCloseButton.visible = !searchMenuCloseButton.visible;
        if(brandsListTopBack)brandsListTopBack.visible = !brandsListTopBack.visible;
        if(brandsListBotBack)brandsListBotBack.visible = !brandsListBotBack.visible;
        if(carsListBotBack)carsListBotBack.visible = !carsListBotBack.visible;
        if(carsListTopBack)carsListTopBack.visible = !carsListTopBack.visible;
        if(searchMenuFullButton)searchMenuFullButton.visible = !searchMenuFullButton.visible;
        if(brandsList && brandListButton) brandListButton.visible = !brandsList.visible;

        searchView.updateStates(1);

        searchFullScreenMenuToggle(new Event(Event.OPEN));
    }

    private function searchFullScreenMenuToggle(event:Event=null) : void
    {
        if (carsList && carsList.isScrolling) {
            carsList.stopScrolling();
        }

        if (brandsList && brandsList.isScrolling) {
            brandsList.stopScrolling();
        }

        if (searchBlocker.alpha != 1 && event && event.type == Event.TRIGGERED)
        {
            SoundManager.playSound(SoundManager.SELECT_PART);
            searchBlocker.color = 0xFFFFFF;
            searchBlocker.alpha = 1;
            serchViewMaximized = true;
        }
        else
        {
            searchBlocker.color = 0x000000;
            searchBlocker.alpha = .65;
            serchViewMaximized  = false;
            searchView.externalCallbeck();
        }

        if (serchViewMaximized)
        {
            searchMenuFullButton.visible  = false;
            searchMenuCloseButton.visible = false;
            searchMenuFullButton.visible  = false;

            searchFullCloseButton.visible = true;
            searchFullCloseButton.width = searchFullCloseButton.height = searchView.height ;
            searchFullCloseButton.x = actualWidth - searchFullCloseButton.width - vertPadding;

            if(Device.isIphoneXVariant()){

                searchFullCloseButton.x-=11;
            }

            searchView.stateMaximized = true;
            searchView.x = searchMenuCloseButton.x + 3;
            searchView.width = actualWidth - searchFullCloseButton.width - 5 * vertPadding;

            if(Device.isIphoneXVariant()){
                searchView.width-=50;
                searchView.x+=22;
            }

            brandsList.x = searchView.x + 4;
            brandsList.paddingTop = -2;
            brandsList.itemRendererFactory = brandsListItemRendererFactory;

            if(Device.isIphoneXVariant()){
                brandsList.x-=14;
            }

            if (!brandListSeperator)
            {
                brandListSeperator = new Quad(1,1,0xECECEC);
                brandListSeperator.x = brandsList.x + brandsList.width + 8;
                brandListSeperator.y = searchView.y + searchView.height + 8;
                brandListSeperator.height = actualHeight - brandListSeperator.y;
                addChildAt(brandListSeperator,getChildIndex(searchView));
            }
            else {
                brandListSeperator.visible = true;
            }

            carsList.x = brandListSeperator.x;
            var newWd : Number = actualWidth - brandListSeperator.x - 15;
            if(Device.isIphoneXVariant()){
                newWd-=20;
            }
            carsList.itemRendererFactory = function () : IListItemRenderer {
                var renderer : CarItemRenderer = new CarItemRenderer();
                renderer._underOffset = -5;
                renderer._carOffset = 7;
                renderer.setSize(newWd / 2, 100);
                return renderer;
            }

            if (carsList){
                carsList.width = newWd + 5;
                carsList.paddingTop = -2;
                carsList.verticalScrollBarFactory = verticalScrollBarFactory1;
            }

            carListRequestedColumns = 2;
            TiledRowsLayout(carsList.layout).requestedColumnCount = carListRequestedColumns;

            if (!carListSeperator){
                carListSeperator = new Quad(1,1,0xECECEC);
                carListSeperator.x = carsList.x + carsList.width / 2;
                carListSeperator.y = searchView.y + searchView.height + 8;
                carListSeperator.height = this.actualHeight - brandListSeperator.y;
                addChildAt(carListSeperator,getChildIndex(searchView) + 1);
            }
            else {
                carListSeperator.visible = true;
            }
        }
        else
        {
            searchView.stateMaximized = false;

            searchFullCloseButton.visible = false;
            searchMenuCloseButton.visible = searchBlocker.visible;
            searchFullCloseButton.visible = false;

            ///////////////////////////////////////////////
            var view_offset : Number;
            if (Constants.SCALE_FACTOR == 4) {
                view_offset = Constants.isIOS ? 180 : 190;
            }
            else if (Constants.SCALE_FACTOR == 2){
                view_offset = Constants.isIOS ? 190 : 200;
            }
            else {
                view_offset = 190;
            }
            ///////////////////////////////////////////////

            searchView.width = actualWidth - view_offset;
            searchView.x = (actualWidth - searchView.width) / 2;

            searchMenuFullButton.visible = searchBlocker.visible;

            if (brandsList && carsList)
            {
                brandsList.x = searchView.x;
                brandsList.y = brandListButton.y + brandListButton.height + 15;
                brandsList.width = (searchView.width - 10) / 2;
                brandsList.height = actualHeight - brandsList.y;

                carsList.x = brandsList.x + brandsList.width + 10;
                carsList.y = brandListButton.y + brandListButton.height + 15;
                carsList.width = brandsList.width;
                carsList.height = actualHeight - carsList.y;
                carsList.verticalScrollBarFactory = verticalScrollBarFactory;

                carListRequestedColumns = 1;
                TiledRowsLayout(carsList.layout).requestedColumnCount = carListRequestedColumns;
                carsList.itemRendererFactory = carsListItemRendererFactory;
            }

            if (brandListSeperator) {
                brandListSeperator.visible = false;
                carListSeperator.visible = false;
            }
        }

        searchView.updateStates();
        //
        if(carsList.visible){
            AdsManager.$.showBannerAfterComplete = false;
            AdsManager.$.bannerHide();
            rewardsButton.visible = dummyButton.visible = false;
            rewardNotificationImage.alpha = 0;
        }else if(event && event.type == Event.OPEN){
            AdsManager.$.showBannerAfterComplete = true;
            AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
            dummyButton.visible = true;
            rewardsButton.visible = rewardsAvailable;
            rewardNotificationImage.visible = rewardsAvailable;
            rewardNotificationImage.alpha = rewardsAdsAvailable?1:0;
        }
    }

    private function updateStandText(index:int = 0):void {
        if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR || AppMode.self.mode == AppMode.MODE_TUNING) {
            if(brandListButton && index > -1 && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length){
                var car:Car = featuredCarsList.dataProvider.getItemAt(index) as Car;
                brandListButton.label = getCarLabel(car);
            }
        }
        var visiblity : Boolean = false;
        var careInFocuse : Car = featuredCars[index];
        var tapStr:String = '<br/><font color="#ff0000" size="7" style="font-style:italic">&#34;<i>tap on car to start</i>&#34;</font>';

        if (Car.weakDevice) {
            careInFocuse = featuredCars[index];
            visiblity = (careInFocuse.updateText && careInFocuse.updateText.indexOf('<br>') != -1 || careInFocuse.updateText.length > 1 && careInFocuse.updateText.indexOf('test text') == -1);
            if (visiblity){
                updateTextLabel.text = careInFocuse.updateText + tapStr;
                updateTextLabel.visible = displayImage.visible = visiblity;
            }
            updateTextPosition();
            return;
        }

        if (careInFocuse && careInFocuse.updateText) {
            visiblity = (careInFocuse.updateText.indexOf('<br>') != -1);
            if (visiblity){
                updateTextLabel.text = careInFocuse.updateText + tapStr;
                updateTextLabel.visible = displayImage.visible = visiblity;
            }
        } else {
            updateTextLabel.visible = displayImage.visible = visiblity;
        }
        updateTextPosition();
    }

    private function updateTextPosition():void{
        updateTextLabel.width = displayImage.width - 20;
        updateTextLabel.validate();
        updateTextLabel.x = displayImage.x + 15;
        updateTextLabel.y = displayImage.y + (displayImage.height - updateTextLabel.height) / 2;
    }

    private var touches:Vector.<Touch> = new Vector.<Touch>;
    private function handleTouch(event:TouchEvent):void
    {
        var touch : Touch = event.touches[0] as Touch;

        if (touch.phase == TouchPhase.BEGAN){
            touchEventTriggered = true;
            if(carListIsScrolling && featuredCarsList.isScrolling){
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
        }

        if (touch.phase == TouchPhase.MOVED){
        }

        if (touch.phase == TouchPhase.ENDED){
            
        }
    }

    private function ftrListScrollHandler(event:Event) : void {
        if (featuredCarsList.isScrolling) {
            if(!carListIsScrolling){
                carListIsScrolling = true;
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
            return;
        }

        if(featuredCarsList.dataProvider==null || featuredCarsList.dataProvider.length == 0){
            return;
        }


        trace(featuredCarsList.selectedIndex);




        if(AppMode.self.mode === AppMode.MODE_TRUCK_CONFIGURATOR) {

            var allDataLength: int = featuredCarsList.horizontalPageCount;
            for (var i: int = 0; i <allDataLength; i++) {
                var dataItem:Object = featuredCarsList.dataProvider.getItemAt(i);

                var rendererItem:FeaturedCarItemRenderer = featuredCarsList.itemToItemRenderer(dataItem) as FeaturedCarItemRenderer;
                if (rendererItem.isLoaded) {
                    rendererItem.specialDispose();
                }
            }

            var data:Object = featuredCarsList.dataProvider.getItemAt(featuredCarsList.horizontalPageIndex);
            var renderer:FeaturedCarItemRenderer = featuredCarsList.itemToItemRenderer(data) as FeaturedCarItemRenderer;
            if(renderer) {
                renderer.loading();
            }
        }

        if (featuredCarsList.horizontalPageIndex == featuredCarsList.dataProvider.length -1){
            lftSlidButton.alpha =  1;
            rgtSlidButton.alpha = .5;
        } else if (featuredCarsList.horizontalPageIndex == 0){
            lftSlidButton.alpha = .5;
            rgtSlidButton.alpha =  1;
        } else {
            rgtSlidButton.alpha = lftSlidButton.alpha = 1;
        }
        carListIsScrolling = false;
        updateStandText(featuredCarsList.horizontalPageIndex);
    }

    public function updateView():void{
        if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR && featuredCarsList && featuredCarsList.dataProvider){
            featuredCarsList.horizontalPageIndex = -1;
            Starling.juggler.delayCall(function():void{
                featuredCarsList.horizontalPageIndex = 0;
            }, 2);
        }
    }



    private function restoreButtonTriggeredHandler(event : Event) : void {
        if (_userSignedIn || Constants.isIOS) {
            dispatchEventWith(BrandsScreen.RESTORE_SELECTED);
        }
        else {
            mainMenuView.pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_LOGIN;
            dispatchEventWith(BrandsScreen.LOGIN_SELECTED);
        }
    }

    private function rewardsButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.PART_MENU);
        dispatchEventWith(DISPLAY_REWARD_INFO_POPUP);
    }

    private function allCarsButtonTriggeredHandler(event : Event) : void {
        if (!_packages || _packages.length < 1){
            return;
        }
        SoundManager.playSound(SoundManager.PART_MENU);
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide();
        packagesView.show(true);
    }

    public function set mainMenuView(value : MainMenuView): void {
        this._mainMenuView = value;
        this._mainMenuView.owner = this;
    }

    public function get mainMenuView():MainMenuView {
        return this._mainMenuView;
    }

    public function brandsScreenButtonTriggeredHandler(event:Event = null):void {
    }

    public function homeButtonTriggeredHandler(event: Event = null) : void
    {
        dispatchEventWith(StackedScreen.HOME_SELECTED);
    }

    public function set selectedLanguage(value:Language):void {
        this._selectedLanguage = value;
    }

    public function get selectedLanguage():Language {
        return this._selectedLanguage;
    }

    public function enterRowsState() : void {
        Tracer.print("Brands screen doesn't have row state");
    }

    public function get topButtonPadding():Number {
        return _topButtonPadding;
    }

    public function set topButtonPadding(value:Number):void {
        if(_topButtonPadding != value) {
            _topButtonPadding = value;
            invalidate(FeathersControl.INVALIDATION_FLAG_SIZE);
            draw();
        }
    }

    public function refresh():void {
        var idList:Object = {};
        var j:int;
        var haveVipPack: Boolean = false;
        for(j = 0; j < _purchasedList.length; j++){
            idList[_purchasedList[j].id] = _purchasedList[j];
            if (_purchasedList[j].type == Packet.TYPE_ALLPACKET) {
                haveVipPack = true;
                break;
            }
        }
        if(featuredCarsList && featuredCarsList.dataProvider) {
            for (var i:int = 0; i < featuredCarsList.dataProvider.length; i++) {
                var car:Car = featuredCarsList.dataProvider.getItemAt(i) as Car;
                if (car.packets && car.packets.length) {
                    for (j = 0; j < car.packets.length; j++) {
                        if (idList.hasOwnProperty(Packet(car.packets[j]).id)) {
                            Packet(car.packets[j]).lock = false;
                        }
                    }
                }
                if (car.packet && (idList.hasOwnProperty(car.packet.id) || haveVipPack)) {
                    car.packet.lock = false;
                }
            }
        }
        refreshCurrentFeatured();
    }

    public function refreshCurrentFeatured():void{
        if(featuredCarsList && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length) {
            featuredCarsList.dataProvider.updateItemAt(featuredCarsList.horizontalPageIndex);
        }
    }
}
}