package com.despark.tuning3d.view.components.brands
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.packages.Packet;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.core.PackagesView;
import com.utils.FontSelector;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import mx.utils.StringUtil;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.text.BitmapFontTextRenderer;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.text.BitmapFontTextFormat;

import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
import starling.text.TextField;
import starling.textures.Texture;
import starling.textures.TextureSmoothing;

public class PacketItemRenderer extends ListItemRenderer
	{
		public static const TOUCH_PACKET_INFO:String="touchPacketInfo";		
		
		public static const ITEM_TOUCH_PACKET:String="itemTouchPacket";		
		
		public static const ITEM_RECIEVE_WIDTH:String="ITEM_RECIEVE_WIDTH";
	
		
		
		private var _line:Quad=null;
		private var _background:Quad=null;
		
		private var _carCountIcon:Image=null;
		private var _carCountLabel:Label=null;
		private var _rewardLabelImage: Image;
		
		//private var _priceBg:Image=null;
		//private var _priceGreenMarker:Image=null;
		//private var _priceOrangeMarker:Image=null;
		
		private var _titleDisplay:TextFieldTextRenderer=null;
		
		private var _priceDisplay:TextFieldTextRenderer=null;
		
		private var _carCheckIcon:Image=null;
		
		//private var _featuredArrowRight:Image=null;
		
		//private var _titlePacketDisplay:TextFieldTextRenderer;
		
		
		//private var lockImage:Image;
		private var unlockImage:Image;		
		
		private var infoButton:Button;	
		
		private var _priceTextColor:uint;
		private static const HIDDEN_ITEM_LIST:Array = ["55f893244d7db53459a59083", "56b37c4171819144463d2114", "56b37c5271819144463d2115", "56422502be65a71aa4475da6"];
		
		public function PacketItemRenderer()
		{
			super();
			
			fontSize = 11;
			textColor = 0xffffff;
			
			priceTextColor=0xffffff;
			
			
		}
		
		public function get priceTextColor():uint{
			
			return _priceTextColor;
		}
		
		
		public function set priceTextColor(value : uint) : void
		{
			_priceTextColor = value;
			
			if(_priceDisplay && _priceDisplay.textFormat)  
			{
				
				_priceDisplay.textFormat.color=_priceTextColor;
				
				//_priceDisplay.textRendererProperties.textFormat = getPriceTextFormat();
			}
		}
		
		
		
		override public function set textColor(value : uint) : void
		{
			super.textColor = value;
			
			/*if(_titlePacketDisplay && _titlePacketDisplay.textFormat)  
			{
				
				_titlePacketDisplay.textFormat.color=value;
				
				//_priceDisplay.textRendererProperties.textFormat = getPriceTextFormat();   
			}*/  
		}
		
		protected override function  initialize():void{   
			
			
			_background=new Quad(actualWidth, actualHeight, 0x222728);
			_background.addEventListener(Event.TRIGGERED, itemTouchTriggeredHandler);
			_background.touchable=true;
			addChild(_background);
			
			super.initialize();
			
			
			
			_titleDisplay=new TextFieldTextRenderer();
			
			_titleDisplay.textFormat  = new TextFormat(FontSelector.getFont(false), 11, 0xffffff);
			_titleDisplay.textFormat.align = TextFormatAlign.LEFT;
			//_titleDisplay.textFormat.bold=false;//getTextFormat() as TextFormat;  
			_titleDisplay.embedFonts=FontSelector.embedFonts();
			//_titleDisplay.snapToPixels=false;
			
			_titleDisplay.wordWrap=false;
			_titleDisplay.isHTML=true;
			_titleDisplay.visible=true;
			
			addChild(_titleDisplay);
			
		
			
			
			
			label.visible=false;  
			
			
			_line=new Quad(actualWidth-32, 1, 0x7e8181);
			addChild(_line);
			
			var carCountTexture:Texture=ButtonFactory.assetManager.getTexture("green_car_icon");
			_carCountIcon=new Image(carCountTexture);
			addChild(_carCountIcon);
			
			
			_carCountLabel=new Label();
			
			addChild(_carCountLabel);  
			
			
			if(useBitmapFont)
			{
				_carCountLabel.textRendererFactory = function():Object
				{
					//var t:TextureSmoothing;
					var textRenderer:BitmapFontTextRenderer = new BitmapFontTextRenderer();
					textRenderer.textureSmoothing = TextureSmoothing.TRILINEAR;
					textRenderer.textFormat = getCarCountTextFormat() as BitmapFontTextFormat;
					textRenderer.useSeparateBatch = false;
					return textRenderer;   
				}
			}
			else
			{
				_carCountLabel.textRendererFactory = function():Object
				{
					var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
					textRenderer.textFormat = getCarCountTextFormat() as TextFormat;
					textRenderer.embedFonts = FontSelector.embedFonts();
					return textRenderer;
				}
			}  
			

			_priceDisplay=new TextFieldTextRenderer();
			_priceDisplay.textFormat = getPriceTextFormat() as TextFormat;
			_priceDisplay.embedFonts=FontSelector.embedFonts();       
			//_priceDisplay.snapToPixels=false;  
			_priceDisplay.isHTML=true;
			addChild(_priceDisplay);
			
			var carCheckIconTexture:Texture=ButtonFactory.assetManager.getTexture("featured_price_check");  
			_carCheckIcon=new Image(carCheckIconTexture);
			_carCheckIcon.visible=false;
			addChild(_carCheckIcon);

			var rewardedLabelTexture: Texture = ButtonFactory.assetManager.getTexture("rewards_icon");
			_rewardLabelImage = new Image(rewardedLabelTexture);
            _rewardLabelImage.width = rewardedLabelTexture.width;
            _rewardLabelImage.height = rewardedLabelTexture.height;
            _rewardLabelImage.visible = false;
            addChild(_rewardLabelImage);
		}
		
		public function getPriceTextFormat() : Object
		{
			if(useBitmapFont)
			{
				return getPriceBitmapFontTextFormat();
			}
			
			return getPriceTextFieldTextFormat();
		}
		
		
		
		
		public function getPriceBitmapFontTextFormat() : BitmapFontTextFormat
		{
			var bitmapFontTextFormat : BitmapFontTextFormat = new BitmapFontTextFormat(
				TextField.getBitmapFont("openSans"), 11, priceTextColor);
			
			bitmapFontTextFormat.align = "left";
			
			return bitmapFontTextFormat;
			
		}
		
		/*protected override function autoSizeIfNeeded():Boolean{
			
			
			var needsWidth : Boolean = isNaN(explicitWidth);
			var needsHeight : Boolean = isNaN(explicitHeight);
			
			if(!needsWidth && !needsHeight)
			{
				return false;
			}
			
			label.width = NaN;
			label.height = NaN;
			label.validate();
			
			var newWidth : Number = explicitWidth;
			
			label.y = 7;
			
			if(!FontSelector.embedFonts())
				label.y = 8;   
			
			if(needsWidth)
			{
				newWidth = Math.ceil(label.width) + 30;
				label.width = newWidth;
			}
			
			var newHeight : Number = explicitHeight;
			
			if(needsHeight)
			{
				newHeight = 36;
				label.height = newHeight - 12;
			}
			
			partSlotNameWidthsMap[partSlot.name] = newWidth;
			
			
			bagroundSelectedState.y=9;  
			bagroundSelectedState.width=actualWidth;
			bagroundSelectedState.height=17.5;
			
			return setSizeInternal(newWidth, newHeight, false);
			
		}*/
		
		public function getPriceTextFieldTextFormat() : TextFormat
		{
			
			var fontName:String=FontSelector.getFont(true, true);
			var textFormat : TextFormat = new TextFormat(fontName, 11, priceTextColor);
			textFormat.align = TextFormatAlign.RIGHT;
			textFormat.bold=true;
			textFormat.italic=true;              
			
			return textFormat;
		}
		
		
		
		
		public function getCarCountTextFormat() : Object
		{
			if(useBitmapFont)
			{
				return getCarCountBitmapFontTextFormat();
			}
			
			return getCarCountTextFieldTextFormat();
		}
		
		
		public function getCarCountBitmapFontTextFormat() : BitmapFontTextFormat
		{
			var bitmapFontTextFormat : BitmapFontTextFormat = new BitmapFontTextFormat(
				TextField.getBitmapFont("openSans"), fontSize, 0x00bf00);
			
			bitmapFontTextFormat.align = "left";
			
			return bitmapFontTextFormat;
			
		}
		
		public function getCarCountTextFieldTextFormat() : TextFormat
		{
			
			var fontName:String=FontSelector.getFont(true);
			
			var textFormat : TextFormat = new TextFormat(fontName, fontSize, 0x00bf00);
			textFormat.align = TextFormatAlign.RIGHT;
			textFormat.bold=true;    
			
			return textFormat;
		}
		
		
		private function itemTouchTriggeredHandler(event : Event) : void 
		{

			owner.dispatchEventWith(ITEM_TOUCH_PACKET,false, {packet:packet});
			
			
		}
		
		private function infoButtonTriggeredHandler(event : Event) : void 
		{
			
		
			//owner.dispatchEventWith(TOUCH_PACKET_INFO,false, {packet:packet});
			
			
		}
		
		public function get packet() :Packet
		{
			return data as Packet;
		}
		
		
	   
		
		protected override function commitData() : void 
		{
			super.commitData();
			
			//'AMERICAN TRUCKS</br> <i>"starter"</i> PACK'; 
			var title:String=packet.title;         
			
			
			if(AlertView.language && AlertView.language.translate(packet.id, "title") && AlertView.language.translate(packet.id, "title")!="title")
			{
				
				title=AlertView.language.translate(packet.id, "title");
				
				/*if(AlertView.language.code=="ru-RU"){
					
					title=title.replace("<br/>", "");
				}*/
			}  
			if(HIDDEN_ITEM_LIST.indexOf(packet.id) != -1){
				visible = !packet.lock;
				scaleY = visible? 1: 0;
			}

				_carCountLabel.visible = true;
				_carCountIcon.visible = true;

				if(!packet.cars || packet.cars.length > 50){
                    _carCountLabel.visible = false;
                    _carCountIcon.visible = false;
				}

                if (packet.type == "banner") {
                    this._carCountLabel.visible = false;
                    this._carCountIcon.visible = false;
                }

                if (packet.type == Packet.TYPE_ALLPACKET) {
                    this._carCountLabel.visible = false;
                    this._carCountIcon.visible = false;
                }

                if (packet.type == Packet.TYPE_CURRENTALLPACKET) {
                    this._carCountLabel.visible = false;
                    this._carCountIcon.visible = false;
                }

                if (packet.type == Packet.TYPE_SUBCOMPONENT && (!packet.cars || packet.cars.length == 0)) {
                    this._carCountLabel.visible = false;
                    this._carCountIcon.visible = false;
                }

			//_titleDisplay.textFormat=this.getTextFormat() as TextFormat;
			
		
			_titleDisplay.text=title;   
			
			
			
			//_titlePacketDisplay.text=title;
		//	
			_titleDisplay.width=NaN;
			_titleDisplay.height=NaN;
			_titleDisplay.validate();     
			
			
			if(PackagesView.calacItemCount){
				if(_titleDisplay.width + 150 > PackagesView.PACKAGE_ITEM_WIDTH){
					PackagesView.PACKAGE_ITEM_WIDTH = _titleDisplay.width + 150;
					//PackagesView.PACKAGE_ITEM_WIDTH = Device.isIos() ? 242 : Constants.SCALE_FACTOR==3.375 ? 232 : 242;
					if(Device.isIphoneXVariant()){
						PackagesView.PACKAGE_ITEM_WIDTH += 25;
					}
				}
			}
			PackagesView.ITEM_COUNT++;

			_carCountLabel.width=25;  
			if(!packet.cars)
				packet.cars=[];  
			
			_carCountLabel.text=packet.cars.length+" x";  
			_carCountLabel.validate();
			
			var currency:String=""; 
				
			if(packet.feeСurrency)
				currency=packet.feeСurrency.replace("₽", "RUB");
			
			currency=currency.replace("$", "USD");
			
			if(packet.lock){
				priceTextColor=0xffffff;  
				_priceDisplay.text=packet.fee.toFixed(2) +" "+StringUtil.trim(currency);//packet.feeString.replace("₽", "р.");
				_priceDisplay.validate();
				_rewardLabelImage.visible = false;
			}else{
				
				priceTextColor=0x00b700;
				
				if(AlertView.language){
                    if (packet.tempOpened) {
                        priceTextColor=0xFF9700;
                        _priceDisplay.text = AlertView.language.translate("mob_settings", "rewarded");
                    } else {
                        priceTextColor=0x00b700;
                        _priceDisplay.text = AlertView.language.translate("mob_settings", "purchased");
					}
				}else{
					if (packet.tempOpened) {
                        priceTextColor=0xFF9700;
                        _priceDisplay.text="rewarded";
                    } else {
                        priceTextColor=0x00b700;
                        _priceDisplay.text="purchased";
                    }

				}
				_priceDisplay.validate();

				if (packet.tempOpened) {
                    _rewardLabelImage.visible = true;
                    _rewardLabelImage.width = _rewardLabelImage.height = _priceDisplay.height;
                    _rewardLabelImage.x = _priceDisplay.x;
                    _rewardLabelImage.y = _priceDisplay.y;
				} else {
                    _rewardLabelImage.visible = false;
				}
			}
			
			
			
			this.invalidate("change_text");     

			if(PackagesView.calacItemCount){
				if(owner){
					owner.dispatchEventWith(ITEM_RECIEVE_WIDTH,false);
				}
			}
		}
		
		protected override function commitSelection() :void
		{
			super.commitSelection();
			

			if(isSelected){
				_background.color=0x6f7273;
				_background.height=this.actualHeight;
				_background.y=0;
				_line.visible=false;
			}else{
				
				_background.color=0x222728;
				_background.height=this.actualHeight-1;
				_background.y=1; 
				_line.visible=true;
			}
			
		}
		
		protected override function layout() : void
		{

			
			_background.width=PackagesView.PACKAGE_ITEM_WIDTH-7.5;
			_background.height=actualHeight;
			
			this._line.width=PackagesView.PACKAGE_ITEM_WIDTH-32;
			this._line.x=12;
			this._line.y=actualHeight;  
			
			if(Device.isIphoneXVariant()){
				this._line.x+=25;
			}
			
			
			_carCountLabel.width=25;   
			_carCountLabel.height=NaN;
			_carCountLabel.validate();
			
			_carCountLabel.x=PackagesView.PACKAGE_ITEM_WIDTH-142;//_carCountIcon.x+_carCountIcon.width+6;
			_carCountLabel.y=int((actualHeight - _carCountLabel.height) / 2);  
			
			
			
			
			_carCountIcon.x=_carCountLabel.x+_carCountLabel.width+6;
			_carCountIcon.y=((actualHeight-_carCountIcon.height)/2)-2;
			
			
			           
			
			
			_carCheckIcon.x=PackagesView.PACKAGE_ITEM_WIDTH-89;//_priceBg.x+((_priceBg.width-_carCheckIcon.width)/2);  
			_carCheckIcon.y=((actualHeight-_carCheckIcon.height)/2);  
			
			_priceDisplay.width=65;   
			_priceDisplay.height=14;       
			
			_priceDisplay.x=PackagesView.PACKAGE_ITEM_WIDTH-89;         
			
			_priceDisplay.validate();
			_priceDisplay.y=_carCountLabel.y;//((actualHeight-_priceDisplay.height)/2)-2;        
			
		}
		
		
		override protected function  draw():void{
			
			
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				if(packet){
					
					var title:String=packet.title;  //'AMERICAN TRUCKS<br/> <b><i>"starter"</i></b> PACK';  
					
					
					if(AlertView.language && AlertView.language.translate(packet.id, "title") && AlertView.language.translate(packet.id, "title")!="title")
					{
						
						title=AlertView.language.translate(packet.id, "title"); 
						
					}
					
					_titleDisplay.x=12;    
					
					if(Device.isIphoneXVariant()){
						_titleDisplay.x+=25;
					}

					if(title){
						
						
						if(_titleDisplay.text!=title){  
							
							_titleDisplay.text=title;
							_titleDisplay.validate();
							

							_titleDisplay.y=((actualHeight - _titleDisplay.height) / 2);         
						}
					}
				   
				}
				
				if(packet && packet.lock){
					
					var currency:String="";
					
					if(packet.feeСurrency) 
					currency=packet.feeСurrency.replace("₽", "RUB");
					
					currency=currency.replace("$", "USD");
				
					
					_priceDisplay.text=packet.fee.toFixed(2) +" "+StringUtil.trim(currency);//packet.feeString.replace("₽", "р.");
					_priceDisplay.validate();
                    _rewardLabelImage.visible = false;
					
				}else if (packet) {
                    if(AlertView.language){
                        if (packet && packet.tempOpened) {
                            priceTextColor=0xFF9700;
                            _priceDisplay.text = AlertView.language.translate("mob_settings", "rewarded");
                        } else {
                            priceTextColor=0x00b700;
                            _priceDisplay.text = AlertView.language.translate("mob_settings", "purchased");
                        }
                    }else{
                        if (packet && packet.tempOpened) {
                            priceTextColor=0xFF9700;
                            _priceDisplay.text="rewarded";
                        } else {
                            priceTextColor=0x00b700;
                            _priceDisplay.text="purchased";
                        }

                    }
					_priceDisplay.validate();
                    if (packet.tempOpened) {
                        _rewardLabelImage.visible = true;
                        _rewardLabelImage.width = _rewardLabelImage.height = _priceDisplay.height;
                        _rewardLabelImage.x = _priceDisplay.x;
                        _rewardLabelImage.y = _priceDisplay.y;

                    } else {
                        _rewardLabelImage.visible = false;
                    }
				}

			}
			
			
			if(isInvalid("change_text"))
			{

				
				_titleDisplay.validate();
				
				_titleDisplay.y=int((actualHeight - _titleDisplay.height) / 2);     
				
			}
			
		}
		
	}
}