package com.despark.tuning3d.view.components.brands {
import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.core.PopUp;
import com.utils.FontSelector;

import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.core.Starling;
import starling.display.Image;
import starling.events.Event;

public class RewardNoAdsPopUp   extends PopUp{
    public function RewardNoAdsPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }

    protected var _mainCotnainer : LayoutGroup;
    private var okButton:MultilingualButton;
    private var newtitleLabel:MultilingualButton;

    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.visible = false;
        this.closeButton.visible = false;



        var mainLayout : AnchorLayoutData = new AnchorLayoutData();
        mainLayout.verticalCenter = 0;
        mainLayout.horizontalCenter = 0;

        _mainCotnainer = new LayoutGroup();
        _mainCotnainer.layout = new AnchorLayout();
        _mainCotnainer.layoutData = mainLayout;
        addChild(_mainCotnainer);

        var borderImage: Image = new Image(assetManager.getTexture('frame'));
        borderImage.scale9Grid = new Rectangle(borderImage.width * .2, borderImage.height * .2, borderImage.width * .6, borderImage.height * .6);
        _mainCotnainer.backgroundSkin = borderImage;

        var textLayout : AnchorLayoutData = new AnchorLayoutData();
        textLayout.verticalCenter = 0;
        textLayout.horizontalCenter = 0;

        var text: String = 'Unfortunately, there are no Rewarded Ads available for your viewing at this moment. Please come back a little bit later for more Rewarded Ads. \n\nWe will also notify you once there are available Rewarded Ads with a notification sign on Rewarded Ads icon on the home screen';



        var textLabel: Label = new Label();
        textLabel.layoutData = textLayout;
        textLabel.textRendererFactory = function () :ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 12, 0xFFFFFF);
            textRenderer.wordWrap = true;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        };
        textLabel.width = actualWidth * (Constants.isWide ? .7 : .6);
        textLabel.wordWrap = true;
        textLabel.text = text;
        textLabel.validate();
        textLabel.padding = 20;


        _mainCotnainer.addChild(textLabel);




        okButton = ButtonFactory.rewardOkButton();
        okButton.addEventListener(Event.TRIGGERED, okButtonTriggeredHandler);
        addChild(okButton);


         newtitleLabel = ButtonFactory.rewardsPopUpTitle();
        addChild(newtitleLabel);
    }
    override protected function draw() : void {
        super.draw();

        _mainCotnainer.invalidate();
        _mainCotnainer.validate();

        _mainCotnainer.x = (actualWidth - _mainCotnainer.width) / 2;
        _mainCotnainer.y = (actualHeight - _mainCotnainer.height) / 2;

        newtitleLabel.width = _mainCotnainer.width;
        newtitleLabel.x = (actualWidth - _mainCotnainer.width) / 2;
        newtitleLabel.y = _mainCotnainer.y - 10 - newtitleLabel.height;

        okButton.x = (actualWidth - okButton.width) / 2;
        okButton.y = _mainCotnainer.y + _mainCotnainer.height + 10;

    }

    private function okButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }

    override public function dispose(): void {
        super.dispose();
        okButton.removeEventListener(Event.TRIGGERED, okButtonTriggeredHandler);
    }

}
}
