package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.core.PopUp;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;

import feathers.controls.Label;

import feathers.controls.LayoutGroup;

import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;

import flash.geom.Rectangle;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.core.Starling;
import starling.display.Image;
import starling.events.Event;

public class RewardNoCoinPopUp   extends PopUp {
    public static const OPEN_WATCH_REWARD_POP_UP : String = 'OPEN_WATCH_REWARD_POP_UP';

    protected var _mainCotnainer : LayoutGroup;
    private var cancelButton:MultilingualButton;
    private var watchButton:MultilingualButton;
    private var newtitleLabel:MultilingualButton;

    public function RewardNoCoinPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }
    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.visible = false;
        this.closeButton.visible = false;

        var mainLayout : AnchorLayoutData = new AnchorLayoutData();
        mainLayout.verticalCenter = 0;
        mainLayout.horizontalCenter = 0;

        _mainCotnainer = new LayoutGroup();
        _mainCotnainer.layout = new AnchorLayout();
        _mainCotnainer.layoutData = mainLayout;
        addChild(_mainCotnainer);

        var borderImage: Image = new Image(assetManager.getTexture('frame'));
        borderImage.scale9Grid = new Rectangle(borderImage.width * .2, borderImage.height * .2, borderImage.width * .6, borderImage.height * .6);
        borderImage.width = borderImage.height = 10;
        _mainCotnainer.backgroundSkin = borderImage;

        var textLayout : AnchorLayoutData = new AnchorLayoutData();
        textLayout.verticalCenter = 0;
        textLayout.horizontalCenter = 0;

        var text: String = 'You don`t have enough 3DT Coins. Would you like to watch a Reward Ad?';



        var textLabel: Label = new Label();
        textLabel.layoutData = textLayout;
        textLabel.textRendererFactory = function () :ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 12, 0xFFFFFF);
            textRenderer.wordWrap = true;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            return textRenderer;
        };
        textLabel.width = actualWidth * .6 - 20;
        textLabel.wordWrap = true;
        textLabel.text = text;
        textLabel.validate();
        textLabel.padding = 20;


        _mainCotnainer.addChild(textLabel);



        cancelButton = ButtonFactory.rewardCancelButton();
        watchButton = ButtonFactory.rewardWatchButton();

        watchButton.addEventListener(Event.TRIGGERED, watchButtonTriggeredHandler);
        addChild(watchButton);

        cancelButton.addEventListener(Event.TRIGGERED, cancelButtonTriggeredHandler);
        addChild(cancelButton);

        newtitleLabel = ButtonFactory.rewardsPopUpTitle();
        addChild(newtitleLabel);

        if(!AdsManager.$.haveRewardAds){
            watchButton.isEnabled = false;
            watchButton.alpha = 0.5;
        }
    }
    override protected function draw() : void {
        super.draw();

        _mainCotnainer.invalidate();
        _mainCotnainer.validate();

        _mainCotnainer.x = (actualWidth - _mainCotnainer.width) / 2;
        _mainCotnainer.y = (actualHeight - _mainCotnainer.height) / 2;

        newtitleLabel.width = _mainCotnainer.width;
        newtitleLabel.x = (actualWidth - _mainCotnainer.width) / 2;
        newtitleLabel.y = _mainCotnainer.y - 10 - newtitleLabel.height;

        watchButton.x = (actualWidth - (cancelButton.width + 10 + watchButton.width)) / 2;
        cancelButton.x = watchButton.x + watchButton.width + 10;
        watchButton.y = cancelButton.y = _mainCotnainer.y + _mainCotnainer.height + 10;

    }

    override public function dispose(): void {
        super.dispose();
        watchButton.removeEventListener(Event.TRIGGERED, watchButtonTriggeredHandler);
        cancelButton.removeEventListener(Event.TRIGGERED, cancelButtonTriggeredHandler);
    }

    private function cancelButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }

    private function watchButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        dispatchEventWith(OPEN_WATCH_REWARD_POP_UP);
    }

    public function enableWatching():void{
        watchButton.isEnabled = true;
        watchButton.alpha = 1;
    }
}
}
