package com.despark.tuning3d.view.components.cars {
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.cars.CarBackground;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.disks.Disk;
    import com.despark.tuning3d.model.disks.DiskBrand;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.parts.PartColor;
    import com.despark.tuning3d.model.parts.PartDisk;
    import com.despark.tuning3d.model.parts.PartMaterial;
    import com.despark.tuning3d.model.parts.PartMaterialImage;
    import com.despark.tuning3d.model.parts.PartMaterialImageTest;
    import com.despark.tuning3d.model.parts.PartSlot;
    import com.despark.tuning3d.model.parts.PartSubposition;
    import com.despark.tuning3d.view.TuningScreenMediator;
    import com.despark.tuning3d.view.components.core.BackgroundContainer;
    import com.despark.tuning3d.view.components.core.ColorUtil;
    import com.despark.tuning3d.view.components.core.ImageForVideo;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.PixelMaskDisplayObject;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.utils.DevHelper;
    import com.utils.DisplayObjectUtil;
    import com.utils.ObjectUtils;
    import com.utils.RandomSplashManager;

    import feathers.core.FeathersControl;

    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.BlendMode;
    import flash.display.Loader;
    import flash.display.LoaderInfo;
    import flash.display.Sprite;
    import flash.events.MouseEvent;
    import flash.geom.Matrix;
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import flash.net.URLRequest;
    import flash.system.System;
    import flash.utils.Dictionary;
    import flash.utils.getTimer;
    import flash.utils.setTimeout;

    import starling.animation.Transitions;
    import starling.animation.Tween;
    import starling.core.Starling;
    import starling.display.DisplayObject;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Stage;
    import starling.events.EnterFrameEvent;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;
    import starling.rendering.Painter;
    import starling.textures.Texture;
    import starling.utils.AssetManager;
    import starling.utils.Color;
    import starling.utils.ScaleMode;

//import flash.trace.Trace;
public class CarView extends FeathersControl {


	public static var CAR_FULL_LOADED:Boolean = false;
    public static const FIRST_IMAGE_DOWNLOADED:String = "FirstImageDownloaded";
    public static const PART_SLOT_SELECTED:String = "PartSlotSelected";
    public static const SPNAPSHOT_FROM_CAMERA_CREATED:String = "SPNAPSHOT_FROM_CAMERA_CREATED";
    public static const SHOW_FRAME:String = "SHOW_FRAME";
    public static const ROTATION_START:String = "ROTATION_START";
    public static const ROTATION_END:String = "ROTATION_END";
    public static const ALL_IMAGES_LOADED:String = "ALL_IMAGES_LOADED";
    public static var CAR_HALF_HEIGHT:int = 70;
    public static var CAR_HEIGHT:int = CAR_HALF_HEIGHT * 2;
    public static var CAR_WIDTH:int;
    public static const NOT_SELECTABLE_PART_SLOTS:Array = ["tire", "tire_front", "tire_rear"].concat(Car.WINDOW_SLOTS);

    public static const ADD_STATE_SUFFIX:String = "AddState";
	
	public static var SHOW_FRAME_TASKS:Array = [];

    public var progressHandler:Function;
    /**
	 * IMPORTANT
	 * We are using this parameter in to load second camera data on background, meanwhile allowing user to rotate the camera
     */
    private var _cameraSecondCameraIsLoading : Boolean;

    private var _car:Car;
    private var isFirstBgShow : Boolean = true;
	private var _carYCalculator : CarYCalculator;
    public function set car(value:Car):void {

        _car = value;
        if (!_car)
            return;

		_carYCalculator = new CarYCalculator(this);






        CarFrameView.isChopper = _car.isChopper;

        if (car && car.camera2Frames) {
            FINDEX = car.camera2Frames;
        }

        if (car && car.camera1Frames) {
            NORMAL_FINDEX = car.camera1Frames;
        }


        if (car.countFrames == 50) {

            CarFrameView.ANDROID_NORMAL_SCALE = false;
        }


        framesIndices = [];


        for (var i:int = 0; i < car.countFrames; i++) {
            var r:int = i;
            framesIndices[i] = r;
        }

    }

    public function get car():Car {
        return _car
    };
    public var assetManager:AssetManager;
    public var canTouchParts:Boolean;
    public var framesAdded:int;
    public var angelsAdded:int;
    public var carScale:Number;


    public var foregroundSpriteForCamera:Sprite;

    public var fillColorQuad:Quad;
    //public var backgroundImage:Image;
	
	public var backgroundContainer:BackgroundContainer;

    /*public var backgroundImage1Camera:ImageLoaderWithStates;
    public var backgroundImage2Camera:ImageLoaderWithStates;*/

    public var imageForVideo:ImageForVideo;
    //
    public var frameMap:Object;
    private var partSlotsImagesMap:Object;
    public var currentFrame:int;
    public var currentAngelIndex:int = 1;
    private var initialPartsAdded:Boolean;
    private var targetRotation:Number = 0;
    private var targetRotationOnMouseDown:Number = 0;
    private var mouseX:Number = 0;
    private var mouseXOnMouseDown:Number = 0;
    private var mouseYOnMouseDown:Number = 0;
    private var mouseY:Number = 0;
    private var windowHalfX:Number;
    private var windowHalfY:Number;
    private var _rotation: Number = 0;
    private var addedListenersForFirstDownloadedImage:Boolean;
    private var lastIndex:int;
    private var imagesToLoadCount:int;
    private var imagesLoadedCount:int;
    private var loadStartTime:Number;
    private var touchMoved:Boolean;
    private var frameOnTouch:int;
    private var colorUpdate:Boolean;
    private var framesIndices:Array;
    private var timeoutId:Number = -1;
    private var lastFrameCurrated:int = -1;
    private var partsLoaded:Boolean;
    public var bodyY:int;
    public var carTexturesScale:Number;
    private var _carY:Number;

    private var framesContainer:SnapShotFramesContainer;
    private var p:Array;
    private var q:Array;

    private var partSlotSubpartsMap:Object;
    private var updateStartTime:Number;

    private var images:Array;
    private var index:int;
    private var imagesGroupSize:int = 800;

    public var locked:Boolean = false;
	public var lockedTouch:Boolean = false;

	private var _isLoading : Boolean = false;

    private var completeAfterUpdate_fun:Function;

    private var mybmp:BitmapData = null;


    public var startedTouch:Boolean = false;

    public var bodyPartSlot:PartSlot = null;


    public var commonAX:Number;

    public var partSlotMask:PartSlot = null;

    public var isExistCember:Boolean = false;

    private var _initialScale:Number = 1.0;

	public function get initialScale() : Number
	{
		return this._initialScale;
	}

    private var cofFrameScale:Number = 1;

    private var bgOffset:Number = 0;

    private var antimaskPartSlot:PartSlot = null;

    public static var FINDEX:Object = {};

    public static var NORMAL_FINDEX:Object = {};

    public static var CURRENT_ANGEL_INDEX:int = -1;

    public var backgrounds:Array = [];
    public var backgroundsBitmaps:Dictionary = new Dictionary();
    public var lastCamBcg:Number;
    public var allBackgroundsDownloaded:Boolean = false;
	public var panorama180back:Boolean = false;


	public var backgroundPanorama180Image:Image;
	private var backgroundPanorama180XOffset:Number = 0;
	
	private var backgroundPanorama180HTile:int = 3;
	private var backgroundPanorama180Ratio:Number = 3.268;
	
	private var backgroundPanorama180PaddingBottom:Number = 50;
	
	private var splashImage:ImageLoaderWithStates;
	
	private var quadSplash:Quad;

	private var _tracer : Tracer;
	

	
	public static var JOBS_AFTER_RENDER_CLEAN:Array = [];
	public static var JOBS_AFTER_RENDER_LOAD:Array = [];
	
	private var firstBlackFrame:ImageLoaderWithStates;
	
	public var listSplashScreenUrls:Array = [];

    private var _loadSelectedFrame:int = -1;
    public var previewMode:Boolean = false;
    private var _fastModeLoadedPartSlots:Array = [];
    private var _fastModeLoadedFrames:Object = {};
	
	//private var _quadMask:Quad

    public function CarView() {
        super();

		CAR_FULL_LOADED = false;

		_tracer = new Tracer("CarView");

		locCurrentFrame = -1;
		locNext1Frame = -1;
		locNext2Frame = -1;
		locPrev1Frame = -1;
		locPrev2Frame = -1;
		locAngleIndex = -1;
		
		oldLocAngelIndex = -1;
		oldLocCurrentFrame = -1;
		
		oldLocNext1Frame = -1;
		oldLocPrev1Frame = -1;
		
		
		oldLocNext2Frame = -1;
		oldLocPrev2Frame = -1;

        frameMap = {};
        partSlotsImagesMap = {};
        lastIndex = -1;
        canTouchParts = true;
        //framesIndices = [];


        carScale = _initialScale;

        if (Constants.SCALE_FACTOR == 1.5 || Constants.SCALE_FACTOR == 3) {

            _initialScale = 1.35;
            carScale = 1.35;
        }
        partSlotSubpartsMap = {};

        p = [];
        q = [];
    }

    private var _visible:Boolean = true;

    override public function get visible():Boolean {

        return _visible;
    }
	
	private var _oldCameraBgTexture:Texture;

	public function updateVisibleBackground():void {

        //trace("updateVisibleBackground")

        var texture:Texture;
        if (TuningScreenMediator.backgroundsToLoad[0]) {

            if (isFirstBgShow) {

                texture = Texture.fromBitmap(TuningScreenMediator.backgroundsToLoad[0] as Bitmap);

                if (backgroundContainer) {
                    backgroundContainer.updateBackground(texture);
                }
                isFirstBgShow = false;
            }
            return;
        }

        if (framesContainer && !framesContainer.visible) {
            backgroundContainer.visible = true;
//            return;
        }

        if (car && car.selectedBackground && car.selectedBackground.id != CarBackground.DEFAULT_ID){

            if(car.selectedBackground.imagePathSecondCam && car.selectedBackground.imagePathSecondCam.length>0){

                if (currentAngelIndex == 0) {

                    if (lastCamBcg != 0 && backgroundsBitmaps['0']) {

                        texture = backgroundsBitmaps['0'];//_oldCameraBgTexture? _oldCameraBgTexture: Texture.fromBitmap(backgroundsBitmaps['0'] as Bitmap);
                        if (backgroundContainer) {

                            //_oldCameraBgTexture = backgroundContainer.texture;
                            backgroundContainer.updateBackground(texture,false);
                        }

                    }
                    lastCamBcg = 0;

                } else if (currentAngelIndex == 1 && backgroundsBitmaps['1']) {

                    if (lastCamBcg != 1) {


                        texture = backgroundsBitmaps['1'];//_oldCameraBgTexture ? _oldCameraBgTexture : Texture.fromBitmap(backgroundsBitmaps['1'] as Bitmap);
                        if (backgroundContainer) {
                            //_oldCameraBgTexture = backgroundContainer.texture;
                            backgroundContainer.updateBackground(texture, false);
                        }


                    }
                    lastCamBcg = 1;

                }
            }else{

                if (lastCamBcg==-1) {
                    texture = backgroundsBitmaps['0'];//Texture.fromBitmap(backgroundsBitmaps['0'] as Bitmap);
                    if (backgroundContainer) {
                        backgroundContainer.updateBackground(texture);
                    }
                    lastCamBcg = 0;
                }
            }
        }else
        if (car && car.defaultBkgMobile && car.defaultBkgMobile.length == 2) {
            if (currentAngelIndex == 0) {

                if (lastCamBcg != 0 && backgroundsBitmaps['0']) {

                    texture = backgroundsBitmaps['0'];//_oldCameraBgTexture? _oldCameraBgTexture: Texture.fromBitmap(backgroundsBitmaps['0'] as Bitmap);
                    if (backgroundContainer) {
                        backgroundContainer.updateBackground(texture,false);
                    }

                }
                lastCamBcg = 0;

            } else if (currentAngelIndex == 1 && backgroundsBitmaps['1']) {

                if (lastCamBcg != 1) {


                    texture = backgroundsBitmaps['1'];//_oldCameraBgTexture ? _oldCameraBgTexture : Texture.fromBitmap(backgroundsBitmaps['1'] as Bitmap);
                    if (backgroundContainer) {
                        //_oldCameraBgTexture = backgroundContainer.texture;
                        backgroundContainer.updateBackground(texture, false);
                    }


                }
                lastCamBcg = 1;

            }
        } else if (car && car.defaultBkgMobile && car.defaultBkgMobile.length == 1) {
            if (!lastCamBcg || lastCamBcg == -1) {
                texture = backgroundsBitmaps['0'];//Texture.fromBitmap(backgroundsBitmaps['0'] as Bitmap);
                if (backgroundContainer) {
                    backgroundContainer.updateBackground(texture);
                }
            }

        }

    }


    override public function set visible(value:Boolean):void {

        _visible = value;

        if (framesContainer) {
            framesContainer.visible = _visible;
            updateVisibleBackground();
        }
    }


    protected function onGlobalEventMemLeakTest(event:*):void {

    }

    public override function dispose():void {
		
		trace("CarView.dispose()");
        removeEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
        visible = true; // to prevent splash image generation, when the car isn't loaded, and internet connection lost ( the app should go to home screen
		
		
		
		
		disposeBackgrounds(backgroundsBitmaps);
		
		
		if(this.backgroundContainer){
			
			backgroundContainer.removeFromParent();
			backgroundContainer.dispose();//removeFromParent(true);
			backgroundContainer = null;
		}
		
		
		ImageLoaderWithStates.carPartCacheInMemory=0;
		
		CarView.JOBS_AFTER_RENDER_CLEAN=[];
		CarView.JOBS_AFTER_RENDER_LOAD=[];


        for (var frameAngel:int in frameMap) {

            for each (var frameView:CarFrameView in frameMap[frameAngel]) {

                if (frameView) {
                    frameView.removeEventListener("frame_loaded", onFrameFullLoad);
                    frameView.removeFromParent(true);
                    frameView.dispose();
                    frameView = null;
                }
            }
        }
		
		SHOW_FRAME_TASKS = [];

		if(car)
        car.dispose();
        car = null;

        if(frameMap){
            DisplayObjectUtil.collectionDispose(frameMap);
        }
        frameMap = null;
        if(partSlotsImagesMap){
            DisplayObjectUtil.collectionDispose(frameMap);
        }
        partSlotsImagesMap = null;

        partSlotSubpartsMap = null;

        framesIndices = null;

        progressHandler = null;

        assetManager = null;

        foregroundSpriteForCamera = null;

       	

        if (ImageForVideo) {

			imageForVideo.dispose();
			imageForVideo = null;
        }

        if (framesIndices) {

            framesIndices = null;
        }

        if (framesContainer) {
            framesContainer.dispose();
            framesContainer.removeFromParent(true);
            framesContainer = null;
        }

        p = null;
        q = null;
        if(images){
            DisplayObjectUtil.collectionDispose(images);
        }
        images = null;

        completeAfterUpdate_fun = null;

        if (mybmp) {

            mybmp.dispose();
            mybmp = null;
        }

		if(bodyPartSlot){
	        bodyPartSlot.dispose();
	        bodyPartSlot = null;
		}

		if(partSlotMask){
	        partSlotMask.dispose();
	        partSlotMask = null;
		}
		
		
		if(_oldCameraBgTexture ){
			
			_oldCameraBgTexture.dispose();
		}
        super.dispose();
        DisplayObjectUtil.dispose(this);
        System.pauseForGCIfCollectionImminent(1);
    }

	
	public function tileImage(image:Image, horizontally:int,vertically:int):void{
		//image.setTexCoords(1,new Point(horizontally,0));
		//image.setTexCoords(2,new Point(0,vertically));
		//image.setTexCoords(3,new Point(horizontally,vertically));
	}
	
	private var _oldSplashImage:ImageLoaderWithStates = null;
	
	
	private var _lastSplashCarUrl:String;
	
	public function setCarSplash(image:ImageLoaderWithStates):void{
		
		if(!image) return;
		
		image.isSplashImage = true;
		
		if(visible){
			
			if(_oldSplashImage && _oldSplashImage.stage) _oldSplashImage.removeFromParent(true);
			if(splashImage && splashImage.stage) splashImage.removeFromParent(true);
			
			splashImage = null;
			_oldSplashImage = null;
			return;
		}
		
		if(image && image.persistentImageProvider){
			listSplashScreenUrls.push(image.persistentImageProvider.remoteUrl);
		}
        var index:int;
        if(splashImage){
			_oldSplashImage = splashImage;

			splashImage = image;
			splashImage.visible = true;
			
			splashImage.alpha = 0;
			index = getChildIndex(_oldSplashImage);
			addChildAt(splashImage, index+1);

			var tweenNew:Tween = new Tween(splashImage, 0.5, Transitions.LINEAR);
			//tween.animate("x", object.x + 50);
			//tween.animate("rotation", deg2rad(45));
			tweenNew.fadeTo(1);    // equivalent to 'animate("alpha", 0)'
			Starling.juggler.add(tweenNew);
			
			
			var tweenOld:Tween = new Tween(_oldSplashImage, 0.5, Transitions.LINEAR);
			
			tweenOld.onComplete = function():void{
				
				tweenOld.target.removeFromParent(true);
				
				startLoadTimer = getTimer();
				setTimeout(nextCarSplash, 2000);
			};
			//tween.animate("x", object.x + 50);
			//tween.animate("rotation", deg2rad(45));
			tweenOld.fadeTo(0);    // equivalent to 'animate("alpha", 0)'
			Starling.juggler.add(tweenOld);
			
			//addChildAt(splashImage, index);
			//removeChild(quadSplash, true);
			quadSplash.width = this.actualWidth;
			quadSplash.height = this.actualHeight;
			quadSplash.x = 0;
			quadSplash.y = 0;
			
			this.invalidate();
			
		}else{
		
			splashImage = image;
			splashImage.visible = true;
			index = getChildIndex(quadSplash);
			addChildAt(splashImage, index+1);
			quadSplash.width = this.actualWidth;
			quadSplash.height = this.actualHeight;
			quadSplash.x = 0;
			quadSplash.y = 0;
			
			this.invalidate();
			
			startLoadTimer = getTimer();
			
			setTimeout(nextCarSplash, 500);
		}
		//
        var imageRatio:Number = splashImage.currentTexture.frameWidth / splashImage.currentTexture.frameHeight;
        var viewRatio:Number = actualWidth / actualHeight;
        if(imageRatio > viewRatio){
            splashImage.height = actualHeight;
            splashImage.y = 0;
        }else{
            splashImage.width = actualWidth;
        }
	}
	
	private var startLoadTimer:int;
	
	private function nextCarSplash():void{
		
		if(visible) {
			if(_oldSplashImage && _oldSplashImage.stage) _oldSplashImage.removeFromParent(true);
			if(splashImage && splashImage.stage) splashImage.removeFromParent(true);
			
			splashImage = null;
			_oldSplashImage = null;
			
			return;
		}
		
		var partSlot:PartSlot = new PartSlot(car);
		var partCarSplash:Part = new Part(partSlot);
		var partMaterial:PartMaterial = new PartMaterial(partCarSplash);
		var randomSplashUrl:String = RandomSplashManager.getRandomUrl();

		var i:int=0;
		while(listSplashScreenUrls.indexOf(randomSplashUrl)>=0){
			randomSplashUrl = RandomSplashManager.getRandomUrl();
			i++;
			if(i>RandomSplashManager.POSTER_IMAGE_COUNT) break;
		}
		trace("randomSplashUrl:", randomSplashUrl);
		
		var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
		carSplashImageProvider.frameIndex = 0;
		carSplashImageProvider.angleIndex = 0;
		carSplashImageProvider.isEncrypted = false;
		
		
		
		
		var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
		carSplashImage.overrideDispose = true;
		carSplashImage.snapToPixels = false;
		if(Constants.TOTAL_MEMORY<1024 && Constants.SCALE_FACTOR<2){
			carSplashImage.bitmapScale = 0.5;
		}
		
		//carSplashImage.startManually = true;
		
		carSplashImage.visible = false;
		
		//tuningScreen.carView.setCarSplash(carSplashImage);
		
		stage.addChild(carSplashImage);
		
		
		
		
		carSplashImage.completeHandler = function(image:ImageLoaderWithStates):void{
			
			if(visible) {
				if(splashImage) splashImage.removeFromParent(true);
				carSplashImage.removeFromParent(true);
				
				
				
				if(_oldSplashImage && _oldSplashImage.stage) _oldSplashImage.removeFromParent(true);
			
				
				splashImage = null;
				_oldSplashImage = null;
				
				
				
				return;
			}
			
			var timerDt:int = getTimer()-startLoadTimer;
			
			if(timerDt>=9000){
				setCarSplash(image);
			}else{
				
				setTimeout(function():void{
				
					if(visible) {
						if(splashImage) splashImage.removeFromParent(true);
						carSplashImage.removeFromParent(true);
						return;
					}
					
					setCarSplash(image);
					
				}, 9000-timerDt);
			}
			
			
		};
		
		
		carSplashImage.scaleMode =	ScaleMode.NONE;
		carSplashImage.persistentImageProvider = carSplashImageProvider;	
		
	}
	
	public function removeCarSplash():void{
		
		if(splashImage){
			
			splashImage.overrideDispose = false;
			splashImage.removeFromParent(true);
			
			if(splashImage.image && splashImage.image.texture){
				splashImage.image.texture.dispose();
			}
		}
		
		if(this._oldSplashImage && _oldSplashImage.stage){
			
			_oldSplashImage.removeFromParent(true);
		}
		
		
		if(_oldSplashImage && _oldSplashImage.image && _oldSplashImage.image.texture){
			_oldSplashImage.image.texture.dispose();
		}
			
		if(this.quadSplash){
			quadSplash.removeFromParent(true);
		}
	}
	
	
    protected override function initialize():void {
        super.initialize();

        carTexturesScale = 0.5;


		
		backgroundContainer = new BackgroundContainer();
		backgroundContainer.setSize(actualWidth, actualHeight);
		addChild(backgroundContainer);
		
		
		
		quadSplash = new Quad(1,1,0x000000);
		addChild(quadSplash);
		//quadSplash.width = actualWidth;
		//quadSplash.height = actualHeight;
		
		
		
		/*backgroundPanorama180Image = new Image(assetManager.getTexture("back180.png"));
		tileImage(backgroundPanorama180Image, backgroundPanorama180HTile, 1);
		
		//backgroundPanorama180Image.pivotY = 40;
	//	backgroundPanorama180Image.pivotX = 50;
		
		
		
		
		backgroundPanorama180Image.height = actualHeight+backgroundPanorama180PaddingBottom;
		
		backgroundPanorama180Image.width = backgroundPanorama180Image.height * backgroundPanorama180Ratio * backgroundPanorama180HTile;
		
		backgroundPanorama180Image.x=0;
		backgroundPanorama180Image.y=0;
		//backgroundPanorama180Image.x = (backgroundPanorama180Image.width - actualWidth)/2;
		
		backgroundPanorama180Image.visible = false;
		
		
		addChild(backgroundPanorama180Image);*/


        fillColorQuad = new Quad(1, 1, 0xffffff);
        fillColorQuad.visible = false;
        addChild(fillColorQuad);


		imageForVideo = new ImageForVideo();
		imageForVideo.maintainAspectRatio = true;

		imageForVideo.scaleMode = ScaleMode.NO_BORDER;
		imageForVideo.visible = false;
        //addEventListener(TouchEvent.TOUCH, touchHandler);
        addChild(imageForVideo);

        framesContainer = new SnapShotFramesContainer();
        framesContainer.scaleX = carScale;
        framesContainer.scaleY = carScale;

        framesContainer.visible = _visible;

        //framesContainer.visible=false;//touchable=false;

        addChild(framesContainer);
		
		
		/*tmpProgressQuad_load = new Quad(1,5, 0x00ff00, true);
		tmpProgressQuad_load.alpha = 0.6;
		tmpProgressQuad_load.x=0;
		tmpProgressQuad_load.y=0;
		addChild(tmpProgressQuad_load)
		
		
		tmpProgressQuad_clean = new Quad(1,5, 0xff0000, true);
		tmpProgressQuad_clean.alpha=0.6;
		tmpProgressQuad_clean.x=5;
		tmpProgressQuad_clean.y=0;
		addChild(tmpProgressQuad_clean)
		*/


    }

    public function applayInitialScale(scale:Number):void {

        //this.initialScale=initialScale*scale;
        cofFrameScale = scale;

        carScale = _scaleComponent * _initialScale * cofFrameScale;

        framesContainer.scaleX = carScale;
        framesContainer.scaleY = carScale;
    }



	public function updateCarY(): void
	{
		var old : Number = _carY;
		if(_carYCalculator)
			_carY = _carYCalculator.carY;
		else {
			_carY = frameHeight/2;
		}

		if(_carY != old || _carY != framesContainer.y)
		{
            invalidate("car_y");
        	framesContainer.y = _carY;
        	trace("CAR NEW Y :  " + _carY);
		}
	}


    protected override function draw():void {
        super.draw();

        var sizeInvalid:Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);

        if (sizeInvalid) {
            fillColorQuad.width = actualWidth;
            fillColorQuad.height = actualHeight;

			imageForVideo.width = actualWidth;
			imageForVideo.height = actualHeight;

            framesContainer.width = actualWidth;
            framesContainer.height = actualHeight;

            
            //
            if(splashImage && splashImage.currentTexture) {
                var imageRatio:Number = splashImage.currentTexture.frameWidth / splashImage.currentTexture.frameHeight;
                var viewRatio:Number = actualWidth / actualHeight;
                if (imageRatio > viewRatio) {
                    splashImage.height = actualHeight;
                    splashImage.y = 0;
                } else {
                    splashImage.width = actualWidth;
                }
                //
                splashImage.validate();
                splashImage.x = (actualWidth - splashImage.width) / 2;
                splashImage.y = (actualHeight - splashImage.height) / 2;
            }
            //
			/*if(splashImage){
				splashImage.width = actualWidth;
				splashImage.height = actualHeight;
			}*/
			
			if(backgroundPanorama180Image){
				backgroundPanorama180Image.height = actualHeight+backgroundPanorama180PaddingBottom;
				backgroundPanorama180Image.width = backgroundPanorama180Image.height * backgroundPanorama180Ratio * backgroundPanorama180HTile;
				backgroundPanorama180Image.x = ((actualWidth-backgroundPanorama180Image.width)/2) + backgroundPanorama180XOffset;
			}

            framesContainer.pivotX = int(actualWidth / 2);
            framesContainer.pivotY = int(actualHeight / 2);
            framesContainer.x = framesContainer.pivotX;
            updateCarY();

            windowHalfX = actualWidth / 2;
            windowHalfY = actualHeight / 2;

            framesContainer.visible = _visible;
			
			backgroundContainer.setSize(this.actualWidth, this.actualHeight);
			var scale:Number;
			var newBgHeight:Number = Device.isIphoneXVariant() ? this.actualHeight + 34.5 : this.actualHeight+27.5;
			
			scale = newBgHeight/actualHeight;
			backgroundContainer.myScale = scale;
        }

        if (isInvalid("car_y") || sizeInvalid) {
            if (car && car.size && car.size.hasOwnProperty("width") && car.size.hasOwnProperty("height") && (car.size.width > 1004 || car.size.height > 373)) {
                bgOffset = 50;
                if (Constants.SCALE_FACTOR != 3.375 && !Constants.isIOS) // 3.375 initial scale 1 is good
                {
                    _initialScale = 1.15;
                }
                else {
                    _initialScale = 1;
                }
                framesContainer.scaleX = _initialScale * _scaleComponent;
                framesContainer.scaleY = _initialScale * _scaleComponent;
                carScale = framesContainer.scaleX;
            } else {               
                bgOffset = 0;
            }

            if (car && car.isBigSize) {
                if (car.size.width >= 1920 && car.size.height >= 1080) {
                    bgOffset = 115;

                    if (Constants.SCALE_FACTOR == 1.5 || Constants.SCALE_FACTOR == 3) {
                        _initialScale = 1.35 * 0.52;
                    } else {
                        _initialScale = 0.52
                    }

                    framesContainer.scaleX = _initialScale * _scaleComponent;
                    framesContainer.scaleY = _initialScale * _scaleComponent;
                    carScale = framesContainer.scaleX;

                } else { 
                    bgOffset = 30;

                    if (Constants.SCALE_FACTOR != 3.375 && !Constants.isIOS) // 3.375 initial scale 1 is good
                    {
                        _initialScale = 1.15;
                    }
                    else {
                        _initialScale = 1;
                    }
                    _initialScale = 1;
                    framesContainer.scaleX = _initialScale * _scaleComponent;
                    framesContainer.scaleY = _initialScale * _scaleComponent;
                }
            }

            if (Constants.ThisIsIPAD) {

                bgOffset = 40;
            }
		
			backgroundContainer.y=/*(_carY+24-offset)-*/((frameHeight / 2) - (this.parent.height/2))+13;
			
            updateInitialScale(actualWidth, frameHeight);
			updateCarY();
        }
    }


    public function removeImagesOfPartSlotName(__nameOfPartSlot:String, __layerIndex:int):void {

        if (__nameOfPartSlot.indexOf('antimask') >= 0) {
            trace('ttt');
        } else if (__nameOfPartSlot.indexOf('mask') >= 0) {
            trace('ttt');
        }

        if (partSlotsImagesMap[__nameOfPartSlot]) {
            for (var angel:int = 0; angel < car.countAngels; angel++) {

                for (var j:int = 0; j < car.countFrames; j++) {
                    if (partSlotsImagesMap[__nameOfPartSlot] && partSlotsImagesMap[__nameOfPartSlot][angel]) {
                        var image:ImageLoaderWithStates = partSlotsImagesMap[__nameOfPartSlot][angel][j];
                        if (image) {
                            var layerIndex:int = __layerIndex;

                            if (layerIndex < 0) {

                                layerIndex = image.layerIndex;
                            }
                            frameMap[angel][j].removeChildFromLayer(image, layerIndex);
                            partSlotsImagesMap[__nameOfPartSlot][angel][j] = null;
                        }
                    }
                }

                partSlotsImagesMap[__nameOfPartSlot][angel] = null;
            }
            if (partSlotsImagesMap[__nameOfPartSlot]) {
                delete partSlotsImagesMap[__nameOfPartSlot];
            }
        }
    }

    public function removePartSlot(partSlot:PartSlot, byExcluding:Boolean = false, callAfterLoad:Boolean = true, skipRestore:String = null):void {

        if (!partSlot) {
            return;
        }

        var partSlotName:String = partSlot.name;
        var partSlotNameSuffix:String = partSlot.name + ADD_STATE_SUFFIX;
        var angel:int = 0;
        var i:int;
        if (partSlot.selectedPart) {

            partSlotName = partSlot.name + partSlot.selectedPart.saveIndex;
            partSlotNameSuffix = partSlot.name + ADD_STATE_SUFFIX + partSlot.selectedPart.saveIndex;
            angel = 0;

            var maskMaterial: PartMaterial = partSlot.selectedPart.getPossibleMaterial('mask');
            var antiMaskMaterial: PartMaterial = partSlot.selectedPart.getPossibleMaterial('antimask');
            if (maskMaterial) {
                removeImagesOfPartSlotName('masks_' + partSlot.selectedPart.id, -1);
            }
            if (antiMaskMaterial) {
                removeImagesOfPartSlotName('antimask_' + partSlot.selectedPart.id, -1);
            }
            if (car.isBeetle) {
                if (partSlot.selectedPart.excludedPartSlotsNames.length > 0) {
                    for (i = 0; i < partSlot.selectedPart.excludedPartSlotsNames.length; i++ ) {
                        var p: PartSlot = car.getPossiblePartSlot(partSlot.selectedPart.excludedPartSlotsNames[i]);
                        if (p) {
                            p.isExcluded = false;
                        }
                    }
                }
            }
        }

        if(!partSlotSubpartsMap.hasOwnProperty(partSlotNameSuffix) && !partSlotSubpartsMap.hasOwnProperty(partSlotName)){
            for(i = 0; i < partSlot.possibleParts.length; i++){
                partSlotNameSuffix = partSlot.name + Part(partSlot.possibleParts[i]).saveIndex.toString();
                if(partSlotSubpartsMap.hasOwnProperty(partSlotNameSuffix)){
                    break;
                }
            }
        }

        removeImagesOfPartSlotName(partSlotName, -1);
        removeImagesOfPartSlotName(partSlotNameSuffix, -1);

        if (partSlotSubpartsMap[partSlotName]) {
            for (angel = 0; angel < car.countAngels; angel++) {
                if (partSlotSubpartsMap[partSlotName][angel]) {
                    for (var w:int = 0; w < partSlotSubpartsMap[partSlotName][angel].length; w++) {
                        var sh:ImageLoaderWithStates = partSlotSubpartsMap[partSlotName][angel][w];
                        if (sh) {
                            frameMap[sh.angelIndex][sh.frameIndex].removeChildFromLayer(sh, sh.layerIndex, true);
                        }
                    }
                }

                partSlotSubpartsMap[partSlotName][angel] = [];
            }

            partSlotSubpartsMap[partSlotName] = {};
        }

        if (!byExcluding) {
            var excludedPartSlotsToAdd:Array = [];
            if (partSlot.selectedPart && partSlot.selectedPart.excludedPartSlotsNames) {
                for each(var excludedPartSlotName:String in partSlot.selectedPart.excludedPartSlotsNames) {
                    var excludedPartSlot:PartSlot = car.getPossiblePartSlot(excludedPartSlotName);
					if(!excludedPartSlot) continue;
					if(!partSlot.selectedPart) continue;

                    if (partSlot.selectedPart.excludedPartSlotsNames.indexOf(excludedPartSlot.name) >= 0) {
                        excludedPartSlot.isExcluded = false;
                        if (!excludedPartSlot.selectedPart) {
                            excludedPartSlot.selectedPart = excludedPartSlot.oldBeforeExludeSelectedPart;
                            excludedPartSlot.oldBeforeExludeSelectedPart = null;
                        }
                        excludedPartSlotsToAdd.push(excludedPartSlot);
                    }
                }
            }

            if (partSlot.selectedPart && partSlot.selectedPart.linkedParts.length > 0) {
                _tracer.print("Обрабатываем линкеды при снятии части");
                for (i = 0; i < partSlot.selectedPart.linkedParts.length; i++) {
                    var linkedPart:Part = partSlot.selectedPart.linkedParts[i];
                    _tracer.print("linkedPart.parentSlot:" + linkedPart.parentSlot.name + linkedPart.parentSlot.savePartLinked);

                    //Смотрим была ли до этого у линкеда антимаска
                    if (linkedPart.parentSlot && linkedPart.parentSlot.selectedPart) {
                        var antimaskPartMaterial:PartMaterial = linkedPart.parentSlot.selectedPart.getPossibleMaterial("antimask");
                        if (antimaskPartMaterial) {
                            removeImagesOfPartSlotName("antimask_" + linkedPart.parentSlot.selectedPart.id, -1);
                        }
                    }

                    if (linkedPart.parentSlot.selectedPart) {
                        removeImagesOfPartSlotName("masks_" + linkedPart.parentSlot.selectedPart.id, -1);
                        var antimaskPartMaterial2: PartMaterial =  linkedPart.parentSlot.selectedPart.getPossibleMaterial("antimask");
                        if (antimaskPartMaterial2) {
                            removeImagesOfPartSlotName("antimask_" + linkedPart.parentSlot.selectedPart.id, -1);
                        }
                    }


                    var isRestore:Boolean = !(skipRestore && skipRestore == linkedPart.parentSlot.name);
                    var isRemoveType:Boolean = (partSlot.selectedPart.removeTypes && partSlot.selectedPart.removeTypes.length && partSlot.selectedPart.removeTypes.indexOf(linkedPart.parentSlot.name) != -1);
                    if(isRestore && isRemoveType){
                        if(linkedPart.parentSlot.isMandatory && linkedPart.parentSlot.savePartLinked){
                            linkedPart.parentSlot.selectedPart = linkedPart.parentSlot.savePartLinked;
                        }else if(!linkedPart.parentSlot.isMandatory){
                            linkedPart.parentSlot.selectedPart = linkedPart.parentSlot.savePartLinked;
                        }
                    }

                    if(Car.DISKS_SLOTS.indexOf(linkedPart.name)>=0) {
                        diskRadiusSync(linkedPart.parentSlot, linkedPart, excludedPartSlotsToAdd);
                    }
                    if(Car.BRAKES_SLOTS.indexOf(linkedPart.parentSlot.name)>=0){
                        linkedPart.parentSlot.selectedPart = brakeDiskSync(linkedPart.parentSlot);
                    }
                    if(Car.TIRES_SLOTS.indexOf(linkedPart.parentSlot.name)>=0) {
                        linkedPart.parentSlot.selectedPart = tireDiskSync(linkedPart.parentSlot);
                    }
                    if(Car.TIRE_VINYL_PARTS.indexOf(linkedPart.parentSlot.name)>=0) {
                        linkedPart.parentSlot.selectedPart = vinylDiskSync(linkedPart.parentSlot);
                    }
                    var addToExcluded:Boolean = true;
                    if(partSlot.selectedPart.removeTypes && partSlot.selectedPart.removeTypes.indexOf(linkedPart.parentSlot) == -1){
                        addToExcluded = false;
                    }

                    if (excludedPartSlotsToAdd.indexOf(linkedPart.parentSlot) == -1 && addToExcluded){
                        excludedPartSlotsToAdd.push(linkedPart.parentSlot);
                    }

                    linkedPart.parentSlot.savePartLinked = null;
                }
            }
            if (excludedPartSlotsToAdd.length > 0) {
                var newSlotsUpdate:Array = [];
                for (var z:int = 0; z < excludedPartSlotsToAdd.length; z++) {

                    var partS:PartSlot = excludedPartSlotsToAdd[z];

                    if (partS.selectedPart) {
                        newSlotsUpdate.push(partS);
                    } else {
                        removePartSlot(partS, true);
                    }
                }
                updateWithPartSlots(newSlotsUpdate);
            }else{
				this.progressHandler(1);
                if(callAfterLoad){
                    afterLoading();
                }
            }
        }

        if(previewMode){
            var isChanged:Boolean = false;
            for(i = fastModeLoadedPartSlots.length - 1; i >= 0; i--){
                if(PartSlot(fastModeLoadedPartSlots[i]).selectedPart == null){
                    fastModeLoadedPartSlots.removeAt(i);
                    isChanged = true;
                }
            }
            var slotIndex:int = fastModeLoadedPartSlots.indexOf(partSlot);
            if(slotIndex != -1){
                fastModeLoadedPartSlots.removeAt(slotIndex);
                isChanged = true;
            }
            if(isChanged){
                resetFastModeCurrentLoaded();
            }
            if(fastModeLoadedPartSlots.length == 0){
                afterLoading();
                var cf:int = currentFrame;
                var frameObj:Object = frameMap[currentAngelIndex];
                for(var frameIndex:String in frameObj){
                    var fi:int = parseInt(frameIndex);
                    showFrame(fi, currentAngelIndex);
                }
                showFrame(cf, currentAngelIndex);
                setFastModeFullLoaded();
            }
        }
        partSlot.selectedPart = null;
    }

    public function calculateHeight(car_width:Number = -1, car_height:Number = -1):void {
        if (car_width < 0) {
            car_width = 300;
        }

		if(car.size && car.size.height==900){
        	CarView.CAR_HEIGHT = 40 + (700 - 0) * carTexturesScale;
		}else{
			CarView.CAR_HEIGHT = 40 + (373 - 0) * carTexturesScale;
		}
        if (car.isBeetle) {
            CarView.CAR_HEIGHT -= 50 * carTexturesScale;
        }
        CarView.CAR_HALF_HEIGHT = CAR_HEIGHT / 2;
        CarView.CAR_WIDTH = car_width * carTexturesScale;

        bodyY = 0;
    }

    private var _topOffset:Number = 0;

    public function set topOffset(value:Number):void {
        if (_topOffset != value) {

            if (value <= 0) {
                value = 30;
            }
            _topOffset = value;
            if (_carRect) {

                this.invalidate("update_initial_scale");
            }
        }
    }

    private var _frameHeight:Number = 0;


    public function get frameHeight():Number {

        return _frameHeight;
    }

    public function set frameHeight(value:Number):void {

        if (_frameHeight != value) {
            _frameHeight = value;

            invalidate(INVALIDATION_FLAG_SIZE);
            invalidate("update_initial_scale");
        }
    }

    private var _carRect:Rectangle = null;

    public function updateInitialScale(boxWidth:Number, boxHeight:Number, carRect:Rectangle = null):void {

        if (!carRect) {
            carRect = _carRect;
        }

        if (!carRect) {
            return;
        }

        _carRect = carRect;

        var box_width:Number, box_height:Number;
        var vRatio:Number, hRatio:Number, ratio:Number;

        box_width = boxWidth - 80;
        box_height = boxHeight - (_topOffset + 41);

        hRatio = box_width / (carRect.width);
        vRatio = box_height / (carRect.height);

        ratio = Math.min(vRatio, hRatio);

        this._initialScale = ratio;//initialScale*0.85;
        this.carScale = _initialScale * this._scaleComponent;

        if (framesContainer) {
            framesContainer.scaleX = _initialScale * this._scaleComponent;
            framesContainer.scaleY = _initialScale * this._scaleComponent;
        }
    }

    protected function onFrameFullLoad(event:Event):void {
        moveBloker = false;
    }

    public function selectMaterialForState(partSlot:PartSlot):void {

        var materialName:String;
        var materialOfState:PartMaterial;
        if (partSlot.selectedPart.selectedMaterial) {
            //если у не state детали есть выбранный материал то пытаемся найти этот же материал у state детали
            materialName = partSlot.selectedPart.selectedMaterial.name;
            materialOfState = partSlot.selectedPart.selectedState.getPossibleMaterial(materialName);
			
			trace("selectMaterialForState", materialName);
        }

        if (!materialOfState) {
            //если не нашли материал то берем первый возможный
            materialOfState = partSlot.selectedPart.selectedState.possibleMaterials[0];//временный код на всякий случай
        }

        if (materialOfState) {
            //задаем материал

            if (partSlot.selectedPart.selectedState.isAdditionState) {
				trace("isAdditionState:", true);
                partSlot.selectedPart.selectedMaterialOfAddState = materialOfState;
            } else {
                if (!partSlot.selectedPart.oldSelectedMaterial) {
                    //запоминаем цвет и материял основной детали
                    partSlot.selectedPart.oldSelectedMaterial = partSlot.selectedPart.selectedMaterial;

                    if (partSlot.previousColorOfState) {//востанавливаем цвет состояния если до этого сохраняли
                        partSlot.selectedColor = partSlot.previousColorOfState.copy();
                    }
                }
				
				if(partSlot.selectedPart.selectedState){
					partSlot.selectedPart.selectedState.selectedMaterial = materialOfState;
				}

                partSlot.selectedPart.selectedMaterial = materialOfState;
				
				trace("isAdditionState:", false, materialOfState.name)
            }
        }
    }

    public function setLayerIndexForPartSlot(partSlot:PartSlot):void{
        var slotNames:Array;
        var frameIndex:int;
        var nextFrameIndex:int = 2000;
        var result:Array = [];
        var partSlotName:String;
        var i:int;
        if(partSlot.name == "aerography" && partSlot.selectedPart && partSlot.selectedPart.manufacturer){
            for(i = 0; i < Disk.brandList.data.length; i++){
                if(DiskBrand(Disk.brandList.data[i]).id == partSlot.selectedPart.manufacturer){
                    var brand:DiskBrand = Disk.brandList.data[i] as DiskBrand;
                    partSlotName = "aerography_" + brand.name.toLowerCase().replace(/\s+/, '_');
                    break;
                }
            }
        }
        if (partSlotName && car.layersPositions && car.layersPositions.length > 0) {
            for (i = 0; i < car.layersPositions.length; i++) {
                slotNames = car.layersPositions[i];
                frameIndex = slotNames.indexOf(partSlotName);
                if (partSlot.name == "mask") {
                    frameIndex = 2500;
                }
                if (frameIndex < 0) {
                    frameIndex = nextFrameIndex;
                } else {
                    frameIndex = frameIndex * 10;
                }
                result.push(frameIndex);
            }
            partSlot.layerIndexForFrames = result;
        }
    }

    public function removeCurrentPartWithState(partSlot:PartSlot):void {
        if (!partSlot.currentPartWithState) return;

        if (partSlot.currentPartWithState.oldSelectedMaterial) {
            //удалили выбраное состояние
            //востанавливаем основной цвет и состояние

            if(partSlot.currentPartWithState.selectedMaterial){
                partSlot.currentPartWithState.selectedMaterial = partSlot.currentPartWithState.getPossibleMaterial(partSlot.currentPartWithState.selectedMaterial.name);
                partSlot.currentPartWithState.selectedMaterial ||= partSlot.currentPartWithState.possibleMaterials[0];
            }else{
                partSlot.currentPartWithState.selectedMaterial = partSlot.currentPartWithState.oldSelectedMaterial;
            }
            partSlot.currentPartWithState.oldSelectedMaterial = null;
        }

        partSlot.currentPartWithState.selectedState = null;
    }

    public var neonOn:Boolean = false;

    public function diskRadiusSync(diskPartSlot : PartSlot, diskPart : Part, arrOfPartSlotForUpdate : Array) :void
    {
        var diskRadius:int = (diskPart as PartDisk).selectedDiskSize;
        var prefix : String = diskPartSlot.name.indexOf("disks") >= 0 ? diskPartSlot.name.replace("disks", "") : diskPartSlot.name.replace("disk", "");
        var tirePartSlot:PartSlot;
        var vinylPartSlot:PartSlot;
        var currentName:String = null;
        var founded : Part;

        var vinyls : Array;
        var tires : Array;
        var brakes : Array;
        if(car.suvTires){
            vinyls = car.possiblePartSlotsVinyls; // for suv tires we should update all vinyls
            tires = car.possiblePartSlotsTires; // for suv tires we should update all tires
            brakes = car.possiblePartSlotsBrakes; // same for brakes
        } else {
            tirePartSlot = car.getPossiblePartSlot('tires' + prefix);
            if(!tirePartSlot)
                tirePartSlot= car.getPossiblePartSlot('tire' + prefix);
            tires = [];
            tires.push(tirePartSlot);

            vinylPartSlot = car.getPossiblePartSlot('tire_vinyls' + prefix);
            if(!vinylPartSlot) {
                vinylPartSlot = car.getPossiblePartSlot('tire_vinyl' + prefix);
            }
            if(vinylPartSlot) {
                vinyls = [];
                vinyls.push(vinylPartSlot);
            }


            brakes = [];
            brakes.push(car.getPossiblePartSlot("brake" + prefix));
        }

        for each (var brakeS : PartSlot in brakes)
        {
            if(!brakeS || !brakeS.selectedPart ||brakeS.selectedPart.properties.size == diskRadius)
            {
                if(currentName != null) _tracer.print("brakes ", "ErrorSync", true);
                break;
            }

            if(currentName == null)
            {
                currentName = brakeS.selectedPart.name;
            }

            founded = brakeS.getPossiblePartForAGivenNameAndRadius(currentName, diskRadius);
            if(founded == null){
                founded = brakeS.getFirstPossiblePartForAGivenRadius(diskRadius);
            }

            brakeS.selectedPart = founded;
            arrOfPartSlotForUpdate.push(brakeS);
            currentName = founded.name; //for suv tires

        }

		currentName = null; // reset

        for each (tirePartSlot in tires){
			if(!tirePartSlot || !tirePartSlot.selectedPart ||tirePartSlot.selectedPart.properties.size == diskRadius) {
                if(currentName != null) _tracer.print("tires", "SyncError", true);
                break;
            }

            if(currentName == null) {
                currentName = tirePartSlot.selectedPart.name;
            }

            founded = tirePartSlot.getPossiblePartForAGivenNameAndRadius(currentName, diskRadius);
            if(founded == null){
                founded = tirePartSlot.getFirstPossiblePartForAGivenRadius(diskRadius);
            }

            tirePartSlot.selectedPart = founded;
            arrOfPartSlotForUpdate.push(tirePartSlot);
            currentName = founded.name; //for suv tires
        }

        currentName = null;
        if(vinyls) {
            for each (vinylPartSlot in vinyls) {
                if (!vinylPartSlot || !vinylPartSlot.selectedPart || vinylPartSlot.selectedPart.properties.size == diskRadius) {
                    if (currentName != null) _tracer.print("vinyls", "SyncError", true);
                    break;
                }

                if (currentName == null) {
                    currentName = vinylPartSlot.selectedPart.name;
                }

                founded = vinylPartSlot.getPossiblePartForAGivenNameAndRadius(currentName, diskRadius);
                if (founded == null) {
                    founded = vinylPartSlot.getFirstPossiblePartForAGivenRadius(diskRadius);
                }

                vinylPartSlot.selectedPart = founded;
                arrOfPartSlotForUpdate.push(vinylPartSlot);
                currentName = founded.name; //for suv tire vinyls
            }
        }
    }

	public function tireDiskSync(partSlot : PartSlot, part : Part = null) : Part {
        if(part == null) part = partSlot.selectedPart;
        var radius : int = 0;
        var depSlotPartSlot:PartSlot;
        var tirePrefix : String = partSlot.name.indexOf("tires") >= 0 ? partSlot.name.replace("tires", "") : partSlot.name.replace("tire", "");
        depSlotPartSlot =car.getPossiblePartSlot("disks" + tirePrefix);
        if(!depSlotPartSlot)
            depSlotPartSlot = car.getPossiblePartSlot("disk" + tirePrefix);

        if(depSlotPartSlot)
        {
            radius = (depSlotPartSlot.selectedPart as PartDisk).selectedDiskSize;
            return partSlot.getPossiblePartForAGivenNameAndRadius(part.name, radius);
        }
        return part;
	}

    public function vinylDiskSync(partSlot : PartSlot, part : Part = null) : Part {
        if(part == null) {
            part = partSlot.selectedPart;
        }
        var radius : int = 0;
        var depSlotPartSlot:PartSlot;
        var vinylPrefix : String = partSlot.name.indexOf("tire_vinyls") >= 0 ? partSlot.name.replace("tire_vinyls", "") : partSlot.name.replace("tire_vinyl", "");
        depSlotPartSlot =car.getPossiblePartSlot("disks" + vinylPrefix);
        if(!depSlotPartSlot) {
            depSlotPartSlot = car.getPossiblePartSlot("disk" + vinylPrefix);
        }

        if(depSlotPartSlot) {
            radius = (depSlotPartSlot.selectedPart as PartDisk).selectedDiskSize;
            return partSlot.getPossiblePartForAGivenNameAndRadius(part.name, radius);
        }
        return part;
	}


	public function brakeDiskSync(brakePartSlot : PartSlot, part : Part = null) : Part
	{
		if(part == null) part = brakePartSlot.selectedPart;

        var radius : int = 0;
        var depSlotPartSlot:PartSlot;
        depSlotPartSlot =car.getPossiblePartSlot(brakePartSlot.name.replace("brake", "disk"));
        if(!depSlotPartSlot)
            depSlotPartSlot=car.getPossiblePartSlot(brakePartSlot.name.replace("brake", "disks"));

        if(depSlotPartSlot)
        {
            radius = (depSlotPartSlot.selectedPart as PartDisk).selectedDiskSize;
            return brakePartSlot.getPossiblePartForAGivenNameAndRadius(part.name, radius,  brakePartSlot.selectedPart.properties.dependence);
        }
        return part;
	}


    public function updateWithPartSlots(partSlots:Array, aColorUpdate:Boolean = false, __completeAfterUpdate_fun:Function = null, __angels : Array = null, switchExcludedPart:Boolean = true):void {
        var partSlot:PartSlot;
        var i:int;
        var j:int;
        var selPart:Part;
		_isLoading = true;

        completeAfterUpdate_fun = __completeAfterUpdate_fun;

        if(__angels == null) // if we do not provide camera angels, than it should work for each possible
        {
			__angels = [];
			for(var cc : int = 0; cc < car.countAngels; cc++)
			{
				__angels.push(cc);
			}
        }
		var angel : int;

        images = [];
        index = 0;
        updateStartTime = getTimer();
        colorUpdate = aColorUpdate;

        if (aColorUpdate) {
            partsLoaded = false;
        }

        imagesToLoadCount = 0;
        imagesLoadedCount = 0;

        loadStartTime = getTimer();

        for each(var partSlotForUpdate:PartSlot in partSlots) {
            if(partSlotForUpdate.name == "aerography"){
                setLayerIndexForPartSlot(partSlotForUpdate);
            }
            if (switchExcludedPart && partSlotForUpdate.selectedPart && partSlotForUpdate.selectedPart.excludedPartSlotsNames) {

                for each(var excludedPartSlotName:String in partSlotForUpdate.selectedPart.excludedPartSlotsNames) {
                    var p:PartSlot = car.getPossiblePartSlot(excludedPartSlotName);
                    if(p){
                        if (!p.isExcluded) {
                            p.isExcluded = true;
                            p.oldBeforeExludeSelectedPart = p.selectedPart;
                            removePartSlot(p, true);
                            p.selectedPart = null;
                        } else {
                            p.isExcluded = false;
                        }
                    }
                }
            }
            var imagesAdded:Boolean;
            for each(var selectedPartSlot:PartSlot in car.selectedPartSlots) {
                if ((selectedPartSlot.name.indexOf("aerography")>=0 || PartSlot.VINYLS.indexOf(selectedPartSlot.name)!=-1) && selectedPartSlot.selectedParts) {
                    for (i = 0; i < selectedPartSlot.selectedParts.length; i++) {
                        var selectedPart:Part = selectedPartSlot.selectedParts[i];
                        imagesAdded = partSlotsImagesMap[selectedPartSlot.name + selectedPart.saveIndex];
                        if (!imagesAdded) {
                            continue;
                        }
                    }
                } else {
                    imagesAdded = partSlotsImagesMap[selectedPartSlot.name];
                    if (!imagesAdded) {
                        continue;
                    }
                }

                var shouldBeExluded:Boolean = (partSlotForUpdate.selectedPart) && (partSlotForUpdate.selectedPart.excludedPartSlotsNames &&
                        partSlotForUpdate.selectedPart.excludedPartSlotsNames.indexOf(selectedPartSlot.name) >= 0);

                if (shouldBeExluded) {
                    removePartSlot(selectedPartSlot, true);
                }
            }
        }

        //можно найти и лучшее место для этой строчки

        //	commonAX = /*- car.frontBumperX * carTexturesScale +*/((1004*carTexturesScale)) - ((actualWidth - CarView.CAR_WIDTH) / 2);

        commonAX = -car.frontBumperX * carTexturesScale + ((actualWidth - CarView.CAR_WIDTH) / 2);//((actualWidth-(1004*carTexturesScale))/2)-(CarView.CAR_WIDTH/2);
        var suspension:int;
        if (!colorUpdate) {
            var currentFrameIndex:int = framesIndices.indexOf(currentFrame);
            var t:int = framesIndices[0];
            framesIndices[0] = currentFrame;            framesIndices[currentFrameIndex] = t;
        }

        for each(partSlot  in partSlots) {
            if (partSlot.name == "masks")
                continue;

            suspension = partSlot.isAffectedBySuspension ? car.suspension : 0;
            if(partSlot.lockSuspension && !partSlot.defaultSuspensionLock){
                suspension = car.defaultSuspension;
            }


            if (!partSlot.selectedPart || partSlot.isExcluded) {
                if (!partSlot.selectedParts || partSlot.isExcluded)
                    continue;
            }

            if (partSlot.selectedPart) {
                if (Car.TIRE_VINYL_PARTS.indexOf(partSlot.name) > -1 && partSlot.selectedPart) {
                    var tirePartSlot: PartSlot;
                    if (partSlot.name === 'tire_vinyl_front_left') {
                        tirePartSlot = _car.getPossiblePartSlot('tire_front_left');
                    } else if (partSlot.name === 'tire_vinyl_front_right') {
                        tirePartSlot = _car.getPossiblePartSlot('tire_front_right');
                    } else if (partSlot.name === 'tire_vinyl_rear_left') {
                        tirePartSlot = _car.getPossiblePartSlot('tire_rear_left');
                    } else if (partSlot.name === 'tire_vinyl_rear_right') {
                        tirePartSlot = _car.getPossiblePartSlot('tire_rear_right');
                    }
                    if (tirePartSlot && tirePartSlot.selectedPart && tirePartSlot.selectedPart.selectedState && tirePartSlot.selectedPart.selectedState.nameOfState) {
                        partSlot.selectedPart.selectedState = partSlot.selectedPart.states[tirePartSlot.selectedPart.selectedState.nameOfState];
                    }

                }
                if (partSlot.selectedPart.selectedState) {
                    //выбрано состояние (возможно и до этого этоже было выбрано только цвет поменяли)


                    if (!partSlot.previousColorOfNoState || true) {
                        partSlot.previousColorOfNoState = partSlot.selectedColor.copy();

                        if (partSlot.selectedPart.selectedState.nameOfState && partSlot.selectedPart.selectedState.nameOfState.indexOf("neon") >= 0) {

                            if (neonOn) {

                                if (partSlot.selectedColor.value == 0xffffff) {

                                    partSlot.selectedColor.isNoColor = false;
                                    partSlot.selectedColor.value = car.bodyPartColor.value;
                                    partSlot.selectedPart.color = partSlot.selectedColor.copy();
                                } else {

                                    partSlot.selectedPart.color = partSlot.selectedColor.copy();
                                }
                            }
                        }

                        if (partSlot.selectedColor.value == 0xffffff) {
                            partSlot.selectedPart.color = partSlot.selectedColor.copy();
                        }
                    } else {
                        if (partSlot.selectedPart.selectedState.nameOfState && partSlot.selectedPart.selectedState.nameOfState.indexOf("neon") >= 0) {
                            partSlot.selectedPart.color = partSlot.selectedColor.copy();
                        }
                    }

					trace("1", partSlot.name, aColorUpdate);
                    selectMaterialForState(partSlot);
                    partSlot.currentPartWithState = partSlot.selectedPart;
                    partSlot.previousColorOfState = partSlot.selectedColor.copy();//запоминаем цвет состояния
                    partSlot.selectedPart.color = partSlot.selectedColor.copy();

                } else {

                    if (partSlot.name != "masks") {

                        var partSlotNameSuffix:String = partSlot.name + ADD_STATE_SUFFIX + partSlot.selectedPart.saveIndex;
                        partSlot.selectedPart.selectedMaterialOfAddState = null;
                        removeImagesOfPartSlotName(partSlotNameSuffix, -1);
                    }

                    /*
                     Если выбрана новая деталь из тогоже слота и в которой есть такоеже состояние то выбираем это состояние и назначаем ей такойже цвет,
                     */

                    //partSlot.selectedPart.l
                    if (partSlot.currentPartWithState && partSlot.currentPartWithState.selectedState &&
                            partSlot.selectedPart.states[partSlot.currentPartWithState.selectedState.nameOfState]) {

                        partSlot.selectedPart.selectedState = partSlot.selectedPart.states[partSlot.currentPartWithState.selectedState.nameOfState];
						trace("2");
                        selectMaterialForState(partSlot);
                        partSlot.previousColorOfState = partSlot.selectedColor.copy();//запоминаем цвет состояния

                        //уберем состояние у предыдущей детали если это мы не просто цвет меняем
                        if (partSlot.currentPartWithState != partSlot.selectedPart) {
                            removeCurrentPartWithState(partSlot);
                        }
                        //новый currentPartWithState
                        partSlot.currentPartWithState = partSlot.selectedPart;

                    } else {
                        //иначе обнуляем сохраненый цвет состояния
                        removeCurrentPartWithState(partSlot);
                        partSlot.currentPartWithState = null;
                        partSlot.previousColorOfState = null;

                        if (partSlot.selectedPart.oldSelectedMaterial) {
                            //удалили выбраное состояние
                            //востанавливаем основной цвет и состояние
                            if(partSlot.selectedPart.selectedMaterial){
                                partSlot.selectedPart.selectedMaterial = partSlot.selectedPart.getPossibleMaterial(partSlot.selectedPart.selectedMaterial.name);
                            }else {
                                partSlot.selectedPart.selectedMaterial = partSlot.selectedPart.oldSelectedMaterial;
                            }
                            partSlot.selectedPart.oldSelectedMaterial = null;
                        }

                        if (partSlot.previousColorOfNoState) {

                            //if((partSlot.selectedPart.selectedMaterial.name != "metal")&&(partSlot.previousColorOfNoState.value != 0xffffff)){
                            if (partSlot.selectedPart && partSlot.selectedPart.selectedMaterial && partSlot.selectedPart.selectedMaterial.name != "metal") {
                                partSlot.selectedColor = partSlot.previousColorOfNoState;

                                partSlot.selectedPart.color = partSlot.selectedColor.copy();

                                if (partSlot.previousColorOfNoState.value == 0xffffff) {
                                    //надо материял метал ставить иначе красным будет
                                    var materialForFFFFFF:PartMaterial = partSlot.selectedPart.getPossibleMaterial("metal");
                                    partSlot.selectedPart.selectedMaterial = materialForFFFFFF;
                                }
                            }

                            partSlot.previousColorOfNoState = null;
                        }
                    }
                }

                if (partSlot.selectedPart && partSlot.selectedPart.linkedParts && partSlot.selectedPart.linkedParts.length > 0 && partSlot.selectedPart.possibleMaterials.length == 0) {
                    updateWithPartSlots(partSlot.selectedPart.linkedParts, aColorUpdate);
                    continue;
                }

                if (!partSlot.selectedPart.selectedMaterial) {
                    continue;
                }

                var material:PartMaterial = partSlot.selectedPart.selectedMaterial;
                //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                /*if(partSlot.prevSelectedPartMaterial && material && !partSlot.prevSelectedPartMaterial.isPaintable && material.isPaintable){
                    partSlot.selectedColor = car.getPossiblePartSlot('body').selectedColor;
                }*/
                /////////////////////////////////////////////////////////////////////////////////////////////////////////////////

                if (partSlot.selectedParts && allSlotUpdate) { //////////////////////////////////
                    var oldSelPart:Part = partSlot.selectedPart;

                    for (i = 0; i < partSlot.selectedParts.length; i++) {
                        selPart = partSlot.selectedParts[i];
                        partSlot.selectedPart = selPart;

                        updatePartMaterial(material, partSlot, suspension, false, __angels);

                        if (partSlot.selectedPart.selectedMaterialOfAddState) {
                            updatePartMaterial(partSlot.selectedPart.selectedMaterialOfAddState, partSlot, suspension, true, __angels);
                        }
                    }

                    partSlot.selectedPart = oldSelPart;
                } else {
                    updatePartMaterial(material, partSlot, suspension, false, __angels);

					if (partSlot.selectedPart.selectedMaterialOfAddState) {
                        updatePartMaterial(partSlot.selectedPart.selectedMaterialOfAddState, partSlot, suspension, true, __angels);
                    }
                }

            } else if (partSlot.selectedParts && partSlot.selectedParts.length) { //////////////////////////////////
                for (i = 0; i < partSlot.selectedParts.length; i++) {
                    selPart = partSlot.selectedParts[i];
                    partSlot.selectedPart = selPart;
                    partSlot.selectedColor = partSlot.selectedPart.color.copy();
                    updateWithPartSlots(partSlots, aColorUpdate, __completeAfterUpdate_fun);
                }

                return;
            }
        }

        if (!colorUpdate) {
            for each(partSlot in partSlots) {
                suspension = partSlot.isAffectedBySuspension ? car.suspension : 0;
                if(partSlot.lockSuspension && !partSlot.defaultSuspensionLock){
                    suspension = car.defaultSuspension;
                }

                if (!partSlot.selectedPart || partSlot.isExcluded) {
                    continue;
                }

                if (!partSlot.selectedPart.selectedMaterial) {
                    continue;
                }

                var partSlotName:String = partSlot.name;

                if (partSlot.selectedPart)
                    partSlotName += partSlot.selectedPart.saveIndex;

                if (partSlotSubpartsMap[partSlotName]) {

                    if (partSlot.name.indexOf("aerography")<0) {
                        for each(angel in __angels) {
                            var isNull:Boolean = true;
                            var w:int;
                            if (partSlotSubpartsMap[partSlotName][angel]) {
                                for (w = 0; w < partSlotSubpartsMap[partSlotName][angel].length; w++) {
                                    var sh:ImageLoaderWithStates = partSlotSubpartsMap[partSlotName][angel][w];
                                    var remove:Boolean = true;
                                    if(previewMode && !(sh.angelIndex == currentAngelIndex && sh.frameIndex == currentFrame) && fastModeLoadedFrames && fastModeLoadedFrames[sh.angelIndex] && fastModeLoadedFrames[sh.angelIndex][sh.frameIndex]){
                                        remove = false;
                                    }
                                    if (sh && remove) {
                                        frameMap[sh.angelIndex][sh.frameIndex].removeChildFromLayer(sh, sh.layerIndex, true);
                                        partSlotSubpartsMap[partSlotName][angel][w] = null;
                                    }

                                    if(isNull && !remove){
                                        isNull = false;
                                    }
                                }
                            }

                            if(isNull) {
                                partSlotSubpartsMap[partSlotName][angel] = [];
                            }else{
                                for(w = partSlotSubpartsMap[partSlotName][angel].length - 1; w >= 0; w--){
                                    if(partSlotSubpartsMap[partSlotName][angel][w] == null){
                                        partSlotSubpartsMap[partSlotName][angel].removeAt(w);
                                    }
                                }
                            }
                        }
                    }
                }

				if(angel != 1 || __angels.length != 1)
				{
                	partSlotSubpartsMap[partSlotName] = {};
				}

                var materialName:String = partSlot.selectedPart.selectedMaterial.name;

                for each(var subpart:Part in partSlot.selectedPart.subparts) {
                    var replacePartSlot:PartSlot = partSlot;
                    var li:int;
                    if (partSlot.name == "fender_flares") {
                        if (subpart.subposition == PartSubposition.HIGHEST_LAYER) {
                            replacePartSlot = new PartSlot(car);
                            replacePartSlot.name = "fenderflares";
                            replacePartSlot.layerIndex = partSlot.layerIndex;
                        }
                    }

                    var l:int = 0;
                    var mat:PartMaterial;

                    for each(angel in __angels) {
                        for (var frameIndex:int = 0; frameIndex < framesIndices.length; frameIndex++) {
                            j = framesIndices[frameIndex];

                            var mat_index:int = -1;

                            if (subpart.subpartType == "disks") {
                                materialName = "metal";
                            }

                            for (l = 0; l < subpart.possibleMaterials.length; l++) {
                                mat = subpart.possibleMaterials[l];

                                if (mat.name == materialName) {
                                    mat_index = l;
                                }
                            }

                            if (mat_index < 0) {
                                var allPartSlot:PartSlot = _car.editablePartSlots[0];

                                var materialName2:String;
                                if (bodyPartSlot && bodyPartSlot.selectedPart && bodyPartSlot.selectedPart.selectedMaterial) {
                                    materialName2 = bodyPartSlot.selectedPart.selectedMaterial.name;
                                } else if(allPartSlot.selectedPart) {
                                    materialName2 = allPartSlot.selectedPart.selectedMaterial.name;
                                }

                                for (l = 0; l < subpart.possibleMaterials.length; l++) {
                                    mat = subpart.possibleMaterials[l];
                                    if (mat.name == materialName2) {
                                        mat_index = l;
                                    }
                                }
                            }

                            if (mat_index < 0) {
                                mat_index = 0;
                            }

                            var subpartMaterial:PartMaterial = subpart.possibleMaterials[mat_index];

                            if (!subpartMaterial) continue;

                            if (angel == 1 && j % car.stepOfFrameIndexUp != 0) {
                                continue;

                            } else if ( angel < 1 && j % car.stepOfFrameIndex != 0) {

                                continue;
                            }

                            if (previewMode && !(angel == currentAngelIndex && j == currentFrame)) {
                                continue;
                            }

							var normalFrame:int = this.getNormalizeFrame(angel, j);
                            var subpartMaterialImage:PartMaterialImage = subpartMaterial.getImage(normalFrame, angel);

                            if (subpartMaterialImage) {
								
								var layerIndex:int = partSlot.layerIndex;
								
								var f:int = normalFrame / car.camera1LayerPositionStep;
								
								if (angel > 0) {
									if(car.stepOfFrameIndexUp == 12){
										f = (j / car.camera2LayerPositionStep) + (car.countFrames /car.camera1LayerPositionStep );// + (car.countFrames==48 ? 1: 0);
									}else{
										f = (normalFrame / car.camera2LayerPositionStep) + (car.countFrames / 2 /*car.camera1LayerPositionStep*/ ) + (car.countFrames==48 ? 1: 0);
									}
								}
								
								if (partSlot.layerIndexForFrames && partSlot.layerIndexForFrames.length > 0) {
									layerIndex = partSlot.layerIndexForFrames[f];
								}
								
								if (subpart.subposition == PartSubposition.LOWEST_LAYER) {
									li = 2;
								}
								else if (subpart.subposition == PartSubposition.BELOW_PARENT_LAYER) {
									li = layerIndex - 1;
								}
								else if (subpart.subposition == PartSubposition.ABOVE_PARENT_LAYER) {
									li = layerIndex + 1;
								}
								else if (subpart.subposition == PartSubposition.HIGHEST_LAYER) {
									li = car.maxPartSlotLayerIndex;
									car.maxPartSlotLayerIndex++;
								}
								
                                var subpartImage:ImageLoaderWithStates = new ImageLoaderWithStates();
                                subpartImage.carPart = true;
                                subpartImage.angelIndex = angel;
                                subpartImage.layerIndex = li;
                                subpartImage.frameIndex = j;
                                subpartImage.startManually = true;
                                subpartImage.persistentImageProvider = subpartMaterialImage;
                                subpartImage.completeHandler = imageLoaderCompleteHandler;

                                subpartImage.textureScale = carTexturesScale;

                                subpartImage.kx = carTexturesScale;
                                subpartImage.ax = commonAX;

                                subpartImage.ky = carTexturesScale;
                                subpartImage.ay = (bodyY - suspension) * carTexturesScale;  //f

                                if (partSlot.selectedColor && subpartMaterial.name !== 'metal') {
                                    var color:uint = partSlot.selectedColor.value;
                                    if (color == 0xffffff) {
                                        color = bodyPartSlot.selectedColor.value;
                                    }
                                    subpartImage.color = color;
                                } else {
                                    subpartImage.color = 0xffffff;
                                }

								if(subpartMaterial && ( subpartMaterial.name=="gold" ||  subpartMaterial.name=="silver")){
									subpartImage.color = 0xffffff;
									subpartImage.newColor = 0xFFFFFF;
									subpartImage.newColor_b = true;
								}

                                subpartImage.x = (subpartImage.kx * subpartMaterialImage.x + subpartImage.ax);
                                subpartImage.y = (subpartImage.ky * subpartMaterialImage.y + subpartImage.ay);
                                images.push(subpartImage);
                                CarFrameView(frameMap[angel][j]).addChildAtLayer(subpartImage, li, replacePartSlot);

                                if (!partSlotSubpartsMap[partSlotName]) {
                                    partSlotSubpartsMap[partSlotName] = {};
                                }

                                if (!partSlotSubpartsMap[partSlotName][angel]) {
                                    partSlotSubpartsMap[partSlotName][angel] = [];
                                }

                                partSlotSubpartsMap[partSlotName][angel].push(subpartImage);
                                imagesToLoadCount++;
                            }
                        }
                    }
                }
            }
        }


        /*  START MASK UPDATE*/

        if (!colorUpdate) {
            var z:int;
            var part:Part;
            var u:int;
            for each(partSlot  in partSlots) {

                suspension = partSlot.isAffectedBySuspension ? car.suspension : 0;
                if(partSlot.lockSuspension && !partSlot.defaultSuspensionLock){
                    suspension = car.defaultSuspension;
                }

				var tiresMask : Boolean = (car.tireMasks && Car.TIRES_SLOTS.indexOf(partSlot.name) >= 0);
				var diskMask : Boolean = (!car.tireMasks && Car.DISKS_SLOTS.indexOf(partSlot.name) >= 0 && !car.suvTires);

                if ((diskMask || tiresMask) && partSlot.selectedPart && partSlot.selectedPart.selectedState && partSlot.selectedPart.selectedState.nameOfState ) {

                    if (car.isNewMask) {
						car.recreateMasks(partSlot.selectedPart, __angels);
                    }
                    if (partSlotMask) {
                        var nameState:String = partSlot.selectedPart.selectedState.nameOfState;
                        nameState = nameState.replace("-neon-", "-");
                        nameState = nameState.replace("-neon", "");
                        nameState = nameState.replace("neon-", "");
                        for (z = 0; z < partSlotMask.possibleParts.length; z++) {

                            part = partSlotMask.possibleParts[z];

                            if (part.nameOfState == nameState) {
                                part.maskForSlots = ObjectUtils.mergeArray(partSlot.selectedPart.affectedSlots, part.maskForSlots);
                                partSlotMask.selectedPart = part;
                                partSlotMask.selectedPart.maskSet = partSlot.selectedPart.id;
                                partSlotMask.setterMaskPartSlotName = partSlot.name;
                                partSlotMask.layerIndex++;

                                if (partSlotMask.layerIndexForFrames) {
                                    for (u = 0; u < partSlotMask.layerIndexForFrames.length; u++) {
                                        partSlotMask.layerIndexForFrames[u]++;
                                    }
                                }
                                if (partSlotMask.selectedPart.selectedMaterial){
                                    updatePartMaterial(partSlotMask.selectedPart.selectedMaterial, partSlotMask, suspension, false, __angels);
                                }
                                partSlotMask.selectedPart.maskSet = "";
                                partSlotMask.selectedPart = null;
                            }
                        }///
                    }
                } else if (partSlotMask) {
                    if (partSlot.selectedPart && partSlot.selectedPart.affectedSlots && partSlot.selectedPart.affectedSlots.length > 0) {
                        for (z = 0; z < partSlotMask.possibleParts.length; z++) {
                            part = partSlotMask.possibleParts[z];

                            if (part.id == partSlot.selectedPart.id + "_") {
                                if (partSlotMask.selectedPart != part) {
                                    partSlotMask.selectedPart = part;
                                    partSlotMask.selectedPart.maskSet = partSlot.selectedPart.id;
                                    partSlotMask.setterMaskPartSlotName = partSlot.name;

                                    var selectedMaterial:PartMaterial = partSlotMask.selectedPart.selectedMaterial;

                                    if (diskMask || tiresMask)
                                    {
                                        selectedMaterial = partSlot.selectedPart.getPossibleMaterial("mask");
                                        partSlotMask.selectedPart.selectedMaterial = selectedMaterial;
                                    }

                                    partSlotMask.layerIndex++;

                                    if (partSlotMask.layerIndexForFrames) {

                                        for (u = 0; u < partSlotMask.layerIndexForFrames.length; u++) {

                                            partSlotMask.layerIndexForFrames[u]++;
                                        }
                                    }

//                                    if (Car.CAR_DISKS_SLOTS.indexOf(partSlot.name )>=0) {
//                                        updatePartMaterial(selectedMaterial, partSlotMask, car.defaultSuspension, false, __angels);
//                                    } else {
//                                    }
                                    updatePartMaterial(selectedMaterial, partSlotMask, suspension, false, __angels);

                                    partSlotMask.selectedPart.maskSet = "";
                                    partSlotMask.selectedPart = null;
                                }
                            }
                        }
                    }
                }


                //antimask
                if (partSlot.selectedPart) {

                    var antimaskPartMaterial:PartMaterial = partSlot.selectedPart.getPossibleMaterial("antimask");
                    if (antimaskPartMaterial && partSlotMask) {

                        if (!antimaskPartSlot) {
                            antimaskPartSlot = new PartSlot(car);
                            antimaskPartSlot.name = "antimask";
                            partSlotMask.layerIndex++;
                            antimaskPartSlot.layerIndex = partSlotMask.layerIndex + 100;
                        }

                        var partAntimask:Part = new Part(antimaskPartSlot);
                        partAntimask.id = partSlot.selectedPart.id;
                        partAntimask.maskSet = partAntimask.id;
                        antimaskPartSlot.setterMaskPartSlotName = partSlot.name;

                        antimaskPartSlot.layerIndex++;
                        antimaskPartSlot.selectedPart = partAntimask;

                        updatePartMaterial(antimaskPartMaterial, antimaskPartSlot, car.defaultSuspension, false, __angels);

                        for (j = 0; j < antimaskNames.length; j++) {


                            updateSuspensionMask(antimaskNames[j]);
                        }

                        partAntimask.maskSet = "";
                        antimaskPartSlot.selectedPart = null;

                    }
                }
            }
        }

        //for each(var ImagE : ImageLoaderWithStates in images){
        //	ImagE.visible = false;
        //}

        if(previewMode){
            for(i = 0; i < partSlots.length; i++){
                if(fastModeLoadedPartSlots.indexOf(partSlots[i]) == -1){
                    fastModeLoadedPartSlots.push(partSlots[i]);
                }
            }
        }

        if (!colorUpdate) {
            if (initialPartsAdded) {
                if (images.length > 0) {


                    if (progressHandler) {
                        progressHandler(0.0);
                        progressHandler(0.01);
                    }

                }
            }

			
			if(images.length>0 ){
				
				_loadCurrentFrameImages = 0;
				_loadedCurrentFrameImages = 0;
				var newImages1:Array = [];
				var newImages2:Array = [];
				var image:ImageLoaderWithStates;
				
				var partMaterialImage:PartMaterialImage;
				var partMaterial:PartMaterial;
				
				//trace("images.length:", images.length)
				for(i=0; i<images.length; i++){
					image = images[i];
                    if (image && previewMode && !(image.angelIndex == currentAngelIndex && image.frameIndex == currentFrame)) {
                        continue;
                    }

					if(image && image.frameIndex == locCurrentFrame &&  image.angelIndex == locAngleIndex){
						
						newImages1.push(image);
						_loadCurrentFrameImages++;
						
						//trace("_loadCurrentFrameImages:", _loadCurrentFrameImages)
					}else{
						newImages2.push(image);
					}
					
				}
				
				imagesToLoadCount = 0;
				images = [];
				
				for(i=0; i<newImages1.length; i++){
                    images.push(newImages1[i]);
					imagesToLoadCount++;
				}
				
			
				for(i=0; i<newImages2.length; i++){
					image = newImages2[i];
					if(!isFastModeEnable){
                        images.push(image);
						imagesToLoadCount++;
					}else{
						image.persistentImageProvider = null;
					}
				}
				
				
			}
			
            runTest();
        }

		this.filteringSuspension();

        if (!initialPartsAdded) {
            addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
            initialPartsAdded = true;
            currentFrame = -1;
            currentAngelIndex = -1;

            //stopShowFrame = false;
			targetRotation=car.startFrame*4;
			_rotation = targetRotation;
            showFrame(car.startFrame*4, 0);
        } else if (colorUpdate) {
            _isLoading = false;
        }
    }
	
	private var _fastModeLoadedParts:Array = [];
	
	public function get fastModeLoadedParts():Array{
		
		return _fastModeLoadedParts;
	}
	
	public function removePartFromFastModeLoadedByPartSlot(partSlot:PartSlot):void{
		
		for(var i:int=_fastModeLoadedParts.length-1; i>=0; i--){
			var p:Part = _fastModeLoadedParts[i];
			if(partSlot==p.parentSlot) {
				p.isFastModeLoaded = false;
				_fastModeLoadedParts.splice(i, 1);
			}
		}
	}
	
	public function addPartToFastModeLoaded(part:Part):void{
		trace("addPartToFastModeLoaded:", part.name);
		part.isFastModeLoaded = true;
		if(_fastModeLoadedParts.indexOf(part)<0){
			
			_fastModeLoadedParts.push(part);
		}
	}
	
	public function removePartFromFastModeLoaded(part:Part):void{
		trace("removePartFromFastModeLoaded:", part.name);
		part.isFastModeLoaded = false;
		var index:int = _fastModeLoadedParts.indexOf(part);
		if(index>=0){
			_fastModeLoadedParts.splice(index, 1);
		}
	}
	
	public var fastModeLastSetPartSlot:PartSlot = null;
	
	private var _isFastModeEnable:Boolean = false;
	
	public function set isFastModeEnable(value:Boolean):void{
		_isFastModeEnable = value;
		
		lockedTouch = _isFastModeEnable;
	}
	
	public function get isFastModeEnable():Boolean {
		return _isFastModeEnable;
	}
	
	//public function setFastModeFrameMap(enable:Boolean, saveCurrentFrameIndex:int):void{
		
		//isFastModeEnable = enable;
		//lockedTouch = enable;
		
		
		/*var carFrameMap:CarFrameView;
		for(var angelIndex:int in frameMap){
			if(!frameMap[angelIndex]) continue;
			
			for(var frameIndex:int in frameMap[angelIndex]){
				
				carFrameMap = frameMap[angelIndex][frameIndex];
				
				if(!enable) {
					
					trace("setFastModeFrameMap:", carFrameMap.angelIndex, carFrameMap.frameIndex, "false")
					
					carFrameMap.skipForFastMode = false; 
				}
				else if(carFrameMap.frameIndex!=saveCurrentFrameIndex && carFrameMap.frameIndex!=12 && carFrameMap.frameIndex!=36){
					trace("setFastModeFrameMap:", carFrameMap.angelIndex, carFrameMap.frameIndex, "true")
					carFrameMap.skipForFastMode = true;	
				}	
				else {
					trace("setFastModeFrameMap:", carFrameMap.angelIndex, carFrameMap.frameIndex, "false")
					carFrameMap.skipForFastMode = false;
				}
			}
			
		}*/
	//}
	
	private var _loadCurrentFrameImages:int = 0;
	private var _loadedCurrentFrameImages:int = 0;
    private function runTest():void {
        var image:ImageLoaderWithStates;
        if(images.length>0){
            var i:int;
            for(i = images.length-1; i > -1; i--){
                image = images[i] as ImageLoaderWithStates;
                if(i != images.indexOf(images[i])){
                    images.removeAt(i);
                    continue;
                }
                if(previewMode && !(image.frameIndex == currentFrame && image.angelIndex == currentAngelIndex)){
                    images.removeAt(i);
                }
            }
            imagesToLoadCount = images.length;
            var count:int = Math.min(index + imagesGroupSize,  images.length);
            for (i = index; i < count; i++) {
                image = images[i];
                image.skipZip = previewMode;
                image.errorHandler = imageLoaderCompleteHandler;//error;
                image.completeHandler = imageLoaderCompleteHandler;//complete;
                image.startLoading(true);
            }
            if(visible && images.length == 0){
                if(previewMode){
                    allImagesLoaded();
                    showFrame(currentFrame, currentAngelIndex);
                }else{
                    afterLoading();
                }
            }
        }else{
            if(this.visible){
                if(previewMode){
                    progressHandler(1);
                    allImagesLoaded();
                    showFrame(currentFrame, currentAngelIndex);
                }else{
                    progressHandler(1);
                    afterLoading();
                }
            }
        }
    }
	
	private function error():void {
		index++;
		
		if (index % imagesGroupSize == 0) {
			runTest();
		}
	}
	
	private function imageLoaderCompleteHandler(image:ImageLoaderWithStates = null):void {
		if (image && image.frameIndex == locCurrentFrame &&  image.angelIndex == locAngleIndex) {
			_loadedCurrentFrameImages++;
			if(_loadedCurrentFrameImages>=_loadCurrentFrameImages && _loadCurrentFrameImages == images.length){
				if(visible){
					_loadedCurrentFrameImages = 0;
					_loadCurrentFrameImages = 0;
					afterLoading();
				}
			}
		}else{
			if (image && image.carPart) {
				if(image.angelIndex !=locAngleIndex){
					image.cleanupMemory();
				}else{
					image.loadFromCache(true);
				}
			}
		}
		if (colorUpdate) {
			partsLoaded = true;  
			return;
		}
		imagesLoadedCount++;
		if (progressHandler) {
			var progress:Number = imagesLoadedCount / imagesToLoadCount;
			progressHandler(progress);
			if (progress >= 1) {
				partsLoaded = true;
				_isLoading = false;
				if (completeAfterUpdate_fun != null) {
					completeAfterUpdate_fun();
					completeAfterUpdate_fun = null;
				}
				if(this.visible){
                    afterLoading();
				}
                if(hasEventListener(ALL_IMAGES_LOADED)){
                    dispatchEvent(new Event(ALL_IMAGES_LOADED));
                }
			} else {
				index++;
				if (index % imagesGroupSize == 0) {
					runTest();
				}
			}
		}
	}


    public function get antimaskLayerIndex():int {

        var max:int = 0;
        for (var angel:int = 0; angel < car.countAngels; angel++) {

            for (var frameIndex:int = 0; frameIndex < framesIndices.length; frameIndex++) {
                var j:int = framesIndices[frameIndex];

                if (frameMap[angel][j]) {
                    var carFrameView:CarFrameView = frameMap[angel][j];

                    if (carFrameView.maxLayerIndex > max) {

                        max = carFrameView.maxLayerIndex;
                    }
                }
            }

        }

        return max;
    }


    public var allSlotUpdate:Boolean = false;

    private var antimaskNames:Array = [];


    private function updatePartMaterial(material:PartMaterial, partSlot:PartSlot, suspension:int, isAddState:Boolean, angels : Array):void {
        if (partSlot.name == "front_fender") {
            trace('1')
        }
        Car.updateTextureBlocker = true;

        var nameOfPartSlot:String = isAddState ? partSlot.name + ADD_STATE_SUFFIX : partSlot.name;
        if (partSlot.name == "masks") {
            nameOfPartSlot = partSlot.name + "_" + partSlot.selectedPart.maskSet;
        }

        if (partSlot.name == "antimask") {
            nameOfPartSlot = partSlot.name + "_" + partSlot.selectedPart.maskSet;
            antimaskNames.push(nameOfPartSlot);
        }


        if (partSlot.name.indexOf("aerography")>=0) {

            if (partSlot.selectedPart.saveIndex == "")
                partSlot.selectedPart.saveIndex = (Math.random() * 1000000).toFixed(0);

            nameOfPartSlot += partSlot.selectedPart.saveIndex;
        }

        var partMaterialImage:PartMaterialImage;
        var nameOfSubpartsMap:String = nameOfPartSlot;
        var angel:int;
        if (partSlotSubpartsMap && partSlotSubpartsMap[nameOfSubpartsMap]) {
            for each(angel in angels){
                if (partSlotSubpartsMap[nameOfSubpartsMap][angel]) {

                    for (var w:int = 0; w < partSlotSubpartsMap[nameOfSubpartsMap][angel].length; w++) {
                        var sh:ImageLoaderWithStates = partSlotSubpartsMap[nameOfSubpartsMap][angel][w];

                        if (sh && sh.persistentImageProvider && (sh.persistentImageProvider as PartMaterialImage) && (sh.persistentImageProvider as PartMaterialImage).parentMaterial && (sh.persistentImageProvider as PartMaterialImage).parentMaterial.name != 'metal') {
                            if (partSlot.selectedColor)
                                sh.color = partSlot.selectedColor.value;
                        }
                    }
                }
            }
        }


        if (!partSlotsImagesMap[nameOfPartSlot]) {
            partSlotsImagesMap[nameOfPartSlot] = {};
        }


        for each(angel in angels) {

            if (!partSlotsImagesMap[nameOfPartSlot][angel])
                partSlotsImagesMap[nameOfPartSlot][angel] = [];

            for (var frameIndex:int = 0; frameIndex < framesIndices.length; frameIndex++) {
                var j:int = framesIndices[frameIndex];
                if (angel == 1 && j % car.stepOfFrameIndexUp != 0) {
                    continue;
                } else if (angel != 1 && j % car.stepOfFrameIndex != 0) {
                    continue;
                }

                if (previewMode && !(angel == currentAngelIndex && j == currentFrame)) {
                    continue;
                }

				var normalFrame:int = this.getNormalizeFrame(angel, j);
                partMaterialImage = material.getImage(normalFrame, angel);
                if (!partMaterialImage) {
                    if (partSlotsImagesMap[nameOfPartSlot][angel] && partSlotsImagesMap[nameOfPartSlot][angel][j]) {
                        var prevImage:ImageLoaderWithStates = partSlotsImagesMap[nameOfPartSlot][angel][j];
                        if (prevImage) {
                            prevImage.visible = false;
                        }
                    }
                    continue;
                }

                if (!frameMap[angel]) {
                    frameMap[angel] = {};
                }

                if (!frameMap[angel][j]) {

                    frameMap[angel][j] = new CarFrameView(car.maxPartSlotLayerIndex + 1, j, angel);
                    (frameMap[angel][j] as CarFrameView).addEventListener("frame_loaded", onFrameFullLoad);
                    frameMap[angel][j].visible = false;

                    if (car.size && car.size.hasOwnProperty("width") && car.size.hasOwnProperty("height")) {

                        (frameMap[angel][j] as CarFrameView).FRAME_WIDTH = car.size.width;
                        (frameMap[angel][j] as CarFrameView).FRAME_HEIGHT = car.size.height;
                    } else {

                        (frameMap[angel][j] as CarFrameView).FRAME_WIDTH = 1004;
                        (frameMap[angel][j] as CarFrameView).FRAME_HEIGHT = 373;
                    }

                    frameMap[angel][j].y = (actualHeight - CAR_HEIGHT) / 2;
                    framesContainer.addChild(frameMap[angel][j]);
                }

                var image:ImageLoaderWithStates = partSlotsImagesMap[nameOfPartSlot][angel][j];

                if (!image) {
                    image = new ImageLoaderWithStates();
                    image.carPart = true;
					if(partSlot.isMask ){
						image.disalowCleanupMemory = true;
					}
                    image.frameIndex = j;
                    image.angelIndex = angel;
                    image.textureScale = carTexturesScale;
                    image.completeHandler = imageLoaderCompleteHandler;



                    if (!addedListenersForFirstDownloadedImage) {
                        addedListenersForFirstDownloadedImage = true;

                        image.addEventListener(Event.COMPLETE, partMaterialImageLoaderCompleteHandler);
                    }

                    var f:int =  normalFrame / car.camera1LayerPositionStep;

					if (angel > 0) {
						if(car.stepOfFrameIndexUp == 12){
							f = (j / car.camera2LayerPositionStep) + (car.countFrames /car.camera1LayerPositionStep ); //+ (car.countFrames==48 ? 1: 0);
						}else{
							f = (normalFrame / car.camera2LayerPositionStep) + (car.countFrames / 2/*car.camera1LayerPositionStep*/ ) + (car.countFrames==48 ? 1: 0);
						}
					}

                    var layerIndex:int = partSlot.layerIndex;

                    if (partSlot.layerIndexForFrames && partSlot.layerIndexForFrames.length > 0) {
                        layerIndex = partSlot.layerIndexForFrames[f];
                    }

                    if(partSlot.name == "masks" && CarFrameView(frameMap[angel][j]).layers[layerIndex] && !PixelMaskDisplayObject(CarFrameView(frameMap[angel][j]).layers[layerIndex]).isMask){
                        layerIndex = 2500; // TODO  ******* check
                    }

                    CarFrameView(frameMap[angel][j]).addChildAtLayer(image, layerIndex, partSlot);
                    partSlotsImagesMap[nameOfPartSlot][angel][j] = image;
                }

                if (colorUpdate) {
                    if (partSlot.selectedPart && partSlot.selectedPart.selectedMaterial && !partSlot.selectedPart.selectedMaterial.isPaintable) {
                        image.color = 0xFEFFFF;
                    } else  {
                        if (partSlot.selectedColor) {
                            image.color = partSlot.selectedColor.value;
                        }
                        else {
                            image.color = 0xFEFFFF;
                        }
                    }

                    image.newColor_b = false;

                } else {
                    if (partSlot.selectedPart && partSlot.selectedPart.selectedMaterial && !partSlot.selectedPart.selectedMaterial.isPaintable) {
                        image.color = 0xFEFFFF;
                    } else {
                        if (partSlot.selectedColor) {
                            if (isAddState && partSlot.name == "rear_lights") {
                                image.newColor = 0xFFFFFF;//partSlot.selectedColor.value;
                            } else {
                                image.newColor = partSlot.selectedColor.value;
                            }
                        } else {
                            image.newColor = 0xFEFFFF;
                        }
                    }
                    image.newColor_b = true;
                }

                if (partSlot.name.indexOf("aerography")>=0 || PartSlot.VINYLS.indexOf(partSlot.name)!=-1) {
                    partSlot.selectedPart.color = partSlot.selectedColor;
                }

				if(material && PartMaterial.UNPAINTABLE_MATERIAL_TYPES.indexOf(material.name) != -1){ //( material.name=="gold" ||  material.name=="silver" || material.name == "metal")
					image.color = 0xffffff;
					image.newColor = 0xFFFFFF;
					image.newColor_b = true;
				}

                imagesToLoadCount++;

				image.visible = true;
                image.startManually = true;
                image.persistentImageProvider = partMaterialImage;

                image.kx = carTexturesScale;
                image.ax = commonAX;

                image.ky = carTexturesScale;
                image.ay = (bodyY - suspension) * carTexturesScale; //f

				image.x = (image.kx * partMaterialImage.x + image.ax);
				image.y = (image.ky * partMaterialImage.y + image.ay);
                images.push(image);
            }
        }

        Car.updateTextureBlocker = false;
    }

    private function recieveImageSize(bmp_width:Number, bmp_height:Number, image:ImageLoaderWithStates):void {

        var partMaterialImage:PartMaterialImage = image.persistentImageProvider as PartMaterialImage;

        partMaterialImage.x -= bmp_width / 2;
        partMaterialImage.y -= bmp_height / 2;

        image.x = (image.kx * partMaterialImage.x + image.ax);
        image.y = (image.ky * partMaterialImage.y + image.ay);

        image.visible = true;

        image.recieveImageSize2 = null;
    }

   

    private function partMaterialImageLoaderCompleteHandler(event:Event):void {

        ImageLoaderWithStates(event.target).removeEventListener(Event.COMPLETE, partMaterialImageLoaderCompleteHandler);
        dispatchEventWith(FIRST_IMAGE_DOWNLOADED, true);
    }

    public function updateSuspension():void {
		try{
		var selPart:Part ;
		var partSlotName:String;
        var material:PartMaterial;
        var angel:int;
        var i:int;
        var subpartImage:ImageLoaderWithStates;
        var subpartMaterialImage:PartMaterialImage;
            for each(var partSlot:PartSlot in car.possiblePartSlots) {


            if (partSlot.name == "chassi") {

                continue;
            }


            if (!partSlot.selectedPart || !partSlot.isAffectedBySuspension) {
                if (!partSlot.selectedParts || !partSlot.isAffectedBySuspension) {
                    continue;
                }
            }


            if (partSlot.selectedParts) {
                var selectedPart:Part = partSlot.selectedPart;
                for (i = 0; i < partSlot.selectedParts.length; i++) {
                    selPart = partSlot.selectedParts[i];
                    material = selPart.selectedMaterial;
                    if (!material) {
                        continue;
                    }
					
					partSlotName = partSlot.name;
					
					if(selPart){
						partSlotName+=selPart.saveIndex;
					}
                    partSlot.selectedPart = selPart;
                    updateSuspensionOfMaterial(material, partSlot.name);
                    if (selPart) {
                        updateSuspensionOfMaterial(partSlot.selectedPart.selectedMaterialOfAddState, partSlot.name + ADD_STATE_SUFFIX);
						if(selPart.subparts){
							for(j = 0; j < selPart.subparts.length; j++){
								selPart = selPart.subparts[j];
								if(!selPart) continue;
								material = selPart.selectedMaterial;
								if(!material) continue;
								updateSuspensionOfMaterial(material, partSlot.name);
							}
						}
                    }

                    if (!partSlotSubpartsMap[partSlotName]) {
                        continue;
                    }


                    for (angel = 0; angel < car.countAngels; angel++) {
                        if (partSlotSubpartsMap[partSlotName][angel]) {
                            for each(subpartImage in partSlotSubpartsMap[partSlotName][angel]) {
                                subpartMaterialImage = subpartImage.persistentImageProvider as PartMaterialImage;
                                if (subpartMaterialImage) {
                                    if (subpartMaterialImage.remoteUrl.indexOf("disks") < 0) {
										//trace("subpart suspension:", subpartMaterialImage.remoteUrl)
                                        subpartImage.ignorePendingCoordinates = true;
                                        subpartImage.y = ( subpartMaterialImage.y - bodyY - car.suspension) * carTexturesScale;
                                        subpartImage.ignorePendingCoordinates = false;
                                    }
                                }
                            }

                        }
                    }
                }
            } else {
                material = partSlot.selectedPart.selectedMaterial;
                if (!material) {
                    continue;
                }
				partSlot.selectedPart.saveIndex = "";
                updateSuspensionOfMaterial(material, partSlot.name);
                if (partSlot.selectedPart) {
                    updateSuspensionOfMaterial(partSlot.selectedPart.selectedMaterialOfAddState, partSlot.name + ADD_STATE_SUFFIX);
					selPart = partSlot.selectedPart;
					if(selPart.subparts){
						for(j=0; j<selPart.subparts.length; j++){
							selPart = selPart.subparts[j];
							if(!selPart) continue;
							material = selPart.selectedMaterial;
							if(!material) continue;
							updateSuspensionOfMaterial(material, partSlot.name);
						}
					}
                }
				
				
				partSlotName = partSlot.name;
				
				if(partSlot.selectedPart){
					partSlotName+=partSlot.selectedPart.saveIndex;
				}


                if (!partSlotSubpartsMap[partSlotName]) {
                    continue;
                }

                for (angel = 0; angel < car.countAngels; angel++) {
                    if (partSlotSubpartsMap[partSlotName][angel]) {
                        for each(subpartImage in partSlotSubpartsMap[partSlotName][angel]) {
                            subpartMaterialImage = subpartImage.persistentImageProvider as PartMaterialImage;
                            if (subpartMaterialImage) {
                                if (subpartMaterialImage.remoteUrl.indexOf("disks") < 0) {
                                    subpartImage.ignorePendingCoordinates = true;
                                    subpartImage.y = ( subpartMaterialImage.y - bodyY - car.suspension) * carTexturesScale;
                                    subpartImage.ignorePendingCoordinates = false;
                                }
                            }
                        }
                    }
                }
            }
        }


        if (partSlotMask) {
            for (i = 0; i < partSlotMask.addedMaskLayerNames.length; i++) {
                var data:Object = partSlotMask.addedMaskLayerNames[i];
				var needUpdate : Boolean;
				if(car.tireMasks){
					needUpdate = Car.TIRES_SLOTS.indexOf(data.setterPartSlotName) < 0 && data.setterPartSlotName != "chassi";
				}else{
					needUpdate = Car.CAR_DISKS_SLOTS.indexOf(data.setterPartSlotName) < 0 && data.setterPartSlotName != "chassi";
				}

                if (needUpdate) {
                    updateSuspensionMask(data.layerName);
                }
            }
        }

        for (var j:int = 0; j < antimaskNames.length; j++) {


            updateSuspensionMask(antimaskNames[j]);
        }
		
		updateAllAntimask();
		
		
		}catch(e:Error){
			
			trace("Error:", e.getStackTrace())
		}

    }
	
	private function updateAllAntimask():void{

		//var partSlotName:String


		/*for (var angel:int = 0; angel < car.countAngels; angel++) {

			if(!frameMap[angel]) continue;


			for each(var carFrameView:CarFrameView in frameMap[angel])
			{
				if(!carFrameView) continue;

				carFrameView.redrawAntimask();
			}*/


			/*if (partSlotSubpartsMap[partSlotName][angel]) {
				for each(var subpartImage:ImageLoaderWithStates in partSlotSubpartsMap[partSlotName][angel]) {
					var subpartMaterialImage:PartMaterialImage = subpartImage.persistentImageProvider as PartMaterialImage;



					if (subpartMaterialImage) {


						if (subpartMaterialImage.remoteUrl.indexOf("disks") < 0) {

							//trace("subpart suspension:", subpartMaterialImage.remoteUrl)
							subpartImage.ignorePendingCoordinates = true;
							subpartImage.y = ( subpartMaterialImage.y - bodyY - car.suspension) * carTexturesScale;

							subpartImage.ignorePendingCoordinates = false;
						}
					}
				}

			}*/
		//}

		if(!frameMap) return;
		if(!frameMap[currentAngelIndex]) return;
		if(!frameMap[currentAngelIndex][currentFrame]) return;
		
	
		frameMap[currentAngelIndex][currentFrame].invalidate("children");
		//frameMap[currentAngelIndex][currentFrame].invalidate("invalid_mask");
	}

    private function updateSuspensionMask(__nameInImageMap:String):void {


        var nameInImageMap:String = __nameInImageMap;

        for (var angel:int = 0; angel < car.countAngels; angel++) {

            for (var j:int = 0; j < car.countFrames; j++) {

                if (!partSlotsImagesMap[__nameInImageMap]) {
                    continue;
                }

                if (!partSlotsImagesMap[__nameInImageMap][angel]) {
                    continue;
                }


                var image:ImageLoaderWithStates = partSlotsImagesMap[__nameInImageMap][angel][j];


                if (image) {
                    var partMaterialImage:PartMaterialImage = image.persistentImageProvider as PartMaterialImage;
					if(partMaterialImage){
	                    image.ignorePendingCoordinates = true;
	                    image.y = ( partMaterialImage.y - bodyY - car.suspension ) * carTexturesScale;
	                    image.ignorePendingCoordinates = false;
					}else{
						trace("__nameInImageMap:", __nameInImageMap)
					}

                }


            }
        }

    }

    private function updateSuspensionOfMaterial(__material:PartMaterial, __nameInImageMap:String):void {
        if (!__material) return;

        var nameInImageMap:String = __nameInImageMap;
		var normalFrame:int;

        for (var angel:int = 0; angel < car.countAngels; angel++) {

            for (var j:int = 0; j < car.countFrames; j++) {
				
				normalFrame = this.getNormalizeFrame(angel, j);
                var partMaterialImage:PartMaterialImage = __material.getImage(normalFrame, angel);

                if (!partMaterialImage) {
                    continue;
                }

                var saveIndex:String = __material.parentPart.saveIndex;

                __nameInImageMap = nameInImageMap + saveIndex

                if (!partSlotsImagesMap[__nameInImageMap]) {
                    continue;
                }

                if (!partSlotsImagesMap[__nameInImageMap][angel]) {
                    continue;
                }

                var image:ImageLoaderWithStates = partSlotsImagesMap[__nameInImageMap][angel][j];

                if (image) {
                    if (nameInImageMap == "masks") {
                        image.ignorePendingCoordinates = true;
                        image.y = ( partMaterialImage.y - bodyY - car.suspension ) * carTexturesScale;
                        image.ignorePendingCoordinates = false;
                    } else {
                        image.ignorePendingCoordinates = true;
                        image.y = ( partMaterialImage.y - bodyY - car.suspension ) * carTexturesScale;
                        image.ignorePendingCoordinates = false;
                    }
                }
				
				
				
				
            }

        }


    }


    private function updateFrontOffsetOfMaterial(__material:PartMaterial, __nameInImageMap:String):void {
        if (!__material) return;

        var frontLeftOffsetStep:Object =
                [
                    {"x": 8, "y": 0},
                    {"x": 7, "y": 0},
                    {"x": 6, "y": 0},
                    {"x": 4.5, "y": -1},
                    {"x": 3, "y": 0},
                    {"x": 1.5, "y": -1},
                    {"x": 0, "y": 0},
                    {"x": -2, "y": 0},
                    {"x": -3, "y": 0},
                    {"x": -4.5, "y": 0},
                    {"x": -5, "y": 0},
                    {"x": -5.5, "y": 0},
                    {"x": -6.5, "y": 0},
                    {"x": -6, "y": 0},
                    {"x": -6.5, "y": 0},
                    {"x": -6, "y": 0},
                    {"x": -5, "y": 0},
                    {"x": -4, "y": 1},
                    {"x": -2.5, "y": 0},
                    {"x": 0, "y": 1},
                    {"x": 1.5, "y": 0},
                    {"x": 4, "y": 0},
                    {"x": 6, "y": 1},
                    {"x": 7.5, "y": 0},
                    {"x": 8, "y": 1}
                ];

        var frontRightOffsetStep:Object =
                [
                    {"x": -8.5, "y": 0},
                    {"x": -8, "y": 1},
                    {"x": -7, "y": 0},
                    {"x": -6, "y": 0},
                    {"x": -4, "y": 0},
                    {"x": -2, "y": 0},
                    {"x": 0, "y": 1},
                    {"x": 2.5, "y": 0},
                    {"x": 3.5, "y": 1},
                    {"x": 5, "y": 0},
                    {"x": 6, "y": 0},
                    {"x": 6.5, "y": 1},
                    {"x": 6.5, "y": 0},
                    {"x": 6.5, "y": 0},
                    {"x": 5.5, "y": 0},
                    {"x": 5.5, "y": 0},
                    {"x": 4.5, "y": 0},
                    {"x": 3, "y": -1},
                    {"x": 2, "y": 0},
                    {"x": 0.5, "y": 0},
                    {"x": -1, "y": -1},
                    {"x": -3, "y": 0},
                    {"x": -5, "y": -1},
                    {"x": -6.5, "y": 0},
                    {"x": -7.5, "y": -1}
                ];

        var nameInImageMap:String = __nameInImageMap;
		var normalFrame:int;

        for (var angel:int = 0; angel < car.countAngels; angel++) {

            for (var j:int = 0; j < car.countFrames; j++) {
				
				normalFrame = getNormalizeFrame(angel, j);
                var partMaterialImage:PartMaterialImage = __material.getImage(normalFrame, angel);

                if (!partMaterialImage) {
                    continue;
                }

                var image:ImageLoaderWithStates = partSlotsImagesMap[__nameInImageMap][angel][j];

                if (image) {


                    var f:int = j / car.camera1LayerPositionStep;

                    if (angel > 0) {
                        f = (j / car.camera2LayerPositionStep) + (car.countFrames / 2/*car.camera1LayerPositionStep*/);
                    }


                    partMaterialImage.x = car.disksPosition[__nameInImageMap][f].x;
                    partMaterialImage.y = car.disksPosition[__nameInImageMap][f].y;


                    if (true) {
                        partMaterialImage.x -= image.width;
                        partMaterialImage.y -= image.height;
                    }


                    var offsetX:Number = car.frontOffset / 10;
                    var offsetY:Number = car.frontOffset / 10;


                    if (__nameInImageMap.indexOf("left") >= 0) {

                        offsetX *= frontLeftOffsetStep[f].x;
                    }

                    if (__nameInImageMap.indexOf("right") >= 0) {

                        offsetX *= frontRightOffsetStep[f].x;
                        //offsetY*=frontLeftOffsetStep[f].y;
                    }

                    image.ignorePendingCoordinates = true;
                    image.x = (image.kx * partMaterialImage.x + image.kx * offsetX + image.ax);
                    image.y = (image.ky * partMaterialImage.y + image.ky * offsetY + image.ay);
                    image.ignorePendingCoordinates = false;

                }
            }

        }

    }


    private var firstInitBg:Boolean = false;

	private function disposeBackgrounds(backToDispose : Dictionary) : void
	{
		if(backToDispose)
		{
			for each (var texture : Texture in backToDispose)
			{
				texture.dispose();
			}
		}
        backToDispose = null;
	}

	public function updateBackground(update:Boolean = true):void {
		
		if(!this.stage) return;
		//var start:int=getTimer();
        var map:Dictionary;
        var map2:Dictionary;
        var backToDispose : Dictionary;
        var i:int;
        var loader:Loader;
		if (car && car.selectedBackground && car.selectedBackground.id != CarBackground.DEFAULT_ID) {
			//imageForVideo.y = backgroundImage.y;
			firstInitBg = false;
			fillColorQuad.visible = false;
			
			
			backgrounds = [car.selectedBackground.remoteUrl];//car.defaultBkgMobile;
			
			if(car.selectedBackground.imagePathSecondCam && car.selectedBackground.imagePathSecondCam.length>10){
				backgrounds.push(car.selectedBackground.imagePathSecondCam);
			}
			
			map = new Dictionary();
			map2 = new Dictionary();
			backToDispose = backgroundsBitmaps;
			backgroundsBitmaps = new Dictionary();
			countBgLoad=0;

			for (i = 0; i < backgrounds.length; i++) {
				loader = new Loader();
				map[loader.contentLoaderInfo] = backgrounds[i];
				map2[backgrounds[i]] = i;
				loader.load(new URLRequest(backgrounds[i]));
				loader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, function (e:flash.events.Event):void {
                    countBgLoad++;
					var currentTarget:LoaderInfo = e.currentTarget as LoaderInfo;
					var url:String = map[currentTarget];
					var scale:Number = 1;//Capabilities.screenResolutionX / currentTarget.content.width / Constants.SCALE_FACTOR;
					var matrix:Matrix = new Matrix();
					matrix.scale(scale, scale);
					var smallBMD:BitmapData = (currentTarget.content as Bitmap).bitmapData;//new BitmapData(currentTarget.content.width * scale, currentTarget.content.height * scale, true, 0x000000);
					
					if(!backgroundsBitmaps) {smallBMD.dispose(); return;}

					backgroundsBitmaps[map2[url]] = Texture.fromBitmapData(smallBMD, false);//new Bitmap(smallBMD, PixelSnapping.NEVER, true);
					
//					if(Device.isIos())
						smallBMD.dispose();
					
					if(countBgLoad==backgrounds.length){
						allBackgroundsDownloaded = true;
						lastCamBcg = -1;
						updateVisibleBackground();
						disposeBackgrounds(backToDispose);
					}
				})
			}
		} else if (car && car.selectedFillColor) {
			
			fillColorQuad.color = car.selectedFillColor.color;
			fillColorQuad.visible = true;
			
		} else if (!firstInitBg) {
			//updateBackgroundScale();
			//imageForVideo.y = backgroundImage.y;
			if (car && car.defaultBkgMobile) {
				backgrounds = car.defaultBkgMobile;
				map = new Dictionary();
				map2 = new Dictionary();
                backToDispose = backgroundsBitmaps;
                backgroundsBitmaps = new Dictionary();
				
				countBgLoad=0;
				
				
				for (i = 0; i < backgrounds.length; i++) {
					loader = new Loader();
					map[loader.contentLoaderInfo] = backgrounds[i];
					map2[backgrounds[i]] = i;
					loader.load(new URLRequest(backgrounds[i]));
					loader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, function (e:flash.events.Event):void {
                        countBgLoad++;
						var currentTarget:LoaderInfo = e.currentTarget as LoaderInfo;
						var url:String = map[currentTarget];
						var scale:Number = 1;
						var matrix:Matrix = new Matrix();
						matrix.scale(scale, scale);
						var smallBMD:BitmapData = (currentTarget.content as Bitmap).bitmapData;//new BitmapData(currentTarget.content.width * scale, currentTarget.content.height * scale, true, 0x000000);
						
						if(!backgroundsBitmaps) {smallBMD.dispose(); return;}
						trace("map2[url]:", map2[url]);
						backgroundsBitmaps[map2[url]] = Texture.fromBitmapData(smallBMD, false);//new Bitmap(smallBMD, PixelSnapping.NEVER, true);
						
						smallBMD.dispose();
						
						if(countBgLoad==car.defaultBkgMobile.length){
							allBackgroundsDownloaded = true;
							lastCamBcg = -1;
							updateVisibleBackground();
                            disposeBackgrounds(backToDispose);
						}
					})
				}
				firstInitBg = true;
			}
			else if (car) {
				firstInitBg = true;
			}
			fillColorQuad.visible = false;
		}

	}
	
	private var countBgLoad:int = 0;


    private var allFramesAdded:Boolean = false;
	
	private var panoramaDX:Number = 1;
	
	

    private function enterFrameHandler(event:EnterFrameEvent):void {
        try {
			
			/*if(CarFrameView.BusyDrawFlag) {
				targetRotation = rotation;
				return;
			}*/
			
			
			
			//ar count:Number=CarView.JOBS_AFTER_RENDER_LOAD.length+CarView.JOBS_AFTER_RENDER_CLEAN.length;
			
			//trace("count:", count)
//			this.tmpProgressQuad_clean.x=0;
//			this.tmpProgressQuad_clean.y=0;
//			this.tmpProgressQuad_clean.width=actualWidth*(CarView.JOBS_AFTER_RENDER_CLEAN.length/24.0);
//
//
//			this.tmpProgressQuad_load.x=0;
//			this.tmpProgressQuad_load.y=5;
//			this.tmpProgressQuad_load.width=actualHeight*(CarView.JOBS_AFTER_RENDER_LOAD.length/24.0);
			
			

           
			if(backgroundPanorama180Image && visible){
				

				if(!backgroundPanorama180Image.visible) backgroundPanorama180Image.visible = true;
				//backgroundPanorama180XOffset+=panoramaDX;
				
				
				
				
				//trace("backgroundPanorama180XOffset:", backgroundPanorama180XOffset, backgroundPanorama180Image.x, panoramaDX, backgroundPanorama180Image.width);
				
				
				var oneTileWidth:Number = backgroundPanorama180Image.width/backgroundPanorama180HTile;
				
				/*if(backgroundPanorama180XOffset>(oneTileWidth/2)+(actualWidth/2)){
					
					//panoramaDX = -1;
					
					backgroundPanorama180XOffset = - (oneTileWidth/2)+(actualWidth/2);
					backgroundPanorama180Image.x=((actualWidth-backgroundPanorama180Image.width)/2)+backgroundPanorama180XOffset;
				}*/
				
				var frame:Number = 0.5- (currentFrame/car.countFrames);
				
				frame = frame * -1;
				
				backgroundPanorama180XOffset = ((oneTileWidth+actualWidth) * frame) /*- ((oneTileWidth/2)+(actualWidth/2))*/;
				
				backgroundPanorama180Image.x=((actualWidth-backgroundPanorama180Image.width)/2)+backgroundPanorama180XOffset;
				
				//trace("frame:",frame, backgroundPanorama180XOffset);
				//backgroundImage.height = actualHeight;
				
				//trace("backgroundImage.x:",backgroundImage.x)
				
				//backgroundImage.width = backgroundImage.height*7.65;
			}
            //rotation += (targetRotation - rotation);

            //var r:int = Math.round(targetRotation  - rotation);


            //showFrame(rotation, currentAngelIndex);
			
			if(Math.round(_targetToFrameAnim)!=Math.round(_showFrameAnim)){
				showFrame(_showFrameAnim, currentAngelIndex);
				
			}


        } catch (e:Error) {

            _tracer.print("error:" +  e.getStackTrace());
        }
    }

    public function rotateToFrame(k:int):void {

		if(this.isFastModeEnable) return;
		
		//oldShowFrameIndex
		/*
		
		*/
		
		var normalFrame:int = (oldShowFrameIndex%car.countFrames);
		
		if(normalFrame<0) normalFrame = car.countFrames + normalFrame;
		_targetToFrameAnim = k;
		targetRotation = k;
		showFrameAnim = normalFrame;
		
		var tween:Tween = new Tween(this, 1, Transitions.LINEAR);
		tween.animate("showFrameAnim", k);
		Starling.juggler.add(tween);
		
		//trace("rotateToFrame:", k, oldShowFrameIndex, oldShowFrameIndex%car.countFrames);
		
        //targetRotation = car.countFrames * int(Math.round(rotation / car.countFrames)) + k;
    }

    private var _fromFrameIndex:int;
    private var _toFrameIndex:int;
    private var _currentFrameIndex:int;
    private var _frameIndexList:Array;
    private var _rotationDelay:Number = 0.05;
    private var _cameraChanged:Boolean = false;
    public function rotateToFrame2(k:int):void {
        if(_loadingCarImage && _loadingCarImage.parent){
            return;
        }
        dispatchEvent(new Event(ROTATION_START));
        if(k>25){
            k -= 25;
            //_cameraChanged = (currentAngelIndex==0);
            _rotationDelay = 0.05;
            //currentAngelIndex = 1;
        }else{
            //_cameraChanged = (currentAngelIndex==1);
            //currentAngelIndex = 0;
            _rotationDelay = 0.05;
        }
        _frameIndexList = ObjectUtils.getKeys(frameMap[currentAngelIndex]);
        for(var i:int = 0; i < _frameIndexList.length; i++){
            _frameIndexList[i] = parseInt(_frameIndexList[i]);
        }
        _fromFrameIndex = _frameIndexList.indexOf(currentFrame);
        _currentFrameIndex = _fromFrameIndex;
        _toFrameIndex = Math.min(k, _frameIndexList.length-1);
        if(_cameraChanged){
            _fromFrameIndex = _currentFrameIndex = _toFrameIndex;
        }
        showNextFrame();
    }

    private function showNextFrame():void{
        var frameIndex:int = getNextFrameIndex(_frameIndexList, _currentFrameIndex, _toFrameIndex);
        var callNextFrame:Boolean = false;
        if(frameIndex != -1){
            _currentFrameIndex = _frameIndexList.indexOf(frameIndex);
            showFrame(frameIndex, currentAngelIndex);
            callNextFrame =  (_currentFrameIndex != _toFrameIndex);
        }else if(_cameraChanged && _currentFrameIndex == _toFrameIndex){
            frameIndex = _frameIndexList[_toFrameIndex];
            showFrame(frameIndex, currentAngelIndex);
            updateCarY();
            frameIndex = -1;
        }else{
            sIndex = currentFrame;
            showFrame(currentFrame, currentAngelIndex);
            frameIndex = -1;
        }
        _cameraChanged = false;
        if(frameIndex == -1 || _currentFrameIndex == _toFrameIndex){
            dispatchEvent(new Event(ROTATION_END));
        }
        if(callNextFrame){
            Starling.juggler.delayCall(function ():void {
                showNextFrame();
            }, _rotationDelay);
        }
    }

    private function getNextFrameIndex(frameList:Array, currentIndex:int, lastIndex:int):int{
        var resultIndex:int;
        var ls:int;
        if(currentIndex < lastIndex){
            ls = lastIndex-currentIndex;
            if(ls<=frameList.length/2){
                resultIndex = currentIndex+1;
            }else{
                resultIndex = (currentIndex==0?frameList.length-1:currentIndex-1);
            }
        }else if(currentIndex > lastIndex){
            ls = currentIndex-lastIndex;
            if(ls>=frameList.length/2){
                resultIndex = (currentIndex==frameList.length-1?0:currentIndex+1);
            }else{
                resultIndex = currentIndex-1;
            }
        }else{
            return -1;
        }
        if(resultIndex >= 0 && resultIndex < frameList.length) {
            return frameList[resultIndex];
        }
        return -1;
    }
	
	private var _targetToFrameAnim:Number = 0;
	private var _showFrameAnim:Number = 0;
	
	
	public function set showFrameAnim(value:Number):void{
		_showFrameAnim = value;
		//trace("_showFrameAnim:", _showFrameAnim);
		
	}
	
	public function get showFrameAnim():Number{
		return _showFrameAnim;
	}

    private var idle_delay:Boolean = false;


    public function getPrevFrame(angelIndex:int, index:int, count:int = 1):int {
        var current:int = getRoundFrame(angelIndex, index);
        var prev:int = current;
        var j:int = 1;

        for (var i:int = 0; i < count; i++) {
            j = 1;
            while (prev == current) {
                prev = getRoundFrame(angelIndex, prev - j);
                j++;
            }
            current = prev;
        }
        return prev;
    }


    public function getNextFrame(angelIndex:int, index:int, count:int = 1):int {
        var current:int = getRoundFrame(angelIndex, index);
        var next:int = current;
        var j:int = 0;

        for (var i:int = 0; i < count; i++) {
            j = 1;
            while (next == current) {
                next = getRoundFrame(angelIndex, next + j);
                j++;
            }
            current = next;
        }
        return next;
    }

    public function getNormalizeFrame(angelIndex:int, index:int):int {

        if (!car) return index;

        try {
            var k:int;
            var r:int;
            k = index;

            if (k < 0) {
                r = index % car.countFrames;
                if (r == 0) {
                    k = 0;
                }
                else {
                    k = car.countFrames + r;
                }
            }
            else if (k > car.countFrames - 1) {
                k = k % car.countFrames;
            }

            if (angelIndex == 1 && k % car.stepOfFrameIndexUp != 0) {
                k = Math.round(k / car.stepOfFrameIndexUp) * car.stepOfFrameIndexUp;
                if (Math.round(k / car.stepOfFrameIndexUp) >= car.countFrames / car.stepOfFrameIndexUp) {
                    k = (car.countFrames / car.stepOfFrameIndexUp);
                }
            } else if (angelIndex < 1 /*&& car.stepOfFrameIndex == 5*/ && k % car.stepOfFrameIndex != 0) {
                k = Math.round(k / car.stepOfFrameIndex) * car.stepOfFrameIndex;
            }

            if (angelIndex == 1 && (car.countFrames==50)) {
                k = FINDEX[k];
            } else if (angelIndex != 1 /*&& car.stepOfFrameIndex == 5*/) {
                k = NORMAL_FINDEX[k];
            }else if(angelIndex == 1){
				k = FINDEX[k];
			}
            return k;

        } catch (e:Error) {
			_tracer.print(e.getStackTrace());
            return index;
        }
    }

	private var sIndex:int  = -1;
	private var sAngelIndex:int = -1;
	
	private function getRoundFrame(angelIndex:int, frameIndex:int):int{
		
		var k:int = frameIndex;
		var step:int = angelIndex == 0 ? car.stepOfFrameIndex : car.stepOfFrameIndexUp;
		
		k = Math.round(Math.round(k/step)*step);
		
		var r:int;
		if (k < 0) {
			r = k % car.countFrames;
			if (r == 0) {
				k = 0;
			}
			else {
				k = Math.abs(car.countFrames + r);
			}
		}
		
		if (k > car.countFrames - 1) {
			k = k % car.countFrames;
		}
		
		
		if(car.countFrames == 50 && angelIndex==1 && k==0){
			
			k=camera2Direct<0 ? car.countFrames+(camera2Direct*step):(camera2Direct*step);
		}
		
		
		return k;
	}
	
	private var oldShowFrameIndex:int = -1;

    public function showFrame(index:int, angelIndex:int):void {

		//trace("index:", index)
		
		oldShowFrameIndex = index;
		//if(CarFrameView.BusyDrawFlag) return;
        try {
			
			//if(sIndex==index && sAngelIndex==angelIndex && !foregroundSpriteForCamera){
				
			//	return;
			//}
			

			//trace("showFrame:", angelIndex);
			sIndex = index;
			sAngelIndex = angelIndex;

            if (foregroundSpriteForCamera) {
                if (idle_delay) return;
                idle_delay = true;
                Starling.juggler.delayCall(function ():void {
                    idle_delay = false;
                }, 0.3);
            }
			
	
            var k:int = index;
			
			if (frameMap && frameMap[currentAngelIndex] && frameMap[currentAngelIndex][currentFrame]){
				
				frameMap[currentAngelIndex][currentFrame].visible = false;
				sIndex = index;
				sAngelIndex = angelIndex;
			}
			
			k = getRoundFrame(angelIndex, k);
			
			//trace("getRoundFrame:", k, index)
			
			 //getNormalizeFrame(angelIndex, index);

            if (foregroundSpriteForCamera) {
                currentFrame = k;
                currentAngelIndex = angelIndex;
                lastIndex = index;
                showCurrentFrameForCamera();
                return;
            }
				
            if (frameMap && frameMap[angelIndex] && frameMap[angelIndex][k] && !frameMap[angelIndex][k].visible) {
                beforeChangeFrame(angelIndex, k);
            }else if(frameMap && frameMap[angelIndex] && !frameMap[angelIndex][k] && angelIndex==1 && car.camera2Frames && car.camera2Frames[k]){
				k = car.camera2Frames[k];
				beforeChangeFrame(angelIndex, k);
			}
			
            if (frameMap && frameMap[angelIndex] && frameMap[angelIndex][k]) {
                frameMap[angelIndex][k].visible = true;
            }
           
            currentFrame = k;
            currentAngelIndex = angelIndex;

            updateVisibleBackground();
            CURRENT_ANGEL_INDEX = angelIndex;
            lastIndex = index;
            dispatchEventWith(SHOW_FRAME, false, {currentFrame: currentFrame, currentAngelIndex: currentAngelIndex});
            /*if (lastFrameCurrated >= 0) {
                decurate();
                lastFrameCurrated = -1;
            }
            if (timeoutId >= 0) {
                clearTimeout(timeoutId);
                timeoutId = -1;
            }

            if (partsLoaded && canTouchParts) {
                timeoutId = setTimeout(curate, 300);
            }*/


        } catch (e:Error) {

            _tracer.print("error:",  e.getStackTrace());
            //Logger.e("showFrame error:"+e.message+" stack:"+e.getStackTrace(), this);
        }


    }

    public static var locCurrentFrame:int = -1;
    public static var locNext1Frame:int = -1;
    public static var locNext2Frame:int = -1;
    public static var locPrev1Frame:int = -1;
    public static var locPrev2Frame:int = -1;
    public static var locAngleIndex:int = -1;
	
	public static var oldLocAngelIndex:int = -1;
	public static var oldLocCurrentFrame:int = -1;
	
	public static var oldLocNext1Frame:int = -1;
	public static var oldLocPrev1Frame:int = -1;
	
	
	public static var oldLocNext2Frame:int = -1;
	public static var oldLocPrev2Frame:int = -1;
	
	public static var intervalBeforeChangeFrameId:int=0;
	
	/*private function intervalJobs():void{
		
		if(CarView.JOBS_AFTER_RENDER.length==0) {
			
			if(intervalBeforeChangeFrameId!=0)
			clearInterval(intervalBeforeChangeFrameId);
			
			return;
		}
		var jobObject:Object = CarView.JOBS_AFTER_RENDER.pop();
		
		
		jobObject.func(jobObject.frameView);
	}*/
	
	private function timerBeforeChangeFrame(frameView:CarFrameView):void{
		
		//trace("timerBeforeChangeFrame")
		frameView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
	}
	
	private function findIndex(carFrameView:CarFrameView, array:Array):int{
		
		
		for(var i:int=0; i<array.length; i++){
			
			
			if(array[i].frameView==carFrameView){
				return i;
			}
			
		}
		
		return -1;
	}
	
	private var beforeChangeFrameCount:int = 0;

    private function beforeChangeFrame(angelIndex:int, index:int):void {
		var newFrameView:CarFrameView;
		var oldframeView:CarFrameView;
		if(this.isFastModeEnable)	newFrameView = frameMap[locAngleIndex][index];
		
		if(this.isFastModeEnable && newFrameView && newFrameView.skipForFastMode){
			/*st = index+camera1Direct;
			if(this.camera1Direct>0){
				if(st>=car.countFrames) st = 0;
				for(i=st; i<car.countFrames; i++){
					newFrameView = frameMap[locAngleIndex][i];
					if(!newFrameView) continue;
					trace("newFrameView:", newFrameView.frameIndex, newFrameView.skipForFastMode)
					if(!newFrameView.skipForFastMode) { index = i; break;}
				}
			}else{
				
				if(st<0) st = car.countFrames-1;
				
				for(i=st; i>=0; i--){
					
					newFrameView = frameMap[locAngleIndex][i];
					if(!newFrameView) continue;
					
					trace("newFrameView:", newFrameView.frameIndex, newFrameView.skipForFastMode)
					
					if(!newFrameView.skipForFastMode) { index = i; break;}
				}
			}*/
		}
		
		

        locCurrentFrame = index;//this.getNormalizeFrame(angelIndex, index);
        locNext1Frame = this.getNextFrame(angelIndex, index);
        locNext2Frame = this.getNextFrame(angelIndex, index, 2);

        locPrev1Frame = this.getPrevFrame(angelIndex, index);
        locPrev2Frame = this.getPrevFrame(angelIndex, index, 2);
		
		
		if(this.isFastModeEnable && newFrameView && newFrameView.skipForFastMode){
			
			locNext1Frame = locCurrentFrame;
			locNext2Frame = locCurrentFrame;

			locPrev1Frame = locCurrentFrame;
			locPrev2Frame = locCurrentFrame;
		}
		
        locAngleIndex = angelIndex;

		var changeCameraFlag:Boolean = locAngleIndex!=oldLocAngelIndex;
		
		if(oldLocAngelIndex==-1) changeCameraFlag=false;
		
		if(oldLocCurrentFrame==-1) changeCameraFlag=false;
		
		var frameView:CarFrameView;
		
		
		if(changeCameraFlag){
			
			//trace("beforeChangeFrame", beforeChangeFrame)
			CarView.JOBS_AFTER_RENDER_CLEAN = [];
			CarView.JOBS_AFTER_RENDER_LOAD = [];
			//if(intervalBeforeChangeFrameId!=0) clearInterval(intervalBeforeChangeFrameId);
			
			oldframeView =  frameMap[oldLocAngelIndex][oldLocCurrentFrame]; //старый кадр
			newFrameView = frameMap[locAngleIndex][locCurrentFrame];  //новый кадр
			
			if(oldframeView)
			oldframeView.beforChangeFrame(angelIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
			
			if(newFrameView)
			newFrameView.beforChangeFrame(angelIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
			
			
			
			//for (frameAngel in frameMap) {
			
				//var mas1:Array = []; 
				
				for each ( frameView in frameMap[oldLocAngelIndex]) {
					if (frameView && frameView!=oldframeView && frameView!=newFrameView) {
						
						
						CarView.JOBS_AFTER_RENDER_CLEAN.push({
							order:2, 
							func:timerBeforeChangeFrame, 
							frameView:frameView
						});
						
						//frameView.beforChangeFrame(angelIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
					}
				}
				
				//trace("CarView.JOBS_AFTER_RENDER_CLEAN.count:", CarView.JOBS_AFTER_RENDER_CLEAN.length);
				
				
				for each ( frameView in frameMap[locAngleIndex]) {
					if (frameView && frameView!=oldframeView && frameView!=newFrameView) {
						
						CarView.JOBS_AFTER_RENDER_LOAD.push({
							order:2, 
							func:timerBeforeChangeFrame, 
							frameView:frameView
						});
						
						//frameView.beforChangeFrame(angelIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
					}
				}
				
				//trace("CarView.JOBS_AFTER_RENDER_LOAD.count:", CarView.JOBS_AFTER_RENDER_LOAD.length);
			//}
			
			//intervalBeforeChangeFrameId=setInterval(intervalJobs, 100);
			
		}else{
			
			
			
			if(CarView.JOBS_AFTER_RENDER_LOAD.length<=0 && CarView.JOBS_AFTER_RENDER_CLEAN.length<=0){
		
				
				frameView = frameMap[locAngleIndex][oldLocCurrentFrame];
				
				if(frameView){
					
					frameView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
					//arr.push(arr);
					
				}
				
				frameView = frameMap[locAngleIndex][locCurrentFrame];
				
				if(frameView ){
					
					frameView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
					
				}
				
				
				
			
			}else{
				
				
				if(CarView.JOBS_AFTER_RENDER_CLEAN.length>0){
					
					var jobObject:Object = CarView.JOBS_AFTER_RENDER_CLEAN.pop();
					
					if(jobObject)
						jobObject.func(jobObject.frameView);
				}	
				
				var indexFrame:int;
					
				oldframeView =  frameMap[locAngleIndex][oldLocCurrentFrame];
				if(oldframeView){
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_CLEAN);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_CLEAN.removeAt(indexFrame);
					}
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_LOAD);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_LOAD.removeAt(indexFrame);
					}
					
					oldframeView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
				}
				
				
				oldframeView =  frameMap[locAngleIndex][oldLocNext1Frame];
				if(oldframeView){
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_CLEAN);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_CLEAN.removeAt(indexFrame);
					}
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_LOAD);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_LOAD.removeAt(indexFrame);
					}
					
					oldframeView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
				}
				
				oldframeView =  frameMap[locAngleIndex][oldLocPrev1Frame];
				if(oldframeView){
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_CLEAN);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_CLEAN.removeAt(indexFrame);
					}
					
					indexFrame = this.findIndex(oldframeView, CarView.JOBS_AFTER_RENDER_LOAD);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_LOAD.removeAt(indexFrame);
					}
					oldframeView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
				}
				
				
				
					
				frameView = frameMap[locAngleIndex][locCurrentFrame];	
				if(frameView){	
					
					indexFrame = this.findIndex(frameView, CarView.JOBS_AFTER_RENDER_CLEAN);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_CLEAN.removeAt(indexFrame);
					}
					
					indexFrame = this.findIndex(frameView, CarView.JOBS_AFTER_RENDER_LOAD);
					if(indexFrame>=0){
						CarView.JOBS_AFTER_RENDER_LOAD.removeAt(indexFrame);
					}
					
					
					frameView.beforChangeFrame(locAngleIndex, locPrev2Frame, locPrev1Frame, locCurrentFrame, locNext1Frame, locNext2Frame);
				}
				
				
			}
			
		
		
		}
		
	
		oldLocAngelIndex = locAngleIndex;
		oldLocCurrentFrame = locCurrentFrame;
		
		
		oldLocNext1Frame = locNext1Frame;
		oldLocPrev1Frame = locPrev1Frame;
		
		
		oldLocNext2Frame = locNext2Frame;
		oldLocPrev2Frame = locPrev2Frame;
		
		//trace("beforeChangeFrame time:", getTimer()-start);

    }

    private var bitmapData:BitmapData;

    private function showCurrentFrameForCamera():void {

        try {

            if (!foregroundSpriteForCamera) {
                return;
            }


            {//тетстовый код

                if (bitmapData) {
                    bitmapData.dispose();
                    bitmapData = null;
                }

                var currentCarFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];


                foregroundSpriteForCamera.removeChildren();
                bitmapData = currentCarFrameView.copyToBitmap(width, height, assetManager.scaleFactor);
                var bmp1:Bitmap = new Bitmap(bitmapData);
                //
                bmp1.x = 0;


                bmp1.y = -113 + (height / 2);//- 480 + bmp1.height;


                foregroundSpriteForCamera.addChild(bmp1);

            }

        } catch (e:Error) {

			_tracer.print("error:",  e.getStackTrace());
            //Logger.e("showCurrentFrameForCamera error:"+e.message+" stack:"+e.getStackTrace(), this);

        }

    }

	private function onCameraError(event:Event):void{
		
		this.dispatchEventWith(BackgroundContainer.EVENT_CAMERA_ERROR, event.data);
	}
    
    public function startCamera():void {
		lockedTouch = true;
		
		backgroundContainer.addEventListener(BackgroundContainer.EVENT_CAMERA_ERROR, onCameraError);
		backgroundContainer.startCamera();
	}

    public function stopCamera(getBitmapData:Boolean = false):BitmapData {
		lockedTouch = false;
        var bitmapData:BitmapData = backgroundContainer.stopCamera(getBitmapData);
        return bitmapData;
    }

    public function setCustomBackground(bitmapData:BitmapData):BitmapData {
		lockedTouch = false;
        return backgroundContainer.uploadCustomBackground(bitmapData);
    }




	public override function set y(value:Number):void {
		super.y = value;
		
		//updateBackgroundPos();
		
	}
	
	

    /*public function decurate():void {
		
		return;
        var carFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];

        for (var layerIndex:int; layerIndex < carFrameView.layersCount; layerIndex++) {
            var layer:DisplayObjectContainer = carFrameView.getLayer(layerIndex);

            if (!layer) {
                continue;
            }

            for (var i2:int = 0; i2 < layer.numChildren; i2++) {
                var c2:ImageLoaderWithStates = ImageLoaderWithStates(layer.getChildAt(i2));


                if (c2 && c2.persistentImageProvider && c2.persistentImageProvider.ignoresTransparentPixelsOnTouch) {
                   // c2.unloadBitmapData();
                }

            }

        }

    }*/

    /*public function curate():void {
		
		return;
        if (!canTouchParts) {
            return;
        }

        if (!frameMap) {
            return;
        }
		
		


        var carFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];

        if (!carFrameView) {
            return;
        }

        for (var layerIndex:int; layerIndex < carFrameView.layersCount; layerIndex++) {
            var layer:DisplayObjectContainer = carFrameView.getLayer(layerIndex);

            if (!layer) {
                continue;
            }

            for (var i2:int = 0; i2 < layer.numChildren; i2++) {

                var dObj:DisplayObject = layer.getChildAt(i2);


                var c2:ImageLoaderWithStates = dObj as ImageLoaderWithStates;

                if (c2) {

                    if (c2 && c2.persistentImageProvider && c2.persistentImageProvider.ignoresTransparentPixelsOnTouch) {
                        //c2.loadBitmapData();
                    }
                }

            }

        }


        lastFrameCurrated = currentFrame;

    }*/

    public var zooming:Boolean;


    private var _scaleComponent:Number = 1;
	public function get scaleComponent() : Number
	{
		return _scaleComponent;
	}


    private function zoom(touches:Vector.<Touch>):void {
        try {
            var touchA:Touch = touches[0];
            var touchB:Touch = touches[1];

            var currentPosA:Point = touchA.getLocation(parent);
            var previousPosA:Point = touchA.getPreviousLocation(parent);
            var currentPosB:Point = touchB.getLocation(parent);
            var previousPosB:Point = touchB.getPreviousLocation(parent);

            var currentVector:Point = currentPosA.subtract(currentPosB);
            var previousVector:Point = previousPosA.subtract(previousPosB);

            var currentAngle:Number = Math.atan2(currentVector.y, currentVector.x);
            var previousAngle:Number = Math.atan2(previousVector.y, previousVector.x);
            var deltaAngle:Number = currentAngle - previousAngle;

            var sizeDiff:Number = currentVector.length / previousVector.length;


            /*scaleComponent *= sizeDiff;
            if (carScale<0.5){
				carScale=0.5;
                //return
            }
            if (carScale>2){
				carScale=2;
                //return
            }

            //trace('scaleComponent='+scaleComponent);
            if (sizeDiff <0.5){
                return;
            }
            if (sizeDiff >2){
                return;
            }*/
			
			_scaleComponent *= sizeDiff;

            framesContainer.scaleX *= sizeDiff;
            framesContainer.scaleY *= sizeDiff;

            carScale = framesContainer.scaleX;
			
			
			
			if (carScale<0.5){
				_scaleComponent = 0.5/_initialScale;
				carScale=0.5;
				framesContainer.scaleX=0.5;
				framesContainer.scaleY=0.5;
				//return
			}
			if (carScale>2){
				_scaleComponent = 2/_initialScale;
				carScale=2;
				framesContainer.scaleX=2;
				framesContainer.scaleY=2;
				//return
			}
			
			updateCarY();
			

            if (foregroundSpriteForCamera) {
                foregroundSpriteForCamera.scaleX = carScale;
                foregroundSpriteForCamera.scaleY = carScale;
                foregroundSpriteForCamera.x = framesContainer.bounds.x;
                foregroundSpriteForCamera.y = bodyY * carScale + framesContainer.bounds.y;
            }

        } catch (e:Error) {

			_tracer.print("error:",  e.getStackTrace());
            //Logger.e("zoom error:"+e.message+" stack:"+e.getStackTrace(), this);
        }

    }

    private function allTouchesEnded(touches:Vector.<Touch>):Boolean {
        var allEnded:Boolean = true;

        for each(var t:Touch in touches) {
            if (t.phase != TouchPhase.ENDED) {
                allEnded = false;
            }
        }

        return allEnded;
    }

    private var startTouchHandler:Boolean = false;

    private var targetAngel:int = 0;
    private var targetAngelOnMouseDown:int = 0;

    private var _isMove:Boolean = false;

    private var camera2Direct:int = 1;
	private var camera1Direct:int=1;
	
	private var moveBloker:Boolean = false;
	public static var touchDown:Boolean=false;
	

    public function touchHandler(event:TouchEvent):void {

        if (startTouchHandler)
            return;

        //startTouchHandler=true;
        try {

            var touches:Vector.<Touch> = event.getTouches(this);
            var touch:Touch = event.getTouch(this);

            if (event.getTouches(this).length == 2) {
                if (!allTouchesEnded(touches)) {
                    zooming = true;
                    zoom(touches);
                }
                else {
                    zooming = false;
                }
                startTouchHandler = false;
                return;
            }

            if (zooming) {
                if (allTouchesEnded(touches)) {
                    zooming = false;
                }
                startTouchHandler = false;
                return;
            }

            if (!touch) {
                startTouchHandler = false;
                return;
            }
			
			if(!zooming && isFastModeEnable && touch.phase == TouchPhase.MOVED) {
				startTouchHandler = false;
				return;
			}

            if (touch.phase == TouchPhase.BEGAN) {
                touchMoved = false;
                frameOnTouch = currentFrame;

                mouseXOnMouseDown = touch.globalX - windowHalfX;
                mouseYOnMouseDown = touch.globalY;//- windowHalfY;
                targetRotationOnMouseDown = targetRotation;

                targetAngelOnMouseDown = targetAngel;
				
				touchDown = true;
            }
            else if (touch.phase == TouchPhase.MOVED) {
				touchDown = true;
                mouseX = touch.globalX - windowHalfX;
                mouseY = touch.globalY;// - windowHalfY;
				//if(moveBloker) return;
				moveBloker = true;
                if (Math.abs(mouseXOnMouseDown - mouseX) > 10 || Math.abs(mouseYOnMouseDown - mouseY) > 10)
                    touchMoved = true;
				var dx:Number = (mouseX - mouseXOnMouseDown);
                if (targetRotation > targetRotationOnMouseDown) {
                    camera2Direct = 1;
                } else {
                    camera2Direct = -1;
                }
				if(dx > 0){
					
					camera1Direct = 1;
				}else {
					camera1Direct = -1;
				}
                var dy:Number = ( mouseYOnMouseDown - mouseY);
                if (dy >= 75) {
                    if (targetAngel - 1 < 0) {
                        targetAngel = 0;
                    } else {
                        targetAngel = targetAngel - 1;
                    }
                } else if (dy < -75) {
                    if (targetAngel + 1 >= car.countAngels) {
                        targetAngel = car.countAngels - 1;
                    } else {
                        targetAngel = targetAngel + 1;
                    }
                }
				var ratationRatio:Number = 0.03;
                if (targetAngel == 1) {
					if(!car.hdsize) ratationRatio=0.05;
                    targetRotation = targetRotationOnMouseDown + (dx * ratationRatio);
                } else {
                    targetRotation = targetRotationOnMouseDown + (dx * ratationRatio);
                }
                if (targetAngel == 1 && targetRotation == 0 && car.countFrames == 50) {
                    targetRotation = camera2Direct * car.stepOfFrameIndexUp;
                }
				var ration:Number = targetAngel==1 ? 1: 1;
				var step:int =  targetAngel==1 ? car.stepOfFrameIndexUp: car.stepOfFrameIndex;
				if(Math.abs((dx * ration))>=step*(Device.isIos() ? 5: 2.5)){
					targetRotation = targetRotationOnMouseDown + (camera1Direct*step);
				}else if(currentAngelIndex!=targetAngel){
					targetRotation = targetRotationOnMouseDown;
				}else{
					//targetRotation = targetRotationOnMouseDown;
					moveBloker = false;
					return;
				}
				_rotation = targetRotation;
				var r:int =(_rotation);
				targetRotationOnMouseDown = targetRotation;
				mouseXOnMouseDown = mouseX;
                var hasCameraChanged : Boolean = this.currentAngelIndex != targetAngel;
                if(!previewMode) {
                    if (car.stepOfFrameIndex == car.stepOfFrameIndexUp) {
                        if (this.currentAngelIndex != targetAngel) {

                            showFrame(sIndex, targetAngel);
                        } else {
                            showFrame(r, targetAngel);
                        }
                    } else {
                        showFrame(r, targetAngel);
                    }
                    if (hasCameraChanged) {
                        updateCarY();
                    }
                }
            }
            else if (touch.phase == TouchPhase.ENDED) {
				
				
				touchDown = false;
				moveBloker = false;
                if (locked) {
                    startTouchHandler = false;
                    return;
                }


                if (touch.tapCount == 2) {
                    resetCarScale();
                    startTouchHandler = false;
                    return;
                }

                if (touchMoved || !canTouchParts) {
                    startTouchHandler = false;
                    return;
                }

                if (!frameMap[currentAngelIndex][currentFrame]) {
                    startTouchHandler = false;
                    return;
                }
				
				if(lockedTouch){
					startTouchHandler = false;
					return;
				}
				

                var parentPart:Part;
                var displayObject:DisplayObject = frameMap[currentAngelIndex][currentFrame].hitTest(touch.getLocation(frameMap[currentAngelIndex][currentFrame]));

                if (displayObject is ImageLoaderWithStates) {
                    var imageLoader:ImageLoaderWithStates = ImageLoaderWithStates(displayObject);
                    var partMaterialImage:PartMaterialImage = PartMaterialImage(imageLoader.persistentImageProvider);

                    if (partMaterialImage.ignoresTransparentPixelsOnTouch) {

                        parentPart = partMaterialImage.parentMaterial.parentPart;
                        //return;
                        if (NOT_SELECTABLE_PART_SLOTS.indexOf(parentPart.parentSlot.name) >= 0) {
                            var tireName:String  = parentPart.parentSlot.name;
                            _tracer.print(tireName + " is not selectable", "CarView TouchHandler");
                            return;
                        }
                        var currentColor:uint = imageLoader.color;
                        var color:Object = ColorUtil.HexToHSV(currentColor);
                        if(parentPart.selectedMaterial && (parentPart.selectedMaterial.name == "white" || parentPart.selectedMaterial.name == "metal")){
                            imageLoader.alpha = 0.9;
                        }else if(color.v < 50){
                            imageLoader.color = ColorUtil.HSVtoHEX(color.h, color.s, color.v + 15);
                        }else{
                            imageLoader.color = ColorUtil.HSVtoHEX(color.h, color.s, color.v - 15);
                        }
                        //imageLoader.alpha = 0.9;

						
						var partAnitmaskMaterial:PartMaterial = parentPart.getPossibleMaterial("antimask");
						
						if(partAnitmaskMaterial){
							trace("partAnitmaskMaterial true");
						}

                        setTimeout(function () :void{
                            imageLoader.alpha = 1;
                            imageLoader.color = currentColor;
                        }, 300);

                        //var t:CarsParser
                        if (parentPart.parentSlot.name.indexOf("aerographyAddState") >= 0) {
                            startTouchHandler = false;
                            return;
                        }

                        if (parentPart.parentSlot.unselectableComponent) {
                            startTouchHandler = false;
                            return;
                        }

                        if (parentPart.parentSlot.name.indexOf("aerography") >= 0) {

                            saveSelectedPart = parentPart;
                            //partMaterialImage.parentMaterial.parentPart.parentSlot.selectedPart=partMaterialImage.parentMaterial.parentPart;
							if(parentPart.color)
                            saveSelectedColor = parentPart.color.copy();
                            //partMaterialImage.parentMaterial.parentPart.parentSlot.selectedColor=partMaterialImage.parentMaterial.parentPart.parentSlot.selectedPart.color.copy();
                            startedTouch = true;
                        } else {

                            saveSelectedPart = null;
                            saveSelectedColor = null;
                        }

                        if (parentPart.parentSlot.name == "frame_back") {

                            var ps:PartSlot = car.getPossiblePartSlot("frame");

                            if (ps && ps.selectedPart) {

                                parentPart = ps.selectedPart;
                            }
                        }


                        dispatchEventWith(PART_SLOT_SELECTED, false, {partSlot: parentPart.parentSlot});
                    }
                }
				
				
            }

            startTouchHandler = false;


        } catch (e:Error) {

            startTouchHandler = false;
			
			touchDown = false;

			_tracer.print("touchHandler error:" + e.getStackTrace());
        }
    }

    public var saveSelectedPart:Part = null;
    public var saveSelectedColor:PartColor = null;
	public var defaultResetScale:Boolean = false;

    public function resetCarScale():void {

        _scaleComponent = car.hdsize ? defaultResetScale ? 1.0: 0.80 : 1.0; //defaultResetScale ? 1.0: 1.5 ;//
		defaultResetScale=!defaultResetScale;
        Starling.juggler.tween(framesContainer, 0.3, {
            scaleX: _initialScale * cofFrameScale*_scaleComponent,
            scaleY: _initialScale * cofFrameScale*_scaleComponent,
            transition: Transitions.EASE_IN_OUT
        });

		updateCarY();
    }

    public function getSnapShotForFrame(complete_fun:Function):void {
        framesContainer.complete_fun_step = complete_fun;

        framesContainer.startCreateSnapShots(frameMap, currentFrame, assetManager.scaleFactor, this, true, true);

    }
	
	private var _loadingCarImage:Image = null;
	private var _loadingCarTexture:Texture = null;
    private var snapshotTween:Tween;
	public function beforeLoading():void{
		
		trace("beforeLoading");
        var currentFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];
		if(!_loadingCarImage){
			
			var tuningScreen:TuningScreen = this.parent as TuningScreen;
			var bitmapData:BitmapData;
			var newBitmapData:BitmapData;
			var ts:Number=1;
            var index:int;
			if(tuningScreen.windowIsOpened){
				
				bitmapData = new BitmapData(Starling.context.backBufferWidth, Starling.context.backBufferHeight, false);
				stage.drawToBitmapData(bitmapData);

				if(bitmapData.width>Texture.maxSize){				
					ts=1;				
					ts=Texture.maxSize/bitmapData.width;
					
					newBitmapData=SnapShotFramesContainer.scaleBitmapData(bitmapData, ts);
					bitmapData.dispose();				
					bitmapData=newBitmapData;
				}
				
				_loadingCarTexture = Texture.fromBitmapData(bitmapData, false,false, 1);
				

				bitmapData.dispose();
				
				_loadingCarImage = new Image(_loadingCarTexture);
				_loadingCarImage.pixelSnapping = true;		
				_loadingCarImage.width = width;
				_loadingCarImage.height = height;
                _loadingCarImage.color = 0xFF0000;
                index = parent.getChildIndex(this);
                parent.addChildAt(_loadingCarImage, index + 1);
				//stage.addChild(_loadingCarImage);
				return;
			}
			
			bitmapData = copyToBitmapAll();
			
			if(bitmapData.width>Starling.context.backBufferWidth){
                                DevHelper._log("beforeLoading ERROR tmpImageSize: " + bitmapData.width);
				
				var bitmapData2:BitmapData = new BitmapData(Starling.context.backBufferWidth, Starling.context.backBufferHeight, true,  0x00808080);				
				bitmapData2.draw(bitmapData);				
				bitmapData.dispose();				
				bitmapData = bitmapData2;				
				bitmapData2 = null; 	
				
				
			}
			
			if(bitmapData.width>Texture.maxSize){				
				ts=Texture.maxSize/bitmapData.width;
				
				newBitmapData=SnapShotFramesContainer.scaleBitmapData(bitmapData, ts);
				bitmapData.dispose();				
				bitmapData=newBitmapData;
			}
			
			_loadingCarTexture = Texture.fromBitmapData(bitmapData, false,false, 1);

			bitmapData.dispose();
			
			_loadingCarImage = new Image(_loadingCarTexture);
			_loadingCarImage.pixelSnapping = true;
            _loadingCarImage.width = width;
            _loadingCarImage.height = height;
            _loadingCarImage.color = 0xFF0000;
            index = parent.getChildIndex(this);
            parent.addChildAt(_loadingCarImage, index + 1);
            // stage.addChild(_loadingCarImage);
			currentFrameView.hideMainLayers();		
		}		
	}
	
	public var moveDelta : Number = 0;

	private function removeLoadingCar():void{
        if (_loadingCarImage){
            trace("afterLoading");
            _loadingCarImage.removeFromParent(true);
            _loadingCarImage = null;
        }
        if(_loadingCarTexture){
            _loadingCarTexture.dispose();
            _loadingCarTexture= null;
        }
        snapshotTween = null;
    }

    public function removeSnapshot(duration:Number = 1):void{
        if(_loadingCarImage && !snapshotTween){
            _loadingCarImage.color = 0xFF0000;
            snapshotTween = new Tween(_loadingCarImage, duration);
            snapshotTween.fadeTo(0);
            snapshotTween.onComplete = removeLoadingCar;
            Starling.juggler.add(snapshotTween);
        }
    }

	public function afterLoading():void {
        var duration:Number = (previewMode?0.5:1);
        removeSnapshot(duration);
		updateAllAntimask();
		var currentFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];
		currentFrameView.showMainLayers();
	}

    override public function drawToBitmapData(out:BitmapData=null,
                                              color:uint=0x0, alpha:Number=0.0):BitmapData
    {
        var painter:Painter = Starling.painter;
        var stage:Stage = Starling.current.stage;
        var viewPort:Rectangle = Starling.current.viewPort;
        var stageWidth:Number  = parent.width;
        var stageHeight:Number = parent.height;
        var scaleX:Number = viewPort.width  / parent.width;
        var scaleY:Number = viewPort.height / parent.height;
        var backBufferScale:Number = painter.backBufferScaleFactor;
        var projectionX:Number, projectionY:Number;
        var bounds:Rectangle;

        if (this is Stage)
        {
            projectionX = viewPort.x < 0 ? -viewPort.x / scaleX : 0.0;
            projectionY = viewPort.y < 0 ? -viewPort.y / scaleY : 0.0;

            out ||= new BitmapData(painter.backBufferWidth  * backBufferScale,
                    painter.backBufferHeight * backBufferScale);
        }
        else
        {
            bounds = new Rectangle(0,0,stageWidth, stageHeight);//getBounds(_parent, sHelperRect);
            projectionX = bounds.x;
            projectionY = bounds.y;

            out ||= new BitmapData(Math.ceil(bounds.width  * scaleX * backBufferScale),
                    Math.ceil(bounds.height * scaleY * backBufferScale));
        }

        color = Color.multiply(color, alpha); // premultiply alpha

        painter.clear(color, alpha);
        painter.pushState();
        painter.setupContextDefaults();
        painter.state.renderTarget = null;
        painter.state.setModelviewMatricesToIdentity();
        painter.setStateTo(transformationMatrix);
        painter.state.setProjectionMatrix(projectionX, projectionY,
                painter.backBufferWidth / scaleX, painter.backBufferHeight / scaleY,
                stageWidth, stageHeight, stage.cameraPosition);

        render(painter);

        painter.finishMeshBatch();
        painter.context.drawToBitmapData(out);
        painter.popState();

        return out;
    }


	
	public function copyToBitmapAll():BitmapData//используется для заставки на время создания снапшотов
	{
		var bmpWidth:Number = Starling.context.backBufferWidth;//Math.ceil(parent.width * scaleFactor) ;
		var bmpHeight:Number = Starling.context.backBufferHeight;//Math.ceil(parent.height * scaleFactor) ;
		
		var bitmapData2:BitmapData = new BitmapData(bmpWidth, bmpHeight, true, 0x00808080);

		//this.backgroundContainer.visible =false;
		this.drawToBitmapData(bitmapData2);
		//this.backgroundContainer.visible =true;
		

		return bitmapData2;
	}

    public function createVideoFrame(angleIndex:int = -1, frameIndex:int = -1):BitmapData {
        var frame:CarFrameView = frameMap[currentAngelIndex][currentFrame] as CarFrameView;
        if(frame){
            return frame.getBitmapData();
        }
        var bmpWidth:Number = Starling.context.backBufferWidth;//Math.ceil(parent.width * scaleFactor) ;
        var bmpHeight:Number = Starling.context.backBufferHeight;//Math.ceil(parent.height * scaleFactor) ;
        var bitmapData2:BitmapData;// = new BitmapData(bmpWidth, bmpHeight, true, 0x00808080);
        this.backgroundContainer.visible =false;
        //this.drawToBitmapData(bitmapData2);
        bitmapData2 = this.drawToBitmapData();
        this.backgroundContainer.visible = true;
        return bitmapData2;
    }

    public function createFrameImage(angleIndex:int = -1, frameIndex:int = -1):BitmapData {
        showFrame(frameIndex, angleIndex);
        var frame:CarFrameView = frameMap[angleIndex][frameIndex] as CarFrameView;
        if(frame){
            return frame.getBitmapData();
        }
        return null;
    }

    public function copyToBitmap():BitmapData//используется для заставки на время создания снапшотов
    {
		var currentFrameView:CarFrameView = frameMap[currentAngelIndex][currentFrame];
		var scaleFactor:Number = assetManager.scaleFactor;
		
		var bmpWidth:Number = (stage.width * scaleFactor) ;
		var bmpHeight:Number = (stage.height * scaleFactor) ;
		
		var bitmapData2:BitmapData = new BitmapData(bmpWidth, bmpHeight, true, 0x00808080);

		var rectCurrentFrame:Rectangle = currentFrameView.getBounds(framesContainer);
		
		
		var rectFramesContainer:Rectangle = framesContainer.getBounds(this.stage);
		var outBmp:BitmapData = new BitmapData(rectFramesContainer.width*scaleFactor, (rectFramesContainer.height*scaleFactor)+(-rectFramesContainer.y*scaleFactor), true,  0x00808080);
		
		trace("currentFrame.x:", currentFrameView.x);
		trace("currentFrame.y:", currentFrameView.y);
		framesContainer.drawToBitmapData(outBmp);
		

		trace("rectFramesContainer:", rectFramesContainer);
		trace("rectCurrentFrame:", rectCurrentFrame);
		

		var matrix:Matrix = new Matrix();
		var offsetX:Number = rectFramesContainer.x < 0 ? rectFramesContainer.x*scaleFactor: 0;
		var offsetY:Number = rectFramesContainer.y < 0 ? rectFramesContainer.y*scaleFactor: 0;
		
		matrix.translate(offsetX, offsetY);
		bitmapData2.draw(outBmp, matrix, null, BlendMode.NORMAL);
		
		outBmp.dispose();
		

		return bitmapData2;
    }

	private static function isIdsExistInMap(idsToInclude : Array, existed2DArrayIds : Array) : Boolean
	{
		if(existed2DArrayIds.length == 0 || idsToInclude.length == 0)
		{
			return false;
		}

		for(var i : int = 0; i < existed2DArrayIds.length; i++)
		{
			var ids: Array = existed2DArrayIds[i];
			var exist : Boolean = true;

			for(var j : int = 0; j < idsToInclude.length; j++)
			{
				var found : Boolean = false;
				for(var k : int = 0; k < ids.length; k ++)
				{
					if(idsToInclude[j] == ids[k])
					{
						found = true;
						break;
					}
				}

				if(!found)
				{
					exist = false;
					break;
				}
			}

			if(exist) return true;
		}

		return false;
	}

    public function filteringSuspension():void
    {
        const defaultMin : int = 1000;
        var minMaxSuspension : int =  defaultMin;  // field to minimize MAX suspension
        var maxMinSuspension : int =  defaultMin; // field to maximize MIN suspension

        var pSlot: PartSlot;
        var def : String = "default";

        var minMax : int;
        var maxMin : int;

        var sett : Object;

        var partIdsMap : Array = [];
		var partSlotMap : Array = [];
        var settings : Array = [];
		var i:int;

        if(car.suspensionComponentsArray && car.suspensionComponentsArray.length > 0)
        {
            for(i=0 ; i < car.suspensionComponentsArray.length; i++)
            {
                var pack : Object = car.suspensionComponentsArray[i];
                var packArray : Array = pack.components;

                var listOfPartSlot : Array = car.isListOfPartsSelected(packArray);

                if(listOfPartSlot && !isIdsExistInMap(packArray, partIdsMap))
                {
                    partIdsMap.push(packArray);
                    settings.push(pack.settings);
					partSlotMap.push(listOfPartSlot);
                }
            }

            for(i=0; i < settings.length; i ++)
            {

                var setting : Object = settings[i];
				var partSlots : Array = partSlotMap[i];

				var state : String = car.getPossibleStateOfPartSlots(partSlots);
				if(state)
				{
                    minMax = setting.hasOwnProperty(def) && setting[def].hasOwnProperty("max") ? setting[def].max : defaultMin; // minimize max
                    maxMin = setting.hasOwnProperty(def) && setting[def].hasOwnProperty("min") ? setting[def].min : car.minSuspension; // maximize min

					sett = setting[state];
					if(sett.hasOwnProperty("min")) maxMin = sett.min;
					if(sett.hasOwnProperty("max")) minMax = sett.max;

                    if (minMax < minMaxSuspension) {
                        minMaxSuspension = minMax;
                    }

                    if(maxMin < maxMinSuspension)
                    {
                        maxMinSuspension = maxMin;
                    }
				}
				else {
                    for each(var diskSlot : PartSlot in car.possiblePartSlotsDisks)
                    {
                        if (diskSlot.selectedPart ) {
                            minMax = setting.hasOwnProperty(def) && setting[def].hasOwnProperty("max") ? setting[def].max : defaultMin; // minimize max
                            maxMin = setting.hasOwnProperty(def) && setting[def].hasOwnProperty("min") ? setting[def].min : car.minSuspension; // maximize min

                            if(diskSlot.selectedPart.selectedState)
                            {
                                sett = setting[diskSlot.selectedPart.selectedState.nameOfState];
                                if(sett.hasOwnProperty("min")) maxMin = sett.min;
                                if(sett.hasOwnProperty("max")) minMax = sett.max;

                            }

                            if (minMax < minMaxSuspension) {
                                minMaxSuspension = minMax;
                            }

                            if(maxMin < maxMinSuspension)
                            {
                                maxMinSuspension = maxMin;
                            }
                        }
                    }
				}


            }
        }

        if(settings.length == 0 && car.suspensionForState && car.suspensionForState["cm1"])
        {
            for each (pSlot in car.possiblePartSlotsDisks)
            {
                if(pSlot.selectedPart)
                {
                    minMax = car.maxSuspension;
                    if( pSlot.selectedPart.selectedState && car.suspensionForState[pSlot.selectedPart.selectedState.nameOfState])
                    {

                        minMax = car.suspensionForState[pSlot.selectedPart.selectedState.nameOfState].max;
                    }
                    if(minMax < minMaxSuspension)
                    {
                        minMaxSuspension = minMax;
                    }
                }
            }
        }

        var isMax : Boolean = minMaxSuspension != defaultMin;
        var isMin : Boolean = maxMinSuspension != defaultMin;

        car.limiterMaxSuspension = isMax ? minMaxSuspension : car.maxSuspension;
        car.limiterMinSuspension = isMin ? maxMinSuspension : car.minSuspension;

        if(isMax || isMin)
        {
            (parent as FeathersControl).invalidate('car');
        }

        _tracer.print("MAX SUSP : " + car.limiterMaxSuspension + " MIN SUSP : " + car.limiterMinSuspension, "FILTERING SUSPENSION");
        isMax = isMin = false; // reset valuse


        if (car.suspension < -car.limiterMaxSuspension) {
            car.suspension = -car.limiterMaxSuspension;
            _tracer.print("MAX SUSP Validate" + minMaxSuspension, "Filtering Suspension");
            isMax = true;
        }

        if(car.suspension > -car.limiterMinSuspension) {
            car.suspension = -car.limiterMinSuspension;
            _tracer.print("MIN SUSP Validate" + maxMinSuspension, "Filtering Suspension");
            isMin = true;
        }

        if(isMin || isMax)
        {
            updateSuspension();
        }
    }

    public function get cameraSecondCameraIsLoading():Boolean {
        return _cameraSecondCameraIsLoading;
    }

    public function set cameraSecondCameraIsLoading(value:Boolean):void {
        _cameraSecondCameraIsLoading = value;
    }

    public function get isLoading():Boolean {
        return _isLoading;
    }

    public function get loadSelectedFrame():int {
        return _loadSelectedFrame;
    }

    public function set loadSelectedFrame(value:int):void {
        if(value == -1){
            _loadSelectedFrame = -1;
        } else {
            _loadSelectedFrame = bestIndexToFrameIndex(value);
        }
    }

    public function get fastModeLoadedFrames():Object {
        return _fastModeLoadedFrames;
    }

    public function set fastModeLoadedFrames(value:Object):void {
        _fastModeLoadedFrames = value;
    }

    public function get fastModeLoadedPartSlots():Array{
        return _fastModeLoadedPartSlots;
    }

    public function setFastModeFullLoaded():void {
        fastModeLoadedFrames = {};
        for(var angleIndex:String in frameMap){
            fastModeLoadedFrames[angleIndex] = {};
            for(var frameIndex:String in frameMap[angleIndex]){
                fastModeLoadedFrames[angleIndex][frameIndex] = true;
            }
        }
    }

    public function resetFastModeCurrentLoaded():void {
        fastModeLoadedFrames = {};
        fastModeLoadedFrames[currentAngelIndex] = {};
        fastModeLoadedFrames[currentAngelIndex][currentFrame] = true;
    }

    public function setFastModeCurrentLoaded():void {
        fastModeLoadedFrames ||= {};
        fastModeLoadedFrames[currentAngelIndex] ||= {};
        fastModeLoadedFrames[currentAngelIndex][currentFrame] = true;
    }

    public function bestIndexToFrameIndex(k:int):int {
        if(k > 25){
            k -= 25;
        }
        _frameIndexList = ObjectUtils.getKeys(frameMap[currentAngelIndex]);
        for(var i:int = 0; i < _frameIndexList.length; i++){
            _frameIndexList[i] = parseInt(_frameIndexList[i]);
        }
        return _frameIndexList[k];
    }

    private function allImagesLoaded():void{
        partsLoaded = true;
        _isLoading = false;
        if (completeAfterUpdate_fun != null) {
            completeAfterUpdate_fun();
            completeAfterUpdate_fun = null;
        }
        if(visible){
            afterLoading();
        }
        if(hasEventListener(ALL_IMAGES_LOADED)){
            dispatchEvent(new Event(ALL_IMAGES_LOADED));
        }
    }

}
}