package com.despark.tuning3d.view.components.cars
{
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.images.DASBitmapDataLoader;

import feathers.core.FeathersControl;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.geom.Matrix;
import flash.utils.setTimeout;

import starling.core.Starling;
import starling.display.DisplayObject;
import starling.display.DisplayObjectContainer;
import starling.display.Image;
import starling.events.Event;
import starling.textures.Texture;

public class SnapShotFramesContainer extends FeathersControl
	{
		private static var arrOfIndexes: Array = [0, 4, 12, 20, 24, 38, 46];
		
		private const stepCS_CreateArrOfSnapshots:int = 0;
		private const stepCS_CreateSnapshotWithBackground:int = 1;
		private const stepCS_CreateSnapshotFHD:int = 2;
		private const stepCS_CreateSnapshotWithoutLight:int = 3;

		public var complete_fun_step : Function=null;

		private var priviousVisible : Boolean;
		private var priviousCurrentIndex : int;
		
                private var prevAngelIndex:int=0;
		private var offset : int = 0;
		private var currentIndexOfFrame : int = -1;		
		private var frameMap : Object;
		private var step : int;
		private var stepCS : int;//step of snapshots creating 
		
		private var scaleFactor :Number;
		private var carView : CarView;
		private var showWithoutNeon : Boolean;
		private var showWithBackground : Boolean;
		private var bitmapDataWithoutNeon: BitmapData;
		private var bitmapDataWithBackground: BitmapData;
		private var backgroundImageFC : Image; //эта картинка будет содержать скриншот временно вместо машины
		private var backgroundImageFCTexture:Texture;
		private var bitmapDataLoader : DASBitmapDataLoader;
		private var excludePartSlotsNames:Array=[];
                private var bitmapData : BitmapData;

		public function SnapShotFramesContainer()
		{
			super();
			
			if(Car.weakDevice){
				arrOfIndexes=[0, 5, 15, 20, 25, 40, 45];
			}
			
		}
		

		public override function dispose():void{
			
			complete_fun_step=null;
			
			frameMap=null;
			carView=null;
			
			if(backgroundImageFCTexture){   
				backgroundImageFCTexture.dispose();
				backgroundImageFCTexture=null;
			}
			
			if(backgroundImageFC){
				backgroundImageFC.dispose();
				backgroundImageFC=null;
			}
			excludePartSlotsNames=null;
			if(bitmapDataLoader){
				bitmapDataLoader.cancel();
				bitmapDataLoader=null;
			}
			
			if(bitmapData){
				
				bitmapData.dispose();
				bitmapData=null;
			}
			
			super.dispose();
		}
		
		
		protected override function initialize() : void
		{
			super.initialize();
		}
		
		public function startCreateSnapShots(__frameMap : Object, __priviousCurrentIndex : int, __scaleFactor :Number, __carView : CarView, __showWithoutNeon:Boolean = true, __showWithBackground:Boolean = true): void
		{
			showWithBackground = __showWithBackground;
			showWithoutNeon = __showWithoutNeon;
			carView = __carView;
			scaleFactor = __scaleFactor;
			frameMap = __frameMap;
			priviousCurrentIndex = __priviousCurrentIndex;
			
			priviousVisible = __frameMap[CarView.CURRENT_ANGEL_INDEX][__priviousCurrentIndex].visible;
			
			currentIndexOfFrame=__priviousCurrentIndex;

			if(bitmapData){
				
				bitmapData.dispose();
				bitmapData=null;				
			}
						
			if(backgroundImageFC){
				
				backgroundImageFC.dispose()
				backgroundImageFC=null;
			}
			
			if(backgroundImageFCTexture){
				
				backgroundImageFCTexture.dispose();
				backgroundImageFCTexture=null;
			}
			
			bitmapData  = stage.drawToBitmapData();//carView.copyToBitmap();
			
			var texture : Texture;
			var ts:Number=1;
			
			if(bitmapData.width>1024){
				
				ts=1024/bitmapData.width;
				
				var newBitmapData:BitmapData=scaleBitmapData(bitmapData, ts);
				
				bitmapData.dispose();
				
				bitmapData=newBitmapData;
			}
			
			texture = Texture.fromBitmapData(bitmapData, false, false,1);
				
			backgroundImageFC=new Image(texture);
			backgroundImageFC.visible = false;
			backgroundImageFC.x =parent.x;//this.x/2;
			backgroundImageFC.y =parent.y;    
			backgroundImageFC.width=parent.width;
			backgroundImageFC.height=parent.height;  
			backgroundImageFC.visible = true;

			//373,1004
			var ratio:Number=1004/373;
			
			width = 1004;
			height = 373;   
			
			if(Constants.STAGE.fullScreenWidth<1004){
				width = Constants.STAGE.fullScreenWidth;
				height = Constants.STAGE.fullScreenWidth/ratio;   
			}
			stage.addChild(backgroundImageFC);
			Starling.juggler.delayCall(continueStart,0.3);
		}
		
		public static function scaleBitmapData(bitmapData:BitmapData, scale:Number):BitmapData {
			scale = Math.abs(scale);
			var width:int = (bitmapData.width * scale) || 1;
			var height:int = (bitmapData.height * scale) || 1;
			var transparent:Boolean = bitmapData.transparent;
			var result:BitmapData = new BitmapData(width, height, transparent, transparent ? 0x00808080: 0xffffff);
			var matrix:Matrix = new Matrix();
			matrix.scale(scale, scale);
			result.draw(bitmapData, matrix);
			return result;
		}

		
		
		
		private function continueStart() : void{
			frameMap[CarView.CURRENT_ANGEL_INDEX][priviousCurrentIndex].visible = false;
			stepCS = stepCS_CreateArrOfSnapshots;
			
			offset = -8000;
			this.x += offset;
			
			bitmapDataWithoutNeon = null;
			bitmapDataWithBackground = null;
			step = 0;
			
			arrOfIndexes = [0, 44, currentIndexOfFrame];
			
			if(Car.weakDevice){
				arrOfIndexes=[0, 44, currentIndexOfFrame];
			}
			
			startDrawNextStep();
		}
		
	
		
		private function startDrawNextStep(indexOfFrame:int = -1, angelIndex:int=-1, addBackground : Boolean = false): void
		{
			if((currentIndexOfFrame>=0) && frameMap[prevAngelIndex][currentIndexOfFrame]){
				frameMap[prevAngelIndex][currentIndexOfFrame].visible = false;
			}
			
			if(indexOfFrame>-1){
				currentIndexOfFrame = indexOfFrame;
			}else{
				currentIndexOfFrame = arrOfIndexes[step];
				
				if(currentIndexOfFrame<-1){
					
					onCompleteFrameDrawToBitmap();
					return;
				}
					
			}
			
			var angel:int=0;
			
			if(step==2){
				
				angel=CarView.CURRENT_ANGEL_INDEX;
				prevAngelIndex=angel;
			}
			
			
			if(angelIndex>=0){
				angel=angelIndex;
				prevAngelIndex=angel;
			}



			var carFrameView :CarFrameView = frameMap[angel][currentIndexOfFrame];
			
			if(carFrameView){
				carFrameView.addEventListener(CarFrameView.COMPLETE_DRAW_TO_BITMAP, onCompleteFrameDrawToBitmap);
				carFrameView.startDrawToBitmap(excludePartSlotsNames, bitmapDataWithBackground);
			}else{
				onCompleteFrameDrawToBitmap();
			}
		}
		
		private function onCompleteFrameDrawToBitmap(event:Event=null):void{
			var bitmapData : BitmapData = null;
			if(event){
				if(event.target){
					(event.target as CarFrameView).removeEventListener(CarFrameView.COMPLETE_DRAW_TO_BITMAP, onCompleteFrameDrawToBitmap);
				}
				bitmapData=event.data.bitmapData;
			}
			
			switch(stepCS) {
				case stepCS_CreateArrOfSnapshots: {
					if(complete_fun_step){
						// complete_fun_step(bitmapData, "stepCS_CreateArrOfSnapshots", step);
						if(bitmapData){
							bitmapData.dispose();
							bitmapData=null;
						}
					}
					step ++;
					if(step < arrOfIndexes.length){
						startDrawNextStep();
					}else{
						startNextStepCS();
					}
					return;
				}
				case stepCS_CreateSnapshotWithBackground: {
					if(complete_fun_step){
						this.complete_fun_step(bitmapData, "stepCS_CreateSnapshotWithBackground", -1);
						if(bitmapData){
							bitmapData.dispose();
							bitmapData=null;
						}

					}
                    startNextStepCS();
					return;
				}
                case stepCS_CreateSnapshotFHD: {
                    if(complete_fun_step){
                        this.complete_fun_step(bitmapData, "stepCS_CreateSnapshotFHD", -1);
                        excludePartSlotsNames=[];
                        if(bitmapData){
                            bitmapData.dispose();
                            bitmapData=null;
                        }
                    }

                    returnBackgroundBack();
                    return;
                }

				case stepCS_CreateSnapshotWithoutLight: {
					if(complete_fun_step){
						this.complete_fun_step(bitmapData, "stepCS_CreateSnapshotWithoutLight", -1);
						excludePartSlotsNames=[];
						if(bitmapData){
							bitmapData.dispose();
							bitmapData=null;
						}
					}
					startNextStepCS();
					return;
				}
			}
		}
		
		private function createSnapShotWithoutNeonAndLights() : void
		{
			excludePartSlotsNames=['shadow', "neon"];
			startDrawNextStep(0);
		}

		private function createFHDSnapShots() : void
		{
			//загрузим Bitmap бэкграунда если он не загружен
			var url : String;
            if(carView.car.selectedBackground)
            {
				if(carView.currentAngelIndex == 1 && carView.car.selectedBackground.imagePathSecondCam && carView.car.selectedBackground.imagePathSecondCam.length)
				{
                    url = carView.car.selectedBackground.imagePathSecondCam;
				}
				else {
                    url = carView.car.selectedBackground.remoteUrl;
                }
            }
			else if(carView.car.defaultBkgMobile)
			{
				if(carView.currentAngelIndex == 1 && carView.car.defaultBkgMobile.length == 2)
				{
					url = carView.car.defaultBkgMobile[1];
				}else {

					url = carView.car.defaultBkgMobile[0];
				}
			}

			if(url)
			{
                bitmapDataLoader = new DASBitmapDataLoader();
                bitmapDataLoader.download(url,function (__bitmap : Bitmap,__url: String) : void
                {
                    bitmapDataWithBackground = __bitmap.bitmapData;
                    startDrawNextStep(priviousCurrentIndex, CarView.CURRENT_ANGEL_INDEX);
                });
			}
			else {
                startDrawNextStep(priviousCurrentIndex, CarView.CURRENT_ANGEL_INDEX);
			}
		}

		private function createCustomSnapShots() : void{
			//сдесь просто без бэка, но в кастомном ракурсе делается шот
			startDrawNextStep(priviousCurrentIndex, CarView.CURRENT_ANGEL_INDEX);
		}
		
		private function returnBackgroundBack() : void{

			if(bitmapDataWithBackground)
			{
				bitmapDataWithBackground.dispose();
				bitmapDataWithBackground = null;
			}

			startNextStepCS();
		}
		
		
		private function startNextStepCS() : void{
			stepCS++;
			switch(stepCS) {
				case stepCS_CreateArrOfSnapshots: {
					return;
				}
				case stepCS_CreateSnapshotWithBackground: {
					if(showWithBackground){
						createCustomSnapShots();
					}else{
						startNextStepCS();
					}
					return;
				}

				case stepCS_CreateSnapshotWithoutLight: {
					if(showWithoutNeon){
						createSnapShotWithoutNeonAndLights();
					}else{
						startNextStepCS();
					}
					return;
				}

				case stepCS_CreateSnapshotFHD: {
                    createFHDSnapShots();
                    return;
                }
			}
			finishCreateSnapshots();
		}
		
		
		private function finishCreateSnapshots() : void{
			if(frameMap[prevAngelIndex] && frameMap[prevAngelIndex][currentIndexOfFrame])
				frameMap[prevAngelIndex][currentIndexOfFrame].visible = false;
			
			
			if(frameMap[CarView.CURRENT_ANGEL_INDEX] && frameMap[CarView.CURRENT_ANGEL_INDEX][priviousCurrentIndex])
				frameMap[CarView.CURRENT_ANGEL_INDEX][priviousCurrentIndex].visible = priviousVisible;
			
			if(bitmapData){
				bitmapData.dispose();
				bitmapData = null;
			}
			
			setTimeout(function():void{
				if(backgroundImageFC){
					backgroundImageFC.visible = false;
					backgroundImageFC.removeFromParent(true);
					backgroundImageFC=null;
				}
			}, 1000);
			
			
			if(backgroundImageFCTexture){
				
				backgroundImageFCTexture.dispose();
				backgroundImageFCTexture=null;
			}
			
			
			if(CarFrameView.bufferBitmapData){
				
				CarFrameView.bufferBitmapData.dispose();
				CarFrameView.bufferBitmapData=null;
            }

            finishComplete();
        }
		
		private function finishComplete():void
		{
			bitmapDataLoader = null;
			this.x -= offset;
			offset = 0;
			
		}		
	}
}

