package com.despark.tuning3d.view.components.challenges {
import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.MainMenuButton;
import com.despark.tuning3d.view.components.core.MainMenuView;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.gallery.GalleryLabelFactory;
    import com.despark.tuning3d.view.components.gallery.GalleryScreen;
    import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;
import com.despark.tuning3d.view.components.timeline.components.TimelineLoadBar;
    import com.distriqt.AdsManager;
    import com.utils.DisplayObjectUtil;

    import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.PullViewDisplayMode;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.FeathersControl;
    import feathers.core.ToggleGroup;
    import feathers.data.ListCollection;
import feathers.events.FeathersEventType;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.HorizontalLayoutData;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;
import feathers.system.DeviceCapabilities;

import flash.utils.setTimeout;

import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
import starling.events.Event;
    import starling.events.EventDispatcher;
    import starling.textures.Texture;
    import starling.utils.Color;

public class ChallengesListScreen extends StackedScreen implements Multilingual, IMainMenuHolder {

        public static const UPDATE_CHALLENEGES:String = 'UpdateChallenges';


        public var _mainMenuView:MainMenuView;
        private var _showAllChallenge:Boolean = true;
        private var _languages:Array;
        private var _selectedLanguage:Language;
        private var startChallengeLabel:Label;
        private var _topBarHeight:Number;
        private var _backgroundQuad:Quad;
        private var _topMenuContainer:LayoutGroup;
        private var _menuButton:MainMenuButton;

        private var _buttonsLayOutGroup:LayoutGroup;
        private var _allChallengeButton:ToggleButton;
        private var _myChallengeButton:ToggleButton;
        private var _createChallengeButton:Button;
        private var _buttonToggleGroup:ToggleGroup;


        private var _topButtonPadding:Number = 0;
        private var _challengeItemContainer:List;
        private var _challanges:Array;
        private var _challengeLoading:Boolean = false;
        private var _timelineLoadBar:TimelineLoadBar;
        private var _timelineLoadBarPulling:TimelineLoadBar;


        private var _scrollToTopButton : Button;
        public var firstChallengeDate: String;

        private var title:Label;
        private var _messageField:Label;

        private static const TOOLBAR_SIZE:Number = 31;

        private function initScrollToTopButton():void {

            this._scrollToTopButton = ButtonFactory.simpleButtonByTextureName('back_to_top');
            this.addChild(this._scrollToTopButton);

            this._scrollToTopButton.width = 30;
            this._scrollToTopButton.height = 30;

            this._scrollToTopButton.alpha = 0;
            this._scrollToTopButton.x = Constants.STAGE_WIDTH - this._scrollToTopButton.width - 10;
            this._scrollToTopButton.y = Constants.STAGE_HEIGHT - this._scrollToTopButton.height - 10;
//            this._scrollToTopButton.width = 50;
//            this._scrollToTopButton.height = 25;
            this._scrollToTopButton.visible = false;
            this._scrollToTopButton.addEventListener(Event.TRIGGERED, scrollButtonTriggered)
        }

        private function scrollButtonTriggered ( e : Event ) : void {
            if (_challengeItemContainer) {
                _challengeItemContainer.scrollToPosition(0,0,0);
            }
        }

        public function set mainMenuView(value:MainMenuView):void {
            this._mainMenuView = value;
            this._mainMenuView.owner = this;
        }

        public function get mainMenuView():MainMenuView {
            return this._mainMenuView;
        }

        public function set languages(value:Array):void {
            _languages = value;
        }

        public function get languages():Array {
            return _languages;
        }

        public function get selectedLanguage():Language {
            return this._selectedLanguage;
        }

        public function set selectedLanguage(value:Language):void {
            this._selectedLanguage = value;
        }

        public function set challengeLoading(val:Boolean):void {
            if (val) {
                showLoader();
            } else {
                hideLoader();
            }
            _challengeLoading = val;
        }

        public function set showAllChallenge(val:Boolean):void {
            var stateChange:Boolean = false;
            if (_showAllChallenge != val) {
                stateChange = true;

            }
            _showAllChallenge = val;
            if (stateChange) {

                challenges = null;
                firstChallengeDate = null;
                dispatchEventWith(UPDATE_CHALLENEGES);
            }
        }

        public function get showAllChallenge():Boolean {
            return _showAllChallenge;
        }

        public function set challenges(values:Array):void {
            if (_challengeItemContainer.hasEventListener(Event.SCROLL, listScrollHandler)) {
                _challengeItemContainer.removeEventListener(Event.SCROLL, listScrollHandler);
            }
            challengeLoading = true;
            if (values && values.length > 0) {
                _messageField.visible = false;
                if (_challengeItemContainer) {
                    if (_challengeItemContainer.dataProvider.length > 0) {

                        for (var i:int = 0; i < values.length; i++) {

                            if (_challengeItemContainer.dataProvider.getItemIndex(values[i]) == -1) {
                                _challengeItemContainer.dataProvider.addItem(values[i]);
                            }
                        }
                    } else {
                        _challengeItemContainer.dataProvider = new ListCollection(values);
                    }
                    _challengeItemContainer.validate();
                }
            } else if (!values) {
                _challengeItemContainer.dataProvider.removeAll();
                _challengeItemContainer.validate();
                _messageField.x = (actualWidth - _messageField.width)/2;
                _messageField.y = BannerStackedScreen.BANNER_SIZE + (actualHeight - BannerStackedScreen.BANNER_SIZE - _messageField.height)/2;
                _messageField.visible = true;
            }
            if (values) {
                if (!_challengeItemContainer.hasEventListener(Event.SCROLL, listScrollHandler)) {
                    _challengeItemContainer.addEventListener(Event.SCROLL, listScrollHandler);
                }
            }
            challengeLoading = false;
        }

        public function getChallengesCount(): Number {
            return _challengeItemContainer.dataProvider.length;
        }

        public function ChallengesListScreen() {
            super('ChallengesListScreen');
        }

        override protected function initialize():void {
            super.initialize();

            _topBarHeight = DeviceCapabilities.isTablet(Starling.current.nativeStage) ? 35 : 40;

            _backgroundQuad = new Quad(1, 1, UIColors.WHITE);
            addChild(_backgroundQuad);

            initTopMenuContainer();



            _timelineLoadBarPulling ||= new TimelineLoadBar();
            _timelineLoadBarPulling.name = '_timelineLoadBarPulling';
            _timelineLoadBarPulling.setSize(60, 60);
            _timelineLoadBarPulling.x = Constants.STAGE_WIDTH / 2 - _timelineLoadBarPulling.width / 2;
            _timelineLoadBarPulling.y = Constants.STAGE_HEIGHT / 2 - _timelineLoadBarPulling.height / 2;
            _timelineLoadBarPulling.addEventListener(FeathersEventType.PULLING, listPull);
            addChild(_timelineLoadBarPulling);

            initChallangeList();


            _timelineLoadBar ||= new TimelineLoadBar();
            _timelineLoadBar.name = '_timelineLoadBar';
            _timelineLoadBar.setSize(60, 60);
            _timelineLoadBar.x = Constants.STAGE_WIDTH / 2 - _timelineLoadBar.width / 2;
            _timelineLoadBar.y = Constants.STAGE_HEIGHT / 2 - _timelineLoadBar.height / 2;
            addChild(_timelineLoadBar);


            showLoader();
            initScrollToTopButton();
        }

        public function showLoader():void {

            _timelineLoadBar.visible = true;
        }

        public function hideLoader():void {
            _timelineLoadBar.visible = false;
        }

        private function initChallangeList():void {
            var layData:AnchorLayoutData = new AnchorLayoutData();
            layData.left = 0;
            layData.top = 0;
            layData.right = 0;
            layData.bottom = 0;


            var layout:VerticalLayout = new VerticalLayout();
            layout.gap = 6;
            layout.hasVariableItemDimensions = true;
            layout.horizontalAlign = HorizontalAlign.LEFT;
            layout.verticalAlign = VerticalAlign.TOP;


            _challengeItemContainer = new List();
            _challengeItemContainer.layout = layout;
            _challengeItemContainer.clipContent = false;
            _challengeItemContainer.layoutData = layData;
            _challengeItemContainer.dataProvider = new ListCollection();
            _challengeItemContainer.horizontalScrollPolicy = ScrollPolicy.OFF;
            _challengeItemContainer.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
            _challengeItemContainer.verticalScrollPolicy = ScrollPolicy.ON;

            var screen:ChallengesListScreen = this;

            _challengeItemContainer.itemRendererFactory = function ():IListItemRenderer {
                var renderer:ChallengeListItemRenderer = new ChallengeListItemRenderer();
                var size:Number = 1080 * (actualWidth / 2 / 1920);
                renderer.setSize(actualWidth, size);
                renderer.addEventListener(StackedScreen.GARAGE_SELECTED, function(event:Event):void{
                    dispatchEventWith(StackedScreen.GARAGE_SELECTED);
                });
                renderer.addEventListener(ChallengeEvent.VIEW_CHALLENGE_TUNING, function(event:Event):void{
                    SoundManager.playSound(SoundManager.PART_MENU);
                    dispatchEventWith(ChallengeEvent.VIEW_CHALLENGE_TUNING, true, event.data);
                });
                renderer.eventDispatcher = screen as EventDispatcher;
                renderer.list = _challengeItemContainer;
                return renderer;
            };
            _challengeItemContainer.topPullView = _timelineLoadBarPulling;
            _challengeItemContainer.topPullViewDisplayMode = PullViewDisplayMode.FIXED;

            addChildAt(_challengeItemContainer, getChildIndex(_backgroundQuad) + 1);
        }
        private function listPull(event:Event): void {
            _timelineLoadBarPulling.removeEventListener(event.type, listPull);
            dispatchEventWith(UPDATE_CHALLENEGES, true, {isPulling: true} );
        }

        public function listPullingEnd(): void {
            setTimeout(function ():void {
                _challengeItemContainer.isTopPullViewActive = false;
            }, 200);

            _timelineLoadBarPulling.addEventListener(FeathersEventType.PULLING, listPull);
        }

        private function listScrollHandler(event:Event):void {
            var headerSize:Number = _topMenuContainer.height + TOOLBAR_SIZE;
            if(_challengeItemContainer.verticalScrollPosition < headerSize){
                _topMenuContainer.visible = true;
                _createChallengeButton.visible = true;
                _buttonsLayOutGroup.visible = true;

                var headerAlpha:Number = 1 - _challengeItemContainer.verticalScrollPosition / headerSize;
                _topMenuContainer.alpha = headerAlpha;
                _createChallengeButton.alpha = headerAlpha;
                _buttonsLayOutGroup.alpha = headerAlpha;
            }else{
                _topMenuContainer.visible = false;
                _createChallengeButton.visible = false;
                _buttonsLayOutGroup.visible = false;
            }

            if( _challengeItemContainer.verticalScrollPosition > 20) {
                _scrollToTopButton.visible = true;
                _scrollToTopButton.alpha = 1;
                BannerStackedScreen.hideAdBanner(false);
            } else {
                _scrollToTopButton.visible = false;
                BannerStackedScreen.showAdBanner();
            }

            if (!_challengeLoading) {
                if (_challengeItemContainer.verticalScrollPosition >= _challengeItemContainer.maxVerticalScrollPosition - 100) {
                    challengeLoading = true;
                    dispatchEventWith(UPDATE_CHALLENEGES, true, {skip: _challengeItemContainer.dataProvider.length});
                }
            }

        }

        private function initTopMenuContainer():void {
            _topMenuContainer = new LayoutGroup();
            _topMenuContainer.height = BannerStackedScreen.BANNER_SIZE;
            _topMenuContainer.layout = new AnchorLayout();

            var headerBg:Image = new Image(Texture.fromColor(1, 1, UIColors.BANNER_BACKGROUND_COLOR));
            headerBg.color = 0xFF0000;
            _topMenuContainer.backgroundSkin = headerBg;
            addChild(_topMenuContainer);

            var menuButtonLayoutData:AnchorLayoutData = new AnchorLayoutData();
            menuButtonLayoutData.verticalCenter = 0;
            menuButtonLayoutData.left = 5.5;
            _menuButton = ButtonFactory.menuBigButton("home_screen_main_menu", 0xFFFFFE);
            _menuButton.layoutData = menuButtonLayoutData;
            _menuButton.width = 35;
            _menuButton.height = 35;
            _menuButton.addEventListener(Event.TRIGGERED, mainMenuButtonHandler);
            _topMenuContainer.addChild(_menuButton);


            var buttonsLayout:HorizontalLayout = new HorizontalLayout();
            buttonsLayout.verticalAlign = VerticalAlign.MIDDLE;
            buttonsLayout.gap = 0;
            _buttonsLayOutGroup = new LayoutGroup();
            _buttonsLayOutGroup.height = TOOLBAR_SIZE;
            _buttonsLayOutGroup.layout = buttonsLayout;
            _buttonsLayOutGroup.x = 0;
            _buttonsLayOutGroup.y = _topMenuContainer.height;
            addChild(_buttonsLayOutGroup);


            _buttonToggleGroup = new ToggleGroup();
            _buttonToggleGroup.isSelectionRequired = true;
            var buttonsLayData:HorizontalLayoutData = new HorizontalLayoutData();

            _allChallengeButton = ButtonFactory.challengeTopMenuButton("All");
            _allChallengeButton.layoutData = buttonsLayData;
            _allChallengeButton.label = 'All';
            _allChallengeButton.isSelected = true;
            _buttonsLayOutGroup.addChild(_allChallengeButton);
            _buttonToggleGroup.addItem(_allChallengeButton);

            _myChallengeButton = ButtonFactory.challengeTopMenuButton("My", "timeline_my_activities_icon");
            _myChallengeButton.layoutData = buttonsLayData;
            _myChallengeButton.label = 'My';
            _myChallengeButton.isSelected = false;
            _myChallengeButton.width = 75;
            _buttonsLayOutGroup.addChild(_myChallengeButton);
            _buttonToggleGroup.addItem(_myChallengeButton);

            _buttonToggleGroup.addEventListener(Event.CHANGE, filterCHangeHandlerHandler);

            _createChallengeButton = ButtonFactory.garageChallengeButton();
            _createChallengeButton.layoutData = buttonsLayData;
            _createChallengeButton.scale = 32/_createChallengeButton.width;
            _createChallengeButton.addEventListener(Event.TRIGGERED, createChallengeHandler);
            addChild(_createChallengeButton);


            var startChallengeLayData:AnchorLayoutData = new AnchorLayoutData();
            startChallengeLayData.verticalCenter = 0;
            startChallengeLayData.right = 55;
            startChallengeLabel = new Label();
            startChallengeLabel.textRendererFactory = LabelFactory.challengesStartChallengeLabel;
            startChallengeLabel.wordWrap = true;
            startChallengeLabel.text = "Start\nChallenge";
            startChallengeLabel.width = 80;
            startChallengeLabel.height = 35;
            startChallengeLabel.layoutData = startChallengeLayData;
            _topMenuContainer.addChild(startChallengeLabel);

            var titleLayData:AnchorLayoutData = new AnchorLayoutData();
            titleLayData.verticalCenter = 0;
            titleLayData.left = 50;
            title = new Label();
            title.layoutData = titleLayData;
            title.textRendererFactory = GalleryLabelFactory.screenTitle;
            title.text = 'CHALLENGES';
            _topMenuContainer.addChild(title);
            checkTopButtonsAccess();

            var messageLayData:AnchorLayoutData = new AnchorLayoutData();
            messageLayData.verticalCenter = 0;
            messageLayData.horizontalCenter = 0;
            _messageField = new Label();
            _messageField.layoutData = titleLayData;
            _messageField.textRendererFactory = GalleryLabelFactory.messageLabel;
            _messageField.text = "You don't have any challenges at this moment";
            _messageField.visible = false;
            addChild(_messageField);

        }

        public function updateNotifications() :void{
            if(_menuButton){
                _menuButton.updateNotification();
            }
            if(mainMenuView){
                mainMenuView.updateNotificationCount();
            }
        }

        public function checkTopButtonsAccess():void {
            var currentUser:User;
            var usersProxy:UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
            currentUser = usersProxy.currentUser;
            if (currentUser) {
                _myChallengeButton.isEnabled = true;
                _allChallengeButton.isEnabled = true;
                _createChallengeButton.isEnabled = true;

            } else {
                _myChallengeButton.isEnabled = false;
                _allChallengeButton.isEnabled = false;
                _createChallengeButton.isEnabled = false;
            }
        }

        private function showAllChallengesHandler(e:Event): void {
            _myChallengeButton.isSelected = false;
            _challengeItemContainer.removeEventListener(Event.SCROLL, listScrollHandler);
            showAllChallenge = true;
        }

        private function filterCHangeHandlerHandler(e:Event): void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            if(_buttonToggleGroup.selectedItem == _myChallengeButton){
                _challengeItemContainer.removeEventListener(Event.SCROLL, listScrollHandler);
                showAllChallenge = false;
            }else if(_buttonToggleGroup.selectedItem == _allChallengeButton){
                _challengeItemContainer.removeEventListener(Event.SCROLL, listScrollHandler);
                showAllChallenge = true;
            }
        }

        private function createChallengeHandler(e: Event):void {
            SoundManager.playSound(SoundManager.PART_MENU);
            BannerStackedScreen.hideAdBanner(false);
            var user: User  = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
            var data: Object  = ChallengeEvent.getData(user, null, Constants.selectedUser, null);
            data.showBannerAfterExit = true;
            dispatchEvent(new Event(ChallengeEvent.CHALLENGE_REQUEST, false, data));
        }

        private function mainMenuButtonHandler():void {
            if (this.mainMenuView) mainMenuView.toggle();
        }

        override protected function draw():void {
            super.draw();

            var sizeInvalid:Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);

            if (!mainMenuView) {
                mainMenuView = new MainMenuView();
                mainMenuView.y = _topButtonPadding;
                mainMenuView.name = 'mainMenuView';
                //mainMenuView.setSize(190, actualHeight - _topButtonPadding);

                mainMenuView.width = MainMenuView.MENU_WIDTH;
                mainMenuView.height = actualHeight - _topButtonPadding;
                mainMenuView.parentActualWidth = actualWidth;
                mainMenuView.parentActualHeight = actualHeight;
                addElement(mainMenuView, this.numChildren - 1);

                mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
                mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
            }

            if (sizeInvalid) {
                if (mainMenuView) {
                    mainMenuView.y = _topButtonPadding;

                    mainMenuView.width = MainMenuView.MENU_WIDTH;
                    mainMenuView.height = actualHeight - _topButtonPadding;
                    mainMenuView.parentActualWidth = actualWidth;
                    mainMenuView.parentActualHeight = actualHeight - _topButtonPadding;
                }

                _topMenuContainer.width = actualWidth;
                _topMenuContainer.validate();

                _backgroundQuad.width = actualWidth;
                _backgroundQuad.height = actualHeight - _topButtonPadding;

                _challengeItemContainer.setSize(actualWidth, actualHeight - _topMenuContainer.height - BannerStackedScreen.BANNER_SIZE);
                _challengeItemContainer.x = 0;
                _challengeItemContainer.y = _topMenuContainer.height + TOOLBAR_SIZE;

                if(_createChallengeButton){
                    _createChallengeButton.x = actualWidth - (_createChallengeButton.width + 10);
                    _createChallengeButton.y = (_topMenuContainer.height - _createChallengeButton.height) / 2;
                }
            }

        }
        override public function ShowDone():void {
            BannerStackedScreen.showAdBanner();
        }

        private function menuOpenHandler(event:Event):void {
            BannerStackedScreen.hideAdBanner(false);
        }

        private function menuCloseHandler(event:Event):void {
            BannerStackedScreen.showAdBanner();
        }

        override protected function screen_removedFromStageHandler(event:Event):void{
            super.screen_removedFromStageHandler(event);
            BannerStackedScreen.hideAdBanner(true);
        }

        public function brandsScreenButtonTriggeredHandler(event:Event = null):void {
            dispatchEventWith(StackedScreen.BRANDS_SELECTED);
        }

        public function dispatchExternalEvent(msg:String):void {
            if (mainMenuView) {
                mainMenuView.hide();
            }

            dispatchEventWith(msg);
        }

        public function enterRowsState():void {
            Tracer.print('Challenge list doesn\'t have row state');
        }

        public function homeButtonTriggeredHandler(event:Event = null):void {
            dispatchEventWith(StackedScreen.HOME_SELECTED);
        }

        public function updateWithLanguage(language:Language):void {
            if (mainMenuView) mainMenuView.updateWithLanguage(language);
        }

        override public function dispose():void {
            super.dispose();
            if(_buttonToggleGroup){
                _buttonToggleGroup.removeAllItems();
                _buttonToggleGroup.removeEventListeners();
                _buttonToggleGroup = null;
            }

            if (_challengeItemContainer) {
                _challengeItemContainer.removeEventListener(Event.SCROLL, listScrollHandler);
                _challengeItemContainer.dataProvider = null;
                _challengeItemContainer.removeFromParent(true);
                _challengeItemContainer.itemRendererFactory = null;
                _challengeItemContainer = null;
            }
            if (_challanges) {
                _challanges = null;
            }



            if (_mainMenuView) {
                _mainMenuView.dispose();
                _mainMenuView = null;
            }


            DisplayObjectUtil.disposeMesh(_backgroundQuad);
            _backgroundQuad = null;
            if (_timelineLoadBar) {
                _timelineLoadBar.removeFromParent();
            }
            if (_timelineLoadBarPulling) {
                _timelineLoadBarPulling.removeFromParent();
            }

            if (_buttonsLayOutGroup) {
                _buttonsLayOutGroup.dispose();
                _buttonsLayOutGroup = null;
            }

            if (_topMenuContainer) {
                _topMenuContainer.dispose();
                _topMenuContainer = null;
            }

            if (_allChallengeButton) {
                _allChallengeButton.dispose();
                _allChallengeButton = null;
            }

            if (_myChallengeButton) {
                _myChallengeButton.dispose();
                _myChallengeButton = null;
            }

            if (_createChallengeButton) {
                _createChallengeButton.removeEventListener(Event.TRIGGERED, createChallengeHandler);
                _createChallengeButton.dispose();
                _createChallengeButton = null;
            }

            if (startChallengeLabel) {
                startChallengeLabel.dispose();
                startChallengeLabel = null;
            }

            if (_scrollToTopButton) {
                this._scrollToTopButton.removeEventListener(Event.TRIGGERED, scrollButtonTriggered);
                this._scrollToTopButton.removeFromParent(true);
            }

        }

        private function addElement(item:*, index:int = -1):void {
            for (var i:int = 0; i < numChildren; i++) {
                if (getChildAt(i).name == item.name) return;
            }
            index == -1 ? addChild(item) : addChildAt(item, index);
        }

    }
}
