package com.despark.tuning3d.view.components.challenges {
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.greensock.TweenLite;

    import feathers.controls.Button;
    import feathers.core.FeathersControl;

    import flash.net.URLRequest;

    import flash.net.navigateToURL;

    import starling.display.Image;
    import starling.display.Quad;

    import starling.events.Event;

    public class InstagramChallengePopup extends FeathersControl {
        private var background:Image;
        private var closeButton:Button;
        private var linkButton:Button;
        private var ratio:Number = 1;
        public function InstagramChallengePopup() {
            super();
        }

        override protected function initialize():void{
            background = new Image(ButtonFactory.assetManager.getTexture("instagram_challenge_popup"));
            background.color = 0xFF0000;
            background.height = height;
            background.scale = scaleY;
            width = background.width;
            addChild(background);

            closeButton = new Button();
            var defaultSkin:Quad = new Quad(1, 1, 0xFF0000);
            defaultSkin.alpha = 0;
            defaultSkin.width = defaultSkin.height = 25;
            closeButton.defaultSkin = defaultSkin;
            closeButton.width = defaultSkin.width;
            closeButton.height = defaultSkin.height;
            closeButton.addEventListener(Event.TRIGGERED, closeTriggeredHandler);
            addChild(closeButton);


            linkButton = new Button();
            var linkSkin:Quad = new Quad(1, 1, 0xFF0000);
            linkSkin.alpha = 0;
            linkSkin.width = 160;
            linkSkin.height = 25;
            linkButton.defaultSkin = linkSkin;
            linkButton.width = linkSkin.width;
            linkButton.height = linkSkin.height;
            linkButton.addEventListener(Event.TRIGGERED, linkTriggeredHandler);
            addChild(linkButton);
            //
            visible = false;
            width = background.width;
            height = background.height;
        }

        override public function set height(value:Number):void{
            super .height = value;
            if(isInitialized){
                background.height = value;
                background.scale = background.scaleY;
                width = background.width;
                //
                ratio = background.texture.scale * background.height / background.texture.nativeHeight;
                closeButton.scale = ratio;
                linkButton.scale = ratio;
            }
        }

        override protected function draw():void{
            if(closeButton){
                closeButton.x = width - (closeButton.width + 8 * ratio);
                closeButton.y = 10 * ratio;
            }

            if(linkButton){
                linkButton.x = 100 * ratio;
                linkButton.y = 235 * ratio;
            }
        }

        override public function dispose():void{
            if(closeButton){
                closeButton.removeFromParent(true);
                closeButton = null;
            }

            if(linkButton){
                linkButton.removeFromParent(true);
                linkButton = null;
            }

            if(background){
                background.removeFromParent(true);
                background = null;
            }
        }

        public function open():void{
            var popup:InstagramChallengePopup = this;
            alpha = 0;
            visible = true;
            TweenLite.to(popup, 0.3, {"alpha":1});
        }

        private function close():void{
            dispatchEventWith(Event.CLOSE);
            var popup:InstagramChallengePopup = this;
            TweenLite.to(popup, 0.3, {"alpha":0, onComplete:function ():void {
                    popup.removeFromParent(true);
                }});
        }

        private function closeTriggeredHandler(event:Event):void {
            close();
        }

        private function linkTriggeredHandler(event:Event):void {
            navigateToURL(new URLRequest("https://instagram.com/3dtuning"));
        }
    }
}
