package com.despark.tuning3d.view.components.challenges.controls {
import feathers.controls.List;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.FeathersControl;

import starling.events.Event;

public class ChallengeListItemRenderer extends FeathersControl implements IListItemRenderer {
    public function ChallengeListItemRenderer()
    {
    }


    protected var _index:int = -1;

    public function get index():int
    {
        return this._index;
    }

    public function set index(value:int):void
    {
        if(this._index == value)
        {
            return;
        }
        this._index = value;
        this.invalidate(INVALIDATION_FLAG_DATA);
    }

    protected var _owner:List;

    public function get owner():List
    {
        return this._owner;
    }

    public function set owner(value:List):void
    {
        if(this._owner == value)
        {
            return;
        }
        this._owner = value;
        this.invalidate(INVALIDATION_FLAG_DATA);
    }

    protected var _data:Object;

    public function get data():Object
    {
        return this._data;
    }

    public function set data(value:Object):void
    {
        if(this._data == value)
        {
            return;
        }
        this._data = value;
        this.invalidate(INVALIDATION_FLAG_DATA);
    }

    protected var _factoryID:String;

    public function get factoryID():String
    {
        return this._factoryID;
    }

    public function set factoryID(value:String):void
    {
        this._factoryID = value;
    }

    protected var _isSelected:Boolean;

    public function get isSelected():Boolean
    {
        return this._isSelected;
    }

    public function set isSelected(value:Boolean):void
    {
        if(this._isSelected == value)
        {
            return;
        }
        this._isSelected = value;
        this.invalidate(INVALIDATION_FLAG_SELECTED);
        this.dispatchEventWith(Event.CHANGE);
    }

    protected var _padding:Number = 0;

    public function get padding():Number
    {
        return this._padding;
    }

    public function set padding(value:Number):void
    {
        if(this._padding == value)
        {
            return;
        }
        this._padding = value;
        this.invalidate(INVALIDATION_FLAG_LAYOUT);
    }

    override protected function draw():void {
        var dataInvalid:Boolean = this.isInvalid(INVALIDATION_FLAG_DATA);

        if(dataInvalid) {
            this.commitData();
        }

        this.autoSizeIfNeeded();
    }

    protected function autoSizeIfNeeded():Boolean
    {
        var needsWidth:Boolean = isNaN(this.explicitWidth);
        var needsHeight:Boolean = isNaN(this.explicitHeight);
        if(!needsWidth && !needsHeight)
        {
            return false;
        }

        var newWidth:Number = this.explicitWidth;
        var newHeight:Number = this.explicitHeight;
        return this.saveMeasurements(newWidth, newHeight, newWidth, newHeight);
    }

    protected function commitData():void{
    }

}
}