package com.despark.tuning3d.view.components.challenges.controls {
import com.despark.tuning3d.model.friend.Friend;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
import com.utils.FontSelector;

import feathers.controls.Label;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.Quad;

public class ChallengeUserItemRenderer extends ListItemRenderer {
    private var _avatar:UserCircularAvatar;
    private var _background:Quad;
    private var _label:Label;
    //private var _searchResultList:SearchResultList;
    private var loaded:Boolean;
    public function ChallengeUserItemRenderer() {
        super();
    }

    private function get user():User{
        if(!data){
            return null;
        }
        return (data as Friend).user;
    }

    override public function setSize(width:Number, height:Number):void {
        super.setSize(width, height);
        if(_background){
            _background.width = width;
            _background.height = height;
        }
        if(_avatar){
            _avatar.x = (actualWidth-_avatar.width)/2;
        }
    }

    override protected function commitData():void {
        super.commitData();
        //_searchResultList = owner as SearchResultList;
        if(!user)
            return;
        if(_avatar){
            _avatar.removeFromParent(true);
            /*if(!loaded){
                _searchResultList.loadingItems--;
            }*/
        }
        if(!_background) {
            _background = new Quad(1, 1, 0xFFFFFF);
        }
        _avatar = new UserCircularAvatar(user, 40);
        //_searchResultList.loadingItems++;
        //loaded = false;
        /*_avatar.loadComplete = function ():void {
            loaded = true;
            _searchResultList.loadingItems--;
        };*/
        if(!_label) {
            _label = new Label();
            _label.textRendererFactory = titleTextRenderer;
            _label.width = actualWidth-4;
            _label.x = 2;
            if(_avatar){
                _label.y = _avatar.y+_avatar.height;
            }
        }
        _label.text = user.nameToShow;
        addChild(_background);
        addChild(_avatar);
        addChild(_label);
    }

    override protected function draw():void {
        super.draw();
        _avatar.x = (actualWidth-_avatar.width)/2;
        _label.x = (actualWidth-_label.width)/2;
        _label.y = _avatar.height;
    }

    private static function  titleTextRenderer ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), 9, 0x424242);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.wordWrap = true;
        return textRenderer;
    }

    override public function dispose():void {
        super.dispose();
        if(_avatar) {
            _avatar.removeFromParent(true);
            _avatar = null;
        }
        if(_background) {
            _background.removeFromParent(true);
            _background = null;
        }
        if(_label) {
            _label.removeFromParent(true);
            _label = null;
        }
    }
}
}
