package com.despark.tuning3d.view.components.challenges.controls {
import feathers.controls.List;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.renderers.IListItemRenderer;
import feathers.events.FeathersEventType;
import feathers.layout.Direction;
import feathers.layout.HorizontalAlign;
import feathers.layout.TiledRowsLayout;
import feathers.layout.VerticalAlign;

import starling.display.Quad;
import starling.events.Event;

public class SearchResultList extends List {
    private var _loadingItems:int;
    private var _loader:ChallengesLoadBar;
    private var _background:Quad;

    public static const END_REACHED:String = "listEndReachedEvent";
    public function SearchResultList() {
        super();
    }

    override protected function initialize():void {
        super.initialize();
        _loadingItems = 0;
        initializeTuningsRowsList();
    }

    private function initializeTuningsRowsList() : void {
        _background = new Quad(1,1,0xFFFFFF);
        backgroundSkin = _background;

        var rowsLayout : TiledRowsLayout = new TiledRowsLayout();
        rowsLayout.paging = Direction.VERTICAL;
        rowsLayout.useSquareTiles = false;

        rowsLayout.useVirtualLayout = true;
        rowsLayout.gap = 0;
        rowsLayout.horizontalGap=0;
        rowsLayout.verticalGap=0;
        rowsLayout.horizontalAlign = HorizontalAlign.CENTER;
        rowsLayout.verticalAlign = VerticalAlign.MIDDLE;
        minimumPageThrowVelocity=1;
        layout = rowsLayout;
        snapToPages = true;
        scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
        horizontalScrollPolicy = ScrollPolicy.OFF;
        verticalScrollPolicy = ScrollPolicy.ON;
        addEventListener(Event.SCROLL, tuningsColumnsListScrollHandler);
        addEventListener(Event.CHANGE, tuningsColumnsListChangeHandler);

    }

    public function set loadingItems(val:int):void{
        _loadingItems = val;
        if(_loadingItems>0){
            _loader ||= new ChallengesLoadBar();
            _loader.setSize(actualWidth, actualHeight);
            if(isScrolling){
                addEventListener(FeathersEventType.SCROLL_COMPLETE, onScrollComplete);
            }else{
                addChild(_loader);
                isEnabled = false;
            }

        }else if(_loader){
            _loader.removeFromParent();
            isEnabled = true;
        }
    }

    private function onScrollComplete(event:Event):void {
        loadingItems = loadingItems;
        if(verticalScrollPosition == maxVerticalScrollPosition){
            dispatchEvent(new Event(END_REACHED));
        }
    }

    public function get loadingItems():int{
        return _loadingItems;
    }

    private function tuningsColumnsListChangeHandler(event:Event):void {

    }

    private function tuningsColumnsListScrollHandler(event:Event):void {

    }
}
}
