package com.despark.tuning3d.view.components.challenges.controls {
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.instructions.SimpleImageProvider;

import starling.display.Image;
import starling.display.Sprite;

public class TuningLabel extends Sprite{
    private var _loader:ImageLoaderWithStates;
    private var _image:Image;
    private var _width:Number;
    private var _height:Number;
    private var _loadComplete:Function;
    public function TuningLabel(url:String) {
        _loader = new ImageLoaderWithStates();
        _loader.overrideDispose = true;
        var simpleImageProvider : SimpleImageProvider = new SimpleImageProvider();
        simpleImageProvider.urlForDownloading = url;
        _loader.persistentImageProvider = simpleImageProvider;
        addChild(_loader);
        _loader.startLoading();
        _loader.completeHandler = function():void{
            _loader.removeFromParent();
            _image = new Image(_loader.currentTexture);
            addChild(_image);
            if(_width){
                width = _width;
            }else if(_height){
                height = _height;
            }
            if(_loadComplete!=null){
                _loadComplete.call();
            }
        };
        _loader.errorHandler = function():void{
            trace("failed loading thumbnail");
        };
    }

    public function set loadComplete(value:Function):void {
        _loadComplete = value;
    }

    override public function set width(value:Number):void {
        super.width = _width = value;
        if(_image){
            super.height = _width * _image.texture.nativeHeight/_image.texture.nativeWidth;
        }
    }

    override public function set height(value:Number):void {
        super.height = _height = value;
        if(_image){
            super.width = _height * _image.texture.nativeWidth/_image.texture.nativeHeight;
        }
    }

    override public function dispose():void {
        super .dispose();
        if(_image){
            _image.texture.dispose();
            _image.removeFromParent(true);
            _image = null;
        }
        if(_loader){
            _loader.removeFromParent(true);
            _loader = null;
        }
        _loadComplete = null;
    }
}
}
