package com.despark.tuning3d.view.components.challenges.modals {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.cars.CarBackground;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.packages.PackagesParser;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.Tuning;
    import com.despark.tuning3d.model.tunings.TuningsProxy;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeLeaderBoardItemRenderer;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengesLoadBar;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.CustomAlertView;
    import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.MainMenuButton;
    import com.despark.tuning3d.view.components.core.MainMenuView;
    import com.despark.tuning3d.view.components.core.ScreenComponentFactory;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.gallery.GalleryLabelFactory;
    import com.despark.tuning3d.view.components.gallery.data.RequestPeriod;
    import com.despark.tuning3d.view.components.gallery.data.RequestRegion;
    import com.despark.tuning3d.view.components.tunings.TuningItemRenderer;
    import com.utils.ObjectUtils;
    import com.utils.ObjectUtils;

    import feathers.controls.Button;

    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.controls.List;
    import feathers.controls.Radio;
    import feathers.controls.ScrollPolicy;
    import feathers.controls.ToggleButton;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.core.FeathersControl;
    import feathers.core.ToggleGroup;
    import feathers.data.ListCollection;
    import feathers.events.FeathersEventType;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.HorizontalLayoutData;
    import feathers.layout.VerticalAlign;
    import feathers.layout.VerticalLayout;

    import flash.display.StageOrientation;

    import flash.events.StageOrientationEvent;

    import flash.geom.Rectangle;

    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;
    import starling.filters.DropShadowFilter;
    import starling.textures.Texture;

    public class ChallengeLeaderBoardScreen extends StackedScreen implements IMainMenuHolder{
    private var _userList:List;
    private var _userIdList:Object;
    private var _titleLabel:Label;
    // private var _flagIcon:Image;
    private var _headerBorder:Quad;
    private var _border1:Quad;
    private var _border2:Quad;
    private var _border3:Quad;



    private var _loadBar:ChallengesLoadBar;
    private var _requestCount:int;
    private var _toDate:Date;
    private var isLoading:Boolean = false;
    private var isLoaded:Boolean = false;
    private var _currentUser:User;
    public var isLeaderBoard:Boolean;
    private var _mainMenuView:MainMenuView;
    //
    private var _showByButton:ToggleButton;
    private var _countryButton:ToggleButton;
    private var _worldButton:ToggleButton;


    private var regionDropDown:ToggleButton;
    private var regionGroup:ToggleGroup;
    public var countryData:Object;
    private var regionMenu:Sprite;

    private var toolbarBackground:Quad;
    //
    private var showByBorderList:Array;
    private var showByGroup:LayoutGroup;
    private var showByMenu:Sprite;
    private var showByToggleGroup:ToggleGroup;
    private var showByLabel:Object;
    private var _period:String;
    //
    private static var USER_MENU_WIDTH:int = 220;
    public static const LOAD_BACKGROUNDS:String = 'loadBackgrounds';
    public static const LOAD_TUNING_BACKGROUNDS:String = 'loadTuningBackgrounds';
    //
    private var _showBannerAfterExit:Boolean;
    private var _bannerScreen:String;
    private var _userMenuBackground:Image;
    private var _background:Quad;
    private var _bannerBackground:Image;
    private var menuButton:MainMenuButton;
    //
    private var _nextButton:Button;
    private var _prevButton:Button;
    private var _snapshots : Array;
    private var tuningView:TuningItemRenderer;
    private var tuningListData:Array;
    private var _backgroundsMap:Object;
    private var _selectedTuning:Tuning;
    private var _selectedUser:User;
    private var _container:LeaderBoardContainer;
    private var _winIcon:Image;
    private var _winLabel:Label;
    private var _language:Language;
    private var _leftMargin:int = 0;
    private var _playSound:Boolean = true;
    public function ChallengeLeaderBoardScreen(data:Object = null) {
        super("ChallengeLeaderBoardScreen");
        isLeaderBoard = false;
        _userIdList = {};
        _showBannerAfterExit = (data && data.hasOwnProperty("showBannerAfterExit") && data.showBannerAfterExit);
        _bannerScreen = (data && data.hasOwnProperty("bannerScreen"))?data["bannerScreen"]:BannerScreen.BANNER_SCREEN;
    }

    override protected function initialize():void {
        super.initialize();
        setSizeInternal(stage.stageWidth, stage.stageHeight, false);
        //
        if(Device.isIphoneXVariant()){
            setOrientationMargins();
        }
        //
        _background ||= new Quad(1, 1, 0x242424);
        addChildAt(_background, 0);

        _bannerBackground = new Image(Texture.fromColor(1,1, UIColors.BANNER_BACKGROUND_COLOR));
        addChild(_bannerBackground);


        _userMenuBackground = new Image(ButtonFactory.assetManager.getTexture("leaderboard_bg"));
        addChild(_userMenuBackground);

        menuButton = ButtonFactory.menuBigButton("home_screen_main_menu", 0xFFFFFE);
        menuButton.width = 35;
        menuButton.height = 35;
        menuButton.addEventListener(Event.TRIGGERED, onMenuButton);
        addChild(menuButton);

        menuButton.x = menuButton.y = (BannerStackedScreen.BANNER_SIZE - menuButton.height) / 2;

        _headerBorder = new Quad(1,1,0xFFFFFF);
        _headerBorder.width = actualWidth;
        var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
        _currentUser = usersProxy.currentUser;
        _headerBorder.y = BannerStackedScreen.BANNER_SIZE - 2;

        _titleLabel = new Label();
        _titleLabel.layoutData = new HorizontalLayoutData();
        _titleLabel.width = actualWidth;
        _titleLabel.textRendererFactory = GalleryLabelFactory.screenTitle;
        _titleLabel.text = "Leaderboard";
        _titleLabel.validate();
        _titleLabel.x = menuButton.x + menuButton.width;
        _titleLabel.y = (BannerStackedScreen.BANNER_SIZE - _titleLabel.height)/2;
        addChild(_titleLabel);
        //
        _container = new LeaderBoardContainer();
        _snapshots = [];
        addChild(_container);

        toolbarBackground = new Quad(1, 1, 0xFFFFFF);
        toolbarBackground.width = USER_MENU_WIDTH;
        toolbarBackground.height = BannerStackedScreen.TOOLBAR_SIZE + 2;
        toolbarBackground.y = BannerStackedScreen.BANNER_SIZE - 1;
        addChild(toolbarBackground);

        //
        _userList = new List();
        _userList.isSelectable = true;
        _userList.setSize(USER_MENU_WIDTH, actualHeight - BannerStackedScreen.BANNER_SIZE - BannerStackedScreen.TOOLBAR_SIZE);
        _userList.y = actualHeight - _userList.height;
        _userList.horizontalScrollPolicy = ScrollPolicy.OFF;
        _userList.verticalScrollPolicy = ScrollPolicy.ON;
        _userList.dataProvider = new ListCollection([]);
        _userList.addEventListener(Event.CHANGE, selectionChangeHandler);
        _userList.addEventListener(Event.SCROLL, listScrollHandler);
        addChild(_userList);

        addChild(_headerBorder);

        /*_flagIcon = new Image(ButtonFactory.assetManager.getTexture("leaderboard_flag_icon"));
        _flagIcon.width = _flagIcon.height = 20;
        _flagIcon.color = 0xFFFFFE;
        addChild(_flagIcon);*/

        createShowBySection();
        createRegionSection();

        _border1 = createBorder();
        _border1.width = USER_MENU_WIDTH / 2 - 10;
        _border1.x = 5;
        _border1.y = 0;
        regionMenu.addChild(_border1);

        _border2 = createBorder();
        _border2.height = BannerStackedScreen.TOOLBAR_SIZE - 10;
        _border2.x = USER_MENU_WIDTH / 2;
        _border2.y = BannerStackedScreen.BANNER_SIZE + (BannerStackedScreen.TOOLBAR_SIZE - _border2.height) / 2 - 2;
        addChild(_border2);

        _border3 = createBorder();
        _border3.height = BannerStackedScreen.TOOLBAR_SIZE ;
        _border3.x = USER_MENU_WIDTH - _border3.width;
        _border3.y = BannerStackedScreen.BANNER_SIZE - 2;
        addChild(_border3);

        _loadBar = new ChallengesLoadBar();
        _loadBar.setSize(USER_MENU_WIDTH, _userList.height);
        _requestCount = Math.ceil(_userList.height/50);
        _userList.itemRendererFactory = leaderBoardItemFactory;

        _prevButton = ButtonFactory.arrowButton("slide_arr_lt");
        _prevButton.disabledSkin = _prevButton.downSkin;
        _prevButton.width = 22.5;
        _prevButton.height = 35;
        _prevButton.addEventListener(Event.TRIGGERED, onPrevButtonHandler);
        _prevButton.alpha = 1;
        Image(_prevButton.defaultSkin).color = 0xFFFFFF;
        _container.addChild(_prevButton);

        _nextButton = ButtonFactory.arrowButton("slide_arr_lt");
        _nextButton.disabledSkin = _nextButton.downSkin;
        _nextButton.rotation = Math.PI;
        _nextButton.width = 22.5;
        _nextButton.height = 35;
        _nextButton.addEventListener(Event.TRIGGERED, onNextButtonHandler);
        Image(_nextButton.defaultSkin).color = 0xFFFFFF;
        _container.addChild(_nextButton);

        _winIcon = new Image(ButtonFactory.assetManager.getTexture("challenge_winner"));
        _winIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        _winIcon.x = USER_MENU_WIDTH + 5;
        _winIcon.y = BannerStackedScreen.BANNER_SIZE + 5;
        _container.addChild(_winIcon);

        _winLabel = new Label();
        _winLabel.textRendererFactory = LabelFactory.leaderBoardWinLabel;
        _container.addChild(_winLabel);
        _winLabel.x = _winIcon.x + _winIcon.width + 2;
        _winLabel.y = _winIcon.y + (_winIcon.height - _winLabel.height)/2;
        requestData();
    }

    private function createRegionSection():void{
        _countryButton = ButtonFactory.createLeaderBoardRegionButton(String(countryData.country).toLowerCase(), RequestRegion.BY_COUNTRY, 14, false);
        _worldButton = ButtonFactory.createLeaderBoardRegionButton("timeline_world_icon", RequestRegion.BY_WORLD);

        _countryButton.label = "Country";
        _worldButton.label = "World";

        _countryButton.width = USER_MENU_WIDTH / 2 - 10;
        _worldButton.width = USER_MENU_WIDTH / 2 - 10;

        _countryButton.x = 2;
        _worldButton.x = 2;

        regionGroup = new ToggleGroup();
        regionGroup.addItem(_worldButton);
        regionGroup.addItem(_countryButton);
        regionGroup.isSelectionRequired = true;
        regionGroup.addEventListener(Event.CHANGE, regionChangeHandler);


        regionDropDown = ScreenComponentFactory.createDropDownButton("timeline_world_icon", "Country", 0, true, false);
        regionDropDown.gap = 3;
        regionDropDown.label = "World";
        regionDropDown.width = USER_MENU_WIDTH / 2;
        regionDropDown.height = BannerStackedScreen.TOOLBAR_SIZE - 2;
        regionDropDown.iconOffsetX = 5;
        regionDropDown.y = BannerStackedScreen.BANNER_SIZE;
        regionDropDown.x = USER_MENU_WIDTH - regionDropDown.width;
        regionDropDown.addEventListener(Event.CHANGE, regionButtonChangeHandler);
        addChild(regionDropDown);

        regionMenu = new Sprite();
        var menuBackground:Image = new Image(ButtonFactory.assetManager.getTexture("menu_background"));
        menuBackground.scale9Grid = new Rectangle(menuBackground.width/3, menuBackground.height/3, menuBackground.width/3, menuBackground.height/3);
        menuBackground.width = regionDropDown.width;
        menuBackground.height = BannerStackedScreen.TOOLBAR_SIZE;
        menuBackground.filter = new DropShadowFilter(2, Math.PI/4, 0, 0.2);
        menuBackground.y = -1;

        regionMenu.addChild(menuBackground);
        regionMenu.addChild(_countryButton);
        regionMenu.addChild(_worldButton);

        _countryButton.validate();
        _worldButton.validate();

        _countryButton.y = (BannerStackedScreen.TOOLBAR_SIZE - _countryButton.height) / 2;
        _worldButton.y = (BannerStackedScreen.TOOLBAR_SIZE - _worldButton.height) / 2;

        _countryButton.visible = !_countryButton.isSelected;
        _worldButton.visible = !_worldButton.isSelected;

        regionMenu.x = regionDropDown.x;
        regionMenu.y = BannerStackedScreen.BANNER_SIZE + BannerStackedScreen.TOOLBAR_SIZE - 5;

        addChild(regionMenu);
        regionMenu.visible = false;
    }

    private function regionChangeHandler(event:Event):void {
        _countryButton.visible = !_countryButton.isSelected;
        _worldButton.visible = !_worldButton.isSelected;

        if(_countryButton.isSelected){
            regionDropDown.label = _countryButton.label;
            regionDropDown.defaultIcon = regionDropDown.defaultSelectedIcon = _countryButton.defaultIcon;
        }else if(_worldButton.isSelected){
            regionDropDown.label = _worldButton.label;
            regionDropDown.defaultIcon = regionDropDown.defaultSelectedIcon = _worldButton.defaultIcon;
        }

        _userList.removeEventListener(Event.CHANGE, selectionChangeHandler);
        _userList.dataProvider.removeAll();
        isLoaded = isLoading = false;
        _showByButton.isSelected = false;
        regionDropDown.isSelected = false;
        _userList.addEventListener(Event.CHANGE, selectionChangeHandler);
        requestData();
    }

    private function listScrollHandler(event:Event):void {
        if(isLoading || isLoaded){
            return;
        }
        if(_userList.verticalScrollPosition>_userList.maxVerticalScrollPosition){
            requestData();
        }
    }

    private function selectionChangeHandler(event:Event):void {
        if(_playSound){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
        dispatchEvent(new Event(ChallengeEvent.LEADER_BOARD_USER_SELECTED, false, _userList.selectedItem));
    }

    override protected function draw():void {
        super.draw();
        //
        if (!mainMenuView){
            mainMenuView = new MainMenuView();
            mainMenuView.name = "mainMenuView";
            mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight);
            mainMenuView.parentActualWidth = actualWidth;
            mainMenuView.parentActualHeight = actualHeight;
            addChild(mainMenuView);

            mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
            mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
        }
        if(_background){
            _background.width = actualWidth;
            _background.height = actualHeight;
        }

        if(_bannerBackground){
            _bannerBackground.width = actualWidth;
            _bannerBackground.height = BannerStackedScreen.BANNER_SIZE;
        }
        //
        _userMenuBackground.width = USER_MENU_WIDTH;
        _userMenuBackground.height = actualHeight - BannerStackedScreen.BANNER_SIZE;
        _userMenuBackground.y = BannerStackedScreen.BANNER_SIZE;


        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }else{
            if(_nextButton){
                _nextButton.x = stage.stageWidth - _nextButton.width / 2;
                _nextButton.y = (actualHeight + BannerStackedScreen.BANNER_SIZE)/2;
            }
        }


        if(_prevButton){
            _prevButton.x = _prevButton.width / 2 + USER_MENU_WIDTH;
            _prevButton.y = (actualHeight + BannerStackedScreen.BANNER_SIZE)/2;
        }

        updateNavigationButtons();
        updatePageIndicatorPosition();
    }

    private function leaderBoardItemFactory() : IListItemRenderer {
        var renderer : ChallengeLeaderBoardItemRenderer = new ChallengeLeaderBoardItemRenderer();
        renderer.setSize(_userList.width, 50);
        renderer.currentUser = _currentUser;
        renderer.paddingLeft = _leftMargin;
        renderer.eventDispatcher = this;
        return renderer;
    }

    public function requestData():void{
        if(!isLoading && !isLoaded) {
            _toDate ||= new Date();
            isLoading = true;
            _loadBar ||= new ChallengesLoadBar();
            _loadBar.x = _userList.x;
            _loadBar.y = _userList.y;
            addChild(_loadBar);
            var params:Object = {
                limit: _requestCount,
                skip: _userList.dataProvider.length,
                toDate:_toDate,
                period:_period
            };
            if(_countryButton && _countryButton.isSelected){
                params.country = true;
            }
            dispatchEvent(new Event(ChallengeEvent.REQUEST_LEADER_BOARD_DATA, false, params));
        }
    }

    private function onMenuButton(event:Event):void{
        mainMenuView.toggle();
    }

        private function updatePageIndicatorPosition():void{
            if(tuningView) {
                tuningView.pageIndicator.validate();
                tuningView.pageIndicator.y =  tuningView.height - (tuningView.pageIndicator.height + 15);
            }
        }

        public function updateNotifications() :void{
            if(mainMenuView){
                mainMenuView.updateNotificationCount();
            }
        }

        protected function onPrevButtonHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART_BACK);
            var currentIndex:int = tuningListData.indexOf(_selectedTuning);
            if(currentIndex>0){
                attemptTuningSelect(tuningListData[currentIndex - 1]);
                // selectTuning(tuningListData[currentIndex - 1]);
            }
        }

        protected function onNextButtonHandler(event:Event):void {
            SoundManager.playSound(SoundManager.SELECT_PART);
            var currentIndex:int = tuningListData.indexOf(_selectedTuning);
            if(currentIndex<tuningListData.length-1){
                attemptTuningSelect(tuningListData[currentIndex + 1]);
                //selectTuning(tuningListData[currentIndex + 1]);
            }
        }

        private function updateNavigationButtons():void{
            var currentIndex:int = -1;
            if(tuningListData && tuningListData.length && _selectedTuning) {
                currentIndex = tuningListData.indexOf(_selectedTuning);
            }
            if(_nextButton){
                if(tuningListData && currentIndex >= tuningListData.length-1){
                    _nextButton.isEnabled = false;
                    Image(_nextButton.defaultSkin).color = 0x000000;
                }else{
                    _nextButton.isEnabled = true;
                    Image(_nextButton.defaultSkin).color = 0xFF0000;
                }
                _nextButton.parent.setChildIndex(_nextButton, _nextButton.parent.numChildren - 1);
            }

            if(_prevButton){
                if(currentIndex <= 0){
                    _prevButton.isEnabled = false;
                    Image(_prevButton.defaultSkin).color = 0x000000;
                }else{
                    _prevButton.isEnabled = true;
                    Image(_prevButton.defaultSkin).color = 0xFF0000;
                }
                _prevButton.parent.setChildIndex(_prevButton, _prevButton.parent.numChildren - 1);
            }
        }

        public function loadTuningList(tunings:Array, user:User, num:int):void{
            _selectedUser = user;
            if((_currentUser && _selectedUser && _selectedUser.id != _currentUser.id) || !_currentUser){
                Constants.selectedUser = _selectedUser;
            }else{
                Constants.selectedUser = null;
            }
            tuningListData = tunings.concat();
            var allCarsList:Object = PackagesParser.allCarsList;
            if(!allCarsList){
                return;
            }
            for(var i:int = tuningListData.length - 1; i >= 0; i--){
                if(tuningListData[i]) {
                    tuningListData[i] = TuningsProxy.parseTuning(tuningListData[i], true);
                    if (tuningListData[i].car && allCarsList[tuningListData[i].car.id]) {
                        tuningListData[i].car = allCarsList[tuningListData[i].car.id];
                    }
                    if(_backgroundsMap && tuningListData[i].backgroundId && !_backgroundsMap.hasOwnProperty(tuningListData[i].backgroundId)){
                        _backgroundsMap = null;
                    }
                }else{
                    tuningListData.removeAt(i);
                }
            }
            attemptTuningSelect(tuningListData[0]);
        }

        private function selectTuning(tuning:Tuning):void{
            _selectedTuning = tuning;
            _selectedTuning.backgroundsMap = _backgroundsMap;
            if(isInitialized) {
                _snapshots = getTuningSnapshots(_selectedTuning);
                tuningView ||= new TuningItemRenderer();
                if(!tuningView.hasEventListener(TouchEvent.TOUCH, tuningTouchEventHandler)){
                    tuningView.addEventListener(TouchEvent.TOUCH, tuningTouchEventHandler)
                }
                tuningView.clipBackground = false;
                tuningView.fitContent = true;
                tuningView.indicatorMargin = 5;
                tuningView.data = tuning;
                /*tuningView.width = actualWidth - USER_MENU_WIDTH;
                tuningView.height = actualHeight - BannerStackedScreen.BANNER_SIZE;*/
                tuningView.setSize(actualWidth - USER_MENU_WIDTH, actualHeight - BannerStackedScreen.BANNER_SIZE);
                tuningView.x = USER_MENU_WIDTH;
                tuningView.y = BannerStackedScreen.BANNER_SIZE - 1;
                if(!_container.contains(tuningView)) {
                    _container.addChildAt(tuningView, 0);
                }
                invalidate(INVALIDATION_FLAG_SIZE);
            }else{
                Starling.juggler.delayCall(function ():void {
                    selectTuning(tuning);
                }, 0.1);
            }
            if(_selectedTuning && _selectedTuning.stats){
                _winLabel.text = "x" + _selectedTuning.stats.challangeWins.toString();
            }else{
                _winLabel.text = " ";
            }
            _winLabel.validate();
            _winLabel.x = _winIcon.x + _winIcon.width + 2;
            _winLabel.y = _winIcon.y + (_winIcon.height - _winLabel.height)/2;
        }

        override protected function feathersControl_addedToStageHandler(event:Event):void{
            super .feathersControl_addedToStageHandler(event);
            Starling.juggler.delayCall(BannerStackedScreen.showAdBanner, 1);
            //
            if(isInitialized && Device.isIphoneXVariant()){
                stage.starling.nativeStage.removeEventListener(StageOrientationEvent.ORIENTATION_CHANGE, stageOrientationChangeHandler);
                stage.starling.nativeStage.addEventListener(StageOrientationEvent.ORIENTATION_CHANGE, stageOrientationChangeHandler);
                setNavButtonPosition();
            }
            //
            if(tuningView){
                tuningView.setSize(stage.stageWidth - USER_MENU_WIDTH, stage.stageHeight - BannerStackedScreen.BANNER_SIZE);
                tuningView.x = USER_MENU_WIDTH;
                tuningView.y = BannerStackedScreen.BANNER_SIZE;
                tuningView.validate();
                updatePageIndicatorPosition();
            }

            if(_nextButton){
                _prevButton.parent.setChildIndex(_prevButton, _prevButton.parent.numChildren - 1);
                _nextButton.parent.setChildIndex(_nextButton, _nextButton.parent.numChildren - 1);
            }
        }

        override protected function feathersControl_removedFromStageHandler(event:Event):void{
            super .feathersControl_removedFromStageHandler(event);
            stage.starling.nativeStage.removeEventListener(StageOrientationEvent.ORIENTATION_CHANGE, stageOrientationChangeHandler);
        }

        private function stageOrientationChangeHandler(event:StageOrientationEvent):void {
            setNavButtonPosition();
            redrawAfterOrientationChange();
            invalidate();
        }

        private function setOrientationMargins():void{
            var marginSize:Number = 24;
            if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_RIGHT){
                _leftMargin = marginSize;
            }else if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_LEFT){
                _leftMargin = 0;
            }else{
                _leftMargin = 0;
            }
            USER_MENU_WIDTH = 220 + _leftMargin;
        }

        private function redrawAfterOrientationChange():void{
            toolbarBackground.width = USER_MENU_WIDTH;
            _userList.setSize(USER_MENU_WIDTH, actualHeight - BannerStackedScreen.BANNER_SIZE - BannerStackedScreen.TOOLBAR_SIZE);

            for(var i:int = 0; i < _userList.dataProvider.length; i++){
                var renderer:ChallengeLeaderBoardItemRenderer = _userList.itemToItemRenderer(_userList.dataProvider.getItemAt(i)) as ChallengeLeaderBoardItemRenderer;
                if(renderer){
                    renderer.paddingLeft = _leftMargin;
                    renderer.validate();
                }
            }

            _countryButton.width = USER_MENU_WIDTH / 2 - 10;
            _worldButton.width = USER_MENU_WIDTH / 2 - 10;

            regionDropDown.width = USER_MENU_WIDTH / 2;
            regionDropDown.x = USER_MENU_WIDTH - regionDropDown.width;
            _showByButton.width = USER_MENU_WIDTH / 2;

            _border1.width = USER_MENU_WIDTH / 2 - 10;
            _border2.x = USER_MENU_WIDTH / 2;
            _border3.x = USER_MENU_WIDTH - _border3.width;
            _loadBar.setSize(USER_MENU_WIDTH, _userList.height);
            _winIcon.x = USER_MENU_WIDTH + 5;

            tuningView.setSize(stage.stageWidth - USER_MENU_WIDTH, stage.stageHeight - BannerStackedScreen.BANNER_SIZE);
            tuningView.x = USER_MENU_WIDTH;

            updatePageIndicatorPosition();
        }

        public function setNavButtonPosition():void{
            if(!stage){
                return;
            }
            var marginSize:Number = 24;
            if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_RIGHT){
                _nextButton.x = stage.stageWidth - _nextButton.width / 2;
                _leftMargin = marginSize;
            }else if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_LEFT){
                _nextButton.x = stage.stageWidth - _nextButton.width / 2 - marginSize;
                _leftMargin = 0;
            }else{
                _nextButton.x = stage.stageWidth - _nextButton.width / 2 - marginSize;
                _leftMargin = 0;
            }
            _nextButton.y = (actualHeight + BannerStackedScreen.BANNER_SIZE)/2;
            USER_MENU_WIDTH = 220 + _leftMargin;
        }

        private function tuningTouchEventHandler(event:TouchEvent):void {
            var touch:Touch = event.getTouch(tuningView, TouchPhase.ENDED);
            if(touch && !tuningView.isScrolling){
                dispatchEventWith(StackedScreen.TUNING_SELECTED, false, {tuning:tuningView.tuning, user: _selectedUser});
            }
        }
        
        private function attemptTuningSelect(tuning:Tuning):void{
            if(tuning.backgroundId && tuning.backgroundId.indexOf("http") != -1){
                selectTuning(tuning);
            }else{
                dispatchEvent(new Event(LOAD_TUNING_BACKGROUNDS, false, {tuning: tuning}));
            }
        }

        public function handleTuningBackgroundsLoaded(tuning:Tuning) : void {
            selectTuning(tuning);
        }

        public function handleCarBackgroundsLoaded(carBackgrounds : Array) : void {
            var background:CarBackground;
            _backgroundsMap = {};
            for(var i:int=0; i < carBackgrounds.length; i++){
                background = carBackgrounds[i];
                _backgroundsMap[background.id] = background;
            }
            selectTuning(_selectedTuning);
        }

        private static function getTuningSnapshots(tuning:Tuning):Array{
            return (tuning.fullHdSnapshots && tuning.fullHdSnapshots.length)?tuning.fullHdSnapshots:tuning.snapshots;
        }

    private function createShowBySection():void{
        _showByButton = ButtonFactory.createLeaderBoardRegionButton("gallery_clock", "showByTime", 0, true, false);
        _showByButton.label = "This week";
        addChild(_showByButton);
        _showByButton.width = USER_MENU_WIDTH / 2;
        _showByButton.validate();
        _showByButton.y = BannerStackedScreen.BANNER_SIZE + (BannerStackedScreen.TOOLBAR_SIZE - _showByButton.height) / 2;

        showByBorderList = [];
        var border:Quad;
        showByLabel = {};
        showByLabel[RequestPeriod.THIS_WEEK] = "This week";
        showByLabel[RequestPeriod.THIS_MONTH] = "This month";
        showByLabel[RequestPeriod.THIS_YEAR] = "This year";
        showByLabel[RequestPeriod.ALL] = "Show all";

        _showByButton.addEventListener(Event.CHANGE, showByChangeHandler);
        border = createBorder();
        showByBorderList.push(border);
        border.height = _showByButton.defaultSkin.height;

        border = createBorder();
        showByBorderList.push(border);
        border.height = _showByButton.defaultSkin.height;

        showByMenu = new Sprite();
        var menuBackground:Image = new Image(ButtonFactory.assetManager.getTexture("menu_background"));
        menuBackground.scale9Grid = new Rectangle(menuBackground.width/3, menuBackground.height/3, menuBackground.width/3, menuBackground.height/3);
        menuBackground.width = _showByButton.width;
        menuBackground.height = 190;
        menuBackground.filter = new DropShadowFilter(2, Math.PI/4, 0, 0.2);
        menuBackground.y = -1;

        var menuTopBorder:Quad = new Quad( 1, 1, 0xFFFFFF);
        menuTopBorder.width = menuBackground.width - 2;
        menuTopBorder.height = 5;
        menuTopBorder.x = 1;
        menuTopBorder.y = -2;

        showByMenu.addChild(menuBackground);
        showByMenu.addChild(menuTopBorder);

        showByGroup = new LayoutGroup();
        var layout:VerticalLayout = new VerticalLayout();
        layout.gap = 5;
        layout.paddingLeft = layout.paddingRight = 5;
        layout.paddingTop = 6;
        showByGroup.layout = layout;
        showByToggleGroup = new ToggleGroup();

        var radio:Radio;
        _period = RequestPeriod.THIS_WEEK;

        radio = createRadio(showByLabel[RequestPeriod.THIS_WEEK], RequestPeriod.THIS_WEEK);
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_WEEK){
            showByToggleGroup.selectedItem = radio;
        }

        radio = createRadio(showByLabel[RequestPeriod.THIS_MONTH], RequestPeriod.THIS_MONTH);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_MONTH){
            showByToggleGroup.selectedItem = radio;
        }

        radio = createRadio(showByLabel[RequestPeriod.THIS_YEAR], RequestPeriod.THIS_YEAR);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_YEAR){
            showByToggleGroup.selectedItem = radio;
        }


        radio = createRadio(showByLabel[RequestPeriod.ALL], RequestPeriod.ALL);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.ALL){
            showByToggleGroup.selectedItem = radio;
        }

        showByGroup.validate();
        menuBackground.height = showByGroup.height + 5;

        showByMenu.addChild(showByGroup);
        addChild(showByMenu);
        showByMenu.visible = false;
        showByToggleGroup.addEventListener(Event.CHANGE, showByGroupChangeHandler);
    }

    private function showByGroupChangeHandler(event:Event):void {
        _period = showByToggleGroup.selectedItem.name;
        _showByButton.label = showByLabel[_period];
        showByMenu.visible = _showByButton.isSelected = false;

        _userList.removeEventListener(Event.CHANGE, selectionChangeHandler);
        _userList.dataProvider.removeAll();
        isLoaded = isLoading = false;
        _userList.addEventListener(Event.CHANGE, selectionChangeHandler);
        requestData();
    }

    private function showByChangeHandler(event:Event):void {
        regionDropDown.isSelected = false;

        showByMenu.x = _showByButton.x;
        showByMenu.y = BannerStackedScreen.BANNER_SIZE + BannerStackedScreen.TOOLBAR_SIZE;
        showByMenu.parent.setChildIndex(showByMenu, showByMenu.parent.numChildren-1);
        showByMenu.visible = _showByButton.isSelected;
        if(_showByButton.isSelected){
            SoundManager.playSound(SoundManager.PART_MENU);
        }else{
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
        }
    }

    private function regionButtonChangeHandler(event:Event):void {
        _showByButton.isSelected = false;

        regionMenu.x = regionDropDown.x;
        regionMenu.y = BannerStackedScreen.BANNER_SIZE + BannerStackedScreen.TOOLBAR_SIZE - 2;
        regionMenu.parent.setChildIndex(regionMenu, regionMenu.parent.numChildren-1);
        regionMenu.visible = regionDropDown.isSelected;
        if(regionDropDown.isSelected){
            SoundManager.playSound(SoundManager.PART_MENU);
        }else{
            SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
        }
    }

    private static function createBorder():Quad{
        var border:Quad = new Quad(1, 1, 0xCCCCCC);
        border.width = 1;
        return border;
    }

    private static function createRadioBorder():Quad{
        var border:Quad = new Quad(1, 1, 0xCCCCCC);
        border.height = 1;
        border.width = 85;
        return border;
    }

    private static function createRadio(label:String, value:String):Radio{
        var radio:Radio = new Radio();
        var defaultIcon:Image = new Image(ButtonFactory.assetManager.getTexture("gallery_radio_default"));
        defaultIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        defaultIcon.color = 0x888888;

        var selectedIcon:Image = new Image(ButtonFactory.assetManager.getTexture("gallery_radio_selected"));
        selectedIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        selectedIcon.color = 0x026edc;

        radio.defaultIcon = defaultIcon;
        radio.defaultSelectedIcon = selectedIcon;
        radio.labelFactory = GalleryLabelFactory.showByRadioDefaultLabel;
        radio.labelOffsetX = 5;
        radio.iconOffsetY = 1;
        radio.label = label;
        radio.name = value;
        radio.paddingTop = -2;
        radio.paddingBottom = 2;
        return radio;
    }

    public function loadData(data:Array):void {
        if(!data){
            return;
        }
        isLoaded = (data.length < _requestCount);
        for(var i:int = data.length-1;  i >= 0; i--){
            data[i].user = new User(data[i].user);
            if(_userIdList.hasOwnProperty(data[i].user.id)){

            }else{
                _userIdList[data[i].user.id] = true;
            }
        }
        var scrollToBottom:Boolean = false;
        if(_userList.dataProvider){
            scrollToBottom = _userList.dataProvider.length>0;
            _userList.dataProvider.addAll(new ListCollection(data));
        }else{
            _userList.dataProvider = new ListCollection(data);
        }
        if(scrollToBottom){
            _userList.removeEventListener(Event.SCROLL, listScrollHandler);
            _userList.scrollToPosition(0, _userList.maxVerticalScrollPosition + _userList.pageHeight, 1);
            Starling.juggler.delayCall(function ():void {
                _userList.addEventListener(Event.SCROLL, listScrollHandler);
            }, 0.01);
        }
        if(_loadBar){
            _loadBar.removeFromParent();
        }
        isLoading = false;
        if(!scrollToBottom){
            _playSound = false;
            _userList.selectedIndex = 0;
            _playSound = true;
        }
    }

    private function scrollCompleteHandler(event:Event):void{
        _userList.removeEventListener(FeathersEventType.SCROLL_COMPLETE, scrollCompleteHandler);
        Starling.juggler.delayCall(function ():void {
            _userList.addEventListener(Event.SCROLL, listScrollHandler);
        }, 0.1);
    }

    private function menuOpenHandler(event:Event):void {
        BannerStackedScreen.hideAdBanner(false);
    }

    private function menuCloseHandler(event:Event):void {
        BannerStackedScreen.showAdBanner();
    }

    override public function dispose():void{
        super .dispose();
        if(_mainMenuView) {
            _mainMenuView.removeFromParent(true);
            _mainMenuView = null;
        }
        if(menuButton) {
            menuButton.removeFromParent(true);
            menuButton = null;
        }

        if(_background) {
            _background.removeFromParent(true);
            _background = null;
        }

        if(_bannerBackground) {
            _bannerBackground.removeFromParent(true);
            _bannerBackground = null;
        }
    }

    public function get selectedLanguage():Language {
        return _language;
    }

    public function set selectedLanguage(value:Language):void {
        _language = value;
    }

    public function updateWithLanguage(language:Language):void {
        _language = language;

        AlertView.language = language;
        CustomAlertView.language = language;
        AlertViewHL.language = language;

        if (mainMenuView){
            mainMenuView.updateWithLanguage(language);
        }
    }

        public function dispatchExternalEvent(msg:String):void {
            if (mainMenuView) {
                mainMenuView.hide();
            }
            dispatchEventWith(msg);
        }

    public function get mainMenuView():MainMenuView {
        return _mainMenuView;
    }

    public function set mainMenuView(value : MainMenuView) :void {
        _mainMenuView = value;
        _mainMenuView.owner = this;
    }

    public function brandsScreenButtonTriggeredHandler(event:Event = null):void{
        dispatchEventWith(StackedScreen.BRANDS_SELECTED);
    }

    public function homeButtonTriggeredHandler(event:Event = null):void {
        dispatchEventWith(StackedScreen.HOME_SELECTED);
    }

    public function enterRowsState():void {
    }

    public function get languages():Array {
        return [];
    }
    }
}
import feathers.core.FeathersControl;

class LeaderBoardContainer extends FeathersControl{
    public function LeaderBoardContainer(){
        super ();
    }
}