package com.despark.tuning3d.view.components.core
{
	import com.despark.tuning3d.view.components.brands.PartInfoPopUp;
	
	import feathers.core.FeathersControl;
	
	import starling.animation.Transitions;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.EnterFrameEvent;
	import starling.textures.Texture;
	
	public class BlockerView extends FeathersControl
	{
		
		private var quad:Quad=null;
		private var spinner:Sprite=null;
		
		public function BlockerView()
		{
			super();
			
			
			
			
		}
		
		public function hide():void{
			
			this.removeFromParent(true);
		}
		
		public static function show():BlockerView
		{
			
			
			
			
			var blockerView : BlockerView = new BlockerView();
			
			
			blockerView.width =Starling.current.stage.width;
			
			blockerView.height=Starling.current.stage.height;
			
			Starling.current.stage.addChild(blockerView);
			
			blockerView.alpha=0;
			
			var tween : Tween = new Tween(blockerView, 0.35, Transitions.EASE_IN_OUT);
			tween.fadeTo(1.0);
			Starling.juggler.add(tween);
			
		
			
			
			return blockerView;
		}
		
		private function enterFrameHandler(event : EnterFrameEvent) : void
		{
			
			if(spinner && spinner.visible){
				
				spinner.rotation+=0.2;  
			}
			
		}
		
		public function addImage(image:Image):void{
			
			addChildAt(image, getChildIndex(quad)+1);
		}
		
		
		protected override function initialize():void{

			super.initialize();
			
			quad=new Quad(1,1,0x000000);
			quad.alpha=0.30;
			addChild(quad);
			
			
			spinner=new Sprite();
			//spinner.visible=true;
			var spinnerTexture:Texture=ButtonFactory.assetManager.getTexture("spinner");
			var spinnerImage:Image=new Image(spinnerTexture);
			spinnerImage.width=40;
			spinnerImage.height=40;
			spinnerImage.x=-20;  
			spinnerImage.y=-20;  
			spinner.addChild(spinnerImage);
			addChild(spinner); 
			
			addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
			
		}
		
		protected override function draw():void{

			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			
			if(sizeInvalid){
				
				quad.x=0;
				quad.y=0;
				quad.width=actualWidth;
				quad.height=actualHeight;
				
				spinner.x=actualWidth/2;
				spinner.y=actualHeight/2;
				
			}
		}
		
		
	}
}