package com.despark.tuning3d.view.components.core
{	
	//import com.despark.tuning3d.view.components.core.CustomAlertView;

import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.utils.FontSelector;

import feathers.core.FeathersControl;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
import starling.events.Touch;
import starling.events.TouchEvent;
import starling.events.TouchPhase;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class CustomAlertView extends FeathersControl implements Multilingual
	{
		public static const MIN_HEIGHT : int = 100;
		public static var assetManager : AssetManager;
		public static var language : Language;
		public var finishAlert : Boolean;
		
		private var titleOfButton1 : String;
		private var titleOfButton2 : String;
		private var titleOfButton3 : String;
		
		public var resultHandler1 : Function;
		public var resultHandler2 : Function;
		public var resultHandler3 : Function;
		
		private var backgroundImage:Image;
		private var label : MultilingualLabel;
		private var _text : String;
		
		private var button1 : MultilingualButton;//yesButton
		private var button2 : MultilingualButton;//closeButton
		private var button3 : MultilingualButton;
		
		
		
		private var dismissingView : Quad;
		
		public function CustomAlertView()
		{
			super();
		}
		
		public function get text():String
		{
			return _text;
		}

		public function set text(value:String):void
		{
			_text = value;
			invalidate("text");
		}
		
		public function updateWithLanguage(language :Language) : void
		{
			label.updateWithLanguage(language);
		}

		protected override function initialize() : void
		{
			super.initialize();
			
			
			
			var backgroundTexture : Texture = assetManager.getTexture("popUpBackground");
			//	var backgroundTextures : Scale9Textures = new Scale9Textures(backgroundTexture, new Rectangle(24, 22, 11, 7));
			
			backgroundImage = new Image(backgroundTexture);
			backgroundImage.scale9Grid = new Rectangle(24, 22, 11, 7);
			backgroundImage.alpha =  1.0;
			addChild(backgroundImage);	
			
			label = new MultilingualLabel();
			label.textFormat = new TextFormat(FontSelector.getFont(),  10, 0xFFFFFF );
			label.textFormat.align = TextFormatAlign.CENTER;
			label.wordWrap = true;
			addChild(label);
			
			if(titleOfButton1){//button1
				//button1 = ButtonFactory.defaultButton(CustomAlertView.language.translate("mob_signup", "yes").toUpperCase(), 0xED3F25);
				button1 = ButtonFactory.defaultButton(titleOfButton1, 0xED3F25);
				button1.updateWithLanguage(CustomAlertView.language);
				button1.addEventListener(Event.TRIGGERED, button1TriggeredHandler);
				addChild(button1);
			}
			
			if(titleOfButton2){//button1
				//button1 = ButtonFactory.defaultButton(CustomAlertView.language.translate("mob_signup", "yes").toUpperCase(), 0xED3F25);
				button2 = ButtonFactory.defaultButton(titleOfButton2, 0xB2BDC1);
				button2.updateWithLanguage(CustomAlertView.language);
				button2.addEventListener(Event.TRIGGERED, button2TriggeredHandler);
				addChild(button2);
			}
			
			if(titleOfButton3){//button1
				//button1 = ButtonFactory.defaultButton(CustomAlertView.language.translate("mob_signup", "yes").toUpperCase(), 0xED3F25);
				button3 = ButtonFactory.defaultButton(titleOfButton3, 0xB2BDC1);
				button3.updateWithLanguage(CustomAlertView.language);
				button3.addEventListener(Event.TRIGGERED, button3TriggeredHandler);
				addChild(button3);
			}
			
			
			
			dismissingView = new Quad(stage.stageWidth, stage.stageHeight, 0xFF0000);
			dismissingView.alpha = 0.0;
			dismissingView.addEventListener(TouchEvent.TOUCH, dismissingViewTouchHandler);
			stage.addChildAt(dismissingView, stage.getChildIndex(this));
		}
		
		private function dismissingViewTouchHandler(event : TouchEvent) : void
		{
			var touch : Touch = event.getTouch(dismissingView);
			
			if(touch && touch.phase == TouchPhase.ENDED)
			{
				hide();
			}
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid("text"))
			{
				if(CustomAlertView.language)
				{
					label.updateWithLanguage(CustomAlertView.language);
				}
				else 
				{
					var l:Language = new Language(null);
					l.code = "en-US";
					label.updateWithLanguage(l);
				}
				
				label.text = text;
			}
			
			var autoSizeNeeded : Boolean = autoSizeIfNeeded();
			
			if(autoSizeNeeded || isInvalid(INVALIDATION_FLAG_SIZE))
			{
				var temp : int = 0;
				
				if(finishAlert){
					temp = 2000;
				}
				
				backgroundImage.width = actualWidth + temp;
				backgroundImage.height = actualHeight + temp;
				
				backgroundImage.x = -temp/2;
				backgroundImage.y = -temp/2;
				
				label.x = 15;
				label.width = actualWidth - 30;
				label.y = 15;

				// UGLY FIX FOR AIR TEXT MEASURING PROBLEMS
				if(CustomAlertView.language && label.text == CustomAlertView.language.translate("mob_alertsAndOverlays", "savedToCameraRoll")) {
					label.y = 20;
				}
				label.validate();
				height = label.height + 60;
				var  numberOfButtons : int = 0;
				
				if(button1)numberOfButtons ++;
				if(button2)numberOfButtons ++;
				if(button3)numberOfButtons ++;
				
				if(numberOfButtons > 0)
				{
					button1.y = actualHeight - button1.height - 10;
					var leftRightOffset : int = 10;
					var offsetBetweenOfButtons : int = 10;
					var widthOfButton : int = (actualWidth - 2* leftRightOffset + offsetBetweenOfButtons)/numberOfButtons - offsetBetweenOfButtons;
					
					var currentX: int = leftRightOffset;
					{
						button1.width = widthOfButton;
						button1.x = currentX;
						currentX += widthOfButton + offsetBetweenOfButtons;
					}
					
					if(button2){
						button2.width = widthOfButton;
						button2.x = currentX;
						button2.y = button1.y;
						
						currentX += widthOfButton + offsetBetweenOfButtons;
					}
				
					if(button3){
						button3.width = widthOfButton;
						button3.x = currentX;
						button3.y = button1.y;
						
						currentX += widthOfButton + offsetBetweenOfButtons;
					}
					
					
				}
				
				x = (stage.stageWidth - actualWidth) / 2;
				y = (stage.stageHeight - actualHeight) / 2;
			}
		}
		
		protected function autoSizeIfNeeded() : Boolean
		{
			var needsHeight : Boolean = isNaN(explicitHeight);
			
			if(!needsHeight)
			{
				return false;
			}
			
			var newWidth : Number = explicitWidth;// + 300;
			
			label.width = newWidth;
			label.height = NaN;
			label.validate();
			
			var newHeight : Number = explicitHeight;
			
			if(needsHeight)
			{
				newHeight = 20 +  Math.ceil(label.height) +30;// 10 + button1.height + 20;
			}
			
						
			return setSizeInternal(newWidth, newHeight, false);
		}
		
		
		public function hide() : void
		{
			if(!this.finishAlert)
			CustomAlertView.hideAlertView(this);
		}
		
		public static function show( text : String, titleOfButton1 : String , titleOfButton2 : String , 
									 titleOfButton3 : String , resultHandler1 : Function = null, 
									 resultHandler2 : Function = null, resultHandler3 : Function = null, 
									 hideTimeout : Number = -1.0, __finishAlert : Boolean = false) : CustomAlertView
		{
			var alertView : CustomAlertView = new CustomAlertView();
			alertView.finishAlert = __finishAlert;
			alertView.text = text;
			alertView.width =  250;
			alertView.alpha = 0.0;
			alertView.titleOfButton1 = titleOfButton1;
			alertView.titleOfButton2 = titleOfButton2;
			alertView.titleOfButton3 = titleOfButton3;
			alertView.resultHandler1 = resultHandler1;
			alertView.resultHandler2 = resultHandler2;
			alertView.resultHandler3 = resultHandler3;
			alertView.touchable = true;
			
			Starling.current.stage.addChild(alertView);
			
			var tween : Tween = new Tween(alertView, 0.35, Transitions.EASE_IN_OUT);
			tween.fadeTo(1.0);
			Starling.juggler.add(tween);
			
			if(hideTimeout > 0)
			{
				Starling.juggler.delayCall(function() : void
				{
					hideAlertView(alertView);
				}, hideTimeout);
			}
			
			return alertView;
		}
		
		public static function hideAlertView(alertView : CustomAlertView) : void
		{
			if(alertView.button1)
			{
				alertView.button1.visible = false;
			}
			
			if(alertView.button2)
			{
				alertView.button2.visible = false;
			}
			
			if(alertView.button3)
			{
				alertView.button3.visible = false;
			}
			
			var tween : Tween = new Tween(alertView, 0.35, Transitions.EASE_IN_OUT);
			tween.fadeTo(0.0);
			tween.onComplete = function() : void
			{
				Starling.current.stage.removeChild(alertView);
				Starling.current.stage.removeChild(alertView.dismissingView);
			}
			Starling.juggler.add(tween);
		}
		
		
		
		private function button1TriggeredHandler(event : Event) : void
		{
			SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			hide();
			
			if(resultHandler1)
			{
				resultHandler1(true);
			}
		}
		
		private function button2TriggeredHandler(event : Event) : void
		{
			
			hide();
			
			if(resultHandler2)
			{
				resultHandler2(true);
			}
		}
		
		private function button3TriggeredHandler(event : Event) : void
		{
			hide();
			
			if(resultHandler3)
			{
				resultHandler3(true);
			}
		}
	}
}