package com.despark.tuning3d.view.components.core
{

import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.core.http.URLLoaderObjects;
import com.despark.tuning3d.model.core.images.BitmapDataUtil;
import com.despark.tuning3d.model.core.images.ImageCacher;
import com.despark.tuning3d.model.core.images.PersistentImageProvider;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.parts.PartMaterialImage;
    import com.despark.tuning3d.model.parts.PartSlotDisk;
    import com.despark.tuning3d.view.components.cars.CarView;
import com.utils.BitmapDataUtils;
import com.utils.DisplayObjectUtil;
import com.utils.ImageUtils;

import feathers.controls.ImageLoader;
import feathers.core.FeathersControl;

import fl.motion.Color;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.BitmapDataChannel;
import flash.display.Loader;
import flash.display.LoaderInfo;
import flash.events.ErrorEvent;
import flash.events.Event;
import flash.events.HTTPStatusEvent;
import flash.events.IOErrorEvent;
import flash.events.SecurityErrorEvent;
import flash.filesystem.File;
import flash.geom.Matrix;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.net.URLLoader;
import flash.net.URLLoaderDataFormat;
import flash.net.URLRequest;
import flash.utils.ByteArray;
import flash.utils.getTimer;
import flash.utils.setTimeout;

import starling.core.Starling;
import starling.display.DisplayObject;
import starling.events.Event;
import starling.filters.ColorMatrixFilter;
import starling.textures.Texture;
import starling.utils.MatrixUtil;
import starling.utils.ScaleMode;

public class ImageLoaderWithStates extends ImageLoader
{
    public static var disposeWhenRemovedFromStage : Boolean = true;
    public static var openedLoaderCount:int=0;

    // if zip won't be downloaded until this amount of time, load from url
    public static var ZIP_ERROR_REPORT_TIME : int = 30;

    private static const HELPER_MATRIX:Matrix = new Matrix();
    private static const HELPER_POINT:Point = new Point();

    private var downStateTexture : Texture;
    private var _selected : Boolean;
    private var _persistentImageProvider : PersistentImageProvider;
    private var _manualCacheURL : String;

    private var imageCacher : ImageCacher;
    //public var b : BitmapData;
    private var brightnessFilter :ColorMatrixFilter;
    private var lastBrightness : Number;
    private var _loader : URLLoader;
    private var imageBytes : ByteArray;

    public var newColor: uint;
    public var newColor_b: Boolean = false;

    public var hasStates : Boolean;
    public var overrideDispose : Boolean = false;
    public var completed : Boolean;

    public var completeHandler : Function;
    public var recieveImageSize:Function;
    public var recieveImageSize2:Function;
    public var errorHandler : Function;
    public var errorHandler2 : Function;
    public var textureCommitedHandler : Function;
    public var layerIndex : int;
    public var frameIndex : int;
    public var angelIndex:int;

    public var startManually : Boolean;

    public var kx:Number;
    public var ky:Number;
    public var ax:Number;
    public var ay:Number;
    public var logToFile : Boolean = false;
    public var hideImageBeforeLoading : Boolean;
    public var forceReload : Boolean=false;
    private var pendingX : Number = NaN;
    private var pendingY : Number = NaN;
    public var disalowCleanupMemory:Boolean = false;
    public var ignorePendingCoordinates : Boolean;
    private static var maxCountLoader:int=10;
    public var carPart:Boolean=false;
    private var _firstLoad:Boolean=true;
    private var _imageDispatchBlocker:Boolean=false;
    public var isSplashImage:Boolean = false;
    private var _updateFilterFlag:Boolean=false;
    private var isUrlLoaderStarted:Boolean=false;
    public static var urlLoaderFull:Boolean=false;

    public var skipZip:Boolean = false;
    private var _cropOnLoadCoefficient : Number = 0;
    //
    /*private var _textureVector:Vector.<Texture>;
    private var _bitmapDataVector:Vector.<BitmapData>;
    private var _loaderVector:Vector.<ImageLoaderWithStates>;*/
    //
    public function ImageLoaderWithStates(){
        maxCountLoader=100;
        hideImageBeforeLoading = true;
        super();
        startManually = false;
        /*_bitmapDataVector = new Vector.<BitmapData>();
        _textureVector = new Vector.<Texture>();
        _loaderVector = new Vector.<ImageLoaderWithStates>();*/
        addEventListener(starling.events.Event.REMOVED_FROM_STAGE, removedFromStageHandler);
    }

    public function updateFilter(brightness:Number) : void {
        if(!persistentImageProvider){
            return;
        }

        if(!image){
            return;
        }

        if(brightness < 1.0){
            if (brightnessFilter) {
                brightnessFilter.dispose();
                brightnessFilter = null;
            }
            if(!brightnessFilter) {
                brightnessFilter = new ColorMatrixFilter();
            }
            brightnessFilter.reset();
            brightnessFilter.adjustBrightness(Math.min(brightness - 0.8, 0));
            brightnessFilter.cache();
            image.filter = brightnessFilter;
        }else{
            if (brightnessFilter){
                brightnessFilter.dispose();
                brightnessFilter = null;
                image.filter = null;
            }
        }
    }

    protected function onGlobalEventMemLeakTest(event:*):void{
    }

    public function set antimaskBitmapDataActuale(value:Boolean):void{

        _antimaskBitmapDataActuale = value;
    }

    public override function set x(value : Number) : void {

        try{
            if(ignorePendingCoordinates || isNaN(pendingX) || hideImageBeforeLoading) {
                super.x = value;
            }

            pendingX = value;
        }catch(e:Error){
            Tracer.print(e.getStackTrace());
        }

        _antimaskBitmapDataActuale = false;

        this.dispatchEventWith("change_pos");
        //if(!_imageDispatchBlocker)
        //dispatchEventWith("image_change", true);
    }

    public override function set y(value : Number) : void {
        try{
            if(ignorePendingCoordinates || isNaN(pendingY) || hideImageBeforeLoading) {
                super.y = value;
            }

            pendingY = value;

        }catch(e:Error){
            Tracer.print(e.getStackTrace());
        }

        _antimaskBitmapDataActuale = false;

        this.dispatchEventWith("change_pos");
        //if(!_imageDispatchBlocker)
        //dispatchEventWith("image_change", true);
    }

    /*public function set image(value:Image):void{

    this.image=value;
    }

    public function get  image():Image{

    return this.image//_image;
    }*/


    /*public function set maskAsTexture(value:Texture):void{

    textureMask=value;
    var maskImage:Image=new Image(textureMask);
    mask=maskImage;
    }
    */

    override public function set source(value:Object):void
    {
        /*if(SnapShotFramesContainer.LOCK_SNAPSHOT)
        return;*/

        if(this._source == value && !forceReload)
        {
            return;
        }
        if(this._isInTextureQueue)
        {
            this.removeFromTextureQueue();
        }

        this._source = value;

        //this.cleanupTexture();

        if(hideImageBeforeLoading) {
            hideImage();
        }

        this._lastURL = null;

        if(this._source is Texture)
        {
            this._isLoaded = true;
        }
        else
        {

            this._isLoaded = false;
        }

        this.invalidate(INVALIDATION_FLAG_DATA);
    }

    override protected function commitData():void
    {
        try{
            if(this._source is Texture)
            {
                this._lastURL = null;
                this._texture = Texture(this._source);
                this.refreshCurrentTexture();
                this._isLoaded = true;
            }
            else
            {
                const sourceURL:String = this._source as String;
                if(!sourceURL && !(source is ByteArray))
                {
                    this._lastURL = sourceURL;
                    this.refreshCurrentTexture();
                    return;
                }

                if(sourceURL && (sourceURL == this._lastURL))
                {
                    //if it's not loaded yet, we'll come back later
                    if(this._isLoaded)
                    {
                        this.refreshCurrentTexture();
                    }
                }
                else
                {
                    this._lastURL = sourceURL;

                    if(this.loader)
                    {
                        this.loader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, loader_completeHandler);
                        this.loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loader_errorHandler);
                        this.loader.contentLoaderInfo.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, loader_errorHandler);
                        try
                        {
                            // PARTLY FIXED :: LOADING TIME ????
                            if (this.loader.contentLoaderInfo.parameters) {
                                this.loader.close();
                            }
                        }
                        catch(error:Error) {

                            //Tracer.print(error.getStackTrace());
                            //trace("error:", error.message/*, error.getStackTrace()*/);
                            /*
                            error:1:
                            Error #2029: This URLStream object does not have a stream opened.
                            Error #2029: This URLStream object does not have a stream opened.
                            at flash.display::Loader/_close()
                            at flash.display::Loader/close()
                            at com.despark.tuning3d.view.components.core::ImageLoaderWithStates/commitData()
                            */
                        }
                    }
                    else {
                        this.loader = new Loader();
                    }
                    this.loader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, loader_completeHandler);
                    this.loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loader_errorHandler);
                    this.loader.contentLoaderInfo.addEventListener(SecurityErrorEvent.SECURITY_ERROR, loader_errorHandler);

                    if(source is ByteArray) {

                        /*var loaderContext:LoaderContext=new LoaderContext();
                        loaderContext.imageDecodingPolicy=ImageDecodingPolicy.ON_LOAD;*/
                        if(ByteArray(source).length) {
                            this.loader.loadBytes(ByteArray(source), LOADER_CONTEXT_2);
                        }
                        this._source = null;
                    }
                    else
                    {
                        var r:URLRequest = new URLRequest(sourceURL);
                        r.idleTimeout = 1000 * 60 * 60;
                        this.loader.load(r, LOADER_CONTEXT);
                    }
                }
            }
        }catch(e:Error){
            Tracer.print("error:", e.getStackTrace()/*, e.getStackTrace()*/);
        }


    }


    public function hideImage() : void {

        try{
            this.cleanupTexture();
        }catch(e:Error){

            Tracer.print(e.getStackTrace());
        }

        if(this.image)
        {
            this.image.visible = false;
        }

        //if(!_imageDispatchBlocker)
        //dispatchEventWith("image_change", true);
    }


    private var _scaleMode : String = ScaleMode.SHOW_ALL;

    public function get scaleMode() : String
    {
        return _scaleMode;
    }

    public function set scaleMode(value : String) : void
    {
        if(this._scaleMode == value)
        {
            return;
        }

        this._scaleMode = value;
        this.invalidate(INVALIDATION_FLAG_LAYOUT);
    }

    public var bitmapScale : Number;
    private function scaleBitmapData(bigBMD : BitmapData, scale : Number) : BitmapData
    {
        //trace("scaleBitmapData");
        var matrix:Matrix = new Matrix();
        matrix.scale(scale, scale);

        var smallBMD:BitmapData = new BitmapData(bigBMD.width * scale, bigBMD.height * scale, true, 0x000000);
        smallBMD.draw(bigBMD, matrix, null, null, null, true);

        return smallBMD;
    }

    override public  function set alpha(value:Number):void{

        super.alpha=value;

        //if(!_imageDispatchBlocker)
        //dispatchEventWith("image_change", true);
    }

    private function removedFromStageHandler(event : starling.events.Event) : void
    {

        //trace("removedFromStageHandler");

        if(disposeWhenRemovedFromStage && !overrideDispose  )
        {
            this.removeEventListener(starling.events.Event.REMOVED_FROM_STAGE, removedFromStageHandler);
            dispose();
        }

        //if(!_imageDispatchBlocker)
        //dispatchEventWith("image_change", true);
    }

    /*private function addedToStageHandler(event:starling.events.Event):void{
        this.addEventListener(starling.events.Event.REMOVED_FROM_STAGE, removedFromStageHandler);

    }*/

    public function set persistentImageProvider(value : PersistentImageProvider) : void
    {
        if (carPart)
        {
            //if(value){
            //	trace("set persistentImageProvider:", value.remoteUrl);
            //}
            if((this._persistentImageProvider!=value) || (value && _persistentImageProvider && value.remoteUrl!=_persistentImageProvider.remoteUrl) ){

                //trace("set persistentImageProvider2 ")
                _firstLoad=true;
                this.loadingFlag=true;
                this.errorFlag=false;
                this.cleanupFlag = false;

                if(_persistentImageProvider && _persistentImageProvider.localFile!=null){
                    var localFile: File = File.applicationStorageDirectory.resolvePath(_persistentImageProvider.localFile.replace("Cars/", "CarsBmp/").replace(".png", ".bmp"));

                    if(localFile.exists) localFile.deleteFile();

                    _fileSave = false;
                    if(this._textureBitmapData){
                        if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
                        _cacheInMemory = false;

                        this._textureBitmapData.dispose();
                        this._textureBitmapData=null;
                    }
                }

                _antimaskBitmapDataActuale = false;

                if(_antimasks){
                    for(var i:int=0; i<_antimasks.length; i++){
                        var image:ImageLoaderWithStates = _antimasks[i];
                        image.removeEventListener("change_pos", onChangePos);
                    }
                }

                this._antimasks = null;

                if(_maskTextureBitmapData){
                    _maskTextureBitmapData.dispose();
                    _maskTextureBitmapData=null;
                }

                updatePersistentImageProvider(value);

            }

        }else{

            updatePersistentImageProvider(value);
        }
    }

    public var cleanupFlag:Boolean=false;
    public var loadingFlag:Boolean=true;

    public var errorFlag:Boolean=false;

    //private var bitmapFileId:String;

    private var saveWidth:Number=0;
    private var saveHeight:Number=0;

    //private var testCleanUpTest:Boolean = false;

    private static var countSaveFiles:int=0;

    public static var carPartCacheInMemory:Number = 0;
    private var _cacheInMemory:Boolean = false;

    private var _strictAspectRatio : Number = 0;


    override protected function cleanupTexture():void{


        if(angelIndex==CarView.locAngleIndex && frameIndex==CarView.locCurrentFrame && carPart){

        }else{

            super.cleanupTexture();

        }
    }

    public function cleanupMemory(force:Boolean=false):void{
        if(!this.carPart) return;

        if(disalowCleanupMemory) return;

        if(
                CarView.locAngleIndex==this.angelIndex && CarView.locCurrentFrame==this.frameIndex
        ){
            //cacheMem = true;
            if(_textureBitmapData){
                if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = true;
            }
            return;
        }

        if(filter){
            filter.dispose();
            filter = null;
        }

        //var specFlag:Boolean= false;
        //Удаляем текстуру
        myCleanupTexture();

        if(_texture){

            _texture.dispose();
            _texture = null;
        }

        if(_textureBitmapData){

            saveWidth = _textureBitmapData.width;
            saveHeight = _textureBitmapData.height;

        }

        var cacheMem:Boolean = false;


        if(!Device.isIos()){

            if((carPartCacheInMemory/1024/1024)<Constants.TOTAL_MEMORY*Constants.RAM_MEMORY_RATIO_ANDROID){


                if(CarView.locAngleIndex==this.angelIndex)
                    cacheMem = true;
            }

        }else{
            if((carPartCacheInMemory/1024/1024)<Constants.TOTAL_MEMORY*Constants.RAM_MEMORY_RATIO_IOS) {

                if(CarView.locAngleIndex==this.angelIndex )
                    cacheMem = true
            };
        }


        cleanupFlag=true;


        //setTimeout(function():void{
        if(!cacheMem){
            cacheToFile();
        }else{


            if(_textureBitmapData){
                if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = true;
            }else{
                cacheToMemory();
            }
        }
    }


    public function get currentTexture():Texture{
        return _currentTexture;
    }

    private function cacheToMemory():void{
        if(!carPart) return;
        if(!_persistentImageProvider) return;
        if(_manualCacheURL) return;
        if(_textureBitmapData) {
            if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
            _cacheInMemory = true;
            return;
        }
        myCleanupTexture();
        if(filter){
            filter.dispose();
            filter = null;
        }
        var localFile: File = File.applicationStorageDirectory.resolvePath(_persistentImageProvider.localFile.replace("Cars/", "CarsBmp/").replace(".png", ".bmp"));
        if(localFile.exists){
            _textureBitmapData = BitmapDataUtils.loadFromDisk(localFile, saveWidth, saveHeight);
            if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
            _cacheInMemory = true;
        }else{
            if(_textureBitmapData) {
                if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = false;
                _textureBitmapData.dispose();
                _textureBitmapData = null;
            }
            this.delayLoad();
        }
    }


    private var _fileSave:Boolean =false;
    private function cacheToFile():void{
        if(!carPart) return;
        if(!_persistentImageProvider) return;
        if(!_textureBitmapData) return;
        if(_manualCacheURL) return;
        if(carPart){
            var partMaterialImage:PartMaterialImage = _persistentImageProvider as PartMaterialImage;
            if(partMaterialImage.parentMaterial && partMaterialImage.parentMaterial.parentPart && partMaterialImage.parentMaterial.parentPart.parentSlot.name.indexOf("mask")==0){
                return;
            }
        }

        saveWidth = _textureBitmapData.width;
        saveHeight = _textureBitmapData.height;

        if(!_fileSave){
            var localFile: File = File.applicationStorageDirectory.resolvePath(_persistentImageProvider.localFile.replace("Cars/", "CarsBmp/").replace(".png", ".bmp"));
            if(BitmapDataUtils.saveToDisk(localFile,  _textureBitmapData)){
                _fileSave = true;
                if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = false;
                _textureBitmapData.dispose();
                _textureBitmapData = null;
            }else{
                Tracer.print("ERROR SAVE");
                if(localFile.exists) try {
                    localFile.deleteFileAsync();

                }catch(e: Error){}
                if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = true;
            }
        }else{

            _fileSave = true;
            if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
            _cacheInMemory = false;

            _textureBitmapData.dispose();
            _textureBitmapData = null;

        }
    }

    public function loadFromCache(toMem:Boolean=false):void{

        if(!this.carPart) return;
        if(toMem){
            cacheToMemory();
            if(image ){



                var flag:Boolean = true;

                if(CarView.locAngleIndex==this.angelIndex && CarView.locCurrentFrame==this.frameIndex) flag = false;

                //if(CarView.locAngleIndex==this.angelIndex && CarView.locNext1Frame==this.frameIndex) flag = false;

                //if(CarView.locAngleIndex==this.angelIndex && CarView.locPrev1Frame==this.frameIndex) flag = false;



                if(flag){

                    myCleanupTexture();


                }

            }

            //if( CarView.locAngleIndex!=this.angelIndex && CarView.locCurrentFrame!=this.frameIndex)

            return;
        }


        if(this._firstLoad) {

            /*if(_textureBitmapData){

            _textureBitmapData.dispose();
            _textureBitmapData = null;



            }*/

            myCleanupTexture();

        }

        if(!image){


            ///this.cleanupTexture();

            loadingFlag=true;


            if(_textureBitmapData ){

                //Tracer.print("load from mem:"+this.angelIndex)

                if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory = true;


                loadingFlag=false;
                completed = true;
                cleanupFlag = false;
                _imageDispatchBlocker = true;
                replaceTextureFromSuperModForce(_textureBitmapData);
                layout();
                validate();
                _imageDispatchBlocker = false;

            }else{

                //Tracer.print("load from file:"+this.angelIndex)
                cacheToMemory();

                if(_textureBitmapData){

                    if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
                    _cacheInMemory = true;

                    loadingFlag=false;
                    completed = true;
                    cleanupFlag = false;
                    _imageDispatchBlocker = true;
                    replaceTextureFromSuperModForce(_textureBitmapData);
                    layout();
                    validate();
                    _imageDispatchBlocker = false;
                }

                //this.delayLoad();
            }

        }else{

            loadingFlag=false;
            completed = true;
            cleanupFlag = false;
            //layout();
            //validate();
        }

        //Tracer.print("carPartCacheInMemory:"+ (carPartCacheInMemory/1024/1024));
    }

    private function updatePersistentImageProvider(value : PersistentImageProvider) : void {
        if(!value || (_persistentImageProvider && _persistentImageProvider.remoteUrl == value.remoteUrl && isUrlLoaderStarted))
            return;
        _persistentImageProvider = value;
        hideImageBeforeLoading = !_persistentImageProvider.isEncrypted;
        if(startManually && !forceReload) {
            return;
        }

        loadingFlag=true;
        _manualCacheURL =  getManualCacheURL(_persistentImageProvider.remoteUrl);
        trace('Start Loading image Car' + _persistentImageProvider.remoteUrl);
        startLoading();
    }


    private function myCleanupTexture():void{

        if(this.angelIndex==CarView.locAngleIndex && this.frameIndex==CarView.locCurrentFrame){

            //trace("myCleanupTexture");
            /*try{
                var t:Object
                t.p=1;
            }catch(e:Error){
                trace("error:", e.getStackTrace())
            }*/
        }

        if(image){


            if(this._currentTexture){

                this._currentTexture.dispose();
                this._currentTexture=null;
            }

            image.removeFromParent(false);

            if(image.texture){
                image.texture.dispose();
            }
            image=null;

        }
    }

    private function closeURLLoader() : void {

        if(_loader){
            try{
                _loader.removeEventListener(IOErrorEvent.IO_ERROR, urlLoaderErrrorHandler);
                _loader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderErrrorHandler);
                _loader.removeEventListener(flash.events.Event.COMPLETE, urlLoaderCompleteHandler);
                if(Constants.LogToFile){
                    _loader.removeEventListener(HTTPStatusEvent.HTTP_RESPONSE_STATUS, urlLoaderHttpStatusHandler);
                }
                openedLoaderCount--;
                if(openedLoaderCount<=0){
                    openedLoaderCount=0;
                    urlLoaderFull=false;
                }
                isUrlLoaderStarted=false;
                _loader.data=null;
                _loader.close();
            }
            catch(error : Error){
                //Tracer.print(error.getStackTrace());
                //Logger.e("closeURLLoader error:"+error.message+" stack:"+error.getStackTrace(), this);
                //trace("error:", error.message, error.getStackTrace());
            }
            URLLoaderObjects.getInstance().releaseLoader(_loader);
            _loader = null;
        }
        imageBytes = null;
    }

    public var hideImageBeforeLoadingOverload:Boolean=false;

    public function startLoading(reload:Boolean = false) : void{
        loadingFlag=true;
        errorFlag=false;
        if(reload){
            isUrlLoaderStarted = false;
        }
        var alreadySetRemoteSource : Boolean = false;
        if(!_persistentImageProvider || !_persistentImageProvider.remoteUrl){
            errorFlag=true;
            return;
        }
        var localFile: File = File.cacheDirectory.resolvePath(_persistentImageProvider.localFile);
        localFile.preventBackup = true;
        var fileExist : Boolean = localFile.exists;
        if(fileExist){
            if(source == _persistentImageProvider.remoteUrl || source == localFile.url ){
                alreadySetRemoteSource = true;
            }
        }

        if(!alreadySetRemoteSource || forceReload){
            closeURLLoader();
            if(hideImageBeforeLoadingOverload){
                hideImageBeforeLoading=false;
            }
            if(hideImageBeforeLoading){
                hideImage();
            }
            delayLoad();
        }else{
            if(completeHandler){
                completeHandler(this);
            }
        }
    }
    /**
     *
     * @param fromByteArray
     * @param timeWaitedForZip indicates the amount of time, that already have been waited for zip
     */
    private function delayLoad(fromByteArray:Boolean=false, timeWaitedForZip : int = 0):void{

        if(!_persistentImageProvider)
        {
            return;
        }

        if(!isUrlLoaderStarted && !urlLoaderFull){
            var request : URLRequest;
            var skipZipLoad:Boolean = CarView.CAR_FULL_LOADED && frameIndex == CarView.locCurrentFrame && angelIndex == CarView.locAngleIndex;

            //if(!skipZipLoad && SKIP_ZIP)  skipZipLoad = true;

            var loadFromUrl:Boolean = true;//skipZipLoad;

            if (this.carPart && ZipManager.getInctance().useForThisCar && !skipZip) {
                loadFromUrl = false;
                var file:File=File.cacheDirectory.resolvePath(_persistentImageProvider.localFile);
                if(!fromByteArray && file.exists){
                    _loader = URLLoaderObjects.getInstance().takeLoader();
                    _loader.dataFormat = URLLoaderDataFormat.BINARY;
                    _loader.addEventListener(flash.events.Event.COMPLETE, urlLoaderCompleteHandler);
                    _loader.addEventListener(IOErrorEvent.IO_ERROR, urlLoaderErrrorHandler);
                    _loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderErrrorHandler);

                    if(Constants.LogToFile){
                        _loader.addEventListener(HTTPStatusEvent.HTTP_RESPONSE_STATUS, urlLoaderHttpStatusHandler);
                    }

                    timeOfStartRequest = getTimer();
                    request = new URLRequest(realSource);
                    request.idleTimeout = Constants.IMAGE_REQUESTS_TIMEOUT;
                    isUrlLoaderStarted=true;
                    openedLoaderCount++;
                    if(openedLoaderCount>=maxCountLoader){
                        urlLoaderFull=true;
                    }
                    _loader.load(request);

                }else{

                    var url:String = _persistentImageProvider.remoteUrl.replace(Constants.IMAGES_URL, "");
                    var data:Object = ZipManager.getInctance().getFileDataByPath(url);
                    var fileData:ByteArray = null;
                    if(data.content && !data.error){
                        fileData = data.content;
                    }else if(data.error){

                        loadFromUrl = true;
                    }
                    //trace("url:", url)
                    if(fileData){
                        isUrlLoaderStarted=true;
                        imageBytes = fileData;//TuningScreenMediator.ImagesBytesList[realSource];
                        this.loadTheBitmap();
                    }else if(!loadFromUrl){

                        if(timeWaitedForZip > ZIP_ERROR_REPORT_TIME*1000 )
                        {
//								var carProxy : CarsProxy = ApplicationFacade.getInstance().retrieveProxy(CarsProxy.NAME) as CarsProxy;
//								carProxy.sendZipErrorData(url);
                            loadFromUrl = true;
                            Tracer.print('Error5 download Url ' + url);
                        }
                        else {
                            setTimeout(delayLoad, 200, true, timeWaitedForZip + 200);
                        }
                    }
                }
            }


            if(loadFromUrl){

                _loader = URLLoaderObjects.getInstance().takeLoader();
                //urlLoader.
                _loader.dataFormat = URLLoaderDataFormat.BINARY;
                _loader.addEventListener(flash.events.Event.COMPLETE, urlLoaderCompleteHandler);
                _loader.addEventListener(IOErrorEvent.IO_ERROR, urlLoaderErrrorHandler);
                _loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderErrrorHandler);

                if(Constants.LogToFile){
                    _loader.addEventListener(HTTPStatusEvent.HTTP_RESPONSE_STATUS, urlLoaderHttpStatusHandler);
                }

                timeOfStartRequest = getTimer();
                request = new URLRequest(realSource);
                request.idleTimeout = Constants.IMAGE_REQUESTS_TIMEOUT;
                isUrlLoaderStarted=true;
                openedLoaderCount++;
                if(openedLoaderCount>=maxCountLoader){
                    urlLoaderFull=true;
                }
                _loader.load(request);

            }

        }else if(!isUrlLoaderStarted){
            setTimeout(delayLoad, 10);
        }
    }

    private var timeOfStartRequest : Number;

    private function urlLoaderHttpStatusHandler(event : HTTPStatusEvent) : void
    {
    }


    private function urlLoaderCompleteHandler(event : flash.events.Event) : void
    {
        var data:*=_loader.data;
        closeURLLoader();
        performBytesAfterDownloading(data);
    }

    public function performBytesAfterDownloading(__imageBytes : ByteArray, __filename : String = null, __savedFile : Boolean = false): void
    {
        try	{
            imageBytes = __imageBytes;
            if(!__savedFile){
                saveImageBytesIfNeccessary();
            }

            if(this._persistentImageProvider.isEncrypted)
            {
                BitmapDataUtil.decryptImageBytes(imageBytes, persistentImageProvider.remoteUrl,__filename);
            }

            loadTheBitmap();

        }catch(e:Error){

            errorFlag=true;
            loadingFlag=false;

            Tracer.print(e.getStackTrace());
        }
    }

    private function saveImageBytesIfNeccessary() : void
    {
        var localFile: File = File.cacheDirectory.resolvePath(persistentImageProvider.localFile);
        localFile.preventBackup = true;
        if(!localFile.exists && !_manualCacheURL)
        {
            BitmapDataUtil.saveImageBytes(imageBytes, localFile);
        }
    }

    private function urlLoaderErrrorHandler(event : ErrorEvent) : void {
        var localFile: File = File.cacheDirectory.resolvePath(_persistentImageProvider.localFile);
        var localCopy:File = new File(localFile.nativePath);
        if(localCopy.exists){
            try{
                localCopy.deleteFile();
                startLoading(true);
            }catch (e:Error) {
                if(e is SecurityError){
                    Starling.juggler.delayCall(function ():void {
                        try{
                            localCopy.deleteFile();
                            startLoading(true);
                        }catch (e:Error) {

                        }
                    }, .1);
                }
            }
            return;
        }

        trace("urlLoaderErrrorHandler");
        errorFlag=true;
        loadingFlag=false;

        closeURLLoader();

        if(persistentImageProvider){
            Tracer.print('error download image:', persistentImageProvider.remoteUrl);
        }
        if(errorHandler)
        {
            errorHandler();
        }

        if(errorHandler2){

            errorHandler2(this);
        }
    }

    private function get realSource() : String
    {
        var realSource : String = null;

        if(!_persistentImageProvider)
            return "";


        var localFile: File = File.cacheDirectory.resolvePath(_persistentImageProvider.localFile);
        localFile.preventBackup = true;


        if(_manualCacheURL){
            realSource = _manualCacheURL;
        }
        else if(localFile.exists){
            realSource = localFile.url;
        }
        else{
            realSource = _persistentImageProvider.remoteUrl;
        }
        return realSource;
    }

    private function getManualCacheURL(url: String) : String{
        if(url == null) return null;
        url = url.split('com')[1];
        var file : File = File.applicationDirectory.resolvePath(Constants.MANUAL_CACHE_PATH + url);
        if(file.exists && !file.isDirectory)
            return file.url;
        else
            return null;
    }


    private function loadTheBitmap() : void
    {
        super.source = imageBytes != null ? imageBytes : realSource;
        imageBytes = null;
    }


    public function get persistentImageProvider() : PersistentImageProvider
    {
        return _persistentImageProvider;
    }

    protected override function loader_errorHandler(event:ErrorEvent):void {
        if(!loader){
            return;
        }
        super.loader_errorHandler(event);

        if(this.persistentImageProvider){
            Tracer.print("isEncryptedL " + persistentImageProvider.isEncrypted);
            Tracer.print("persistentImageProvider:" + persistentImageProvider.remoteUrl);
        }

        if(errorHandler)
        {
            errorHandler();
        }

        if(errorHandler2)
        {
            errorHandler2(this);
        }
    }

    private var _maskTextureBitmapData:BitmapData = null;
    private var _antimasks:Array = null;
    private var _antimaskBitmapDataActuale:Boolean=false;

    public function addAntimask(image:ImageLoaderWithStates):void{

        if(!_antimasks) _antimasks=[];

        if(_antimasks.indexOf(image)<0){
            _antimasks.push(image);
            _antimaskBitmapDataActuale = false;
        }
    }

    public function removeAntimask(image:ImageLoaderWithStates):void{

        if(!_antimasks) return;

        if(_antimasks.indexOf(image)>=0){
            Tracer.print("remove antimask");
            _antimasks.splice(_antimasks.indexOf(image),1);
        }

    }

    public function get textureBitmapData():BitmapData{
        return _textureBitmapData;
    }

    private function onChangePos(event:starling.events.Event):void{
        _antimaskBitmapDataActuale = false;
    }

    public function clearAntimask():void{

        if(!_antimasks) return;
        if(_antimasks.length<=0) return;
        _antimasks = [];
        _antimaskBitmapDataActuale = false;
    }

    public function applayAntimask():void{
        var i:int;
        if(_antimaskBitmapDataActuale) return;
        if(!_antimasks) return;
        if(_antimasks.length<=0) return;

        var image:ImageLoaderWithStates;
        for(i = 0; i<_antimasks.length; i++){

            image = _antimasks[i];
            if(!image.textureBitmapData){

                return;
            }

        }

        if(!_maskTextureBitmapData) _maskTextureBitmapData = _textureBitmapData.clone();

        var newMaskTextureBitmapData:BitmapData = new BitmapData(_maskTextureBitmapData.width,_maskTextureBitmapData.height, true, 0xffffffff);
        newMaskTextureBitmapData.draw(_maskTextureBitmapData);
        newMaskTextureBitmapData.copyChannel(newMaskTextureBitmapData, newMaskTextureBitmapData.rect, new Point(), BitmapDataChannel.BLUE, BitmapDataChannel.ALPHA);
        var maskDX:Number = x;
        var maskDY:Number = y;
        var complete:Boolean = false;

        for(i = 0; i<_antimasks.length; i++){

            image = _antimasks[i];
            image.removeEventListener("change_pos", onChangePos);
            image.addEventListener("change_pos", onChangePos);

            var matrix:Matrix = new Matrix();
            matrix.translate((image.x-maskDX)*2, (image.y-maskDY)*2);

            if(image.textureBitmapData){
                newMaskTextureBitmapData.draw(image.textureBitmapData, matrix,null, null, newMaskTextureBitmapData.rect,true);
            }else{
                complete = false;
            }
        }



        var bitmapData:BitmapData = new BitmapData(newMaskTextureBitmapData.width, newMaskTextureBitmapData.height, true, 0x000000);
        bitmapData.copyChannel(newMaskTextureBitmapData, newMaskTextureBitmapData.rect, new Point(), BitmapDataChannel.ALPHA, BitmapDataChannel.ALPHA);
        newMaskTextureBitmapData.fillRect(newMaskTextureBitmapData.rect, 0xffffffff);
        newMaskTextureBitmapData.draw(bitmapData);
        bitmapData.fillRect(bitmapData.rect, 0xff000000);
        bitmapData.copyChannel(newMaskTextureBitmapData, newMaskTextureBitmapData.rect, new Point(), BitmapDataChannel.BLUE, BitmapDataChannel.ALPHA);

        newMaskTextureBitmapData.dispose();
        newMaskTextureBitmapData=null;

        _textureBitmapData.dispose();
        _textureBitmapData = bitmapData;

        loadingFlag=false;
        completed = true;
        cleanupFlag = false;
        _imageDispatchBlocker = true;
        replaceTextureFromSuperModForce(_textureBitmapData);
        layout();
        validate();
        _imageDispatchBlocker = false;
        _antimaskBitmapDataActuale = true;
    }


    override protected function loader_completeHandler(event:flash.events.Event):void
    {
        completed = true;
        var currentLoader:Loader = LoaderInfo(event.currentTarget).loader;
        var bitmap:Bitmap = Bitmap(currentLoader.content);

        if(_strictAspectRatio > 0)
        {
            var newWidth : int = bitmap.width;
            var newHeight : int = bitmap.height;
            var currentAspect : Number =newWidth / newHeight;

            if(currentAspect > _strictAspectRatio)
            {
                newWidth =  _strictAspectRatio*newHeight;
            }
            else {
                newHeight = newWidth / _strictAspectRatio;
            }
            var cX : int = (bitmap.width - newWidth)/2;
            var cY : int = (bitmap.height - newHeight)/2;
            bitmap = ImageUtils.cropBMP(bitmap, cX,cY , bitmap.width - 2*cX, bitmap.height- 2*cY );
        }else if(_cropOnLoadCoefficient > 0 && _cropOnLoadCoefficient < .5) // crop the image with the given coefficient/percentage
        {
            var w :Number = bitmap.width;
            var h :Number = bitmap.height;
            bitmap = ImageUtils.cropBMP(bitmap,w*_cropOnLoadCoefficient, h*_cropOnLoadCoefficient, w * (1-2*_cropOnLoadCoefficient), h * (1-2*_cropOnLoadCoefficient));
        }


        var bmp_width:Number=bitmap.width;
        var bmp_height:Number=bitmap.height;

        currentLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, loader_completeHandler);
        currentLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loader_errorHandler);
        currentLoader.contentLoaderInfo.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, loader_errorHandler);

        try{

            currentLoader.close();
        }catch(e:Error){
        }

        try{
            currentLoader.unload();
        }catch(e:Error){

            //Tracer.print(e.getStackTrace());
        }
        this.loader = currentLoader = null;







        if(!bitmap)
            return;


        var bitmapData:BitmapData = bitmap.bitmapData;

        updateFilterNew(bitmapData);

        if(_firstLoad && this.carPart){

            myCleanupTexture();

            if(_textureBitmapData){

                if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
                _cacheInMemory=false;

                _textureBitmapData.dispose();
                _textureBitmapData = null;


            }

            //trace("skip:", this.angelIndex);

            if(this.newColor_b){
                this.color = this.newColor;
                this.newColor_b = false;
            }


            if(this.filter){

                this.filter.dispose();
                this.filter=null;
            }




            this._textureBitmapData = bitmapData;

            if(!_cacheInMemory) carPartCacheInMemory+=_textureBitmapData.width*_textureBitmapData.height*4;
            _cacheInMemory = true;

            //var bmp_width:Number = this._textureBitmapData.width;
            //var bmpt_height:Number = this._textureBitmapData.height;

            if(this.angelIndex != CarView.locAngleIndex){

                this.cacheToFile();

            }




            //if(!_firstLoadCleanupBlocker){
            //cleanupMemory();
            //}
            this.cleanupFlag=true;
            this.loadingFlag=false;
            this.errorFlag=false;

            if(this.angelIndex == CarView.locAngleIndex && this.frameIndex==CarView.locCurrentFrame){

                loadFromCache();
            }


            _firstLoad=false;

            if(recieveImageSize)
            {
                try{
                    recieveImageSize(bmp_width, bmp_height);
                    recieveImageSize=null;




                }catch(e:Error){

                    Tracer.print("Error:"+e.getStackTrace());
                }
            }

            if(recieveImageSize2)
            {
                try{
                    recieveImageSize2(bmp_width, bmp_height, this);
                    recieveImageSize2=null;




                }catch(e:Error){

                    Tracer.print("Error:"+e.getStackTrace());
                }
            }

            if(completeHandler)
                completeHandler(this);

            isUrlLoaderStarted=false;

            return;

        }

        if(this.carPart && !_firstLoad){
            this.cleanupTexture();
        }else if(!this.carPart){
            this.cleanupTexture();
        }

        if(bitmapScale < 1) {
            var oldBitmapData:BitmapData = bitmapData;
            bitmapData = scaleBitmapData(bitmapData, bitmapScale);
            oldBitmapData.dispose();
        }
        else {
            //bitmapData = bitmap.bitmapData;
        }

        bitmap=null;


        if(carPart){
            if(!_cacheInMemory) carPartCacheInMemory+=bitmapData.width*bitmapData.height*4;
            _cacheInMemory = true;
        }


        if(this._delayTextureCreation)
        {
            //trace("_delayTextureCreation");
            this._pendingBitmapDataTexture = bitmapData;
            if(this._textureQueueDuration < Number.POSITIVE_INFINITY)
            {
                this.addToTextureQueue();
            }
        }
        else
        {
            //trace("replaceBitmapDataTexture");



            this.replaceBitmapDataTexture(bitmapData);
        }

        var that:ImageLoaderWithStates=this;
        //Starling.juggler.delayCall(function():void{

        if(recieveImageSize)
        {
            try{
                recieveImageSize(bmp_width, bmp_height);
                recieveImageSize=null;




            }catch(e:Error){

                Tracer.print("Error:"+e.getStackTrace());
            }
        }

        if(recieveImageSize2)
        {
            try{
                recieveImageSize2(bmp_width, bmp_height, that);
                recieveImageSize2=null;




            }catch(e:Error){

                Tracer.print("Error:"+e.getStackTrace());
            }
        }


        if(carPart && _firstLoad){

            _firstLoad=false;

            if(!_firstLoadCleanupBlocker){
                cleanupMemory();
            }


        }

        if(completeHandler)
        {
            try{
                completeHandler(that);
            }catch(e:Error){
                //completeHandler(that);
                trace("error:", e.getStackTrace());
            }
            //completeHandler = null;
        }




        isUrlLoaderStarted=false;

        dispatchEventWith("complete_load", true);
        //}, 0.01);



        //dispatchEventWith("image_change", true);
    }

    private var _firstLoadCleanupBlocker:Boolean=false;

    public function set firstLoadCleanupBlocker(value:Boolean):void{

        _firstLoadCleanupBlocker=value;
    }


    public function get firstLoad():Boolean{

        return _firstLoad;
    }




    override protected function replaceBitmapDataTexture(bitmapData : BitmapData) : void {
        if(!hasStates){
            try	{
                replaceTextureFromSuperMod(bitmapData);
            }
            catch(error : Error) {
                Tracer.print("error:", error.message, error.getStackTrace());
            }
        }else{
            replaceTextureUsingStates(bitmapData);
        }
        this.verifyCurrentStarling();
    }

    protected function replaceTextureFromSuperModForce(bitmapData:BitmapData):void
    {
        if(this.newColor_b){
            this.color = this.newColor;
            this.newColor_b = false;
        }

        myCleanupTexture();
        if(_texture){
            _texture.dispose();
            _texture=null;
        }

        /*if(_bitmapDataVector.indexOf(bitmapData)==-1) {
            _bitmapDataVector.push(bitmapData);
        }*/
        this._texture = Texture.fromBitmapData(bitmapData, false, false);
        if(!persistentImageProvider) {
            this._textureBitmapData = bitmapData;
        }else{
            if(carPart){
                this._textureBitmapData=bitmapData;
            }else{
                if(!Device.isIos())
                    bitmapData.dispose();
            }
        }
        this._isTextureOwner = true;
        this.commitData();
        if(!this._isLoaded){
            this.invalidate(INVALIDATION_FLAG_SIZE);
            this._isLoaded = true;
        }
    }

    protected function replaceTextureFromSuperMod(bitmapData:BitmapData):void {
        if(this.newColor_b){
            this.color = this.newColor;
            this.newColor_b = false;
        }
        if(_texture){
            _texture.dispose();
            _texture=null;
        }

        if(_currentTexture){
            _currentTexture.dispose();
            _currentTexture=null;
        }
        this._texture = Texture.fromBitmapData(bitmapData, false, false);
        if(!persistentImageProvider){
            this._textureBitmapData = bitmapData;
        }else{
            if(carPart){
                this._textureBitmapData=bitmapData;
            }else{
                bitmapData.dispose();
            }
        }

        if(!Device.isIos()){
            _texture.root.onRestore = function() : void {
                if(_textureBitmapData){
                    replaceTextureFromSuperMod(_textureBitmapData)
                }else{
                    if(carPart){
                        trace("restore carPart new shema");
                        var localFile: File;
                        if(_persistentImageProvider){
                            localFile = File.applicationStorageDirectory.resolvePath(_persistentImageProvider.localFile.replace("Cars/", "CarsBmp/").replace(".png", ".bmp"));
                        }
                        if(localFile && localFile.exists){
                            var tmpBitmapData:BitmapData = BitmapDataUtils.loadFromDisk(localFile, saveWidth, saveHeight);
                            /*if(_texture){
                                _textureVector.push(_texture);
                            }*/
                            _texture = Texture.fromBitmapData(tmpBitmapData, false, false);
                            tmpBitmapData.dispose();
                        }else{
                            var persistentProvider:PersistentImageProvider=persistentImageProvider;
                            _persistentImageProvider=null;
                            persistentImageProvider = persistentProvider;
                        }
                    }else{
                        forceReload = true;
                        updatePersistentImageProvider(persistentImageProvider);
                        forceReload = false;
                    }
                }
            }
        }
        this._isTextureOwner = true;
        this.commitData();
        if(!carPart)
            this.refreshCurrentTexture();
        this._isLoaded = true;
        this.invalidate(INVALIDATION_FLAG_SIZE);
        this.dispatchEventWith(starling.events.Event.COMPLETE);
        if(carPart)	{
            if(this.parent && 	this.parent.mask){
                this.parent.mask.removeFromParent(true);
                this.parent.mask = null;
            }
        }
    }

    override public function getBounds(targetSpace:DisplayObject, resultRect:Rectangle=null):Rectangle{
        if(this.carPart){
            if(!resultRect){
                resultRect = new Rectangle();
            }
            var imgWidth:Number=this.actualWidth;
            var imgHeight:Number= this.actualHeight;
            if(_textureBitmapData){
                imgWidth=_textureBitmapData.width*textureScale;
                imgHeight=_textureBitmapData.height*textureScale;
            }
            var minX:Number = Number.MAX_VALUE, maxX:Number = -Number.MAX_VALUE;
            var minY:Number = Number.MAX_VALUE, maxY:Number = -Number.MAX_VALUE;
            if (targetSpace == this){
                minX = 0;
                minY = 0;
                maxX = imgWidth;
                maxY = imgHeight;
            }else{
                this.getTransformationMatrix(targetSpace, HELPER_MATRIX);
                MatrixUtil.transformCoords(HELPER_MATRIX, 0, 0, HELPER_POINT);
                minX = minX < HELPER_POINT.x ? minX : HELPER_POINT.x;
                maxX = maxX > HELPER_POINT.x ? maxX : HELPER_POINT.x;
                minY = minY < HELPER_POINT.y ? minY : HELPER_POINT.y;
                maxY = maxY > HELPER_POINT.y ? maxY : HELPER_POINT.y;

                MatrixUtil.transformCoords(HELPER_MATRIX, 0,imgHeight, HELPER_POINT);
                minX = minX < HELPER_POINT.x ? minX : HELPER_POINT.x;
                maxX = maxX > HELPER_POINT.x ? maxX : HELPER_POINT.x;
                minY = minY < HELPER_POINT.y ? minY : HELPER_POINT.y;
                maxY = maxY > HELPER_POINT.y ? maxY : HELPER_POINT.y;

                MatrixUtil.transformCoords(HELPER_MATRIX, imgWidth, 0, HELPER_POINT);
                minX = minX < HELPER_POINT.x ? minX : HELPER_POINT.x;
                maxX = maxX > HELPER_POINT.x ? maxX : HELPER_POINT.x;
                minY = minY < HELPER_POINT.y ? minY : HELPER_POINT.y;
                maxY = maxY > HELPER_POINT.y ? maxY : HELPER_POINT.y;

                MatrixUtil.transformCoords(HELPER_MATRIX, imgWidth, imgHeight, HELPER_POINT);
                minX = minX < HELPER_POINT.x ? minX : HELPER_POINT.x;
                maxX = maxX > HELPER_POINT.x ? maxX : HELPER_POINT.x;
                minY = minY < HELPER_POINT.y ? minY : HELPER_POINT.y;
                maxY = maxY > HELPER_POINT.y ? maxY : HELPER_POINT.y;
            }

            resultRect.x = minX;
            resultRect.y = minY;
            resultRect.width  = maxX - minX;
            resultRect.height = maxY - minY;
            return resultRect;
        }else{
            return super.getBounds(targetSpace, resultRect);
        }
    }


    private function replaceTextureUsingStates(aBitmapData : BitmapData) : void{
        var halfHeight : int = aBitmapData.height / 2;
        var upStateBitmapData : BitmapData = new BitmapData(aBitmapData.width, halfHeight);
        upStateBitmapData.copyPixels(aBitmapData, new Rectangle(0, 0, aBitmapData.width, halfHeight), new Point(0, 0));
        replaceTextureFromSuperMod(upStateBitmapData);
        var downStateBitmapData : BitmapData = new BitmapData(aBitmapData.width, halfHeight);
        downStateBitmapData.copyPixels(aBitmapData, new Rectangle(0, halfHeight, aBitmapData.width, halfHeight), new Point(0, 0));
        downStateTexture = Texture.fromBitmapData(downStateBitmapData);
        invalidate(FeathersControl.INVALIDATION_FLAG_SELECTED);
    }

    override public function dispose() : void{
        if(filter){
            trace("FILTER DISPOSE");
            filter.dispose();
            filter = null;
        }
        if(_persistentImageProvider && _persistentImageProvider.localFile!=null){
            var localFile: File = File.applicationStorageDirectory.resolvePath(_persistentImageProvider.localFile.replace("Cars/", "CarsBmp/").replace(".png", ".bmp"));
            localFile.addEventListener(IOErrorEvent.IO_ERROR, onErrorDeleteFileAsync);
            localFile.addEventListener("complete", onCompleteDeleteFileAsync);
            if(localFile.exists) {
                if(localFile.exists) try {
                    localFile.deleteFileAsync();
                }catch(e: Error){}
            }
        }
        if(downStateTexture) {
            downStateTexture.dispose();
            downStateTexture = null;
        }

        if(brightnessFilter) {
            brightnessFilter.dispose();
            brightnessFilter = null;
        }
        if(_textureBitmapData){
            if(_cacheInMemory) carPartCacheInMemory-=_textureBitmapData.width*_textureBitmapData.height*4;
            _cacheInMemory=false;

            _textureBitmapData.dispose();
            _textureBitmapData=null;
        }
        if(imageCacher){
            imageCacher.cancel();
            imageCacher=null;
        }
        _persistentImageProvider=null;
        if(imageBytes){
            imageBytes.clear();
            imageBytes=null;
        }
        completeHandler=null;
        recieveImageSize=null;
        recieveImageSize2=null;
        errorHandler=null;
        errorHandler2=null;
        textureCommitedHandler=null;
        closeURLLoader();
        _antimaskBitmapDataActuale = false;
        if(_antimasks){
            for(var i:int=0; i<_antimasks.length; i++){
                var image:ImageLoaderWithStates = _antimasks[i];
                image.removeEventListener("change_pos", onChangePos);
            }
        }
        this._antimasks = null;
        if(_maskTextureBitmapData){
            _maskTextureBitmapData.dispose();
            _maskTextureBitmapData=null;
        }
        if(!carPart){
            if(_currentTexture){
                trace("_currentTexture dispose");
                _currentTexture.dispose();
                _currentTexture=null
            }
            if(_texture){
                trace("_texture dispose");
                _texture.dispose();
                _texture = null;
            }
        }
        super.dispose();
        if(_loader){
            _loader.removeEventListener(flash.events.Event.COMPLETE, urlLoaderCompleteHandler);
            _loader.removeEventListener(IOErrorEvent.IO_ERROR, urlLoaderErrrorHandler);
            _loader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoaderErrrorHandler);
            _loader = null;
        }
        DisplayObjectUtil.dispose(this, true, true);
    }

    public function sepcialDispose():void{
        if(_currentTexture){
            trace("_currentTexture dispose");
            _currentTexture.dispose();
            _currentTexture=null
        }
        if(_texture){
            trace("_texture dispose");
            _texture.dispose();
            _texture = null;
        }
    }

    private function onCompleteDeleteFileAsync(e:*):void{
        var localFile: File = e.target as File;
        localFile.removeEventListener("complete", onCompleteDeleteFileAsync);
    }

    private function onErrorDeleteFileAsync(event:IOErrorEvent):void{
        var localFile: File = event.target as File;
        localFile.removeEventListener(IOErrorEvent.IO_ERROR, onErrorDeleteFileAsync);
    }

    public function set selected(value : Boolean) : void {
        _selected = value;
        invalidate(FeathersControl.INVALIDATION_FLAG_SELECTED);
    }

    public function get selected() : Boolean {
        return _selected;
    }

    override protected function draw() : void {
        super.draw();
        var selectedInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SELECTED);
        if(selectedInvalid){
            commitSelected();
        }
    }

    protected function commitSelected() : void {
        if(!hasStates || !downStateTexture) {
            return;
        }
        if(selected){
            if(downStateTexture) {
                image.texture = downStateTexture;
            }
        }else{
            if(_texture){
                image.texture = _texture;
            }
        }
    }

    override public function hitTest(localPoint:Point):DisplayObject {
        if (persistentImageProvider && persistentImageProvider.ignoresTransparentPixelsOnTouch && _textureBitmapData && getBounds(this).containsPoint(localPoint)){
            try{
                var x : int = localPoint.x * (1.0 / textureScale);
                var y : int = localPoint.y * (1.0 / textureScale);
                return _textureBitmapData.hitTest(new Point(0, 0), 127, new Point(x, y)) ? this : null;
            }catch(e:Error){
                Tracer.print(e.getStackTrace());
                return null;
            }
        } else if(persistentImageProvider && !persistentImageProvider.touchable){
            return null;
        }
        return super.hitTest(localPoint);
    }

    override protected function refreshCurrentTexture() : void{
        super.refreshCurrentTexture();
        if(!hideImageBeforeLoading && !isNaN(pendingX) && !isNaN(pendingY)) {
            super.x = pendingX;
            super.y = pendingY;
        }
        if(textureCommitedHandler && _texture){
            textureCommitedHandler();
        }
        if(this._currentTexture && image){
            this.loadingFlag=false;
            this.cleanupFlag=false;
        }
    }

    private function updateFilterNew(bitmapData:BitmapData):void{

        if(!persistentImageProvider)
        {
            return;
        }

        if(!bitmapData){
            return;
        }

        //trace("persistentImageProvider.brightness:", persistentImageProvider.brightness)

        if(persistentImageProvider.brightness < 1.0)
        {

            //trace("updateFilterNew:", persistentImageProvider.brightness)

            var bd:BitmapData=bitmapData.clone();
            var bmp:Bitmap=new Bitmap(bd);

            var brightness:Number=Math.min(persistentImageProvider.brightness - 0.8, 0);


            var colorTint:Color=new Color();

            colorTint.setTint(0x000000, Math.abs(brightness))


            bitmapData.fillRect(bitmapData.rect, 0x00808080);
            bitmapData.draw(bmp, null, colorTint);


            bd.dispose();

            bmp=null;
            colorTint=null;


        }


    }
    //import fl.



    //		private var foregroundSpriteForCamera : flash.display.Sprite;

    private var completeDownloadBitmapData : Function = null;


    /*public function loadBitmapData(__fun_complete : Function = null) : void
    {
        //			foregroundSpriteForCamera = __foregroundSpriteForCamera;
        //			bitmapForCameraDownloaded = __bitmapForCameraDownloaded;
        if(completeDownloadBitmapData){
            Logger.e("neogidanno!!!!!!!", this);
        }else{
            completeDownloadBitmapData = __fun_complete;
        }


        if( _textureBitmapData)
        {



            if(completeDownloadBitmapData){
                Starling.juggler.delayCall(function(thisImage:ImageLoaderWithStates):void{
                    completeDownloadBitmapData();
                    completeDownloadBitmapData = null;
                },0.001, this);
            }
            //				drawIfNeedOnSprite();

            return;
        }

        var file: File = File.cacheDirectory.resolvePath( persistentImageProvider.localFile);
        file.preventBackup = true;



        if(file.exists)
        {
            imageCacher = new ImageCacher();
            imageCacher.decryptAndLoad = true;
            imageCacher.persistentImageProvider = persistentImageProvider;
            imageCacher.bitmapLoadedHandler = bitmapLoadedHandler;
            imageCacher.load();
        }
    }*/

    public var completeDownloadBitmapDataForDraw:Function=null;
    private var bmpDataForDraw:BitmapData=null;

    public function loadBitmapDataForDraw(__fun_complete : Function = null) : void
    {
        completeDownloadBitmapDataForDraw = __fun_complete;

        if(bmpDataForDraw || _textureBitmapData)
        {

            if(_textureBitmapData){

                if(completeDownloadBitmapDataForDraw){


                    Starling.juggler.delayCall(function(thisImage:ImageLoaderWithStates):void{
                        completeDownloadBitmapDataForDraw(thisImage, _textureBitmapData);
                        completeDownloadBitmapDataForDraw = null;
                    },0.01, this);
                }

            } else if(bmpDataForDraw){

                if(completeDownloadBitmapDataForDraw){
                    completeDownloadBitmapDataForDraw(this, bmpDataForDraw);
                    completeDownloadBitmapDataForDraw = null;
                }
            }
            return;
        }

        var file: File = File.cacheDirectory.resolvePath( persistentImageProvider.localFile);
        file.preventBackup = true;
        if(file.exists){
            trace("decryptAndLoad");
            imageCacher = new ImageCacher();
            imageCacher.decryptAndLoad = persistentImageProvider.isEncrypted;
            imageCacher.persistentImageProvider = persistentImageProvider;
            imageCacher.bitmapLoadedHandler = bitmapLoadedForDrawHandler;
            imageCacher.load();
        }else{
            trace("decryptAndLoad2");
            if(completeDownloadBitmapDataForDraw){
                completeDownloadBitmapDataForDraw(this, null);
                completeDownloadBitmapDataForDraw = null;
            }
        }
    }

    protected function bitmapLoadedForDrawHandler(bitmap : Bitmap):void{
        if(bmpDataForDraw){
            bmpDataForDraw.dispose();
        }
        bmpDataForDraw = bitmap.bitmapData;
        if(completeDownloadBitmapDataForDraw){
            completeDownloadBitmapDataForDraw(this, bmpDataForDraw);
            completeDownloadBitmapDataForDraw = null;
        }

        if(imageCacher){
            imageCacher.cancel();
            imageCacher=null;
        }
    }

    public function unloadBitmapDataForDraw() : void {
        if(imageCacher){
            imageCacher.cancel();
            imageCacher = null;
        }

        if(bmpDataForDraw){
            if(_textureBitmapData!=bmpDataForDraw){
                if(bmpDataForDraw){
                    bmpDataForDraw.dispose();
                    bmpDataForDraw = null;
                }

            }
        }
    }

    public function get strictAspectRatio():Number {
        return _strictAspectRatio;
    }

    public function set strictAspectRatio(value:Number):void {
        _strictAspectRatio = value;
    }

    public function set cropOnLoadCoefficient(value:Number):void {
        _cropOnLoadCoefficient = value;
    }
}
}




