package com.despark.tuning3d.view.components.core {
import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;
import com.utils.FontSelector;

import feathers.controls.Label;

import feathers.controls.text.StageTextTextEditor;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
    import feathers.core.IMultilineTextEditor;
    import feathers.core.IMultilineTextEditor;
import feathers.core.ITextRenderer;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.text.engine.FontPosture;
import flash.text.engine.FontWeight;

// ITextBaselineControl, IFeathersControl
public class LabelFactory {
    private static const TEXT_COLOR_BLACK:uint = 0x242424;
    private static const TEXT_COLOR_GRAY:uint = 0x646464;
    private static const TEXT_COLOR_FRIEND_LIST:uint = 0x58595b;
    private static const MAIL_LABEL_DATE_COLOR:uint = 0x999999;
    //
    private static const FONT_SIZE_FRIEND_LIST:uint = 10;
    private static const FONT_SIZE_MAIL_BODY:uint = 12;
    //
    private static const MAIL_LABEL_NAME_SIZE:uint = 12;
    private static const MAIL_LABEL_MESSAGE_SIZE:uint = 11;
    private static const MAIL_LABEL_DATE_SIZE:uint = 10;
    private static const MAIL_BODY_LINK_TITLE_SIZE:uint = 14;
    private static const MAIL_BODY_LINK_DESC_SIZE:uint = 12;
    private static const MAIL_BODY_LINK_URL_SIZE:uint = 12;

    public static const HOME_NEWS_SMALL:uint = 8;
    public function LabelFactory() {
    }

    public static function  garageSettingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 14, UIColors.WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function saveVideoMessageLabel(): ITextRenderer {
        var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
        var bold:Boolean = false;
        var italic:Boolean = false;
        var color:uint = 0xFFFFFF;
        var size:int = 12;
        var align:String = TextFormatAlign.CENTER;
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratLight(), size, color);
        textRenderer.textFormat.align = align;
        textRenderer.textFormat.bold = bold;
        textRenderer.textFormat.italic = italic;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.isHTML = true;
        return textRenderer;
    }

    public static function saveVideoHeaderLabel(): ITextRenderer {
        var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 12, 0xFFFFFF);
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.textFormat.bold = true;
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.isHTML = false;
        return textRenderer;
    }

    public static function  mailDateLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), MAIL_LABEL_DATE_SIZE, MAIL_LABEL_DATE_COLOR);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  mailBodyLinkTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), MAIL_BODY_LINK_TITLE_SIZE, TEXT_COLOR_BLACK);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  friendSocialLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), MAIL_LABEL_NAME_SIZE, TEXT_COLOR_BLACK);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  mailBodyLinkDescLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), MAIL_BODY_LINK_DESC_SIZE, TEXT_COLOR_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  mailBodyLinkURLLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), MAIL_BODY_LINK_URL_SIZE, TEXT_COLOR_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.underline = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  tuningSettingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 8, UIColors.WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  leaderBoardWinLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 11, UIColors.WHITE, true);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengesStartChallengeLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 11, UIColors.WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  notificationsMessageField ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 12, UIColors.UI_COMPONENT_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function createLabelPopup():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelPopupIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererPopupAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelLarge():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelLargeIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererLargeAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelTimelineCarName():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.carNameTimelineLabelLargeIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.carNameLabelRendererLargeAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelComment():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelCommentIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererCommentAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createAvatarLabel(textSize:Number):FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = getIOSRenderer(textSize, TimelineLabelFactory.COLOR_TEXT_WHITE, true, false, TextFormatAlign.LEFT, false) as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = function():ITextRenderer{
                return getAndroidRenderer(textSize, TimelineLabelFactory.COLOR_TEXT_WHITE, true, false, TextFormatAlign.LEFT, true, false);
            }
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createUserDetailsLabel():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.userDetailsLabelIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.userDetailsLabelAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailPopupUsername():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.createMailPopupUsernameLabelIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.createMailPopupUsernameLabelAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailBody():FeathersControl{
        var result:FeathersControl;
        /*if(Constants.isIOS) {
            result = labelMailBodyIos() as FeathersControl;
            StageTextTextEditor(result).multiline = true;
        }else{*/
            result = new Label();
            Label(result).textRendererFactory = labelMailBodyAndroid;
            Label(result).wordWrap = true;
        //}
        return result;
    }

    private static function  labelMailBodyIosTemp ():IMultilineTextEditor {
        var textEditor:StageTextTextEditor = new StageTextTextEditor();
        textEditor.multiline = true;
        textEditor.fontFamily = "Arial";
        textEditor.isEditable = false;
        textEditor.fontSize = TimelineLabelFactory.SIZE_BIG;
        textEditor.color = TEXT_COLOR_BLACK;
        return textEditor;
    }

    public static function createLabelMailMessage():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelMailMessageIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelMailMessageAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelFriendList():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.nameLabelFriendListIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelFriendListAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailUserName():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelMailUserNameIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelMailUserNameAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelTimelineDesc():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelTimelineDescIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelTimelineDescAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function setLabelText(label:FeathersControl, text:String):void{
        if(label.hasOwnProperty("text")){
            label["text"] = text;
        }else if(label.hasOwnProperty("label")){
            label["label"] = text;
        }
        label.validate();
    }

    // ************** Android ******************
    public static function  nameLabelRendererCommentAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  userDetailsLabelAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  createMailPopupUsernameLabelAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_WHITE, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailMessageAndroid ():ITextRenderer{
        return getAndroidRenderer(MAIL_LABEL_MESSAGE_SIZE, MAIL_LABEL_DATE_COLOR, false, false, TextFormatAlign.LEFT, true);
    }

    public static function  labelMailBodyAndroid ():ITextRenderer{
        return getAndroidRenderer(FONT_SIZE_MAIL_BODY, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT, true, true);
    }

    public static function  nameLabelRendererLargeAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  carNameLabelRendererLargeAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_RED, true, false, TextFormatAlign.LEFT, false);
    }

    private static function nameLabelRendererPopupAndroid() :ITextRenderer {
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TEXT_COLOR_BLACK, false, true, TextFormatAlign.LEFT);
    }

    private static function nameLabelFriendListAndroid() :ITextRenderer {
        return getAndroidRenderer(FONT_SIZE_FRIEND_LIST, TEXT_COLOR_FRIEND_LIST, true, false, TextFormatAlign.LEFT);
    }

    private static function labelMailUserNameAndroid() :ITextRenderer {
        return getAndroidRenderer(MAIL_LABEL_NAME_SIZE, TEXT_COLOR_FRIEND_LIST, false, false, TextFormatAlign.LEFT);
    }

    private static function labelTimelineDescAndroid() :ITextRenderer {
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, false, false, TextFormatAlign.LEFT);
    }

    private static function getAndroidRenderer(fontSize:int, textColor:uint, bold:Boolean = false, italic:Boolean = false, align:String = null, hasFilter:Boolean = true, multiline:Boolean = false):ITextRenderer{
        align ||= TextFormatAlign.LEFT;
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getUnicode(), fontSize, textColor);
        textRenderer.textFormat.italic = italic;
        textRenderer.textFormat.bold = bold;
        textRenderer.textFormat.align = align;
        textRenderer.wordWrap = multiline;
        textRenderer.filter = hasFilter?TimelineLabelFactory.getFilter():null;
        return textRenderer;
    }

    // ************** IOS **********************
    public static function  usernameLabelCommentIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  userDetailsLabelIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  createMailPopupUsernameLabelIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_WHITE, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailBodyIos ():IMultilineTextEditor {
        return getIOSRenderer(FONT_SIZE_MAIL_BODY, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT, false);
    }

    public static function  labelMailMessageIos ():IMultilineTextEditor {
        return getIOSRenderer(MAIL_LABEL_MESSAGE_SIZE, MAIL_LABEL_DATE_COLOR, false, false, TextFormatAlign.LEFT);
    }

    public static function  usernameLabelLargeIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  carNameTimelineLabelLargeIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_RED, true, false, TextFormatAlign.LEFT);
    }

    public static function  usernameLabelPopupIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TEXT_COLOR_BLACK, false, true, TextFormatAlign.LEFT);
    }

    public static function  nameLabelFriendListIos ():IMultilineTextEditor {
        return getIOSRenderer(FONT_SIZE_FRIEND_LIST, TEXT_COLOR_FRIEND_LIST, true, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailUserNameIos ():IMultilineTextEditor {
        return getIOSRenderer(MAIL_LABEL_NAME_SIZE, TEXT_COLOR_FRIEND_LIST, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelTimelineDescIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, false, false, TextFormatAlign.LEFT);
    }

    private static function getIOSRenderer(fontSize:int, textColor:uint, bold:Boolean = false, italic:Boolean = false, align:String = null, multiline:Boolean = false):IMultilineTextEditor{
        align ||= TextFormatAlign.LEFT;
        var textEditor:StageTextTextEditor = new StageTextTextEditor();
        textEditor.fontSize = fontSize;
        textEditor.color = textColor;
        textEditor.multiline = multiline;
        textEditor.isEditable = false;
        if(bold){
            textEditor.fontWeight = FontWeight.BOLD;
        }
        if(italic){
            textEditor.fontPosture = FontPosture.ITALIC;
        }
        textEditor.textAlign = align;
        textEditor.fontFamily = "Arial";
        return textEditor;
    }
}
}
