package com.despark.tuning3d.view.components.core
{
    import com.utils.SplashScreenLogo;

    import feathers.core.FeathersControl;

    import flash.system.Capabilities;

    import starling.animation.Transitions;
    import starling.animation.Tween;
    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.EnterFrameEvent;
    import starling.textures.Texture;

    public class LoaderView extends FeathersControl {

    private var quad:Quad = null;
    private var spinner:Sprite = null;
    private var bgImage:Image;
    public function LoaderView() {
        super();
    }

    public function hide():void {
        this.removeFromParent(true);
    }

	public static function show():LoaderView {
        var blockerView:LoaderView = new LoaderView();
        blockerView.width = Starling.current.stage.width;
        blockerView.height = Starling.current.stage.height;
        Starling.current.stage.addChild(blockerView);
        blockerView.alpha = 0;
        var tween:Tween = new Tween(blockerView, 0.35, Transitions.EASE_IN_OUT);
        tween.fadeTo(1.0);
        Starling.juggler.add(tween);
        return blockerView;
    }

	private function enterFrameHandler(event : EnterFrameEvent) : void {
        if (spinner && spinner.visible) {
            spinner.rotation += 0.2;
        }
    }


    protected override function initialize():void {
        super.initialize();
        quad = new Quad(1, 1, 0x000000);
        quad.alpha = 0.30;
        addChild(quad);
        var splash;
        if (Capabilities.os.indexOf('iPad') > -1) {
            splash = new SplashScreenLogo.SPLASH_LOGO_IPAD_CLASS();
        } else {
            splash = new SplashScreenLogo.SPLASH_LOGO_CLASS();
        }

        bgImage = new Image(Texture.fromBitmap(splash));
        bgImage.width = Starling.current.stage.width;
        bgImage.height = Starling.current.stage.height;
        addChild(bgImage);

        spinner = new Sprite();
        var spinnerTexture:Texture = ButtonFactory.assetManager.getTexture("spinner");
        var spinnerImage:Image = new Image(spinnerTexture);
        spinnerImage.width = 40;
        spinnerImage.height = 40;
        spinnerImage.x = -20;
        spinnerImage.y = -20;
        spinner.addChild(spinnerImage);
        addChild(spinner);
        addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
    }

    protected override function draw():void {
        super.draw();
        var sizeInvalid:Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
        if (sizeInvalid) {
            quad.x = 0;
            quad.y = 0;
            quad.width = actualWidth;
            quad.height = actualHeight;

            bgImage.x = 0;
            bgImage.y = 0;

            bgImage.width = actualWidth;
            bgImage.height = actualHeight;

            //432
            //248.5

            spinner.x = 447 * (actualWidth / 568);//actualWidth/2;
            spinner.y = 268.5 * (actualHeight / 320);//actualHeight/2;

        }
    }
}
}