package com.despark.tuning3d.view.components.core {
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.NotificationView.InAppNotificationPopUp;
import com.despark.tuning3d.view.components.NotificationView.NotificationPanelLabelFactory;
    import com.despark.tuning3d.view.components.timeline.FeedData;
    import com.utils.ImageUtils;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;

import starling.display.Canvas;

import starling.display.Image;
import starling.display.Quad;

import starling.textures.Texture;


public class MainMenuButton extends ExtentedButton{
    private var _texture:Texture;
    private var _notContainer:LayoutGroup;
    public function MainMenuButton(texture:Texture, scaleFactor:int, color:uint = 0x0055aa) {
        super();

        this._texture = texture;
        this.hitAreaPadding = 5;


        var defaultImage : Image = new Image(_texture);
        defaultImage.color = color;
        this.defaultSkin = defaultImage;

        var down: Image = new Image(_texture);
        defaultImage.color = color;
        this.downSkin = down;
        this.downSkin.alpha = .6;

        var w:Number = Device.isIos() || scaleFactor < 3.375 ? 34 : 32;
        var h:Number = Device.isIos() || scaleFactor < 3.375 ? 34 : 32;
        this.width = w;
        this.height = h;
    }


    override protected function draw():void {
        super.draw();
        updateNotification();
    }

    public function updateNotification() : void{
        Constants.updateNotificationCount();
        if(UsersProxy.loggedInUser() && Constants.UNREAD_NOTIFICATIONS_COUNT>0){
            if(!_notContainer){
                initNotContainer();
            } else {
                _notContainer.visible = true;
            }
            (_notContainer.getChildAt(0) as Label).text = FeedData.getNumberString(Constants.UNREAD_NOTIFICATIONS_COUNT);
        } else if(_notContainer){
            Constants.clearNotificationCount();
            _notContainer.visible = false;
        }
    }


    override protected function initialize():void {
        super.initialize();
        updateNotification();
    }

    private function initNotContainer():void{
        _notContainer ||= InAppNotificationPopUp.generateNotificationIcon();

        addChild(_notContainer);
        _notContainer.x = 24;
        _notContainer.y = 0;
    }
}
}
