package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.model.core.AppMode;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.LanguagesProxy;
import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.mails.MailsProxy;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.BrandsScreenMediator;
import com.despark.tuning3d.view.components.NotificationView.InAppNotificationPopUp;
import com.despark.tuning3d.view.components.brands.BrandsScreen;
	import com.despark.tuning3d.view.components.challenges.ChallengesListScreen;
	import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
import com.despark.tuning3d.view.components.gallery.GalleryScreen;
import com.despark.tuning3d.view.components.languages.LanguageItemRenderer;
	import com.despark.tuning3d.view.components.timeline.FeedData;
	import com.despark.tuning3d.view.components.timeline.TimelineScreen;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
import com.despark.tuning3d.view.components.votes.VotesListScreen;
	import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
	import com.distriqt.AdsManager;
import com.utils.FontSelector;
import com.utils.ImageUtils;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.PickerList;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollContainer;
import feathers.controls.ScrollPolicy;
import feathers.controls.popups.DropUpPopUpContentManager;
import feathers.controls.renderers.IListItemRenderer;
import feathers.data.ListCollection;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.display.Bitmap;
import flash.display.Loader;
import flash.events.IOErrorEvent;
import flash.events.TimerEvent;
import flash.geom.Rectangle;
import flash.net.URLRequest;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.utils.ByteArray;
import flash.utils.Timer;
import flash.utils.setTimeout;

import starling.animation.Transitions;
import starling.animation.Tween;
	import starling.core.Starling;
	import starling.core.Starling;
import starling.display.DisplayObjectContainer;
import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.events.EventDispatcher;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class MainMenuView extends StackedScreenNavigator implements Multilingual
	{
		public static var assetManager : AssetManager;
		public static var language : Language;

		public var garageThumbMode:Boolean = false;
		public var caller : *;

		private static var pickerButton2 : MultilingualButton = null;

		public var image : Sprite;
		public var isOpened : Boolean = false;

		public  var stateTimer:Timer;
		private var avatarTimer:Timer;
		private var languageTimer:Timer;
		private var backgroundImage : Image;

		private var _text : String;
		private var _parentActualWidth:Number;
		private var _parentActualHeight:Number;

        public var frndButton : MainMenuItem;
		public var homeButton : Sprite;
		public var tuningButton : Sprite;
		public var truckButton : Sprite;
		public var grgeButton : Sprite;
		public var shedButton : Sprite;
		public var challengeButton: Sprite;
		public var challengeNotesButton: MainMenuItem;
		public var leaderBoardButton: Sprite;
        public var timelineButton:Sprite;
        public var galleryButton:Sprite;
        public var notificationButton: MainMenuItem;
        public var mailsButton: MainMenuItem;

        // public var _notificicationCount : DisplayObjectContainer;

        //public var timelineButton:Sprite;
        public var pendingForAuthAction : String;

		private var label : MultilingualLabel;
		private var backButton : MultilingualButton;
		public var loginButton : MultilingualButton;
		public var pickerButton : MultilingualButton;
		public var avatarButton : MultilingualButton;
		public var toggleButton : MainMenuButton;
		private var avatarContainer:Sprite;
		private var userButtonContainer:LayoutGroup;

		private var _languages : Array;
		private var _languageList:List = null;

		public var languagePickerList : PickerList;
		public var instructionButton : Button;
		public var logoutButton : Button;
		public var profileButton : Button;
		public var restoreButton : Button;
		private var overlay : Button;

		private var verticalOffset   : Number = 13;
		private var horizontalOffset : Number = 15;

		private var _userData : Object;
		private var itemCollection : Array;

		public var _language : Language = null;
		public var _selectedLanguage : Language;
		public var languageChangedHandlerDisabled : Boolean;

		private var verSpacer : Quad;
		private var _signedIN : Boolean = false;
		public var avatarImage : Image = null;

		protected var loginSign  : int = -1;

		private var _owner : IMainMenuHolder;

        private var avatarLoader : Loader;
        private var isLoading   : Boolean = false;
        private var _dataLoaded : Boolean = false;

		private var completeShowCallback : Function = null;
        private var _buttonsContainer:ScrollContainer;

		private var _friendProxy:FriendProxy;
		public static const MENU_WIDTH:int = 205;
		public static const START_SHOW:String = 'startShow';
		public  function MainMenuView(obj:*=null)
		{
			super();

			if(Device.isIphoneXVariant()){
				horizontalOffset+=17;
			}

			if (obj) caller = obj;

			this.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
            _friendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
		}

        public function get customUserName() : String
		{
            var str : String = AlertView.language.translate("mob_garage","myGarage");
            if (Constants.selectedUser && Constants.selectedUser.username){
                MultilingualButton(getElement(grgeButton,"label")).label = Constants.selectedUser.username + " " + str.split(" ")[1];
				trace("customUserName:", Constants.selectedUser.username + " " + str.split(" ")[1]);
            }

            return str;
        }

		public function set owner(value : IMainMenuHolder)  : void {
			this._owner = value;
		}
		public function get owner():IMainMenuHolder{
			return this._owner;
		}

		public function get userSignedIn():Boolean{
			return (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser != null;
		}

		private function onAddedToStage(event:Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);

			language = owner.selectedLanguage;
			languageChangedHandlerDisabled = true;

			hide();

			if (userSignedIn) {
				loginButtonTriggeredHandler();
			}
		}

		public function get signedIN() : Boolean {
			_signedIN=userSignedIn;
			return userSignedIn;
		}
		public function set signedIN(value:Boolean):void{
			//	_signedIN = value;
		}

		public function get userData() : Object {
			return _userData;
		}
		public function set userData(value :Object):void{
			_userData = value;
		}

		public function get selectedLanguage() : Language {
			return _selectedLanguage;
		}
		public function set selectedLanguage(value :Language):void{
			_selectedLanguage = value;
		}

		public function get languages() : Array {
			return _languages;
		}

		public function set languages(value:Array):void{
			_languages = value;
			invalidate("languages");
		}

		private function addElement(item:*,index:int=-1) : void
		{
			if (!itemCollection) {
				itemCollection = [];
			}

			for (var i:int = 0; i < itemCollection; i++) {
				if (itemCollection[i].name == item.name) {
					return;
				}
			}
			index != -1 ? addChildAt(item,index) : addChild(item);
		}

		public function get text() : String {
			return _text;
		}
		public function set text(value:String):void{
			_text = value;
			invalidate("text");
		}

		public function set parentActualWidth(value:Number):void{
			_parentActualWidth = value;
		}
		public function get parentActualWidth() : Number{
			return _parentActualWidth;
		}

		public function set parentActualHeight(value:Number):void{
			_parentActualHeight = value;
		}
		public function get parentActualHeight():Number{
			return _parentActualHeight;
		}

		private function onCheckStateTimer(event:TimerEvent=null) : void
		{

			signedIN = userSignedIn;

			var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;

			var eventDone : Boolean = false;
			if (loginSign == -1)
			{
				if (!signedIN)
				{
					signedIN  = false;
					eventDone = true;
					label.text = "";
				}
			}
			else
			{
				if (signedIN && null != usersProxy.currentUser)
				{

					var tempUser : User = usersProxy.currentUser as User;

					label.text = tempUser.name ? tempUser.name : tempUser.username;
					if (label.text.length > 12) {
                        label.wordWrap = true;
                        label.y = avatarButton.y - (Constants.isIOS ? 2 : 3);
                        label.validate();
					}

					avatarButton.updateWithLanguage(AlertView.language);
					avatarButton.label = label.text.substr(0,1).toLocaleUpperCase();

					if (tempUser.avatarPath) {
						loadImage(tempUser.avatarPath);
					}

					signedIN  = true;
					eventDone = true;

					updateWithLanguage(AlertView.language);

				}
			}

			if (eventDone)
			{
				if (stateTimer){
					stateTimer.stop();
					stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer = null;
				}

				//updateStates();
				if (owner.mainMenuView) {
					owner.mainMenuView.updateStates();
				}


			}
		}

        public function loadImage(url:String) : void
        {
            if(url.indexOf("http") == - 1) url = "http:" + url;

            isLoading = true;
            avatarLoader = new Loader();
            avatarLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
            avatarLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.load(new URLRequest(url));
        }

        private function onIOErrorHandler(event:IOErrorEvent):void
        {
            isLoading = false;
            avatarLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
        }

        public  function onLoadComplete(event:flash.events.Event) : void
        {
            if (!isLoading) return;

			if(avatarImage) avatarImage.removeFromParent(true);
            avatarImage = new Image(Texture.fromBitmap(ImageUtils.roundCorners(event.currentTarget.loader.content as Bitmap))) ;
            avatarContainer ||= new Sprite();
            avatarContainer.addChild(avatarButton);
            avatarContainer.addChild(avatarImage);

            avatarImage.x = avatarButton.x;
            avatarImage.y = avatarButton.y;
            avatarImage.width = avatarImage.height = avatarButton.width;
            verSpacer.y = (avatarImage && avatarImage.visible)?(avatarImage.height + avatarImage.y + verticalOffset/2):(loginButton.height+loginButton.y + verticalOffset/2);

            label.x = avatarImage.width+avatarImage.x+horizontalOffset/2;
            label.y = avatarImage.y+(avatarImage.height-label.height)/2;
            isLoading = false;

            avatarLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);

            _dataLoaded = true;
            avatarButton.visible = false;

        }

		public function loginButtonTriggeredHandler(event:Event=null) : void {
			Starling.juggler.delayCall(AdsManager.$.bannerHide, 0.25);
            if (avatarImage){
                removeChild(avatarImage);
            }

			if (event) {
				SoundManager.playSound(SoundManager.SELECT_PART);
				pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_LOGIN;
				owner.dispatchExternalEvent(BrandsScreen.LOGIN_SELECTED);

				var target : MainMenuView = owner.mainMenuView;

				loginSign = 1;
				if (target.stateTimer) {
					target.stateTimer.stop();
					target.stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					target.stateTimer = null;
				}
				target.stateTimer = new Timer(40,0);
				target.stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
				target.stateTimer.start();
			} else {
				loginSign = 1;
				if (stateTimer) {
					stateTimer.stop();
					stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer = null;
				}
				stateTimer = new Timer(40,0);
				stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
				stateTimer.start();
			}
		}

		private function logoutButtonTriggeredHandler(event:Event) : void {
			owner.dispatchExternalEvent(BrandsScreen.LOGOUT_SELECTED);
			if (owner is TuningsListScreen) {
				owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
			}
			var target:MainMenuView = owner.mainMenuView;
			loginSign = -1;
			if(event){
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			}
			if(target) {
                if (target.stateTimer) {
                    target.stateTimer.stop();
                    target.stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
                    target.stateTimer = null;
                }
                target.stateTimer = new Timer(40, 0);
                target.stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
                target.stateTimer.start();
            }

			if (caller && caller.hasOwnProperty("homeButtonTriggeredHandler")){
				caller.homeButtonTriggeredHandler();
			}

			if (avatarImage){
				avatarImage.removeFromParent();
			}
		}

		private function profileButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.PART_MENU);
			owner.dispatchExternalEvent(StackedScreen.USER_PROFILE_SELECTED);
		}

		private function restoreButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            if (userSignedIn || Constants.isIOS) {
                owner.dispatchExternalEvent(StackedScreen.USER_RESTORE_SELECTED);
            } else {
                pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_LOGIN;
                owner.dispatchExternalEvent(BrandsScreen.LOGIN_SELECTED);
            }
		}

		public function updateStats():void{
            _friendProxy.loadPendings();
		}

		public function updateStates() : void
		{


			/*if (instructionButton && actualHeight){
				instructionButton.y = verticalOffset;
				instructionButton.x = _signedIN ? ((actualWidth - instructionButton.width) / 2 -horizontalOffset): ((actualWidth - 3 * instructionButton.width) / 2-horizontalOffset);
			}*/

			if (logoutButton && actualHeight){
				// logoutButton.y = verticalOffset;
			}

			if (languagePickerList){
				languagePickerList.width = logoutButton.width;
				languagePickerList.height = logoutButton.height;
				//languagePickerList.x = _signedIN ? actualWidth - logoutButton.width - 2*horizontalOffset : logoutButton.x + 2 * logoutButton.width;
				//languagePickerList.y = logoutButton.y; //actualHeight - logoutButton.height - verticalOffset;
			}

			if (signedIN)
			{
				loginButton.visible = false;
				logoutButton.visible = profileButton.visible = true;
                restoreButton.visible = true; // restore later
                verSpacer.visible = true;
				label.visible = true;
                avatarButton.visible = true;

				if (avatarImage) {
					avatarImage.visible = true;
				}

				avatarButton.updateWithLanguage(AlertView.language);


				var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
				var tempUser : User = usersProxy.currentUser as User;

				label.text = tempUser.name ? tempUser.name : tempUser.username;
				if (label.text.length > 12) {
					label.wordWrap = true;
					label.y = avatarButton.y - (Constants.isIOS ? 2 : 3);
					label.validate();
				}

				avatarButton.updateWithLanguage(AlertView.language);
				avatarButton.label = label.text.substr(0,1).toLocaleUpperCase();

				if (tempUser.avatarPath) {
					loadImage(tempUser.avatarPath);
				}

				signedIN  = true;


				updateWithLanguage(AlertView.language);
			}
			else
			{
				loginButton.visible = true;
                logoutButton.visible = profileButton.visible = false;
                restoreButton.visible = true; // restore later
                verSpacer.visible = true;
				label.visible = false;
				avatarButton.visible = false;

				if (avatarImage) {
					avatarImage.visible = false;
				}
			}

			invalidate();
		}

		private function updateItemsLanguage() : void
		{
			MultilingualButton(getElement(homeButton,"label")).label = AlertView.language.translate("mob_home","home");
			MultilingualButton(getElement(tuningButton,"label")).label = AlertView.language.translate("mob_home","Vehicles");
            MultilingualButton(getElement(mailsButton,"label")).label = "Mails";
            MultilingualButton(getElement(notificationButton,"label")).label = "Notifications";
            MultilingualButton(getElement(challengeNotesButton,"label")).label = "VS Notifications";
            MultilingualButton(getElement(truckButton,"label")).label = AlertView.language.translate("mob_home","Trucks");
            MultilingualButton(getElement(grgeButton,"label")).label = customUserName;
            MultilingualButton(getElement(shedButton,"label")).label = AlertView.language.translate("mob_home","Cars Schedule");

            MultilingualButton(getElement(challengeButton,"label")).label = "Challenges";
            MultilingualButton(getElement(timelineButton,"label")).label = "Timeline";
            MultilingualButton(getElement(galleryButton,"label")).label = "Gallery";
            MultilingualButton(getElement(leaderBoardButton,"label")).label = "Leaderboard";
            MultilingualButton(getElement(frndButton,"label")).label = "Friends";

			invalidate();

            /*MultilingualButton(getElement(frndButton,"label")).label = "Friends";*/
		}

		public function updateGaragLabel(str:String) : void {
            MultilingualButton(getElement(grgeButton,"label")).label = str;
		}

		public function updateWithLanguage(language:Language) : void
		{
			if(!language)
					return;
			//trace("updateWithLanguage", language)
			_language = language;

			if (backButton){
				backButton.updateWithLanguage(language);
			}

			if (label){
				label.updateWithLanguage(language);
			}

			if (loginButton){
				loginButton.label = language.translate("mob_signup","login").toLocaleUpperCase();
			}

			if (pickerButton){
				pickerButton.updateWithLanguage(language);
			}

			if (pickerButton2){
				pickerButton2.updateWithLanguage(language);
			}

			updateItemsLanguage();
		}

		private function closeLangMenuButtonTriggeredHandler(event:Event):void
		{
			if (pickerButton2)
			{
				pickerButton2.alpha = 1.0;
				if (pickerButton2.disabledSkin) {
					pickerButton2.disabledSkin.alpha = 1.0;
				}
			}
			closeLanguagePickerList();
		}

		public function closeLanguagePickerList() : void
		{
			if (languagePickerList && languagePickerList.popUpContentManager) {
				languagePickerList.popUpContentManager.close();
			}
			languageChangedHandlerDisabled = false;
		}

		private function getElement(target:*,str:String) :*
		{
			if (!target || !target.numChildren) return null;

			for (var i:int = 0; i < target.numChildren; i++){
				if (target.getChildAt(i).name == str) return target.getChildAt(i);
			}
			return null;
		}

		private function onTouchOverlay(event:Event) : void {
			SoundManager.playSound(SoundManager.MENU_CLOSE);
			hide(true);
		}

		public function hide(animation:Boolean=false, time:Number=.1):void
		{
			BrandsScreen.adsBlocker = false;
			if (languagePickerList) {
				closeLanguagePickerList();
			}

			var target :* = !caller ? owner : caller;
			if (animation)
			{
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
					tween.moveTo(0,0);
					tween.onComplete = completeHide;
				Starling.juggler.add(tween);
			}
			else
			{
				target.x = 0;
				completeHide();
			}
		}

		private function completeHide() : void {
			if (overlay) {
				overlay.visible = false;
			}

			dispatchEventWith(Event.CLOSE);
			isOpened = false;
		}

		private function modeUpdate():void{
			if(AppMode.self.mode == AppMode.MODE_HOME){
                _buttonsContainer.addChildAt(tuningButton, 1);
                _buttonsContainer.addChildAt(truckButton, 1);
                _buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
			}else if(AppMode.self.mode == AppMode.MODE_TUNING) {
				if(truckButton.parent) {
					truckButton.removeFromParent();
				}
				_buttonsContainer.addChildAt(tuningButton, 1);
                shedButton.removeFromParent();
                _buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
            }else if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR){
                if(tuningButton.parent){
                    tuningButton.removeFromParent();
                }
				_buttonsContainer.addChildAt(truckButton, 1);
				shedButton.removeFromParent();
				_buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
            }
		}

		public function show(animation:Boolean=false, complete:Function=null):void {
			SoundManager.playSound(SoundManager.MENU);

            modeUpdate();
			updateStates();
			completeShowCallback = complete;
			dispatchEventWith(START_SHOW);
			var target :* = !caller ? owner : caller;
			if (animation) {
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
				tween.moveTo(actualWidth,0);
				tween.onComplete = completeShow;
				Starling.juggler.add(tween);
			} else {
				target.x = actualWidth;
				completeShow();
			}
		}

		private function completeShow():void {
			dispatchEventWith(Event.OPEN);

			if (completeShowCallback) {
				completeShowCallback();
				completeShowCallback = null;
			}

			if (overlay) {
				overlay.visible = true;
			}
			isOpened = true;
		}

		private function brandsScreenButtonTriggeredHandler(event:Event=null) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if(event && event.currentTarget){
				var parent:Sprite = MultilingualButton(event.currentTarget).parent as Sprite;
				if(parent){
					if(parent == tuningButton && AppMode.self.mode != AppMode.MODE_TUNING){
						AppMode.self.mode = AppMode.MODE_TUNING;
					}else if(parent == truckButton && AppMode.self.mode != AppMode.MODE_TRUCK_CONFIGURATOR){
                        AppMode.self.mode = AppMode.MODE_TRUCK_CONFIGURATOR;
					}
				}
			}
			//
            if(owner is BrandsScreen){
                hide(true);
            }else{
                owner.brandsScreenButtonTriggeredHandler();
            }
		}

		private function homeButtonTriggered(event:Event=null) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            owner.homeButtonTriggeredHandler();
		}


		private function instructionButtonTriggeredHandler(event : Event) : void {
			owner.dispatchExternalEvent(BrandsScreen.INSTRUCTION_SELECTED);
		}

		private function sheduleButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is VotesListScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.VOTE_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);
			}
		}

		private function challengeButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is ChallengesListScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.CHALLENGES_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);
			}
		}

		private function galleryButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is GalleryScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.GALLERY_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);

			}
		}


		private function grgeButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			var currentUser:User =usersProxy.currentUser;
			var reloadGarage:Boolean = false;
			if(currentUser && Constants.selectedUser && Constants.selectedUser.id != currentUser.id){
                Constants.selectedUser = null;
				reloadGarage = true;
			}
			pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_GARAGE;
			if (owner is TuningsListScreen){
				if(reloadGarage){
                    TuningsListScreen(owner).dispatchEventWith(StackedScreenNavigator.BACK_TO_SCREEN);
                    var delayedCall:Function = function ():void {
                        pendingForAuthAction =  BrandsScreenMediator.AUTH_ACTION_GARAGE;
                        usersProxy.sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
                        if(isLoading){
                            setTimeout(function():void{
                                owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
                            },1500);
                        }
                    };
                    Starling.juggler.delayCall(delayedCall, 0.03);
				}else {
                    if (!garageThumbMode) {
                        owner.enterRowsState();
                    }
                    hide(true);
                }
			}else{
				if(owner as TuningScreen){
					pendingForAuthAction =  BrandsScreenMediator.AUTH_ACTION_GARAGE;
				}
				owner.dispatchExternalEvent(StackedScreen.GARAGE_SELECTED);
				//if(!owner as TuningScreen)
				if(isLoading){
					setTimeout(function():void{
						owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
					},1500);
				}

			}
		}

		private  function onCheckForLanguage(event:TimerEvent):void {
			if (!owner.languages) return;

			//trace("onCheckForLanguage")

			languages = owner.languages;
			if (languages && languages.length > 0)
			{
				languageTimer.stop();
				languageTimer.removeEventListener(TimerEvent.TIMER, onCheckForLanguage);
				languageTimer = null;

				if (owner.selectedLanguage)
				{
					//trace("onCheckForLanguage2");
					selectedLanguage = owner.selectedLanguage;
					if (selectedLanguage /*&& isInvalid("languages") &&*/ && languages)
					{
						var index : int = -1;
						for (var i : int = 0; i < languages.length; i++){
							if (selectedLanguage.code == languages[i].code) {
								index = i;
								break;
							}
						}
					}

					languagePickerList.dataProvider = new ListCollection(languages);
					languagePickerList.selectedIndex = index;


					invalidate();
				}
			}
		}

		private function languagePickerListChangeHandler(event :Event) : void
		{
			if (languageChangedHandlerDisabled) return;

			try {
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);
			}
			catch(error:Error){
				//trace("MainMenuView.languagePickerListChangeHandler()",error.message);
			}

			if (/*selectedLanguage && */languagePickerList && languagePickerList.selectedItem && selectedLanguage != languagePickerList.selectedItem as Language)
			{
				selectedLanguage = languagePickerList.selectedItem as Language;
				language = selectedLanguage;

				owner.selectedLanguage = selectedLanguage;
				owner.dispatchExternalEvent(BrandsScreen.LANGUAGE_CHANGED);
				owner.updateWithLanguage(owner.selectedLanguage);

				if (caller && caller.hasOwnProperty("updateWithLanguage")){
					caller.updateWithLanguage(selectedLanguage);
				}
			}

			closeLanguagePickerList()
		}

		private function getInstanceMemoryLocation(obj:*) : void
		{
			try {
				ByteArray(obj);
			}
			catch (error:Error){
				trace("hash:"+String(error).replace(/.*([@|\$].*?) to .*$/gi, '$1'));
			}
		}

		private function getItemLabel(target:*) : String{
			return MultilingualButton(getElement(target,"label")).label;
		}

		protected override function initialize() : void
		{
			super.initialize();

			languageChangedHandlerDisabled = true;
			this.x = -actualWidth;

			var size : Number = 28;
			var wdth : Number = actualWidth - 2 * horizontalOffset;
			if(Device.isIphoneXVariant()){
				wdth+=horizontalOffset-5;
			}
			var target : MainMenuView = owner.mainMenuView;

            var layout : VerticalLayout = new VerticalLayout();
            layout.gap = 0;
            layout.hasVariableItemDimensions = true;
            layout.horizontalAlign = HorizontalAlign.LEFT;
            layout.verticalAlign = VerticalAlign.TOP;

            _buttonsContainer  = new ScrollContainer();
            _buttonsContainer.layout = layout;
            _buttonsContainer.horizontalScrollPolicy = ScrollPolicy.OFF;
            _buttonsContainer.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
            _buttonsContainer.verticalScrollPolicy = ScrollPolicy.ON;

            if (caller)
			{
				if (!stateTimer){
					stateTimer = new Timer(40,0);
					stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer.start();
				}
				else{
					stateTimer.stop();
					stateTimer.start();
				}

				homeButton = ButtonFactory.mainMenuButton("home_btn",{w:wdth,h:size,t:getItemLabel(target.homeButton)});
                tuningButton = ButtonFactory.mainMenuButton("care_btn",{w:wdth,h:size,t:getItemLabel(target.tuningButton)});
                truckButton = ButtonFactory.mainMenuButton("truck_icon",{w:wdth,h:size,t:getItemLabel(target.truckButton)});
				grgeButton = ButtonFactory.mainMenuButton("garage_button",{w:wdth,h:size,t:getItemLabel(target.grgeButton)});
				shedButton = ButtonFactory.mainMenuButton("shed_btn",{w:wdth,h:size,t:getItemLabel(target.shedButton)});
				challengeButton = ButtonFactory.mainMenuButton("challenges_btn",{w:wdth,h:size,t:getItemLabel(target.challengeButton)});
				challengeNotesButton = new MainMenuItem("challenges_notes_btn",{w:wdth,h:size,t:getItemLabel(target.challengeNotesButton)}, true); // ButtonFactory.mainMenuButton("clock-menu",{w:wdth,h:size,t:getItemLabel(target.challengeNotesButton)});
				timelineButton = ButtonFactory.mainMenuButton("globe",{w:wdth,h:size,t:getItemLabel(target.timelineButton)});
                galleryButton = ButtonFactory.mainMenuButton("gallery_icon",{ w:wdth, h:size, t:getItemLabel(target.galleryButton)});
                leaderBoardButton = ButtonFactory.mainMenuButton("leaderboard_icon",{w:wdth,h:size,t:getItemLabel(target.leaderBoardButton)});
                frndButton = new MainMenuItem("users-solid",{w:wdth,h:size,t:getItemLabel(target.frndButton)}, true);
                notificationButton = new MainMenuItem("clock-menu",{w:wdth,h:size,t:getItemLabel(target.challengeNotesButton)}, true); //ButtonFactory.mainMenuButton("clock-menu",{w:wdth,h:size,t:getItemLabel(target.notificationButton)});
                mailsButton = new MainMenuItem("messages_btn",{w:wdth,h:size,t:getItemLabel(target.challengeNotesButton)}, true); //ButtonFactory.mainMenuButton("clock-menu",{w:wdth,h:size,t:getItemLabel(target.notificationButton)});

				label = new MultilingualLabel();
				label.name = "user";
				label.paddingLeft = 10;
				label.textFormat = new TextFormat(FontSelector.getFont(true),  15, 0xffffff);
				label.textFormat.align = TextFormatAlign.LEFT;
				label.textFormat.letterSpacing = -.3;
				label.textFormat.bold = true;

				avatarButton = ButtonFactory.avatarButton("emptyButton","") as ExtentedButton;
				loginButton  = ButtonFactory.loginButton("LOG IN", 0xC90809);

                logoutButton = ButtonFactory.circleDefaultButton("logout", 0.6, 0xC80909, 0);
                logoutButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / logoutButton.width;

                profileButton = ButtonFactory.circleDefaultButton("profile", 0.6, 0x0B89DF, 0);
                profileButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / profileButton.width;

                restoreButton = ButtonFactory.circleDefaultButton("restore", 0.6, 0x0756B0, 0);
                restoreButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / restoreButton.width;
                //restoreButton.visible = false;



				verSpacer = new Quad(Device.isIphoneXVariant() ? homeButton.width-5 :homeButton.width,1.2,0xffffff);
				verSpacer.alpha = .45;

				loginSign = target.loginSign;
				signedIN  = target.signedIN;

				onCheckStateTimer();
			}

			overlay = new Button();
			overlay.defaultSkin = new Quad((Constants.STAGE_WIDTH - actualWidth), 1, 0x000000);
			overlay.defaultSkin.alpha = 0;
			overlay.addEventListener(Event.TRIGGERED, onTouchOverlay);
			overlay.visible = false;
			addChild(overlay);

			backgroundImage = new Image(assetManager.getTexture("main_menu_bg") as Texture);
			backgroundImage.alpha = 1;
			addChild(backgroundImage);

			if (!LanguageItemRenderer.SHORT_LABEL) {
				LanguageItemRenderer.SHORT_LABEL={};
				LanguageItemRenderer.SHORT_LABEL['ru-RU'] = 'RUS';
				LanguageItemRenderer.SHORT_LABEL['en-US'] = 'ENG';
			}

			languagePickerList = new PickerList();

			languagePickerList.addEventListener(Event.CLOSE,function(event:Event) : void{});
			languagePickerList.addEventListener(Event.CHANGE,languagePickerListChangeHandler);
			languagePickerList.addEventListener(Event.OPEN,function(event:Event) : void {
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);});
			languagePickerList.labelField = "name";
			languagePickerList.popUpContentManager = new DropUpPopUpContentManager();
			(languagePickerList.popUpContentManager as DropUpPopUpContentManager).gap = -15;

			pickerButton = ButtonFactory.circleButton("emptyButton") as ExtentedButton;


			languageChangedHandlerDisabled = false;
			languagePickerList.buttonFactory = function() : Button {return pickerButton;};
			languagePickerList.labelFunction = function(item:Object) : String {
				return LanguageItemRenderer.getShortname(item as Language);
			};
			languagePickerList.listFactory = function() : List
			{

				var texture:Texture = assetManager.getTexture("bgOfShareMenu");

				//var backgroundTextures : Scale3Textures =
				//	new Scale3Textures(assetManager.getTexture("bgOfShareMenu"),30,24,Scale3Textures.DIRECTION_VERTICAL);

				if(pickerButton2 && pickerButton2.parent) pickerButton2.removeFromParent(true);
				pickerButton2 = ButtonFactory.circleButton("emptyButton", 1.0) as ExtentedButton;
				pickerButton2.width  = logoutButton.width;
				pickerButton2.height = logoutButton.height;
				pickerButton2.y = 105 - 15;
				pickerButton2.addEventListener(Event.TRIGGERED,closeLangMenuButtonTriggeredHandler);



				var list : List = new List();
				_languageList = list;

				var layout : VerticalLayout = new VerticalLayout();
				//layout.manageVisibility = true;
				layout.useVirtualLayout = false;
				list.layout = layout;
				list.setSize(logoutButton.width, 105);
				list.verticalScrollPosition = 0;
				list.paddingTop = 15;
				list.paddingBottom = 15;
				list.backgroundSkin = new Image(texture);
				(list.backgroundSkin as Image).scale9Grid = new Rectangle(0, 30, texture.frameWidth, 24); //tt возможно не правильно нужно для вертикальной позиции задать
				list.backgroundSkin.y = 0;
				list.itemRendererFactory = function() : IListItemRenderer {
					var renderer :	LanguageItemRenderer = new LanguageItemRenderer();
					renderer.setSize(logoutButton.width, 35);
					return renderer;
				};
				list.addChild(pickerButton2);

				return list;
			};



			if (!_languages || caller && !languageTimer) {
				languageTimer = new Timer(40, 0);
				languageTimer.addEventListener(TimerEvent.TIMER, onCheckForLanguage);
				languageTimer.start();
			}

            if (!homeButton){
				homeButton = ButtonFactory.mainMenuButton("home_btn",{w:wdth,h:size,t:""});
				homeButton.name = "homeButton";
				Button(getElement(homeButton,"touch")).addEventListener(Event.TRIGGERED, homeButtonTriggered);
				_buttonsContainer.addChild(homeButton);
			}

            if (!tuningButton){
                tuningButton = ButtonFactory.mainMenuButton("care_btn",{w:wdth,h:size,t:""});
                tuningButton.name = "tuningButton";
                Button(getElement(tuningButton,"touch")).addEventListener(Event.TRIGGERED, brandsScreenButtonTriggeredHandler);
                _buttonsContainer.addChild(tuningButton);
            }

            if (!truckButton){
                truckButton = ButtonFactory.mainMenuButton("truck_icon",{w:wdth,h:size,t:""});
                truckButton.name = "truckButton";
                Button(getElement(truckButton,"touch")).addEventListener(Event.TRIGGERED, brandsScreenButtonTriggeredHandler);
                _buttonsContainer.addChild(truckButton);
            }

            if (!galleryButton){
                galleryButton = ButtonFactory.mainMenuButton("gallery_icon",{w:wdth,h:size,t:""});
                galleryButton.name = "galleryButton";
                _buttonsContainer.addChild(galleryButton);
                Button(getElement(galleryButton,"touch")).addEventListener(Event.TRIGGERED, galleryButtonTriggeredHandler);
            }

            if (!notificationButton){
                notificationButton = new MainMenuItem("globe",{w:wdth,h:size,t: ""}, true); //ButtonFactory.mainMenuButton("globe",{w:wdth,h:size,t:""});
                notificationButton.name = "notificationButton";
                Button(getElement(notificationButton,"touch")).addEventListener(Event.TRIGGERED, notificationButtonTriggeredHandler);
                _buttonsContainer.addChild(notificationButton);

                updateNotificationCount();
            }

			if (!mailsButton){
				mailsButton = new MainMenuItem("messages_btn",{w:wdth,h:size,t: ""}, true, 0xFFFFFE);
				mailsButton.name = "mailsButton";
                Button(getElement(mailsButton,"touch")).addEventListener(Event.TRIGGERED, mailButtonTriggeredHandler);
                _buttonsContainer.addChild(mailsButton);

                updateNotificationCount();
            }

            if (!challengeNotesButton){
                challengeNotesButton = new MainMenuItem("challenges_notes_btn",{w:wdth,h:size,t: ""}, true);
                challengeNotesButton.name = "challengeNotesButton";
                Button(getElement(challengeNotesButton,"touch")).addEventListener(Event.TRIGGERED, challengeNotesButtonTriggeredHandler);
                _buttonsContainer.addChild(challengeNotesButton);
            }

            if (!timelineButton){
                timelineButton = ButtonFactory.mainMenuButton("clock-menu",{w:wdth,h:size,t:""}, 0xFFFFFE);
                timelineButton.name = "timelineButton";
                Button(getElement(timelineButton,"touch")).addEventListener(Event.TRIGGERED, timelineButtonTriggeredHanlder);
                _buttonsContainer.addChild(timelineButton);
            }

			if (!leaderBoardButton){
                leaderBoardButton = ButtonFactory.mainMenuButton("leaderboard_icon",{w:wdth,h:size,t:""});
                leaderBoardButton.name = "leaderBoardButton";
                Button(getElement(leaderBoardButton,"touch")).addEventListener(Event.TRIGGERED, leaderBoardButtonTriggeredHandler);
            }

			if (!challengeButton){
                challengeButton = ButtonFactory.mainMenuButton("challenges_btn",{w:wdth,h:size,t:""});
                challengeButton.name = "challengeButton";
                Button(getElement(challengeButton,"touch")).addEventListener(Event.TRIGGERED, challengeButtonTriggeredHandler);
                _buttonsContainer.addChild(challengeButton);
            }

            _buttonsContainer.addChild(leaderBoardButton);

            if (!grgeButton){
				grgeButton = ButtonFactory.mainMenuButton("garage_icon",{w:wdth,h:size,t:""}, 0xFFFFFE);
				grgeButton.name = "grgeButton";
				Button(getElement(grgeButton,"touch")).addEventListener(Event.TRIGGERED, grgeButtonTriggeredHandler);
				_buttonsContainer.addChild(grgeButton);
			}

            if (!frndButton){
                frndButton = new MainMenuItem("users-solid",{w:wdth,h:size,t:""}, true);
                frndButton.name = "friendButton";
                if(owner is EventDispatcher){
                    EventDispatcher(owner).addEventListener(FriendsListPopUp.PENDING_FRIENDS_READ, pendingFriendsLoadHandler);
                }
            }
            Button(getElement(frndButton,"touch")).addEventListener(Event.TRIGGERED,friendsButtonTriggeredHandler);
            _buttonsContainer.addChild(frndButton);

			if (!shedButton){
				shedButton = ButtonFactory.mainMenuButton("shed_btn",{w:wdth,h:size,t:""});
				shedButton.name = "sheduleButton";
				Button(getElement(shedButton,"touch")).addEventListener(Event.TRIGGERED, sheduleButtonTriggeredHandler);
            	_buttonsContainer.addChild(shedButton);
			}

            if (!logoutButton){
				logoutButton = ButtonFactory.circleDefaultButton("logout", 0.6, 0xC80909, 0);
                logoutButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / logoutButton.width;
				logoutButton.name = "logoutButton";
                logoutButton.addEventListener(Event.TRIGGERED, logoutButtonTriggeredHandler);
			}

			if (!profileButton){
                profileButton = ButtonFactory.circleDefaultButton("profile", 0.6, 0x0B89DF, 0);
                profileButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / profileButton.width;
                profileButton.name = "profileButton";
                profileButton.addEventListener(Event.TRIGGERED, profileButtonTriggeredHandler);
			}

			if (!restoreButton){
                restoreButton = ButtonFactory.circleDefaultButton("restore", 0.6, 0x0756B0, 0);
                restoreButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / restoreButton.width;
                restoreButton.name = "profileButton";
                restoreButton.addEventListener(Event.TRIGGERED, restoreButtonTriggeredHandler);
			}
            logoutButton.visible = profileButton.visible = false;
            restoreButton.visible = true;

            userButtonContainer ||= new LayoutGroup();
			var buttonLayout:HorizontalLayout = new HorizontalLayout();
            buttonLayout.paddingTop = 3 * horizontalOffset / 2;
            buttonLayout.horizontalAlign = HorizontalAlign.LEFT;
            userButtonContainer.layout = buttonLayout;

            userButtonContainer.addChild(logoutButton);
            userButtonContainer.addChild(profileButton);
            userButtonContainer.addChild(restoreButton);
            userButtonContainer.addChild(languagePickerList);
            userButtonContainer.width = Device.isIphoneXVariant() ? homeButton.width-5: homeButton.width;
			if (languagePickerList) {
				trace("languagePickerList.dp", languagePickerList.dataProvider);
				languagePickerList.width  = logoutButton.width;
				languagePickerList.height = logoutButton.height;
			}

			if (!verSpacer){
				verSpacer = new Quad((Device.isIphoneXVariant() ? homeButton.width-5: homeButton.width),1.2,0xffffff);
				verSpacer.name = "verSpacer";
			}
			verSpacer.alpha = .45;
            avatarContainer ||= new Sprite();
            avatarContainer.addChild(verSpacer);
			//addElement(verSpacer);

			if (!loginButton){
				loginButton = ButtonFactory.loginButton("LOG IN", 0xC90809);
				loginButton.addEventListener(Event.TRIGGERED, loginButtonTriggeredHandler);
				loginButton.name = "loginButton";
			}
			loginButton.visible = false;
            avatarContainer ||= new Sprite();
            avatarContainer.addChild(loginButton);
			//addElement(loginButton);
			if (!avatarButton){
				avatarButton = ButtonFactory.avatarButton("emptyButton","") as ExtentedButton;
				avatarButton.name = "avatarButton";
			}
			avatarContainer.addChild(avatarButton);
			//addElement(avatarButton);

			if (!label){
				label = new MultilingualLabel();
				label.name = "user";
				label.textFormat = new TextFormat(FontSelector.getFont(true),  16, 0xffffff);
				label.textFormat.align = TextFormatAlign.LEFT;
				label.textFormat.bold = true;
			}

			avatarContainer.addChild(label);
			//addElement(label);

			toggleButton = ButtonFactory.menuBigButton();
			toggleButton.visible=false;
			toggleButton.name = "toggleButton";
			toggleButton.width = toggleButton.height = 35;
			addElement(toggleButton);

            _buttonsContainer.addChild(avatarContainer);
            _buttonsContainer.addChild(userButtonContainer);
			addChild(_buttonsContainer);
            var buttonsLayout:VerticalLayout = new VerticalLayout();
            buttonsLayout.paddingBottom = 2*verticalOffset;
            _buttonsContainer.layout = buttonsLayout;
			updateStates();
		}

        private function pendingFriendsLoadHandler(event:Event):void {
			var changed:Boolean = (frndButton.noteCount > 0);
			if(event.data && event.data.hasOwnProperty("unread") && event.data.unread){
				frndButton.noteCount = Constants.UNREAD_FRIEND_REQUESTS = event.data.friends.length;
			}else{
                frndButton.noteCount = Constants.UNREAD_FRIEND_REQUESTS = 0;
			}
			if(changed != frndButton.noteCount==0){
				updateNotificationCount();
			}
        }

        private function timelineButtonTriggeredHanlder(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_TIMELINE;
            if (owner is TimelineScreen){
                hide(true);
            } else {
                owner.dispatchExternalEvent(StackedScreen.TIMELINE_SECLECTED);
            }
        }


        private function notificationButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_NOTIFICATIONS;
            owner.dispatchExternalEvent(StackedScreen.NOTIFICATION_SELECTED);
        }

		private function mailButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_MAILS;
            owner.dispatchExternalEvent(StackedScreen.MAILS_SELECTED);
        }

		private function challengeNotesButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_CHALLENGE_NOTIFICATIONS;
            owner.dispatchExternalEvent(StackedScreen.CHALLENGE_NOTIFICATIONS_SELECTED);
        }

		private function leaderBoardButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            owner.dispatchExternalEvent(StackedScreen.LEADER_BOARD_SELECTED);
        }

        private function friendsButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_FRIENDS;
            if (owner is FriendsListPopUp){
                hide(true);
            }else{
                owner.dispatchExternalEvent(StackedScreen.FRIENDS_SELECTED);
            }
        }

        public function updateNotificationCount() : void{
			if(notificationButton){
                if (UsersProxy.loggedInUser()) {
                    notificationButton.noteCount = Constants.UNREAD_COMMON_NOTIFICATIONS
                } else {
                    Constants.UNREAD_COMMON_NOTIFICATIONS = 0;
                    notificationButton.noteCount = 0;
                }
			}

			if(challengeNotesButton) {
                if (UsersProxy.loggedInUser()) {
                    updateChallengeNotificationCount();
                } else {
                    challengeNotesButton.noteCount = 0;
                }
            }

			if(mailsButton) {
				if (UsersProxy.loggedInUser()) {
					updateMailCount();
				} else {
					mailsButton.noteCount = 0;
				}
            }

			if(toggleButton){
                toggleButton.updateNotification();
            }
        }

		public function updateChallengeNotificationCount():void{
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var challengesProxy:ChallengesProxy= facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            challengesProxy.getAllUnreadNotificationCount(function (count:int):void {
                MainMenuItem(challengeNotesButton).noteCount = count;
            });
		}

		public function updateMailCount():void{
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var mailsProxy:MailsProxy = facade.retrieveProxy(MailsProxy.NAME) as MailsProxy;
            mailsProxy.getUnreadCount(function (count:int):void {
                MainMenuItem(mailsButton).noteCount = count;
            });
		}

        public override function set  y(value : Number): void {
			super.y = value;
			if (backgroundImage){
				backgroundImage.y = - value;
                backgroundImage.height = actualHeight + Math.abs(value);
            }
		}

		public function toggle():void{
			isOpened ? hide(true) : show(true);
		}

		override protected function draw() : void {
			super.draw();

			if (isInvalid(INVALIDATION_FLAG_SIZE))
			{
				overlay.x = actualWidth;
				overlay.width = parentActualWidth - actualWidth;
				overlay.height = actualHeight;

				toggleButton.x = actualWidth + horizontalOffset / 2;
				toggleButton.y = verticalOffset / 2;

				backgroundImage.x = 0;
				backgroundImage.y = -this.y;
				backgroundImage.width  = actualWidth;
				backgroundImage.height = actualHeight + Math.abs(this.y);

				// logoutButton.y = verticalOffset;
				_buttonsContainer.x = horizontalOffset;
				_buttonsContainer.y = 0;
				_buttonsContainer.height = actualHeight /**.6*/;


				if(AlertView.language){

					if(pickerButton){
						pickerButton.updateWithLanguage(AlertView.language);
					}

					if(pickerButton2){
						pickerButton2.updateWithLanguage(AlertView.language);
					}
				}

				if (languagePickerList) {

					var facade : ApplicationFacade = ApplicationFacade.getInstance();
					var langProxy:LanguagesProxy= facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;

					if(langProxy.defaultLanguageCode=="en-US"){
						languagePickerList.visible = false;
					}

					if(!languagePickerList.dataProvider){


						if(langProxy.languages && AlertView.language){

							var index : int = -1;
							if (AlertView.language /*&& isInvalid("languages") &&*/ && langProxy.languages)
							{

								for (var i : int = 0; i < langProxy.languages.length; i++){
									if (AlertView.language.code == langProxy.languages[i].code) {
										index = i;
										break;
									}
								}
							}



							languagePickerList.dataProvider = new ListCollection(langProxy.languages);
							languagePickerList.selectedIndex = index;
							//languagePickerList.



						}
					}
					languagePickerList.width = logoutButton.width;
					languagePickerList.height = logoutButton.height;
					// languagePickerList.x = _signedIN ? actualWidth - logoutButton.width - 2 * horizontalOffset : logoutButton.x + 2 * logoutButton.width;
					// languagePickerList.y = logoutButton.y; //actualHeight - logoutButton.height - verticalOffset;

					languagePickerList.validate();
				}

				if(languagePickerList && languagePickerList.selectedItem)
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);



				//verSpacer.x = horizontalOffset;


				loginButton.x = (actualWidth - loginButton.width) / 2-horizontalOffset;
				/*if(Device.isIphoneX()){
					loginButton.x = (horizontalOffset + ((actualWidth-horizontalOffset) - loginButton.width) / 2)-5;
				}*/

                /*var tpad : Number = loginButton.height;
               if (Constants.isIOS){
                    tpad = (tpad / Constants.SCALE_FACTOR) - 5;
                }
                else {
                    tpad = 5;
                }*/

				//var temp_y : Number = (_buttonsContainer.y + _buttonsContainer.height) + (Math.abs((_buttonsContainer.y + _buttonsContainer.height) - verSpacer.y) - loginButton.height) / 2 + tpad;
				//loginButton.y = (!Constants.isIOS && Constants.SCALE_FACTOR != 2) ? temp_y  : temp_y - 5;
				loginButton.y = verticalOffset/2;
				avatarButton.y = verticalOffset/2;
				/*avatarButton.x = horizontalOffset;*/
                verSpacer.y = (avatarImage && avatarImage.visible)?(avatarImage.height + avatarImage.y + verticalOffset/2):(loginButton.height+loginButton.y + verticalOffset/2);

				if (avatarImage){
					avatarImage.width = avatarImage.height = avatarButton.width;
					avatarImage.x = avatarButton.x;
					avatarImage.y = avatarButton.y;
				}

				label.x = avatarImage?(avatarImage.width+avatarImage.x+horizontalOffset/2):42;
				label.y = avatarImage?(avatarImage.y+(avatarImage.height-label.height)/2):(avatarButton.y + (avatarButton.height -  label.height) / 2);//avatarButton.y + (avatarButton.height -  label.height) / 2 - (Constants.isIOS ? 5 : 7);
				label.width = actualWidth - label.x - horizontalOffset;

				if(Device.isIphoneXVariant()){
					label.x+=12;
					label.width-=12;
				}

				if(userButtonContainer){
					var btnCount:int = -1;
					var btnWidth:Number = 0;
					var j:int;
					for(j = 0; j < userButtonContainer.numChildren; j++){
						if(userButtonContainer.getChildAt(j).visible){
							btnWidth += userButtonContainer.getChildAt(j).width;
                            btnCount ++;
						}
					}

                    verSpacer.visible = (btnCount != -1);
                    if(btnCount >= 1) {
                        var btnGap:Number = (userButtonContainer.width - btnWidth) / btnCount;
						var btnX:Number = 0;
                        for(j = 0; j < userButtonContainer.numChildren; j++){
                            if(userButtonContainer.getChildAt(j).visible){
                                userButtonContainer.getChildAt(j).x = btnX;
                                btnX += userButtonContainer.getChildAt(j).width + btnGap;
                            }
                        }
                    }else{
                        for(j = 0; j < userButtonContainer.numChildren; j++){
                            if(userButtonContainer.getChildAt(j).visible){
                                userButtonContainer.getChildAt(j).x = 0;
                                break;
                            }
                        }
					}
				}
				//updateStates();
			}
		}
	}
}
