package  com.despark.tuning3d.view.components.core{
	import flash.display3D.Context3D;
	import flash.display3D.Context3DBlendFactor;
	import flash.display3D.Context3DProgramType;
	import flash.display3D.Program3D;
	
	import starling.filters.FragmentFilter;
	import starling.textures.Texture;
	
	public class MaskFilter extends FragmentFilter {
		private var mShaderProgram:Program3D;
		private var mMaskTexture:Texture;
		
		private var mVars:Vector.<Number> = new <Number>[1,1,1,1];
		
		public function MaskFilter(maskTexture:Texture) {
			mMaskTexture = maskTexture;
		}
		
		protected override function activate(pass:int, context:Context3D, texture:Texture):void {
			context.setTextureAt(1,mMaskTexture.base);
			
			
			
			//context.setBlendFactors(Context3DBlendFactor.SOURCE_ALPHA, Context3DBlendFactor.ONE_MINUS_SOURCE_ALPHA);
			context.setProgramConstantsFromVector(Context3DProgramType.FRAGMENT, 0, mVars, 1); 
			context.setProgram(mShaderProgram);
		}
		
		protected override function createPrograms():void {  
			var fragmentProgramCode:String =
				"mov ft3, v0	\n" +
				"mul ft3, ft3, fc0	\n" +
				"tex ft0, v0, fs0 <2d, clamp, linear, mipnone>	\n" +
				"tex ft1, ft3, fs1 <2d, clamp, linear, mipnone>  \n" + 
				//"mov ft1.x, fc0.w \n"+   
				//"sub ft1.w, fc0.x, ft1.y \n"+   
				//"sub ft1.w, fc0.x, ft1.w" + "\n" +
				
				"mul ft0, ft1, ft0				\n" +  
				"mov oc, ft0";  
			//	"mov oc, ft1";  
			mShaderProgram = assembleAgal(fragmentProgramCode);
		}
		
		public function set scale(value:Number):void { 
			
			mVars[0]=1/value;
			mVars[1]=1/value;
			mVars[2]=1/value;
			mVars[3]=1/value;
			
			
		}
		
		
		
		protected override function deactivate(pass:int, context:Context3D, texture:Texture):void {
			context.setTextureAt(1,null);
			context.setBlendFactors(Context3DBlendFactor.ONE, Context3DBlendFactor.ZERO);  
		}
		
		public override function dispose():void {
			if (mShaderProgram) mShaderProgram.dispose();
			super.dispose();
		}
	}
}
import com.despark.tuning3d.view.components.core.MaskFilter;

