package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.parts.PartMaterial;

import flash.geom.Rectangle;

import starling.display.Image;
import starling.display.Quad;
import starling.textures.Texture;

public class MaterialItemRenderer extends ListItemRenderer
	{
		
		public var language : Language;
		
		private var quad : Quad;
		private var HELPER_RECTANGLE : Rectangle = new Rectangle();
		
		public static const HEIGHT:Number=50;
		private var bagroundSelectedState:Image;
		
		private var bagroundState:Image;
		
		override public function dispose():void{
			

			HELPER_RECTANGLE=null;
			
			
			
			language=null;
			data=null;
			
			super.dispose();
			
			
			
		}
				
		public function MaterialItemRenderer()
		{
			super();
			
			fontSize = 11;
			_textColor = 0xffffff;
			
			_bold=false;
			
			//Tuning3D.memLeakTest.addEventListener(MemLeakTest.GLOBAL_EVENT, onGlobalEventMemLeakTest2,false, 0, true);
			
			//useBitmapFont = true;
		}
		
		
		protected override function initialize() : void
		{	
			quad = new Quad( 1,  1, 0xffffff);
			quad.alpha=0;
			//quad.touchable = false;
			addChild(quad);
			
			var scale:Number=ButtonFactory.assetManager.scaleFactor/2;
			
			
			var texture:Texture = ButtonFactory.assetManager.getTexture("a_partslot_bg_selected");
			
			
			//var bagroundSelectedStateTexture:Scale3Textures=new Scale3Textures(ButtonFactory.assetManager.getTexture("a_partslot_bg_selected"), 25.5/scale, 25.5/scale);
			
			
			bagroundSelectedState=new Image(texture);
			bagroundSelectedState.scale9Grid = new Rectangle(25.5/scale, 0, 25.5/scale, texture.frameHeight);  //tt scale под вопросом нужно ли
			bagroundSelectedState.visible=false;
			
			addChild(bagroundSelectedState);
			
			
			texture = ButtonFactory.assetManager.getTexture("a_partslot_bg");
			//var bagroundStateTexture:Scale3Textures=new Scale3Textures(ButtonFactory.assetManager.getTexture("a_partslot_bg"), 25.5/scale, 25.5/scale);
			
			
			bagroundState=new Image(texture);
			bagroundState.scale9Grid = new Rectangle(25.5/scale, 0, 25.5/scale, texture.frameHeight);
			bagroundState.visible=false;
			
			addChild(bagroundState);
			
			super.initialize();
		
			
			label.paddingBottom=0;
			label.paddingTop=0;
			label.paddingLeft=0;
			label.paddingRight=0;    
			
			
			 
			
			
			imageLoader.visible = false;
		}
		
		public function get material() :PartMaterial
		{
			return data as PartMaterial;
		}
		
		protected override function commitData() : void {
			super.commitData();
			if(!language){
				return;
			}
			var text : String = material.label;
			label.text = text;
		}

		override protected function draw():void{
			super.draw();
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			if(sizeInvalid) {
				quad.width = actualWidth;
				quad.height = actualHeight;
			}
		}

		protected override function layout() : void {
			super.layout();
			//label.y = 4.5;
			//if(!FontSelector.embedFonts())
			//	label.y = 5.5;   
			label.width = actualWidth;
			label.y=((HEIGHT-label.height)/2)-1;
			//label.height = actualHeight;
			bagroundSelectedState.width=actualWidth;
			bagroundSelectedState.height=25;
			bagroundSelectedState.y=(HEIGHT-bagroundSelectedState.height)/2;

			bagroundState.width=actualWidth;
			bagroundState.height=25;
			bagroundState.y=(HEIGHT-bagroundState.height)/2;
		}
		
		/*override public function hitTest(localPoint : Point, forTouch : Boolean = false) : DisplayObject
		{
			if(getBounds(this, HELPER_RECTANGLE).containsPoint(localPoint))
			{
				return label;
			}
			
			return super.hitTest(localPoint, forTouch);
		}*/
		
		protected override function autoSizeIfNeeded() : Boolean
		{
			var needsWidth : Boolean = isNaN(explicitWidth);
			var needsHeight : Boolean = isNaN(explicitHeight);
			
			if(!needsWidth && !needsHeight)
			{
				return false;
			}
			
			label.width = NaN;
			label.height = NaN;
			label.validate();
			
			var newWidth : Number = explicitWidth;
			
			//label.y = 4.5;
			
			//if(!FontSelector.embedFonts())
			//	label.y = 5.5;   
			
			if(needsWidth)
			{
				newWidth = Math.ceil(label.width) + 25;
				label.width = newWidth;
			}
			
			var newHeight : Number = explicitHeight;
			
			if(needsHeight)
			{
				newHeight = HEIGHT;
				label.height = HEIGHT;
			}
			
			//partSlotNameWidthsMap[partSlot.name] = newWidth;
			
			
			 
			bagroundSelectedState.width=actualWidth;
			bagroundSelectedState.height=25;
			bagroundSelectedState.y=(HEIGHT-bagroundSelectedState.height)/2;
			
			
			bagroundState.width=actualWidth;
			bagroundState.height=25;
			bagroundState.y=(HEIGHT-bagroundState.height)/2;
			
			
			return setSizeInternal(newWidth, HEIGHT, false);
		}
			
		protected override function commitSelection() :void
		{
			super.commitSelection();
			
			//textColor = isSelected ?  0xffffff:   0xc0c2c2;      
			
			if(isSelected){  
				
				textColor=0x414141;
			}else{
				
				textColor=0xffffff;
			}
			
			bagroundSelectedState.visible=isSelected;
			bagroundState.visible=!isSelected;
		}
		
		public override function get useEmbeddedFont() : Boolean 
		{
			if(!language){
				return null;
			}
			
			return language.supportsEmbeddedFont;
		}
	}
}



