
package com.despark.tuning3d.view.components.core 
{
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.utils.FontSelector;
	
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Button;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.ITextRenderer;

	public class MultilingualButton extends Button implements Multilingual
	{
		public var textFormat : TextFormat;
		//public var wordWrap : Boolean; //tt
		public var isHTML : Boolean=true;
		
		public function updateWithLanguage(language : Language) : void
		{
			labelFactory = function() : ITextRenderer
			{
				
				var bold:Boolean=false;
				
				if(textFormat){
					
					bold=textFormat.bold;
				}
				
				var italic:Boolean=false;
				
				
				if(textFormat){
					
					italic=textFormat.italic;  
				}
				
				var color:uint=0x000000;
				if(textFormat){
					
					color=textFormat.color as uint;  
				}
				
				var size:int=12;
				
				if(textFormat){
					
					size=textFormat.size as int;
				}
				
				
				var align:String=TextFormatAlign.LEFT;   
				
				if(textFormat){
					
					align= textFormat.align;  
				}
				
				var underline:Boolean=false;
				if(textFormat){
					
					underline= textFormat.underline;  
				}
				
				var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();// TODO
				if(align==TextFormatAlign.LEFT){
					
					textRenderer.width=this.actualWidth;
				}
				     
				  
				
				
				textRenderer.textFormat = new TextFormat(FontSelector.getFont(), size, color);
				textRenderer.textFormat.align = align;  
				textRenderer.textFormat.bold=bold; 
				textRenderer.textFormat.italic=italic;   
				textRenderer.textFormat.underline=underline;
				textRenderer.isHTML=isHTML;
				textRenderer.embedFonts = FontSelector.embedFonts();//language.supportsEmbeddedFont;
				textRenderer.wordWrap = wordWrap;    
				
				//textRenderer.snapToPixels=false; //tt 
				
				return textRenderer;
			}
		}
	}
}