package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.brands.PacketItemRenderer;
	import com.distriqt.extension.inappbilling.Purchase;
	import com.utils.FontSelector;

import feathers.controls.Button;
import feathers.controls.List;
import feathers.controls.ScrollBar;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.FeathersControl;
import feathers.data.ListCollection;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;
import feathers.layout.Direction;
	import feathers.utils.display.stageToStarling;

	import flash.geom.Rectangle;
	import flash.html.script.Package;
	import flash.text.TextFormat;
import flash.text.TextFormatAlign;


import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class PackagesView extends FeathersControl implements Multilingual
	{
		
		public static const BUY_NOW_PACKET:String="BUY_NOW_PACKET";
		public static const PACKAGES_VIEW_CALC_WIDTH_END:String="PACKAGES_VIEW_CALC_WIDTH_END";
        public static const SHOW_NO_COIN_POP_UP: String = 'SHOW_NO_COIN_POP_UP';
        public static const SHOW_CONFIRM_POP_UP: String = 'SHOW_CONFIRM_POP_UP';
		public static const UPDATE_CAR_PACKAGES: String = "UPDATE_CAR_PACKAGES";


		public static const VIEW_CAR_360 : String = "VIEW_CAR_360";
		
		
		public static var assetManager : AssetManager;
		public static var language : Language;
		
		private var overlay:Button;  
		private var backgroundHeadImage:Image;
		private var backgroundImage:Image;
		
		private var closeButton:Button;
		
		private var backButton:MultilingualButton;
		
		private var label : MultilingualLabel;
		private var _text : String;
		
		private var selectedPacketView:PacketView;
		
	
		private var packetView:PacketView;

		
		private var mainList : List;
		
		private var _dataProvider:Array;
		
		private var _featuredArrow:Image;
		
		//private var _
		
		//public static var PACKAGE_ITEM_WIDTH:Number = 242;//Device.isIos() ? 242 : Constants.SCALE_FACTOR==3.375 ? 242 : 242;
		
		public static var ITEM_COUNT:int=0;
		
		public static var calacItemCount:Boolean=true;
		
		private var _parentActualWith:Number;
		private var _parentActualHeight:Number;   
		
		public static var PACKAGE_ITEM_WIDTH:Number = 262;

		public static function getPackageItemWidth():Number{
			return (Device.isIos() ? 262 : Constants.SCALE_FACTOR==3.375 ? 252 : 262) + (Device.isIphoneXVariant()?25:0);
		}


		public function PackagesView() {
			super();
			PACKAGE_ITEM_WIDTH = getPackageItemWidth();
			PackagesView.ITEM_COUNT = 0;
		}
		
		
		public function set parentActualWith(value:Number):void{
			_parentActualWith = value;
			var packetViewWidth:Number = parentActualWith-PACKAGE_ITEM_WIDTH + 20;
			if(selectedPacketView){
				selectedPacketView.hideX =- (packetViewWidth - (PACKAGE_ITEM_WIDTH - 20));
				selectedPacketView.showX = (PACKAGE_ITEM_WIDTH - 20);
			}
			
			if(packetView){
				packetView.hideX =- (packetViewWidth - (PACKAGE_ITEM_WIDTH - 20));
				packetView.showX = (PACKAGE_ITEM_WIDTH - 20);
			}
		}
		
		
		public function get parentActualWith():Number{
			return _parentActualWith;
		}
		
		public function set parentActualHeight(value:Number):void{
			_parentActualHeight=value;
		}
		
		public function get parentActualHeight():Number{
			return _parentActualHeight;
		}
		
		public function packetPurchaseSuccess(packet:Packet):void{
			var i:int;
			var pc:Packet;
			if(this.mainList){
				if (packet.type == Packet.TYPE_ALLPACKET) {
					for (i = 0; i < mainList.dataProvider.length; i++) {
						pc = mainList.dataProvider.getItemAt(i) as Packet;
						pc.lock = false;
					}
				} else {
					for (i = 0; i < mainList.dataProvider.length; i++) {
						pc = mainList.dataProvider.getItemAt(i) as Packet;
						if (pc.id == packet.id) {
							mainList.dataProvider.removeItemAt(i);
							mainList.dataProvider.addItemAt(packet, i);
							break;
						}
					}
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.validate();
			}
		}

		public function packetPurchaseUpdate(purchase:com.despark.tuning3d.model.packages.Purchase):void{
			if(this.mainList && mainList.dataProvider){
				for(var i:int = 0; i < mainList.dataProvider.length; i++){
					var pc:Packet = mainList.dataProvider.getItemAt(i) as Packet;
					if(pc.id == purchase.id){
						pc.lock = false;
						mainList.dataProvider.addItemAt(mainList.dataProvider.removeItemAt(i), i);
						break;
					}
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.validate();
			}
		}

		public function clearPurchases():void{
			if(this.mainList){
				for(var i:int = 0; i < mainList.dataProvider.length; i++){
					var pc:Packet = mainList.dataProvider.getItemAt(i) as Packet;
					pc.lock = true;
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.validate();
			}
		}
		
		public function set dataProvider(value:Array):void{
			
			this.subpacksMode=false;
		//	trace("SETS111:", value);
			_dataProvider=value;
			text="CAR PACKAGES";
			
			invalidate("data_provider");
		}
		
		public function get dataProvider():Array{
			
			return _dataProvider;
		}
		
		private var _language:Language=null;
		
		public function updateWithLanguage(language:Language):void
		{
			_language=language;
			
			if(backButton)
				backButton.updateWithLanguage(language);
			
			if(label)
				label.updateWithLanguage(language);
			
			
			if(selectedPacketView)
				selectedPacketView.updateWithLanguage(language);
			
			
			if(packetView)
				packetView.updateWithLanguage(language);

			
			if(mainList && mainList.dataProvider){
				
				for(var i:int=0; i<mainList.dataProvider.length; i++){
					
					mainList.dataProvider.updateItemAt(i);  
				}
			}
			
			text=this._language.translate("mob_home", "featured");  
			
			
		}
		
		protected override function initialize() : void
		{
			super.initialize();
			//Constants.
			//var t:Constants
			var packetViewWidth:Number;
			overlay=new Button();
			overlay.defaultSkin=new Quad((Constants.STAGE_WIDTH-PACKAGE_ITEM_WIDTH)+12, 1, 0x000000);  
			overlay.defaultSkin.alpha=0.0;   
			overlay.addEventListener(Event.TRIGGERED, onTouchOverlay);
			addChild(overlay);
			

			packetView=new PacketView(); //-actualWidth), actualWidth-20 );


			packetView.addEventListener(PacketView.BUY_NOW_PACKET, onBuyNowPacket);


			packetView.addEventListener(PacketView.VIEW_CAR_360, viewCar360);

            packetView.addEventListener(PacketView.SHOW_NO_COIN_POP_UP, showNoCoinPopUp);
            packetView.addEventListener(PacketView.SHOW_CONFIRM_POP_UP, showConfirmPopUp);

			packetViewWidth = parentActualWith-PACKAGE_ITEM_WIDTH+20;
			packetView.setSize((packetViewWidth), actualHeight);

			packetView.hideX=-(packetViewWidth-(PACKAGE_ITEM_WIDTH-20));


			packetView.showX=(PACKAGE_ITEM_WIDTH-20);

			packetView.hide();
			addChild(packetView);
			
			
			
			selectedPacketView=new PacketView(); //-actualWidth), actualWidth-20 );
			
			
			selectedPacketView.addEventListener(PacketView.BUY_NOW_PACKET, onBuyNowPacket);
			
			
			selectedPacketView.addEventListener(PacketView.VIEW_CAR_360, viewCar360);
            selectedPacketView.addEventListener(PacketView.SHOW_NO_COIN_POP_UP, showNoCoinPopUp);
            selectedPacketView.addEventListener(PacketView.SHOW_CONFIRM_POP_UP, showConfirmPopUp);
			packetViewWidth = parentActualWith-PACKAGE_ITEM_WIDTH+20;
			selectedPacketView.setSize((packetViewWidth), actualHeight);
			
			selectedPacketView.hideX=-(packetViewWidth-(PACKAGE_ITEM_WIDTH-20));             
			

			selectedPacketView.showX=(PACKAGE_ITEM_WIDTH-20);      
			
			selectedPacketView.hide();
			
			
			
			addChild(selectedPacketView);	
			
			
			
			
			
			
			
			var backgroundTexture : Texture = assetManager.getTexture("controlBackground");
			//backgroundTexture.
			//var backgroundTextures : Scale9Textures = new Scale9Textures(backgroundTexture, new Rectangle(10, 10, 10, 10));
			
			backgroundImage = new Image(backgroundTexture);
			backgroundImage.scale9Grid = new Rectangle(10, 10, 10, 10);
			backgroundImage.alpha = 1.0;
		   //	backgroundImage.color = 0x222728;
			addChild(backgroundImage);	
			
			
			var backgroundHeadTexture:Texture = assetManager.getTexture("featured_title");  
			//var backgroundHeadTextures:Scale3Textures=new Scale3Textures(backgroundHeadTexture, 190, 16);
			
			backgroundHeadImage = new Image(backgroundHeadTexture);
			backgroundHeadImage.scale9Grid = new Rectangle(190,0,16, backgroundHeadTexture.frameHeight);
			addChild(backgroundHeadImage);
			
			label = new MultilingualLabel();
			label.textFormat = new TextFormat(FontSelector.getFont(true),  13, 0xffffff );
			label.textFormat.align = TextFormatAlign.CENTER;
			label.textFormat.bold=true;
			label.wordWrap = true;
			addChild(label); 
			
			
			closeButton= ButtonFactory.popupCloseButton(15,15);
			(closeButton as SimpleExtendedButton).hitAreaPadding = 30;

			//closeButton.  
			
			closeButton.addEventListener(Event.TRIGGERED, backButtonTriggeredHandler);
			
			addChild(closeButton);
			
			var mainListLayout :VerticalLayout = new VerticalLayout();
			//mainListLayout.manageVisibility = true; //tt
			mainListLayout.paddingTop = 0;
			mainListLayout.useVirtualLayout = false;
			
			mainListLayout.scrollPositionVerticalAlign=VerticalAlign.TOP;
			//mainListLayout.
			
			
			mainList = new List();
			mainList.clipContent = true;
			mainList.layout = mainListLayout;
			mainList.scrollBarDisplayMode=ScrollBarDisplayMode.FIXED;
			mainList.horizontalScrollPolicy = ScrollPolicy.OFF;
//			mainList.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO , touchPacketInfo );
			mainList.addEventListener(PacketItemRenderer.ITEM_RECIEVE_WIDTH , onItemRecieveWidth );
			mainList.addEventListener("itemSelectedAgain", mainListItemSelectedAgain);
			mainList.addEventListener(Event.CHANGE, changePacketItem);
			mainList.itemRendererFactory = function() : IListItemRenderer
			{
				var renderer:PacketItemRenderer = new PacketItemRenderer();
				renderer.setSize(PackagesView.PACKAGE_ITEM_WIDTH, 50);     
				return renderer;
			};
				
			mainList.verticalScrollBarFactory = function ():ScrollBar
			{
				var scrollbar:ScrollBar = new ScrollBar();
				scrollbar.direction = Direction.VERTICAL;
				scrollbar.thumbFactory = function ():Button
				{
					var button:Button = new Button();
					var sprite:Sprite=new Sprite();
					var back:Quad = new Quad(15, 25, 0xffffff);   
					back.alpha=0;
					var quad:Quad = new Quad(3, 25, 0xc1c3c3);  
					sprite.addChild(back);
					sprite.addChild(quad);
					button.defaultSkin = sprite;
					
					return button;
				};
				
				return scrollbar;
			};
				
			addChild(mainList);
			
			var featuredArrowTexture:Texture = assetManager.getTexture("slide_arr_lt");
			_featuredArrow=new Image(featuredArrowTexture);
			_featuredArrow.pivotX = _featuredArrow.width/2;
			_featuredArrow.pivotY = _featuredArrow.height/2;
			_featuredArrow.rotation = - Math.PI/2;
			_featuredArrow.scaleX  = 0.7;
			_featuredArrow.scaleY  = 0.7;

			addChild(_featuredArrow);    
		}

		private function showNoCoinPopUp(event: Event): void {

            if(subpacksMode)
            {
                dataProvider=_dataProvider;
            }else{
                if(this.selectedPacketView && selectedPacketView.visible){
                    selectedPacketView.hide(true);
                }
            }
            this.dispatchEventWith(SHOW_NO_COIN_POP_UP);
		}

        private function showConfirmPopUp(event: Event): void {

            if(subpacksMode)
            {
                dataProvider=_dataProvider;
            }else{
                selectedPacketView.hide(true);
            }
            this.dispatchEventWith(SHOW_CONFIRM_POP_UP, false, {packet: selectedPacketView.packet});
        }

		private function viewCar360(event:Event):void{
			
			var car:Car=event.data.car;
			//this.
			this.dispatchEventWith(VIEW_CAR_360, false, {car:car, packet:selectedPacketView.packet});
			
			selectedPacketView.hide(true, function():void{
				hide(false);
			});
			
		}
		
		private function onBuyNowPacket(event:Event):void{
			
			var packet:Packet=event.data.packet;
			dispatchEventWith(BUY_NOW_PACKET, false, {packet: packet});    
			
			
		}
		
		public function updateLists():void{
			
			if(mainList && mainList.dataProvider){
				  
				for(var i:int=0; i<mainList.dataProvider.length; i++){
					
					mainList.dataProvider.updateItemAt(i);
				}
				
				mainList.invalidate();
			}
			
			if(selectedPacketView){
				selectedPacketView.updateLists();	
			}
			
			if(packetView){

				packetView.updateLists();
			}
			
		}
		
		private function onItemRecieveWidth(event:Event):void{
			
			//PACKAGE_ITEM_WIDTH
			
			//ITEM_COUNT
			

			if(this.mainList.dataProvider)

			if(this.mainList.dataProvider && mainList.dataProvider.length<=ITEM_COUNT){
				
				if(OLD_PACKET_ITEM_WIDTH!=PACKAGE_ITEM_WIDTH){
					
					dispatchEventWith(PACKAGES_VIEW_CALC_WIDTH_END, false, {width:PACKAGE_ITEM_WIDTH});
					OLD_PACKET_ITEM_WIDTH=PACKAGE_ITEM_WIDTH;
					
				}
			}
		}
		
		public static var OLD_PACKET_ITEM_WIDTH:Number=262;    
		
		private function mainListItemSelectedAgain(event:Event):void{
			if(selectedPacketView.visible){
				this.mainList.selectedIndex=-1;
				selectedPacketView.hide(true);
			}
		}
		
		private var completeShowFlag:Boolean=true;
		private var subpacksMode:Boolean=false;
		protected function changePacketItem(event:Event=null):void{
			    
			
			if(!completeShowFlag){
				
				Starling.juggler.delayCall(changePacketItem, 0.64);      
				return;
				
			}
			
			
			if(mainList.selectedIndex<0)  
				return;

			SoundManager.playSound(SoundManager.SELECT_PART);
			var packet:Packet=mainList.selectedItem as Packet;
			
			if(packet==selectedPacketView.packet && selectedPacketView.visible)  
				return;   
			

			if(packet.subpacks==null){
				
				//mainList.selectedIndex=-1;
				
				//dispatchEventWith(PacketItemRenderer.ITEM_TOUCH_PACKET, false, {packet:packet});
				if(mainList.selectedIndex>=0){
					
					var tmpPacketView:PacketView=selectedPacketView;
					
					this.swapChildren(selectedPacketView, packetView);
					
					selectedPacketView=packetView;
					
					packetView=tmpPacketView;
					
					
					   
					
					//selectedPacketView.hide(true, function(){   
					
						selectedPacketView.packet=packet;
						
						selectedPacketView.x=selectedPacketView.hideX;  
						completeShowFlag=false;
						selectedPacketView.show(true, function():void{
						
							completeShowFlag=true;
						
							
							BrandsScreen.adsBlocker=true;
							//packetView.hide(); 
						});  
						
						packetView.hideRight(true);    
					//});
				
				}else{
					selectedPacketView.packet=packet;
					completeShowFlag=false;
					selectedPacketView.show(true, function():void{
					
						completeShowFlag=true;
					});   
				}
				
				
				
			}else{
				
				mainList.dataProvider=new ListCollection(packet.subpacks);
				subpacksMode=true;
			    this.text=packet.title.toLocaleUpperCase();
				
			}
			
			
		}
		protected function touchPacketInfo(event:Event):void{
			
			var packet:Packet=event.data.packet as Packet;

			this.dispatchEventWith(PacketItemRenderer.TOUCH_PACKET_INFO, false, {packet:packet});
		}
		
		public function get text():String
		{
			return _text;
		}
		
		public function set text(value:String):void
		{
			_text = value;
			invalidate("text");
		}
		
		private function onTouchOverlay(event:Event):void{
			
			
			hide(true);  
		}
		
		private function backButtonTriggeredHandler(event : Event) : void 
		{
			
			if(subpacksMode)
			{
				
				dataProvider=_dataProvider;   
				
			}else{
				
				if(this.selectedPacketView && selectedPacketView.visible){
					
					selectedPacketView.hide(true, function():void{
						hide(true);
					});
				}else{
					
					hide(true);
				}
			
			}
			//dispatchEventWith(BrandsScreen.GARAGE_SELECTED);	
		}
		
		
		public function hide(animation:Boolean=false):void{
			if(visible && stage){
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			}
			BrandsScreen.adsBlocker=false;
			if(animation){
				
				var tween : Tween = new Tween(this, 0.35, Transitions.EASE_IN_OUT);
				tween.moveTo(-this.actualWidth, 0);//fadeTo(1.0);
				
				tween.onComplete=completeHide;
				//tween.addEventListener( Transitions.
				Starling.juggler.add(tween);
			
			}else{
				
				if(mainList)
				mainList.selectedIndex=-1;  
				
				if(packetView)
				packetView.hide();  
				
				
				completeHide();
				
			}
			
		
			
		}
		
		private var completeShowCallback:Function=null;
		
		public function show(animation:Boolean=false, complete:Function=null):void{
			
			
			
			completeShowCallback=complete;  
			
			if(_language){
			
				text=this._language.translate("mob_home", "featured");  
			
			}else{
				
				text="Featured";
			}
			
			

			
			if(animation){
			
				this.x=-this.actualWidth;
			}else{
				
				this.x=0;
			}
			
			this.visible=true;   
		
			if(animation){
				var tween : Tween = new Tween(this, 0.5, Transitions.EASE_IN_OUT);
				tween.moveTo(0, 0);
				
				tween.onComplete=completeShow;
				Starling.juggler.add(tween);
			}else{
				
				completeShow();
			}
		}
		
		
		private function completeHide():void{
			visible=false;
			dispatchEventWith(Event.CLOSE);
			
			if(this.mainList)  
			this.mainList.selectedIndex=-1;
			
		}
		
		private function completeShow():void{
			
			this.dispatchEventWith(Event.OPEN);
			
			if(completeShowCallback){
				
				completeShowCallback();
				completeShowCallback=null;
			}
			
		}
		
		public function updateItemAt(index:int):void{
			
			if(mainList && mainList.dataProvider){
				
				if(mainList.selectedIndex==index){
					
					mainList.selectedIndex=-1;
					
					if(selectedPacketView && selectedPacketView.visible)
						selectedPacketView.hide(true); 
				}
				mainList.dataProvider.updateItemAt(index);
			}
		}
		
		public function showPacket(packet:Packet):void{
			
			show(true, function():void{
			
			
				if(_dataProvider){
					
					
					for(var i:int=0; i<_dataProvider.length; i++){
						
						if(_dataProvider[i].id==packet.id){
							
							//trace("MAINLIST set selectedIndex=", i);
							
							if(mainList.selectedIndex>=0)
							mainList.selectedIndex=-1;
							
							mainList.selectedIndex=i;
							
							mainList.scrollToDisplayIndex(i);  
						}
					}
				}
			
			});
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid("data_provider")){
				
				this.mainList.dataProvider=new ListCollection(_dataProvider);
				
				if(this.mainList.dataProvider.length*40>actualHeight-85){
					
					_featuredArrow.visible=true;
				}else{
					
					_featuredArrow.visible=false;
				}
				
			}
			
			if(isInvalid("text"))
			{
				if(PackagesView.language)
				{
					label.updateWithLanguage(PackagesView.language);
				}
				else 
				{
					var l:Language = new Language(null);
					l.code = "en-US";
					label.updateWithLanguage(l);
				}   
				
				label.text = text;
				
				
			}
			
			//var autoSizeNeeded : Boolean = autoSizeIfNeeded();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				overlay.x=(PACKAGE_ITEM_WIDTH-20); 
				overlay.width=(parent.width-actualWidth)+20;
				overlay.height=actualHeight;
				
				
				selectedPacketView.setSize((parent.width-actualWidth)+20, actualHeight);
				
				packetView.setSize((parent.width-actualWidth)+20, actualHeight);
				
				
				backgroundHeadImage.x=0;
				backgroundHeadImage.y=0;
				
				backgroundHeadImage.width=actualWidth;
				
				closeButton.x=backgroundHeadImage.width-closeButton.width - 15;
				closeButton.y=(backgroundHeadImage.height-closeButton.height) /2;
			
			
				
				
				label.x = 0;
				label.width = actualWidth;
				label.y = 10;
				   
				
				backgroundImage.x=-20;
				backgroundImage.width = actualWidth + 20;
				backgroundImage.height = actualHeight;
				
				
				//backButton.x=0;
				//backButton.y=actualHeight-backButton.height;
				
				mainList.x=0;
				mainList.y = 40;
				mainList.width = actualWidth;
				mainList.height = actualHeight-85;
				
				
				_featuredArrow.x=(actualWidth)/2;
				
				_featuredArrow.y=actualHeight-(_featuredArrow.height/2+10);
			}
		}

		public function updateTempOpenPacket(packet:Packet):void {
			for(var i:int = 0; i < mainList.dataProvider.length; i++){
				var pkt:Packet = mainList.dataProvider.getItemAt(i) as Packet;
				if(pkt && pkt.id == packet.id){
					pkt.lock = false;
					pkt.tempOpened = packet.tempOpened;
					mainList.dataProvider.updateItemAt(i);
					break;
				}
			}
		}
	}
}