package com.despark.tuning3d.view.components.core
{
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.Notifications;

import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.brands.BuyPacketItemRenderer;
import com.distriqt.AdsManager;
import com.distriqt.GameService;
import com.utils.FontSelector;
import com.utils.Tracker;

import feathers.controls.Button;
import feathers.controls.List;
import feathers.controls.ScrollBar;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollContainer;
import feathers.controls.renderers.IListItemRenderer;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
import feathers.data.ListCollection;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;
import feathers.layout.Direction;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;


import mx.utils.StringUtil;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
	import starling.display.DisplayObjectContainer;
	import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.utils.AssetManager;

public class PacketView extends FeathersControl implements Multilingual
	{
		
		public static const BUY_NOW_PACKET : String = "buyNowPacket";
		
		public static const VIEW_CAR_360 : String = "VIEW_CAR_360";

		public static const SHOW_NO_COIN_POP_UP: String = 'SHOW_NO_COIN_POP_UP';
		public static const SHOW_CONFIRM_POP_UP: String = 'SHOW_CONFIRM_POP_UP';
		
		//public static const PACKAGES_VIEW_CALC_WIDTH_END:String="PACKAGES_VIEW_CALC_WIDTH_END";
		public static var assetManager : AssetManager;
		public static var language : Language;
		
		
		private var _titleDisplay:TextFieldTextRenderer=null;
		
		private var _background:Quad=null;
		
		private var _buyNowButton:MultilingualButton=null;
		private var _buyNowButton2:MultilingualButton=null;

		private var _buy3DCoinButton1: MultilingualButton = null;
		private var _buy3DCoinButton: MultilingualButton = null;
        private var _orLabel:TextFieldTextRenderer;

		private var _textLabel:TextFieldTextRenderer;
		
		
		private var _carList:List;
		
			
		
		private var _packet:Packet=null;
		
		
		
		private var _hideX:Number=0;
		private var _showX:Number=0;
		
		
		private var packNameLabel:TextFieldTextRenderer;
		//private var _featured360:Image;
		
		private var container : ScrollContainer;
		
		private var quadDown:Quad;
		
		private var _textFontSize:int=10;
		
		private var _titleFontSize:int=13;
		
		
		private var _priceDisplay:TextFieldTextRenderer=null;
		
		
		public function PacketView()
		{
			super();
			
			if(Constants.SCALE_FACTOR==4){
				_textFontSize=8;
				_titleFontSize=10;  
			}
			//PackagesView.ITEM_COUNT=0;
		}
		
		
		public function get showX():Number{
			
			return _showX;
		}
		
		
		public function set showX(value:Number):void{
			
			_showX=value;
		}
		
		
		
		public function get hideX():Number{
			
			return _hideX;   
		}
		
		
		public function set hideX(value:Number):void{
			
			_hideX=value;  
		}

		
		public static function calcOptimalFontSizeForWidth(text:String,  fontSize:uint, maxWidth:Number, maxHeight:Number):uint{
			
			var labelTmp : MultilingualLabel=new MultilingualLabel();
			
			labelTmp.updateWithLanguage(AlertView.language);
			labelTmp.textFormat = new TextFormat(FontSelector.getFont(true), fontSize, 0xFFFFFF );
			labelTmp.textFormat.align = TextFormatAlign.LEFT;
			labelTmp.wordWrap = true;
			labelTmp.text=text;  
			labelTmp.width=maxWidth;
			labelTmp.height=NaN;
			labelTmp.validate();

            Tracer.print("labelTmp.height:"+labelTmp.height + fontSize);
			if(labelTmp.height>maxHeight){
				
				return calcOptimalFontSizeForWidth(text, fontSize-1, maxWidth, maxHeight );
			}else{
				
				return fontSize;
			}
			
		}
	
	
		
		public function set packet(value:Packet):void{      
			_packet=value;
			
			if(_textLabel){
				
				_textLabel.removeFromParent(true);
				_textLabel=null;
			}
			
			_textFontSize=10;
			_titleFontSize=13;
			
			if(Constants.SCALE_FACTOR==4){
				_textFontSize=8;
				_titleFontSize=10;
			}
			
			
				
			_textLabel = new TextFieldTextRenderer();
			_textLabel.textFormat=new TextFormat(FontSelector.getFont(), _textFontSize, 0x454545);
			_textLabel.wordWrap=true;
			
			_textLabel.isHTML=true;       
			
			//_textLabel.snapToPixels=false;    //tt
			
			_textLabel.embedFonts=FontSelector.embedFonts();
			
			container.addChild(_textLabel);
			
			
			
			
			
			/*_textLabel = new HyperlinkTextFieldTextRenderer();
			_textLabel.textFormat = new TextFormat(FontSelector.getFont(),  10, 0x454545 );
			_textLabel.embedFonts=FontSelector.embedFonts();
			_textLabel.textFormat.horizontalAlign = TextFormatAlign.LEFT;
			
			_textLabel.snapToPixels=false;
			//_textLabel.te
			//label.textFormat.
			_textLabel.wordWrap = true;
			container.addChild(_textLabel);*/
			
			invalidate("packet");
		}
		
		public function get packet():Packet{
			
			return _packet;
		}
		
		public function updateWithLanguage(language:Language):void
		{
			
			/*if(backButton)
				backButton.updateWithLanguage(language);
			
			if(label)
				label.updateWithLanguage(language);*/
			
			if(_titleDisplay){
				
				//_titleDisplay.updateWithLanguage(language);
			}
			
			if(_buyNowButton){
				
				_buyNowButton.label=AlertView.language.translate("mob_home", "buynow").toLocaleUpperCase();
				_buyNowButton.updateWithLanguage(language);
			}
			
			if(_buyNowButton2){  
				
				_buyNowButton2.label=AlertView.language.translate("mob_home", "buynow").toLocaleUpperCase();
				_buyNowButton2.updateWithLanguage(language);
			}



			if(_textLabel){
				
				//_textLabel.updateWithLanguage(language);
			}
			
			
		 
			
		}
		
		protected override function initialize() : void
		{
			super.initialize();
			
			
			
			
			_background=new Quad(1, 1,0xf2eded);
			addChild(_background);
			   
			
			container = new ScrollContainer();
			
			//container.
			
		//	container.layout.
			
			container.verticalScrollBarFactory = function ():ScrollBar
			{
				var scrollbar:ScrollBar = new ScrollBar();
				
				scrollbar.direction = Direction.VERTICAL;
				
				scrollbar.thumbFactory = function ():Button
				{
					var button:Button = new Button();  
					
					var sprite:Sprite=new Sprite();
					var back:Quad = new Quad(10, 25, 0xffffff);
					back.alpha=0;
					var quad:Quad = new Quad(3, 25, 0xc1c3c3);
					//quad.x
					sprite.addChild(back);
					sprite.addChild(quad);
					//=new S
					  
					button.defaultSkin = sprite;       
					
					return button;
				}
				
				return scrollbar;
			}
			
		//	container.
			//container.visible = false;
			/*container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 10;*/
			addChild( container );
			
		
		
			
			
			_titleDisplay=new TextFieldTextRenderer();
			
			
			_titleDisplay.textFormat = new TextFormat(FontSelector.getFont(true), _titleFontSize, 0x454545);
			_titleDisplay.textFormat.align = TextFormatAlign.LEFT;
			_titleDisplay.textFormat.bold=true;  
			_titleDisplay.wordWrap=true;
			_titleDisplay.isHTML=true;
			_titleDisplay.embedFonts=FontSelector.embedFonts();
			
			//_titleDisplay.snapToPixels=false; //tt
			//_titleDisplay.textFormat.
			//_titleDisplay.textFormat.italic=true;  
			addChild(_titleDisplay);  
			
			
			_priceDisplay=new TextFieldTextRenderer();
			_priceDisplay.textFormat=new TextFormat(FontSelector.getFont(), _textFontSize, 0x454545);
			_priceDisplay.wordWrap=false;
			_priceDisplay.textFormat.align=TextFormatAlign.CENTER;   
			
			_priceDisplay.isHTML=false;       
			
			//_priceDisplay.snapToPixels=false;    //tt
			
			_priceDisplay.embedFonts=FontSelector.embedFonts();
			
			addChild(_priceDisplay);
			
			    
			
			_buyNowButton=ButtonFactory.orangeButton("BUY NOW");
			_buyNowButton.addEventListener(Event.TRIGGERED, buyNowButtonnTriggeredHandler);
			addChild(_buyNowButton);

			_buy3DCoinButton1 = ButtonFactory.buy3dCoinButton();
            _buy3DCoinButton1.addEventListener(Event.TRIGGERED, buyCoin3DButtonTriggeredHandler);
			addChild(_buy3DCoinButton1);

            _orLabel=new TextFieldTextRenderer();
            _orLabel.textFormat=new TextFormat(FontSelector.getFont(), _textFontSize, 0x454545);
            _orLabel.wordWrap=false;
            _orLabel.textFormat.align=TextFormatAlign.CENTER;
            _orLabel.text = 'or';
            _orLabel.validate();
			addChild(_orLabel);
			
			
			_textLabel = new TextFieldTextRenderer();
			_textLabel.textFormat=new TextFormat(FontSelector.getFont(), _textFontSize, 0x454545);
			_textLabel.wordWrap=true;
			
			_textLabel.isHTML=true;
			
			_textLabel.embedFonts=FontSelector.embedFonts();
			
			//_textLabel.snapToPixels=false; //tt
			
			
			container.addChild(_textLabel);
			
			
			
		/*	_textLabel = new HyperlinkTextFieldTextRenderer();
			_textLabel.textFormat = new TextFormat(FontSelector.getFont(),  10, 0x454545 );
			_textLabel.embedFonts=FontSelector.embedFonts();
			_textLabel.textFormat.horizontalAlign = TextFormatAlign.LEFT;
			
			_textLabel.snapToPixels=false;
			
			//_textLabel.te
			//label.textFormat.
			_textLabel.wordWrap = true;
			container.addChild(_textLabel);*/     
			
			
			
			var carListLayout :VerticalLayout = new VerticalLayout();
			//carListLayout.manageVisibility = true; //tt
			carListLayout.paddingTop = 15;
			carListLayout.useVirtualLayout = false;
			
			carListLayout.scrollPositionVerticalAlign=VerticalAlign.TOP;
			carListLayout.gap=17;
			
			_carList=new List();
			
			_carList.clipContent = false;  
			_carList.layout = carListLayout;
			
			//_carList.addEventListener(BuyPacketItemRenderer.BUY_NOW_PACKET, this.buyNowPacket);  
			
			_carList.addEventListener(BuyPacketItemRenderer.VIEW_CAR_360, this.viewCar360);
			
			_carList.scrollBarDisplayMode=ScrollBarDisplayMode.FIXED;
			
			_carList.snapScrollPositionsToPixels=false;       
			_carList.itemRendererFactory = function() : IListItemRenderer
			{
				PACKET_VIEW_WIDTH=actualWidth-(32+20);
				var renderer:BuyPacketItemRenderer = new BuyPacketItemRenderer();   

				
				
				return renderer;   
			};
			container.addChild(_carList);
			
			
			
			packNameLabel=new TextFieldTextRenderer();
			
			packNameLabel.textFormat = new TextFormat(FontSelector.getFont(true, true), _titleFontSize, 0x454545);
			packNameLabel.textFormat.align = TextFormatAlign.CENTER;
			packNameLabel.textFormat.bold=true;
			packNameLabel.textFormat.italic=true;   
			
			//packNameLabel.snapToPixels=false; //tt
			
			packNameLabel.isHTML=true;
			packNameLabel.wordWrap=true;
			
			
			packNameLabel.embedFonts=FontSelector.embedFonts();
			container.addChild(packNameLabel);   
			
			
			_buyNowButton2=ButtonFactory.orangeButton("BUY NOW");
			_buyNowButton2.addEventListener(Event.TRIGGERED, buyNowButtonnTriggeredHandler);
			container.addChild(_buyNowButton2);



			_buy3DCoinButton = ButtonFactory.buyPacketByReward(0);
			_buy3DCoinButton.addEventListener(Event.TRIGGERED, buyCoin3DButtonTriggeredHandler);



            container.addChild(_buy3DCoinButton);
			
			quadDown=new Quad(1,10,0xffffff);
			quadDown.alpha=0;
			container.addChild(quadDown);
			
			
		}
		
		public static var PACKET_VIEW_WIDTH:Number;
		
		private function viewCar360(event:Event):void{
			
			
			
			var car:Car=event.data.car;
			dispatchEventWith(VIEW_CAR_360, false, {car:car});     
			
			//_carList.dataProvider.removeAll();   
			
		}
		
		private function buyNowPacket(event:Event):void{
			
			//trace("PacketView.buyNowButtonnTriggeredHandler");
			dispatchEventWith(BUY_NOW_PACKET, false, {packet:packet});     
		}

		private function buyCoin3DButtonTriggeredHandler(event: Event = null): void {
			GameService.$.getSaveData(function (data: String): void {
                Tracker.getInstance().trackEvent("click_buy_width_reward", 'click_buy_width_reward', 'click_buy_width_reward');
				var jsonData: Object = JSONer.parse(data);
				if (jsonData.rewards >= packet.coin3dFee) {
					dispatchEventWith(SHOW_CONFIRM_POP_UP);
				} else {
					AdsManager.$.rewardsCallback = buyCoin3DButtonTriggeredHandler;
                    dispatchEventWith(SHOW_NO_COIN_POP_UP);
				}
            })
		}

		private function buyNowButtonnTriggeredHandler(event : Event) : void
		{
			
			//trace("PacketView.buyNowButtonnTriggeredHandler");
			dispatchEventWith(BUY_NOW_PACKET, false, {packet:packet});     
		}
		
		public function hideRight(animation:Boolean=false):void{  
			
			//_completeHideCallback=complete;
			
			if(animation){
				
				var tween : Tween = new Tween(this, 0.65, Transitions.EASE_IN_OUT);
				tween.moveTo(this.showX+this.actualWidth, 0);//fadeTo(1.0);
				
				tween.onComplete=completeHide;    
				
				
				//tween.addEventListener( Transitions.
				Starling.juggler.add(tween);
				
			}else{
				
				
				completeHide();
				
			}
			
		}
		
		
		
		private var _completeHideCallback:Function=null
		public function hide(animation:Boolean=false, complete:Function=null):void{
			_completeHideCallback=complete;
			if(animation){
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
				var tween : Tween = new Tween(this, 0.35, Transitions.EASE_IN_OUT);
				tween.moveTo(_hideX, 0);//fadeTo(1.0);
				tween.onComplete=completeHide;
				//tween.addEventListener( Transitions.
				Starling.juggler.add(tween);
			}else{
				completeHide();
			}
			
		}
		
		override public function setSize(width:Number, height:Number):void{
			
			super.setSize(width, height);
			
			//_hideX=-width;  
			//private var _showX:Number=0;
		}
		
		private var _completeShowCallback:Function=null;
		
		public function show(animation:Boolean=false, complete:Function=null):void{
			
			_completeShowCallback=complete;
			if(this.container)
				this.container.verticalScrollPosition=0;  
			
			if(animation){
			
				this.x=_hideX;
			}else{
				
				this.x=_showX;
			}
			
			this.visible=true;   
		
			if(animation){
				var tween : Tween = new Tween(this, 0.65, Transitions.EASE_IN_OUT);
				tween.moveTo(_showX, 0);
				
				tween.onComplete=completeShow;
				Starling.juggler.add(tween);
			}else{
				
				completeShow();
			}
		}
		
		
		private function completeHide():void{
			visible=false;
			
			if(this._carList)
			this._carList.dataProvider=new ListCollection([]);      
			
			if(_completeHideCallback){
				
				       
				_completeHideCallback();
				_completeHideCallback=null;  
			}
		
			dispatchEventWith(Event.CLOSE);
			
		}
		
		public function updateLists():void{
			
			if(_titleDisplay){
				_titleDisplay.text=_titleDisplay.text+"";
				_titleDisplay.validate();
			}
		}
		
		private function completeShow():void{
			
			if(_completeShowCallback){
				
				_completeShowCallback();
				_completeShowCallback=null;
			}
			
			if(this.container)
				this.container.verticalScrollPosition=0;      
			
			this.dispatchEventWith(Event.OPEN);
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid("packet")){
				
				
				
				if(_packet && _titleDisplay){
					
					var title:String=packet.title;  
					
					if(!title){
						
						title="";  
					}
					
					if(AlertView.language  /*&& AlertView.language.translate(packet.id, "title")!="title"*/)
					{
						
						title=AlertView.language.translate(packet.id, "title");
						
					}  
					
					var w:Number=(actualWidth-(_buyNowButton.width+32+5));        
					_titleFontSize=calcOptimalFontSizeForWidth(title, _titleFontSize, w, 32);
					_titleDisplay.textFormat = new TextFormat(FontSelector.getFont(true), _titleFontSize, 0x454545);
					
					_titleDisplay.text=(title);
				
					
					_titleDisplay.validate();

					_titleDisplay.y=(45-_titleDisplay.height)/2;
					
					if(title)
					packNameLabel.text=(title);//.toLocaleUpperCase();
					else packNameLabel.text="";
					
					
					var currency:String=""; 
					
					if(packet.feeСurrency)
						currency=packet.feeСurrency.replace("₽", "RUB");
					
					currency=currency.replace("$", "USD");   
					
					
					_priceDisplay.text=packet.fee.toFixed(2) +" "+StringUtil.trim(currency);
					  
					_priceDisplay.width=_buyNowButton.width;  
					_priceDisplay.height=NaN;
					_priceDisplay.validate();
					
					_priceDisplay.y=(45-_priceDisplay.height)/2;
					
					
					_priceDisplay.x=actualWidth-(_buyNowButton.width+12);  
					
					_priceDisplay.y=_buyNowButton.height+7;
					
					//actualWidth-(32+23+_buyNowButton.width);
					
				}
				
				if(_packet && _textLabel){
					
					//_textLabel.contentMaxWidth=actualWidth-(32+20);
					
					_textLabel.x=32;
					_textLabel.width=actualWidth-(32+20);
					
					
					_textLabel.y=7;    
					

					var body:String=_packet.body;
					
					
					
					if(AlertView.language /*&& AlertView.language.translate(packet.id, "title")!="title"*/)
					{
						body=AlertView.language.translate(packet.id, "body");
						
					}

                    Tracer.print("BODY:", body);
					
					_textLabel.text='<textformat rightmargin="3" >'+body+'</textformat>';  
					
					
					
				
					_textLabel.validate();
					
					_textLabel.height=_textLabel.height+10;


                    Tracer.print("_textLabel777.height :"+ _textLabel.height);
					
					
					_carList.y=_textLabel.y+ _textLabel.height+5;    
				
				}
				
				
				
				
				if(_packet && _carList){
				
					_carList.dataProvider=new ListCollection();
					
				
					
					Starling.juggler.delayCall(function() : void 
					{
				
						//container.height=NaN;
						if (_packet.example) {

							for (var i:int = _packet.example.length - 1; i >= 0; i--) {
								if (_packet.example.indexOf(_packet.example[i]) != i) {
									_packet.example.removeAt(i);
								}
							}
							_carList.dataProvider = new ListCollection(_packet.example);
						}
						_carList.height=NaN;
						try{
							_carList.validate();
						}catch (e:Error) {

							return;
						}
						
						_carList.y=_textLabel.y+_textLabel.height+5;    
						
						packNameLabel.y=_carList.y+_carList.height+5;  
						
						packNameLabel.height=NaN;
						packNameLabel.validate();  
						
						
						_buyNowButton2.x=(actualWidth-_buyNowButton2.width)/2;
						_buyNowButton2.y = packNameLabel.y+packNameLabel.height+15;


						_buy3DCoinButton.x = actualWidth - _buy3DCoinButton.width - 20;
						_buy3DCoinButton.y = _buyNowButton2.y;

						if (_buy3DCoinButton.visible && _buyNowButton2.visible) {
                            _buyNowButton2.x = 35;
						}
						
						quadDown.x=0;
						quadDown.y=_buyNowButton2.y+_buyNowButton2.height;      
						
						
						container.readjustLayout();
						//container.height=_textLabel.height+_carList.height+packNameLabel.height+5+_buyNowButton2.height;
						//container
						  
					
					}, 1);      
					
					_textLabel.validate();
					
					_textLabel.height=_textLabel.height+10;
					

					_carList.y=_textLabel.y+_textLabel.height+5;    
					
					
					
						
					var	heightList:Number=_packet.cars.length*217;
					

					
					packNameLabel.width=actualWidth;
					packNameLabel.y=_carList.y+heightList+5;  
					
					packNameLabel.height=NaN;
					packNameLabel.validate();
					
					
					_buyNowButton2.x=(this.actualWidth-this._buyNowButton2.width)/2;
					_buyNowButton2.y=packNameLabel.y+packNameLabel.height+15;



					_buy3DCoinButton.x = actualWidth - _buy3DCoinButton.width - 10;
					_buy3DCoinButton.y = _buyNowButton2.y;



					container.readjustLayout();
					

				
				}
				
				
			}
			
			if(isInvalid("text"))
			{
			
				
			
			}
			
			
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{

				_titleDisplay.x=32;
				_titleDisplay.y=(45-_titleDisplay.height)/2;
				
				_titleDisplay.width=actualWidth-(32+5+_buyNowButton.width);
				  
				_buyNowButton.x = actualWidth-(_buyNowButton.width+12);
				_buyNowButton.y=5;

                _orLabel.x = _buyNowButton.x - (_orLabel.width + 10);
                _orLabel.y = _buyNowButton.y + (_buyNowButton.height - _orLabel.height) / 2;

				_buy3DCoinButton1.x = _orLabel.x - (_buy3DCoinButton1.width + 10);
                _buy3DCoinButton1.y = 5;
				
				
				container.x=0;
				container.y=45;  
				
				
				container.width=actualWidth;
				container.height=actualHeight-45;  
				
				
			
				_background.x=0;
				_background.y=0;
				
				_background.width=actualWidth;
				_background.height=actualHeight;     
				
				
				
				//_textLabel.contentMaxWidth=actualWidth-(32+20);  
				_textLabel.x=32;
				_textLabel.width=actualWidth-(32+20);
				
				
				_textLabel.y=7;  
				
				//_textLabel.height = 45;
				_textLabel.height=NaN;
				_textLabel.validate();  
				
				_textLabel.height=_textLabel.height+10;
				

				_carList.x=32;    
				
				_carList.y=_textLabel.y+_textLabel.height+5;    
				
				_carList.width=actualWidth-(32+20);  
				
				heightList=_carList.height;
				

				
			
				packNameLabel.width=actualWidth;
				packNameLabel.y=_carList.y+heightList+5;  
				
				packNameLabel.height=NaN;
				packNameLabel.validate();
				
				
				_buyNowButton2.x=(actualWidth-_buyNowButton2.width)/2;
				_buyNowButton2.y=packNameLabel.y+packNameLabel.height+15;

                    _buy3DCoinButton.x = actualWidth - _buy3DCoinButton.width - 10;
                    _buy3DCoinButton.y = _buyNowButton2.y;

				
				quadDown.x=0;
				quadDown.y=_buyNowButton2.y+_buyNowButton2.height;

				container.readjustLayout();

			}
			
			if(_packet && _buyNowButton){
				
				if(_packet.lock){
					_buyNowButton.visible=true;
					_buyNowButton2.visible=true;
					var scaleKoef: Number = _buyNowButton2.height / _buy3DCoinButton.height;
					_buy3DCoinButton.height = _buyNowButton2.height;
                    _buy3DCoinButton.width *= scaleKoef;
					GameService.$.rewardsIsSupport(function (status: Boolean): void {
                        _buy3DCoinButton.visible = status;
                        _buy3DCoinButton1.visible = _orLabel.visible = status;
                        if (!_packet.coin3dFee || _packet.coin3dFee === 0) {
                            _buy3DCoinButton.visible = false;
                            _buy3DCoinButton1.visible = _orLabel.visible = false;
                        }
                    });


				}else{
					_buyNowButton.visible=false;
					_buyNowButton2.visible=false;
 					_buy3DCoinButton.visible = false;
                    _buy3DCoinButton1.visible = _orLabel.visible = false;
				}

				if (!_packet.coin3dFee || _packet.coin3dFee === 0) {
                    _buy3DCoinButton.visible = false;
                    _buy3DCoinButton1.visible = _orLabel.visible = false;
				}
			}

		}
	}
}