package com.despark.tuning3d.view.components.core
{
	import com.despark.tuning3d.model.parts.PartMaterialImage;
	
	import starling.display.DisplayObjectContainer;
	import starling.filters.ColorMatrixFilter;
	
	public class PixelMaskDisplayObject extends DisplayObjectContainer
	{
	
		public var partSlotName:String;
		public var partSlotNameWithoutState:String;
		public var layerIndex:int;
		public var isMask:Boolean=false;
		public var maskForSlots:Array=[];
		public var maskSet:String="";
		public var maskPartSlotSetterName:String;
		
		
		public function PixelMaskDisplayObject(scaleFactor:Number=-1, isAnimated:Boolean=true)
		{
			super();			
		}
		
		override public function dispose():void
		{
		
			maskForSlots=null;
			maskSet=null;
			partSlotNameWithoutState=null;
			partSlotName=null;
			maskPartSlotSetterName=null;
			super.dispose();
		}
		
		public function sortIfNeeded():void{
			
			if(partSlotName.indexOf("aerography")>=0){
				
				
				for(var i:int=0; i<numChildren; i++){
					
					var image:ImageLoaderWithStates = getChildAt(i) as ImageLoaderWithStates;
					
					if(!image.persistentImageProvider) continue;
					
					var partMaterialImage:PartMaterialImage = image.persistentImageProvider as PartMaterialImage;
					
					if(!partMaterialImage.parentMaterial) continue;
					
					if(!partMaterialImage.parentMaterial.parentPart) continue;
					
					if(partMaterialImage.parentMaterial.parentPart.multiselect) this.swapChildren(image, getChildAt(0));
					
					
				}
				
			}
		}
		
		
		public function updateFilter(brightness:Number=1.0) : void
		{
			
			//persistentImageProvider.
			if(brightness < 1.0)
			{
				trace("updateFilter")
				
				if(filter)
				{
					
					filter.dispose();
					filter = null;
				}
				
				var brightnessFilter:ColorMatrixFilter=new ColorMatrixFilter();
				brightnessFilter = new ColorMatrixFilter();
				
				brightnessFilter.reset();
				
				brightnessFilter.adjustBrightness(Math.min(brightness - 0.8, 0));
				brightnessFilter.cache();
				
				filter = brightnessFilter;
				
			}
			else
			{
				if(filter)
				{
					filter.dispose();
					filter = null;
					
				}
			}
		}
		
	}
}


