package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.model.core.Device;

import feathers.controls.Button;
import feathers.controls.Screen;

import starling.events.Event;
import starling.utils.AssetManager;
import starling.utils.StringUtil;

public class StackedScreen extends Screen {
		public static const BACK_BUTTON_SELECTED : String = "BackButtonSelected";

		public static const HOME_SELECTED : String = "HomeSelected";
		public static const BRANDS_SELECTED : String = "BrandsSelected";
		public static const GARAGE_SELECTED : String = "GarageSelected";
		public static const POST_TUNING_SELECTED : String = "PostTuningSelected";
		public static const USER_GARAGE_SELECTED : String = "UserGarageSelected";
		public static const VOTE_SELECTED : String = "VoteSelected";
		public static const TUNING_SELECTED : String = "TuningSelected";
		public static const CHALLENGES_SELECTED : String = "ChallengeSelected";
		public static const GALLERY_SELECTED : String = "GallerySelected";
		public static const CHALLENGE_NOTIFICATIONS_SELECTED : String = "ChallengeNotificationsSelected";
		public static const LEADER_BOARD_SELECTED : String = "LeaderBoardSelected";
        public static const FRIENDS_SELECTED : String = "FriendsSelected";
        public static const TIMELINE_SECLECTED : String = "TimelineSelected";
        public static const NOTIFICATION_SELECTED : String = "NotificationSelected";
        public static const MAILS_SELECTED : String = "MailsSelected";


        public static const USER_PROFILE_SELECTED : String = "UserProfileSelected";
        public static const USER_RESTORE_SELECTED : String = "UserRestoreSelected";
        public static const USER_DETAILS_SELECTED : String = "UserDetailsSelected";
		private static const _tempOpenPackages:Object = {};


		private static var currentID : int = 0;
		
		private var id : int;
		
		public var backButton : Button;
		
		public var hasBackButton : Boolean;
		public var assetManager : AssetManager;
		public var backLevel : int;
		protected var _isRoot : Boolean = false;
				
		public function StackedScreen(name : String) {
			super();
			this.name = name;
			id = currentID;
			currentID++;
			
			backButtonHandler = function() : void {
				dispatchEventWith(BACK_BUTTON_SELECTED);
			}   
		}
		
		public function get screenName() : String {
			return StringUtil.format("Screen_{0}", id);
		}
		
		public function initializeBackButton() : void {
			if (hasBackButton) {
				backButton = ButtonFactory.circleButton("backButton");
				backButton.x = 5;
				backButton.y = 5;
				
				if(Device.isIphoneXVariant()){
					backButton.x+=7;
					backButton.y+=7;
				}
                backButton.addEventListener(Event.TRIGGERED, backButtonTriggeredHandler);
				addChild(backButton);
			}
		}

		public function isDisposed():Boolean{
			return this._isDisposed;
		}
		
		protected function backButtonTriggeredHandler(event : Event) : void {
			dispatchEventWith(BACK_BUTTON_SELECTED);
		}
		
		public function ShowDone() : void {
		}

        public function get isRoot():Boolean {
            return _isRoot;
        }

		public static function get tempOpenPackages():Object {
			return _tempOpenPackages;
		}
    }
}