//package  com.despark.tuning3d.view.components.core
//{
//	import com.adobe.utils.AGALMiniAssembler;
//
//	import flash.display.Bitmap;
//	import flash.display.BitmapData;
//	import flash.display3D.Context3D;
//	import flash.display3D.Context3DBlendFactor;
//	import flash.display3D.Context3DProgramType;
//	import flash.display3D.Context3DTextureFormat;
//	import flash.display3D.Context3DVertexBufferFormat;
//	import flash.display3D.IndexBuffer3D;
//	import flash.display3D.VertexBuffer3D;
//	import flash.geom.Matrix;
//	import flash.geom.Point;
//	import flash.geom.Rectangle;
//
//	import starling.core.RenderSupport;
//	import starling.core.Starling;
//	import starling.display.DisplayObject;
//	import starling.errors.MissingContextError;
//	import starling.events.Event;
//	import starling.rendering.VertexData;
//	import starling.textures.Texture;
//	import starling.utils.VertexData;
//	import starling.utils.deg2rad;
//
//	/** This custom display objects renders a regular, n-sided polygon. */
//	public class Test extends DisplayObject
//	{
//		private static var PROGRAM_NAME:String = "trokutProgram";
//
//		// custom members
//		private var mRadius:Number;
//		private var mRatio:Number;
//		private var mNumEdges:int = 3;
//		private var mTexture:Texture;
//
//		// vertex data
//		private var mVertexData:VertexData;
//		private var mVertexBuffer:VertexBuffer3D;
//
//		// index data
//		private var mIndexData:Vector.<uint>;
//		private var mIndexBuffer:IndexBuffer3D;
//
//		protected var mPremultipliedAlpha:Boolean;
//		protected var mBlendFactorSource:String;
//		protected var mBlendFactorDestination:String;
//
//		// helper objects (to avoid temporary objects)
//		private static var sHelperMatrix:Matrix = new Matrix();
//		private static var sRenderAlpha:Vector.<Number> = new <Number>[1.0, 1.0, 1.0, 1.0];
//
//		/** Creates a regular polygon with the specified redius, number of edges, and color. */
//		public function Test(texture:Texture, radius:Number, ratio:Number, blendFactorSource:String=null, blendFactorDest:String=null)
//		{
//			mRadius = radius;
//			mRatio = ratio;
//			mTexture=texture;
//			mPremultipliedAlpha = texture.premultipliedAlpha;
//
//			mBlendFactorDestination = blendFactorDest || Context3DBlendFactor.ONE_MINUS_SOURCE_ALPHA;
//			mBlendFactorSource = blendFactorSource ||
//				(mPremultipliedAlpha ? Context3DBlendFactor.ONE : Context3DBlendFactor.SOURCE_ALPHA);
//
//			// setup vertex data and prepare shaders
//			setupVertices();
//			createBuffers();
//			registerPrograms();
//
//			// handle lost context
//			Starling.current.addEventListener(Event.CONTEXT3D_CREATE, onContextCreated);
//
//		}
//
//		/** Disposes all resources of the display object. */
//		public override function dispose():void
//		{
//			Starling.current.removeEventListener(Event.CONTEXT3D_CREATE, onContextCreated);
//
//			if (mVertexBuffer) mVertexBuffer.dispose();
//			if (mIndexBuffer)  mIndexBuffer.dispose();
//
//			super.dispose();
//		}
//
//		private function onContextCreated(event:Event):void
//		{
//			// the old context was lost, so we create new buffers and shaders.
//			createBuffers();
//			registerPrograms();
//		}
//
//		/** Returns a rectangle that completely encloses the object as it appears in another
//		 * coordinate system. */
//		public override function getBounds(targetSpace:DisplayObject, resultRect:Rectangle=null):Rectangle
//		{
//			if (resultRect == null) resultRect = new Rectangle();
//
//			var transformationMatrix:Matrix = targetSpace == this ?
//				null : getTransformationMatrix(targetSpace, sHelperMatrix);
//
//			return mVertexData.getBounds(transformationMatrix, 0, -1, resultRect);
//		}
//
//		/** Creates the required vertex- and index data and uploads it to the GPU. */
//		private function setupVertices():void
//		{
//
//			// create vertices
//			mVertexData = new VertexData(mNumEdges, true);
//
//			mVertexData.setPosition(0, 0.0, 0.0);//prva tocka ishodiste
//
//			//druge dvije tocke
//			var edge1:Point = Point.polar(mRadius, 0);
//			mVertexData.setPosition(1, edge1.x, edge1.y);
//
//			var edge2:Point = Point.polar(mRadius, deg2rad(180/mRatio));
//			mVertexData.setPosition(2, edge2.x, edge2.y);
//
//			//For every vertex you add you must set the UV (texture coords) for that vertex.
//			//UV goes from 0 to 1. So if the x position of the vertex is at the middle of the texture the U would be 0.5.
//			//(U, V) = (0, 0) means the bottom-left corner of the texture image, and (U, V) = (1, 1) means the top-right corner.
//			mVertexData.setTexCoords(0, 0, 0);
//			mVertexData.setTexCoords(1, 1, 1);
//			mVertexData.setTexCoords(2, 0, 1);
//
//			// create indices that span up the triangles
//			mIndexData = new <uint>[];
//
//			mIndexData.push(0, 1, 2);
//
//		}
//
//		/** Creates new vertex- and index-buffers and uploads our vertex- and index-data to those
//		 *  buffers. */
//		private function createBuffers():void
//		{
//			var context:Context3D = Starling.context;
//			if (context == null) throw new MissingContextError();
//
//			if (mVertexBuffer) mVertexBuffer.dispose();
//			if (mIndexBuffer)  mIndexBuffer.dispose();
//
//			mVertexBuffer = context.createVertexBuffer(mVertexData.numVertices, VertexData.ELEMENTS_PER_VERTEX);
//			mVertexBuffer.uploadFromVector(mVertexData.rawData, 0, mVertexData.numVertices);
//
//			mIndexBuffer = context.createIndexBuffer(mIndexData.length);
//			mIndexBuffer.uploadFromVector(mIndexData, 0, mIndexData.length);
//		}
//
//		/** Renders the object with the help of a 'support' object and with the accumulated alpha
//		 * of its parent object. */
//		public override function render(support:RenderSupport, alpha:Number):void
//		{
//			// always call this method when you write custom rendering code!
//			// it causes all previously batched quads/images to render.
//			support.finishQuadBatch();
//
//			alpha *= this.alpha;
//
//			sRenderAlpha[0] = sRenderAlpha[1] = sRenderAlpha[2] = mPremultipliedAlpha  ? alpha : 1.0;
//			sRenderAlpha[3] = alpha;
//
//			var context:Context3D = Starling.context;
//			if (context == null) throw new MissingContextError();
//
//			context.setBlendFactors(mBlendFactorSource, mBlendFactorDestination);
//			context.setTextureAt(0, mTexture.base);
//
//			// activate program (shader) and set the required buffers / constants
//			context.setProgram(Starling.current.getProgram(PROGRAM_NAME));
//			context.setVertexBufferAt(0, mVertexBuffer, VertexData.POSITION_OFFSET, Context3DVertexBufferFormat.FLOAT_2);
//			context.setVertexBufferAt(1, mVertexBuffer, VertexData.COLOR_OFFSET,    Context3DVertexBufferFormat.FLOAT_4);
//			context.setVertexBufferAt(2, mVertexBuffer, VertexData.TEXCOORD_OFFSET, Context3DVertexBufferFormat.FLOAT_2);
//			context.setProgramConstantsFromMatrix(Context3DProgramType.VERTEX, 0, support.mvpMatrix3D, true);
//			context.setProgramConstantsFromVector(Context3DProgramType.VERTEX, 4, sRenderAlpha, 1);
//
//			// finally: draw the object!
//			context.drawTriangles(mIndexBuffer, 0, 1);
//
//			// reset buffers
//			context.setTextureAt(0, null);
//			context.setVertexBufferAt(0, null);
//			context.setVertexBufferAt(1, null);
//			context.setVertexBufferAt(2, null);
//		}
//
//		/** Creates vertex and fragment programs from assembly. */
//		private static function registerPrograms():void
//		{
//			var target:Starling = Starling.current;
//			if (target.hasProgram(PROGRAM_NAME)) return; // already registered
//
//			// va0 -> position
//			// va1 -> color
//			// vc0 -> mvpMatrix (4 vectors, vc0 - vc3)
//			// vc4 -> alpha
//
//			var vertexProgramCode:String =
//				"m44 op, va0, vc0 \n" + // 4x4 matrix transform to output space
//				"mul v0, va1, vc4 \n" + // multiply color with alpha and pass it to fragment shader
//				"mov v6, va2 \n";  //insert uv and send to fragment shader
//
//			var fragmentProgramCode:String =
//				"tex ft0, v6, fs0 <2d,linear,nomip> \n" +
//				"mov oc, ft0 \n";
//
//			var vertexProgramAssembler:AGALMiniAssembler = new AGALMiniAssembler();
//			vertexProgramAssembler.assemble(Context3DProgramType.VERTEX, vertexProgramCode);
//
//			var fragmentProgramAssembler:AGALMiniAssembler = new AGALMiniAssembler();
//			fragmentProgramAssembler.assemble(Context3DProgramType.FRAGMENT, fragmentProgramCode);
//
//			target.registerProgram(PROGRAM_NAME, vertexProgramAssembler.agalcode,
//				fragmentProgramAssembler.agalcode);
//		}
//
//		/** The radius of the polygon in points. */
//		public function get radius():Number { return mRadius; }
//		public function set radius(value:Number):void { mRadius = value; setupVertices(); createBuffers();}
//
//		/** The ratio of the polygon. */
//		public function get ratio():Number { return mRatio; }
//		public function set ratio(value:Number):void { mRatio = value; setupVertices(); createBuffers();}
//	}
//}