package com.despark.tuning3d.view.components.disks
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.utils.FontSelector;
	
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.ScrollContainer;
	
	import starling.core.Starling;
	import starling.events.Event;
	
	public class DiskInfoPopUp extends PopUp implements Multilingual
	{//cleanCacheButton
		//public static const CLEAN_CACHE_SELECTED : String = "cleanCacheSelected";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 100;
		public var car : Car;
		private var currentLanguage : Language;
		private var container : ScrollContainer;
		private var leaveACommentButton : MultilingualButton;
		private var thanksButton : MultilingualButton;
		private var textLabel : MultilingualLabel;		
		
		public function DiskInfoPopUp()
		{
			super();
			
			setSizeInternal(Starling.current.stage.width - 150, Starling.current.stage.height - 120, false);
			
			if(width <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 25, Starling.current.stage.height - 50, false);
			}
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
//			title = language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
//			
//			leaveACommentButton.updateWithLanguage(language);
//			leaveACommentButton.label = language.translate("mob_morecars", "leave a comment").toUpperCase();
//			
//			thanksButton.updateWithLanguage(language);
//			thanksButton.label = language.translate("mob_morecars", "thanks, not now").toUpperCase();
//			
//			
			textLabel.updateWithLanguage(language);
			textLabel.text = "Disk info here...";
//			if(textLabel.text=="TEXT"){
//				
//				var str:String="We are constantly adding new cars, parts and tunings option. \n"+
//					"Your feedback is very important for us to stay \n"+
//					"On the right track! \n\n"+
//					"Please give us your feedback!"
//				
//				textLabel.text=str.toLocaleUpperCase();
//				
//			}
			
			title = "Disk info".toUpperCase();
			//titleLabel.updateWithLanguage(language);
			
			//leaveACommentButton.updateWithLanguage(language);
			//leaveACommentButton.label = language.translate("mob_morecars", "leave a comment").toUpperCase();
			//leaveACommentButton.label = language.translate("mob_morecars", "leave a comment").toUpperCase();
			
			thanksButton.updateWithLanguage(language);
			thanksButton.label = "CLOSE";
			
			
			//textLabel.updateWithLanguage(language);
			//textLabel.text = "Disk info";
			
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			container = new ScrollContainer();
			container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 10;
			addChild( container );
			
//			leaveACommentButton = ButtonFactory.defaultButton(null, 0x49cc46);
//			
//			leaveACommentButton.textFormat.size=11;
//			leaveACommentButton.addEventListener(Event.TRIGGERED, commentsButtonnTriggeredHandler);
//			addChild(leaveACommentButton);
			
			thanksButton = ButtonFactory.defaultButton(null, 0xff0000);
			thanksButton.addEventListener(Event.TRIGGERED, thanksButtonTriggeredHandler);
			thanksButton.textFormat.size=11;
			addChild(thanksButton);
			
			
			textLabel=new MultilingualLabel();
			textLabel.height=60;
			textLabel.textFormat = new TextFormat(FontSelector.getFont(), 9, 0x8f8f8f);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			
			textLabel.paddingRight=13;
			textLabel.paddingLeft=13;
			textLabel.paddingTop=16;
			
			addChild(textLabel);			
		}
		
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.width-=10;
				contentBackgroundImage.height-=15;
				
				contentBackgroundImage.x+=5;
				contentBackgroundImage.y+=5;
				
				
				container.x = contentBackgroundImage.x;
				container.y = contentBackgroundImage.y;
				container.width = contentBackgroundImage.width;
				container.height = contentBackgroundImage.height;
				
				
				thanksButton.width=130;
				thanksButton.height=28;
				thanksButton.x = (contentBackgroundImage.x + contentBackgroundImage.width)-thanksButton.width;  
				thanksButton.y = contentBackgroundImage.y + contentBackgroundImage.height + 15;; 
				
//				leaveACommentButton.width=130;
//				leaveACommentButton.height=28;
//				leaveACommentButton.x =  thanksButton.x - leaveACommentButton.width - 10;
//				leaveACommentButton.y =  thanksButton.y
				
				
				textLabel.width=contentBackgroundImage.width;
				textLabel.height=contentBackgroundImage.height;
				
				textLabel.x = contentBackgroundImage.x;
				textLabel.y = contentBackgroundImage.y;				
			}
			
			
		}
		
		private function commentsButtonnTriggeredHandler(event : Event) : void
		{
			//dispatchEventWith(DOWNLOAD_SELECTED);
			
//			if(car.moreCarsURL){
//				
//				navigateToURL(new URLRequest(car.moreCarsURL));
//			}
//			
//			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		private function thanksButtonTriggeredHandler(event : Event) : void
		{
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
			//dispatchEventWith(DELETE_SELECTED);
		}
	}
}

