package com.despark.tuning3d.view.components.gallery
{
import com.despark.tuning3d.view.components.core.ListItemRenderer;

import feathers.layout.HorizontalAlign;
import feathers.layout.VerticalAlign;

import starling.events.EventDispatcher;

public class GridItemRenderer extends ListItemRenderer {
        private var _count:int = 0;
        private var _itemList:Array;
    private var _eventDispatcher:EventDispatcher;
		public function GridItemRenderer(){
		}

		public function get tunings() : Array {
			return data as Array;
		}
		
		protected override function initialize() : void {
			super.initialize();
			this.label.visible=false;
		}

        override public function dispose():void {
            super.dispose();
        }

        protected override function draw() : void {
			super.draw();

		}
		
		protected override function commitData() : void{
			super.commitData();
            var i:int;
            var item:GalleryTuningItem;
            if(tunings && tunings.length){
                if(_itemList){
                    for(i = 0; i < _itemList.length; i++){
                        item = _itemList[i] as GalleryTuningItem;
                        item.removeFromParent(true);
                    }
                }
                _itemList = [];
                for(i = 0; i < _count; i++){
                    item = new GalleryTuningItem();
                    item.horizontalAlign = HorizontalAlign.RIGHT;
                    if(_count == 1){
                        item.cell = item.row = 0;
                        item.width = actualWidth;
                        item.height = actualHeight;
                    }else if(_count == 4){
                        item.width = actualWidth / 2;
                        item.height = actualHeight / 2;
                        item.cell = (i % 2);
                        item.row = int(i / 2);
                        item.x = item.cell * item.width;
                        item.y = item.row * item.height;
                        if(item.cell == 0){
                            item.horizontalAlign = HorizontalAlign.LEFT;
                        }else{
                            item.horizontalAlign = HorizontalAlign.RIGHT;
                        }

                        if(item.row == 0){
                            item.verticalAlign = VerticalAlign.TOP;
                        }else{
                            item.verticalAlign = VerticalAlign.BOTTOM;
                        }
                    }else if(_count == 9){
                        item.width = actualWidth / 3;
                        item.height = actualHeight / 3;
                        item.cell = (i % 3);
                        item.row = int(i / 3);
                        item.x = item.cell * item.width;
                        item.y = item.row * item.height;
                        if(item.cell == 0){
                            item.horizontalAlign = HorizontalAlign.LEFT;
                        }else if(item.cell == 1){
                            item.horizontalAlign = HorizontalAlign.CENTER;
                        }else{
                            item.horizontalAlign = HorizontalAlign.RIGHT;
                        }

                        if(item.row == 0){
                            item.verticalAlign = VerticalAlign.TOP;
                        }else if(item.row == 1){
                            item.verticalAlign = VerticalAlign.MIDDLE;
                        }else{
                            item.verticalAlign = VerticalAlign.BOTTOM;
                        }
                    }
                    item.count = _count;
                    item.data = tunings[i];
                    _itemList.push(item);
                    item.eventDispatcher = _eventDispatcher;
                    item.owner = owner;
                    addChild(item);
                }
            }
		}

    public function set eventDispatcher(eventDispatcher:EventDispatcher):void {
        _eventDispatcher = eventDispatcher;
        if(_itemList){
            for(var i:int = 0; i < _itemList.length; i++){
                var item:GalleryTuningItem = _itemList[i] as GalleryTuningItem;
                item.eventDispatcher = _eventDispatcher;
            }
        }
    }

    public function set count(value:int):void {
        _count = value;
    }
}
}
