package com.despark.tuning3d.view.components.garage {
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.SimpleExtendedButton;

    import feathers.controls.Button;

    import feathers.core.FeathersControl;

    import starling.display.Image;

    import starling.display.Quad;
    import starling.events.Event;
    import starling.textures.Texture;

    public class GarageSettingControl extends FeathersControl {
        private static const SCREEN_WIDTH:int = 160;
        private var background:Quad;
        private var closeButton:SimpleExtendedButton;
        public function GarageSettingControl() {
            super();
            width = SCREEN_WIDTH;
        }

        override protected function initialize():void {
            super.initialize();
            setSizeInternal(SCREEN_WIDTH, stage.stageHeight, false);

            background = new Quad(1, 1, 0x000000);
            background.color = 0x000000;
            background.alpha = 1;
            addChildAt(background, 0);

            var closeButtonTexture : Texture = ButtonFactory.assetManager.getTexture("a_close_effect_menu");
            closeButton = new SimpleExtendedButton();
            closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
            closeButton.defaultIcon = new Image(closeButtonTexture);
            closeButton.width = 12;
            closeButton.height = 12;

            closeButton.defaultIcon.width=12;
            closeButton.defaultIcon.height=12;

            (closeButton).hitAreaPadding=10;

            addChild(closeButton);
        }

        private function closeButtonTriggeredHandler(event:Event):void {
            dispatchEvent(new Event(Event.CLOSE));
        }

        override protected function draw():void{
            if(background){
                background.width = actualWidth;
                background.height = actualHeight;
            }

            if(closeButton){
                closeButton.x = actualWidth - (closeButton.width + closeButton.hitAreaPadding);
                closeButton.y = closeButton.hitAreaPadding;
            }
        }
    }
}
