package com.despark.tuning3d.view.components.instructions
{
	//import com.despark.tuning3d.view.components.instructions.TutorialView
	//import com.despark.tuning3d.view.components.core.AlertView;

	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.core.images.DASBitmapDataLoader;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.PageItemRenderer;

import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;

import feathers.layout.Direction;
import feathers.layout.HorizontalAlign;

import feathers.layout.RelativePosition;
import feathers.layout.VerticalAlign;

import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.events.TimerEvent;
	import flash.geom.Rectangle;
	import flash.media.StageWebView;
	import flash.net.URLLoader;
	import flash.system.Capabilities;
	import flash.utils.Timer;
	
	import feathers.controls.Button;
	import feathers.controls.List;
	import feathers.controls.renderers.IListItemRenderer;
	import feathers.core.FeathersControl;
	import feathers.data.ListCollection;
	import feathers.layout.TiledRowsLayout;
	
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.utils.AssetManager;

	public class TutorialView extends FeathersControl
	{
		//public static const CLOSE_SELECTED : String = "CloseSelected";
		public static var assetManager : AssetManager;
		
		private var text : String;
		private var url : String;
		private var backgroundQuad : Quad;
		private var closeButton : Button;
		private var closeButtonBackgroundQuad : Quad;
		private var stageWebView : StageWebView = new StageWebView();
		private var caruselList : List;
		private var refreshed : Boolean;
		public var indexOfPage : int;
		
		public var width_of_image : int = 0;
		public var height_of_image : int = 0;
		
	    //private var imageCacher : ImageCacher;
		private var bitmapDataLoader : DASBitmapDataLoader;
		
		private var currentIndexOfPage : int = 0;
		private var arrOfUrlsImages : Array;
		
		private var _challenge:Boolean=false;
		
		public function TutorialView()
		{
			super();
			
			var max: Number;
			var min: Number;
			if(Capabilities.screenResolutionY > Capabilities.screenResolutionX){
				max = Capabilities.screenResolutionY;
			}else{
				max = Capabilities.screenResolutionX;
			}
			
			width_of_image = max - 40;//1800;
			height_of_image = width * 640 /1136; //iphone
			
			
		}
		
		protected override function initialize() : void
		{
			super.initialize();
			
			backgroundQuad = new Quad(1, 1, 0x0);//0xFFFFFF
			addChild(backgroundQuad);
			
			closeButtonBackgroundQuad = new Quad(10, 10, 0xFFFFFF);
			closeButtonBackgroundQuad.pivotX = closeButtonBackgroundQuad.width / 2;
			closeButtonBackgroundQuad.pivotY = closeButtonBackgroundQuad.height / 2;
			addChild(closeButtonBackgroundQuad);
			
			var closeButtonTexture : Texture = assetManager.getTexture("closeButton");
			closeButton = new Button();
			closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
			closeButton.defaultIcon = new Image(closeButtonTexture);
			closeButton.width = 25;
			closeButton.height = 25;
			closeButton.iconPosition = RelativePosition.MANUAL;
			closeButton.iconOffsetX = int((closeButton.width - closeButtonTexture.width) / 2);
			closeButton.iconOffsetY = int((closeButton.height - closeButtonTexture.height) / 2);
			closeButton.pivotX = closeButton.width / 2;
			closeButton.pivotY = closeButton.height / 2;
			addChild(closeButton);
			
			stageWebView.stage = Starling.current.nativeStage;

			var max: Number;
			if(Capabilities.screenResolutionY > Capabilities.screenResolutionX){
				max = Capabilities.screenResolutionY;
			}else{
				max = Capabilities.screenResolutionX;
			}
			
			var width: int = max;//1800;
			var padding : int = 0;
			
			this.width = Starling.current.stage.stageWidth - 2 * padding;
			this.height = Starling.current.stage.stageHeight - 2 * padding;
			
			var koef:Number =   this.height /this.width;//iphone
			
			var height: int = width * koef; 
			stageWebView.viewPort = new Rectangle(
				-5000, 
				-5000, 
				width, 
				height);
			this.x = (Starling.current.stage.stageWidth - this.width)/2;
			this.y = (Starling.current.stage.stageHeight - this.height)/2;

			var layout : TiledRowsLayout = new TiledRowsLayout();
			layout.paging = Direction.HORIZONTAL;
			layout.useSquareTiles = false;
			//layout.manageVisibility = true; //tt
			layout.gap = 10;
			//layout.padding = 0;
			layout.horizontalAlign = HorizontalAlign.CENTER;
			layout.verticalAlign = VerticalAlign.MIDDLE;

			
			
			caruselList = new List();
			caruselList.layout = layout;
			caruselList.snapToPages = true;
			caruselList.scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
			caruselList.horizontalScrollPolicy = ScrollPolicy.ON;
			caruselList.itemRendererFactory = function() : IListItemRenderer
			{
				var renderer : PageItemRenderer = new PageItemRenderer();
				renderer.setSize(actualWidth, actualHeight);
				renderer.textColor = 0xffffff;
				
				return renderer;
			};
			
			addChildAt(caruselList, 1);
		}
		
		private var  loader:URLLoader;
        private var _textureToDispose:Array;
		
		public function getBitmap(challenge:Boolean=false): void
		{
			_challenge=challenge;
			getBitmap_continue(null);
			
		}   
		
		private function loaderComplete(e:flash.events.Event):void
		{
			getBitmap_continue(loader.data);
		}
		
		
		public function getBitmap_continue(htmlText:String): void
		{
			var arrOfNames : Array = [];
			if(_challenge){
				if(Constants.ThisIsIPAD){
					arrOfNames.push("ipad-page-1");
					
				}else{
					arrOfNames.push("iphone-page-1");
				
				}
				
				
			}else{
				if(Constants.ThisIsIPAD){
					arrOfNames.push("ipad-home-page");
					arrOfNames.push("ipad-suspension-snapshot");
					arrOfNames.push("ipad-custom-download");
					arrOfNames.push("ipad-parts-menu");
					arrOfNames.push("ipad-settings");
					arrOfNames.push("ipad-delete-parts");
					arrOfNames.push("ipad-clean-cache");
					
				}else{
					arrOfNames.push("iphone-home-page");
					arrOfNames.push("iphone-suspension-snapshot");
					arrOfNames.push("iphone-custom-download");
					arrOfNames.push("iphone-parts-colors");
					arrOfNames.push("iphone-settings");
					arrOfNames.push("iphone-delete-parts");
					arrOfNames.push("iphone-clean-cache");
				}
			}

			var tag:String="mobileAppHelper";
			if(_challenge){
				tag="mobileAppChellange";
			}
			
			
			arrOfUrlsImages = new Array();
			for each(var nameOfField : String in arrOfNames)
			{
				var url_str : String = AlertView.language.translate(tag, nameOfField);
				if(url_str){	
					arrOfUrlsImages.push(url_str);
				}
				
			}
			currentIndexOfPage = 0;
			downloadNextImage();
		}
		
		private function downloadNextImage():void
		{
			if(bitmapDataLoader)
				bitmapDataLoader.cancel();
			bitmapDataLoader = null;
			if(currentIndexOfPage>= arrOfUrlsImages.length){
				arrOfUrlsImages = null;
				return;
			}
			
			var urlForDownloading : String = arrOfUrlsImages[currentIndexOfPage];
			
			bitmapDataLoader = new DASBitmapDataLoader();
			bitmapDataLoader.download(urlForDownloading,bitmapLoadedHandler);
			
			
			currentIndexOfPage++;
		}
		
		protected function bitmapLoadedHandler(__bitmap : Bitmap,__url: String):void
		{
			if(__bitmap){
				var bitmapData : BitmapData = __bitmap.bitmapData;
				

				var texture: Texture = Texture.fromBitmapData( bitmapData );
				
				var object:Object = new Object;
				object.testText = " "+currentIndexOfPage+1;
				object.texture = texture;
				
				var arr:Array = new Array(object);
				
				addPages(arr);
				bitmapData.dispose();
				
				
			}
			
			
			
			downloadNextImage();
		}
		
		
		
		public function handleLoad(e:Object):void
		{
			var myTimer:Timer = new Timer(2000, 1);
			myTimer.addEventListener("timer", timerHandler);
			myTimer.start();
			
			
			//stageWebView.stage = null;
		}
		
		public function timerHandler(event:TimerEvent):void {
			/////////////////if
			if(!stageWebView){
				return;
			}
			var bitmapData:BitmapData = new BitmapData(stageWebView.viewPort.width, stageWebView.viewPort.height);
			stageWebView.drawViewPortToBitmapData(bitmapData);
			var webViewBitmap:Bitmap=new Bitmap(bitmapData);
			
			var texture: Texture = Texture.fromBitmapData( bitmapData );
			
			var object:Object = new Object;
			object.testText = " "+indexOfPage;
			object.texture = texture;
			
			var arr:Array = new Array(object);
			/*
			for(var i0: int = 1;i0<=2;i0++){
				//var htmlText:String = AlertView.language.translate("mobileAppHelper", "ipad_helper_1");
				
				var object:Object = new Object;
				object.testText = " "+i0;
				object.texture = texture;
				arr.push(object);
			}
			*/
			addPages(arr);
			
			indexOfPage ++;
			if(indexOfPage<=5){
				getBitmap();
			}
		}
		
		
		public function addPages(tuningsToAdd : Array) : void
		{

			if(caruselList)
			{
				
				refreshed = false;
				if(caruselList.dataProvider == null)
				{
					caruselList.dataProvider = new ListCollection(tuningsToAdd);
                    _textureToDispose = new Array(tuningsToAdd[0]);
                }else{

					caruselList.dataProvider.addItem(tuningsToAdd[0]);
					_textureToDispose.push(tuningsToAdd[0]);

				}
				
			} 
		}
		
		protected override function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				if(backgroundQuad){
					backgroundQuad.width = actualWidth;
					backgroundQuad.height = actualHeight;
				}
				
				
				closeButton.x = actualWidth - closeButton.width / 2;
				closeButtonBackgroundQuad.x = closeButton.x;
				
				closeButton.y = closeButton.height / 2;
				closeButtonBackgroundQuad.y = closeButton.y;
				
				
				if(Device.isIphoneXVariant()){
					closeButton.x-=6;
					closeButton.y+=6;
				}

				var scale : int = assetManager.scaleFactor;
				var webViewPadding : int = 10;
				
				
				caruselList.x = 0;
				caruselList.y = 0;
				caruselList.width = actualWidth ;
				caruselList.height = actualHeight;
				
				
				/*
				stageWebView.stage = Starling.current.nativeStage;
				stageWebView.viewPort = new Rectangle(
					(x + webViewPadding) * scale, 
					(y + webViewPadding) * scale, 
					(actualWidth - 2 * webViewPadding) * scale, 
					(actualHeight - 2 * webViewPadding) * scale);
				
				if(text){
					stageWebView.loadString(text);
				}else if(url){
					stageWebView.loadURL(url);
				}
				*/
				
				
				
			}
		}
		
		private function closeButtonTriggeredHandler(event : Event) : void
		{
			caruselList.dataProvider.removeAll();
			caruselList.dataProvider = null;
            caruselList.removeFromParent(true);
            closeButtonBackgroundQuad.removeFromParent(true);
            closeButton.removeFromParent(true);

			if(bitmapDataLoader)
			bitmapDataLoader.cancel();
			
			bitmapDataLoader = null;
			arrOfUrlsImages = null;
			//CaptureStageWebView();
			if(stageWebView){
				stageWebView.dispose();
				stageWebView = null;
			}
			for(var i : int =0; i < _textureToDispose.length; i++)
			{
				var texture : Texture = _textureToDispose[i].texture;
				texture.dispose();
				texture = null;
			}
			_textureToDispose = null;
			
			this.removeFromParent(true);
			
		}
		
		
		
		/*
		public function CaptureStageWebView(): void {
			var support:RenderSupport = new RenderSupport();
			RenderSupport.clear(stage.color, 1.0);
			
			
			
			var result:BitmapData = new BitmapData(20, 20, true);
			Starling.context.drawToBitmapData(result);
			stageWebView.drawViewPortToBitmapData(result);
			
			
			
			//this.SaveAsPng(result);
			{
				
				
				
			}
		}*/
		
		 
		
		public static function showText(text : String, challenge:Boolean=false) : void
		{
//			var padding : int = 20;
			var tutorialView : TutorialView = new TutorialView();
			
			tutorialView.text = text;
			tutorialView.url = null;
			Starling.current.stage.addChild(tutorialView);

			tutorialView.indexOfPage = 1;
			tutorialView.getBitmap(challenge);
			
		}
		
		
		
		public static function showCustomUrl(challenge:Boolean=false): void
		{
			showText("12345", challenge);
		}
		
		public static function showUrl(url : String) : void
		{
			var padding : int = 0;
			var tutorialView : TutorialView = new TutorialView();
			
			tutorialView.text = null;
			tutorialView.url = url;
			
			tutorialView.x = padding;
			tutorialView.y = padding;
			tutorialView.width = Starling.current.stage.stageWidth - 2 * padding;
			tutorialView.height = Starling.current.stage.stageHeight - 2 * padding;
			
			Starling.current.stage.addChild(tutorialView);
		}
		
	}
}