package com.despark.tuning3d.view.components.languages {
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.view.components.core.ListItemRenderer;
	import starling.display.Quad;
	public class LanguageItemRenderer extends ListItemRenderer {
		public static var SHORT_LABEL:Object = null;
		private var _quad:Quad = null;
		private var _bg:Quad = null;
		public function LanguageItemRenderer() {
			super();
			if(!SHORT_LABEL){
				SHORT_LABEL = {};
				SHORT_LABEL['ru-RU'] = 'RUS';
				SHORT_LABEL['en-US'] = 'ENG';
			}
			fontSize = 10;
			textColor = 0x2b3233;
		}
		
		protected override function  initialize():void{
			_bg=new Quad(this.actualWidth-4, this.actualHeight, 0xe6e6e6);
			addChild(_bg);
			super.initialize();
			_quad = new Quad(this.actualWidth-10, 1, 0x2b3233);
			_quad.alpha = 0.75;
			addChild(_quad);
		}
		
		public function get language() : Language {
			return data as Language;
		}
		
		protected override function commitData() : void {
			super.commitData();
			label.text=LanguageItemRenderer.getShortname(language);
		}
		
		public static function getShortname(language:Language):String{
			/*if(language.shortname!=null && language.shortname!=""){
				
				return language.shortname.toUpperCase();
			}else if(SHORT_LABEL[language.code]){
				
				
				return SHORT_LABEL[language.code];//  language.name.toUpperCase();  
				
			}else{*/
				if(language.code){
					return language.code.substr(0, 2).toUpperCase();
				} else {
					return "N/A";
				}
			//}
		}
		
		protected override function commitSelection() :void {
			super.commitSelection();
			textColor = isSelected ?  0xcccccc :  0x2b3233;
		}
		
		protected override function layout() : void {
			label.width = actualWidth;
			label.height = 13;
			label.y = int((actualHeight - label.height) / 2);
			label.height = actualHeight;
			
			_bg.x=2;
			_bg.y=0;
			_bg.width=actualWidth-4;
			_bg.height=actualHeight;
			
			_quad.x=5;
			_quad.y=actualHeight-1;
		}
		
		public override function get useEmbeddedFont() : Boolean {
			return language.supportsEmbeddedFont;
		}
	}
}