package com.despark.tuning3d.view.components.morecars
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.core.images.ImageCacher;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.downloads.DownloadsDefCarSlotView;
	import com.despark.tuning3d.view.components.downloads.DownloadsPartSlotView;
	import com.utils.FontSelector;

import feathers.controls.ScrollPolicy;

import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.ScrollContainer;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.FeathersControl;
	
	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.filters.ColorMatrixFilter;

	public class MoreCarsPopUp extends PopUp implements Multilingual
	{//cleanCacheButton
		//public static const CLEAN_CACHE_SELECTED : String = "cleanCacheSelected";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 480;
		
		//public var totalValueLabel : Label;
		public var car : Car;
		//public var partSlotsForDownload : Array;
		
		private var currentLanguage : Language;
		private var container : ScrollContainer;
		//private var totalLabel : MultilingualLabel;
		//private var cleanCacheButton : MultilingualButton;
		private var leaveACommentButton : MultilingualButton;
		private var thanksButton : MultilingualButton;
		private var textLabel : MultilingualLabel;
		
		private var image:ImageLoaderWithStates=null;
		//private var intializingLabel : MultilingualLabel;
		//private var downloadingView : FeathersControl;
		//private var partSlotViews : Array;
		
		//private var _saveDefCar : Boolean;
		
		//private var defCarView : DownloadsDefCarSlotView;

		
		
		
		
		public function MoreCarsPopUp()
		{
			super()
						
			setSizeInternal(Starling.current.stage.width - 150, Starling.current.stage.height - 120, false);
			
			if(Starling.current.stage.width  <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 50, Starling.current.stage.height - 50, false);
			}
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
			title = language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
			
			//intializingLabel.updateWithLanguage(language);
			
			//totalLabel.text = language.translate("mob_downloads", "total");
			//totalLabel.updateWithLanguage(language);
			
			//cleanCacheButton.updateWithLanguage(language);
			//cleanCacheButton.label = "   CLEAN CACHE"//language.translate("mob_downloads", "cleanCache").toUpperCase();
			
			
			
		//	leaveACommentButton.  language.translate("mob_settings", "morecarbuttoncolor");
			
			thanksButton.updateWithLanguage(language);
			thanksButton.label = language.translate("mob_morecars", "thanks, not now").toUpperCase();
			
			
			textLabel.updateWithLanguage(language);
			textLabel.text = language.translate("mob_morecars", "text").toUpperCase();
			if(textLabel.text=="TEXT"){
				
				var str:String="We are constantly adding new cars, parts and tunings option. \n"+
							   "Your feedback is very important for us to stay \n"+
							   "On the right track! \n\n"+
							   "Please give us your feedback!"
							   
				textLabel.text=str.toLocaleUpperCase();
				
			}
			
			
			var color:uint=0x49cc46
				
			if(leaveACommentButton){
				
				leaveACommentButton.removeFromParent(true);
				leaveACommentButton=null;
			}
			
			if(currentLanguage){
				var colorString:String=currentLanguage.translate("mob_settings", "morecarbuttoncolor");
				
				colorString=colorString.substr(1);     
				
				color=parseInt(colorString, 16);
			}
			
			leaveACommentButton = ButtonFactory.defaultButton(null, color);    
			//leaveACommentButton.visible = false;
			
			leaveACommentButton.textFormat.size=11;
			leaveACommentButton.addEventListener(Event.TRIGGERED, commentsButtonnTriggeredHandler);
			addChild(leaveACommentButton);
			
			
			leaveACommentButton.updateWithLanguage(language);
			leaveACommentButton.label = language.translate("mob_morecars", "leave a comment").toUpperCase();
			
			
			
			var image_url:String=language.translate("feedback", "image");
			
			//trace("TEST:", image_url);
			
			if(image){
				
				image.removeFromParent();
				image=null;
			}
			
			
			image=new ImageLoaderWithStates();
			image.visible=false;
			
			image.bitmapScale=0.5;
			
			//image.recieveImageSize2 =imageCompleteHandler;
			
			
			image.source=image_url;
			
			
			
			container.addChild(image)
			
			invalidate();
			
			
		}
		
		private function imageCompleteHandler(w:Number, h:Number, image:ImageLoaderWithStates) : void
		{
			//image.recieveImageSize2=null;
			//trace("image.width:", image.image.width);
			//trace("image.height:", image.image.height);
			
			
			invalidate("image");
			
			
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			container = new ScrollContainer();
			container.horizontalScrollPolicy=ScrollPolicy.OFF;
			//container.visible = false;
			container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 23;
			container.paddingRight = container.paddingRight = 23;
			addChild( container );
			
			var color:uint=0x49cc46;
		
			if(currentLanguage){
				var colorString:String=currentLanguage.translate("mob_settings", "morecarbuttoncolor");
				
				colorString=colorString.substr(1);     
				
			    color=parseInt(colorString, 16);
			}
			
			leaveACommentButton = ButtonFactory.defaultButton(null, color);    
			//leaveACommentButton.visible = false;
			
			leaveACommentButton.textFormat.size=11;
			leaveACommentButton.addEventListener(Event.TRIGGERED, commentsButtonnTriggeredHandler);
			addChild(leaveACommentButton);
			
			thanksButton = ButtonFactory.defaultButton(null, 0xff0000);
			thanksButton.addEventListener(Event.TRIGGERED, thanksButtonTriggeredHandler);
			thanksButton.textFormat.size=11;
			//thanksButton.visible = false;
			addChild(thanksButton);
			
			
			textLabel=new MultilingualLabel();
			textLabel.height=60;
			textLabel.textFormat = new TextFormat(FontSelector.getFont(), 9, 0x8f8f8f);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			
			textLabel.paddingRight=0;
			textLabel.paddingLeft=0;
			textLabel.paddingTop=16;
			  
		
			container.addChild(textLabel);
			
			//textLabel.text
			//contentBackgroundImage.visible = false;
		}
	
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.width-=10;
				contentBackgroundImage.height-=15;
				
				contentBackgroundImage.x+=5;
				contentBackgroundImage.y+=5;
				
				
				container.x = contentBackgroundImage.x;
				container.y = contentBackgroundImage.y;
				container.width = contentBackgroundImage.width;
				container.height = contentBackgroundImage.height;
				
				
				thanksButton.width=130;
				thanksButton.height=28;
				thanksButton.x = (contentBackgroundImage.x + contentBackgroundImage.width)-thanksButton.width;  
				thanksButton.y = contentBackgroundImage.y + contentBackgroundImage.height + 15;; 
			
				leaveACommentButton.width=130;
				leaveACommentButton.height=28;
				leaveACommentButton.x =  thanksButton.x - leaveACommentButton.width - 10;
				leaveACommentButton.y =  thanksButton.y
				
				
				textLabel.width=contentBackgroundImage.width;
				textLabel.height=contentBackgroundImage.height;
							
				textLabel.x = 0//contentBackgroundImage.x;
				textLabel.y = 0//contentBackgroundImage.y;
				
				/*intializingLabel.width = actualWidth;
				intializingLabel.y = int((actualHeight - intializingLabel.height) / 2);*/
			}
			
			
			if(isInvalid("image"))
			{
				if(image && image.image){
					
					//trace('isInvalid("image")');
					
					//trace("this.actualWidth:", this.actualWidth)
					
					var ration:Number=image.image.width/image.image.height;
					
					image.y=16;
					image.x=0;
					
					image.width=contentBackgroundImage.width-46;
					
					image.height=image.width/ration;
					
					
					textLabel.y=image.y+image.height;
					image.visible=true;
					
					
					
				}
			}
			
			
		}
		
	
		/*public function setDownloadButtonEnabled(value : Boolean) : void
		{
			downloadButton.alpha = value ? 1.0 : 0.5;
			downloadButton.touchable = value;
		}
		
		public function setDeleteButtonEnabled(value : Boolean) : void
		{
			deleteButton.alpha = value ? 1.0 : 0.5;
			deleteButton.touchable = value;
		}*/
			
				
		
		private function commentsButtonnTriggeredHandler(event : Event) : void
		{
			//dispatchEventWith(DOWNLOAD_SELECTED);
			SoundManager.playSound(SoundManager.SELECT_PART);
			if(car.moreCarsURL){
				
				navigateToURL(new URLRequest(car.moreCarsURL));
			}
			
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		private function thanksButtonTriggeredHandler(event : Event) : void
		{
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
			//dispatchEventWith(DELETE_SELECTED);
		}
	}
}