/**
 * Created by armen on 02.10.2017.
 */
package com.despark.tuning3d.view.components.partinfo
{
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.despark.tuning3d.view.components.partinfo.webview.IWebView;
import com.despark.tuning3d.view.components.partinfo.webview.NativeWB;
import com.despark.tuning3d.view.components.partinfo.webview.StageWB;
import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
import com.utils.DevHelper;
import com.utils.FontSelector;

import flash.events.Event;
import flash.geom.Rectangle;
import flash.net.URLRequest;
import flash.net.navigateToURL;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import feathers.controls.Button;
import feathers.controls.ToggleButton;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
import feathers.core.ITextRenderer;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
import starling.textures.Texture;

public class ComponentWebView extends FeathersControl
    {

        private var blockerView:WebViewLoader;
        private var _headerQuad:Quad;
        private var _backgroundQuad:Quad;
        private var _headerSeparator1 : Quad;
        private var _headerSeparator2 : Quad;

        private var _closeButton:Button;
        private var _minMaxButton:ToggleButton;
        private var _linkButton:Button;

        private static var _webView : IWebView;

        private var _isMinMaxButtonEnabled : Boolean = false;
        private var _isLinkButtonEnabled : Boolean = false;

        private var _verPadding  : Number;

        private var _completeShowCallback : Function = null;

        public var isOpened : Boolean = false;
        public var caller : *;
        public var initiator  : *;

        private var _label : MultilingualLabel;

        private var label1 : MultilingualLabel;

        private var headerOffset : Number = 15;
        public var dispatcher : DetailInfoView;

        private var _buttonSize : Number = 16;

        private var doubleLabel : Boolean = false;

        private var _title     : String;

        private var headerImage:Image;

        private var _ratio : Number = 3;

        public function get title():String {
            return _title;
        }

        public function set title(value:String) : void {
            _title = value;
            invalidate("text");
        }
        private var _headerHeight : Number;
        public function get headerHeight():Number {
            return _headerHeight;
        }

        public function set headerHeight(value:Number) : void {
            _headerHeight = value;
            invalidate(INVALIDATION_FLAG_SIZE);
        }

        private function  titleTextRenderer ():ITextRenderer
        {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (Constants.isWide ? 13 : 12), 0xFEFEFF);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }

        private function  titleTextRendererBold ():ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (Constants.isWide ? 13 : 12), 0xFEFEFF);
            textRenderer.embedFonts = FontSelector.embedFonts();
            textRenderer.textFormat.bold = true;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.LEFT;
            return textRenderer;
        }

        private var _properties:Object;
        public function set properties(value:Object) : void
        {
            _properties = value;

            title = properties.title;
            url = properties.url;
            name = properties.name;


            _isMinMaxButtonEnabled = properties.fullButton;
            _isLinkButtonEnabled = properties.linkButton;

            isInvalid(INVALIDATION_FLAG_DATA);
        }

        public function get properties():Object {
            return _properties;
        }
        private var _itewWidth:Number = 190;
        public function set itewWidth(value:Number) : void {
            _itewWidth = value;
            isInvalid(INVALIDATION_FLAG_SIZE)
        }

        public function get itewWidth():Number {
            return _itewWidth;
        }
        private var _startX:Number = 0;
        public function set startX(value:Number) : void {
            _startX = value;
        }

        public function get startX():Number {
            return _startX;
        }
        private var _url:String = null;
        public function set url(value:String) : void {
            _url = value;
        }

        public function get url():String {
            return _url;
        }
        private var _endX:Number = 0;
        public function set endX(value:Number) : void {
            _endX = value;
        }

        public function get endX():Number {
            return _endX;
        }


        public function ComponentWebView(obj:*)
        {
            super();

            _ratio = Starling.current.nativeStage.stageWidth / Constants.STAGE_WIDTH;

            if (obj) caller = obj;

            layout();
        }

        public function layout() : void
        {
            if(Constants.IS_EMULATOR )
            {
                if(!_webView )
                {
                    _webView = new StageWB();
                }

            }else {
                if(!_webView )
                {
                    _webView = new NativeWB();

                }
            }

            this.addEventListener(starling.events.Event.ADDED_TO_STAGE, onAddedToStage);
        }

        protected override function initialize():void {

            super.initialize();

            startupWidth = itewWidth;

            var _headerOffset:Number = 15;
            endX = -_headerOffset;
            _backgroundQuad = new Quad(1, 1, 0xffffff);

            addChild(_backgroundQuad);
            _headerQuad = new Quad(1, 1, 0x222828);

            addChild(_headerQuad);
            headerImage = new Image((caller as TuningScreen).assetManager.getTexture(properties.icon) as Texture);
            headerImage.color = 0xf7f7f7;

            addChild(headerImage);
            _label = new MultilingualLabel();
            _label.textRendererFactory = titleTextRenderer;

            addChild(_label);

            label1 = new MultilingualLabel();
            label1.visible = false;
            label1.textRendererFactory = titleTextRendererBold;
            addChild(label1);

            _closeButton = ButtonFactory.popupCloseButton(_buttonSize-4,_buttonSize-4);
            _closeButton.addEventListener(starling.events.Event.TRIGGERED, closeButtonTriggeredHandler);
            addChild(_closeButton);

            if (_isMinMaxButtonEnabled) {
                _minMaxButton = ButtonFactory.maxMinButton(_buttonSize - 4);
                _minMaxButton.isEnabled = false;
                _minMaxButton.addEventListener(starling.events.Event.CHANGE, minMaxButtonTriggeredHandler);

                addChild(_minMaxButton );

            }
            if (_isLinkButtonEnabled) {
                _linkButton = ButtonFactory.circleButton("ebay-navi");
                _linkButton.width = _linkButton.height = _buttonSize - 2;
                _linkButton.addEventListener(starling.events.Event.TRIGGERED, openDefaultBrowser);
                addChild(_linkButton);
            }

            if(_isMinMaxButtonEnabled || _isLinkButtonEnabled) _headerSeparator1 = new Quad(1,1,0xCECECE);
            if(_isMinMaxButtonEnabled && _isLinkButtonEnabled) _headerSeparator2 = new Quad(1,1,0xCECECE);

            width  = itewWidth;
            height = Starling.current.stage.stageHeight;

            x = -width;
            if (!blockerView) {
                blockerView = new WebViewLoader(true);
                blockerView.visible = false;
                addChild(blockerView);
            }
        }

        private function onPageLoadComplete(event:flash.events.Event):void
        {
            DevHelper._log("Page load complete event...");

            hideBlocker();

            if(_minMaxButton)
            {
                _minMaxButton.isEnabled = true;
            }
        }

        private function webViewPort(bottomPadding : int = 0) : Rectangle
        {

            var leftOffset: Number = 0;
            if (Device.isIphoneXVariant()) {
                leftOffset = Device.IPHONE_X_VARIANT_MARGIN_LEFT * Starling.current.contentScaleFactor;
            }

            var x: Number = Starling.current.nativeStage.stageWidth - itewWidth * _ratio;

            var width: Number = itewWidth * _ratio + leftOffset;


            if (x == 0) {
                x -= leftOffset;
                width += leftOffset;
            }

            var rect: Rectangle = new Rectangle(
                    x,
                    headerHeight * _ratio,
                    width,
                    Starling.current.nativeStage.stageHeight -headerHeight * _ratio - bottomPadding * _ratio
            );



            return rect;
        }

        private function hideBlocker() : void {
            if(blockerView)
            {
                blockerView.visible = false;
                blockerView.removeFromParent(true);
                blockerView = null;
            }

        }

        public function load(str:String) : void
        {
            if(HTMLCacher.instance.isCachableURL(str))
            {
                var html : String = HTMLCacher.instance.getHtml(str);
                if(html)
                {
                    Tracer.print("LOAD FROM STRING : " + str);
                    loadHtml(html);
                }
                else {
                    addCacherListeners();
                    HTMLCacher.instance.enqueueWithPriority(str);
                }
            }
            else {
                 loadDirectURL(str)
            }
        }

        private function removeCacherListeners() : void
        {
            HTMLCacher.instance.removeEventListener(HTMLCacher.EVENT_LOADED, htmlLoadedHandler);
            HTMLCacher.instance.removeEventListener(HTMLCacher.EVENT_ERROR, htmlLoadError);
            HTMLCacher.instance.removeEventListener(HTMLCacher.EVENT_IO_ERROR, htmlLoadIOError);
        }
        private function addCacherListeners() : void
        {
            HTMLCacher.instance.addEventListener(HTMLCacher.EVENT_LOADED, htmlLoadedHandler);
            HTMLCacher.instance.addEventListener(HTMLCacher.EVENT_ERROR, htmlLoadError);
            HTMLCacher.instance.addEventListener(HTMLCacher.EVENT_IO_ERROR, htmlLoadIOError);
        }


        private function htmlLoadError(e : starling.events.Event): void
        {
            removeCacherListeners();

            loadDirectURL(url);
        }

        private function htmlLoadIOError(e : starling.events.Event): void
        {
            removeCacherListeners();

            loadDirectURL(url);
        }

        public function htmlLoadedHandler(e : starling.events.Event) : void
        {
            var html : String = HTMLCacher.instance.getHtml(url);
            if(html)
            {
                Tracer.print("LOAD FROM STRING : " + url);
                loadHtml(html);
                removeCacherListeners();
            }
        }

        private function loadDirectURL(str : String) : void
        {
           removeCacherListeners();

            Tracer.print("LOAD FROM URL : " + str);
            _webView.loadURL(str);
        }

        private function loadHtml(html:String, addShadow : Boolean = true) : void
        {
            if(addShadow)
            {
                html = HTMLCacher.instance.addShadowOnHtml(html);
                html = HTMLCacher.instance.additionalWrapper(html);
            }

            removeCacherListeners();

            _webView.loadHTML(html);
        }

        private function onAddedToStage(event:starling.events.Event) : void {
            this.removeEventListener(starling.events.Event.ADDED_TO_STAGE, onAddedToStage);
            show(true);
        }

        protected override function draw():void
        {
            super.draw();

            if (isInvalid(INVALIDATION_FLAG_SIZE)) {
                var gap : Number = 8;
                var _headerOffset:Number = 15;
                _backgroundQuad.width  = itewWidth;
                _backgroundQuad.height = Constants.STAGE_HEIGHT;
                _backgroundQuad.x = _headerOffset;
                _backgroundQuad.y = 0;

                _headerQuad.width  = itewWidth + _headerOffset;
                _headerQuad.height = headerHeight;

                if (blockerView) {
                    blockerView.x = itewWidth - 50;
                    blockerView.y = actualHeight - 50;
                    blockerView.setSize(50, 50);
                    blockerView.visible = true;
                }


                _closeButton.x = _backgroundQuad.x + _backgroundQuad.width - _closeButton.width - 5;
                _closeButton.y = (headerHeight - _closeButton.width ) / 2;
				
				if(Device.isIphoneXVariant()) _closeButton.x-=17;

                if (headerImage) {
                    headerImage.width = headerImage.height = _buttonSize;
                    headerImage.x = 20;
                    headerImage.y = (headerHeight - _buttonSize ) / 2;
                }


                if(_isMinMaxButtonEnabled || _isLinkButtonEnabled)
                {
                    _headerSeparator1.alpha = .8;
                    _headerSeparator1.height = headerHeight - 10;
                    _headerSeparator1.width = 1;
                    _headerSeparator1.visible = true;
                    _headerSeparator1.x = _closeButton.x - 9;
                    _headerSeparator1.y = (headerHeight - _headerSeparator1.height) / 2;
                    if(!_headerSeparator1.parent) addChild(_headerSeparator1);

                    if (_isMinMaxButtonEnabled && _isLinkButtonEnabled) {
                        _minMaxButton.x = _headerSeparator1.x - _minMaxButton.width - 8 ;
                        _minMaxButton.y = (headerHeight - _minMaxButton.height)/2;

                        _headerSeparator2.alpha = .8;
                        _headerSeparator2.height = headerHeight - 10;
                        _headerSeparator2.width = 1;
                        _headerSeparator2.visible = true;
                        _headerSeparator2.y = (headerHeight - _headerSeparator2.height) / 2;
                        _headerSeparator2.x = _minMaxButton.x - 9;
                        if(!_headerSeparator2.parent) addChild(_headerSeparator2);

                        _linkButton.x =  _headerSeparator2.x - _linkButton.width - 8 ;
                        _linkButton.y = (headerHeight - _linkButton.height) / 2 - 1;
                    }
                    else if(_isMinMaxButtonEnabled)
                    {
                        _minMaxButton.x = _headerSeparator1.x - _minMaxButton.width - 8 ;
                        _minMaxButton.y = (headerHeight - _minMaxButton.height)/2;
                    }else {
                        _linkButton.x =  _headerSeparator1.x - _linkButton.width - 8 ;
                        _linkButton.y = (headerHeight - _linkButton.height) / 2 - 1;
                    }
                }

                _label.x = headerImage.x + headerImage.width + gap;//(smallWidth() ? - 30 : 0);
                _label.width = itewWidth - (headerImage.x + headerImage.width * (smallWidth() ? 3 : 2) + gap);

                label1.x = _label.x + 75;
            }

            if (isInvalid("text"))
            {
                if (title.indexOf("EBAY") != -1){
                    _label.text  = title.split('EBAY')[0].toString();
                    label1.text = 'EBAY' + title.split('EBAY')[1].toString();
                    label1.visible = true;
                    _label.y = (headerHeight - _label.height) / 2;
                }
                else {
                    _label.text = title;
                }

                _label.validate();
                label1.validate();
                _label.y = (headerHeight - _label.height) / 2;
                label1.y = (headerHeight - label1.height) / 2;

            }
        }

        private function smallWidth() : Boolean {
            return  (_isMinMaxButtonEnabled || _isLinkButtonEnabled);
        }

        public function hide(animation:Boolean=false):void
        {
            Starling.juggler.removeTweens(this);
            hideBlocker();

            if(_webView.hasEventListener(flash.events.Event.COMPLETE))
            {
                _webView.removeEventListener(flash.events.Event.COMPLETE, onPageLoadComplete);
            }
            _webView.hide();
            removeCacherListeners();

            if (animation)
            {
                var tween : Tween = new Tween(this, .45, Transitions.EASE_IN_OUT);
                    tween.moveTo(startX,0);
                    tween.onComplete = completeHide;
                Starling.juggler.add(tween);
            }
            else
            {
                this.x = startX;
                completeHide();
            }
        }

        private function completeHide() : void
        {
            hideBlocker();
            Starling.juggler.delayCall(function () : void {
                dispatchEventWith(starling.events.Event.CLOSE);

            }, .3);
            isOpened = false;

            if (initiator){
               (initiator as DetailInfoView).closeButtonTriggeredHandler();
            }

            clear();
        }

        public function show(animation:Boolean=false, complete:Function=null):void
        {
            _completeShowCallback = complete;

            if (animation)
            {
                var tween : Tween = new Tween(this, .45, Transitions.EASE_IN_OUT);
                    tween.moveTo(endX,0);
                    tween.onComplete = completeShow;
                Starling.juggler.add(tween);
            }
            else
            {
                this.x = endX;
                completeShow();
            }
        }

        private function completeShow():void
        {

            if(!_webView.hasEventListener(flash.events.Event.COMPLETE))
            {
                _webView.addEventListener(flash.events.Event.COMPLETE, onPageLoadComplete);
            }

            _webView.setViewPort(webViewPort());

            if (url) {
                load(url);
            }
            else {
                loadHtml(properties.dataHTML, false);
            }

            dispatchEventWith(starling.events.Event.OPEN);

            if (_completeShowCallback) {
                _completeShowCallback();
                _completeShowCallback = null;
            }

            isOpened = true;
        }

        public function showLoader():void{
            if(_webView){
                _webView.setViewPort(webViewPort());
                _webView.loadHTML('<html>\n' +
                        '<head>\n' +
                        '<meta name="viewport" content="width=device-width, initial-scale=1">\n' +
                        '<style>\n' +
                        'html, body{\n' +
                        '\tmargin: 0;\n' +
                        '    padding: 0;\n' +
                        '}\n' +
                        '.bg{\n' +
                        '\twidth: 100%;\n' +
                        '    height: 100%;\n' +
                        '    display: block;\n' +
                        '    position: absolute;\n' +
                        '    background-color: #424242;\n' +
                        '    opacity: 0.5;\n' +
                        '}\n' +
                        '.loader {\n' +
                        '  border: 8px solid #f0f0f0;\n' +
                        '  border-radius: 50%;\n' +
                        '  border-top: 8px solid #3498db;\n' +
                        '  width: 40px;\n' +
                        '  height: 40px;\n' +
                        '  -webkit-animation: spin 2s linear infinite; /* Safari */\n' +
                        '  animation: spin 2s linear infinite;\n' +
                        '  position: absolute;\n' +
                        '    top: calc(50% - 24px);\n' +
                        '    left: calc(50% - 24px);\n' +
                        '    margin-right: -50%;\n' +
                        '    transform: translate(-50%, -50%)\n' +
                        '  \n' +
                        '}\n' +
                        '\n' +
                        '/* Safari */\n' +
                        '@-webkit-keyframes spin {\n' +
                        '  0% { -webkit-transform: rotate(0deg); }\n' +
                        '  100% { -webkit-transform: rotate(360deg); }\n' +
                        '}\n' +
                        '\n' +
                        '@keyframes spin {\n' +
                        '  0% { transform: rotate(0deg); }\n' +
                        '  100% { transform: rotate(360deg); }\n' +
                        '}\n' +
                        '</style>\n' +
                        '</head>\n' +
                        '<body>\n' +
                        '<div class="bg"></div>\n' +
                        '<div class="loader"></div>\n' +
                        '</body>\n' +
                        '</html>');
            }
        }

        public function clear() : void
        {

            if (_closeButton) {
                _closeButton.removeEventListener(starling.events.Event.TRIGGERED, closeButtonTriggeredHandler);
                _closeButton.removeFromParent(true);
            }

            if (_backgroundQuad){
                _backgroundQuad.removeFromParent(true);
            }

            if (_minMaxButton ) {
                _minMaxButton.removeEventListener(starling.events.Event.CHANGE, minMaxButtonTriggeredHandler);
                _minMaxButton.removeFromParent(true);
            }

            if (_linkButton) {
                _linkButton.removeEventListener(starling.events.Event.TRIGGERED, openDefaultBrowser);
                _linkButton.removeFromParent(true);
            }

            hideBlocker();

            this.removeFromParent(true);
        }

        public function openDefaultBrowser(event:starling.events.Event) : void
        {
            if (url) {
                SoundManager.playSound(SoundManager.SELECT_PART);
                navigateToURL(new URLRequest(url));
             }
        }

        private var startupWidth : Number;
        public function minMaxButtonTriggeredHandler(event:starling.events.Event) : void
        {
            SoundManager.playSound(SoundManager.SELECT_PART);
            var tempObject : * = (caller as TuningScreen).getChildAt((caller as TuningScreen).numChildren-1);
            if (_minMaxButton.isSelected) // need to maximize
            {
                itewWidth = Constants.STAGE_WIDTH;
                this.x -= (Constants.STAGE_WIDTH - startupWidth);
                tempObject.visible = false;

            }
            else
            {
                this.x = endX;
                itewWidth = startupWidth;
                tempObject.visible = true;
            }

            tempObject = null;

            // resize view
            _webView.setViewPort(webViewPort());

            invalidate(FeathersControl.INVALIDATION_FLAG_ALL);
        }

        public function closeButtonTriggeredHandler(event:starling.events.Event=null) : void
        {
            SoundManager.playSound(SoundManager.SELECT_PART);
            if (_minMaxButton && _minMaxButton.isSelected){
                _minMaxButton.isSelected = !_minMaxButton.isSelected;
                Starling.juggler.delayCall(reset,.3);
            }
            else {
                reset();
            }
        }

        private function reset() : void {
            dispatcher.reset();
        }

        public static function disposeWebView() : void {
            if(_webView) {
                _webView.hide();
                _webView.dispose();
                _webView = null
            }
        }

        override public function dispose():void {
            super.dispose();
        }
    }
}