/**
 * Created by armen on 02.10.2017.
 */
package com.despark.tuning3d.view.components.partinfo
{
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.greensock.TweenLite;
    import com.utils.FontSelector;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.Radio;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;
import feathers.core.ToggleGroup;
import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;
import feathers.layout.HorizontalLayout;
    import feathers.layout.RelativePosition;
    import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.net.URLVariables;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
    import starling.textures.Texture;
    import starling.textures.Texture;

public class DetailInfoView extends LayoutGroup
{

    public static const SHOP_URL_BASE : String = "http://assets2.3dtuning.com/api/v1/buy";

    public var isOpened : Boolean = false;
    public var isCustom : Boolean;
    public var caller : TuningScreen;
    public var shopVariables : URLVariables;

    private var _emptyInfoContainer:LayoutGroup;

    /**
     * HEADER CONTAINER
     */
    private var _headContainer:LayoutGroup;
    private var _headerLabel : MultilingualLabel;
    private var _closeButton : Button;

    private var _carAndComponentNameLabel  : Label;
    private var _priceLabel1 : MultilingualLabel;
    private var _priceLabel2 : MultilingualLabel;
    private var _partLabel1  : MultilingualLabel;
    private var _partLabel2  : MultilingualLabel;

    private var _emptyInfoLabel : MultilingualLabel;
    private var _emptyInfoImage : Image;

    private var _title     : String;
    private var _itemTitle : String;
    private var _priceText : String;
    private var _partText  : String;

    /**
     * BUTTON CONTAINER
     */
    private var _buttonsContainer : LayoutGroup;
    private var _group:ToggleGroup;
    public var _specButton : Radio;
    public var _shopButton : Radio;
    public var _descButton : Radio;
    public var _pageButton : Radio;

    private var _itemWidth  : Number;
    private var _padding : int = 10;
    private var _wide : Boolean = false;
    private var _defaultItemHeight : int= 50;
    private var _headerHight : int = 22;
    private var _buttonHeight : int = 50;
    private var _carImageHeight : int;
    private var _shadowWidht : Number = 5.7;

    private var _mainLayoutGroup : LayoutGroup;
    //private var _mainLayoutGroup : Sprite;

    private var _shopURL : String;
    private var _properties:Object;
    private var _componentImageSourceURL:String;
    private var _componentImageLoader : ImageLoaderWithStates;
    private var _completeShowCallback : Function = null;

    private var curView  : ComponentWebView;

    private var buttonSelectedColor : uint = 0xFDFDFD;
    private var buttonDefaultColor  : uint = 0x454545;
    private var backgroundColor     : uint = 0xF7F7F7;

    private var carPositionWasChanged : Boolean = false;
    private var menuBarNeededWidth  : Number = 0;
    private var _loader:WebViewLoader;

    private var carImageContainer : LayoutGroup;
    private var partContainer : LayoutGroup;
    private var priceContainer: LayoutGroup;
    private var _maxPartLabelWidth:Number;
    private var _iphoneXVariantDiff:int = 0;
    private var _currentView:Image;
    private static const turn5Icon:Object = {
        "ford": {"defaultIcon":"turn5_americantrucks", "selectedIcon":"turn5_americantrucks_selected"},
        "jeep": {"defaultIcon":"turn5_extrime", "selectedIcon":"turn5_extrime_selected"}
    };
    private var _turn5Icons:Object;
    private var _defaultIcons:Object;
    public function DetailInfoView(obj:*) {
        super();
		
		if(Device.isIphoneXVariant()){
			_defaultItemHeight = 60;
			_buttonHeight = 60;
            _iphoneXVariantDiff = 17;
		}

        if (obj) caller = obj;


        _wide = Constants.isWide;
        _itemWidth = Constants.STAGE_WIDTH * (_wide ? .38 : .42) + _iphoneXVariantDiff;
    }

    private function initHeadContainer():void {
        var iconSize : int = 14;

        _headContainer = new LayoutGroup();
        _headContainer.layout = new AnchorLayout();
        addChild(_headContainer);
        _headContainer.width = _itemWidth;
        _headContainer.height = _headerHight;

        var backgroundHeadTexture:Texture = (caller as TuningScreen).assetManager.getTexture("info-bar");
        var backgroundHeadImage : Image = new Image(backgroundHeadTexture);

        _headContainer.addChild( backgroundHeadImage );
        backgroundHeadImage.width = _itemWidth+_shadowWidht - Constants.SCALE_FACTOR * .5;
        backgroundHeadImage.height = _headerHight;

        var labelLayData : AnchorLayoutData = new AnchorLayoutData();
        labelLayData.verticalCenter = 0;
        labelLayData.horizontalCenter = 0;

        _headerLabel = new MultilingualLabel();
        _headerLabel.layoutData = labelLayData;
        _headerLabel.textFormat = new TextFormat(FontSelector.getFont(true), (_wide ? 13 : 12),0xffffff);
        _headerLabel.textFormat.align = TextFormatAlign.CENTER;
        _headerLabel.textFormat.bold = true;
        _headContainer.addChild(_headerLabel);

        var hLayData : AnchorLayoutData = new AnchorLayoutData();
        hLayData.verticalCenter = 0;
        hLayData.left = _padding + _iphoneXVariantDiff;

        var headerIconImage:Image = new Image(ButtonFactory.assetManager.getTexture("ebay_info_icon") as Texture);
        var headerIcon : LayoutGroup = new LayoutGroup();
        headerIcon.setSize(iconSize,iconSize);
        headerIcon.layoutData = hLayData;
        headerIcon.backgroundSkin = headerIconImage;
        _headContainer.addChild(headerIcon);

        var closeLatData : AnchorLayoutData = new AnchorLayoutData();
        closeLatData.verticalCenter = 0;
        closeLatData.right = _padding;

        _closeButton = ButtonFactory.popupCloseButton(12,12);
        _closeButton.layoutData = closeLatData;
        _closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
        _headContainer.addChild(_closeButton);

    }

    private function initMainContainer(): void {
        _carAndComponentNameLabel = new Label();
        _carAndComponentNameLabel.maxWidth = _itemWidth - 2 * _padding;
        _carAndComponentNameLabel.minWidth = _itemWidth -  _padding;
        _carAndComponentNameLabel.wordWrap = true;
        _carAndComponentNameLabel.minHeight = 32.6;
        _carAndComponentNameLabel.textRendererFactory = carNameLabelTextRenderer;
        addChild(_carAndComponentNameLabel);

        priceContainer = new LayoutGroup();
        var priceLay : HorizontalLayout = new HorizontalLayout();
        priceLay.verticalAlign = VerticalAlign.MIDDLE;
        priceLay.gap = 4;
        priceLay.paddingLeft = _iphoneXVariantDiff;
        priceContainer.layout = priceLay;
        priceContainer.width = _itemWidth - 2 * _padding;
        addChild(priceContainer);

        var maxH : int = 16;
        _priceLabel1 = new MultilingualLabel();
        _priceLabel1.textRendererFactory = priceTextRenderer1;
        _priceLabel1.maxHeight = maxH;
        priceContainer.addChild(_priceLabel1);

        _priceLabel2 = new MultilingualLabel();
        _priceLabel2.textRendererFactory = priceTextRenderer2;
        _priceLabel2.maxHeight = maxH;
        priceContainer.addChild(_priceLabel2);

        partContainer = new LayoutGroup();
        var partLay : HorizontalLayout = new HorizontalLayout();
        partLay.verticalAlign = VerticalAlign.MIDDLE;
        partLay.gap = 4;
        partLay.paddingLeft = _iphoneXVariantDiff;
        partContainer.layout = partLay;
        partContainer.maxHeight = maxH;
        addChild(partContainer);

        partContainer.width = _itemWidth - 2 * _padding;

        _partLabel1 = new MultilingualLabel();
        _partLabel1.textRendererFactory = partTextRenderer1;
        _partLabel1.maxHeight = maxH;
        _partLabel1.text = "Brand:";
        _partLabel1.validate();

        partContainer.addChild(_partLabel1);

        _partLabel2 = new MultilingualLabel();
        _partLabel2.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 11 : 10), 0x454545);
        _partLabel2.wordWrap = false;
        _partLabel2.textFormat.align = TextFormatAlign.LEFT;
        _partLabel2.textFormat.bold = true;
        _partLabel2.validate();
        _maxPartLabelWidth = _itemWidth - 3 * _padding - _partLabel1.width;
        partContainer.addChild(_partLabel2);
        partContainer.validate();

        _emptyInfoLabel = new MultilingualLabel();
        _emptyInfoLabel.textRendererFactory = emptyInfoTextRenderer;
        _emptyInfoLabel.wordWrap = true;
        _emptyInfoLabel.visible = false;
        _emptyInfoLabel.width = partContainer.width;
        addChild(_emptyInfoLabel);
        _emptyInfoLabel.text = "No information available at the moment. Please check later for featured updates";
    }

	private function initImageContainer():void {
		_carImageHeight = actualHeight - 87 - (_buttonHeight + 22);
		carImageContainer  = new LayoutGroup();
		addChild(carImageContainer);
		var itemWidth:Number = _itemWidth - _iphoneXVariantDiff;
		carImageContainer.width = itemWidth;
		carImageContainer.x = _iphoneXVariantDiff;
		
		carImageContainer.height = _carImageHeight; // there are 3 items;
		carImageContainer.backgroundSkin = new Quad(1,1,backgroundColor);
		_componentImageLoader = new ImageLoaderWithStates();
		_componentImageLoader.strictAspectRatio = itemWidth / (_carImageHeight);
		_componentImageLoader.completeHandler = function(loader : ImageLoaderWithStates):void {
			if(properties) {
				_componentImageLoader.width = itemWidth;
				_componentImageLoader.height = _carImageHeight; // there are 3 items
				_componentImageLoader.visible = true;
			} else {
				_componentImageLoader.visible = false;
			}
            removeView();
		};

        _componentImageLoader.errorHandler = function():void {
            removeView();
		};

        _componentImageLoader.errorHandler2 = function():void {
            removeView();
		};
		
		_componentImageLoader.overrideDispose = true;
		_componentImageLoader.width = itemWidth;
		_componentImageLoader.height = _carImageHeight; // there are 3 items
		carImageContainer.addChild(_componentImageLoader);
		
		if(_componentImageSourceURL)
		{
			componentImageSourceURL = _componentImageSourceURL;
		}
	}

    private function initButtonsContainer():void {

        var horLay :HorizontalLayout = new HorizontalLayout();
        horLay.gap = 1;
        horLay.paddingTop = 1;

        _group = new ToggleGroup();
        _group.addEventListener(Event.CHANGE, toolbarButtonButtonTriggeredHandler);
        _group.isSelectionRequired = false;

        _buttonsContainer = new LayoutGroup();
        _buttonsContainer.layout = horLay;

        addChild(_buttonsContainer);
        _buttonsContainer.backgroundSkin = new Quad( 1,1,0xaaaaaa);

        var _h : Number = _buttonHeight;
        var _w : Number = (_itemWidth - 3)/4;
        _specButton = ButtonFactory.detailsMenuButton({sel:"spec-def"},{w:_w,h:_h,t:"SPECS"});
        _specButton.isEnabled = false;
        _specButton.toggleGroup = _group;
        _buttonsContainer.addChild(_specButton);

        _pageButton = ButtonFactory.detailsMenuButton({sel:"official-def"},{w:_w,h:_h,t:"OFFICIAL"});
        _pageButton.toggleGroup = _group;
        _pageButton.isEnabled = false;
        _buttonsContainer.addChild(_pageButton);

        _descButton = ButtonFactory.detailsMenuButton({sel:"deal-loc"},{w:_w,h:_h,t:"DEALERS"});
        _descButton.toggleGroup = _group;
        _descButton.isEnabled = false;
        _buttonsContainer.addChild(_descButton);

        _shopButton = ButtonFactory.detailsMenuButton({sel:"shop-def"},{w:_w,h:_h,t:"SHOP"});
        _shopButton.toggleGroup = _group;
        _shopButton.isEnabled = false;
        _buttonsContainer.addChild(_shopButton);
        _defaultIcons = {"defaultIcon": _shopButton.defaultIcon, "selectedIcon": _shopButton.defaultSelectedIcon};
    }

    protected override function initialize():void {
        super.initialize();

        this.visible = false;
        this.width  = _itemWidth;
        this.height = Starling.current.stage.stageHeight;
        this.x = -_itemWidth;

        _mainLayoutGroup = new  LayoutGroup();
        _mainLayoutGroup.y = _headerHight;
        _mainLayoutGroup.width = _itemWidth;
        _mainLayoutGroup.height = Starling.current.stage.stageHeight - _headerHight;
        _mainLayoutGroup.layout = new VerticalLayout();
        _mainLayoutGroup.backgroundSkin = new Quad(1,1, backgroundColor);
        this.addChild(_mainLayoutGroup);

        _shadowWidht = _itemWidth  * 10/433;

        var shadow : Image = new Image((caller as TuningScreen).assetManager.getTexture("simple_shadow")) ;
        addChild(shadow);
        shadow.height =this.height;
        shadow.width = _shadowWidht;
        shadow.x = _itemWidth;
        shadow.y = _headerHight;

        initHeadContainer();
        initMainContainer();
        initImageContainer();
        initButtonsContainer();

        _emptyInfoContainer = new LayoutGroup();
        addChild(_emptyInfoContainer);

        var backgroundTexture : Texture = (caller as TuningScreen).assetManager.getTexture("No-Info-Image-for-Buy");
        _emptyInfoImage  = new Image(backgroundTexture);

        _emptyInfoContainer.addChild(_emptyInfoImage);
        _emptyInfoContainer.visible = false;
    }

    protected override function draw():void {
        super.draw();

        _carAndComponentNameLabel.x = _padding + _iphoneXVariantDiff;
        _carAndComponentNameLabel.y = _headContainer.height + _padding/2;

        _buttonsContainer.y = actualHeight - _buttonsContainer.height;

        partContainer.x = _padding;
        partContainer.y = _buttonsContainer.y - 22;

        //_partLabel2.x = _partLabel1.width + 0.6 +_padding;
        partContainer.validate();
        priceContainer.x = _padding;
        priceContainer.y = partContainer.y - 15;



        if (carImageContainer) {
            carImageContainer.y = _carAndComponentNameLabel.y + _carAndComponentNameLabel.height + _padding/2 + 2;
        }

        if (_emptyInfoContainer) {
            _emptyInfoContainer.width = _itemWidth;
            _emptyInfoContainer.height = actualHeight - 87 - (_buttonHeight + 22);
            _emptyInfoContainer.y = _carAndComponentNameLabel.y + _carAndComponentNameLabel.height + _padding/2 + 2;

            _componentImageLoader.width = _itemWidth - _iphoneXVariantDiff;
            _componentImageLoader.height = _carImageHeight; // there are 3 items

            _emptyInfoImage.width = _itemWidth;
            _emptyInfoImage.height = _emptyInfoContainer.height;

            _emptyInfoLabel.x = priceContainer.x + _iphoneXVariantDiff;
            _emptyInfoLabel.y = _emptyInfoContainer.y + _emptyInfoContainer.height + _padding/2 + 2;
        }

        if (isInvalid("text")) {
            if (title) {
                _headerLabel.text = title;
                _headerLabel.updateWithLanguage((caller as TuningScreen).language);
            }

            if (itemTitle) {
                _carAndComponentNameLabel.text = itemTitle;
                maxHeightRegulator(_carAndComponentNameLabel,(_wide ? 12 : 11), 33);
            }
            else {
                _carAndComponentNameLabel.text = "";
            }

            _priceLabel1.text = "MSRP:";
            if (priceText) {
                _priceLabel2.text = priceText;
                _priceLabel2.validate();
//                priceContainer.validate();
            }else {
                _priceLabel2.text ="";
            }

            _partLabel1.text = "Brand:";
            if (partText) {
                _partLabel2.text = partText;
                maxWidthRegulator(_partLabel2,(_wide ? 11 : 10),_maxPartLabelWidth);

                _partLabel1.validate();
                _partLabel2.validate();
                //_partLabel2.y = partContainer.y + (15 -_partLabel2.height) *  0.78 ; //0.8
                partContainer.validate();
            }else {
                _partLabel2.text = "";
            }
        }
    }

    private function buttonSelected(dt:Object) : void {
        if (curView){

            curView.startX = curView.endX;
            curView.hide(true);
            curView = null;
        }

        curView = new ComponentWebView(caller);
        curView.dispatcher = this;
        curView.itewWidth = Constants.STAGE_WIDTH - _itemWidth;
        curView.startX = x - (curView.itewWidth - _itemWidth);
        curView.headerHeight = _headerHight;
        curView.properties = dt;
        caller.addChildAt(curView,(caller as TuningScreen).numChildren - 1);
        // curView.clear();

        showLoader();
    }

    private function toolbarButtonButtonTriggeredHandler(event:Event) : void {
        var  object : Object;
        if(_group.selectedIndex != -1){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
        switch(_group.selectedIndex) {
            case 0:
                object = {
                    name:"SPECIFICATION",
                    title:"ITEM SPECIFICATION & DESCRIPTION",
                    icon:"spec-def",
                    fullButton:false,
                    linkButton:false,
                    url:null,
                    dataHTML:properties.dataHTML
                }; break;
            case 2:
                object = {
                    name:"DESCRIPTION",
                    title:"DEALER LOCATOR",
                    icon:"deal-loc",
                    fullButton:true,
                    linkButton:true,
                    url:setUrl(properties.dealer_locator)
                }; break;
            case 3:
                object = {
                    name:"SHOP NOW",
                    title:"SEARCH ON EBAY",
                    icon:"shop-def",
                    fullButton:true,
                    linkButton:false,
                    url:shopURL
                };
                if(properties.hasOwnProperty("turn_five") && properties.turn_five){
                    object.title = "";
                    object.icon = turn5Icon[properties.carName].selectedIcon;
                }
                break;
            case 1:
                object = {
                    name:"OFFICIAL",
                    title:"OFFICIAL PAGE",
                    icon:"official-def",
                    fullButton:true,
                    linkButton:true,
                    url:setUrl(properties.url)
                }; break;
            default :
                    if(curView)
                    {
                        curView.hide(true);
                        curView = null;
                    }
                return;
        }

        if(properties){

        }

        if(properties) {
            object.desc = properties.description;
        }

        buttonSelected(object);

    }


    private function maxWidthRegulator(label : MultilingualLabel, defaultFont : Number, maxWidth : Number) : void {
        setTextSize(label, defaultFont, 0,false, true);
        label.validate();

        while (label.width > maxWidth)
        {
            defaultFont -= .1;
            setTextSize(label, defaultFont, 0,false, true );
            label.validate();
        }
    }

    private function maxHeightRegulator(label : Label, defaultFont : Number, maxHeight : Number) : void {
        setTextSize(label, defaultFont, 0 , true, false);
        label.validate();

        while (label.height > maxHeight)
        {
            defaultFont -= .1;
            setTextSize(label, defaultFont, 0,true, false );
            label.validate();
        }


        var delta : Number = 10;
        setTextSize(label, defaultFont, delta,true, false);
        label.validate();
        var acc : Number = 1.2;

        while (label.height > maxHeight)
        {
            delta -= acc;
            if(acc>.2){
                acc -= .1;
            }
            setTextSize(label, defaultFont, delta ,true, false);
            label.validate();
        }

    }

    private function setTextSize(lbl:Label,sz:int, delta : Number, wordWrap : Boolean, bold: Boolean) : void {
        lbl.textRendererFactory = function ():ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
                textRenderer.textFormat = new TextFormat(FontSelector.getFont(true), sz, 0x454545);
                textRenderer.textFormat.bold = bold;
                textRenderer.embedFonts = true;
                textRenderer.textFormat.align = TextFormatAlign.LEFT;
                textRenderer.wordWrap = wordWrap;
                if(delta>0) textRenderer.textFormat.leading = 1 + delta;
            return textRenderer;
        }
    }

    public function hide(animation:Boolean=false, time:Number=.1):void {
        if (curView) {
            curView.hide(false);
            curView = null;
        }

        var target : TuningScreen = caller as TuningScreen;
        target.deltaIsUsed = true;
        target.onUpdateMenu();
        target.updateMenuListWidth(target.width);

        if (animation) {
            var tween : Tween = new Tween(caller, .45, Transitions.EASE_IN_OUT);
            tween.moveTo(0,0);
            tween.onComplete = completeHide;
            Starling.juggler.add(tween);

            if (carPositionWasChanged) {
                isOpened = false;
                target.carView.moveDelta = 0;
                target.moveTo(0,target.carView);
                carPositionWasChanged = false;
            }
        } else {
            target.x = 0;
            caller.x = 0;
            completeHide();
        }
    }

    private function completeHide() : void {
        var target : TuningScreen = caller as TuningScreen;
        target.hitAreaDX = 0;
        target.windowIsOpened = false;
        dispatchEventWith(Event.CLOSE);

        isOpened = false;
        visible = false;
    }

    public function show(animation:Boolean=false, complete:Function=null):void {
        var target : TuningScreen = caller as TuningScreen;
        if (0 == target.progressDeltaX && target.progressDefaultX == 0) {
            target.progressDefaultX = (target.width - target.progressBar.width) / 2;
            menuBarNeededWidth = target.width - actualWidth;
            target.progressDeltaX = (menuBarNeededWidth - target.progressBar.width) / 2;
        }
        //target.windowIsOpened = true;
        target.deltaIsUsed = false;
        target.updateMenuListWidth(menuBarNeededWidth);
        target.onUpdateMenu();

        this.visible = true;
        _completeShowCallback = complete;

        this.title = "INFORMATION";

        if (animation) {
            var tween : Tween = new Tween(caller, .45, Transitions.EASE_IN_OUT);
            tween.moveTo(width,0);
            tween.onComplete = completeShow;
            Starling.juggler.add(tween);

            target.carView.moveDelta = width / 2;
            target.moveTo(-width / 2,target.carView);
        } else {
            target.x = -width / 2;
            caller.x = actualWidth;
            completeShow();
        }
        Starling.juggler.delayCall(target.lockMenu,.1,false);
    }

    private function createView():void{
        if(_currentView){
            _currentView.removeFromParent(true);
        }
        var restoreLoader:Boolean = false;
        if(_loader && _loader.stage && _loader.visible){
            restoreLoader = true;
            _loader.visible = false;
        }
        var txt:Texture = Texture.fromBitmapData(drawToBitmapData());
        _currentView = new Image(txt);
        _currentView.scale = width / _currentView.width;
        if(restoreLoader){
            _loader.visible = true;
        }
        var index:int = getChildIndex(_loader);
        addChildAt(_currentView, index);
    }

    private function removeView():void{
        if(_currentView){
            TweenLite.to(_currentView, 0.2, {alpha:0, onComplete:function():void{
                    _currentView.removeFromParent(true);
                    _currentView = null;
                }
            });
        }
    }

    public function showLoading() : void {
        createView();
        if(!_loader) {
            _loader = new WebViewLoader();
            addChild(_loader);
            _loader.x = _itemWidth / 2 - _loader.width / 2;
            _loader.y = (actualHeight - _loader.height) / 2;
        }
    }

    public function hideLoading() : void {
        if(_loader) {
            _loader.hide();
            _loader = null;
        }
    }

    private function completeShow():void {
        var target : TuningScreen = caller as TuningScreen;
        dispatchEventWith(Event.OPEN);

        target.hitAreaDX = width / 2;
        target.hideBlocker();

        if (_completeShowCallback) {
            _completeShowCallback();
            _completeShowCallback = null;
        }

        carPositionWasChanged = true;
        isOpened = true;
    }


    public function clear() : void {
        if (_headContainer) _headContainer.removeFromParent(true);

        if (_priceLabel1) _priceLabel1.removeFromParent(true);
        if (_priceLabel2) _priceLabel2.removeFromParent(true);
        if (_partLabel1) _partLabel1.removeFromParent(true);
        if (_partLabel2) _partLabel2.removeFromParent(true);
        if (_headerLabel) _headerLabel.removeFromParent(true);

        if (_emptyInfoContainer) {
            _emptyInfoContainer.removeChild(_emptyInfoImage);
            _emptyInfoContainer.removeFromParent(true);
        }

        if (_closeButton){
            _closeButton.removeEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
            _closeButton.removeFromParent(true);
        }

        if (_carAndComponentNameLabel) removeChild(_carAndComponentNameLabel);

        if(_componentImageLoader)
        {
            _componentImageLoader.removeFromParent();
            _componentImageLoader.sepcialDispose();
            _componentImageLoader.dispose();
            _componentImageLoader = null;
        }


        if (_specButton) {
            (_specButton).removeEventListeners();
            _buttonsContainer.removeChild(_specButton,true);
        }

        if (_descButton) {
            (_descButton).removeEventListeners();
            _buttonsContainer.removeChild(_descButton,true);
        }

        if (_shopButton) {
            (_shopButton).removeEventListeners();
            _buttonsContainer.removeChild(_shopButton,true);
        }

        if (_pageButton) {
            (_pageButton).removeEventListeners();
            _buttonsContainer.removeChild(_pageButton,true);
        }

        _group.removeEventListener(Event.CHANGE, toolbarButtonButtonTriggeredHandler);


        if (_buttonsContainer) _buttonsContainer.removeFromParent(true);

        ComponentWebView.disposeWebView();


    }

    public function closeButtonTriggeredHandler(event:Event=null) : void {
        SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
        if (curView) {
            curView.initiator = this;
            curView.hide(true);
            curView = null;
            reset();
        }else{
            hide(true);
        }
    }

    public function set componentImageSourceURL(source : String ) : void {
        if(_componentImageSourceURL == source) {
            _componentImageLoader.visible = true;
            return;
        }
        _componentImageSourceURL = source;

        if(_componentImageLoader) {
            _componentImageLoader.source = source;
            _componentImageLoader.visible = false;
        }
    }

    public function set properties(value:Object) : void {
        _properties = value;
        shopURL +=
                "?model=" + shopVariables.model +
                "&make=" + shopVariables.make +
                "&year=" + shopVariables.year +
                "&type=" + shopVariables.type +
                "&component=" + shopVariables.component +
                "&mobile=true";
        if(value == null) {
            isCustom = true;

            itemTitle = "";
            priceText = "";
            partText = "";
            partContainer.visible = false;
            priceContainer.visible = false;

            if (_componentImageLoader) {
                _componentImageLoader.visible = false;
            }

            _specButton.isEnabled = false;
            _shopButton.isEnabled = true;
            _pageButton.isEnabled = false;
            _descButton.isEnabled = false;

            _emptyInfoContainer.visible = true;
            _emptyInfoLabel.visible = true;
            itemTitle = this.name;

        } else {
            //
            if(_properties.hasOwnProperty("turn_five") && _properties.turn_five){
                _shopButton.label = "";
                if(!_turn5Icons){
                    var iconObj:Object = turn5Icon[_properties.carName];
                    var margin:Number = 5;
                    if(iconObj){
                        var defaultIcon:Image = new Image(ButtonFactory.assetManager.getTexture(iconObj.defaultIcon));
                        if(defaultIcon.width / defaultIcon.height < _shopButton.width / _shopButton.height){
                            defaultIcon.height = _shopButton.height - margin;
                            defaultIcon.scale = defaultIcon.scaleY;
                        }else{
                            defaultIcon.width = _shopButton.width - margin;
                            defaultIcon.scale = defaultIcon.scaleX;
                        }

                        var selectedIcon:Image = new Image(ButtonFactory.assetManager.getTexture(iconObj.selectedIcon));
                        if(selectedIcon.width / selectedIcon.height < _shopButton.width / _shopButton.height){
                            selectedIcon.height = _shopButton.height - margin;
                            selectedIcon.scale = selectedIcon.scaleY;
                        }else{
                            selectedIcon.width = _shopButton.width - margin;
                            selectedIcon.scale = selectedIcon.scaleX;
                        }
                        _turn5Icons = {"defaultIcon": defaultIcon, "selectedIcon": selectedIcon};
                        _shopButton.defaultSelectedIcon = selectedIcon;
                    }
                }
                _shopButton.defaultIcon = _turn5Icons.defaultIcon;
                _shopButton.defaultSelectedIcon = _turn5Icons.selectedIcon;
            }else{
                _shopButton.defaultIcon = _defaultIcons.defaultIcon;
                _shopButton.defaultSelectedIcon = _defaultIcons.selectedIcon;
                _shopButton.label = "SHOP";
            }
            //
            partContainer.visible = true;
            priceContainer.visible = true;
            _emptyInfoLabel.visible = false;
            _emptyInfoContainer.visible = false;

            isCustom = false;
            _specButton.isEnabled = (properties.dataHTML != null);
            _shopButton.isEnabled = true;
            _pageButton.isEnabled = true;
            _descButton.isEnabled = true;

            var date : Date = new Date();
            date.hours = 0;
            date.minutes = 0;
            date.seconds = 1;

            itemTitle = (properties.name) ? properties.name : "";
            partText  = (properties.manufacturer) ? properties.manufacturer : "";
            partText += (properties.manufacturer_option) ? " " + properties.manufacturer_option : "";
            priceText = (properties.price) ? properties.price : "";

            _pageButton.isEnabled = (properties.url != null && properties.url.length > 0);
            _descButton.isEnabled = (properties.dealer_locator != null && properties.dealer_locator.length > 0);

            if(properties.image && properties.image.length > 0) {
                componentImageSourceURL = (properties.image[0]);
            }

            if(properties.hasOwnProperty("part_number") && properties["part_number"] != null) {
                shopURL += "&product_part_number=" + properties["part_number"];
            }

            if(properties.hasOwnProperty("manufacturer") && properties["manufacturer"] != null) {
                shopURL += "&product_manufacturer=" + properties["manufacturer"];
            }

            shopURL += "&t=" + date.getTime().toString();
            if(_properties.hasOwnProperty("turn_five") && _properties.turn_five){
                shopURL = _properties.turn_five_url;
            }

            HTMLCacher.instance.enqueue(setUrl(properties.url));
            HTMLCacher.instance.enqueue(setUrl(properties.dealer_locator));
            HTMLCacher.instance.startLoad();

            reset();
        }

        invalidate(INVALIDATION_FLAG_DATA);
    }
    public function get properties():Object {
        return _properties;
    }

    public function get shopURL():String {
        return _shopURL;
    }
    public function set shopURL(value:String) : void {
        value = value.replace(" ",'%20');
        _shopURL = value;
    }

    public function get priceText():String {
        return _priceText;
    }
    public function set priceText(value:String) : void {
        _priceText = value;
        invalidate("text");
    }

    public function get title():String {
        return _title;
    }
    public function set title(value:String) : void {
        _title = value;
        invalidate("text");
    }

    public function set partText(value:String) : void {
        _partText = value;
        invalidate("text");
    }

    public function get partText():String {
        return _partText;
    }

    public function get itemTitle():String {
        return _itemTitle;
    }
    public function set itemTitle(value:String) : void {
        _itemTitle = value;
        invalidate("text");
    }

    private function setUrl(str:String) : String {
        return str;
        /*if(str == null){
            return null;
        }
        return (Constants.isIOS ? "https:" : "http:") + "//" + str.split("//")[1];*/
    }

    private function  carNameLabelTextRenderer ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 12 : 11), 0x454545);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    private function  priceTextRenderer1 ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 11 : 10), 0x454545);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = false;
        textRenderer.textFormat.letterSpacing = 0.68;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    private function  priceTextRenderer2 ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 11 : 10), 0x454545);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    private function  partTextRenderer1 ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 11 : 10), 0x454545);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }


    private function  emptyInfoTextRenderer ():ITextRenderer
    {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getFont(), (_wide ? 11 : 10), 0x454545);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.bold = false;
        textRenderer.textFormat.italic = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public function reset():void
    {
        if(_group) {
            _group.selectedIndex = -1;
        }
    }

    public function showLoader():void {
        if(curView){
            curView.showLoader();
        }
    }
}
}