package com.despark.tuning3d.view.components.partinfo.webview {
import com.despark.tuning3d.model.core.Tracer;
import com.distriqt.extension.nativewebview.Header;
import com.utils.DevHelper;

import flash.events.ErrorEvent;
import flash.events.Event;
import flash.events.EventDispatcher;
import flash.events.LocationChangeEvent;
import flash.geom.Rectangle;
import flash.media.StageWebView;
import flash.net.URLRequest;
import flash.net.navigateToURL;

import starling.core.Starling;

public class StageWB extends EventDispatcher implements IWebView{

    private var _stageWebView : StageWebView;
    private static const BLANK_HTML : String = "<html> </html>";

    public function StageWB() {

        Tracer.print("STAGE WEB VIEW");

        _stageWebView = new StageWebView();

        _stageWebView.addEventListener(flash.events.Event.COMPLETE, onPageLoadComplete);
        _stageWebView.addEventListener(ErrorEvent.ERROR, onPageLoadError);
        _stageWebView.stage = Starling.current.nativeStage;

    }

    public function dispose(): void
    {
        if (_stageWebView ) {
            _stageWebView.stop();
            _stageWebView.removeEventListener(LocationChangeEvent.LOCATION_CHANGING, onLocationChanging);
            _stageWebView.removeEventListener(flash.events.Event.COMPLETE, onPageLoadComplete);
            _stageWebView.removeEventListener(ErrorEvent.ERROR, onPageLoadError);
            _stageWebView.viewPort = null;
            _stageWebView.dispose();
            _stageWebView = null;
        }
    }

    private function onPageLoadComplete(event:Event):void {
        if( !_stageWebView.hasEventListener(LocationChangeEvent.LOCATION_CHANGING))
        {
            _stageWebView.addEventListener(LocationChangeEvent.LOCATION_CHANGING, onLocationChanging);
        }
        dispatchEvent(event);
    }

    public function setViewPort(rect:Rectangle):void {
        _stageWebView.viewPort = rect;
    }

    public function loadHTML(html:String):void {
        _stageWebView.loadString(html);
    }

    public function loadURL(url:String, headers: Vector.<Header> = null):void {
        _stageWebView.loadURL(url);
    }


    private function onLocationChanging(event:LocationChangeEvent):void
    {
        DevHelper._log("navigateToURL(" + event.location + ")");
        event.preventDefault();
        navigateToURL(new URLRequest(event.location));
    }
    private function onPageLoadError(event:ErrorEvent):void {
        DevHelper._log("Error loading page: " + event.text);
        //loadFromURL(setUrl(url));
    }

    public function hide():void {
        if (_stageWebView ) {
            _stageWebView.stop();
            loadHTML(BLANK_HTML);
            _stageWebView.viewPort = null;
        }
    }
}
}
