package com.despark.tuning3d.view.components.parts
{
import com.despark.tuning3d.model.core.images.PersistentImageProvider;
import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.distriqt.AdsManager;
import com.utils.DisplayObjectUtil;
import com.utils.FontSelector;

import feathers.controls.Button;

import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
import starling.textures.Texture;

public class PartItemRenderer extends ListItemRenderer
{

    public static const EVENT_OPEN_INFO_POP_UP:String="EVENT_OPEN_INFO_POP_UP";


    protected var quad_back:Quad;
    protected var carLock:Image;
    protected var btnInfo : Button;

    private var _isTranslate:Boolean=false;
    private var _translateDescription:String="";

    private var _enabled:Boolean=true;



    private var seporator:Image;
	
	private var button:Button;
    protected var newIcon:Image;


    public function PartItemRenderer()
    {
        super();
        fontSize = 9;
        _textColor = 0x9c9c9c;
        _bold=false;
    }
	
	private function onTouch(event:Event):void{
		
		trace("onTouch", part.isFastModeLoaded);
		
		if(part.isFastModeLoaded){
			//var selIndex:int = owner.selectedIndex;
			//owner.selectedIndex = -1;
			//owner.selectedIndex = selIndex;
			itemSelectedAgainBlocker = true;
			
			owner.dispatchEventWith("ExitFromFastMode", false, {part:part});
			
			trace("onTouch2", part.isFastModeLoaded);
			
			this.invalidate();
		}
	}

    public function get translateDescription():String{

        return _translateDescription;
    }

    public function get part() : Part
    {
        return data as Part;
    }

    public function get isChopper():Boolean{
        return part ? part.parentSlot.parentCar.isChopper: false;
    }

    override public function dispose():void{
        if(quad_back){
            quad_back.dispose();
            quad_back = null;
        }
        if(carLock){
            carLock.dispose();
            carLock = null;
        }
        if(seporator){
            seporator.dispose();
            seporator = null;
        }
        if(button){
            button.dispose();
            button = null;
        }
        if(btnInfo){
            btnInfo.dispose();
            btnInfo = null;
        }
        if(newIcon){
            newIcon.dispose();
            newIcon = null;
        }
        super.dispose();
    }

    protected override function initialize():void
    {

        quad_back=new Quad(1, 1, 0xeaeaea);

        quad_back.alpha=0;

        this.addChild(quad_back);

        super.initialize();


        var carLockTexture : Texture = AlertView.assetManager.getTexture("car_lock_big_icon");
        carLock=new Image(carLockTexture);
        carLock.width=19.5;
        carLock.height=19.5;
        addChild(carLock);

        var seporatorTexture:Texture=ButtonFactory.assetManager.getTexture("a_seporator_1");

        seporator=new Image(seporatorTexture);

        seporator.width=1.5;

        addChild(seporator);

        label.paddingLeft=5;
        label.paddingRight=5;
		
		button = ButtonFactory.transparentButton();
		button.addEventListener(Event.TRIGGERED, onTouch);
		addChild(button);

        btnInfo  = ButtonFactory.circleButton("a_part_info_icon");
        btnInfo.width=14;
        btnInfo.height=15;
        btnInfo.addEventListener(Event.TRIGGERED, btnInfoHandler);
        addChild(btnInfo);

        newIcon = new Image(ButtonFactory.assetManager.getTexture("new_icon"));
        newIcon.width = 38;
        newIcon.height = 38;
        addChild(newIcon);

    }

    private function btnInfoHandler(event:Event):void {
        if(!part.lock) {
            if(isSelected){
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
            owner.dispatchEventWith(EVENT_OPEN_INFO_POP_UP, false, {part:this});
        }
    }

    protected override function commitData() : void
    {
        super.commitData();



        if (part && part.name === 'banner') {
            imageLoader.persistentImageProvider = null;
            newIcon.visible = btnInfo.visible = label.visible = carLock.visible = seporator.visible = imageLoader.visible = false;

            var bannerWidth: Number = AdsManager.$.bannerWidth;
            this.setSize(bannerWidth, 50);

            this.touchable = false;

        } else {
            if (this.part) {
                this.touchable = part.name != '.';
            }
            else {
                this.touchable = false;
            }
            newIcon.visible = btnInfo.visible = label.visible = carLock.visible = seporator.visible = imageLoader.visible = true;
            this.setSize(100, 50);
            if (part && AlertView.language.translate(part.id, "htmlCode") != null && AlertView.language.translate(part.id, "htmlCode") != "htmlCode") {

                _isTranslate = true;

                _translateDescription = AlertView.language.translate(part.id, "htmlCode");

            } else if (part && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != null && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != "htmlCode") {

                _isTranslate = true;

                _translateDescription = AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode");
            } else {

                _isTranslate = false;
                _translateDescription = "";
            }

            //_isTranslate=true;

            if (newIcon.x == 0) {
                newIcon.visible = false;
            } else {
                newIcon.visible = (part && part.properties.hasOwnProperty("is_new") && part.properties["is_new"])
            }



            if (part && part.name.indexOf("{custom}") >= 0) {
                var text:String = part.name;
                text = text.replace("{custom}", AlertView.language.translate("componentNames", "custom"));
                label.text = text;//AlertView.language.translate("componentNames", "custom").toUpperCase();


            } else if (part && part.name.indexOf("{factory}") >= 0) {
                var text2:String = part.name;
                text2 = text2.replace("{factory}", AlertView.language.translate("componentNames", "factory"));

                label.text = text2;//AlertView.language.translate("componentNames", "factory").toUpperCase();
            } else if (part) {
                label.text = part.name;
            }

//        newIcon.visible = true;//(part && part.properties.hasOwnProperty("is_new") && part.properties["is_new"]);


            if (part) {

                _enabled = part.enabled && !part.parentSlot.isExcluded;

                var newPersistentImageProvider:PersistentImageProvider = part;


                if (imageLoader.persistentImageProvider && imageLoader.persistentImageProvider.remoteUrl != newPersistentImageProvider.remoteUrl) {
                    //imageLoader.persistentImageProvider.remoteUrl
                    imageLoader.persistentImageProvider = part;
                    imageLoader.completeHandler = completeIconLoad;
                } else if (!imageLoader.persistentImageProvider) {

                    imageLoader.completeHandler = completeIconLoad;
                    imageLoader.persistentImageProvider = part;
                } else {
                    updatePartIcon();

                }
            }
        }
        isEnabled = _enabled;
    }

    override public function set bold(value : Boolean) : void
    {
        _bold = value;

        if(label)
        {
            label.textFormat.color = isSelected ? part.isFastModeLoaded ? 0xcccccc: 0xffffff : textColor
            label.textFormat.font=FontSelector.getFont(_bold);
            label.textFormat.bold=_bold;

            label.invalidate();
        }
    }

    protected override function commitSelection() :void
    {
        super.commitSelection();

        if (part && part.parentSlot) {
            if (!part.parentSlot.isExcluded) {
                bold = isSelected; //&& !part.parentSlot.isExcluded;
            }
        }

    }

    protected function completeIconLoad(image:ImageLoaderWithStates) : void
    {
        updatePartIcon();
    }

    protected function updatePartIcon() : void{

        imageLoader.width = 80;
        imageLoader.height = actualHeight - label.height - 5;
        imageLoader.x=(actualWidth-imageLoader.width )/2;
        imageLoader.y=4;

        Starling.juggler.delayCall(function () : void {
            if(newIcon)
            {
                newIcon.visible = (part && part.properties.hasOwnProperty("is_new") && part.properties["is_new"]);

                if(newIcon.visible)
                {
                    updateNewIcon();
                }
            }
        }, 0.3);
    }

    protected function updateNewIcon() :void {

        if(imageLoader && imageLoader.image)
        {
            newIcon.width = newIcon.height = imageLoader.image.height * 0.8;
            newIcon.x = imageLoader.x + imageLoader.image.x;
            newIcon.y = imageLoader.y + imageLoader.image.y;
            trace(imageLoader.image.height, imageLoader.height, imageLoader.x, imageLoader.image.x);
        }
        else {
            newIcon.visible = false;
        }

    }

    protected override function layout():void
    {
        var featuresWidth:Number=0;

        if(isSelected && _isTranslate){

            featuresWidth=(btnInfo.width)+4;
        }


        label.updateWithLanguage(AlertView.language);

        label.maxWidth=actualWidth-featuresWidth;
        label.validate();

        //label.width = actualWidth;
        if (isChopper==true){
            label.x = actualWidth-label.width;
        }
        else{
            label.x = ((actualWidth-label.width)/2)-featuresWidth/2;
        }
        label.height = 15;
        //label.validate();
        label.y = 34;//actualHeight - label.height;


        quad_back.width=this.actualWidth;
        quad_back.height=this.actualHeight;




        btnInfo.y=4;

        var posx:Number=label.x+label.width+4;


        btnInfo.x=posx;

        carLock.x=(actualWidth-carLock.width)/2;
        carLock.y=7;

        if(part && part.name == 'banner') {
            carLock.visible=false;
        }else {
            carLock.visible = (part && part.lock);
        }

        btnInfo.visible = (part && part.activeForInformation);

        if(!_enabled){
            this.alpha=0.3;
        }else{
            this.alpha= 1;
        }

        seporator.x=actualWidth-seporator.width;
        seporator.y=0;
        seporator.height=actualHeight;

        //btnInfo.x = label.width+label.x+4;

        btnInfo.x = seporator.x - btnInfo.width - 4;

    }


    private function chopperLayout():void{
        var featuresWidth:Number=0;

        if(isSelected && _isTranslate){

            featuresWidth=(btnInfo.width)+4;
        }

        label.updateWithLanguage(AlertView.language);

        label.maxWidth=actualWidth-featuresWidth;
        label.validate();

        label.x = actualWidth-label.width;
        label.height = 15;
        label.y = 34;//actualHeight - label.height;
        label.validate();

        quad_back.width=this.actualWidth;
        quad_back.height=this.actualHeight;

        btnInfo.y=label.y-2;

        var posx:Number=label.x+label.width+4;


        btnInfo.x=posx;

        carLock.x=(actualWidth-carLock.width)/2;
        carLock.y=7;

        if(part.lock){
            carLock.visible=true;
        }else{
            carLock.visible=false;
        }

        if (part && part.activeForInformation/* && _isTranslate*/){
            btnInfo.visible = true;
        }else{
            btnInfo.visible = false;
        }
        btnInfo.x = label.width+label.x+4;

        if(!_enabled){

            this.alpha=0.3;

        }else{
            this.alpha=1;
        }

        seporator.x=actualWidth-seporator.width;
        seporator.y=0;
        seporator.height=actualHeight;
    }


    protected override function  draw():void{

        super.draw();

        //layout();
        if(part && part.parentSlot.parentCar.isChopper){
            chopperLayout();
        }else{
            layout();
        }

		button.width = actualWidth;
		button.height = actualHeight;



        //btnInfo.visible = isSelected;
        //carLock.visible =true;

    }

}
}

