/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.view.components.timeline
{
import com.despark.tuning3d.model.brands.BrandsParser;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.model.social.SocialStats;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.auth.UserDetailsPopup;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.core.MainMenuButton;
import com.despark.tuning3d.view.components.core.MainMenuView;
    import com.despark.tuning3d.view.components.core.MultilingualLabel;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
    import com.despark.tuning3d.view.components.gallery.GalleryLabelFactory;
    import com.despark.tuning3d.view.components.gallery.GalleryScreen;
    import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Abstract.ATimelineCommentLikeItemRender;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentInput;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedChallengeAcceptedItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedChallengeWinItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedCommentedItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedLikeTuningItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedNewBornItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedNewFriendItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedNewTuningItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedTextImagesItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.FeedTextItemRenderer;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.UploadImageItemRenderer;
import com.despark.tuning3d.view.components.timeline.TimelineGarage.TimelineTuningView;
import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;
import com.despark.tuning3d.view.components.timeline.components.TimelineLoadBar;
import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
    import com.distriqt.AdsManager;
    import com.utils.FileUtil;
    import com.utils.FontSelector;
    import com.utils.ImageUtils;
import com.utils.ObjectUtils;
import com.utils.StageUtil;

import feathers.controls.AutoSizeMode;

import feathers.controls.Button;

import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.PullViewDisplayMode;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollPolicy;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.FeathersControl;
import feathers.core.ToggleGroup;
import feathers.data.ListCollection;
    import feathers.events.FeathersEventType;
    import feathers.layout.AnchorLayout;
import feathers.layout.AnchorLayoutData;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.TiledRowsLayout;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.desktop.Clipboard;

import flash.display.StageAspectRatio;
import flash.filesystem.File;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;
    import flash.utils.setTimeout;

    import starling.core.Starling;
import starling.display.DisplayObject;
    import starling.display.Image;
    import starling.display.MovieClip;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.Event;
import starling.events.Touch;
import starling.events.TouchEvent;
import starling.events.TouchPhase;
    import starling.textures.Texture;

    public class TimelineScreen extends StackedScreen implements Multilingual, IMainMenuHolder{

    public static const UPDATE_FEED   : String = "UpdateFeed";
    public static const CAR_SELECTED  : String = "CarSelected";
    public static const FEED_PULLING: String = 'FeedPulling';
    public static const FILTER_CHANGED: String = 'TimelineFilterChanged';
    public static const TUNING_SELETCED: String = 'TimelineTuningSelected';

    public static var SCROLL_FLAG : Boolean = false;

    private var _selectedLanguage:Language;
    private var _mainMenuView : MainMenuView;
    private var _languages:Array;
    private var _topButtonPadding:Number;
    private var menuButton:MainMenuButton;
    private var backgroundQuad:Quad;
    private var _feed : Array;
    public var _feedList :List;
    private var _postMessageView:CommentInput;
    private var _pendingLikePostIDs : Array = [];
    private var _messageLabel:Label;


    private var _selectedFeedData:FeedData;
    private var _selectedTuning:Tuning;

    public  var timelineTuningView : TimelineTuningView = null;
    private var _topMenuContainer:LayoutGroup;
    private var _postContainer:LayoutGroup;
    private var _imageList:List;
    private var quad:Quad;
    private var _scrollToTopButton : Button;

    private var _pullImage: Sprite;
    private var _timelineLoadBar:TimelineLoadBar;

    private var _sendPostAlert: AlertView;
    private var _firstPost:String;

    private var _filterMyButton:ToggleButton;
    private var _filterFriendsButton:ToggleButton;
    private var _filterCountryButton:ToggleButton;
    private var _filterWorldButton:ToggleButton;
    private var _filterToggleGroup:ToggleGroup;

    private var _feedFilterLayoutGroup:LayoutGroup;

    private var _topButton:ToggleButton;
    private var _currentButton:ToggleButton;
    private var _officialsButton:ToggleButton;

    private var _topLayoutGroup:LayoutGroup;
    private var _topToggleGroup:ToggleGroup;
    private var titleLabel : FeathersControl;

    public static var feedFilter:Object;
    private static var settingsFile:File;
    private static var instance:TimelineScreen;
    private static const POST_HEIGHT:int = 95;
    private var _gap:Number = 8;
    public var countryData:Object;

    private var _selectedUser:User;
    private var _ownTimeline:Boolean;
    private var _avatar:UserCircularAvatar;
    private var closeButton:Button;
    private var _closeHandler:Function;
    public function TimelineScreen(user:User = null) {
        super("Timeline screen");
        _selectedUser = user;
        if(instance){
            instance.removeFromParent(true);
        }
        instance = this;
        if(!feedFilter){
            feedFilter = {withMy: false, withFriends: true, fullWorld: false, country:false, withOfficial: true, onlyTop: false};
            settingsFile = File.applicationStorageDirectory.resolvePath("timeline_settings.json");
            if(settingsFile.exists){
                var contentObject:Object = JSON.parse(FileUtil.fileGetContent(settingsFile));
                ObjectUtils.mergeInto(contentObject, feedFilter);
            }
        }else{
            var temp:Object = feedFilter;
            feedFilter = {withMy: temp.withMy, withFriends: temp.withFriends, fullWorld: temp.fullWorld, country: temp.country, withOfficial: temp.withOfficial, onlyTop: temp.onlyTop};
        }
    }

        override protected function screen_removedFromStageHandler(event:Event):void{
            super.screen_removedFromStageHandler(event);
            BannerStackedScreen.hideAdBanner(true);
        }

    override protected function initialize() : void {
        super.initialize();
        this.layout = new AnchorLayout();

        Clipboard.generalClipboard.clear();

        _pendingLikePostIDs = [];
        _topButtonPadding = 0;

        backgroundQuad = new Quad(1, 1, 0xe9e9e9);
        addChild(backgroundQuad);

        initTopMenuContainer();
        initializeTimelineList();
        if(ownTimeline){
            initPostMessageView();
            initFilterButtons();
        }
        initScrollToTopButton();
        //
        _messageLabel = new Label();
        _messageLabel.textRendererFactory = TimelineLabelFactory.commentTextRenderer;
        _messageLabel.text = "There are no events available at this moment.\nPlease come back later.";
        addChild(_messageLabel);
        _messageLabel.visible = false;
    }

    private function initScrollToTopButton():void {
        var layData : AnchorLayoutData =new AnchorLayoutData();
        layData.right = 5;
        layData.bottom = 5;

        this._scrollToTopButton = ButtonFactory.simpleButtonByTextureName('back_to_top');
        this._scrollToTopButton.layoutData = layData;
        this.addChild(this._scrollToTopButton);
        this._scrollToTopButton.alpha = 0;
        this._scrollToTopButton.width = 30;
        this._scrollToTopButton.height = 30;
        this._scrollToTopButton.visible = false;
        this._scrollToTopButton.addEventListener(Event.TRIGGERED, scrollButtonTriggered)
    }

    private function initFilterButtons():void{
        _topLayoutGroup = new LayoutGroup();
        var topLayout:HorizontalLayout = new HorizontalLayout();
        topLayout.gap = 10;
        _topLayoutGroup.layout = topLayout;

        _currentButton = ButtonFactory.timelineTopButton('Live');
        _topButton = ButtonFactory.timelineTopButton('Top');
        _officialsButton = ButtonFactory.timelineTopButton('News');

        _topToggleGroup = new ToggleGroup();
        _topToggleGroup.addItem(_currentButton);
        _topToggleGroup.addItem(_topButton);
        _topToggleGroup.addItem(_officialsButton);
        _topToggleGroup.isSelectionRequired = true;

        if(_firstPost){
            feedFilter.onlyTop = false;
        }
        _currentButton.isSelected = !feedFilter.onlyTop;
        _topButton.isSelected = feedFilter.onlyTop;
        _officialsButton.isSelected = feedFilter.withOfficial;

        _currentButton.validate();
        _topButton.validate();
        _officialsButton.validate();

        var topLayoutData:AnchorLayoutData = new AnchorLayoutData();
        topLayoutData.verticalCenter = 0;
        topLayoutData.right = 20;
        _topLayoutGroup.layoutData = topLayoutData;

        _topLayoutGroup.addChild(_currentButton);
        _topLayoutGroup.addChild(_topButton);
        _topLayoutGroup.addChild(_officialsButton);

        _topMenuContainer.addChild(_topLayoutGroup);
        //
        enableFeedFilterLayoutGroup(_currentButton.isSelected||_topButton.isSelected);
        if (_currentButton.isSelected) {
            _filterMyButton.isEnabled = true;
        } else {
            if(_filterMyButton.isSelected){
                _filterFriendsButton.isSelected = true;
            }
            _filterMyButton.isEnabled = false;
        }
        _topToggleGroup.addEventListener(Event.CHANGE, filterButtonSelectHandler);
    }
        private function enableFeedFilterLayoutGroup(value:Boolean):void{
            for(var i:int = 0; i < _feedFilterLayoutGroup.numChildren; i++){
                var child:DisplayObject = _feedFilterLayoutGroup.getChildAt(i);
                if(child is ToggleButton){
                    ToggleButton(child).isEnabled = value;
                }else{
                    child.alpha = value? 1: 0.4;
                }
            }
        }


        private function filterButtonSelectHandler(event:Event):void {
            enableFeedFilterLayoutGroup(_currentButton.isSelected||_topButton.isSelected);
            SoundManager.playSound(SoundManager.SELECT_PART);
            if(_currentButton.isSelected){
                _filterMyButton.isEnabled = true;
            }else{
                if(_filterMyButton.isSelected){
                    _filterFriendsButton.isSelected = true;
                }
                _filterMyButton.isEnabled = false;
            }

            feedFilter.withFriends = _filterFriendsButton.isEnabled && _filterFriendsButton.isSelected;
            feedFilter.withMy = _filterMyButton.isEnabled && _filterMyButton.isSelected;
            feedFilter.withOfficial = _officialsButton.isEnabled && _officialsButton.isSelected;
            feedFilter.fullWorld = _filterWorldButton.isEnabled && _filterWorldButton.isSelected;
            feedFilter.country = _filterCountryButton.isEnabled && _filterCountryButton.isSelected;
            feedFilter.onlyTop = _topButton.isEnabled && _topButton.isSelected;

            dispatchEvent(new Event(FILTER_CHANGED));
            settingsFile ||= File.applicationStorageDirectory.resolvePath("timeline_settings.json");
            FileUtil.filePutContent(settingsFile, JSON.stringify(feedFilter));
        }

    private function scrollButtonTriggered ( e : Event ) : void {
        if (_feedList) {
            _feedList.scrollToPosition(0,0,0);
        }
    }

    private function initTopMenuContainer():void {
        var menuLayoutData : AnchorLayoutData = new AnchorLayoutData();
        menuLayoutData.left = 0;
        menuLayoutData.top = 0;
        menuLayoutData.right = 0;

        _topMenuContainer = new LayoutGroup();
        _topMenuContainer.height = 47;
        _topMenuContainer.layout = new AnchorLayout();
        var bannerBg:Image = new Image(Texture.fromColor(1,1,UIColors.BANNER_BACKGROUND_COLOR));
        bannerBg.color = 0xFF0000;
        _topMenuContainer.backgroundSkin = bannerBg;
        _topMenuContainer.addEventListener(TouchEvent.TOUCH, topQuadTouchHandler);
        addChild(_topMenuContainer);

        var menuButtonLayoutData : AnchorLayoutData = new AnchorLayoutData();
        menuButtonLayoutData.verticalCenter = 0;
        menuButtonLayoutData.left = 5.5;

        menuButton = ButtonFactory.menuBigButton("home_screen_main_menu", 0xFFFFFE);
        menuButton.layoutData = menuButtonLayoutData;
        menuButton.width = 35;
        menuButton.height = 35;
        menuButton.addEventListener(Event.TRIGGERED, mainMenuButtonHandler);
        _topMenuContainer.addChild(menuButton);

        if(ownTimeline){
            titleLabel = new Label();
            Label(titleLabel).textRendererFactory = GalleryLabelFactory.screenTitle;
            Label(titleLabel).text = "TIMELINE";
            titleLabel.validate();
            Label(titleLabel).paddingBottom = 3;
            _topMenuContainer.addChild(titleLabel);
        }else{
            titleLabel = LabelFactory.createLabelMailPopupUsername();
            LabelFactory.setLabelText(titleLabel, _selectedUser.nameToShow);
            _topMenuContainer.addChild(titleLabel);
            //
            activateCloseButton(_closeHandler);
        }

    }

    public function get feedCount() : int {
        return _feedList.dataProvider.length;
    }

    override protected function draw() : void
    {
        super.draw();

        if(quad && _postContainer){
            quad.y = _postContainer.height;
        }

        var sizeInvalid:Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);
        if(ownTimeline){
            menuButton.visible = true;
        }else{
            if(_avatar == null){
                _avatar = new UserCircularAvatar(_selectedUser, 32, true, 1);
                _avatar.addEventListener(TouchEvent.TOUCH, labelTouchHandler);
                _topMenuContainer.addChild(_avatar);
            }
            _avatar.x = _gap;
            _avatar.y = (BannerStackedScreen.BANNER_SIZE - _avatar.height) / 2;

            titleLabel.x = _avatar.x + _avatar.width + _gap / 2;
            titleLabel.y = (BannerStackedScreen.BANNER_SIZE - titleLabel.height) / 2;
            if(!titleLabel.hasEventListener(TouchEvent.TOUCH)){
                titleLabel.addEventListener(TouchEvent.TOUCH, labelTouchHandler);
            }

            menuButton.visible = false;
        }

        if (!mainMenuView) {
            mainMenuView = new MainMenuView();
            mainMenuView.y = topButtonPadding;
            mainMenuView.name = "mainMenuView";
            //mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight - _topButtonPadding);

            mainMenuView.width =MainMenuView.MENU_WIDTH;
            mainMenuView.height = actualHeight - _topButtonPadding;
            mainMenuView.parentActualWidth = actualWidth;
            mainMenuView.parentActualHeight = actualHeight;
            addElement(mainMenuView, this.numChildren - 1);
            //
            mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
            mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
        }

        if ( sizeInvalid) {
            if (mainMenuView) {
                mainMenuView.y = topButtonPadding;
                //mainMenuView.setSize(190, actualHeight - topButtonPadding);

                mainMenuView.width = MainMenuView.MENU_WIDTH;
                mainMenuView.height = actualHeight - topButtonPadding;
                mainMenuView.parentActualWidth = actualWidth;
                mainMenuView.parentActualHeight = actualHeight - topButtonPadding;
            }
        }

        if (sizeInvalid) {
            _topMenuContainer.width = actualWidth;
            _topMenuContainer.validate();

            backgroundQuad.width = actualWidth;
            backgroundQuad.height = actualHeight- topButtonPadding;
        }

        if(_feedFilterLayoutGroup && _postMessageView){
            _feedFilterLayoutGroup.x = _postMessageView.x;
            _feedFilterLayoutGroup.y = _postMessageView.getBounds(_postMessageView.parent).bottom + 7;
        }

        if(_messageLabel){
            _messageLabel.x = (actualWidth - _messageLabel.width)/2;
            _messageLabel.y = (actualHeight + _topMenuContainer.height - _messageLabel.height)/2;
        }

        if(titleLabel){
            titleLabel.validate();
            titleLabel.x = 50;
            titleLabel.y = (_topMenuContainer.height - titleLabel.height) / 2;
            titleLabel.width = 150;
        }

        if(closeButton){
            var diff:Number = (BannerStackedScreen.BANNER_SIZE - closeButton.height) / 2;
            closeButton.y = diff;
            closeButton.x = actualWidth - (closeButton.width + diff);
        }
    }

    public function activateCloseButton(closeHandler:Function = null): void {
        _closeHandler = closeHandler;
        if(!closeButton && _topMenuContainer){
            closeButton = ButtonFactory.screenCloseButton();
            closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
            _topMenuContainer.addChild(closeButton);
        }
    }

    private function closeButtonTriggeredHandler(event:Event):void{
        Constants.selectedUser = null;
        FeedData.CURRENT_USER = UsersProxy.loggedInUser();
        if(_closeHandler != null){
            _closeHandler();
        }else{
            dispatchEventWith(StackedScreenNavigator.BACK_TO_SCREEN);
        }
    }

    override public function ShowDone():void {
        BannerStackedScreen.showAdBanner();
    }

    private function menuOpenHandler(event:Event):void {
        BannerStackedScreen.hideAdBanner(false);
    }

    private function menuCloseHandler(event:Event):void {
        if(showAdBanner){
            BannerStackedScreen.showAdBanner();
        }
    }

    private function topQuadTouchHandler(e : TouchEvent):void {
        var t : Touch = e.getTouch(_topMenuContainer, TouchPhase.BEGAN);
        if(t && !t.isTouching(menuButton))
        {
            _feedList.scrollToPosition(0,0, 0.5);
        }
    }

    private function initPostMessageView():void {

        var postLayData : AnchorLayoutData = new AnchorLayoutData();
        postLayData.topAnchorDisplayObject = _topMenuContainer;
        postLayData.left = 0;
        postLayData.top = 0;
        postLayData.right = 0;

        _postContainer = new LayoutGroup();
        _postContainer.layoutData = postLayData;
        _postContainer.layout= new AnchorLayout();
        _postContainer.height = POST_HEIGHT;
        _postContainer.backgroundSkin = new Quad(10,10, 0xffffff);
        addChild(_postContainer);

        var inputLayData : AnchorLayoutData = new AnchorLayoutData();
        inputLayData.top = 15;
        inputLayData.left = inputLayData.right = 0;

        _postMessageView = new CommentInput(false);
        _postMessageView.layoutData = inputLayData;

        _postMessageView.width = actualWidth;
        _postMessageView.height = 45;
        _postMessageView.addEventListener(FeedData.COMMENT_SEND, onNewPostHandler);
        _postMessageView.addEventListener(CommentInput.CAR_BUTTON_SELECTED, carButtonSelectedHandler);
        _postMessageView.addEventListener(CommentInput.UPDATE_UPLOADED_IMAGES, uploadPhotoButtonHandler);
        _postContainer.addChild(_postMessageView);

        quad = new Quad(650,2,0x939090);
        _postContainer.addChild(quad);
        quad.y = _postContainer.height;



        _filterMyButton = ButtonFactory.timelineFilterButton2("timeline_my_activities_icon");
        _filterFriendsButton = ButtonFactory.timelineFilterButton2("timeline_friends_activities_icon");
        _filterCountryButton = ButtonFactory.timelineFilterButton2(String(countryData.country).toLowerCase(), false, 15);
        _filterWorldButton = ButtonFactory.timelineFilterButton2("timeline_world_icon");

        _filterMyButton.label = "My Activity";
        _filterFriendsButton.label = "Friends'";
        _filterCountryButton.label = "Country";
        _filterWorldButton.label = "World";



        _filterMyButton.validate();
        _filterFriendsButton.validate();
        _filterCountryButton.validate();
        _filterWorldButton.validate();


        _feedFilterLayoutGroup = new LayoutGroup();
        var filterLayout:HorizontalLayout = new HorizontalLayout();
        filterLayout.gap = 0;
        filterLayout.paddingLeft = 65;
        _feedFilterLayoutGroup.layout = filterLayout;


        _feedFilterLayoutGroup.addChild(createFilterSeparator());
        _feedFilterLayoutGroup.addChild(_filterMyButton);
        _feedFilterLayoutGroup.addChild(createFilterSeparator());
        _feedFilterLayoutGroup.addChild(_filterFriendsButton);
        _feedFilterLayoutGroup.addChild(createFilterSeparator());
        _feedFilterLayoutGroup.addChild(_filterCountryButton);
        _feedFilterLayoutGroup.addChild(createFilterSeparator());
        _feedFilterLayoutGroup.addChild(_filterWorldButton);
        _feedFilterLayoutGroup.addChild(createFilterSeparator());
        //
        _filterToggleGroup = new ToggleGroup();
        _filterToggleGroup.addItem(_filterMyButton);
        _filterToggleGroup.addItem(_filterFriendsButton);
        _filterToggleGroup.addItem(_filterCountryButton);
        _filterToggleGroup.addItem(_filterWorldButton);

        _filterFriendsButton.isSelected = feedFilter.withFriends;
        _filterMyButton.isSelected = feedFilter.withMy;
        _filterCountryButton.isSelected = feedFilter.country;
        _filterWorldButton.isSelected = feedFilter.fullWorld;

        _filterToggleGroup.isSelectionRequired = true;
        _filterToggleGroup.addEventListener(Event.CHANGE, filterButtonSelectHandler);
        _postContainer.addChild(_feedFilterLayoutGroup);
    }

    private function uploadPhotoButtonHandler(event:Event):void {
        if(!_imageList){

            var layData : AnchorLayoutData = new AnchorLayoutData();
            layData.horizontalCenter= 0;
            layData.top = 23;
            layData.topAnchorDisplayObject = _postMessageView;

            var layout : HorizontalLayout = new HorizontalLayout();
            layout.hasVariableItemDimensions = true;
            layout.useVirtualLayout  = false;
            layout.verticalAlign = VerticalAlign.TOP;
            layout.horizontalAlign = HorizontalAlign.LEFT;

            _imageList = new List();
            _imageList.width = actualWidth - 20;
            _imageList.layout = layout;
            _imageList.layoutData = layData;
            _imageList.isSelectable = false;
            _imageList.scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
            _imageList.horizontalScrollPolicy = ScrollPolicy.OFF;
            _imageList.verticalScrollPolicy = ScrollPolicy.OFF;
            _imageList.itemRendererFactory = uploadPhotoItemRenderer;
            _imageList.dataProvider= new ListCollection(event.data);
            _imageList.addEventListener(UploadImageItemRenderer.CLOSE_IMAGE, removeImageHandler);

            _postContainer.addChild(_imageList);
            updateImageList(false);

        }else {
            updateImageList(true);
        }
    }

    private function updateImageList(updateItems: Boolean) : void{
        if(updateItems)
            _imageList.dataProvider.updateAll();

        _imageList.invalidate();
        _imageList.validate();

        _postContainer.height = _imageList.height + POST_HEIGHT;
        _postContainer.validate();
        quad.y = _postContainer.height;
    }



    private function removeImageHandler(event:Event):void {
        _imageList.dataProvider.removeItem(event.data);
        updateImageList(true);
    }

    private function uploadPhotoItemRenderer() : IListItemRenderer {
        var width : Number = _imageList.width / 5;
        var renderer : UploadImageItemRenderer = new UploadImageItemRenderer();
        renderer.itemWidth = width;
        renderer.setSize(width, NaN);
        return renderer;
    }

    private function carButtonSelectedHandler(e : Event) : void{
        SoundManager.playSound(SoundManager.PART_MENU);
        this.dispatchEventWith(StackedScreen.POST_TUNING_SELECTED, false, e.data);
    }

    private function onNewPostHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        this.dispatchEventWith(FeedData.NEW_POST, false, event.data);
        _postMessageView.clearFocus();
        if(_imageList){
            _imageList.dataProvider.removeAll();
            updateImageList(false);
        }
        _sendPostAlert = AlertView.show("Sending post", 0);
    }

    private function initializeTimelineList() : void
    {
        var listLayData : AnchorLayoutData = new AnchorLayoutData();
//        listLayData.topAnchorDisplayObject = _topMenuContainer;
        listLayData.left = 0;
        listLayData.top = 0;
        listLayData.right = 0;
        listLayData.bottom = 0;

        var layout : VerticalLayout = new VerticalLayout();//VerticalLayout();
        layout.gap = 12;
        layout.hasVariableItemDimensions = true;
        layout.horizontalAlign =  HorizontalAlign.LEFT;  //VerticalSpinnerLayout.HORIZONTAL_ALIGN_LEFT;
        layout.verticalAlign = VerticalAlign.TOP;
        layout.paddingTop = BannerStackedScreen.BANNER_SIZE + (ownTimeline?(POST_HEIGHT + 13): 10);
        layout.paddingBottom = 10;
        layout.useVirtualLayout = true;
        layout.afterVirtualizedItemCount=5;
        layout.beforeVirtualizedItemCount=5;


        _timelineLoadBar ||= new TimelineLoadBar();
        _timelineLoadBar.name = "_timelineLoadBar";
        _timelineLoadBar.visible = false;
        addChild(_timelineLoadBar);

        _timelineLoadBar.addEventListener(FeathersEventType.PULLING, feedListPull);


        _feedList = new List();
        _feedList.isSelectable = false;
        _feedList.dataProvider = new ListCollection();
        _feedList.topPullView = _timelineLoadBar;
        _feedList.topPullViewDisplayMode = PullViewDisplayMode.FIXED;
        _feedList.layout = layout;
        _feedList.layoutData = listLayData;
        _feedList.scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
        _feedList.horizontalScrollPolicy = ScrollPolicy.OFF;
        _feedList.verticalScrollPolicy = ScrollPolicy.ON;
        _feedList.addEventListener(Event.SCROLL, listScrollHandler);

        _feedList.addEventListener(FeedData.TUNING_CAR_IMAGE_SELECTED, tuningsListChangeHandler);
        _feedList.addEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
        _feedList.addEventListener(FeedData.COMMENT_DELETE, deleteCommentHandler);
        _feedList.addEventListener(FeedData.COMMENT_MORE, moreCommentRequestHandler);
        _feedList.addEventListener(FeedData.COMMENT_EDIT, editCommentHandler);
        _feedList.addEventListener(FeedData.LIKE, likePostHandler);
        _feedList.addEventListener(TouchEvent.TOUCH, touchTestingHandler);
        _feedList.addEventListener(ChallengeEvent.VIEW_CHALLENGE_TUNING, challengeLabelTouchHandler);

        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_TEXT, textFeedItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_POST_COMMENT, textFeedItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_POST_LIKE, textFeedItemRendererFactory);

        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_NEWBORN, newBornItemRendererFactory);

        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_TEXT_AND_IMAGES, textAndImageFeedItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_NEW_TUNING, newTuningItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_TUNING_LIKE, tuningLikeItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_NEW_FRIEND, newFriendItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_TUNING_COMMENT, feedItemRendererFactory);

        // Challenge feeds
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_CHALLENGE_WIN, challengeWinItemRendererFactory);
        _feedList.setItemRendererFactoryWithID(FeedData.TYPE_CHALLENGE_ANSWER, challengeAcceptItemRendererFactory);

        _feedList.factoryIDFunction = factoryIDFunction;
//            _feedList.isQuickHitAreaEnabled = true;
        _feedList.clipContent = true;

        addChildAt(_feedList,this.numChildren - 1);


    }

    private function feedListPull(event:Event): void {
        _timelineLoadBar.removeEventListener(event.type, feedListPull);
        dispatchEventWith(FEED_PULLING);
        showBlocker();
    }

        private function showBlocker():void {
            if(!_timelineLoadBar.visible) {
                _timelineLoadBar.setSize(actualWidth, actualHeight);
                _timelineLoadBar.visible = true;
            }
        }

        private function hideBlocker():void{
            _timelineLoadBar.visible = false;
        }

    private function updateScrollFlag() : void {
        if(_feedList && _feedList.isScrolling)
        {
            TimelineScreen.SCROLL_FLAG = true;
            Starling.juggler.delayCall(updateScrollFlag, 0.1);
        }
        else {
            TimelineScreen.SCROLL_FLAG = false;
        }
    }

    private function touchTestingHandler(event:TouchEvent):void {
        var touch : Touch = event.getTouch(event.currentTarget as DisplayObject);

        if(touch)
        {
            switch (touch.phase)
            {
                case TouchPhase.BEGAN:
                    SCROLL_FLAG = _feedList.isScrolling || false ;
                    break;
                case TouchPhase.ENDED:
                    Starling.juggler.delayCall(updateScrollFlag, 0.1);
                    break;
                case TouchPhase.HOVER:
                case TouchPhase.MOVED:
                case TouchPhase.STATIONARY:
                    SCROLL_FLAG = SCROLL_FLAG || _feedList.isScrolling;
                    break;
            }
        }
    }
        private function challengeLabelTouchHandler(event:Event):void {
            dispatchEvent(new Event(ChallengeEvent.VIEW_CHALLENGE_TUNING, false, event.data));
        }

    private function textAndImageFeedItemRendererFactory() : IListItemRenderer {
        var renderer :FeedTextImagesItemRenderer = new FeedTextImagesItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }

    private function newBornItemRendererFactory() : IListItemRenderer {
        var renderer :FeedNewBornItemRenderer = new FeedNewBornItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }


        private function textFeedItemRendererFactory() : IListItemRenderer {
            var renderer :FeedTextItemRenderer = new FeedTextItemRenderer();
            renderer.eventDispatcher = this;
            renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
            renderer.setSize(renderer.itemWidth, NaN);
            return renderer;
        }

    private function newTuningItemRendererFactory() : IListItemRenderer {
        var renderer :FeedNewTuningItemRenderer = new FeedNewTuningItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }


    private function tuningLikeItemRendererFactory() : IListItemRenderer {
        var renderer :FeedLikeTuningItemRenderer = new FeedLikeTuningItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }

    private function newFriendItemRendererFactory() : IListItemRenderer {
        var renderer :FeedNewFriendItemRenderer = new FeedNewFriendItemRenderer();
        renderer.eventDispatcher = this;
        renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
        renderer.setSize(renderer.itemWidth, NaN);
        return renderer;
    }

    //

        // Challenge feedData item factories
        private function challengeWinItemRendererFactory() : IListItemRenderer {
            var renderer :FeedChallengeWinItemRenderer = new FeedChallengeWinItemRenderer();
            renderer.eventDispatcher = this;
            renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
            renderer.setSize(renderer.itemWidth, NaN);
            return renderer;
        }

        private function challengeAcceptItemRendererFactory() : IListItemRenderer {
            var renderer :FeedChallengeAcceptedItemRenderer = new FeedChallengeAcceptedItemRenderer();
            renderer.eventDispatcher = this;
            renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
            renderer.setSize(renderer.itemWidth, NaN);
            return renderer;
        }

        private function feedItemRendererFactory() : IListItemRenderer {
            var renderer :FeedCommentedItemRenderer = new FeedCommentedItemRenderer();
            renderer.eventDispatcher = this;
            renderer.itemWidth = _feedList.width-_feedList.paddingLeft - _feedList.paddingRight;
            renderer.setSize(renderer.itemWidth, NaN);
            return renderer;
        }



    private function factoryIDFunction(item : Object, index : int):String{
        return item.feedType;
    }

    public function savePendingLikeForPost(feedData :FeedData):void {
        var count : int = 0;
        var i : int;
        switch (feedData.feedType) {
            case FeedData.TYPE_NEW_FRIEND:
            case FeedData.TYPE_TEXT: // if the type is text (Post), than there shouldn't be duplicates (WE ASSUME)
            case FeedData.TYPE_POST_COMMENT: // if the type is text (Post), than there shouldn't be duplicates (WE ASSUME)
            case FeedData.TYPE_POST_LIKE: // if the type is text (Post), than there shouldn't be duplicates (WE ASSUME)
            case FeedData.TYPE_TEXT_AND_IMAGES: // if the type is text (Post), than there shouldn't be duplicates (WE ASSUME)
                for(i = 0 ; i < _feed.length; i++) {
                    if(_feed[i].id == feedData.id) {
                        _pendingLikePostIDs.push(i);
                        _pendingLikePostIDs.push(1);
                    }
                }
                break;
            case FeedData.TYPE_NEW_TUNING:
            case FeedData.TYPE_TUNING_COMMENT:
            case FeedData.TYPE_TUNING_LIKE: {
                /**
                 * If the post has tuning, means it can have duplicates
                 * (for example, one for like, one for comment, one for new tuning)
                 * so we should store all the data in order to update it later
                 */
                for(i = 0 ; i < _feed.length; i++) {
                    if(_feed[i].id == feedData.id)
                    {
                        _pendingLikePostIDs.push(i);
                        count ++;
                        continue;
                    }
                    if(_feed[i].tuning && _feed[i].tuning.id == feedData.tuning.id)
                    {
                        count ++;
                        _pendingLikePostIDs.push(i);

                    }
                }

                _pendingLikePostIDs.push(count);
                break;
            }

        }

        this.dispatchEventWith(FeedData.LIKE, false, feedData);
    }

    private function likePostHandler(event:Event):void {
        //initLikesList(true);
        savePendingLikeForPost(event.data as FeedData);
    }

    public function dislikeSelectedTuning():void
    {
        var index:int = -1;
        for(var j : int = _selectedFeedData.likes.length - 1; j >= 0; j--) // Find the user's index in like list
        {
            if(_selectedFeedData.likes[j].user._id == FeedData.CURRENT_USER.id)
            {
                index = j;
                break;
            }
        }
        for(var i : int = 0 ; i < _feed.length; i++)
        {
            if((_feed[i].id == _selectedFeedData.id)
                    || (_feed[i].tuning && _feed[i].tuning._id == _selectedFeedData.tuning._id))
            {
                _feedList.dataProvider.getItemAt(i).likes.removeAt(index);
                _feedList.dataProvider.getItemAt(i).iLiked = false;
                var counters:Object = ObjectUtils.getProperty(_feedList.dataProvider.getItemAt(i), "tuning.counters");
                if(counters){
                    counters.likes--;
                }
            }
        }
        _feedList.invalidate(INVALIDATION_FLAG_DATA);
    }

    public function likeSelectedTuning():void
    {
        /**
         * If the post has tuning, means it can have duplicates
         * (for example, one for like, one for comment, one for new tuning)
         * so we should update it
         */
        for(var i : int = 0 ; i < _feed.length; i++)
        {
            if((_feed[i].id == _selectedFeedData.id)
                    || (_feed[i].tuning && _feed[i].tuning._id == _selectedFeedData.tuning._id))
            {
                var us : Object = {};
                us.__v = 0;
                us._id = _selectedFeedData.id;
                us.feedPost = _selectedFeedData.id;
                us.like = true;
                us.user = {};
                us.user._id = FeedData.CURRENT_USER.id;
                us.user.avatar = FeedData.CURRENT_USER.avatarPath;
                us.user.name = FeedData.CURRENT_USER.name;
                us.user.username = FeedData.CURRENT_USER.username;

                _feedList.dataProvider.getItemAt(i).likes.push(us);
                _feedList.dataProvider.getItemAt(i).iLiked = true;
                var counters:Object = ObjectUtils.getProperty(_feedList.dataProvider.getItemAt(i), "tuning.counters");
                if(counters){
                    counters.likes++;
                }
            }
        }
        _feedList.invalidate(INVALIDATION_FLAG_DATA);
    }

    public function likeSuccess(currentUser : User):void
    {
        var count: int = _pendingLikePostIDs.pop();
        var renderer:ATimelineCommentLikeItemRender
        for(var k:int = 0; k < count; k++)
        {
            var index : int = _pendingLikePostIDs.pop();
            var feedData : FeedData = _feedList.dataProvider.getItemAt(index) as FeedData;
            if(feedData.iLiked) // means that i want to dislike
            {
                for(var i : int = feedData.likes.length - 1; i >= 0; i--)
                {
                    if(feedData.likes[i].user._id == currentUser.id)
                    {
                        _feedList.dataProvider.getItemAt(index).likes.removeAt(i);
                        _feedList.dataProvider.getItemAt(index).iLiked = false;
                        renderer = _feedList.itemToItemRenderer(_feedList.dataProvider.getItemAt(index)) as ATimelineCommentLikeItemRender;
                        if(renderer){
                            renderer.enableLike();
                        }
                        break;
                    }
                }
            }else {// just liked it

                var us : Object = {};
                us.__v = 0;
                us._id = feedData.id;
                us.feedPost = feedData.id;
                us.like = true;
                us.user = {};
                us.user._id = currentUser.id;
                us.user.avatar = currentUser.avatarPath;
                us.user.name = currentUser.name;
                us.user.username = currentUser.username;

                _feedList.dataProvider.getItemAt(index).likes.push(us);
                _feedList.dataProvider.getItemAt(index).iLiked = true;
                renderer = _feedList.itemToItemRenderer(_feedList.dataProvider.getItemAt(index)) as ATimelineCommentLikeItemRender;
                if(renderer){
                    renderer.enableLike();
                }
            }
        }

        _feedList.invalidate(FeathersControl.INVALIDATION_FLAG_DATA);
    }

    public function likeFailed(currentUser : User):void {
        //SoundManager.playSound(SoundManager.DISABLED_PART);
        var count: int = _pendingLikePostIDs.pop();
        var renderer:ATimelineCommentLikeItemRender;
        for(var k:int = 0; k < count; k++) {
            var index : int = _pendingLikePostIDs.pop();
            var feedData : FeedData = _feedList.dataProvider.getItemAt(index) as FeedData;
            renderer = _feedList.itemToItemRenderer(feedData) as ATimelineCommentLikeItemRender;
            if(renderer){
                renderer.enableLike();
            }
            var counters:Object = ObjectUtils.getProperty(feedData, "tuning.counters");
            if(!feedData.iLiked) {
                counters.likes--;
                for(var i : int = feedData.likes.length - 1; i >= 0; i--) {
                    if(feedData.likes[i].user._id == currentUser.id) {
                        _feedList.dataProvider.getItemAt(index).iLiked = false;
                        renderer = _feedList.itemToItemRenderer(_feedList.dataProvider.getItemAt(index)) as ATimelineCommentLikeItemRender;
                        if(renderer){
                            renderer.enableLike();
                        }
                        break;
                    }
                }
            } else {
                counters.likes++;
                _feedList.dataProvider.getItemAt(index).iLiked = true;
                renderer = _feedList.itemToItemRenderer(_feedList.dataProvider.getItemAt(index)) as ATimelineCommentLikeItemRender;
                if(renderer){
                    renderer.enableLike();
                }
            }
        }
        _feedList.invalidate(FeathersControl.INVALIDATION_FLAG_DATA);
    }

    private function editCommentHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        this.dispatchEventWith(FeedData.COMMENT_EDIT, false, event.data);
    }

    private function moreCommentRequestHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        this.dispatchEventWith(FeedData.COMMENT_MORE, false, event.data);
    }

    private function deleteCommentHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        this.dispatchEventWith(FeedData.COMMENT_DELETE, false, event.data);
    }

    private function sendCommentHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        this.dispatchEventWith(FeedData.COMMENT_SEND, false, event.data);
    }


    private function listScrollHandler(event:Event):void
    {
        if(!_feedList || !_feed || _feed.length == 0 || _feedList.dataProvider.length == 0) {
            return;
        }

        var h1 : Number = (_postContainer?_postContainer.height:0) + _topMenuContainer.height;
        var h2 : Number = h1 * .9;
        var h3 : Number = actualHeight/2;

        if( _feedList.verticalScrollPosition > h3) {

            _scrollToTopButton.visible = true;
            _scrollToTopButton.alpha = Math.min((_feedList.verticalScrollPosition - h3) / h3, 1);
        } else {
            _scrollToTopButton.visible = false;
        }

        if(_feedList.verticalScrollPosition < h2) {
            var showAd:Boolean = !_topMenuContainer.visible;
            _topMenuContainer.alpha = (h2 - _feedList.verticalScrollPosition  )/(h2 );
            _topMenuContainer.visible = true;
            if(_postContainer){
                _postContainer.alpha = (h2 - _feedList.verticalScrollPosition  )/(h2 );
                _postContainer.visible = true;
            }
            if(showAd){
                BannerStackedScreen.showAdBanner();
            }
        } else {
            var hideAd:Boolean = _topMenuContainer.visible;
            _topMenuContainer.visible = false;
            if(_postContainer){
                _postContainer.visible = false;
            }
            if(hideAd){
                BannerStackedScreen.hideAdBanner(false);
            }
        }

        if(_feedList.verticalScrollPosition >= _feedList.maxVerticalScrollPosition-100) {
            dispatchEventWith(UPDATE_FEED);
        }
    }

        public function get showAdBanner():Boolean{
            return _topMenuContainer.visible && (_postContainer?_postContainer.visible:true);
        }

    public function get selectedTuning():Tuning{
        return _selectedTuning;
    }

    public function get selectedFeedData():FeedData{
        return _selectedFeedData;
    }

    private var _currentCar : Car;
    public function set currentCar(value:Car) : void{
        _currentCar = value;
    }
    public function get currentCar() : Car{
        return _currentCar;
    }

    public var social : SocialStats = new SocialStats();
    private function createTuning(tunningJSON:Object):Tuning{
        var tunning : Tuning = new Tuning();
        tunning.id = tunningJSON._id;
        tunning.name = tunningJSON.name;
        if(tunningJSON.hasOwnProperty("shortId")){
            tunning.shortId = tunningJSON.shortId;
        }

        if(tunningJSON.hasOwnProperty("user")){
            tunning.userObj = tunningJSON.user;
        }

        if (tunningJSON.counters) {
            social.likes = tunningJSON.counters.likes;
            social.comments = tunningJSON.counters.comments;
            tunning.stats = social;
            social.challangesCount = tunningJSON.counters.challangesCount;
            social.challangeWins = tunningJSON.counters.challangeWins;
        }

        if (tunningJSON.customSnapshotsBackgrounds && tunningJSON.customSnapshotsBackgrounds.length > 0){
            tunning.backgroundId = tunningJSON.customSnapshotsBackgrounds[0];
        } else {
            tunning.backgroundId = null;
        }
        tunning.customSnapshotsBackgrounds = tunningJSON.customSnapshotsBackgrounds;
        if (tunningJSON.customSnapshots && tunningJSON.customSnapshots.length > 0) {
            if (tunningJSON.customSnapshots[0].indexOf("http") >= 0){
                tunning.imageURL = tunningJSON.customSnapshots[0];
            }
            else{
                tunning.imageURL = "http:" + tunningJSON.customSnapshots[0];
            }
        }else if(tunningJSON.snapshots && tunningJSON.snapshots.length > 0) {
            if(tunningJSON.snapshots[0].indexOf("http") >= 0){
                tunning.imageURL = tunningJSON.snapshots[0];
            }else{
                tunning.imageURL = "http:" + tunningJSON.snapshots[0];
            }
        }


        tunning.snapshots=[];
        var isCustomSnapshots:Boolean=false;
        var i:int;
        var url:String;

        if(tunningJSON.customSnapshots && tunningJSON.customSnapshots.length > 0) {
            for(i=0; i<tunningJSON.customSnapshots.length; i++){
                url=tunningJSON.customSnapshots[i];
                if(url.indexOf("http://")<0){
                    url="http:"+url;
                }
                tunning.snapshots.push(url);
                isCustomSnapshots=true;
            }

        }


        if(tunningJSON.snapshots && tunningJSON.snapshots.length > 0) {
            var count:int=isCustomSnapshots ? tunningJSON.snapshots.length: 1;
            for(i=0; i<count - count > 2 ? 2 : 0; i++){
                url=tunningJSON.snapshots[i];
                if(url.indexOf("http://")<0){
                    url="http:"+url;
                }
                tunning.snapshots.push(url);
            }
        }
        var car2:Car=BrandsParser.allCarsList[tunningJSON.car._id];
        tunning.car = car2;
        if(tunningJSON.car && tunningJSON.car.hasOwnProperty("carChooserBgName")){
            tunning.carChooserBgName = tunningJSON.car.carChooserBgName;
        }
        //carChooserBgName	"a_garage.jpg"
        if(tunningJSON.car && tunningJSON.car.hasOwnProperty("hdsize")){
            tunning.hdsize = tunningJSON.car.hdsize;
        }
        tunning.carObj = tunningJSON.car;
        return tunning;
    }



    private function tuningsListChangeHandler(event:Event):void {
        var feedData : FeedData = event.data as FeedData;
        _selectedTuning ||= createTuning(feedData.tuning);
        selectedFeedData = feedData;
        currentCar = new Car();
        currentCar.id  = feedData.tuning.car["_id"];
        dispatchEvent(new Event(TUNING_SELETCED, false, {tuning:TuningsProxy.parseTuning(feedData.tuning), user:feedData.owner}));
    }

    private function mainMenuButtonHandler(event:Event):void{
        if(this.mainMenuView) mainMenuView.toggle();
    }

    public function updateNotifications() :void{
        if(mainMenuView){
            mainMenuView.updateNotificationCount();
        }
    }

    public function cleanupMemory() : void
    {
        ImageUtils.clearAllTexture();
    }

    public function feedListPullingEnd(): void {
        setTimeout(function ():void {
            if(_feedList){
                _feedList.isTopPullViewActive = false;
            }
        }, 200);

        if (_sendPostAlert) {
            _sendPostAlert.hide();
        }
        _timelineLoadBar.addEventListener(FeathersEventType.PULLING, feedListPull);
    }
    public function refreshFeed(value : Array) :void
    {
        if (_sendPostAlert) {
            _sendPostAlert.hide();
        }
        var newListCollection : ListCollection = new ListCollection();
        for(var i : int = 0; i < value.length; i++)
        {
            newListCollection.addItem(value[i]);// its automatically adds in feed array too
            for (var j: int = 0; j <  _feedList.dataProvider.length; j++) {
                var feed: Object = _feedList.dataProvider.getItemAt(j);
                if (
                        (feed.feedType === 'tuning_like' || feed.feedType === 'new_tuning' || feed.feedType === 'tuning_comment')
                        && (value[i].feedType === 'tuning_like' || value[i].feedType === 'new_tuning' || value[i].feedType === 'tuning_comment')
                        && feed.tuning && value[i].tuning
                        && feed.tuning.id == value[i].tuning.id) {
                    _feedList.dataProvider.removeItemAt(j);
                }
            }
        }
//        _feedList.isTopPullViewActive = false;

        _feedList.dataProvider.addAllAt(newListCollection, 0);
    }

        public function unload():void{
            while(_feed.length){
                var feedData:FeedData = _feed.pop();
                feedData.dispose();
            }
            _feed = null;
            if(_feedList) {
                _feedList.visible = false;
                _feedList.dataProvider = null;
                _feedList.validate();
            }
        }


    public function set feed(value : Array) : void {
        if(_feed && _feed.length > 0) {
            var newListCollection : ListCollection = new ListCollection();
            for(var i : int = 0; i < value.length; i++) {
                newListCollection.addItem(value[i]);
            }
            _feedList.dataProvider.addAll(newListCollection);
        } else {
            _feed = value;
            if(_feedList)
            {
                _feedList.dataProvider = new ListCollection(value);
                _feedList.validate();
                _feedList.visible = true;
            }
        }
        _messageLabel.visible = (_feed.length == 0);
    }

    public function get feed() : Array{
        return _feed;
    }

    public function set languages(value:Array):void{
        _languages=value;
    }

    public function get languages():Array{
        return _languages;
    }

    public function brandsScreenButtonTriggeredHandler(event:Event = null):void {

        dispatchEventWith(StackedScreen.BRANDS_SELECTED);

    }

    public function homeButtonTriggeredHandler(event:Event = null):void {
        dispatchEventWith(StackedScreen.HOME_SELECTED);
    }

    public function enterRowsState():void {

    }

    public function set mainMenuView(value : MainMenuView) : void
    {
        _mainMenuView = value;
        _mainMenuView.owner = this;
    }

    public function get mainMenuView():MainMenuView {
        return _mainMenuView;
    }

    public function set selectedLanguage(value:Language):void {
        _selectedLanguage = value;
    }

    public function get selectedLanguage():Language {
        return _selectedLanguage;
    }

    public function dispatchExternalEvent(msg:String):void {
        if (mainMenuView) mainMenuView.hide();
        dispatchEventWith(msg);
    }

    public function updateWithLanguage(language:Language):void {
        if (mainMenuView) mainMenuView.updateWithLanguage(language);
    }

    public function get topButtonPadding() : Number {
        return _topButtonPadding
    }


        public function clearContent():void{
            if(feed) {
                while (feed.length) {
                    var feedData:FeedData = feed.pop() as FeedData;
                    feedData.dispose();
                }
            }

            if(_imageList){
                if(_imageList.dataProvider){
                    _imageList.dataProvider.removeAll();
                }
            }

            if(_feedList) {
                if(_feedList.dataProvider){
                    _feedList.dataProvider.removeAll();
                }
                _feedList.invalidate();
            }
        }

    override public function dispose():void {
        super.dispose();
        if(ownTimeline){
            UserCircularAvatar.disposeStoredAvatarTextures();
        }
        for each (var fdata : FeedData in feed){
            fdata.dispose();
        }

        if (_postMessageView) {
            _postMessageView.removeEventListener(FeedData.COMMENT_SEND, onNewPostHandler);
            _postMessageView.removeEventListener(CommentInput.CAR_BUTTON_SELECTED, carButtonSelectedHandler);
            _postMessageView.removeEventListener(CommentInput.UPDATE_UPLOADED_IMAGES, uploadPhotoButtonHandler);
            _postMessageView.removeFromParent(true);
            _postMessageView = null;

        }

        if(titleLabel){
            titleLabel.removeFromParent(true);
            titleLabel = null;
        }

        if (_scrollToTopButton) {
            this._scrollToTopButton.removeEventListener(Event.TRIGGERED, scrollButtonTriggered);
            this._scrollToTopButton.removeFromParent(true);
        }

        if(_imageList){
            _imageList.removeEventListener(UploadImageItemRenderer.CLOSE_IMAGE, removeImageHandler);
            if(_imageList.dataProvider){
                _imageList.dataProvider.removeAll();
                _imageList.dataProvider= null;
            }
            _imageList.removeFromParent(true);
            _imageList =null;
        }

        if(_feedList) {
            _feedList.removeEventListener(Event.SCROLL, listScrollHandler);
            _feedList.removeEventListener(FeedData.TUNING_CAR_IMAGE_SELECTED, tuningsListChangeHandler);
            _feedList.removeEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
            _feedList.removeEventListener(FeedData.COMMENT_DELETE, deleteCommentHandler);
            _feedList.removeEventListener(FeedData.COMMENT_EDIT, editCommentHandler);
            _feedList.removeEventListener(FeedData.COMMENT_MORE, moreCommentRequestHandler);
            _feedList.removeEventListener(FeedData.LIKE, likePostHandler);
            _feedList.dataProvider = null;
            _feedList.removeFromParent(true);
            _feedList = null;
        }

        if (_timelineLoadBar) {
            _timelineLoadBar.removeEventListener(FeathersEventType.PULLING, feedListPull);
            _timelineLoadBar.removeFromParent(true);
            _timelineLoadBar = null;
        }

        if(menuButton) {
            menuButton.removeEventListener(Event.TRIGGERED, mainMenuButtonHandler);
            menuButton.removeFromParent(true);
        }

        if(_topMenuContainer) {
            _topMenuContainer.removeFromParent(true);
            _topMenuContainer =null;
        }
        if(instance == this){
            instance = null;
        }
    }

    private function labelTouchHandler(event:TouchEvent):void {
        var touch:Touch = event.getTouch(_avatar, TouchPhase.ENDED);
        var touch3:Touch = event.getTouch(titleLabel, TouchPhase.ENDED);
        if(touch || touch3){
            dispatchEvent(new Event(StackedScreen.USER_DETAILS_SELECTED, false, {user: _selectedUser, options: [UserDetailsPopup.GARAGE, UserDetailsPopup.EMAILS, UserDetailsPopup.CHALLENGE]}));
        }
    }

    private function addElement(item:*,index:int=-1) : void
    {
        for (var i:int = 0; i < numChildren; i++) {
            if (getChildAt(i).name == item.name) return;
        }
        index == -1 ? addChild(item) : addChildAt(item,index);
    }

    public function updateList(fD: FeedData ):void {
        for(var i : int  = _feed.length-1; i >= 0; i--) {
            if(_feed[i].id == fD.id) {
                _feedList.dataProvider.updateItemAt(i);
                return;
            }
        }
        // _feedList.scrollToPosition(0,1, 0.2);
    }

    public function updateSelectedItem():void {
        if(_selectedFeedData) {
            var selectedFeedIndex:int = _feedList.dataProvider.getItemIndex(_selectedFeedData);
            if(selectedFeedIndex != -1){
                var renderer:ListItemRenderer = _feedList.itemToItemRenderer(_selectedFeedData) as ListItemRenderer;
                if(renderer) {
                    renderer.height = NaN;
                    renderer.invalidate(INVALIDATION_FLAG_SIZE);
                }
            }
        }
    }

    public function unshift(item:FeedData):void {
        _feedList.dataProvider.unshift(item);
    }

        public function get firstPost():String {
            return _firstPost;
        }

        public function set firstPost(value:String):void {
            _firstPost = value;
        }

        public function set selectedFeedData(selectedFeedData:FeedData):void {
            _selectedFeedData = selectedFeedData;
        }

        private static function createFilterSeparator():Quad{
            var separator:Quad = new Quad(1, 1, 0x8C8C8C);
            separator.width = 1;
            separator.height = 21;
            return separator;
        }

        public function get selectedUser():User {
            return _selectedUser;
        }

        public function set selectedUser(value:User):void {
            _selectedUser = value;
        }

        public function get ownTimeline():Boolean {
            return _ownTimeline;
        }

        public function set ownTimeline(value:Boolean):void {
            _ownTimeline = value;
        }
    }
}
