package com.despark.tuning3d.view.components.timeline.components {
import com.despark.tuning3d.view.components.core.ButtonFactory;

import feathers.core.FeathersControl;

import starling.display.Image;

import starling.display.Sprite;
import starling.events.EnterFrameEvent;
import starling.textures.Texture;

public class TimelineLoadBar extends FeathersControl{
    private var spinner:Sprite;
    public function TimelineLoadBar() {
    }

    protected override function initialize():void{
        super.initialize();
        spinner=new Sprite();
        var spinnerTexture:Texture=ButtonFactory.assetManager.getTexture("spinner");
        var spinnerImage:Image=new Image(spinnerTexture);
        spinnerImage.width=40;
        spinnerImage.height=40;
        spinnerImage.x=-20;
        spinnerImage.y=-20;
        spinner.addChild(spinnerImage);
        addChild(spinner);
        addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
    }

    override protected function draw():void {
        super.draw();
        spinner.x = actualWidth/2;
        spinner.y = actualHeight/2;
    }

    private function enterFrameHandler(event : EnterFrameEvent) : void{
        if(spinner && spinner.visible){
            spinner.rotation+=0.2;
        }
    }

    override public function dispose():void {
        spinner.removeFromParent(true);
        super.dispose();
    }
}
}
