package com.despark.tuning3d.view.components.tunings
{
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.cars.CarBackground;
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.http.URLLoaderObjects;
	import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.view.components.core.BackgroundContainer;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.utils.DisplayObjectUtil;
	import com.utils.ObjectUtils;
	import com.utils.RegExpUtil;

	import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Loader;
import flash.display.LoaderInfo;
import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.filesystem.File;
	import flash.geom.Rectangle;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.Dictionary;

	import mx.events.Request;

	import starling.display.Quad;
import starling.textures.Texture;
import starling.utils.MathUtil;

public class TuningSlideItemRenderer extends ListItemRenderer
	{
		
		private var clipRectQuad:Quad;
		
		private var backgroundContainer:BackgroundContainer = null;
		private var _slide:Object;
		public var clipBackground:Boolean = false;

        private var _loaderArr: Dictionary = new Dictionary();
        private var _overrideDispose:Boolean = false;
		private var _fitContent:Boolean = false;
		public function get slide() : Object
		{
			return data as Object;
		}
		
		protected override function initialize() : void {
			backgroundContainer = new BackgroundContainer();
            overrideDispose = _overrideDispose;
            setBackgroundSize();
			addChild(backgroundContainer);
			super.initialize();
			clipRectQuad = new Quad(1,1);
			this.label.visible=false;
		}

		private function setBackgroundSize():void{
            if(_fitContent && backgroundContainer.texture){
				updatePositions();
            }else if(clipBackground) {
				var h:Number = actualHeight + 50;
				var w:Number = actualWidth * h / actualHeight;
				backgroundContainer.setSize(w, h);
			} else {
                backgroundContainer.setSize(actualWidth, actualHeight);
            }
            backgroundContainer.x = (actualWidth - backgroundContainer.width) / 2;
            backgroundContainer.y = (actualHeight - backgroundContainer.height) / 2;
		}

		protected override function commitSelection() :void {
			
			
		}
		protected override function layout():void{
			//override
		}
		
		protected override function draw() : void
		{
			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			if(sizeInvalid){
				if(!this.mask){
					clipRectQuad.x = 0;
					clipRectQuad.width = actualWidth;
					if(clipBackground){
                        clipRectQuad.height = actualHeight + 50;
                        clipRectQuad.y = -25;
						addChild(clipRectQuad);
                    }else{
                        clipRectQuad.height = actualHeight;
                        clipRectQuad.y=0;
					}
					 this.mask = clipRectQuad;
				}else if(clipBackground){
                    if(mask.height != actualHeight + 50){
                        mask.height = actualHeight + 50;
                    }
                    if(mask.y != -25){
                        mask.y = -25;
                    }
                    if(!mask.parent){
                        addChild(mask);
                    }
				}
			}
		}
		
		protected function completeLoadImage(imageWidth:Number, imageHeight:Number):void{
			trace("imageWidth:", imageWidth, "imageHeight:", imageHeight);
			if(_fitContent && imageLoader.image){
				imageLoader.scale = 1;
				if(owner.width / owner.height < imageLoader.originalSourceWidth / imageLoader.originalSourceHeight){
					imageLoader.height = owner.height;
					imageLoader.width = owner.height * imageLoader.originalSourceWidth / imageLoader.originalSourceHeight;
				}else{
					imageLoader.width = owner.width;
					imageLoader.height = owner.width * imageLoader.originalSourceHeight / imageLoader.originalSourceWidth;
				}
			}else{
				imageLoader.width = imageWidth / 2;
				imageLoader.height = imageLoader.originalSourceHeight*imageLoader.scaleX;
			}

			if(slide && slide.hdsize){
				imageLoader.x = (actualWidth - imageLoader.width) / 2;
				imageLoader.y = (actualHeight - imageLoader.height)/ 2 - 20.5; // 20.5
			}else{
				imageLoader.x = (actualWidth - imageLoader.width) / 2;
				imageLoader.y = (actualHeight - imageLoader.height) / 2 - 12; // 12
			}
			updatePositions();
		}

		public function updatePositions():void{
			if(_fitContent){
				if(backgroundContainer.texture){
					setSize(owner.width, owner.height);
					if(imageLoader.image){
						imageLoader.validate();
						backgroundContainer.background.scale = imageLoader.image.scale;
						backgroundContainer.width = backgroundContainer.background.width;
						backgroundContainer.height = backgroundContainer.background.height;
						backgroundContainer.validate();
					}
					backgroundContainer.x = (actualWidth - backgroundContainer.width) / 2;
					backgroundContainer.y = (actualHeight - backgroundContainer.height) / 2;
				}
				
				if(imageLoader.image){
					imageLoader.validate();
					var offsetObj:Object = ObjectUtils.getProperty(data, "tuning.carObj.custom_offset");
					if(offsetObj){
						imageLoader.x = (actualWidth - imageLoader.width) / 2 - offsetObj.left * imageLoader.image.scale;
						imageLoader.y = (actualHeight - imageLoader.height) / 2 + offsetObj.bottom * imageLoader.image.scale;
					}
				}
			}
		}

		private function getBgUrl() : String {
            if(!slide) return "";
			var cameraIndex:int;
            var tuning:Tuning = slide.tuning;
            if(tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds[index] && tuning.customSnapshotsBackgrounds[index] != CarBackground.DEFAULT_ID
                    && tuning.backgroundsMap && tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[index]]){

                var carBackground:CarBackground=  tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[index]];//tuning.backgroundsMap[tuning.backgroundId];
                carBackground.showThumbnailUrl=false;
				cameraIndex =0;
                if(tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length>0 && carBackground.imagePathSecondCam && carBackground.imagePathSecondCam.length>0){
                    cameraIndex = tuning.customSnapshotsCamera[slide.index];
                }

                carBackground.selectedCamera =cameraIndex;
                return carBackground.remoteUrl;

            }else{

				var randomSplashUrl:String = "";
				if(tuning.customSnapshotsBackgrounds){
					var i:int;
					for(i = tuning.customSnapshotsBackgrounds.length-1; i >= 0; i--){
						if(!tuning.customSnapshotsBackgrounds[i] || tuning.customSnapshotsBackgrounds[i] == undefined){
							tuning.customSnapshotsBackgrounds[i] = CarBackground.DEFAULT_ID;
						}
					}
					for(i = tuning.customSnapshotsBackgrounds.length-1; i >= 0; i--){
						if(!tuning.customSnapshotsCamera[i]){
							tuning.customSnapshotsCamera[i] = 0;
						}
						if(tuning.customSnapshotsBackgrounds[i] == CarBackground.DEFAULT_ID && tuning.carObj && tuning.carObj.defaultBkgSite && tuning.carObj.defaultBkgSite.length){
							tuning.customSnapshotsBackgrounds[i] = tuning.carObj.defaultBkgSite[tuning.customSnapshotsCamera[i]];
						}else if(!RegExpUtil.isUrl(tuning.customSnapshotsBackgrounds[i]) && tuning.backgroundsMap && tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[i]]){
							var bg:CarBackground = tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[i]];
							tuning.customSnapshotsBackgrounds[i] = bg.remoteUrl;
						}
					}
					if(tuning.customSnapshotsBackgrounds.length) {
                        index = MathUtil.clamp(index, 0, tuning.customSnapshotsBackgrounds.length - 1);
                        randomSplashUrl = tuning.customSnapshotsBackgrounds[index];
						if(randomSplashUrl && randomSplashUrl.indexOf(Constants.BACKGROUNDS_URL) != -1){
							return 'http:' + randomSplashUrl.replace('http:', '');
						}
						for(i = 0; i < tuning.customSnapshotsBackgrounds.length; i++){
							randomSplashUrl = tuning.customSnapshotsBackgrounds[i];
							if(randomSplashUrl && randomSplashUrl.indexOf(Constants.BACKGROUNDS_URL) != -1){
								return 'http:' + randomSplashUrl.replace('http:', '');
							}
						}
                    }
				}

                if(tuning.carChooserBgName) {
					randomSplashUrl = File.applicationDirectory.resolvePath("assets/textures/bgs/"+tuning.carChooserBgName.replace('.jpg', '') + ".jpg").url;
					if(tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length>0){
						cameraIndex = tuning.customSnapshotsCamera[slide.index];
                        if(tuning.carObj.defaultBkgMobile[cameraIndex]){
                            randomSplashUrl = tuning.carObj.defaultBkgMobile[cameraIndex];
                        }
                    }
                    return randomSplashUrl;
                }else if(tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds.length && tuning.customSnapshotsBackgrounds[MathUtil.clamp(index, 0, tuning.customSnapshotsBackgrounds.length-1)].indexOf("data.3dtuning.com") > -1){
					index = MathUtil.clamp(index, 0, tuning.customSnapshotsBackgrounds.length-1);
					return 'http:' + tuning.customSnapshotsBackgrounds[index].replace('http:', '');
				} else {
                    randomSplashUrl = File.applicationDirectory.resolvePath("assets/textures/bgs/a_bridge.jpg").url;
                    return randomSplashUrl;
                }
            }
		}


        override public function dispose():void {
            super.dispose();
			if(backgroundContainer){
                backgroundContainer.removeFromParent(true);
                backgroundContainer = null;
			}
			if(clipRectQuad){
                clipRectQuad.removeFromParent(true);
                clipRectQuad = null;
			}
			DisplayObjectUtil.dispose(this);
        }


        protected override function commitData() : void {
			super.commitData();
			if(!slide || slide == _slide) {
				return;
            }
			_slide = slide;
            setBackgroundSize();
			loadBackground(getBgUrl());

			var car:Car = new Car();
			car.imageURL = slide.url;
			imageLoader.recieveImageSize = completeLoadImage;
			imageLoader.overrideDispose = _overrideDispose;
			imageLoader.persistentImageProvider = car;
		}

		private function loadBackground(url:String):void{
			var loader: Loader = new Loader();
			_loaderArr[url] = loader;
			loader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, function (e:Event):void {
				var currentTarget:LoaderInfo = e.currentTarget as LoaderInfo;
				var smallBMD:BitmapData =(currentTarget.content as Bitmap).bitmapData; //new BitmapData(currentTarget.content.width * scale, currentTarget.content.height * scale, true, 0x000000);

				if (backgroundContainer) {
					var bgUrl:String = url;
					var texture:Texture = Texture.fromBitmapData(smallBMD);
					texture.root.onRestore = function():void{
						loadBackground(bgUrl);
					};
					backgroundContainer.updateBackground(texture);
					setBackgroundSize();
				}

				smallBMD.dispose();
				delete _loaderArr[url];
			});
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, function (e:Event):void {
				trace('error', url);
				delete _loaderArr[url];
			});
			loader.contentLoaderInfo.addEventListener(SecurityErrorEvent.SECURITY_ERROR, function (e:Event):void {
				trace('error', url);
				delete _loaderArr[url];
			});

			loader.load( new URLRequest( url ) );

		}

        public function set overrideDispose(overrideDispose:Boolean):void {
            _overrideDispose = overrideDispose;
			if(imageLoader){
				imageLoader.overrideDispose = _overrideDispose;
			}
        }

		public function set fitContent(value:Boolean):void {
			_fitContent = value;
		}
	}
}
