package com.despark.tuning3d.view.components.tunings.colors
{
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.utils.FontSelector;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.DisplayObject;
import starling.display.Image;
import starling.display.Quad;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class PartColorButton extends MultilingualButton
	{
		private var defaultBackgroundQuad:Quad;
		private var colorPoint:Image;
		
		private var downBackgroundQuad:Quad;
		private var downColorPoint:Image;
		
		private var _downSkin:DisplayObject;
		
		private var assetManager:AssetManager;
		private var language:Language;
		
		public function PartColorButton()
		{
			assetManager=AlertView.assetManager;
			language=AlertView.language;
			
			super();
			
			
			
		}
		
		override protected function initialize():void{
			
			
			super.initialize();
			
			textFormat = new TextFormat(FontSelector.getFont(true), 7, 0xFFFFFF );
			textFormat.align = TextFormatAlign.CENTER;
			textFormat.bold=false;
			paddingLeft=0;
			paddingTop=13.5;
			wordWrap=true;
			label="Body";
			updateWithLanguage(language);
			
			_defaultSkin=createDefaultSkin();
			_downSkin=createDownSkin();
			
			
			defaultSkin =_defaultSkin;
			
			downSkin=_downSkin;
			
			
			var colorPointTexture:Texture=assetManager.getTexture("a_part_color");
			colorPoint=new Image(colorPointTexture);
			colorPoint.width=12;
			colorPoint.height=13;
			colorPoint.color=0xfefefe;
			
			
			addChild(colorPoint);
			
		}
		
		
		
		protected function createDefaultSkin():DisplayObject{
			
			//var skin:DisplayObjectContainer=new DisplayObjectContainer();
			defaultBackgroundQuad=new Quad(1,1, 0x000000);
			defaultBackgroundQuad.alpha=0;
			
			//skin.addChild(defaultBackgroundQuad);
			
			/*var colorPointTexture:Texture=assetManager.getTexture("a_part_color");
			defaultColorPoint=new Image(colorPointTexture);
			skin.addChild(defaultColorPoint);*/
			
			return defaultBackgroundQuad;
		}
		
		protected function createDownSkin():DisplayObject{
			
			//var skin:DisplayObjectContainer=new DisplayObjectContainer();
			downBackgroundQuad=new Quad(1,1, 0x000000);
			downBackgroundQuad.alpha=0.3;
			//downBackgroundQuad.width=12;
			//downBackgroundQuad.height=13;
			//skin.addChild(downBackgroundQuad);
			
			//var colorPointTexture:Texture=assetManager.getTexture("a_part_color");
			//downColorPoint=new Image(colorPointTexture);
			//skin.addChild(downColorPoint);
			
			return downBackgroundQuad;
		}
		
		override protected function draw():void{
			
			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			
			if(sizeInvalid){
				
				
				defaultBackgroundQuad.width=actualWidth;
				defaultBackgroundQuad.height=actualHeight;
				
				
				downBackgroundQuad.width=actualWidth;
				downBackgroundQuad.height=actualHeight;
				
				colorPoint.x=(actualWidth-colorPoint.width)/2;
				colorPoint.y=8;
				
				//downColorPoint.x=(actualWidth-downColorPoint.width)/2;
				
				
				//downColorPoint.y=11;
				
				
				/*
				defaultBackgroundQuad.width=12;
				defaultBackgroundQuad.height=13;
				*/
				
				
			}
		}
		
		
		
	}
}


