package com.despark.tuning3d.view.components.tunings.colors
{
import com.despark.tuning3d.model.disks.Disk;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.model.parts.Part;
import com.despark.tuning3d.model.parts.PartColor;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartDisk;
import com.despark.tuning3d.model.parts.PartSlot;
import com.despark.tuning3d.model.parts.PartSlotDisk;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ExtentedButton;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.despark.tuning3d.view.components.core.SimpleExtendedButton;
import com.despark.tuning3d.view.components.parts.CamberItemRenderer;
import com.despark.tuning3d.view.components.parts.PartDiskItemRenderer;
import com.google.analytics.debug.Layout;
import com.utils.FontSelector;
import com.utils.ObjectUtils;

import feathers.controls.Button;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.ScrollContainer;
import feathers.controls.renderers.IListItemRenderer;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
import feathers.core.ITextRenderer;
import feathers.data.ListCollection;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.EnterFrameEvent;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class TuningDiskSettingsView extends FeathersControl implements Multilingual
	{
		public static const CLOSE_DISK_SETTINGS:String="CloseDisksSettingsMenu";
		
		public static const SHOW_BUY_PACKET_CAMBER:String="SHOW_BUY_PACKET";
		
	
		public static const ITEM_WIDTH:Number=20;
		public static const ITEM_HEIGHT:Number=20;

		public var assetManager : AssetManager;

		private var currentLanguage : Language;
		private var _partColor : PartColor;
		private var quad : Quad;
		private var _partSlot : PartSlot;
		private var separator : Quad;
		
		private var curRadius : int = 15;
		private var _min_size:int=0;
		private var _max_size:int=0;
		private var _isExtanded:Boolean=false;

		private var btnClose:Button;

		private var btnRotateContainer : ScrollContainer;
		private var btnTrl:Button;
		private var btnTrr:Button;
		private var iconTr:Image;
		
		
		private var btnRadiusContainer : ScrollContainer;
		private var btnRadius : Button;
		private var btnRadiusPlus : Button;
		private var btnRadiusMinus : Button;
		private var camberList:List;
		private var wideList:List;
		private var profileList:List;


		
		private var _rotateDataProvider:Array;
		private var _camberDataProvider:Array;
		private var _wideDataProvider:Array;
		private var _profileDataProvider:Array;

		private var spinner:Sprite;
		
		private var blocker:Quad;

		private var buttonLock:Button;
		
		protected var carLock:Image;

		private var camberLabel:MultilingualLabel;
		private var offsetLabel:MultilingualLabel;
		private var profileLabel:MultilingualLabel;

		private var radiusRotationGroup:LayoutGroup;
		private var delimiter1:Quad;
		private var delimiter2:Quad;

        private static const PART_GAP:Number = 15;
        private static const CAMBER_LABEL_WIDTH:Number = 70;
        private static const RADIUS_WIDTH:Number = 105;
        private static const CAMBER_LIST_WIDTH:Number = 75;

		private var isPart1:Boolean = false;
		private var isPart2:Boolean = false;
		private var isPart3:Boolean = false;


		public function TuningDiskSettingsView() {
			super();
		}

		private function isExistsState(id:String):Boolean{
			if(!_partSlot)
				return false;
			if(!_partSlot.selectedPart)
				return false;
			var part:PartDisk=_partSlot.selectedPart as PartDisk;
			if(!part)
				return false;
			for (var nameOfState:String in part.states){
				if(nameOfState.indexOf(id)>=0){
					return true;
				}
			}
			return false;
		}
		
		public function set partSlot(value : PartSlot) : void {
			_partSlot = value;
			if(_partSlot){
				var part:PartDisk=_partSlot.selectedPart as PartDisk;
				var partDisk:PartDisk=part;
				_rotateDataProvider=[];
				_camberDataProvider=[];

				if(isExistsState("cm1")){
					_camberDataProvider.push({     
						id:"cm1",
						icon_up:"a_disk_set_default",
						icon_down:"a_disk_set_select",
						selected_background:"a_disk_set_select",
						title:"1"
					});
				}
				
				if(isExistsState("cm2")){
					_camberDataProvider.push({
						id:"cm2",
                        icon_up:"a_disk_set_default",
                        icon_down:"a_disk_set_select",
                        selected_background:"a_disk_set_select",
						title:"2"
					});
				}
				_wideDataProvider=[];
				
				if(isExistsState("of1")){
					_wideDataProvider.push({
						id:"of1",
                        icon_up:"a_disk_set_default",
                        icon_down:"a_disk_set_select",
                        selected_background:"a_disk_set_select",
						title:"1"
					});
				}
					
				if(isExistsState("of2")){
					_wideDataProvider.push({
						id:"of2",
                        icon_up:"a_disk_set_default",
                        icon_down:"a_disk_set_select",
                        selected_background:"a_disk_set_select",
						title:"2"
					});
				}

                _profileDataProvider=[];
                _profileDataProvider.push({
                    id:"FLAT",
                    icon_up:"a_disk_set_default",
                    icon_down:"a_disk_set_select",
                    selected_background:"a_disk_set_select",
                    title:"F"
                },{
                    id:"MID",
                    icon_up:"a_disk_set_default",
                    icon_down:"a_disk_set_select",
                    selected_background:"a_disk_set_select",
                    title:"M"
                },{
                    id:"DEEP",
                    icon_up:"a_disk_set_default",
                    icon_down:"a_disk_set_select",
                    selected_background:"a_disk_set_select",
                    title:"D"
                },{
                    id:"S.DEEP",
                    icon_up:"a_disk_set_default",
                    icon_down:"a_disk_set_select",
                    selected_background:"a_disk_set_select",
                    title:"S"
                });

				if(partDisk && partDisk.radius>0){
					_min_size=part.properties.min_size;
					_max_size=part.properties.max_size;
					if((part as PartDisk).selectedDiskSize>0){
						curRadius=(part as PartDisk).selectedDiskSize;
					}else{
						curRadius=part.properties.size;
					}
					_isExtanded=true;
					//invalidate("data_provider");
				}else{
					_isExtanded=false;
					//invalidate("data_provider");
				}

                if(hasProfile(_partSlot) && !profileList) {
                    profileList = new List();
                    profileList.clipContent = false;
                    profileList.layout = createListLayout();
                    profileList.itemRendererFactory = function ():IListItemRenderer {
                        var renderer:CamberItemRenderer = new CamberItemRenderer();
                        renderer.setSize(16, 16);
                        return renderer;
                    };
                    profileList.addEventListener(Event.CHANGE, profileListChangeHandler);
                    addChild(profileList);

                    profileLabel = new MultilingualLabel();
                    profileLabel.visible = false;
                    profileLabel.textFormat = new TextFormat(FontSelector.getFont(false), 9, 0xffffff);

                    profileLabel.textFormat.align = TextFormatAlign.LEFT;
                    profileLabel.textFormat.bold = false;
                    profileLabel.text = "Wheel Profile Shape";
                    profileLabel.updateWithLanguage(AlertView.language);
                    addChild(profileLabel);
                }

				var selectedItemRenderer:PartDiskItemRenderer = owner.itemToItemRenderer(owner.selectedItem) as PartDiskItemRenderer;
                if(_partSlot) {
                    var profileWidth:Number = 120;
                    var radiusWidth:Number = 95;
                    var camberWidth:Number = 155;
					isPart1 = ((partSlot.name.indexOf("rear") == -1 || isTrrPossible() || isTrlPossible()) || _max_size!=_min_size);
					isPart2 = hasProfile(_partSlot);
					isPart3 = (_camberDataProvider.length || _wideDataProvider.length);
					var ps:int = int(isPart1) + int(isPart2) + int(isPart3);
					if(ps == 1 && selectedItemRenderer){
                        width = selectedItemRenderer.width;
					}else{
                        width = (isPart1?radiusWidth:0) + (isPart2? profileWidth : 0) + (isPart3?camberWidth:0);
                    }

                    var leftBorder:Quad = createDelimiter(actualHeight);
                    addChild(leftBorder);

                    var rightBorder:Quad = createDelimiter(actualHeight);
                    addChild(rightBorder);
                    rightBorder.x = actualWidth-1;
                    if(ps > 1) {
                        delimiter1 = createDelimiter();
                        addChild(delimiter1);
                    }

                    if(ps == 3) {
                        delimiter2 = createDelimiter();
                        addChild(delimiter2);
                    }
                }

                if(!hasProfile(_partSlot)){
					if(profileList && profileLabel) {
                        profileList.visible = profileLabel.visible = false;
                    }
                }
				invalidate("partSlot");
			}
		}

		private function delimiterLayout():void {
            var ps:int = int(isPart1) + int(isPart2) + int(isPart3);
            if(delimiter1){
                if(ps > 1) {
                    delimiter1 = createDelimiter();
                    addChild(delimiter1);
                    if(ps == 2) {
                        if(offsetLabel && !profileList) {
                            delimiter1.x = offsetLabel.x - PART_GAP;
                        }else{
                            delimiter1.x = profileList.x - PART_GAP;
                        }
                    }else if(offsetLabel){
                        delimiter1.x = offsetLabel.x - PART_GAP;
                    }
                    delimiter1.y = 5;
                }
            }

            if(delimiter2 && profileList){
                delimiter2.x = profileList.x - PART_GAP;
                delimiter2.y = 5;
            }
		}

        private function hasProfile(ps:PartSlot):Boolean {
			var diskSlot:PartSlotDisk = ps as PartSlotDisk;
			if(!diskSlot){
				return false;
			}
			var part:PartDisk = diskSlot.selectedPart as PartDisk;
			return part.profile != 'default';
        }
		
		public function get partSlot() : PartSlot {
			return _partSlot;
		}

		public function updateWithLanguage(language : Language) : void {
			currentLanguage = language;
		}

		override protected function initialize() : void {
			super.initialize();
			quad = new Quad(1, 1, 0x000000);
			quad.alpha=1;
			addChild(quad);

			btnRadiusContainer = new ScrollContainer();
			var btnGroup :  HorizontalLayout = new  HorizontalLayout();
			btnGroup.gap = 10;
			btnGroup.verticalAlign = VerticalAlign.MIDDLE;
			btnRadiusContainer.layout = btnGroup;


			btnRadiusPlus = ButtonFactory.circleButton("a_plus_icon");
			btnRadiusPlus.width = 12;
			btnRadiusPlus.height = 11.5;
			(btnRadiusPlus as ExtentedButton).hitAreaPadding = 10;
			btnRadiusPlus.addEventListener(Event.TRIGGERED, btnRadiusPlusHandler);
			btnRadiusContainer.addChild(btnRadiusPlus);

			// Radius
			//btnRadius = ButtonFactory.circleButton("btn_r15");
			btnRadius = ButtonFactory.circleButton("a_disk_radius_icon");

			btnRadius.width = 20;
			btnRadius.height = 20;
			btnRadius.touchable=false;
			btnRadius.isEnabled=false;
			btnRadius.labelFactory=function():ITextRenderer{
				var label:TextFieldTextRenderer=new TextFieldTextRenderer();
				label.textFormat=new TextFormat(FontSelector.getFont(true), 8, 0xc0c2c2 );
				label.textFormat.bold=true;
				label.textFormat.align="center";
				label.embedFonts=FontSelector.embedFonts();
				//label.snapToPixels=false; //tt
				label.focusPaddingRight=2;
				label.focusPaddingBottom=1;
				return label ;
			};
			if(FontSelector.embedFonts()){
				btnRadius.labelOffsetX=0.5;
				btnRadius.labelOffsetY=-0.5;
			}else{
				btnRadius.labelOffsetX=-.5;
				btnRadius.labelOffsetY=-0.5;
			}
			btnRadiusContainer.addChild(btnRadius);

			btnRadiusMinus = ButtonFactory.circleButton("a_minus_icon");
			btnRadiusMinus.width = 11.5;
			btnRadiusMinus.height = 11.5;

			(btnRadiusMinus as ExtentedButton).hitAreaPadding = 10;
			btnRadiusMinus.addEventListener(Event.TRIGGERED, btnRadiusMinusHandler);
			btnRadiusContainer.addChild(btnRadiusMinus);

			btnRotateContainer = new ScrollContainer();
			var btnGroup2 :  HorizontalLayout = new  HorizontalLayout();
			btnGroup2.gap = 10;
			btnGroup2.verticalAlign = VerticalAlign.MIDDLE;
			btnRotateContainer.layout = btnGroup2;

			btnTrl = ButtonFactory.circleButton("a_disk_left_icon");
			btnTrl.width = 6;
			btnTrl.height = 9;
			(btnTrl as ExtentedButton).hitAreaPadding=7;
			btnTrl.addEventListener(Event.TRIGGERED, btnTrlHandler);
			btnRotateContainer.addChild(btnTrl);

			var trTexture:Texture=ButtonFactory.assetManager.getTexture("a_disk_left_right_icon");
			iconTr=new Image(trTexture);
			iconTr.alpha=0.5;
			iconTr.width=20;
			iconTr.height=20.5;
			btnRotateContainer.addChild(iconTr);

			btnTrr = ButtonFactory.circleButton("a_disk_right_icon");
			btnTrr.width = 7;
			btnTrr.height = 9;

			btnTrr.addEventListener(Event.TRIGGERED, btnTrrHandler);
			(btnTrr as ExtentedButton).hitAreaPadding=7;
			btnRotateContainer.addChild(btnTrr);

            radiusRotationGroup = new LayoutGroup();
			var radRotLayout:VerticalLayout = new VerticalLayout();
			radRotLayout.paddingTop = 3;
			radRotLayout.paddingLeft = radRotLayout.paddingRight = PART_GAP;
            radRotLayout.horizontalAlign = HorizontalAlign.CENTER;
            radRotLayout.gap = 4;
            radiusRotationGroup.layout = radRotLayout;
            radiusRotationGroup.addChild(btnRadiusContainer);
            radiusRotationGroup.addChild(btnRotateContainer);
			addChild(radiusRotationGroup);

			this.camberList=new List();
			camberList.addEventListener("itemSelectedAgain", camberListItemSelectedAgain);
			camberList.clipContent = false;
			camberList.layout = createListLayout();
			camberList.itemRendererFactory = function() :IListItemRenderer {
				var renderer:CamberItemRenderer = new CamberItemRenderer();
				renderer.setSize(16, 16);
				return renderer;
			};
			camberList.addEventListener(Event.CHANGE, camberListChangeHandler);	
			addChild(camberList);
			
			
			
			wideList=new List();
			wideList.addEventListener("itemSelectedAgain", wideListItemSelectedAgain);
			wideList.clipContent = false;
			wideList.layout = createListLayout();
			wideList.itemRendererFactory = function() :IListItemRenderer {
				var renderer:CamberItemRenderer = new CamberItemRenderer();
				renderer.setSize(16, 16);
				return renderer;
			};
			wideList.addEventListener(Event.CHANGE, wideListChangeHandler);
			addChild(wideList);


			camberLabel = new MultilingualLabel();
			camberLabel.visible=false;
			camberLabel.textFormat = new TextFormat(FontSelector.getFont(false), 9, 0xffffff);
			
			camberLabel.textFormat.align = TextFormatAlign.LEFT;
			camberLabel.textFormat.bold=false;   
			camberLabel.text="Camber";
			camberLabel.updateWithLanguage(AlertView.language);
			
			addChild(camberLabel);
			
			
			
			offsetLabel = new MultilingualLabel();
			offsetLabel.visible=false;
			offsetLabel.textFormat = new TextFormat(FontSelector.getFont(false), 9, 0xffffff);
			
			offsetLabel.textFormat.align = TextFormatAlign.LEFT;
			offsetLabel.textFormat.bold=false;   
			offsetLabel.text="Off-set";
			offsetLabel.updateWithLanguage(AlertView.language);
			
			addChild(offsetLabel);
			
			
			buttonLock=new Button();   
			buttonLock.visible=false;
			//buttonLock.alpha=0.3;
			
			buttonLock.defaultSkin=new Quad(10,10,0x000000);
			buttonLock.defaultSkin.alpha=0.3;
			buttonLock.addEventListener(Event.TRIGGERED, onClickBlockerLock);
			addChild(buttonLock);  
			
			
			
			var carLockTexture : Texture = AlertView.assetManager.getTexture("car_lock_big_icon");
			carLock=new Image(carLockTexture);
			carLock.visible=false;
			carLock.touchable=false;
			carLock.addEventListener(Event.TRIGGERED, onClickBlockerLock);
			addChild(carLock);	
			
			
			btnClose=ButtonFactory.circleButton("a_close_effect_menu");
			btnClose.addEventListener(Event.TRIGGERED, closeViewHandler);
			btnClose.width=10;
			btnClose.height=10;
			addChild(btnClose);

			blocker=new Quad(1,1,0x000000);
			blocker.visible=false;
			blocker.alpha=0.3;
			addChild(blocker);

			spinner=new Sprite();
			spinner.visible=false;
			
			var spinnerTexture:Texture=assetManager.getTexture("spinner");
			
			var spinnerImage:Image=new Image(spinnerTexture);
			
			
			spinnerImage.width=16;
			spinnerImage.height=16;
			
			spinnerImage.x=-8;  
			spinnerImage.y=-8;  
			
			spinner.addChild(spinnerImage);
            delimiterLayout();
			
			addChild(spinner);
			addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
        }
		
		private function btnTrlHandler(event:Event):void{
			if(btnTrl.alpha==0.5){
				btnTrl.alpha=1;
				this.doChangeData(false, true);
			}else{
				btnTrl.alpha=0.5;
				btnTrr.alpha=btnTrr.alpha>0.2?1:0.2;
				this.doChangeData(false, false);
			}
		}
		
		private function btnTrrHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART);
			if(btnTrr.alpha==0.5){
				btnTrr.alpha=1;
				this.doChangeData(false, true);
			}else{
				btnTrr.alpha=0.5;
				btnTrl.alpha=btnTrl.alpha!=0.2?1:0.2;
				this.doChangeData(false, false);
			}
		}
		
		public function get owner():List{
			return parent as List;//(parent as PartDiskItemRenderer).owner;
		}
		
		private function btnRadiusMinusHandler(event:Event = null):void {
			changeRadius(-1);
			if(owner.selectedItem){
				var partDisk:PartDisk=(owner.selectedItem as  PartDisk);
				partDisk.selectedDiskSize=curRadius;
				var profileValue:String = PartDisk(partDisk.parentSlotDisk.selectedPart).profile;
				var prefix:String=PartSlotDisk.getPrefixDep(partDisk);
				var partDiskObj:Object=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize, profileValue);
				while(!partDiskObj && curRadius>_min_size && curRadius<_max_size){
					changeRadius(-1);
					partDisk.selectedDiskSize=curRadius;
					prefix=PartSlotDisk.getPrefixDep(partDisk);
					partDiskObj=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize, profileValue);
				}
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
                owner.dispatchEventWith(PartDiskItemRenderer.EVENT_CHANGE_PART_DATA, false, {disk: partDiskObj});
			}
		}
		
		
		
		private function btnRadiusPlusHandler(event:Event = null):void {
			changeRadius(1);
            if(owner.selectedItem){
                var partDisk:PartDisk=(owner.selectedItem as  PartDisk);
                partDisk.selectedDiskSize=curRadius;
                var profileValue:String = PartDisk(partDisk.parentSlotDisk.selectedPart).profile;
                var prefix:String=PartSlotDisk.getPrefixDep(partDisk);
                var partDiskObj:Object=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize, profileValue);
                while(!partDiskObj && curRadius>_min_size && curRadius<_max_size){
                    changeRadius(1);
                    partDisk.selectedDiskSize=curRadius;
                    prefix=PartSlotDisk.getPrefixDep(partDisk);
                    partDiskObj=partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name+prefix, partDisk.selectedDiskSize, profileValue);
                }
				SoundManager.playSound(SoundManager.SELECT_PART);
                owner.dispatchEventWith(PartDiskItemRenderer.EVENT_CHANGE_PART_DATA, false, {disk: partDiskObj});
            }
		}

		private function changeRadius(delta:int):void {
			curRadius += delta;
			if(curRadius==_max_size && curRadius==_min_size){
				btnRadiusPlus.isEnabled =  false;
				btnRadiusMinus.isEnabled = false;
				
				btnRadiusPlus.alpha=0.5;
				btnRadiusMinus.alpha=0.5;
			}else {
                if (curRadius >= _max_size) {
                    btnRadiusPlus.isEnabled = false;
                    btnRadiusMinus.isEnabled = true;

                    btnRadiusPlus.alpha = 0.5;
                    btnRadiusMinus.alpha = 1;

                } else if (curRadius <= _min_size) {
                    btnRadiusPlus.isEnabled = true;
                    btnRadiusMinus.isEnabled = false;

                    btnRadiusPlus.alpha = 1;
                    btnRadiusMinus.alpha = 0.5;
                } else {
                    btnRadiusPlus.isEnabled = true;
                    btnRadiusMinus.isEnabled = true;

                    btnRadiusPlus.alpha = 1;
                    btnRadiusMinus.alpha = 1;
                }
            }
            this.btnRadiusContainer.visible=(_max_size!=_min_size);
			btnRadius.label = curRadius.toString();
		}
		
		private function onClickBlockerLock(event:Event):void{
			SoundManager.playSound(SoundManager.DISABLED_PART);
			
			dispatchEventWith(SHOW_BUY_PACKET_CAMBER, true);
		}
		
		
		private function enterFrameHandler(event : EnterFrameEvent) : void
		{
			
			if(spinner && spinner.visible){
				
				spinner.rotation+=0.2;  
			}
			
		}
		
		
		
		public function doChangeData(neon_on:Boolean=false, unselect:Boolean=false):void{
			if(!sendDataChangeEvent)
				return;
			var part:PartDisk=_partSlot.selectedPart as PartDisk;
			part.parentSlotDisk.selectedPart = part;
			if(part && part.selectedState && part.selectedState.nameOfState && part.selectedState.nameOfState.indexOf("neon")>=0){
				neon_on=true;
			}    
			
			var stateName:String="";
			if(camberList.selectedItem){
				stateName=camberList.selectedItem.id;
			}
			
			if(neon_on){
				if(stateName!=""){
					stateName+="-";
				}
				stateName+="neon";
			}
			
			if(wideList.selectedItem){
				if(stateName!=""){
					stateName+="-";
				}
				stateName+=wideList.selectedItem.id;
			}
			
			if(btnTrr.alpha==0.5){
				if(stateName!=""){
					stateName+="-";
				}
				stateName+="trr"
			}
			
			if(btnTrl.alpha==0.5){
				if(stateName!=""){
					stateName+="-";
				}
				
				stateName+="trl"
			}

			for(var nameOfState:String in part.states){
				if(nameOfState==stateName){
					enableButtons(false);
					dispatchEventWith(TuningSelectedStateView.STATE_SELECTED, true, {selectedState: nameOfState, part: Part});
					//dispatchEventWith(CHANGE_DISK_SETTINGS);
					return;
				}
			}
			
			nameOfState=null;
			if(neon_on){
				
				nameOfState="neon";
			}
			
			if(unselect){
				enableButtons(false);
				dispatchEventWith(TuningSelectedStateView.STATE_SELECTED, true, {selectedState: nameOfState, part: Part});
			}
		}
		
		public function enableButtons(value:Boolean):void{   
			
			//this.rotateList.touchable=value;
			this.wideList.touchable=value;
			this.camberList.touchable=value;  
			
			
			this.blocker.visible=!value;
			this.spinner.visible=!value;         
			//this.
		}
		

		
		private function camberListItemSelectedAgain(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			camberList.selectedIndex = -1;
			doChangeData(false, true);
		}
		
		private function camberListChangeHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART);
			doChangeData();
		}
		
		
		private function wideListItemSelectedAgain(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			wideList.selectedIndex = -1;
			doChangeData(false, true);
		}
		
		private function wideListChangeHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART);
			doChangeData();
		}

		private function profileListChangeHandler(event:Event):void {
            var profileValue:String = profileList.selectedItem ? profileList.selectedItem.id : null;
            var partDisk:PartDisk = PartDisk(partSlot.selectedPart)||(owner.selectedItem as PartDisk);
            if (partDisk) {
				partDisk.selectedDiskSize = curRadius;
				var prefix:String = PartSlotDisk.getPrefixDep(partDisk);
				var partDiskObj:Object = partDisk.parentSlotDisk.findPartDiskForRadius(partDisk.name + prefix, partDisk.selectedDiskSize, profileValue);
				SoundManager.playSound(SoundManager.SELECT_PART);
				owner.dispatchEventWith(PartDiskItemRenderer.EVENT_CHANGE_PART_DATA, false, {disk: partDiskObj});
			}
		}

		private function createListLayout():HorizontalLayout{
			var listLayout : HorizontalLayout = new HorizontalLayout();
			listLayout.useVirtualLayout = false;
			listLayout.gap=11.5;//ITEM_HGAP;
			return listLayout;
		}
		
		public function removeCamberLock():void{
			
			trace("removeCamberLock");
				
			buttonLock.visible=false;
			carLock.visible=false;    
			
			
			
			if(_partSlot && _partSlot.selectedPart){
				trace("removeCamberLock2");
				_partSlot.selectedPart.camberLock = false;
				invalidate();
			}
			
			
		}
		
		override protected function draw() : void {
			super.draw();
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			var radAndRot:Boolean = true;
			if(isInvalid("partSlot")){
				var stateName:String="";
				if(partSlot.selectedPart && partSlot.selectedPart.selectedState && partSlot.selectedPart.selectedState.nameOfState){
					stateName=partSlot.selectedPart.selectedState.nameOfState;
				}
				
				sendDataChangeEvent=false;
				if(stateName.indexOf("trr")>=0){
					this.btnTrr.alpha=0.5;
				}else{
					this.btnTrr.alpha=1;
				}
				
				if(stateName.indexOf("trl")>=0){
					this.btnTrl.alpha=0.5;
				}else{
					this.btnTrl.alpha=1;
				}

				if(partSlot && partSlot.name) {
                    btnTrl.visible = (partSlot.name.indexOf("rear") == -1);
                    btnTrr.visible = (partSlot.name.indexOf("rear") == -1);
                    iconTr.visible = (partSlot.name.indexOf("rear") == -1);
                    radAndRot = (partSlot.name.indexOf("rear") >= 0);
                    if (partSlot.name.indexOf("rear") >= 0) {

                    } else {
                        btnTrl.isEnabled = isTrlPossible();
						btnTrl.alpha = isTrlPossible()?btnTrl.alpha:0.2;

                        btnTrr.isEnabled = isTrrPossible();
                        btnTrr.alpha = isTrrPossible()?btnTrr.alpha:0.2;

                        iconTr.alpha = (isTrlPossible() || isTrrPossible())?iconTr.alpha:0.2;
                    }
                }

				camberList.dataProvider=new ListCollection(_camberDataProvider);
				camberList.selectedIndex=-1;  
				camberList.visible=camberList.dataProvider.length>0;
				
				if(stateName.indexOf("cm1")>=0){
                    camberList.selectedIndex=0;
                }

				if(stateName.indexOf("cm2")>=0){
                    camberList.selectedIndex=1;
                }

				wideList.dataProvider=new ListCollection(_wideDataProvider);
				wideList.selectedIndex=-1;
				wideList.visible=wideList.dataProvider.length>0;

				if(stateName.indexOf("of1")>=0){
                    wideList.selectedIndex=0;
                }

				if(stateName.indexOf("of2")>=0){
                    wideList.selectedIndex=1;
                }

				if(profileList) {
                    profileList.removeEventListener(Event.CHANGE, profileListChangeHandler);
					var profileValues:Array = ObjectUtils.getKeys(PartSlotDisk(_partSlot).diskRadiusMap[partSlot.selectedPart.name][PartDisk(partSlot.selectedPart).radius], false);
                    var i:int;
                    var dat:Object;
					for(i = _profileDataProvider.length-1; i >= 0; i--){
                        dat = _profileDataProvider[i];
                        if(profileValues.indexOf(dat.id)==-1){
                            _profileDataProvider.removeAt(i);
                        }
                    }
                    profileList.dataProvider = new ListCollection(_profileDataProvider);
                    for(i = _profileDataProvider.length-1; i >= 0; i--){
                        dat = _profileDataProvider[i];
                        if(dat.id == PartDisk(partSlot.selectedPart).profile){
                            profileList.selectedItem = dat;
							break;
                        }
                    }
                    profileList.visible = profileList.dataProvider.length > 0;
                    profileList.addEventListener(Event.CHANGE, profileListChangeHandler);
                }

				sendDataChangeEvent=true;
				sizeInvalid=true;
				if(_partSlot && _partSlot.selectedPart){
					var part:PartDisk=_partSlot.selectedPart as PartDisk;
					if (part) {
						part.camberLock = PartDisk(_partSlot.possibleParts[0]).camberLock;
						if (part.camberLock) {
							buttonLock.visible = true;
							carLock.visible = true;
						} else {
							buttonLock.visible = false;
							carLock.visible = false;
						}
					}


				}

				if(_isExtanded){
					btnRadius.label=curRadius.toString();
					changeRadius(0);
				}else{
					changeRadius(0);
					btnRadiusContainer.visible=false;
				}
			}
			
			
			if(sizeInvalid) {
				if(quad) {
					quad.width = actualWidth;
					quad.height = actualHeight;
				}

				if(btnClose){
					btnClose.x = actualWidth-(btnClose.width+3);
					btnClose.y = 3;
				}
				
				var posy:Number=4;
				if(camberList){
					camberList.x = (isPart1?RADIUS_WIDTH:15) + CAMBER_LABEL_WIDTH;
					camberList.y = posy;
					camberList.width=CAMBER_LABEL_WIDTH;
					camberList.height=16;
					if(camberList.visible){
						camberLabel.x=(isPart1?RADIUS_WIDTH:15);
						camberLabel.y=camberList.y+2.5;
						camberLabel.visible=true;
						posy+=camberList.height+6.5;
					}else{
						camberLabel.visible=false;
					}
				}
				
				
				if(wideList){
					wideList.x = (isPart1?RADIUS_WIDTH:PART_GAP) + CAMBER_LABEL_WIDTH;
					wideList.y = posy;
					wideList.width=CAMBER_LABEL_WIDTH;
					wideList.height=16;
					
					if(wideList.visible){
						
						offsetLabel.x=(isPart1?RADIUS_WIDTH:PART_GAP);
						offsetLabel.y=wideList.y+2.5;
						offsetLabel.visible=true;
					}else{
						offsetLabel.visible=false;
					}
				}

				if(profileList){
                    profileList.x = (isPart1?RADIUS_WIDTH:PART_GAP) + (isPart2?(CAMBER_LABEL_WIDTH + CAMBER_LIST_WIDTH):PART_GAP);
                    profileList.y = posy;
					if(profileList.visible){
                        profileLabel.y=5;
                        profileLabel.visible=true;
					}else{
                        profileLabel.visible=false;
					}
				}

				posy=1.5;
				
				
				btnRadiusContainer.y=2.5;
				btnRotateContainer.y=2.5;
				if(this._isEnabled){
					btnRadiusContainer.x=15;
					btnRotateContainer.x=50;
				}else{
					btnRadiusContainer.visible=false;
					btnRotateContainer.x=40;
				}

				if(blocker){
					blocker.width=actualWidth;
					blocker.height=actualHeight;
				}
				
				if(buttonLock){
					buttonLock.width=actualWidth;
					buttonLock.height=actualHeight;
				}
				
				if(carLock){
					carLock.x=(actualWidth-carLock.width)/2;
					carLock.y=(actualHeight-carLock.height)/2;
				}
				
				if(spinner){
					spinner.x=this.actualWidth/2;
					spinner.y=this.actualHeight/2;
				}
			}
			if(profileLabel && profileList){
                profileLabel.validate();
                profileList.validate();
                profileLabel.x = profileList.x + Math.max((profileList.width-profileLabel.width)/2, 0);
			}
            delimiterLayout();
		}

        private function isTrrPossible():Boolean{
			for (var nameOfState:String in partSlot.selectedPart.states){
				if(nameOfState && nameOfState.indexOf("trr")>=0) return true;
			}
			return false;
		}
		
		private function isTrlPossible():Boolean{
			for (var nameOfState:String in partSlot.selectedPart.states){
				if(nameOfState && nameOfState.indexOf("trl")>=0) return true;
			}
			return false;
		}

		private static function createDelimiter(borderHeight:Number = -1):Quad{
			var line:Quad = new Quad(1,1, 0xFFFFFF);
			line.width = 1;
			line.height = borderHeight==-1?40:borderHeight;
			return line;
		}

		private var sendDataChangeEvent:Boolean=true;
		
		private function closeViewHandler(event : Event) : void {
			dispatchEventWith(CLOSE_DISK_SETTINGS);
		}
	}
}
