package com.despark.tuning3d.view.components.tunings.editing
{
	
	
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.parts.Part;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.ExtentedButton;
	
	import feathers.controls.Button;
	import feathers.core.FeathersControl;
	
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	
	public class SuspensionMenu extends FeathersControl
	{
		
		public static const TOGGLE_STATE:String="toogle_state";
		
		public static const TOGGLE_STATE_ERROR:String="toogle_state_error";
		
		
		private var backgroundImage:Image;
		
		private var closeButton:Button;
		
		
		public function SuspensionMenu()
		{
			super();
		}
		
		override protected function initialize():void{
			
			super.initialize();
			
			
			var backgroundTexture:Texture=AlertView.assetManager.getTexture("a_effect_bg");
			
			backgroundImage=new Image(backgroundTexture);
			//background.width=1136/2;
			//background.height=50;
			addChild(backgroundImage);
			
			
			
			
			
			
			
			/*
			frontLightButton=ButtonFactory.circleButton("a_front_light_effect");
			frontLightButton.name="front_light";
			frontLightButton.width=78/2;
			frontLightButton.height=43/2;
			frontLightButton.addEventListener(Event.TRIGGERED, onToggleState);
			(frontLightButton.defaultSkin as Image).color=0xfefefe;
			(frontLightButton.downSkin as Image).color=0xfefefe;
			addChild(frontLightButton);
			
			
			diskNeonButton=ButtonFactory.circleButton("a_disk_neon_effect");
			diskNeonButton.name="disk_neon";
			diskNeonButton.width=50/2;
			diskNeonButton.height=50/2;
			diskNeonButton.addEventListener(Event.TRIGGERED, onToggleState);
			(diskNeonButton.defaultSkin as Image).color=0xfefefe;
			(diskNeonButton.downSkin as Image).color=0xfefefe;
			addChild(diskNeonButton);
			
			
			neonButton=ButtonFactory.circleButton("a_neon_effect");
			neonButton.name="neon";
			neonButton.width=129/2;
			neonButton.height=41/2;
			neonButton.addEventListener(Event.TRIGGERED, onToggleState);
			(neonButton.defaultSkin as Image).color=0xfefefe;
			(neonButton.downSkin as Image).color=0xfefefe;
			addChild(neonButton);*/
			
			
			closeButton=ButtonFactory.circleButton("a_close_effect_menu");
			(closeButton as ExtentedButton ).hitAreaPadding=25;
			closeButton.width=19/2;
			closeButton.height=20/2;
			//closeButton.addEventListener(Event.TRIGGERED, onCloseHandler);
			
			
			addChild(closeButton);
			
			
			
		}
		
		/*	public function get rearLightEnabled():Boolean{
		return _rearLightEnabled;
		}*/
		
		/*public function set rearLightEnabled(value:Boolean):void{
		
		_rearLightEnabled=value;
		
		if(_rearLightEnabled){
		
		(rearLightButton.defaultSkin as Image).color=0x0f86ff;
		(rearLightButton.downSkin as Image).color=0x0f86ff;
		}else{
		
		(rearLightButton.defaultSkin as Image).color=0xfefefe;
		(rearLightButton.downSkin as Image).color=0xfefefe;
		}
		
		}*/
		
		public function get suspension():int{
			return 0;
		}
		
		public function set suspension(val:int):void{
			
		}
		
	
		
		
		
		protected function onCloseHandler(event:Event):void{
			
			this.visible=false;
		}
		
		private var closeContainer:Sprite;
		private var backAlpha : Number = 0;
		
		override protected function draw():void
		{
			
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE)){
				backgroundImage.width=actualWidth;
				backgroundImage.height=actualHeight;
				
				backgroundImage.x=0;
				backgroundImage.y=0;
				
				closeButton.x=actualWidth-closeButton.width-3;
				closeButton.y=3;
				
				var hGap:Number=38/2;
				
				
				if (!closeContainer)
				{
					closeContainer = new Sprite();
					addChild(closeContainer);
					
					var tx : Number = closeButton.x - 4;
					var wt:Number = (closeButton.width + 8);
					var ht:Number = closeButton.height + 8;
					
					var skn : Quad = new Quad(wt,ht,0xff0000);
					skn.alpha = backAlpha;
					var cl:Button = new Button();
					cl.defaultSkin = skn;
					cl.x = tx;
					cl.y = 0;
					cl.addEventListener(Event.TRIGGERED, onCloseHandler);
					closeContainer.addChild(cl);
				}
				
				
				
				
				
			}
			
			
			
			
		}
	}
}



