package com.despark.tuning3d.view.components.tunings.editing {
	import com.utils.FontSelector;

	import feathers.controls.Label;
	import feathers.core.FeathersControl;

	import flash.geom.Rectangle;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import starling.animation.Transitions;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.filters.DropShadowFilter;
	import starling.textures.Texture;
	import starling.utils.AssetManager;

	public class TuningProgressBar extends FeathersControl {
		public var assetManager : AssetManager;
		
		private var _progress : Number = -1;
		private var backgroundImage:Image;
		private var progressImage:Image;
		private var texture : Texture;
		private var percentDisplay:Label;
		public function TuningProgressBar() {
			super();
			visible = false;
		}
		
		public function get progress() : Number {
			return _progress;
		}

		public function set progress(value : Number):void {
			_progress = value;
			invalidate("progress");
		}

		override protected function initialize() : void {
			super.initialize();
			texture = Texture.fromColor(3, 3, 0xf4eded);

			backgroundImage = new Image(texture);
			backgroundImage.filter = new DropShadowFilter(0, 0, 0, 0.15, 0.2);
			addChild(backgroundImage);

			progressImage = new Image(Texture.fromColor(3, 3, 0x2ed718));
			addChild(progressImage);
			setSizeInternal(100, texture.height, false);
		}
		
		public function getCarCountTextFieldTextFormat() : TextFormat {
			var fontName:String=FontSelector.getFont(true);
			var textFormat : TextFormat = new TextFormat(FontSelector.getFont(), 7, 0xffffff);
			textFormat.align = TextFormatAlign.RIGHT;
			textFormat.bold = true;
			return textFormat;
		}
		
		override protected function draw() : void {
			super.draw();
			if(isInvalid(INVALIDATION_FLAG_SIZE)) {
				backgroundImage.width = actualWidth;
				backgroundImage.height = actualHeight;
				progressImage.height = backgroundImage.height;
			}
			
			if(isInvalid("progress") && progress >= 0) {
				progressImage.width = Math.max(progress * backgroundImage.width, texture.width);
				alpha = 1.0;
				if(progress == 1) {
					var tween : Tween = new Tween(this, 0.3, Transitions.EASE_OUT);
					tween.delay = 0.5;
					tween.fadeTo(0);
					tween.onComplete = function() : void {
						visible = false;
					}
					Starling.juggler.add(tween);		
				}
			}
		}
	}
}