package com.despark.tuning3d.view.components.tunings.editing {
    import flash.utils.Dictionary;

    public class TuningScreenViewManager {
        public static const PART_SLOTS_VIEW:String = "partSlotsView";
        public static const PAINTS_VIEW:String = "paintsView";
        public static const CAR_SETTINGS_VIEW:String = "carSettingsView";

        public static const PARTS_VIEW:String = "partsView";
        public static const MANUFACTURERS_VIEW:String = "manufacturersView";
        public static const DISK_BRANDS_VIEW:String = "diskBrandsView";
        public static const DISK_PARTS_VIEW:String = "diskPartsView";
        public static const VINYL_TYPES_VIEW:String = "vinylTypesView";
        public static const VINYL_PARTS_VIEW:String = "vinylPartsView";

        public static const COMPONENTS_GROUP:Array = [PART_SLOTS_VIEW, PARTS_VIEW, DISK_BRANDS_VIEW, DISK_PARTS_VIEW, VINYL_TYPES_VIEW, VINYL_PARTS_VIEW];
        public static const COMPONENT_PARTS_GROUP:Array = [PARTS_VIEW, DISK_PARTS_VIEW, VINYL_PARTS_VIEW];
        public static const PAINTS_GROUP:Array = [PARTS_VIEW];
        private var _modeCallbackList:Object;
        private var _currentMode:String = null;
        private var _lastViewMode:Dictionary;
        public function TuningScreenViewManager() {
            _modeCallbackList = {};
            _lastViewMode = new Dictionary();
        }

        public function addMode(name:String, callback:Function):void{
            _modeCallbackList[name] = callback;
        }

        public function removeMode(name:String):void{
            if(_modeCallbackList.hasOwnProperty(name)){
                _modeCallbackList[name] = null;
               delete _modeCallbackList[name];
            }
        }

        public function setMode(value:String, reset:Boolean = true):void{
            if(!reset && currentMode == value){
                return;
            }
            _currentMode = value;
            if(_currentMode){
                if(COMPONENTS_GROUP.indexOf(_currentMode) != -1){
                    _lastViewMode[COMPONENTS_GROUP] = _currentMode;
                }
                if(PAINTS_GROUP.indexOf(_currentMode) != -1){
                    _lastViewMode[PAINTS_GROUP] = _currentMode;
                }
            }
            if(_modeCallbackList.hasOwnProperty(_currentMode)){
                _modeCallbackList[_currentMode].call();
            }
        }

        public function getGroupLastMode(value:Array):String{
            if(_lastViewMode[value]){
                return _lastViewMode[value];
            }
            return null;
        }

        public function get currentMode():String {
            return _currentMode;
        }
    }
}
