package com.despark.tuning3d.view.components.votes
{

import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.TextInputView;

import feathers.core.FeathersControl;

import flash.geom.Rectangle;

import starling.display.Image;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class SearchView extends FeathersControl implements Multilingual
	{
		public static const ON_ANIMATION_UPDATE:String="ON_ANIMATION_UPDATE";
		public static var assetManager : AssetManager;
		public static var language : Language;
		
		
		public var image:Image;
		
		private var icon:Image;
	
		private var _text:String="";
		private var _language:Language=null;
		
		private var textInput:TextInputView;
		
		public function SearchView()
		{
			super();
			
		
		}
		
		
		
		
		public function updateWithLanguage(language:Language):void
		{
			_language=language;
			
			/*if(backButton)
				backButton.updateWithLanguage(language);
			
			if(label)
				label.updateWithLanguage(language);
			
			
			if(selectedPacketView)
				selectedPacketView.updateWithLanguage(language);
			
			
			if(packetView)
				packetView.updateWithLanguage(language);
			
			
			if(mainList && mainList.dataProvider){
				
				for(var i:int=0; i<mainList.dataProvider.length; i++){
					
					mainList.dataProvider.updateItemAt(i);  
				}
			}
			
			text=this._language.translate("mob_home", "featured");  */
			
			
		}
		
		protected override function initialize() : void
		{
			super.initialize();

				
			var texture : Texture = AlertView.assetManager.getTexture("searchBg");
			//var textures :Scale3Textures = new Scale3Textures(texture, 12,12);
			image =new  Image(texture);
			image.scale9Grid = new Rectangle(12,0,12, texture.frameHeight);
			
			image.width=125;
			image.height=22;
			addChild(image);   
			
			var textureIcon:Texture = AlertView.assetManager.getTexture("searchIcon");
			
			icon = new Image(textureIcon);
			
			icon.width=13.5;
			icon.height=13.5;
			
			addChild(icon);
			
			
			
			
			textInput=new TextInputView(false, true);
			textInput.width=125-10-icon.width;
			textInput.height=22;
			textInput.y=1;
			
			//textInput.visible=false;
			
			textInput.addEventListener(Event.CHANGE, onTextChange);
			
			addChild(textInput);
			
		
		
			
		}
		
		protected function onTextChange(event:Event):void{
			
			dispatchEventWith(Event.CHANGE);
		}
		
		
		
		public function get text():String
		{
			return textInput.text;
		}
		
		public function set text(value:String):void
		{
			_text = value;
			invalidate("text");
		}
		
	
		
	
		
		override protected function draw() : void
		{
			super.draw();
			
			
			
			if(isInvalid("text"))
			{
				/*if(PackagesView.language)
				{
					label.updateWithLanguage(PackagesView.language);
				}
				else 
				{
					var l:Language = new Language(null);
					l.code = "en-US";
					label.updateWithLanguage(l);
				}   
				
				label.text = text;*/
			}
			
		
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
			
				icon.x=13.5;
				
				icon.y=(22-icon.height)/2;
			
				
				textInput.x=13.5+icon.width;
				textInput.y=1;
				
				textInput.height=22;
				
				image.y=0;
				image.x=0;
				image.width=125;
				image.height=22;
				
				
				
			}
		}
	}
}