package com.distriqt {
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.distriqt.extension.adverts.AdView;
    import com.distriqt.extension.adverts.InterstitialAd;
    import com.distriqt.extension.adverts.rewarded.RewardedVideoAd;

    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.distriqt.extension.adverts.AdSize;
    import com.distriqt.extension.adverts.AdViewParams;
    import com.distriqt.extension.adverts.AdvertPlatform;
    import com.distriqt.extension.adverts.Adverts;
    import com.distriqt.extension.adverts.builders.AdRequestBuilder;
    import com.distriqt.extension.adverts.events.AdViewEvent;
    import com.distriqt.extension.adverts.events.InterstitialAdEvent;
    import com.distriqt.extension.adverts.events.RewardedVideoAdEvent;
import com.distriqt.extension.application.Application;


import flash.utils.setTimeout;

import org.puremvc.as3.patterns.command.SimpleCommand;

    import starling.core.Starling;

    import starling.core.Starling;

public class AdsManager extends SimpleCommand {

    private static var self : AdsManager;

    private static const STATE_IDLE : String = "idle";
    private static const STATE_LOADING : String = "loading/requesting";
    private static const STATE_READY : String = "ready";
    private static const STATE_OPENED : String = "opened";
    private static const STATE_ASK_TO_OPEN : String = "ask_to_open/show";
    private static const STATE_CLOSED : String = "closed";
    private static const STATE_APP_LEFT : String = "app_left";
    private var httpClient : HttpClient;

    private static var APP_ID_ANDROID : String = "ca-app-pub-6170645818005481~6648240857";
    private static var APP_ID_IOS : String = "ca-app-pub-6170645818005481~3555173658";

    private static var INTERSTITIAL_ID_ANDROID : String = "ca-app-pub-6170645818005481/2078440450";
    private static var INTERSTITIAL_ID_IOS : String = "ca-app-pub-6170645818005481/6508640059";

    private static var REWARD_ID_ANDROID: String = 'ca-app-pub-6170645818005481/5753268876';
    private static var REWARD_ID_IOS: String = 'ca-app-pub-6170645818005481/9179424280';

    private static var BANNER_ID_ANDROID : String = "ca-app-pub-6170645818005481/8124974055";
    private static var BANNER_ID_IOS : String = "ca-app-pub-6170645818005481/5031906855";


    public static var bannerY: Number;
    private static var ADS_ENABLED : Boolean = true;

    private var _state : String;
    private var _initialized : Boolean = false;
    private var _interstitial : InterstitialAd;
    private var _callBackFunction : Function;
    private var _rewardsCallback : Function;
    private var _tracer : Tracer = new Tracer("ADS_MANAGER");

    private var _reward: RewardedVideoAd;
    private var _rewardCB: Function;
    public var haveRewardAds: Boolean = false;
    private var adView:AdView;
    private var inHomeBanner:Boolean = false;

    public var bannerInited: Boolean = false;
    public var bannerWidth: int = 1;
    public var bannerHeight: int = 45;
    private var _bannerEnabled: Boolean = false;

    private var bannerIsShown: Boolean = false;
    private var bannerLoadAttempts: int = 0;
    private var _showBannerAfterComplete:Boolean = false;

    private var _currentBannerScreen: String;
    private var viewParams:AdViewParams;
    private var _lastBannerStatus:Boolean;

    private static const MAX_ATTEMPT_COUNT:int = 15;

    public static function get $() : AdsManager{
        if(!self){
            self = new AdsManager();
        }

        return self;
    }


    public function isSupportReward(): Boolean {
        return Adverts.service.rewardedVideoAds.isSupported;
    }

    public static function get ENABLED() : Boolean {
        return ADS_ENABLED;
    }
    public static function turnOffAds() : void
    {
        if(ADS_ENABLED){
            ADS_ENABLED = false;
            $.bannerHide(true);
        }
    }

    public function AdsManager() {
        if(self){
            throw new Error("Advert Manager is singleton");
        }

        if(!ADS_ENABLED ) return;
        DistriqtController.init();
        Adverts.init( DistriqtController.getKey() );

        var advertIsSupported:Boolean = false;
        try{
            advertIsSupported = Adverts.isSupported;
        }catch (e:Error) {
            advertIsSupported = false;
        }
        if (advertIsSupported){
            var accountId : String = Device.isIos() ? APP_ID_IOS : APP_ID_ANDROID;
            Adverts.service.initialisePlatform( AdvertPlatform.PLATFORM_ADMOB, accountId );
            initReward();
            initInterstitial();
            initBanner();
            _initialized =  true;
            _tracer.print("INITIALIZED");
            this.changeState(STATE_IDLE);
        } else {
            _tracer.print("Ads do not supported");
            AdsManager.turnOffAds();
        }
    }

    public function showReward(): void {
        if (haveRewardAds) {
            _reward.show();
        }
    }

    public function checkRewardAds(completeCallback:Function):void{
        GameService.$.getSaveData(function (gameData: String): void {
            requestReward();
            GameService.$.rewardsIsSupport(function(status: Boolean): void {
                completeCallback(status);
            });
        });
    }

    private function initInterstitial() : void{
        if(!ADS_ENABLED ) {
            return;
        }

        if(Adverts.service.interstitials.isSupported) {
            var id : String = Device.isIos() ? INTERSTITIAL_ID_IOS : INTERSTITIAL_ID_ANDROID;
            _interstitial = Adverts.service.interstitials.createInterstitialAd();
            _interstitial.setAdUnitId( id );
            _interstitial.addEventListener( InterstitialAdEvent.LOADED, interstitialLoadedHandler);
            _interstitial.addEventListener( InterstitialAdEvent.ERROR, interstitialErrorHandler);
            _interstitial.addEventListener( InterstitialAdEvent.LEFT_APPLICATION, leftApplicationHandler );
            _interstitial.addEventListener( InterstitialAdEvent.CLOSED, closedHandler );
            _interstitial.addEventListener( InterstitialAdEvent.OPENED, openedHandler );
            _tracer.print("Interstitial is initialized");
        }
        else {
            _tracer.print("Interstitial is not supported");
            AdsManager.turnOffAds();
        }
    }

    private function initReward(): void {
        if (Adverts.service.rewardedVideoAds.isSupported) {
            var id : String = Device.isIos() ? REWARD_ID_IOS : REWARD_ID_ANDROID;
            _reward = Adverts.service.rewardedVideoAds.createRewardedVideoAd();
            _reward.setAdUnitId(id);
            _reward.addEventListener( RewardedVideoAdEvent.LOADED, rewardLoadedHandler);
            _reward.addEventListener( RewardedVideoAdEvent.ERROR, rewardErrorHandler);
            _reward.addEventListener( RewardedVideoAdEvent.REWARD, rewardHandler);
            _reward.addEventListener( RewardedVideoAdEvent.CLOSED, rewardClosedHandler);
            _reward.addEventListener( RewardedVideoAdEvent.OPENED, rewardOpenedHandler);

        } else {
            _tracer.print('Rewards is not supported');
        }
    }

    private function initBanner(): void {
        if(!ADS_ENABLED ) {
            return;
        }
        bannerInited = false;
        var id : String = Device.isIos() ? BANNER_ID_IOS : BANNER_ID_ANDROID;
        adView = Adverts.service.createAdView();
        adView.setAdUnitId( id );
        adView.addEventListener( AdViewEvent.LOADED, bannerLoadedHandler );
        adView.addEventListener( AdViewEvent.ERROR, bannerErrorHandler );
        bannerLoadAttempts = 0;
    }

    public function requestBanner(bannerScreen:String = null): void {
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        if (adView && ADS_ENABLED && !adView.isLoading()) {
            if (bannerScreen == BannerScreen.TUNING_SCREEN) {
                adView.setAdSize( AdSize.BANNER );
            } else if (bannerScreen == BannerScreen.HOME_SCREEN){
                var halfScreenWidth: Number = 2 * Constants.SCREEN_WIDTH / Starling.current.contentScaleFactor;
                if (halfScreenWidth < 320) {
                    adView.setAdSize( AdSize.BANNER );
                    // return;
                } else if (halfScreenWidth >= 320 && halfScreenWidth < 468) {
                    adView.setAdSize(AdSize.BANNER)
                } else if (halfScreenWidth >= 468 && halfScreenWidth < 728) {
                    adView.setAdSize(AdSize.BANNER)
                } else {
                    adView.setAdSize(AdSize.BANNER)
                }
            } else if (bannerScreen == BannerScreen.BANNER_SCREEN){
                adView.setAdSize( AdSize.BANNER );
            }
            adView.load(new AdRequestBuilder().build());
        }
    }

    public function setBannerPosition(y: Number, bannerScreen:String = null): void {
        viewParams = getAdViewParams(bannerScreen);
        viewParams.y =  bannerY = y;
        if (ADS_ENABLED && bannerInited) {
            adView.setViewParams(viewParams);
            adView.show();
        }
    }

    private function getAdViewParams(bannerScreen:String = null):AdViewParams{
        var horizontalAlign:String;
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        if(bannerScreen == BannerScreen.HOME_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_CENTER;
        }else if(bannerScreen == BannerScreen.TUNING_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_RIGHT;
        }else if(bannerScreen == BannerScreen.BANNER_SCREEN){
            horizontalAlign = AdViewParams.ALIGN_CENTER;
        }
        var result:AdViewParams = new AdViewParams();
        result.horizontalAlign = horizontalAlign;
        return result;
    }

    public function set bannerEnabled ( value : Boolean ) : void {
        _bannerEnabled = value;
        if(!_bannerEnabled) {
            bannerHide();
        }
    }

    public function bannerShow(bannerScreen: String = null): void {
        bannerScreen ||= BannerScreen.TUNING_SCREEN;
        _currentBannerScreen = bannerScreen;
        viewParams = getAdViewParams(_currentBannerScreen);
        viewParams.y =  bannerY;
        if(_bannerEnabled && !bannerIsShown && ADS_ENABLED){
            if (bannerInited) {
                adView.setViewParams(viewParams);
                adView.show();
                bannerIsShown = true;
            } else if (bannerLoadAttempts < MAX_ATTEMPT_COUNT) {
                showBannerAfterComplete = true;
                requestBanner(_currentBannerScreen);
            }
        }
    }

    public function bannerHide(exitScreen:Boolean = false): Boolean {
        if(exitScreen){
            showBannerAfterComplete = false;
        }
        if (bannerInited && bannerIsShown) {
            adView.hide();
            bannerIsShown = false;
            _lastBannerStatus = !exitScreen;
            return _lastBannerStatus;
        }
        _lastBannerStatus = false;
        return _lastBannerStatus;
    }

    public function homeBannerHide(): Boolean {
        if (adView) {
            adView.hide();
            return true;
        }
        return false;
    }

    public function destroyBanner(): void {
        if (adView) {
            bannerHide();
        }
    }

    private function bannerLoadedHandler(event: AdViewEvent): void {
        bannerInited = true;
        var oldHeight:int = bannerHeight;
        var size: AdSize = adView.getAdSize();
        bannerWidth = size.widthInPixels / Starling.current.contentScaleFactor;
        bannerHeight = size.heightInPixels / Starling.current.contentScaleFactor;

        if (bannerHeight <= 10) {
            bannerHeight = 45;
        }
       if(bannerIsShown){
            viewParams.y -= (bannerHeight - oldHeight) / 2;
            adView.setViewParams(viewParams);
        }else if(showBannerAfterComplete){
            bannerShow(_currentBannerScreen);
        }
    }

    private function bannerErrorHandler(event: AdViewEvent): void {
//        if (bannerLoadAttempts == 1) {
//            if (event.errorCode == 1) {
//                _sendAdsDebug();
//            }
//        }
        if(bannerLoadAttempts < MAX_ATTEMPT_COUNT){
            bannerLoadAttempts++;
            Starling.juggler.delayCall(requestBanner, bannerLoadAttempts, _currentBannerScreen);
        } else {

        }
    }


    private function rewardOpenedHandler(event: RewardedVideoAdEvent): void {
        sendNotification(Notifications.REWARD_ARS_OPEND);
    }

    private function rewardLoadedHandler( event: RewardedVideoAdEvent ): void {
        haveRewardAds = true;
        sendNotification(Notifications.REWARD_ARS_LOAD);
        trace('Reward Ads Loaded');
    }

    private function rewardErrorHandler( event: RewardedVideoAdEvent ): void {

        if (_rewardCB) {
            _rewardCB(false);
        }

        haveRewardAds = false;
        setTimeout(function (): void {
            requestReward(_rewardCB);
        }, 6000);

    }

    private function rewardHandler( event: RewardedVideoAdEvent ): void {
        GameService.$.addReward(1);
        haveRewardAds = false;
        requestReward(_rewardCB);
    }

    private function rewardClosedHandler(event: RewardedVideoAdEvent): void {
        haveRewardAds = false;
        requestReward(_rewardCB);
        if(_rewardsCallback != null){
            _rewardsCallback.call();
            _rewardsCallback = null;
        }
    }

    private function changeState(state : String) : void
    {
        this._state = state;
        _tracer.print("STATE : " + state);
    }

    private function openedHandler(event:InterstitialAdEvent):void {
        this.changeState(STATE_OPENED);
    }


    private function closedHandler(event:InterstitialAdEvent):void {
        this.changeState(STATE_CLOSED);
        completeRequest(true);
        this.changeState(STATE_IDLE);
    }

    private function leftApplicationHandler(event:InterstitialAdEvent):void {
        this.changeState(STATE_APP_LEFT);
        completeRequest(false);
        this.changeState(STATE_IDLE);
    }

    private function interstitialErrorHandler(event:InterstitialAdEvent):void {
        _tracer.print("Interstitial load error");
        this.changeState(STATE_IDLE);
        completeRequest(false);
    }

    private function interstitialLoadedHandler(event:InterstitialAdEvent):void {
        _tracer.print("Interstitial is loaded");
        this.changeState(STATE_READY);
        if(_callBackFunction){ // means waiting for load to show
            showInterstitial();
        }
    }

    public function prepareInterstitial() : void{
        if(!ADS_ENABLED ) return;

        if (Adverts.service.interstitials.isSupported && _initialized)
        {
            _tracer.print("Prepare interstitial");
            if(_interstitial.isLoading()) return;

            _interstitial.load( new AdRequestBuilder().build() );
            this.changeState(STATE_LOADING);
        }
    }

    public function requestInterstitial(callBack:Function) : void{
        if(!ADS_ENABLED ) {
            callBack(false); return
        }
        if (Adverts.service.interstitials.isSupported && _initialized) {

            _tracer.print("Request");
            _callBackFunction = callBack;

            if(_interstitial.isLoaded()){
                showInterstitial();
            }
            else if(!_interstitial.isLoading()) {
                prepareInterstitial();
            }
        }
    }

    public function requestReward(cb: Function = null): void {
        if (Adverts.service.rewardedVideoAds.isSupported && !haveRewardAds) {

            _reward.load(new AdRequestBuilder().build());
            if (cb) {
                _rewardCB = cb;
            }

        } else {
            if (cb) {
                cb(false);
            }
        }
    }

    private function showInterstitial() : void{

        if(_interstitial.isLoaded()){
            this.changeState(STATE_ASK_TO_OPEN);
            _interstitial.show();
        }else {
            completeRequest(false);
        }

    }

    private function completeRequest(status : Boolean) : void{
        if(_callBackFunction){
            _tracer.print("Complete with status : " + status );
            _callBackFunction(status);
            _callBackFunction = null;
        }
    }

    public function get currentBannerScreen():String {
        return _currentBannerScreen;
    }

    public function get showBannerAfterComplete():Boolean {
        return _showBannerAfterComplete;
    }

    public function set showBannerAfterComplete(value:Boolean):void {
        _showBannerAfterComplete = value;
    }

    private function _sendAdsDebug(): void {
        if (!httpClient) {
            httpClient = new HttpClient();
        }

        var data: * = {
            deviceName: Application.service.device.name,
            deviceBrand: Application.service.device.brand,
            deviceManufacturer: Application.service.device.manufacturer,
            deviceDevice: Application.service.device.device,
            deviceModel: Application.service.device.model,
            deviceProduct: Application.service.device.product,
            deviceId: Application.service.device.uniqueId()


        }
        httpClient.postPath("/ads", data, function(success : Boolean, result : Object) : void {

        })
    }

    public function set rewardsCallback(value:Function):void {
        _rewardsCallback = value;
    }

    public function get lastBannerStatus():Boolean {
        return _lastBannerStatus;
    }
}
}
