package com.distriqt {
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.model.core.Device;

import com.despark.tuning3d.model.core.http.HttpClient;

import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
import com.despark.tuning3d.Notifications;

import org.puremvc.as3.patterns.command.SimpleCommand;

public class GameService  extends SimpleCommand {
    private static var self: GameService;
    private const SAVED_GAME_NAME: String = 'tuningRewards';
    private var isCacheStrategy: Boolean;
    public var isInited: Boolean = false;
    public var httpClient : HttpClient;
    private const EXCLUDE_COUNTRY: Array = ['US'];

    private var _cachedData: String;
    public static function get $() : GameService{
        if(!self){
            self = new GameService();
        }

        return self;
    }

    public  function rewardsIsSupport(cb: Function): void {

        if (!Tuning3D.GEODATA) {
            if (!httpClient) {
                httpClient = new HttpClient();
            }
            httpClient.getPath("?country=true", null, function(success : Boolean, result : Object) : void {
                if (success) {
                    var data:Object = JSONer.parse(result as String);
                    if (data.hasOwnProperty('region')) {
                        Tuning3D.GEODATA = data.region;
                        cb(true);
                        /*if (EXCLUDE_COUNTRY.indexOf(Tuning3D.GEODATA.country) > -1 && Device.isIos()) {
                            cb(false);
                        } else {
                            cb(true);
                        }*/
                    }
                } else  {
                    cb(false);
                }
            })
        } else {
            cb(true);
            /*if (EXCLUDE_COUNTRY.indexOf(Tuning3D.GEODATA.country) > -1 && Device.isIos()) {
                cb(false);
            } else {
                cb(true);
            }*/

        }

    }

    public function init(): void {
        isCacheStrategy = true;
        isInited = true;
    }

    public function GameService(): void {
        if(self){
            throw new Error("GameService is singleton");
        }

    }

    public function getSaveData(cb: Function): void {
        if (isCacheStrategy) {
            if (_cachedData) {
                cb(_cachedData);
            } else {
                var savedGameFile:File = File.cacheDirectory.resolvePath(SAVED_GAME_NAME + '.json');
                if (savedGameFile.exists) {
                    var fileStream:FileStream = new FileStream();
                    fileStream.open(savedGameFile, FileMode.READ);
                    var savedGameData:String = fileStream.readUTF();
                    fileStream.close();
                    _cachedData = savedGameData;
                    cb(savedGameData);
                } else {
                    cb('{"rewards": 0, "rewardsPackets":[]}');
                }
            }

        }

    }

    public function addReward(count3DCount: Number): void {
//        count3DCount = 50;
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty('rewards')) {
                rewardData.rewards = 0;
            }
            if (!rewardData.hasOwnProperty('rewardsPackets')) {
                rewardData.rewardsPackets = [];
            }
            rewardData.rewards += count3DCount;
            saveGameData(JSONer.stringify(rewardData));
        });
    }

    public function addRewardPacket(packetId: String, packetPrice: Number, cb: Function): void {
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty('rewards')) {
                rewardData.rewards = 0;
            }
            if (!rewardData.hasOwnProperty('rewardsPackets')) {
                rewardData.rewardsPackets = [];
            }
            if ((rewardData.rewards >= packetPrice && rewardData.rewardsPackets.indexOf(packetId) === -1)) {
                rewardData.rewards -= packetPrice;
                rewardData.rewardsPackets.push(packetId);
                cb(true);
                saveGameData(JSONer.stringify(rewardData));
            } else {
                cb(false);
            }

        });
    }

    public function deleteRewardPacket(packetId: String): void {
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty('rewards')) {
                rewardData.rewards = 0;
            }
            if (!rewardData.hasOwnProperty('rewardsPackets')) {
                rewardData.rewardsPackets = [];
            }
            if (rewardData.rewardsPackets.indexOf(packetId) > -1) {
                rewardData.rewardsPackets.splice(rewardData.rewardsPackets.indexOf(packetId), 1);
                sendNotification(Notifications.DELETE_REWARD_PACKET, {packetId: packetId});
                saveGameData(JSONer.stringify(rewardData));
            }



        });
    }

    private function saveGameData(data: String): void {
        if (isCacheStrategy) {
            _cachedData = data;
            var savedGameFile: File = File.cacheDirectory.resolvePath(SAVED_GAME_NAME + '.json');
            var fileStream: FileStream = new FileStream();
            fileStream.open(savedGameFile, FileMode.WRITE);
            fileStream.writeUTF(data);
            fileStream.close();
            sendNotification(Notifications.REWARD_DATA_CHANGE, {})
        }
    }


}
}
