package com.utils
{
	import com.maxbsoft2.utils.BitmapDataUtils;
	
	import flash.display.BitmapData;
	import flash.display.PNGEncoderOptions;
	import flash.errors.IOError;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.utils.ByteArray;

	public class CachedBitmapData
	{
		private var _id:String;
		private var _inMemory:Boolean=true;
		private var _bitmapData:BitmapData=null;
		private var _width:int=0;
		private var _height:int=0;
		
		//private static var fileStream:FileStream=new FileStream();
		//private static var byteArray:ByteArray=new ByteArray();
		
		
		public function CachedBitmapData(id:String, bitmapData:BitmapData)
		{
			_bitmapData=bitmapData;
			_inMemory=true;
			_id=id;
			
			_width=bitmapData.width;
			_height=bitmapData.height;
		}
		
		
		public function get inMemory():Boolean{
			
			return _inMemory;
		}
		
		public function get bitmapData():BitmapData{
			return _bitmapData;
		}
		
		public function get width():int{
			
			return _width;
		}
		
		public function get height():int{
			
			return _height;
		}
		
		
		
		public function saveToDisk():void{
			
			if(!_bitmapData)
				return;
			
			if(!_inMemory)
				return;
			
			
			if(!File.applicationStorageDirectory.resolvePath("car").exists){
				File.applicationStorageDirectory.resolvePath("car").createDirectory();
			}
			
			
			var file:File=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id);
			
			
			BitmapDataUtils.saveToDisk(file, _bitmapData);
			
			
			
			//
			/*if(!fileStream)
				fileStream=new FileStream();
			
			ba=new ByteArray();
			_bitmapData.encode(_bitmapData.rect, new PNGEncoderOptions(true), ba);
			file=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id+".png");
			
			fileStream.open(file, FileMode.WRITE);
			fileStream.writeBytes(ba);
			fileStream.close();*/
			//
			
			_bitmapData.dispose();
			_bitmapData=null;
			//byteArray.clear();
			//ba=null;
			_inMemory=false;
		}
		
		
		public function loadFromDisk():void{
			
			if(_inMemory)
				return;
			
			if(_bitmapData){
				_inMemory=true;
				return;
			}
			
			var file:File=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id);
			
			_bitmapData=BitmapDataUtils.loadFromDisk(file, _width, _height);
			_inMemory=true;
			
			return;
			
			
		}
		
		public function dispose():void{
			
			if(_inMemory && _bitmapData){
				
				_bitmapData.dispose();
				_bitmapData=null;
			}
			
			var file:File=File.applicationStorageDirectory.resolvePath("car").resolvePath(_id);
			
			if(file.exists){
				
				file.deleteFileAsync();
			}
			
			_id=null;
		}
	}
}