package com.utils
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
import flash.display.PixelSnapping;
import flash.display.Shape;
import flash.display.Sprite;
	import flash.events.Event;
import flash.geom.Matrix;
import flash.geom.Rectangle;
	import flash.net.URLRequest;

import starling.display.Image;
import starling.textures.Texture;
	
	public class ImageUtils extends Sprite
	{
		public static var bitmap:Bitmap;
		
		public static function loadImage(url:String) : void
		{
			var loader:Loader = new Loader();
				loader.load(new URLRequest(url));
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE,onLoadComplete);
		}
		
		public static  function onLoadComplete(event:Event) : void{
			bitmap = event.currentTarget.loader.content as Bitmap;
		}

        public static function getDashLine(width:Number, size:Number, dashSize:Number, gapSize:Number):Texture{
			var dashBd:BitmapData = new BitmapData(dashSize + gapSize, size, true, 0);
			var shape:Shape = new Shape();
			var lineBd:BitmapData = new BitmapData(width, size, true, 0);
			//
            dashBd.fillRect(new Rectangle(0,0,dashSize, size), 0xFFFFFFFF);
			//
            shape.graphics.beginBitmapFill(dashBd, null, true, true);
			shape.graphics.drawRect(0,0,width, size);
			shape.graphics.endFill();
			lineBd.draw(shape);
			return Texture.fromBitmapData(lineBd);
        }
		
        public static function clearAllTexture():void {
			trace("CLEAR ALL TEXTURES ____________________________________________________________________________");
			/*var texturesForDispose : Array = Texture.texturesToDispose;
			for each ( var st : Texture  in texturesForDispose)
			{
				if (st!=null && st.forDelete == true) {
					st.dispose();
				}
			}*/

			//ObjectUtils.cleanArray(Texture.texturesToDispose);

		}

    public static function scaleBitmapData(bigBMD : BitmapData, scale : Number) : BitmapData
    {
        //trace("scaleBitmapData");
        var matrix:Matrix = new Matrix();
        matrix.scale(scale, scale);

        var smallBMD:BitmapData = new BitmapData(bigBMD.width * scale, bigBMD.height * scale, true, 0x000000);
        smallBMD.draw(bigBMD, matrix, null, null, null, true);

        return smallBMD;
    }

    public static  function cropBMP(btm : Bitmap, _x:Number, _y:Number, _width:Number, _height:Number) : Bitmap
    {
        var cropArea:Rectangle = new Rectangle( 0, 0, _width, _height );
        var croppedBitmap:Bitmap = new Bitmap( new BitmapData( _width, _height ), PixelSnapping.ALWAYS, true );
        croppedBitmap.bitmapData.draw( btm, new Matrix(1, 0, 0, 1, -_x, -_y) , null, null, cropArea, true );
        return croppedBitmap;
    }

		public static function roundCorners(bmp:Bitmap) : Bitmap
		{
			if (!bmp) return null;
				
			var width  : Number = bmp.width;
			var radius : Number = width / 2;
			
			var circle : Sprite = new Sprite();
				circle.addChild(bmp);
			
			var mask : Sprite = new Sprite();
				mask.graphics.beginFill(0xFFFFFF);
				mask.graphics.drawCircle(radius, radius, radius);
				mask.graphics.endFill();
			
			circle.addChild(mask);
			bmp.mask = mask;
			
			var bmpData : BitmapData = new BitmapData(width, width, true, 0x000000);
				bmpData.draw(circle, null, null, null, null, true);
			bmp.bitmapData.dispose();
			var newBmp : Bitmap = new Bitmap(bmpData, 'auto', true);
			circle = null; // clear
			
			return newBmp;
		}
	}
}