package com.utils {
public class RegExpUtil {
    private static const URL_REGEXP:RegExp = /(http(s)?:\/\/((\d+\.\d+\.\d+\.\d+)|(([\w-]+\.)+([a-z,A-Z][\w-]*)))(:[1-9][0-9]*)?(\/([\w-.\/:%+@&=]+[\w- .\/?:%+@&=]*)?)?(#(.*))?)/ig;
    private static const DOMAIN_REGEXP:RegExp = /[^https:\/\/]([a-z-_]*)?.?[a-z-_]*.[a-z]*/;
    private static const IMAGE_REGEXP:RegExp = /(jpg|jpeg|png)$/img;
    private static const NUMBER_REGEXP:RegExp = /([0-9]+)/img;
    private static const WINDOW_STATE_Pattern:RegExp = /([a-zA-Z_\-]+(open|close))/;
    private static const WINDOW_TINT_Pattern:RegExp = /([0-9]+)%?$/;
    private static const WHEEL_ROTATION_PATTERN:RegExp = /-?(trr|trl)/gmi;
    public static function urlsToAnchors(str:String):String{
        return str.replace(URL_REGEXP, "<font color='#ED9564'><a href='$1'><b>$1</b></a></font>");
    }

    public static function getNumber(str:String):Number{
        var obj:* = NUMBER_REGEXP.exec(str);
        if(obj && obj[0]){
            return parseInt(obj[0]);
        }
        return 0;
    }

    public static function isUrl(str:String):Boolean{
        return URL_REGEXP.test(str);
    }

    public static function getDomain(str:String):String{
        return str.match(DOMAIN_REGEXP)[0];
    }

    public static function getWindowTint(str:String):Array{
        return str.match(WINDOW_TINT_Pattern);
        // return WINDOW_TINT_Pattern.exec(str);
    }

    public static function getWindowTintValue(str:String):int{
        var arr:Array = str.match(WINDOW_TINT_Pattern);
        if(arr && arr.length){
            return parseInt(arr[0]);
        }
        return 100;
    }

    public static function getWindowTintState(str:String):Array{
        return str.match(WINDOW_STATE_Pattern);
        // return WINDOW_TINT_Pattern.exec(str);
    }

    public static function removeHtmlTags(str:String):String{
        var patter:RegExp = /<[^>]*>/gsmi;
        return str.replace(patter, '');
    }

    public static function getHtmlTagContent(str:String, tagName:String):String{
        var patter:RegExp = new RegExp("<"+tagName+">(?P<content>.*)</"+tagName+">", 'gsmi');
        var result:Object = patter.exec(str);
        if(result && result.content){
            return result.content;
        }
        return null;
    }

    public static function isAllowedImageURL(str:String):Boolean{
        return IMAGE_REGEXP.test(str);
    }

    public static function getWheelStraightState(stateName:String):String{
        var result:String = stateName?stateName.replace(WHEEL_ROTATION_PATTERN, ""):null;
        if(result && result.length){
            return result;
        }
        return null;
    }

}
}
