/*
Feathers
Copyright 2012-2017 Bowler Hat LLC. All Rights Reserved.

This program is free software. You can redistribute and/or modify it in
accordance with the terms of the accompanying license agreement.
*/
package feathers.controls
{
	/**
	 * Formats for date and time components.
	 *
	 * @productversion Feathers 3.0.0
	 */
	public class DateTimeMode
	{
		/**
		 * Both date and time will be displayed.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const DATE_AND_TIME:String = "dateAndTime";

		/**
		 * Only the time will be displayed. The date will not be displayed.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const TIME:String = "time";

		/**
		 * Only the date will be displayed. The time will not be displayed.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const DATE:String = "date";
	}
}
