/*
Feathers
Copyright 2012-2017 Bowler Hat LLC. All Rights Reserved.

This program is free software. You can redistribute and/or modify it in
accordance with the terms of the accompanying license agreement.
*/
package feathers.layout
{
	/**
	 * Constants for positioning an item at a depth relative to another item's
	 * depth in a layout.
	 *
	 * @productversion Feathers 3.0.0
	 */
	public class RelativeDepth
	{
		/**
		 * The item will be positioned above another item.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const ABOVE:String = "above";

		/**
		 * The item will be positioned below another item.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const BELOW:String = "below";
	}
}
